if not srb2p return end

DNG_Abilities["elie"] = {

    jfunc =     function(p)
                    local mo = p.mo

                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(46*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					mo.state = S_PLAY_ROLL
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%3)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}

freeslot("sfx_elgun", "sfx_elgry", "sfx_elspk", "sfx_elthr", "sfx_aercan", 
 "sfx_arcann", "sfx_antisp", "sfx_preaer", "sfx_aersik", "sfx_fortun", "sfx_aerial", 
 "sfx_aersto", "sfx_sanfor", "sfx_ragblt", "sfx_spaarw", "sfx_judbol", "sfx_gallan", 
 "sfx_grastr", "sfx_ragvor","sfx_aurran")

charStats["elie"] = {

		-- GENERAL

		name = "Elie",			-- This is only for bots / enemies
		basehp = 62,			-- base HP for level 1
		basesp = 54,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		--cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		tpmode = "craft points",
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_aura_rain_c", 1, 1}, {"tr_aerialcannon_c", 30, 2}, {"tr_aerialcannon_c2", 60, 2}, {"tr_aura_rain_c2", 90, 1},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"lloyd", "tr_starblast_c", 25}, {"lloyd", "tr_starblast_c2", 50}, {"lloyd", "tr_starblast_c3", 75},
			}
			or {
				{"lloyd", "tr_starblast", 25}, {"lloyd", "tr_starblast_2", 50}, {"lloyd", "tr_starblast_3", 75},
		},
		
		
		persona = "elieskillset",
		melee_natk = "tr_revolver",	-- normal melee attack
		--melee_satk = "tr_aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,
		
		wep = "tr_ingrid",		-- default weapon.
		weptype = WPT_GENERICRANGED,	-- Equippable weapon type(s)

		atk = 40,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, 1, "SPR2_MLEE"},
		anim_special2 =		{SPR_PLAY, A, B, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, 2, "SPR2_MLEL"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4", "sfx_elsmn5"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elxhrt"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2", "sfx_elaoi3"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3", "sfx_elwin4"},
		vfx_levelup = {"sfx_elkil2"},
		vfx_tartarus_pit = {"sfx_elrip"},
		vfx_tartarus_item = {"sfx_lyelit"},
		vfx_tartarus_spring = {"sfx_elspng"},
		vfx_tartarus_spike = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_tartarus_critspike = {"sfx_elhrt2"},
		vfx_tartarus_spikepit = {"sfx_elmpit"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		hudscutin = "SLIE_A",	-- super cut in
		aoa_quote = "They are down!\nLet's go everyone!",

		tip = "A member of the Special Support Section with Wind and Elec orbal arts using the ARCUS Orbment. With her orbal gun she can use powerful Pierce skills to shoot down the enemies. She also has a buff and a Dekunda Skill",
}

VFX_freeslotC("elie") 
	
personaList["elieskillset"] = {
		-- GENERAL
		name = "Elie",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk = 		{SPR_NULL, A, 8},
		startframe = 0,

		strength = 8,
		magic = 10,
		endurance = 8,
		luck = 7,
		agility = 6,
		stab = {ATK_WIND,ATK_ELEC,ATK_PIERCE},
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,
		skills = C2SBarEdits and {
					
						{"tr_air_strike", 1}, {"tr_triple_burst_c", 4},
						{"tr_sparkle", 9}, {"tr_sylphen_wing", 15}, {"tr_aero_sickle", 17},
						{"tr_aerial", 20}, {"tr_forte", 22}, {"tr_innocence_arc", 23},
						
						{"tr_judgement_bolt", 26, "tr_sparkle"},
						{"tr_wild_swan_c", 28, "tr_triple_burst_c"},
						{"tr_gale_lance", 30, "tr_air_strike"}, {"wind boost", 35, "tr_aero_sickle"},
						
						{"tr_saint", 36, "tr_forte"}, {"tr_sylphen_guard", 40, "tr_sylphen_wing"},
						{"tr_wild_swan_c2", 44, "tr_wild_swan_c"},
						{"elec boost", 47, "tr_aerial"}, {"tr_aero_storm", 49, "tr_gale_lance"},
						
						{"tr_triple_piercer_c", 53, "tr_wild_swan_c2"},
						{"wind amp", 57, "wind boost"}, {"tr_ragna_vortex", 60, "tr_judgement_bolt"}, {"elec amp", 65, "elec boost"},
						
						 {"tr_grand_stream", 68, "tr_aero_storm"}, {"tr_sylpharion", 71, "tr_sylphen_guard"},
						 {"tr_zodiac", 75, "tr_saint"}, {"tr_ragna_blast", 79, "tr_ragna_vortex"},
				},
}


-- Melee Attack


attackDefs["tr_revolver"] = {
	name = "Revolver Shot",
	type = ATK_PIERCE,
	power = 38,
	accuracy = 95,
	critical = 6,
	target = TGT_ENEMY,
	costtype = CST_HP,
	cost = 0,
	nometronome = true,
	norandom = true,
	norogue = true,		
	desc = "Shoots a bullet at an enemy",
	physical = true,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local btl = server.P_BattleStatus[mo.battlen]
		local cam = btl.cam
		
		if timer == 1
			ANIM_set(mo, mo.anim_special1)
			playSound(mo.battlen, sfx_elgry)
			mo.oldangle = mo.angle
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
		elseif timer == 5*TICRATE/8
			local cx = target.x + 168*cos(target.angle + ANG1*20)
			local cy = target.y + 168*sin(target.angle + ANG1*20)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
		end
		
		if timer == 1*TICRATE/2
			playSound(mo.battlen, sfx_elgun)
		end

		if timer == 1*TICRATE/2
			local boom = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
			boom.scale = FRACUNIT*1
			boom.sprite = SPR_JBUL
			boom.colorized = true
			boom.color = SKINCOLOR_GOLD
			boom.frame = A|FF_FULLBRIGHT
			boom.fuse = 17
			boom.momx = (target.x - boom.x)/5
			boom.momy = (target.y - boom.y)/5
			boom.momz = (target.z - boom.z)/5
		end

        if timer == 3*TICRATE/4
			local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
			boom.state = S_SHOT1
			boom.colorized = true
			boom.scale = FRACUNIT*1
			boom.color = SKINCOLOR_GOLD
		end
		
		if timer == 3*TICRATE/4
			damageObject(hittargets[1])
			playSound(mo.battlen, sfx_lydhit)
			P_StartQuake(FRACUNIT*7, 4)
			for i = 1, 2
				createSplat(mo)
			end
		end
		if timer == 3*TICRATE/2
			return true
		end
	end,
}

-- Crafts--


--From Zero (lvl 1 - lvl 50)

--Zero Initial
attackDefs["tr_triple_burst"] = {
		name = "Triple Burst",
		type = ATK_PIERCE,
		power = 110,
		accuracy = 99,
		costtype = CST_HPPERCENT,
		cost = 9,
		critical = 2,
		hits = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
		end,
		desc = "Fire three bullets at an enemy, \neach dealing Miniscule Pierce Damage.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 10
				ANIM_set(mo, mo.anim_special1)
				playSound(mo.battlen, sfx_elgry)	
			end	

			if timer == 30
			or timer == 40
			or timer == 70
				local shot = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = FRACUNIT*3
				P_StartQuake(FRACUNIT*4, 4)
				playSound(mo.battlen, sfx_elgun)
			end

			if timer == 30
			or timer == 40
			or timer == 70
				damageObject(target)
			elseif timer == 105
				return true
			end
		end,
}

--Zero lvl 7
--attackDefs["tr_holy_bullet"] = {
--name = "Holy Bullet", 

--Zero lvl 18
attackDefs["tr_wild_swan"] = {
		name = "Wild Swan",
		type = ATK_PIERCE,
		power = 280,
		accuracy = 99,
		costtype = CST_HPPERCENT,
		cost = 15,
		critical = 2,
		hits = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
		end,
		desc = "Fire three bullets at an enemy, \neach dealing Light Pierce Damage.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 10
				ANIM_set(mo, mo.anim_special1)
				playSound(mo.battlen, sfx_elgry)	
			end	

			if timer == 30
			or timer == 40
			or timer == 70
				local shot = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = FRACUNIT*3
				P_StartQuake(FRACUNIT*4, 4)
				playSound(mo.battlen, sfx_elgun)
			end

			if timer == 30
			or timer == 40
			or timer == 70
				damageObject(target)
			elseif timer == 105
				return true
			end
		end,
}

--Zero lvl 23
--attackDefs["tr_cross_mirage"] = {
--name = "Cross Mirage", 

--Zero lvl 27
--attackDefs["tr_strike_bell"] = {
--name = "Strike Bell", 

--To Azure (lvl 50 - lvl 100+
	
--Azure Initial
attackDefs["tr_wild_swan_2"] = {
		name = "Wild Swan 2",
		type = ATK_PIERCE,
		power = 490,
		accuracy = 99,
		costtype = CST_HPPERCENT,
		cost = 18,
		critical = 2,
		hits = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
		end,
		desc = "Fire three bullets at an enemy, \neach dealing Medium Pierce Damage.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local cx = mo.x + 128*cos(mo.angle + ANG1*202)
			local cy = mo.y + 128*sin(mo.angle + ANG1*202)
			local wepz = mo.z + FRACUNIT*40
			local cam = server.P_BattleStatus[mo.battlen].cam
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cam.x, cam.y, target.x, target.y))
			//CONSTANTLY be chasing the right angle!
			
			//Megido star, make some shocks, fire 2 shots looking with Thoks then the final one after a smaller pause
			local dist = (R_PointToDist2(mo.x,mo.y,target.x,target.y)/FRACUNIT)/2
			
			
			if timer == 1
				if mo.anim_special2 and #mo.anim_special2
					if mo.skin == "elie"
						ANIM_set(mo, mo.anim_special2)
					end	
				end
				playSound(mo.battlen, sfx_elgry)
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				//Looking at our victim!
			end
			if timer == 10
				local s = P_SpawnMobj(wepx,wepy,wepz, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = mo.scale
				playSound(mo.battlen, sfx_hamas1)
			end

			if timer == 40
				local thok = P_SpawnMobj(wepx,wepy,wepz, MT_THOK)
				thok.tics = 20
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/20
				thok.color = SKINCOLOR_GOLD
			end

			if timer == 45
			or timer == 55 
				for i = 1, dist 
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/4
					thok.tics = 1
					thok.color = SKINCOLOR_YELLOW
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
				end
				damageObject(target)
				for i = 1,15
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,20)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_GOLD
					p.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-12, 12)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_elgun)
			end
			//Basically like a laser, I think it looks neat!
			if timer == 55
				local thok = P_SpawnMobj(wepx,wepy,FRACUNIT*10, MT_THOK)
				thok.tics = 15
				thok.scale = FRACUNIT*2
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT*2)/15
				thok.color = SKINCOLOR_MINT
				playSound(mo.battlen, sfx_s3k9c)
			end
			//3rd SHOT'S orb charge - This one actually ends at the start of the shot
			if timer == 70
				for i = 1, dist 
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/2
					thok.color = SKINCOLOR_TEAL
					thok.tics = 2
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 35
						g.color = thok.color
				end
				damageObject(target)
				for i = 1,30
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,35)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_EMERALD
					p.angle = mo.angle + P_RandomRange(-45, 45)*ANG1
					p.momz = P_RandomRange(-20, 20)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_s3kc5l)
				playSound(mo.battlen, sfx_cdfm35)
				playSound(mo.battlen, sfx_cdfm35)

			end
			if timer == 105
				return true 
			end
		end,
}

--Azure lvl 56
attackDefs["tr_triple_piercer"] = {
		name = "Triple Piercer",
		type = ATK_PIERCE,
		power = 700,
		accuracy = 99,
		costtype = CST_HPPERCENT,
		cost = 23,
		critical = 2,
		hits = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
		end,
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Fire three bullets at an enemy, \neach dealing Heavy Pierce Damage (Set Line M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				target = hittargets[1]
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local cx = mo.x + 128*cos(mo.angle + ANG1*202)
			local cy = mo.y + 128*sin(mo.angle + ANG1*202)
			local wepz = mo.z + FRACUNIT*40
			local cam = server.P_BattleStatus[mo.battlen].cam
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cam.x, cam.y, target.x, target.y))
			//CONSTANTLY be chasing the right angle!
			
			//Megido star, make some shocks, fire 2 shots looking with Thoks then the final one after a smaller pause
			local dist = (R_PointToDist2(mo.x,mo.y,target.x,target.y)/FRACUNIT)/2
			
			
			if timer == 1
				if mo.anim_special2 and #mo.anim_special2
					if mo.skin == "elie"
						ANIM_set(mo, mo.anim_special2)
					end	
				end
				playSound(mo.battlen, sfx_elgry)
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				//Looking at our victim!
			end
			if timer == 10
				local s = P_SpawnMobj(wepx,wepy,wepz, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = mo.scale
				playSound(mo.battlen, sfx_hamas1)
			end

			if timer == 40
				local thok = P_SpawnMobj(wepx,wepy,wepz, MT_THOK)
				thok.tics = 20
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/20
				thok.color = SKINCOLOR_GOLD
			end

			if timer == 45
			or timer == 55 
				for i = 1, dist 
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/4
					thok.tics = 1
					thok.color = SKINCOLOR_YELLOW
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
				end
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
				for i = 1,15
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,20)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_GOLD
					p.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-12, 12)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_elgun)
			end
			//Basically like a laser, I think it looks neat!
			if timer == 55
				local thok = P_SpawnMobj(wepx,wepy,FRACUNIT*10, MT_THOK)
				thok.tics = 15
				thok.scale = FRACUNIT*2
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT*2)/15
				thok.color = SKINCOLOR_MINT
				playSound(mo.battlen, sfx_s3k9c)
			end
			//3rd SHOT'S orb charge - This one actually ends at the start of the shot
			if timer == 70
				for i = 1, dist 
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/2
					thok.color = SKINCOLOR_TEAL
					thok.tics = 2
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 35
						g.color = thok.color
				end
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
				for i = 1,30
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,35)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_EMERALD
					p.angle = mo.angle + P_RandomRange(-45, 45)*ANG1
					p.momz = P_RandomRange(-20, 20)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_s3kc5l)
				playSound(mo.battlen, sfx_cdfm35)
				playSound(mo.battlen, sfx_cdfm35)

			end
			if timer == 105
				return true 
			end
		end,
}

--Azure lvl 83
--attackDefs["tr_cross_mirage_2"] = {
--name = "Cross Mirage 2", 


--bar edits crafts

--From Zero (lvl 1 - lvl 50)
		
	--Zero Initial
	attackDefs["tr_triple_burst_c"] = {
			name = "Triple Burst",
			type = ATK_PIERCE,
			power = 110,
			accuracy = 99,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 9,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			hits = 3,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
			end,
			desc = "Fire three bullets at an enemy, \neach dealing Miniscule Pierce Damage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					ANIM_set(mo, mo.anim_special1)
					playSound(mo.battlen, sfx_elgry)	
				end	

				if timer == 30
				or timer == 40
				or timer == 70
					local shot = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
					shot.state = S_STAB_1_1
					shot.color = SKINCOLOR_WHITE
					shot.scale = FRACUNIT*3
					P_StartQuake(FRACUNIT*4, 4)
					playSound(mo.battlen, sfx_elgun)
				end

				if timer == 30
				or timer == 40
				or timer == 70
					damageObject(target)
				elseif timer == 105
					return true
				end
			end,
	}

	--Zero lvl 7
	--attackDefs["tr_holy_bullet"] = {
	--name = "Holy Bullet", 

	--Zero lvl 18
	attackDefs["tr_wild_swan_c"] = {
			name = "Wild Swan",
			type = ATK_PIERCE,
			power = 280,
			accuracy = 99,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 15,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			hits = 3,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
			end,
			desc = "Fire three bullets at an enemy, \neach dealing Light Pierce Damage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					ANIM_set(mo, mo.anim_special1)
					playSound(mo.battlen, sfx_elgry)	
				end	

				if timer == 30
				or timer == 40
				or timer == 70
					local shot = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
					shot.state = S_STAB_1_1
					shot.color = SKINCOLOR_WHITE
					shot.scale = FRACUNIT*3
					P_StartQuake(FRACUNIT*4, 4)
					playSound(mo.battlen, sfx_elgun)
				end

				if timer == 30
				or timer == 40
				or timer == 70
					damageObject(target)
				elseif timer == 105
					return true
				end
			end,
	}

	--Zero lvl 23
	--attackDefs["tr_cross_mirage"] = {
	--name = "Cross Mirage", 

	--Zero lvl 27
	--attackDefs["tr_strike_bell"] = {
	--name = "Strike Bell", 

	--To Azure (lvl 50 - lvl 100+
		
	--Azure Initial
	attackDefs["tr_wild_swan_c2"] = {
			name = "Wild Swan 2",
			type = ATK_PIERCE,
			power = 490,
			accuracy = 99,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 18,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			hits = 3,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
			end,
			desc = "Fire three bullets at an enemy, \neach dealing Medium Pierce Damage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
				local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
				local cx = mo.x + 128*cos(mo.angle + ANG1*202)
				local cy = mo.y + 128*sin(mo.angle + ANG1*202)
				local wepz = mo.z + FRACUNIT*40
				local cam = server.P_BattleStatus[mo.battlen].cam
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cam.x, cam.y, target.x, target.y))
				//CONSTANTLY be chasing the right angle!
				
				//Megido star, make some shocks, fire 2 shots looking with Thoks then the final one after a smaller pause
				local dist = (R_PointToDist2(mo.x,mo.y,target.x,target.y)/FRACUNIT)/2
				
				
				if timer == 1
					if mo.anim_special2 and #mo.anim_special2
						if mo.skin == "elie"
							ANIM_set(mo, mo.anim_special2)
						end	
					end
					playSound(mo.battlen, sfx_elgry)
					mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
					//Looking at our victim!
				end
				if timer == 10
					local s = P_SpawnMobj(wepx,wepy,wepz, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = mo.scale
					playSound(mo.battlen, sfx_hamas1)
				end

				if timer == 40
					local thok = P_SpawnMobj(wepx,wepy,wepz, MT_THOK)
					thok.tics = 20
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/20
					thok.color = SKINCOLOR_GOLD
				end

				if timer == 45
				or timer == 55 
					for i = 1, dist 
						local dx = wepx + (i*4)*cos(mo.angle)
						local dy = wepy + (i*4)*sin(mo.angle)
						local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
						thok.scale = FRACUNIT/4
						thok.tics = 1
						thok.color = SKINCOLOR_YELLOW
						local g = P_SpawnGhostMobj(thok)
							g.fuse = 5
							g.color = thok.color
					end
					damageObject(target)
					for i = 1,15
						local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
						local rt = P_RandomRange(2,20)*FRACUNIT
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SSPK1
						p.scale = mo.scale
						p.colorized = true
						p.color = SKINCOLOR_GOLD
						p.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
						p.momz = P_RandomRange(-12, 12)*mo.scale
						P_InstaThrust(p, p.angle, rt)
					end
					playSound(mo.battlen, sfx_elgun)
				end
				//Basically like a laser, I think it looks neat!
				if timer == 55
					local thok = P_SpawnMobj(wepx,wepy,FRACUNIT*10, MT_THOK)
					thok.tics = 15
					thok.scale = FRACUNIT*2
					thok.destscale = 1
					thok.scalespeed = (FRACUNIT*2)/15
					thok.color = SKINCOLOR_MINT
					playSound(mo.battlen, sfx_s3k9c)
				end
				//3rd SHOT'S orb charge - This one actually ends at the start of the shot
				if timer == 70
					for i = 1, dist 
						local dx = wepx + (i*4)*cos(mo.angle)
						local dy = wepy + (i*4)*sin(mo.angle)
						local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
						thok.scale = FRACUNIT/2
						thok.color = SKINCOLOR_TEAL
						thok.tics = 2
						local g = P_SpawnGhostMobj(thok)
							g.fuse = 35
							g.color = thok.color
					end
					damageObject(target)
					for i = 1,30
						local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
						local rt = P_RandomRange(2,35)*FRACUNIT
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SSPK1
						p.scale = mo.scale
						p.colorized = true
						p.color = SKINCOLOR_EMERALD
						p.angle = mo.angle + P_RandomRange(-45, 45)*ANG1
						p.momz = P_RandomRange(-20, 20)*mo.scale
						P_InstaThrust(p, p.angle, rt)
					end
					playSound(mo.battlen, sfx_s3kc5l)
					playSound(mo.battlen, sfx_cdfm35)
					playSound(mo.battlen, sfx_cdfm35)

				end
				if timer == 105
					return true 
				end
			end,
	}

	--Azure lvl 56
	attackDefs["tr_triple_piercer_c"] = {
			name = "Triple Piercer",
			type = ATK_PIERCE,
			power = 700,
			accuracy = 99,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 23,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			hits = 3,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
			end,
			tr_castarea = 2,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Fire three bullets at an enemy, \neach dealing Heavy Pierce Damage (Set Line M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target
				if not mo.tr_lockskill
					target = hittargets[1]
				else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
					target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
					target.state = S_INVISIBLE
					target.fuse = 2
				end
				local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
				local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
				local cx = mo.x + 128*cos(mo.angle + ANG1*202)
				local cy = mo.y + 128*sin(mo.angle + ANG1*202)
				local wepz = mo.z + FRACUNIT*40
				local cam = server.P_BattleStatus[mo.battlen].cam
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cam.x, cam.y, target.x, target.y))
				//CONSTANTLY be chasing the right angle!
				
				//Megido star, make some shocks, fire 2 shots looking with Thoks then the final one after a smaller pause
				local dist = (R_PointToDist2(mo.x,mo.y,target.x,target.y)/FRACUNIT)/2
				
				
				if timer == 1
					if mo.anim_special2 and #mo.anim_special2
						if mo.skin == "elie"
							ANIM_set(mo, mo.anim_special2)
						end	
					end
					playSound(mo.battlen, sfx_elgry)
					mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
					//Looking at our victim!
				end
				if timer == 10
					local s = P_SpawnMobj(wepx,wepy,wepz, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = mo.scale
					playSound(mo.battlen, sfx_hamas1)
				end

				if timer == 40
					local thok = P_SpawnMobj(wepx,wepy,wepz, MT_THOK)
					thok.tics = 20
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/20
					thok.color = SKINCOLOR_GOLD
				end

				if timer == 45
				or timer == 55 
					for i = 1, dist 
						local dx = wepx + (i*4)*cos(mo.angle)
						local dy = wepy + (i*4)*sin(mo.angle)
						local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
						thok.scale = FRACUNIT/4
						thok.tics = 1
						thok.color = SKINCOLOR_YELLOW
						local g = P_SpawnGhostMobj(thok)
							g.fuse = 5
							g.color = thok.color
					end
					if #hittargets > 0	--In case we select nothing
						for i = 1, #hittargets
							damageObject(hittargets[i])	--this should just hit everything highlighted
						end
					end
					for i = 1,15
						local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
						local rt = P_RandomRange(2,20)*FRACUNIT
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SSPK1
						p.scale = mo.scale
						p.colorized = true
						p.color = SKINCOLOR_GOLD
						p.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
						p.momz = P_RandomRange(-12, 12)*mo.scale
						P_InstaThrust(p, p.angle, rt)
					end
					playSound(mo.battlen, sfx_elgun)
				end
				//Basically like a laser, I think it looks neat!
				if timer == 55
					local thok = P_SpawnMobj(wepx,wepy,FRACUNIT*10, MT_THOK)
					thok.tics = 15
					thok.scale = FRACUNIT*2
					thok.destscale = 1
					thok.scalespeed = (FRACUNIT*2)/15
					thok.color = SKINCOLOR_MINT
					playSound(mo.battlen, sfx_s3k9c)
				end
				//3rd SHOT'S orb charge - This one actually ends at the start of the shot
				if timer == 70
					for i = 1, dist 
						local dx = wepx + (i*4)*cos(mo.angle)
						local dy = wepy + (i*4)*sin(mo.angle)
						local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
						thok.scale = FRACUNIT/2
						thok.color = SKINCOLOR_TEAL
						thok.tics = 2
						local g = P_SpawnGhostMobj(thok)
							g.fuse = 35
							g.color = thok.color
					end
					if #hittargets > 0	--In case we select nothing
						for i = 1, #hittargets
							damageObject(hittargets[i])	--this should just hit everything highlighted
						end
					end
					for i = 1,30
						local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
						local rt = P_RandomRange(2,35)*FRACUNIT
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SSPK1
						p.scale = mo.scale
						p.colorized = true
						p.color = SKINCOLOR_EMERALD
						p.angle = mo.angle + P_RandomRange(-45, 45)*ANG1
						p.momz = P_RandomRange(-20, 20)*mo.scale
						P_InstaThrust(p, p.angle, rt)
					end
					playSound(mo.battlen, sfx_s3kc5l)
					playSound(mo.battlen, sfx_cdfm35)
					playSound(mo.battlen, sfx_cdfm35)

				end
				if timer == 105
					return true 
				end
			end,
	}

	--Azure lvl 83
	--attackDefs["tr_cross_mirage_2"] = {
	--name = "Cross Mirage 2", 

if C2SBarEdits
	-- S-Crafts

	--Zero Initial
	attackDefs["tr_aura_rain_c"] = {	--"whoops, starting to bring out my FES core animations" - Catcocomics
	name = "Aura Rain",
	type = ATK_HEAL,
	power = 50,
	--accuracy = 90,
	costtype = CST_SP,
	cost = 0,
	forcetp = true,
	notpgain = true,
	scraft = true,
	nometronome = true,
	norandom = true,
	norogue = true,	
	hudfunc =     function(v, mo, timer)	
					if timer < TICRATE
					-- draw chars:
						local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ELEAOA")
							if mo.status_condition == COND_SUPER
							and charStats[mo.stats] and charStats[mo.stats].hudsaoa
								pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
							end
			
						v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
					end	
				end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AETHER))
	end,
	desc = "".."\x82".."100 CP or higher.".."\x80".."\nRain healing energy upon all allies, \n50% HP recovery and Revival, cures status. \n100% Heal at 200 CP.",
	target = TGT_ALLALLIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
	anim = function(mo, targets, hittargets, timer)

			local avgx, avgy, avgz = 0, 0, 0
			for i = 1, #mo.allies_noupdate
				avgx = $ + mo.allies_noupdate[i].x/FRACUNIT
				avgy = $ + mo.allies_noupdate[i].y/FRACUNIT
				avgz = $ + mo.allies_noupdate[i].y/FRACUNIT
			end
			avgx = ($/#mo.allies_noupdate)	*FRACUNIT
			avgy = ($/#mo.allies_noupdate)	*FRACUNIT
			avgz = ($/#mo.allies_noupdate)	*FRACUNIT
			
			if timer == 1
				mo.hudcharx = -300
			end
			if timer < TICRATE/3
				mo.hudcharx = $+30
			end
			if timer == TICRATE/3
				mo.hudcharx = 0
			end
			if timer >= TICRATE - 10
				mo.hudcharx = $+60
			end				
			
			if timer == 1
				for i = 1, #mo.allies_noupdate
					local t = mo.allies_noupdate[i]
					if t.hp < 1
						revivePlayer(t)
						t.hp = 1
						ANIM_set(t, t.anim_downloop, true)
					end
				end
			end
			
			if timer == 1
				playSound(mo.battlen, sfx_cutlyd)
			end	
			
			if timer == 8 
				playSound(mo.battlen, sfx_aurran)
			end	
			
			if timer < 10
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 80
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_GOLD
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(1, 4)*FRACUNIT*6
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT*7
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
			end

			if timer >= 10 and timer <= 90
				if timer == 20
					playSound(mo.battlen, sfx_zio5)
					playSound(mo.battlen, sfx_hama3)
				end
				for i = 1, 8
					local sb = P_SpawnMobj(avgx+(P_RandomRange(-360,360)*FRACUNIT), avgy+(P_RandomRange(-360,360)*FRACUNIT), mo.z+(480*FRACUNIT), MT_DUMMY)
					sb.state = S_THOK
					sb.color = SKINCOLOR_SEAFOAM
					sb.frame = FF_FULLBRIGHT
					sb.blendmode = AST_ADD
					sb.renderflags = $|RF_FULLBRIGHT
					sb.scale = FRACUNIT/P_RandomRange(4, 12)*2
					sb.momx = P_RandomRange(-4, 4)*FRACUNIT
					sb.momy = P_RandomRange(-4, 4)*FRACUNIT
					sb.momz = FRACUNIT*-24
					sb.tics = 40
				end
				
				for i = 1, 8
					local sb = P_SpawnMobj(avgx+(P_RandomRange(-360,360)*FRACUNIT), avgy+(P_RandomRange(-360,360)*FRACUNIT), mo.z+(480*FRACUNIT), MT_DUMMY)
					sb.state = S_THOK
					sb.color = SKINCOLOR_TEAL
					sb.frame = FF_FULLBRIGHT
					sb.blendmode = AST_ADD
					sb.renderflags = $|RF_FULLBRIGHT
					sb.scale = FRACUNIT/P_RandomRange(2, 6)*2
					sb.momx = P_RandomRange(-4, 4)*FRACUNIT
					sb.momy = P_RandomRange(-4, 4)*FRACUNIT
					sb.momz = FRACUNIT*-24
					sb.tics = 40
				end
				
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 256
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_AZURE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*7
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(4, 12))
				end
				if timer < 50
					local grow = (50-timer)
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_SEAFOAM or SKINCOLOR_TEAL
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
				if timer == 50
					localquake(mo.battlen, FRACUNIT*8, 10)
					playSound(mo.battlen, sfx_teara)
					
					for k,v in ipairs(mo.allies_noupdate)
						if v.status_condition and v.status_condition < COND_HYPER
							cureStatus(v)
						end
						BTL_logMessage(mo.battlen, "Status nullified!")
						 if ((mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)) and mo.tp == 200) or mo.sp == 200
							damageObject(v, -v.maxhp)
						else
							damageObject(v, -v.maxhp/2)
						end
					end
				end
				if timer > 50
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 200
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + 160*FRACUNIT + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_SEAFOAM or SKINCOLOR_TEAL
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(-12, -48)*FRACUNIT
						aura.scale = FRACUNIT*3
						aura.destscale = FRACUNIT*7
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 15))
					end
					local grow = (timer-50)*2
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_SEAFOAM or SKINCOLOR_TEAL
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
			elseif timer == 100
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
				mo.hudcharx = nil
				return true
			end
		end,
	}

	--Zero lvl 33
	attackDefs["tr_aerialcannon_c"] = {
		name = "Aerial Cannon",
		type = ATK_BLESS,
		power = 500,
		accuracy = 100,
		critical = 1,
		target = TGT_ALLENEMIES, 
		costtype = CST_SP, 
		cost = 0,
		forcetp = true,
		notpgain = true,
		scraft = true,
		nometronome = true,
		norandom = true,
		norogue = true,	
		--noenemycast = true,	--Should be enemy safe now.
		status = COND_BURN, 
		statuschance = 5, 
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		hits = 16, 
		tr_castarea = 4,
		desc = "".."\x82".."100 CP or higher.".."\x80".."\nElie's S-Craft\nPrays for Aidios to give power\nand shoots explosive shots (Area M)",
		nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
		hudfunc =     function(v, mo, timer)	
						if timer < TICRATE
						-- draw chars:
							local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ELEAOA")
								if mo.status_condition == COND_SUPER
								and charStats[mo.stats] and charStats[mo.stats].hudsaoa
									pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
								end
			
							v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
						end	
					end,
		anim = function(mo, targets, hittargets, timer)

			local cam = server.P_BattleStatus[mo.battlen].cam
			local ctgt = hittargets[1] 
			local rnd = P_RandomRange(1,#hittargets) 
			local rtgt = hittargets[rnd] 
			
			if timer == 1
				mo.hudcharx = -300
			end
			if timer < TICRATE/3
				mo.hudcharx = $+30
			end
			if timer == TICRATE/3
				mo.hudcharx = 0
			end
			if timer >= TICRATE - 10
				mo.hudcharx = $+60
			end	
			
			if timer == 1
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
				ANIM_set(mo, mo.anim_special1, true)//Do this anim
				playSound(mo.battlen, sfx_cutlyd)
				playSound(mo.battlen, sfx_aercan)
				mo.angle = R_PointToAngle2(mo.x,mo.y,ctgt.x,ctgt.y) //Okay look at "1"
				//And of course, Camera
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, welcome back
			elseif timer == 15

				local cx = mo.x + 8*cos(mo.angle)
				local cy = mo.y + 8*sin(mo.angle)//TAKe this, thanks
				local thok = P_SpawnMobj(cx, cy, mo.z + FRACUNIT*40, MT_DUMMY)//At this Z height
				thok.color = SKINCOLOR_TEAL 
				thok.frame = A|FF_FULLBRIGHT //Make it not transparent
				thok.tics = 90 //For 90 - 2 seconds + 20 frames
				thok.scale = FRACUNIT*2 //2 seems good
				mo.nrg = thok 
			elseif timer >= 50 
			and timer < 85
				local cx = mo.x + 192*cos(mo.angle+ANGLE_225)
				local cy = mo.y + 192*sin(mo.angle+ANGLE_225) 
				local ccx = mo.x + 9*cos(mo.angle)
				local ccy = mo.y + 9*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				local thok = P_SpawnMobj(ccx,ccy, mo.nrg.z + 16*FRACUNIT, MT_DUMMY) //Spawn cool stuff from the main
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_CYAN
					if timer%3 then thok.color = SKINCOLOR_ICY end
					if timer%2 then thok.color = SKINCOLOR_MINT end
					thok.frame = A
					thok.tics = 10
					thok.scale = FRACUNIT
					thok.scalespeed = FRACUNIT/11
					thok.destscale = 1
					thok.momz = P_RandomRange(-10, 10)*FRACUNIT
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
			elseif timer >=85
			and timer < 105
				if timer == 85
				playSound(mo.battlen, sfx_arcann)
				local cx = mo.x + 384*cos(mo.angle+ANGLE_225)
				local cy = mo.y + 384*sin(mo.angle+ANGLE_225) 
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				if not (timer%2)
				local shot = P_SpawnMobj(mo.nrg.x + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.y + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.z + P_RandomRange(-16, 16)*FRACUNIT, MT_DUMMY)
					if not (timer%4)
						playSound(mo.battlen, sfx_elgun)
					end
					shot.state = S_STAB_1_1
					shot.color = SKINCOLOR_TEAL 
					shot.scale = (P_RandomRange(1,12)*FRACUNIT)/4
				end
			elseif timer == 105
				cam.momx = 0
				cam.momy = 0
				local cx = ctgt.x + 512*cos(ctgt.angle + ANG1*200)
				local cy = ctgt.y + 512*sin(ctgt.angle + ANG1*200) 
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, ctgt.x, ctgt.y)
			elseif timer >= 110
			and timer < 145 
				local booma = P_SpawnMobj(rtgt.x+P_RandomRange(-20, 20)*FRACUNIT, rtgt.y+P_RandomRange(-20, 20)*FRACUNIT, rtgt.z+P_RandomRange(-20, 20)*FRACUNIT, MT_BOSSEXPLODE)
					if not (leveltime%10)
						playSound(mo.battlen, sfx_tiexp)
					end
					booma.scale = FRACUNIT*3
					booma.state = S_QUICKBOOM1
					booma.colorized = true
					booma.color = SKINCOLOR_TEAL
				local boomb = P_SpawnMobj(rtgt.x+P_RandomRange(-64, 64)*FRACUNIT, rtgt.y+P_RandomRange(-64, 64)*FRACUNIT, rtgt.z+20*FRACUNIT, MT_BOSSEXPLODE)
					boomb.scale = FRACUNIT*4
					boomb.state = S_PFIRE1
					booma.colorized = true
					booma.color = SKINCOLOR_CYAN
				damageObject(rtgt) 
				localquake(mo.battlen, FRACUNIT*24, 3) 
			end
				local j = mo.columns and #mo.columns or 0
				while j
					local m = mo.columns[j]
					if not m or not m.valid
						j = $-1
						continue
					end

					for i = 1, 5
						local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.colorized = true
						boom.color = SKINCOLOR_AQUA
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*3
					end
					P_StartQuake(FRACUNIT*8, 1)
					j = $-1
				end //Setup the KANNON BOOOOOM
			if timer >= 125
			and timer < 145
				if timer == 125
					DoExplosion(ctgt)
				end
				for i = 1, 12
					local boom = P_SpawnMobj(ctgt.x + P_RandomRange(-48, 48)*FRACUNIT, ctgt.y + P_RandomRange(-48, 48)*FRACUNIT, ctgt.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1 //One person gets the biggest lol
					boom.colorized = true
					boom.color = SKINCOLOR_LIME
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
			elseif timer == 145
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 4, 10) 
					end
				end
			P_StartQuake(FRACUNIT*32, 15)

				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target)
					local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
					smol.fuse = TICRATE*2
					smol.scale = FRACUNIT*3
					smol.colorized = true
					smol.color = SKINCOLOR_TEAL
				end
				DoExplosion(ctgt)
				mo.fangle = (R_PointToAngle(ctgt.x, ctgt.y)) + ANG1*180
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)


				local a = mo.fangle - ANG1*80

				for i = 1, 16
					local m = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_DUMMY)
					P_InstaThrust(m, a, FRACUNIT*48)
					mo.columns[#mo.columns+1] = m
					m.state = S_INVISIBLE
					m.tics = TICRATE
					a = $+ ANG1*10
				end
			elseif timer == 170 //Wrap it up
				for i = 1,#hittargets
					local target = hittargets[i]
					local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
					smol.fuse = TICRATE*2
					smol.scale = FRACUNIT*3
					smol.colorized = true
					smol.color = SKINCOLOR_SEAFOAM //More smoldering
				end
				mo.nrg = nil
				mo.hudcharx = nil
				return true
			end
		end, 
	}

	--Azure lvl 67
	attackDefs["tr_aerialcannon_c2"] = {
		name = "Aerial Cannon 2",
		type = ATK_BLESS,
		power = 900,
		accuracy = 100,
		critical = 4,
		target = TGT_ALLENEMIES, 
		costtype = CST_SP, 
		cost = 0,
		forcetp = true,
		notpgain = true,
		scraft = true,
		nometronome = true,
		norandom = true,
		norogue = true,	
		noenemycast = true,
		status = COND_BURN, 
		statuschance = 10, 
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		hits = 16, 
		tr_castarea = 5,
		desc = "".."\x82".."100 CP or higher.".."\x80".."\nElie's S-Craft\nPrays for Aidios to give power\nand shoots explosive shots (Area L)",
		nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
		hudfunc =     function(v, mo, timer)	
						if timer < TICRATE
						-- draw chars:
							local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ELEAOA")
								if mo.status_condition == COND_SUPER
								and charStats[mo.stats] and charStats[mo.stats].hudsaoa
									pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
								end
			
							v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
						end	
					end,
		anim = function(mo, targets, hittargets, timer)

			local cam = server.P_BattleStatus[mo.battlen].cam
			local ctgt = hittargets[1] 
			local rnd = P_RandomRange(1,#hittargets) 
			local rtgt = hittargets[rnd] 
			
			if timer == 1
				mo.hudcharx = -300
			end
			if timer < TICRATE/3
				mo.hudcharx = $+30
			end
			if timer == TICRATE/3
				mo.hudcharx = 0
			end
			if timer >= TICRATE - 10
				mo.hudcharx = $+60
			end	
			
			if timer == 1
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
				ANIM_set(mo, mo.anim_special1, true)//Do this anim
				playSound(mo.battlen, sfx_cutlyd)
				playSound(mo.battlen, sfx_aercan)
				mo.angle = R_PointToAngle2(mo.x,mo.y,ctgt.x,ctgt.y) //Okay look at "1"
				//And of course, Camera
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, welcome back
			elseif timer == 15

				local cx = mo.x + 8*cos(mo.angle)
				local cy = mo.y + 8*sin(mo.angle)//TAKe this, thanks
				local thok = P_SpawnMobj(cx, cy, mo.z + FRACUNIT*40, MT_DUMMY)//At this Z height
				thok.color = SKINCOLOR_TEAL 
				thok.frame = A|FF_FULLBRIGHT //Make it not transparent
				thok.tics = 90 //For 90 - 2 seconds + 20 frames
				thok.scale = FRACUNIT*2 //2 seems good
				mo.nrg = thok 
			elseif timer >= 50 
			and timer < 85
				local cx = mo.x + 192*cos(mo.angle+ANGLE_225)
				local cy = mo.y + 192*sin(mo.angle+ANGLE_225) 
				local ccx = mo.x + 9*cos(mo.angle)
				local ccy = mo.y + 9*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				local thok = P_SpawnMobj(ccx,ccy, mo.nrg.z + 16*FRACUNIT, MT_DUMMY) //Spawn cool stuff from the main
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_CYAN
					if timer%3 then thok.color = SKINCOLOR_ICY end
					if timer%2 then thok.color = SKINCOLOR_MINT end
					thok.frame = A
					thok.tics = 10
					thok.scale = FRACUNIT
					thok.scalespeed = FRACUNIT/11
					thok.destscale = 1
					thok.momz = P_RandomRange(-10, 10)*FRACUNIT
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
			elseif timer >=85
			and timer < 105
				if timer == 85
				playSound(mo.battlen, sfx_arcann)
				local cx = mo.x + 384*cos(mo.angle+ANGLE_225)
				local cy = mo.y + 384*sin(mo.angle+ANGLE_225) 
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				if not (timer%2)
				local shot = P_SpawnMobj(mo.nrg.x + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.y + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.z + P_RandomRange(-16, 16)*FRACUNIT, MT_DUMMY)
					if not (timer%4)
						playSound(mo.battlen, sfx_elgun)
					end
					shot.state = S_STAB_1_1
					shot.color = SKINCOLOR_TEAL 
					shot.scale = (P_RandomRange(1,12)*FRACUNIT)/4
				end
			elseif timer == 105
				cam.momx = 0
				cam.momy = 0
				local cx = ctgt.x + 512*cos(ctgt.angle + ANG1*200)
				local cy = ctgt.y + 512*sin(ctgt.angle + ANG1*200) 
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, ctgt.x, ctgt.y)
			elseif timer >= 110
			and timer < 145 
				local booma = P_SpawnMobj(rtgt.x+P_RandomRange(-20, 20)*FRACUNIT, rtgt.y+P_RandomRange(-20, 20)*FRACUNIT, rtgt.z+P_RandomRange(-20, 20)*FRACUNIT, MT_BOSSEXPLODE)
					if not (leveltime%10)
						playSound(mo.battlen, sfx_tiexp)
					end
					booma.scale = FRACUNIT*3
					booma.state = S_QUICKBOOM1
					booma.colorized = true
					booma.color = SKINCOLOR_TEAL
				local boomb = P_SpawnMobj(rtgt.x+P_RandomRange(-64, 64)*FRACUNIT, rtgt.y+P_RandomRange(-64, 64)*FRACUNIT, rtgt.z+20*FRACUNIT, MT_BOSSEXPLODE)
					boomb.scale = FRACUNIT*4
					boomb.state = S_PFIRE1
					booma.colorized = true
					booma.color = SKINCOLOR_CYAN
				damageObject(rtgt) 
				localquake(mo.battlen, FRACUNIT*24, 3) 
			end
				local j = mo.columns and #mo.columns or 0
				while j
					local m = mo.columns[j]
					if not m or not m.valid
						j = $-1
						continue
					end

					for i = 1, 5
						local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.colorized = true
						boom.color = SKINCOLOR_AQUA
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*3
					end
					P_StartQuake(FRACUNIT*8, 1)
					j = $-1
				end //Setup the KANNON BOOOOOM
			if timer >= 125
			and timer < 145
				if timer == 125
					DoExplosion(ctgt)
				end
				for i = 1, 12
					local boom = P_SpawnMobj(ctgt.x + P_RandomRange(-48, 48)*FRACUNIT, ctgt.y + P_RandomRange(-48, 48)*FRACUNIT, ctgt.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1 //One person gets the biggest lol
					boom.colorized = true
					boom.color = SKINCOLOR_LIME
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
			elseif timer == 145
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 4, 10) 
					end
				end
			P_StartQuake(FRACUNIT*32, 15)

				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target)
					local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
					smol.fuse = TICRATE*2
					smol.scale = FRACUNIT*3
					smol.colorized = true
					smol.color = SKINCOLOR_TEAL
				end
				DoExplosion(ctgt)
				mo.fangle = (R_PointToAngle(ctgt.x, ctgt.y)) + ANG1*180
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)


				local a = mo.fangle - ANG1*80

				for i = 1, 16
					local m = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_DUMMY)
					P_InstaThrust(m, a, FRACUNIT*48)
					mo.columns[#mo.columns+1] = m
					m.state = S_INVISIBLE
					m.tics = TICRATE
					a = $+ ANG1*10
				end
			elseif timer == 170 //Wrap it up
				for i = 1,#hittargets
					local target = hittargets[i]
					local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
					smol.fuse = TICRATE*2
					smol.scale = FRACUNIT*3
					smol.colorized = true
					smol.color = SKINCOLOR_SEAFOAM //More smoldering
				end
				mo.nrg = nil
				mo.hudcharx = nil
				return true
			end
		end, 
	}

	--Azure lvl 102
	attackDefs["tr_aura_rain_c2"] = {	--"whoops, starting to bring out my FES core animations" - Catcocomics
	name = "Aura Rain 2",
	type = ATK_HEAL,
	power = 50,
	--accuracy = 90,
	costtype = CST_SP,
	cost = 0,
	forcetp = true,
	notpgain = true,
	scraft = true,
	nometronome = true,
	norandom = true,
	norogue = true,	
	hudfunc =     function(v, mo, timer)	
					if timer < TICRATE
					-- draw chars:
						local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ELEAOA")
							if mo.status_condition == COND_SUPER
							and charStats[mo.stats] and charStats[mo.stats].hudsaoa
								pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
							end
			
						v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
					end	
				end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AETHER))
	end,
	desc = "".."\x82".."100 CP or higher.".."\x80".."\nRain healing energy upon all allies, \n50% HP recovery and Revival, cures status, \nbuffs Defense 1 stage. 100% Heal at 200 CP.",
	target = TGT_ALLALLIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
	anim = function(mo, targets, hittargets, timer)

			local avgx, avgy, avgz = 0, 0, 0
			for i = 1, #mo.allies_noupdate
				avgx = $ + mo.allies_noupdate[i].x/FRACUNIT
				avgy = $ + mo.allies_noupdate[i].y/FRACUNIT
				avgz = $ + mo.allies_noupdate[i].y/FRACUNIT
			end
			avgx = ($/#mo.allies_noupdate)	*FRACUNIT
			avgy = ($/#mo.allies_noupdate)	*FRACUNIT
			avgz = ($/#mo.allies_noupdate)	*FRACUNIT
			
			if timer == 1
				mo.hudcharx = -300
			end
			if timer < TICRATE/3
				mo.hudcharx = $+30
			end
			if timer == TICRATE/3
				mo.hudcharx = 0
			end
			if timer >= TICRATE - 10
				mo.hudcharx = $+60
			end	
			
			if timer == 1
				playSound(mo.battlen, sfx_cutlyd)
			end		
			
			if timer == 8 
				playSound(mo.battlen, sfx_aurran)
			end				
			
			if timer == 1
				for i = 1, #mo.allies_noupdate
					local t = mo.allies_noupdate[i]
					if t.hp < 1
						revivePlayer(t)
						t.hp = 1
						ANIM_set(t, t.anim_downloop, true)
					end
				end
			end
			
			if timer < 10
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 80
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_GOLD
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(1, 4)*FRACUNIT*6
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT*7
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
			end

			if timer >= 10 and timer <= 90
				if timer == 20
					playSound(mo.battlen, sfx_zio5)
					playSound(mo.battlen, sfx_hama3)
				end
				for i = 1, 8
					local sb = P_SpawnMobj(avgx+(P_RandomRange(-360,360)*FRACUNIT), avgy+(P_RandomRange(-360,360)*FRACUNIT), mo.z+(480*FRACUNIT), MT_DUMMY)
					sb.state = S_THOK
					sb.color = SKINCOLOR_SEAFOAM
					sb.frame = FF_FULLBRIGHT
					sb.blendmode = AST_ADD
					sb.renderflags = $|RF_FULLBRIGHT
					sb.scale = FRACUNIT/P_RandomRange(4, 12)*2
					sb.momx = P_RandomRange(-4, 4)*FRACUNIT
					sb.momy = P_RandomRange(-4, 4)*FRACUNIT
					sb.momz = FRACUNIT*-24
					sb.tics = 40
				end
				
				for i = 1, 8
					local sb = P_SpawnMobj(avgx+(P_RandomRange(-360,360)*FRACUNIT), avgy+(P_RandomRange(-360,360)*FRACUNIT), mo.z+(480*FRACUNIT), MT_DUMMY)
					sb.state = S_THOK
					sb.color = SKINCOLOR_TEAL
					sb.frame = FF_FULLBRIGHT
					sb.blendmode = AST_ADD
					sb.renderflags = $|RF_FULLBRIGHT
					sb.scale = FRACUNIT/P_RandomRange(2, 6)*2
					sb.momx = P_RandomRange(-4, 4)*FRACUNIT
					sb.momy = P_RandomRange(-4, 4)*FRACUNIT
					sb.momz = FRACUNIT*-24
					sb.tics = 40
				end
				
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 256
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_AZURE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*7
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(4, 12))
				end
				if timer < 50
					local grow = (50-timer)
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_SEAFOAM or SKINCOLOR_TEAL
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
				if timer == 50
					localquake(mo.battlen, FRACUNIT*8, 10)
					playSound(mo.battlen, sfx_teara)
					
					for k,v in ipairs(mo.allies_noupdate)
						if v.status_condition and v.status_condition < COND_HYPER
							cureStatus(v)
						end
						BTL_logMessage(mo.battlen, "Status nullified!")
						 if ((mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)) and mo.tp == 200) or mo.sp == 200
							damageObject(v, -v.maxhp)
						else
							damageObject(v, -v.maxhp/2)
						end
						if v.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and v.damagestate ~= DMG_BLOCK
						and v.damagestate ~= DMG_DRAIN
							buffStat(v, "def", BUFFSTEP)	-- negative values lower a stat
						end
					end
				end
				if timer > 50
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 200
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + 160*FRACUNIT + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_SEAFOAM or SKINCOLOR_TEAL
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(-12, -48)*FRACUNIT
						aura.scale = FRACUNIT*3
						aura.destscale = FRACUNIT*7
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 15))
					end
					local grow = (timer-50)*2
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_SEAFOAM or SKINCOLOR_TEAL
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
			elseif timer == 100
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
				mo.hudcharx = nil
				return true
			end
		end,
	}



	--Azure Final Chapter
	--attackDefs["tr_divine_crusade"] = {
	--name = "Divine Crusade", 

end







