if not srb2p return end

DNG_Abilities["estelle_fire"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.drawangle = mo.angle
					P_SetObjectMomZ(mo, FRACUNIT*10)
					local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					t.color = mo.color
					P_InstaThrust(mo,mo.angle,(25*FRACUNIT)/*(mo.scale)*/)
					S_StartSound(p.mo,sfx_spdpad)
				end,

		func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if not P_IsObjectOnGround(mo)
							if (leveltime%3)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							mo.p_abl = false
						end
					end
				end,
}


charStats["estelle_fire"] = {

		-- GENERAL

		name = "Estelle",			-- This is only for bots / enemies
		basehp = 65,			-- base HP for level 1
		basesp = 45,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		--cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		tpmode = "craft points",
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_pummel_c", 1, 1}, {"tr_barrage_c", 15, 2}, {"tr_pummel_c2", 30, 1}, {"tr_barrage_c2", 45, 2}, {"tr_twheeloftime_c", 70, 1}, {"tr_twheeloftime_c2", 90, 1},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"joshua", "tr_timelesspummel_c", 25}, {"joshua", "tr_timelesspummel_c2", 50}, {"joshua", "tr_timelesspummel_c3", 75},
			}
			or {
				{"joshua", "tr_timelesspummel", 25}, {"joshua", "tr_timelesspummel_2", 50}, {"joshua", "tr_timelesspummel_3", 75},
		},
		
		persona = "estelleskillset_fire",
		melee_natk = "tr_staff_hit",
		--melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,
		prefcolor = SKINCOLOR_ORANGE,	--Idk why they can't just pull this from the skin.
		
		wep = "tr_birchstaff",		-- default weapon.
		weptype = WPT_HAMMER,	-- Equippable weapon type(s)

		atk = 33,
		acc = 90,
		crit = 2,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 = 	{SPR_PLAY, A, 2, "SPR2_MLEE"}, -- hammer prep
		anim_special2 = 	{SPR_PLAY, B, C, D, E, 2, "SPR2_MLEE"}, -- hammer swing
		anim_special3 = 	{SPR_PLAY, A, "SPR2_MLEE"},	-- hammer swung
		anim_special5 = 	{SPR_PLAY, A, B, C, D, E, 3, "SPR2_TAL1"},	-- Pummel/Barrage Forward Walk
		anim_special6 = 	{SPR_PLAY, E, A, A, A, A, 3, "SPR2_TAL1"},	-- Barrage Forward Jump
		anim_special7 = 	{SPR_PLAY, A, B, C, D, 3, "SPR2_MLEL"},	-- Pummel/Barrage Staff Jab
		anim_special8 = 	{SPR_PLAY, A, A, B, B, C, C, D, D, E, E, F, G, G, H, H, H, 2, "SPR2_TAL2"},	-- Barrage Kick Jump (28)| A-C kick (12) , D impact (4), E-H land (12), jab. Ghost Trail.
		anim_special9 = 	{SPR_PLAY, I, J, K, K, B, B, A, A, F, F, F, F, 2, "SPR2_TAL2"},	-- Barrage Kick-Flip (28)| I-K rising kick (8), B-A flip (8), F land (4), stand.
		--Estelle does a twirl-strike here in Barrage animation. Run anim_special2 while rotating her -36' per tick (clock-wise).
		anim_special10 = 	{SPR_PLAY, O, P, Q, R, S, T, U, U, U, U, U, U, U, U, U, 2, "SPR2_TAL2"},	-- Barrage Rising Strike (14)
		anim_special11 = 	{SPR_PLAY, A, B, B, B, B, B, B, B, B, B, B, B, B, B, B, B, C, D, E, F, G, G, G, G, G, G, G, G, G, G, G, G, G, G, 2, "SPR2_TAL3"},	-- Barrage Grand Finale (42)
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3", "sfx_eesmn4"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_hurtx = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},
		vfx_tartarus_pit = {"sfx_eemis1"},
		vfx_tartarus_item = {"sfx_esjoti"},
		vfx_tartarus_spring = {"sfx_eespng"},
		vfx_tartarus_spike = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_tartarus_critspike = {"sfx_eehrt5"},
		vfx_tartarus_spikepit = {"sfx_eempit"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		hudscutin = "ESTS_A",	-- super cut in
		aoa_quote = "Alright guys! Time for \nsome ul-tra-vio-lence!",

		tip = "A Senior A-Rank Bracer. Equipped with an Arcus II model Battle Orbment, Estelle is loaded up with a fierce mix of Fire and Earth quartz to help brain her foes when push comes to shove."
}

personaList["estelleskillset_fire"] = {
		-- GENERAL
		name = "Estelle",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 10,
		magic = 7,
		endurance = 8,
		luck = 8,
		agility = 7,
		stab = ATK_FIRE,
		weak = bionis and ATK_PSY|ATK_GRAVITY or ATK_PSY,
		resist = bionis and ATK_FIRE|ATK_BLESS|ATK_EARTH or ATK_FIRE|ATK_BLESS,
		skills = {
						{"tr_firebolt", 1}, {"tr_stone_hammer", 3}, {"tr_hard_break_c", 5},
						{"tr_forte", 8}, {"tr_comet_c", 11}, {"tr_crest", 13},
						{"tr_hurricane_c", 15}, {"tr_firebolt_ex", 17},
						
						{"tr_morale_c", 20, "tr_forte"}, {"tr_flare_arrow", 23, "tr_firebolt"},
						{"tr_comet_c2", 27, "tr_comet_c"},
						{"tr_petrify_breath", 31, "tr_stone_hammer"}, {"tr_spiral_flare", 34, "tr_firebolt_ex"}, {"tr_la_crest", 37, "tr_crest"},
						{"tr_hard_break_c2", 40, "tr_hard_break_c"},
						{"tr_hurricane_c2", 44, "tr_hurricane_c"},
						
						{"tr_swellinghope_c", 46, "tr_morale_c"},
						{"tr_napalm_breath", 50, "tr_flare_arrow"}, {"tr_earth_lance", 53, "tr_petrify_breath"},
						{"tr_comet_c3", 57, "tr_comet_c2"},
						{"tr_volcanic_rave", 60, "tr_spiral_flare"}, {"tr_zodiac", 63, "tr_la_crest"},
						{"tr_hard_break_c3", 66, "tr_hard_break_c2"},
						{"tr_hurricane_c3", 70, "tr_hurricane_c2"},
						{"tr_cyclone_napalm", 77, "tr_napalm_breath"},
				},
}









