-- Stuff relative to custom dungeon save files goes here
-- Part of the Expanded Custom Dungeon Code Pack created by NerduMiner/UltimateBoboboFan713/MichaelYIIKFan4499
if ExpandedDungeonSaves return end
rawset(_G, "ExpandedDungeonSaves", true)
---------------------CUSTOM DUNGEON SAVES---------------------------------------
local files = {}
for i = 1, MAXQSAVEFILES do
	files[i] = {"FILE "..i}
end

local function drawqSavecFiles(v, mo, choice, forcetimer)

	local timers = mo.m_hudtimers
	local timer = timers.sclosemenu and ((TICRATE*2/3) - timers.sclosemenu) or timers.smenuopen or 0
	local fwtimer = (TICRATE*2/3) - timer

	-- kool visual!!!!
	v.fadeScreen(31, min(7, fwtimer/2))
	PDraw(v, 0, timer*48, v.cachePatch("M_SAVE"), V_SNAPTOLEFT)
	v.drawFill(64, 0, 1, fwtimer*48, 135|V_SNAPTOLEFT|V_SNAPTOTOP)

	local y = 24

	for i = 1, MAXQSAVEFILES do
		local t = max(0, timer - (MAXQSAVEFILES-(i-1))*2)
		local startx = 80 + (64*t)
		local skinx = startx + 40	--120
		local h = srb2p.fileheaders[i]
		local invalid

		local headertext = "FILE"..i
		if mo.m_selectfile and choice == i
			headertext = "CONFIRM AGAIN TO OVERWRITE"
		end

		V_drawString(v, startx, y, headertext, "FPIMP", 0, nil, 0, 31)
		local txt = h and h.text or "EMPTY"
		-- iterate skins first

		V_drawString(v, startx, y+12, txt, "NFNT", 0, nil, 0, 31)
		-- draw characters:
		if h and not (choice == i and mo.m_selectfile)
			for i = 1, #h.playerlist
				for j = 1, #h.playerlist[i]
					local skin = h.playerlist[i][j].skin

					local stats = charStats[skin] or charStats["sonic"]	-- whatever lmfao
					local pp = v.cachePatch(stats.icon or "ICO_SONI")
					local color = skins[skin] and skins[skin].prefcolor or SKINCOLOR_GREEN

					PDraw(v, skinx, y+1, pp, 0, v.getColormap(TC_DEFAULT, color))
					skinx = $+10
				end
				skinx = $+6
			end
		end

		local colour = 31
		if choice == i and not (mo.m_selectfile and leveltime & 1)
			colour = 135
		end

		v.drawFill(startx-5, y-4, 999, 1, colour)
		v.drawFill(startx-4, y-3, 999, 1, colour)

		v.drawFill(startx-5, y+22, 999, 1, colour)
		v.drawFill(startx-4, y+21, 999, 1, colour)

		y = $+27
	end
end

local SAVEVER = "1"
local qsavefolder = "client/Quickplay/"

-- Unarchives dungeon status and writes to the server
local function SAVE_NetUnArchiveDungeon(f)
	local dng = f:read()
	dng = json.decode(dng)
	server.P_DungeonStatus = dng
end

-- Unarchives a single battle status and returns the unarchived table
local function SAVE_NetUnArchiveBattle(s)
	return json.decode(s)
end

-- Unarchives all battle statuses and overwrite the server
local function SAVE_NetUnArchiveBattles(f)

	local r = f:read()
	local nbattle = 1

	while r ~= SAVEBLOCK_END
		local btl = SAVE_NetUnArchiveBattle(r)	-- Get decoded battle
		-- Overwrite battle statuses
		SAVE_OverwriteObject(server.P_BattleStatus[nbattle], btl)
		r = f:read()
	end
end

-- Unarchives a single player and returns the table:
local function SAVE_NetUnArchivePlayer(s)
	return json.decode(s)
end

-- Overwrite players from the plentities list by unarchiving save data
local function SAVE_NetUnArchivePlayers(f)

	local r = f:read()
	local nteam = 1
	local teamslot = 1

	while r ~= SAVEBLOCK_END

		if r == SAVEBLOCK_TEAM
			nteam = $+1
			teamslot = 1
			r = f:read()
			continue	-- switch teams to write into
		end

		local p = SAVE_NetUnArchivePlayer(r)	-- Get player table
		SAVE_OverwriteObject(server.plentities[nteam][teamslot], p)

		teamslot = $+1
		r = f:read()
	end
end

-- reads and returns header from a given file (file must already be opened and ready to read)
local function SAVE_getCHeader(f, load)
	-- leave header nil for inexistant files, makes it easier
	if not f
		return false
	end

	local h = {}
	h.usable = true

	local r = f:read()
	-- these types of files can exist if the host tried to load an empty file.
	if not r or r == "\n" or r == "EMPTY"
		return false
	end

	-- Get save version
	if r ~= SAVEVER
		h.text = "\x85".."OLD: SAVE VERSION DOES NOT MATCH"
		h.usable = nil	-- NO!
		return h
	end


	while r ~= SAVEBLOCK_ENDFILE

		if r == SAVEBLOCK_DUNGEON
			-- get floor
			local r = f:read()
			if r == nil or r == ""
				h.text = "\x85".."CORRUPTED: DUNGEON BLOCK INVALID"
				h.usable = nil	-- NO!
				return h
			end

			local dng = json.decode(r)
			h.dng = dng
			h.text = server.cdungeon.name..", "..dng.floor.."F"

		-- get roguemode seed if necessary
		elseif r == SAVEBLOCK_ROGUESEED
			--print("seed set")
			h.rogueseed = tonumber(f:read())

		elseif r == SAVEBLOCK_BATTLE
			local nbattle = 1
			h.battle = {}

			r = f:read()
			if r == nil or r == ""
				h.text = "\x85".."CORRUPTED: BATTLE BLOCK INVALID"
				h.usable = nil	-- NO!
				return h
			end

			while r ~= SAVEBLOCK_END
				h.battle[nbattle] = SAVE_NetUnArchiveBattle(r)	-- Get decoded battle
				nbattle = $+1
				r = f:read()
			end

		elseif r == SAVEBLOCK_PLAYERS	-- get skin list
			local teamslot = 1
			local teamnum = 1
			h.playerlist = {}
			r = f:read()

			if r == nil or r == ""
				h.text = "\x85".."CORRUPTED: PLAYER BLOCK INVALID"
				h.usable = nil	-- NO!
				return h
			end

			while r ~= SAVEBLOCK_END
				h.playerlist[teamnum] = $ or {}

				if r == SAVEBLOCK_TEAM
					h.teamlen = $ or teamslot-1
					teamslot = 1
					teamnum = $+1
					r = f:read()
					continue
				end

				h.playerlist[teamnum][teamslot] = SAVE_NetUnArchivePlayer(r)

				teamslot = $+1
				r = f:read()
			end
			h.teamlen = $ or teamslot-1	-- just in case
		end

		r = f:read()
	end
	return h
end

-- Archive server.P_DungeonStatus
local function SAVE_NetArchiveDungeon(f)
	local dng = json.encode(server.P_DungeonStatus)	-- this can be encoded directly.
	f:write(SAVEBLOCK_DUNGEON.."\n")
	f:write(dng.."\n")
	f:write(SAVEBLOCK_END.."\n")
end

-- Archive server.P_BattleStatus.
-- This is archived as several tables on different lines.
local function SAVE_NetArchiveBattles(f)

	f:write(SAVEBLOCK_BATTLE.."\n")

	for i = 1, #server.P_BattleStatus

		local btl = server.P_BattleStatus[i]
		local s = SAVE_ArchiveBattle(btl)
		f:write(s.."\n")
	end

	f:write(SAVEBLOCK_END.."\n")
end

local function SAVE_NetArchivePlayers(f)

	f:write(SAVEBLOCK_PLAYERS.."\n")

	for i = 1, #server.plentities
		for j = 1, #server.plentities[i]
			local s = SAVE_ArchivePlayer(server.plentities[i][j])
			f:write(s.."\n")
		end
		f:write(SAVEBLOCK_TEAM.."\n")	-- For file parser
	end

	f:write(SAVEBLOCK_END.."\n")
end

rawset(_G, "SAVE_QSaveCFile", function(filenum, fileprefix)
	-- save battle status
	local filename = qsavefolder..fileprefix..filenum..".sav2"
	local f = io.openlocal(filename, "w")
	-- write file headers
	f:write(SAVEVER.."\n")	-- save version, used for file compatibility

	-- Write relevant data
	--SAVE_NetArchiveRogueSeed(f)
	SAVE_NetArchiveDungeon(f)
	SAVE_NetArchivePlayers(f)
	SAVE_NetArchiveBattles(f)

	-- SAVING COMPLETE
	f:write(SAVEBLOCK_ENDFILE)
	f:close()
end)

M_menus["mp_qsavec"] = {

	m_start_at = "qsave_main",	-- where the menu starts
	openfunc = function(mo)	-- play a sound when we open the menu:
		S_StartSound(nil, sfx_select, mo.player)
		mo.m_selectfile = nil
		srb2p.fileheaders = SAVE_GetQFilesCHeaders(server.cdungeon.fileprefix)	-- reset file header display
	end,

	qsave_main = {
		opentimer = TICRATE*2/3,
		closetimer = TICRATE*2/3,
		hoversound = sfx_hover,
		confirmsound = sfx_confir,

		-- choices: mostly used for the input handler. The drawer might not need it.
		choices = files,
		-- drawer to run continuously whilst this menu is opened

		drawer = drawqSavecFiles,

		runfunc =			function(mo)

								local inpts = mo.P_inputs
								if mo.m_selectfile
									if inpts[BT_SPIN] == 1
										S_StartSound(nil, sfx_cancel, mo.player)
										mo.m_selectfile = nil
									elseif inpts[BT_JUMP] == 1
										S_StartSound(nil, sfx_lvup, mo.player)
										mo.m_selectfile = nil

										-- make sure this only happens for the game client,
										-- we wouldn't want everyone's games to be saved...
										if mo.player == consoleplayer
											SAVE_QSaveCFile(mo.m_menuchoices[mo.m_submenu], server.cdungeon.fileprefix)
											srb2p.fileheaders = SAVE_GetQFilesCHeaders(server.cdungeon.fileprefix)	-- update headers
										end
									end
									-- don't allow normal menu operation
									return true
								end
							end,

		confirmfunc = 		function(mo)
								mo.m_selectfile = true
							end,
	},

}

rawset(_G, "SAVE_GetQFilesCHeaders", function(fileprefix)

	local headers = {}
	for i = 1, MAXQSAVEFILES
		local filename = qsavefolder..fileprefix..i..".sav2"

		local f = io.openlocal(filename, "r")
		if not f
			continue
		end
		-- leave header nil for inexistant files, makes it easier
		--print(filename)
		headers[i] = SAVE_getCHeader(f)
	end

	return headers
end)

rawset(_G, "SAVE_getNetgameFileHeaderC", function(filenum, fileprefix)
	local filename = qsavefolder..fileprefix..filenum..".sav2"
	local f = io.openlocal(filename, "r")
	io.open(filename, "r", function(f)
		server.netgamefile = SAVE_getCHeader(f)
	end)
end)
----------------------CUSTOM DUNGEON SAVES END---------------------------------------

----------------------NET MENU---------------------------------------
local addy = 0

local function drawMenu_customDungeons(v, mo, choice, forcetimer)

	-- reminder that this whole menu is kind of a hack

	--drawScreenwidePatch(v, v.cachePatch("H_RIP4"), nil, V_30TRANS)
	v.fadeScreen(31, 7)

	-- draw the old menu going away at the back
	local timers = mo.m_hudtimers
	local oldtimer = TICRATE/3 - (timers.sclosemenu and (TICRATE/3 - timers.sclosemenu) or timers.smenuopen or 0)

	local mx = 320
	if oldtimer
		mx = 320 + oldtimer*64
	end

	-- draw menu string or smth:
	v.drawFill(mx - 97, 0, 200, 12, 135|V_SNAPTOTOP|V_SNAPTORIGHT)
	V_drawString(v, mx - 102, 0, "SELECT", "FPIMP", V_SNAPTORIGHT|V_SNAPTOTOP, nil, 31, nil, FRACUNIT*75/100)

	local m = M_menus["mpselect_main"].mpselect_mainmenu

	-- draw the command help first:
	v.drawFill(oldtimer*96, 180, 999, 12, 31|V_SNAPTOBOTTOM|V_SNAPTOLEFT)

	-- draw the commands for it:
	for i = 1, #m.choices do
		V_drawString(v, mx - (124 + i*6), 40 + (i*20), m.choices[i][1], "FPIMP", V_SNAPTORIGHT, nil, 0, 31, FRACUNIT*80/100)
	end

	-- now draw our new menu~

	local nchoices = mo.m_dynchoices

	local dy = 92 - 16*(choice-1) --164
	local y = dy-16

	addy = $/2

	if not nchoices return end	-- wait a bit

	-- set addy thru some hack
	local inpt = mo.P_inputs
	local tchoice = choice	-- temp choice used for calc

	if inpt["up"] == 1
		--tchoice = $+1
		if tchoice == 1
			--addy = blocks*16
		else
			tchoice = $+1
			--addy = (84 + 16*(choice-1)) - (84 + 16*(tchoice-1))
		end

	elseif inpt["down"] == 1
		if tchoice == blocks
			--addy = -blocks*32
		else
			tchoice = $-1
			--addy = (32*(choice-1)) - (32*(tchoice-1))
		end
	end


	local t = (timers.sclosemenu and (TICRATE/3 - timers.sclosemenu) or timers.smenuopen or 0)

	--PDraw(v, 0, t*32, v.cachePatch("H_CHAL"), V_SNAPTOLEFT)
	--v.drawFill(43, 0, 2, 300 - t*32, 135|V_SNAPTOLEFT)

	-- draw the difficulties first:
	for i = 1, nchoices

		if dy < 36
			dy = $+16	-- skip drawing
			continue
		end

		local header = P_getCustomDungeon(i)
		if not header break end

		local color = choice == i and 135 or 31
		v.drawFill(97 + t*64, dy+addy, 999, 1, color|V_SNAPTORIGHT)
		v.drawFill(96 + t*64, dy+1+addy, 999, 1, color|V_SNAPTORIGHT)

		v.drawFill(96 + t*64, dy+14+addy, 999, 1, color|V_SNAPTORIGHT)	-- borders
		v.drawFill(97 + t*64, dy+15+addy, 999, 1, color|V_SNAPTORIGHT)

		V_drawString(v, 100 + t*64, dy+4+addy, header.name:upper(), "FPIMP", V_SNAPTORIGHT, nil, 0, 31)

		dy = $+16
	end

	-- info:
	local header = P_getCustomDungeon(choice)
	PDraw(v, t*32, 0, v.cachePatch("H_CINFO"), V_SNAPTORIGHT)
	V_drawString(v, 320 +t*32 - 8, 8, header.name:upper(), "FPIMP", V_SNAPTORIGHT, "right", 31, nil)

	V_drawString(v, 320 +t*32 - 8, 18, header.description, "NFNT", V_SNAPTORIGHT, "right", 31, nil)

	V_drawString(v, 320 - 220 +t*32, 42, "LEVEL", "FPIMP", V_SNAPTORIGHT, nil, 31, nil)
	V_drawString(v, 320 - 180 +t*32, 43, header.level, "NFNT", V_SNAPTORIGHT, nil, 31, nil)

	V_drawString(v, 320 - 150 +t*32, 42, "FLOORS", "FPIMP", V_SNAPTORIGHT, nil, 31, nil)
	V_drawString(v, 320 - 100 +t*32, 43, header.floors, "NFNT", V_SNAPTORIGHT, nil, 31, nil)

	-- difficulty
	local difficulty = header.gensize
	local sx = 320 - 50 + t*32

	for i = 1, 6
		local pname = "RSTAR1"

		if i > difficulty
			pname = "RSTAR0"
		end

		v.drawIndex(sx<<FRACBITS, 42<<FRACBITS, FRACUNIT/2, v.cachePatch(pname), V_SNAPTORIGHT, 31)
		sx = $+8
	end

	--V_drawString(v, 320 - 90 +t*32, 38, "SCORE", "FPIMP", V_SNAPTORIGHT, nil, 31, nil)
	--V_drawString(v, 320 - 93 +t*32, 46, "TARGET", "FPIMP", V_SNAPTORIGHT, nil, 31, nil)
	--V_drawString(v, 320 - 45 +t*32, 43, header.points, "NFNT", V_SNAPTORIGHT, nil, 31, nil)
end

local function drawMenu_tartarus_cdungeonselect(v, mo, choice, forcetimer)
	local timers = mo.m_hudtimers
	local timer = timers.sclosemenu and (TICRATE/3 - timers.sclosemenu) or timers.smenuopen or 0

	local fade = V_50TRANS
	if timer
		fade = V_90TRANS - ((8 - timer)/2)*V_10TRANS
	end
	--drawScreenwidePatch(v, v.cachePatch("H_RIP4"), nil, V_30TRANS)
	v.fadeScreen(31, 7)

	-- main
	local mx = 320
	if timer
		mx = 320 + timer*64
	end
	PDraw(v, mx, 200, v.cachePatch("M_BG1"), V_SNAPTORIGHT|V_SNAPTOBOTTOM)

	-- draw menu string or smth:
	v.drawFill(mx - 97, 0, 200, 12, 135|V_SNAPTOTOP|V_SNAPTORIGHT)
	V_drawString(v, mx - 102, 0, "TARTARUS", "FPIMP", V_SNAPTORIGHT|V_SNAPTOTOP, nil, 31, nil, FRACUNIT*75/100)

	local m = M_menus["mpselect_main"].mpselect_cdungeonsel

	-- draw the command help first:
	v.drawFill(0, 180, 999, 12, 31|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	V_drawString(v, 12, 182, m.choices[choice][2], "NFNT", V_SNAPTORIGHT|V_SNAPTOBOTTOM, nil, 0, nil)

	-- draw the commands for it:
	for i = 1, #m.choices do
		-- draw cursor:
		if i == choice
			PDraw(v, mx - (130 + i*6), 56 + (i*20), v.cachePatch("M_CURS1"), V_SNAPTORIGHT)
		end
		V_drawString(v, mx - (124 + i*6), 60 + (i*20), m.choices[i][1], "FPIMP", V_SNAPTORIGHT, nil, 0, 31, FRACUNIT*80/100)
	end
end

M_menus["mpselect_main"].mpselect_cdungeon = {
		opentimer = TICRATE/3,
		closetimer = TICRATE/3,
		hoversound = sfx_hover,
		confirmsound = sfx_confir,
		dynchoices = true,
		prev = "mpselect_mainmenu",
		drawer = drawMenu_customDungeons,
		
		choices = {
			-- syntax: {name, description, nextmenu}
			{"", "", ""},
		},

		confirmfunc = function(mo)
							mo.P_inputs[BT_JUMP] = 2	-- skip input
							server.cdungeon = P_getCustomDungeon(mo.m_menuchoices[mo.m_submenu])

							M_openSubmenu(mo, "mpselect_cdungeonsel", true)
		end,
	}
M_menus["mpselect_main"].mpselect_cdungeonsel = {
		opentimer = TICRATE/3,
		closetimer = TICRATE/3,
		hoversound = sfx_hover,
		confirmsound = sfx_confir,
		prev = "mpselect_cdungeon",
	
		-- choices: mostly used for the input handler. The drawer might not need it.
		choices = {
			-- syntax: {name, description, nextmenu}
			{"NEW GAME", "Start a new Custom Dungeon run.", ""},
			{"LOAD FILE", "Load a saved Custom Dungeon run.", "qload_cdun"},
		},
	
		confirmfunc = 	function(mo)
							if mo.m_menuchoices[mo.m_submenu] == 2 -- we're checking save files
								-- ready the file headers
								srb2p.fileheaders = SAVE_GetQFilesCHeaders(server.cdungeon.fileprefix)
							else
								if not server.cdungeon
									return	-- ?????
								end
								mo.P_inputs[BT_JUMP] = 2	-- skip input
								NET_begin()
								server.P_netstat.buffer = {
									map = server.cdungeon.mapid and server.cdungeon.mapid or srb2p.customdungeon_map,
									gamemode = GM_COOP,
									extradata = 1,
									maxparties = 4,
								}
								M_closeMenu(mo)
							end
						end,
	
		-- drawer to run continuously whilst this menu is opened
		drawer = drawMenu_tartarus_cdungeonselect,
	}

local function drawqLoadFilesc(v, mo, choice, forcetimer)

	local timers = mo.m_hudtimers
	local timer = timers.sclosemenu and ((TICRATE*2/3) - timers.sclosemenu) or timers.smenuopen or 0
	local fwtimer = (TICRATE*2/3) - timer

	v.fadeScreen(31, 7)

	-- OLD MENU DRAWER
	if 1	-- < i know this is stupid but at least it's more organized :)
		local oldtimer = (TICRATE*2/3) - (timers.sclosemenu and ((TICRATE*2/3) - timers.sclosemenu) or timers.smenuopen or 0)

		local mx = 320
		if oldtimer
			mx = 320 + oldtimer*64
		end

		-- draw menu string or smth:
		v.drawFill(mx - 97, 0, 200, 12, 135|V_SNAPTOTOP|V_SNAPTORIGHT)
		V_drawString(v, mx - 102, 0, "MARATHON", "FPIMP", V_SNAPTORIGHT|V_SNAPTOTOP, nil, 31, nil, FRACUNIT*75/100)

		local m = M_menus["mpselect_main"].mpselect_cdungeonsel

		-- draw the command help first:
		v.drawFill(oldtimer*96, 180, 999, 12, 31|V_SNAPTOBOTTOM|V_SNAPTOLEFT)

		-- draw the commands for it:
		for i = 1, #m.choices do
			V_drawString(v, mx - (124 + i*6), 60 + (i*20), m.choices[i][1], "FPIMP", V_SNAPTORIGHT, nil, 0, 31, FRACUNIT*80/100)
		end
	end

	-- kool visual!!!!
	PDraw(v, 0, timer*48, v.cachePatch("M_LOAD"), V_SNAPTOLEFT)
	v.drawFill(64, 0, 1, fwtimer*48, 135|V_SNAPTOLEFT|V_SNAPTOTOP)

	local y = 24

	for i = 1, MAXQSAVEFILES do
		local t = max(0, timer - (MAXQSAVEFILES-(i-1))*2)
		local startx = 80 + (64*t)
		local skinx = startx + 40	--120
		local h = srb2p.fileheaders[i]
		local invalid

		local headertext = "FILE"..i
		if mo.m_selectfile and choice == i
			headertext = "CONFIRM AGAIN TO LOAD"
		end

		V_drawString(v, startx, y, headertext, "FPIMP", 0, nil, 0, 31)
		local txt = h and h.text or "EMPTY"
		-- iterate skins first

		V_drawString(v, startx, y+12, txt, "NFNT", 0, nil, 0, 31)
		-- draw characters:
		if h and not (choice == i and mo.m_selectfile) and h.playerlist and #h.playerlist
			for i = 1, #h.playerlist
				for j = 1, #h.playerlist[i]
					local skin = h.playerlist[i][j].skin

					local stats = charStats[skin] or charStats["sonic"]	-- whatever lmfao
					local pp = v.cachePatch(stats.icon or "ICO_SONI")
					local color
					if skins[skin]
						color = skins[skin].prefcolor
					end

					PDraw(v, skinx, y+1, pp, 0, v.getColormap(TC_DEFAULT, color))
					skinx = $+10
				end
				skinx = $+6
			end
		end

		local colour = 31
		if choice == i and not (mo.m_selectfile and leveltime & 1)
			colour = 135
		end

		v.drawFill(startx-5, y-4, 999, 1, colour)
		v.drawFill(startx-4, y-3, 999, 1, colour)

		v.drawFill(startx-5, y+22, 999, 1, colour)
		v.drawFill(startx-4, y+21, 999, 1, colour)

		y = $+27
	end


	if (mo.m_invalidskins and #mo.m_invalidskins) or mo.m_invalidfile or mo.m_toomanyplayers
		v.fadeScreen(31, 7)
		v.drawFill(0, 80, 999, 40, 135|V_SNAPTOLEFT)
		V_drawString(v, 160, 85, "\x82".."Couldn't load the save file", "NFNT", 0, "center", 0, 31)

		if mo.m_invalidfile
			V_drawString(v, 160, 95, "Save version differs, or the file is corrupt or empty.", "NFNT", 0, "center", 0, 31)
		elseif mo.m_toomanyplayers
			V_drawString(v, 160, 95, "There are too many players.", "NFNT", 0, "center", 0, 31)
		elseif #mo.m_invalidskins
			local str = "Skins missing: "
			for i = 1, #mo.m_invalidskins do
				str = $..mo.m_invalidskins[i]
				if i < #mo.m_invalidskins
					str = $..", "
				end
			end
			V_drawString(v, 160, 95, str, "NFNT", 0, "center", 0, 31)
		end

		V_drawString(v, 160, 105, "(Press A to abort)", "NFNT", 0, "center", 0, 31)
	end
end

M_menus["mpselect_main"].qload_cdun = {
		opentimer = TICRATE*2/3,
		closetimer = TICRATE*2/3,
		hoversound = sfx_hover,
		confirmsound = sfx_confir,
		prev = "mpselect_cdungeonsel",

		-- choices: mostly used for the input handler. The drawer might not need it.
		choices = files,
		-- drawer to run continuously whilst this menu is opened

		drawer = drawqLoadFilesc,

		openfunc =			function(mo)
								mo.m_waitforfile = nil	-- make sure we don't keep that somehow
							end,

		runfunc =			function(mo)

								local inpts = mo.P_inputs

								if server.netgamefile ~= nil
									mo.m_waitforfile = nil
									-- check netgame file:
									mo.m_invalidfile = (server.netgamefile == false)
									mo.m_invalidskins = {}
									-- count players
									local nump = 0
									for p in players.iterate do
										nump =$+1
									end
									local initialnump = nump


									-- check skins
									if not mo.m_invalidfile and server.netgamefile.playerlist
										for i = 1, #server.netgamefile.playerlist
											for j = 1, #server.netgamefile.playerlist[i]
												nump = $-1
												if not skins[server.netgamefile.playerlist[i][j].skin]
													mo.m_invalidskins[#mo.m_invalidskins+1] = server.netgamefile.playerlist[i][j].skin
												end
											end
										end
									end

									mo.m_toomanyplayers = nump > 0

									-- if nothing's wrong, move to next menu index!
									if not mo.m_invalidfile and not #mo.m_invalidskins and not mo.m_toomanyplayers
										mo.P_inputs[BT_JUMP] = 2	-- skip inpt
										NET_begin(NET_LOAD)
										server.P_netstat.buffer = {
											map = srb2p.customdungeon_map,
											gamemode = GM_COOP,
											load = true,	-- tell the game we're gonna be loading skins
											extradata = 1,	-- by default, do normal difficulty
											maxparties = max(1, nump/4),
										}
										M_closeMenu(mo)
										return
									end

									if inpts[BT_BTNA] == 1
										server.netgamefile = nil
										mo.m_invalidfile = nil
										mo.m_invalidskins = nil
										mo.m_toomanyplayers = nil
									end


									return true
								end

								-- don't do anything while we wait for the file to load
								if mo.m_waitforfile
									return true
								end

								if mo.m_selectfile
									if inpts[BT_SPIN] == 1
										S_StartSound(nil, sfx_cancel, mo.player)
										mo.m_selectfile = nil
									elseif inpts[BT_JUMP] == 1
										mo.m_selectfile = nil

										-- make sure this only happens for the game client,
										-- we wouldn't want everyone's games to be saved...
										SAVE_getNetgameFileHeaderC(mo.m_menuchoices[mo.m_submenu], server.cdungeon.fileprefix)
										mo.m_waitforfile = true
									end
									-- don't allow normal menu operation
									return true
								end
							end,

		confirmfunc = 		function(mo)
								mo.m_selectfile = true
							end,
	}
----------------------NET MENU END---------------------------------------

----------------------TARTARUS CRAWLER---------------------------------------
local entity_pos = {}

local function DNG_check_stairs_uncovered(p, n)
	if server.map[n] == T_EXIT
	and not server.P_DungeonStatus.stairsfound
		server.P_DungeonStatus.stairsfound = true
		VFX_Play(p.mo,VFX_TARTARUS_SPRING)
		DNG_logMessage("\x82"..p.name.."\x80".." found the ".."\x83".."Spring".."\x80".."!")
	end
end

-- have players fill the map by walking
local function DNG_fillmap()

	if server.gentype == GEN_INTERFERENCE
		return	-- No minimap filling during interference!
	end

	for p in players.iterate do
		local mo = p.mo
		if not mo continue end

		local map = server.map
		-- this is the map index we are in

		local w, h = 48,48	-- width and height of the map borders

		local sec = mo.subsector.sector
		local t = server.map

		local up,down,left,right,diag1,diag2,diag3,diag4
		local upn,downn,leftn,rightn,diag1n,diag2n,diag3n,diag4n

		if not t or not #t return end	-- oops

		for k,v in ipairs(t)
			if k == #sec

				local i = k+1

				if t[i-48] ~= nil
					up = t[i-48]
					upn = i-48
				end

				if t[i+48] ~= nil
					down = t[i+48]
					downn = i+48
				end

				if t[i-1] ~= nil
				and i%48 ~= 1
					left = t[i-1]
					leftn = i-1
				end

				if t[k+1] ~= nil
				and i%48 ~= 0
					right = t[i+1]
					rightn = i+1
				end

				if t[i-49] ~= nil
				and i%48 ~= 1
					diag1 = t[i-49]
					diag1n = i-49
				end

				if t[i-47] ~= nil
				and i%48 ~= 0
					diag2 = t[i-47]
					diag2n = i-47
				end

				if t[i+49] ~= nil
				and i%48 ~= 0
					diag3 = t[i+49]
					diag3n = i+49
				end

				if t[i+47] ~= nil
				and i%48 ~= 1
					diag4 = t[i+47]
					diag4n = i+47
				end
			end
		end

		local n = tonumber(#sec+1)

		-- always check for all squares around the player to make map filling easier.

		local m = server.rendermap[p.P_party]
		if not m continue end

		if n
			if m[n] == nil
				m[n] = map[n]
				DNG_check_stairs_uncovered(p, n)
			end
		end

		if tonumber(upn)
			if m[tonumber(upn)] == nil
				m[tonumber(upn)] = tonumber(up)
				DNG_check_stairs_uncovered(p, upn)
			end
		end

		if tonumber(downn)
			if m[tonumber(downn)] == nil
				m[tonumber(downn)] = tonumber(down)
				DNG_check_stairs_uncovered(p, downn)
			end
		end

		if tonumber(leftn)
		if m[tonumber(leftn)] == nil
				m[tonumber(leftn)] = tonumber(left)
				DNG_check_stairs_uncovered(p, leftn)
			end
		end

		if tonumber(rightn)
			if m[tonumber(rightn)] == nil
				m[tonumber(rightn)] = tonumber(right)
				DNG_check_stairs_uncovered(p, rightn)
			end
		end

		if tonumber(diag1n)
			if m[tonumber(diag1n)] == nil
				m[tonumber(diag1n)] = tonumber(diag1)
				DNG_check_stairs_uncovered(p, diag1n)
			end
		end

		if tonumber(diag2n)
			if m[tonumber(diag2n)] == nil
				m[tonumber(diag2n)] = tonumber(diag2)
				DNG_check_stairs_uncovered(p, diag2n)
			end
		end

		if tonumber(diag3n)
			if m[tonumber(diag3n)] == nil
				m[tonumber(diag3n)] = tonumber(diag3)
				DNG_check_stairs_uncovered(p, diag3n)
			end
		end

		if tonumber(diag4n)
			if m[tonumber(diag4n)] == nil
				m[tonumber(diag4n)] = tonumber(diag4)
				DNG_check_stairs_uncovered(p, diag4n)
			end
		end
	end
end

local function DNG_tartarusSynch()
	-- ready synch shit (EXPERIMENTAL)
	for i = 1, #server.DNG_entities
		local e = server.DNG_entities[i]
		if e and e.valid and DNG_isShadow(e)
			entity_pos[i] = {e.x, e.y, e.z, e.angle, e.shadowflags, e.type}
		end
	end

	if server.mustresetentities
		DNG_resetEntitiesForJoiner()
		server.mustresetentities = nil
	end
end

local function DNG_tartarusReaper()
	-- reaper stuff:
	local d = server.P_DungeonStatus
	if d.reapertimer ~= nil
	and not (d.noreaper)
	--and cv_reaper.value
	and server.gamemode == GM_COOP
		d.reapertimer = $-1

		if d.reapertimer <= 0
		and not (server.reaper and server.reaper.valid)
		and not d.spawnedreaper

			-- check if NO ONE is in a battle
			local run
			for i = 1, 4
				if server.P_BattleStatus[i].running
				and #server.P_BattleStatus[i].fighters
					run = true
					break
				end
			end

			if not run
				d.spawnedreaper = true
				D_spawnReaper()
			end
		end
	end

	if server.gamemode == GM_VOIDRUN
	and d.VR_type == VC_INFILTRATION
	and d.VR_timer ~= nil
	and not server.reaper
		D_spawnReaper()
	end
end

rawset(_G, "D_tartarusCrawler", function()
	if not (DNG_isTartarusMap()) return end
	if not server.map or not #server.map return end	-- map hasn't fully generated yet, just wait a bit.
	local d = server.P_DungeonStatus

	DNG_tartarusSynch()

	if server.blocktrans
		-- Do block transition
		for p in players.iterate do
			PLAY_nomove(p)
		end


		server.blocktrans = $+1

		if server.blocktrans == TICRATE*2
			ROGUE_reset()
			server.difficulty = $+1	-- increase difficulty.
			-- Raise everyone's levelcaps

			for i = 1, #server.plentities do
				for j = 1, server.P_netstat.teamlen
					if server.plentities[i][j]
					and server.plentities[i][j].valid
						server.plentities[i][j].levelcap = difficulty_cap[server.difficulty] or 99	-- ???
					end
				end
			end

			S_StartSound(nil, sfx_lvup)
		end

		if server.blocktrans == TICRATE*5
			S_FadeOutStopMusic(MUSICRATE)	-- stop the transition music for the next block
		end

		if server.blocktrans == TICRATE*6
			server.blocktrans = nil
			server.P_DungeonStatus.floor = $+1
			server.P_DungeonStatus.spawnedreaper = nil
			server.P_DungeonStatus.stairsfound = nil
			server.P_DungeonStatus.savefloor = server.P_DungeonStatus.floor
			DNG_setFloor(server.P_DungeonStatus.floor)
			for p in players.iterate do
				PLAY_move(p)
			end

			-- raise emerald pow cap and delete current saved affs
			for i = 1, 4
				local btl = server.P_BattleStatus[i]
				if btl
					btl.emeraldpow_max = $+1
					btl.saved_affs = {}	-- clear saved affinities
				end
			end

		end
		return
	end

	DNG_fillmap()			-- map out the floor
	DNG_tartarusReaper()	-- handle reaper spawning


	-- check if we've reached the stairs
	local stairplayers, totalplayers = 0, 0
	local i = 0	-- # of iterarions

	for p in players.iterate
		if p.mo and p.mo.valid and not p.P_spectator	-- not spectators.

			if not p.P_party continue end
			if server.P_BattleStatus[p.P_party].gameover continue end	-- don't count gameover'd players
			totalplayers = $+1

			if not (server.P_BattleStatus[p.P_party] and server.P_BattleStatus[p.P_party].running)
			and server.map[#p.mo.subsector.sector+1] == T_EXIT
				stairplayers = $+1
			end
		end
	end

	for p in players.iterate
		local mo = p.mo
		if not mo continue end

		if p.charability ~= CA_GLIDEANDCLIMB	-- leave that on
		and p.charability ~= CA_TWINSPIN
			p.charability = 0
		end
		--CA_ClimbHack(p)	-- see above, prevents climbing non-pit lines
		-- @FIXME: fuck this

		-- flashtics
		if P_IsObjectOnGround(mo)
		and mo.spikehits
			p.powers[pw_flashing] = TICRATE*3 -1
			mo.spikehits = nil
		end

		if p.P_spectator
			p.charability = 0
			p.dashmode = 0

			if mo.z < 0	-- pits...
				mo.momz = $ + FRACUNIT
			end

			continue
		end	-- don't do anything else.

		if server.P_BattleStatus[p.P_party] and server.P_BattleStatus[p.P_party].running
			-- spawn smoke etc etc
			if leveltime%35 == 0
				local smoke
				for i=1,2
					smoke = P_SpawnMobj(mo.x + P_RandomRange(-80, 80)*FRACUNIT, mo.y + P_RandomRange(-80, 80)*FRACUNIT, mo.z + P_RandomRange(0, 150)*FRACUNIT, MT_DUMMY)
					smoke.state = S_AOADUST1
					smoke.scale = FRACUNIT*3
					smoke.destscale = FRACUNIT*5
					smoke.momz = P_RandomRange(0, 2)*FRACUNIT
					P_InstaThrust(smoke, P_RandomRange(0, 359)*ANG1, P_RandomRange(0, 2)*FRACUNIT)
				end
			end

			if (leveltime%35) == 0
				local h
				h = P_SpawnMobj(mo.x + P_RandomRange(-100, 100)<<FRACBITS, mo.y + P_RandomRange(-100, 100)<<FRACBITS, mo.z + P_RandomRange(0, 40)<<FRACBITS, MT_DUMMY)
				h.state = S_HURTB1
				h.scale = FRACUNIT*4 + P_RandomRange(-FRACUNIT/4, FRACUNIT/2)
				h.eflags = $ | MFE_VERTICALFLIP*P_RandomRange(0, 1)
			end

			if leveltime%35 == 0
				S_StartSoundAtVolume(mo, sfx_hit2, 127)
			end
			continue
		end

		if D_ReadyBattle(p) continue end

		-- player initialization: (A hack if anything weird happens to the player)
		if not mo.pinit
			-- get them to the floor entrance if we're in tartarus

			for i = 1, 2048
				local block = server.map[i]
				if block == 4
					DNG_tpmobj(mo, i)
					break
				end
			end
			mo.scale = server.mo.scale
			mo.angle = server.mo.angle
			p.powers[pw_flashing] = TICRATE*3-1
			mo.pinit = true
			-- this teleports the p to the server and gives em everything they should have~
		end

		local evt_startbattle
		-- someone standing on event space:
		if server.map[#mo.subsector.sector+1] == T_BOSS	-- miniboss event space
		and not mo.eventclear
		--and not (d.savefloor >= d.floor)
			/*local donealready
			for p2 in players.iterate do
				-- if anyone else in the party has stepped here, don't let me step here

				if p2 and p2.mo and p2.mo.valid and p2.P_party == mo.player.P_party
				and p2.mo.evt_startbattle
					donealready = true
					break
				end
			end

			-- if we don't do that we can actually softlock the game by having multiple players step on here, oops!
			if not donealready*/
			evt_startbattle = true
			--end
		end

		if evt_startbattle
			for p2 in players.iterate
				if p.P_party ~= p2.P_party continue end	-- only my party
				local mo2 = p2.mo
				if not mo2 continue end
				PLAY_nomove(p2)
				P_InstaThrust(mo2, 0, 0)
				if mo2.evt_startbattle
					mo2.evt_startbattle = max($, mo.evt_startbattle)
				else
					mo2.evt_startbattle = mo.evt_startbattle or 0
				end
			end

			if not mo.evt_startbattle
				mo.evt_startbattle = 0
			end
			mo.evt_startbattle = $+1

			if mo.evt_startbattle > TICRATE*2

				evt_startbattle = nil	-- don't start 2 battles, lol
				-- select wave:
				local wave

				-- remove the boss thing
				for k,v in ipairs(server.DNG_entities)
					if v and v.valid and v.eventwave
						wave = v.eventwave
						local cur = v.hnext
						local cnext
						-- remove hnext list
						while cur
							cnext = cur.hnext
							--P_RemoveMobj(cur)
							if consoleplayer.P_party == p.P_party
								cur.flags2 = $|MF2_DONTDRAW	-- multiparty
							end
							cur = cnext
						end

						--P_RemoveMobj(v)
						if consoleplayer.P_party == p.P_party
							v.flags2 = $|MF2_DONTDRAW
						end
						break
					end
				end

				if not wave	-- this shouldn't happen, ever
					wave = DNG_getRandomWave()
				end

				-- start the battle from the players

				local mus = MUS_PlayRandomBattleMusic("mus_battle_mb")
				local party = p.P_party
				BTL_start(party, wave, 2, mus, nil, true)

				-- Clear the event garbage
				for p2 in players.iterate
					if p2.P_party ~= p.P_party continue end
					local mo2 = p2.mo
					if not mo2 continue end
					mo2.eventclear = true	-- used to not trigger the event after battle again
					mo2.evt_startbattle = nil	-- reset this for everyone just in case
				end
			end
		end

		i = $+1

		if mo.spr_floorbuf
			mo.spr_floorbuf = $-1
			if mo.spr_nfloor
				mo.spr_nfloor = nil
				mo.p_battlebuf = nil
				mo.startbattle = nil
				PLAY_move(mo.player)
				mo.spr_floorbuf = 0
			end
		end

		if mo.spr_nfloor
			mo.spr_nfloor = $+1
			if totalplayers > stairplayers
				mo.spr_nfloor = min(2, $)	-- do not progress furhter.
			end
		end

		local teamplayers = 0
		local teamonstairs = 0

		for p2 in players.iterate do
			if p2.P_party ~= p.P_party continue end
			if not p2.mo or not p2.mo.valid continue end

			teamplayers = $+1
			if server.map[#p2.mo.subsector.sector+1] == 5
				teamonstairs = $+1
			end
		end

		if teamplayers and teamonstairs >= teamplayers		--stairplayers >= totalplayers	-- everyone is on the "stairs"

			for p2 in players.iterate do
				local mo2 = p2.mo

				if not p2.P_party continue end
				if server.P_BattleStatus[p2.P_party].gameover continue end
				if p2.P_party ~= p.P_party continue end

				if not mo2 continue end

				mo2.d_f12text = stairplayers < totalplayers

				if not mo2.spr_nfloor	-- dumb timer
					mo2.spr_nfloor = 1
					P_DoPlayerPain(p2)
					P_InstaThrust(mo2, 0, 0)
					PLAY_nomove(p2)
					mo2.flags2 = $|MF2_DONTDRAW
					p2.pflags = $|PF_GODMODE
					p2.pflags = $ & ~(PF_JUMPED|PF_THOKKED)

					-- start animation; a fake player that looks like it's springing
					local fake = P_SpawnMobj(mo2.x, mo2.y, mo2.z, MT_DUMMY)
					fake.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
					fake.fuse = TICRATE
					fake.color = mo2.color
					fake.skin = mo2.skin
					fake.angle = mo2.angle
					fake.state = S_PLAY_SPRING
					fake.momz = 32<<FRACBITS

					if p2 == p	-- only do this once pls
						for j = 1, #server.DNG_entities do
							local m = server.DNG_entities[j]
							if m and m.valid and m.type == MT_REDSPRING
								m.state = S_REDSPRING2
								S_StartSound(m, sfx_spring)
								break
							end
						end
					end

				elseif mo2.spr_nfloor >= TICRATE
					if stairplayers >= totalplayers
						-- goto next floor

						-- SPECIAL CASE FOR TARTARUS ONLY
						if (server.gamemode == GM_COOP and gamemap == srb2p.tartarus_play and server.P_DungeonStatus.floor+1) == 112	-- this may need to be a constant
							DNG_loadNewMap(5)

							return
						end

						if p2 == p
							for i = 1, 4
								server.P_BattleStatus[i].netstats.floors = $+1

								-- case of a game over:
								if server.P_BattleStatus[i].gameover
									local btl = server.P_BattleStatus[i]
									btl.r_wipe = 1
									BTL_finish(i)
									for j = 1, 4
										if server.plentities[i][j] and server.plentities[i][j].valid
											server.plentities[i][j].hp = server.plentities[i][j].maxhp
											server.plentities[i][j].sp = server.plentities[i][j].maxsp
										end
									end
								end
							end
							server.P_DungeonStatus.floor = $+1
							server.P_DungeonStatus.spawnedreaper = nil
							server.P_DungeonStatus.stairsfound = nil
							DNG_setFloor(server.P_DungeonStatus.floor)
							server.reaper = nil
						end

						PLAY_move(p2)
						mo2.spr_nfloor = nil
						mo2.flags2 = $ & ~MF2_DONTDRAW
						p2.pflags = $ & ~PF_GODMODE

						for p3 in players.iterate
							if p3.mo and p3.mo.valid
								PLAY_move(p3)	-- bruh
								p3.mo.p_battlebuf = nil
								p3.mo.startbattle = nil
								p3.mo.spr_nfloor = nil
								p3.mo.spr_floorbuf = TICRATE
							end
						end

					else
						mo2.spr_nfloor = TICRATE
					end
				else
					mo2.momz = 0
					mo2.flags2 = $|MF2_DONTDRAW
					PLAY_nomove(p2)
				end
			end
		end

		if server.map[#mo.subsector.sector+1] and server.map[#mo.subsector.sector+1] <= T_START
			mo.dng_savesector = #mo.subsector.sector+1
		end

		-- the shop / item lab
		if server.map[#mo.subsector.sector+1] == T_SHOP
		and mo.d_lastmapspace ~= T_SHOP	-- we weren't already on a shop last frame.
			/*local shoptype = "velvet_shop_mp1"

			if server.gamemode == GM_VOIDRUN
				shoptype = "void_shop"
			end

			DNG_startShop(mo, shoptype)*/
			M_openMenu(mo, "m_selectfacility")
		end

		-- star post:
		if server.map[#mo.subsector.sector+1] == T_CHECKPOINT
			if d.savefloor < d.floor

				for j = 1, #server.DNG_entities do
					local m = server.DNG_entities[j]
					if m and m.valid and m.type == MT_STARPOST
						m.state = S_STARPOST_STARTSPIN
						S_StartSound(m, sfx_strpst)
						d.savefloor = d.floor
						d.savepos = #mo.subsector.sector+1
						DNG_logMessage("\x82".."Checkpoint activated!")
					end
				end
			end

			-- allow saving...
			if server.marathon
			or server.cdungeon
				if mo.P_inputs[BT_BTNC] == 1
					if server.marathon
						M_openMenu(mo, "mp_qsave")
					else
						M_openMenu(mo, "mp_qsavec")
					end
				end
				mo.m_savebutton = $ and $+1 or 1
				if mo.m_savebutton == 1
					S_StartSound(nil, sfx_select, mo.player)
				end
			end
		else
			mo.m_savebutton = 0
		end

		-- spikes:
		if server.map[#mo.subsector.sector+1] == T_SPIKES
		and mo.z < 0	-- big pain!
		and not mo.spr_pain

			S_StartSound(mo, sfx_spkdth)	-- spikes
			S_StartSound(mo, sfx_s3kb9)		-- rings

			-- spill fake rings
			for i = 1, 8
				local ring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FLINGRING)
				ring.momx = P_RandomRange(-16, 16)*FRACUNIT
				ring.momy = P_RandomRange(-16, 16)*FRACUNIT
				ring.momz = P_RandomRange(0, 16)*FRACUNIT
				ring.flags = $ & ~MF_SPECIAL
				ring.fuse = TICRATE
			end

			VFX_Play(mo, VFX_TARTARUS_SPIKEPIT)			-- big pain(fallsback to VFX_DIE)
			DNG_Damage(p.maincontrol, p.maincontrol.maxhp/10)

			local h = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
			h.flags = mo.flags|MF_NOCLIPHEIGHT
			h.angle = mo.angle
			h.scale = mo.scale
			h.skin = mo.skin
			h.color = mo.color
			h.momz = FRACUNIT*18
			h.fuse = TICRATE
			h.state = S_PLAY_PAIN
			--P_InstaThrust(mo, 0, 0)
			mo.momz = 0
			mo.flags2 = $|MF2_DONTDRAW
			PLAY_nomove(p)
			mo.spr_pain = TICRATE
		end

		if mo.spr_pain
			mo.spr_pain = $-1
			P_InstaThrust(mo, 0, 0)
			mo.momz = 0
			mo.flags2 = $|MF2_DONTDRAW

			if not mo.spr_pain
				-- teleport me back:
				PLAY_move(p)
				mo.flags2 = $ & ~MF2_DONTDRAW
				p.powers[pw_flashing] = TICRATE*3 -1

				local s = mo.dng_savesector
				while s == nil or server.map[s] == T_PIT or server.map[s] == T_SPIKES or not server.map[s]	-- !!!
					local tmp = P_RandomRange(1, #server.map)
					if map[tmp] == 1
						s = tmp
					end
				end
				mo.z = 0
				DNG_tpmobj(mo, s)
				p.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
				mo.state = S_PLAY_STND
			end
		end


		-- death pits:
		if server.map[#mo.subsector.sector+1] == T_PIT
		and mo.z < -((p.pflags & PF_JUMPED or mo.p_abl or p.climbing) and 128 or 2)*FRACUNIT -- you fell (tm)
		and not mo.spr_pit
			S_StartSound(mo, sfx_s3k51)
			VFX_Play(mo, VFX_TARTARUS_PIT) -- Fallsback onto VFX_DIE
			mo.spr_pit = TICRATE

			emotionBubble(mo, EMOTE_SURPRISED, 128*FRACUNIT)

			local h = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
			h.flags = mo.flags|MF_NOCLIPHEIGHT
			h.angle = mo.angle
			h.scale = mo.scale
			h.skin = mo.skin
			h.color = mo.color
			h.state = S_PLAY_PAIN
			h.momx = mo.momx*2/3
			h.momy = mo.momy*2/3
			h.momz = mo.momz
			h.fuse = TICRATE
			--P_InstaThrust(mo, 0, 0)
			mo.momz = 0
			mo.flags2 = $|MF2_DONTDRAW
			PLAY_nomove(p)
		end
		if mo.spr_pit
			mo.spr_pit = $-1
			P_InstaThrust(mo, 0, 0)
			mo.momz = 0
			mo.flags2 = $|MF2_DONTDRAW

			if not mo.spr_pit
				-- teleport me back:
				PLAY_move(p)
				mo.flags2 = $ & ~MF2_DONTDRAW
				p.powers[pw_flashing] = TICRATE*3 -1

				local s = mo.dng_savesector
				while s == nil or server.map[s] == T_PIT or server.map[s] == T_SPIKES	-- !!!
					local tmp = P_RandomRange(1, #server.map)
					if server.map[tmp] == 1
						s = tmp
					end
				end
				mo.z = 0
				DNG_tpmobj(mo, s)
				p.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
				mo.state = S_PLAY_STND
				DNG_Damage(p.maincontrol, p.maincontrol.maxhp/10)
				S_StartSound(nil, sfx_hit2, p)
			end
		end

		mo.d_lastmapspace = server.map[#mo.subsector.sector+1]
	end
end)

----------------------TARTARUS CRAWLER END---------------------------------------