if not srb2p return end

freeslot("sfx_jshptb", "S_PHANTRAIDBUDDY", "SPR_JPRD", "sfx_jopht")

states[S_PHANTRAIDBUDDY] = {
	sprite = SPR_JPRD,
	frame = A,
	tics = -1, 
	nextstate = S_PHANTRAIDBUDDY
}

DNG_Abilities["joshua"] = {

    jfunc =     function(p)
                    local mo = p.mo
					P_SetObjectMomZ(mo, FRACUNIT*(-5))
                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(60*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					p.powers[pw_flashing] = 2
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%2)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}


freeslot("sfx_endrn", "sfx_chrdwn", "SPR_PHPN", "sfx_orbald", "sfx_orbal2", 
"SPR_ENFE", "sfx_clokdw", "sfx_duastk", "sfx_flickr", "sfx_solblu", "sfx_helgat", 
"sfx_deaspl", "sfx_calved", "sfx_caledg", "sfx_josflh", "sfx_josfl2", "sfx_josvr")

charStats["joshua"] = {

		-- GENERAL

		name = "Joshua",			-- This is only for bots / enemies
		basehp = 59,			-- base HP for level 1
		basesp = 50,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		--cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		tpmode = "craft points",
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_sever_c", 1, 1},  {"tr_blackfang_c", 15, 2}, {"tr_sever_c2", 30, 1}, {"tr_blackfang_c2", 45, 2}, {"tr_phantomraid_c", 60, 1}, {"tr_phantomraid_c2", 90, 1},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"estelle", "tr_timelesspummel_c", 25}, {"estelle", "tr_timelesspummel_c2", 50}, {"estelle", "tr_timelesspummel_c3", 75},
			}
			or {
				{"estelle", "tr_timelesspummel", 25}, {"estelle", "tr_timelesspummel_2", 50}, {"estelle", "tr_timelesspummel_3", 75},
		},
		
		persona = "joshuaskillset",
		melee_natk = "tr_slash_strike", 
		--melee_satk = "tr_phantomraid",
		
		supercolor_start = SKINCOLOR_SUPERJOSH1,
		
		wep = "tr_twindirks",		-- default weapon.
		weptype = WPT_HANDSONIC,	-- Equippable weapon type(s)

		atk = 40,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_SPIN"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, F, E, D, C, B, A, 2, "SPR2_SPIN"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, 1, "SPR2_TAL0"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"},
		--anim_special4 =		{SPR_PLAY, A, B, C, C, C, D, 4, "SPR2_TAL1"},	--Sever, flashes daggers before jumping
		--anim_special5 =		{SPR_PLAY, E, F, 4, "SPR2_TAL1"},	--Sever, first two strikes
		
		vfx_summon = {"sfx_josmn1", "sfx_josmn2", "sfx_josmn3", "sfx_josmn4"},
		vfx_skill = {"sfx_joskl1", "sfx_joskl2", "sfx_joskl3", "sfx_joskl4"},
		vfx_item = {"sfx_joitem"},
		vfx_hurt = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_hurtx = {"sfx_joxhrt"},
		vfx_die = {"sfx_jodie1", "sfx_jodie2"},
		vfx_heal = {"sfx_johel1", "sfx_johel2"},
		vfx_healself = {"sfx_johel1"},
		vfx_kill = {"sfx_jokil1", "sfx_jokil2", "sfx_jokil3"},
		vfx_1more = {"sfx_jo1mor", "sfx_jo1mo"},
		vfx_crit = {"sfx_jocrt1", "sfx_jocrt2", "sfx_jocrt3", "sfx_jocrt4"},
		vfx_aoaask = {"sfx_joaoi1", "sfx_joaoi2", "sfx_joaoi3", "sfx_joaoi4"},
		vfx_aoado = {"sfx_joaoa1", "sfx_joaoa2", "sfx_joaoa3", "sfx_joaoa4"},
		vfx_aoarelent = {"sfx_jomis3"},
		vfx_miss = {"sfx_jomis1", "sfx_jomis2", "sfx_jomis3"},
		vfx_dodge = {"sfx_jodog1", "sfx_jodog2"},
		vfx_win = {"sfx_jowin1", "sfx_jowin2", "sfx_jowin3", "sfx_jowin4"},
		vfx_levelup = {"sfx_jowin3", "sfx_jolevl"},
		vfx_tartarus_pit = {"sfx_jodie2"},
		vfx_tartarus_item = {"sfx_esjoti"},
		vfx_tartarus_spring = {"sfx_jospng"},
		vfx_tartarus_spike = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_tartarus_critspike = {"sfx_joxhrt"},
		vfx_tartarus_spikepit = {"sfx_jompit"},

		icon = "H_JOSICO",	-- icon for net select and other menus
		hudbust = "H_JOSBAR",			-- patch to draw on the stat hud
		hudaoa = "H_JOSAOA",	-- patch for all out attack hud
		hudcutin = "JOSH_A",	-- cut in
		hudscutin = "JOSS_A",	-- super cut in
		aoa_quote = "We will not fail!\nLet's finish them off!",

		tip = "Formerly the infamous 'The Black Fang', now Senior A-Rank Bracer. Blisteringly fast, equipped with several Time and Mirage Orbal Arts as well as his assasin's tricks to criple and destroy the enemy."
}
	
VFX_freeslotC("joshua")
	
personaList["joshuaskillset"] = {
		-- GENERAL
		name = "Joshua",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 9,
		magic = 7,
		endurance = 7,
		luck = 5,
		agility = 12,
		stab = {ATK_CURSE,ATK_SLASH},
		weak = ATK_BLESS,
		resist = ATK_CURSE|ATK_WIND,
		skills = {
					
					{"tr_soul_blur", 1}, {"tr_dual_strike_c", 4},	--2
					{"tr_clock_up", 12}, {"tr_flicker_c", 14},	--4
					{"tr_ascension", 15}, {"tr_calamity_edge", 17}, {"tr_chrono_down", 19},	--7
					{"tr_cloak_dagger_c", 23},	--8
					
					{"tr_hell_gate", 25, "tr_soul_blur"},{"tr_silver_thorn", 31, "tr_ascension"},
					{"tr_tdual_strike_c", 28, "tr_dual_strike_c"},
					{"tr_shadow_spear", 31, "tr_calamity_edge"}, {"tr_clock_up_ex", 36, "tr_clock_up"},
					{"tr_tflicker_c", 39, "tr_flicker_c"},
					{"tr_chrono_break", 43, "tr_chrono_down"}, {"tr_death_spiral", 45, "tr_shadow_spear"},
					{"tr_tcloak_dagger_c", 47, "tr_cloak_dagger_c"},
					
					{"tr_chrono_drive", 50, "tr_clock_up_ex"},
					{"tr_sdual_strike_c", 53, "tr_tdual_strike_c"},
					{"tr_white_gehenna", 56, "tr_hell_gate"}, {"tr_phantom_phobia" , 61, "tr_silver_thorn"},
					{"tr_sflicker_c", 65, "tr_tflicker_c"},
					{"tr_scloak_dagger_c", 68, "tr_tcloak_dagger_c"},
					{"tr_death_scream", 70, "tr_death_spiral"},
					
					{"tr_twinshadfang_c", 72, "tr_sdual_strike_c"},
					{"tr_lightning_flash_c", 75, "tr_sflicker_c"},
					{"tr_abyss_fall", 80, "tr_white_gehenna"},
				},
}


attackDefs["tr_slash_strike"] = {
		name = "Slash Strike",
		type = ATK_SLASH,
		power = 60,
		accuracy = 90,
		critical = 2,
		target = TGT_ENEMY,
		costtype = CST_HP,
		cost = 0,
		nometronome = true,
		norandom = true,
		norogue = true,			
		desc = "Slashes the enemy with a assassin\nslash.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 1
				ANIM_set(mo, mo.anim_special2)
				local g = P_SpawnGhostMobj(mo)
				g.colorized = true

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)

			elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
			and mo.k_savetime == nil
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				mo.angle = ang
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
					ANIM_set(mo, mo.anim_downloop)
					P_InstaThrust(mo, ang, FRACUNIT*64)
					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.colorized = true
					end
				else
					P_InstaThrust(mo, ang, FRACUNIT*32)
				end
			elseif mo.k_savetime == nil	-- attack connects

				mo.k_savetime = timer

				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)
				s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)

			elseif timer == mo.k_savetime + 2

				damageObject(target)
				playSound(mo.battlen, sfx_bexpld)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*8
				s.scalespeed = FRACUNIT/2
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = G|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.tics = TICRATE/2
				s.fuse = s.tics
				s.destscale = FRACUNIT*10
				s.scalespeed = FRACUNIT/4
				s.color = SKINCOLOR_WHITE
			elseif timer == mo.k_savetime + TICRATE

				mo.k_savetime = nil
				return true
			end
		end,
}

-- Crafts--

--In the Sky FC (lvl 1 - lvl 50)

--Sky FC Initial
attackDefs["tr_dual_strike"] = {
		name = "Dual Strike",
		type = ATK_SLASH,
		power = 90,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 6,
		critical = 2,
		hits = 2,
		desc = "Miniscule Slash Damage to a enemy\nhitting twice.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_WHITE
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}

--Sky FC level 13
attackDefs["tr_flicker"] = {
		name = "Flicker",
		type = ATK_SLASH,
		power = 100,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 9,
		critical = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
		end,
		tr_castarea = 1,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Light Damage with quick slashes \n(Set Line S).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local time = timer - (i-1)*6
					local target = hittargets[1]
					if timer >= 10
					and timer <= 40
						if leveltime%5 == 0
							local avgx, avgy = 0, 0
							for i = 1, #targets
								avgx = $ + targets[i].x/FRACUNIT
								avgy = $ + targets[i].y/FRACUNIT
							end
							avgx = ($/#targets)	*FRACUNIT
							avgy = ($/#targets)	*FRACUNIT
						
							local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
							d.state = S_HOWL1
							d.color = SKINCOLOR_AETHER
							d.angle = mo.angle + ANG1*90
							d.scale = mo.scale*2
							d.scale = FRACUNIT*2
							d.destscale = FRACUNIT*7
							d.scalespeed = FRACUNIT/4
						end
					end
				
					if timer == 30
						local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
					end		
				
					if timer == 31
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end	
					end
				
					if time == 40
						local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
						playSound(mo.battlen, sfx_duastk)
						playSound(mo.battlen, sfx_duastk)
				
					elseif time == 41
						damageObject(target)
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end
					
						local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLSH
						s.frame = I|FF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_WHITE
					end	
				end
			end	
			if timer == 65 + (#hittargets-1)*6
				return true
			end
		end,
}

--Sky FC level 16
--attackDefs["tr_taunt"] = {
--name = "Taunt", 

--Sky FC level 18
attackDefs["tr_cloak_dagger"] = {
		name = "Cloak and Dagger",
		type = ATK_SLASH,
		power = 80,
		accuracy = 95,
		critical = 5,
		target = TGT_ENEMY,
		costtype = CST_HP,
		cost = 8,	
		desc = "Surprise attack aimed at an enemy's \nweak point. Light Slash Damage, \nFlat 20% Deathblow Chance.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
		end,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 1
				ANIM_set(mo, mo.anim_special2)
				local g = P_SpawnGhostMobj(mo)
				g.colorized = true

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)

			elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
			and mo.k_savetime == nil
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				mo.angle = ang
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
					ANIM_set(mo, mo.anim_downloop)
					P_InstaThrust(mo, ang, FRACUNIT*64)
					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.colorized = true
					end
				else
					P_InstaThrust(mo, ang, FRACUNIT*32)
				end
			elseif mo.k_savetime == nil	-- attack connects

				mo.k_savetime = timer

				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)
				s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)

			elseif timer == mo.k_savetime + 2

				damageObject(target)
				tr_deathblow(target, 20)
				playSound(mo.battlen, sfx_bexpld)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*8
				s.scalespeed = FRACUNIT/2
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = G|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.tics = TICRATE/2
				s.fuse = s.tics
				s.destscale = FRACUNIT*10
				s.scalespeed = FRACUNIT/4
				s.color = SKINCOLOR_WHITE
			elseif timer == mo.k_savetime + TICRATE

				mo.k_savetime = nil
				return true
			end
		end,
}

--Sky FC level 26
--attackDefs["tr_evil_eye"] = {
--name = "Evil Eye", 

--In the Sky SC (lvl 50 - lvl 100)

--Sky SC initial
attackDefs["tr_tdual_strike"] = {
		name = "True Dual Strike",
		type = ATK_SLASH,
		power = 210,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 13,
		critical = 2,
		hits = 2,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
		end,
		desc = "Light Slash Damage to a enemy\nhitting twice.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_ICY
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_ICY

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_ICY
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_ICY

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}


--Sky SC initial
attackDefs["tr_tflicker"] = {
		name = "True Flicker",
		type = ATK_SLASH,
		power = 260,
		accuracy = 93,
		costtype = CST_HPPERCENT,
		cost = 16,
		critical = 6,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
		end,
		tr_castarea = 1,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Medium Damage with quick slashes \n(Set Line S).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local time = timer - (i-1)*6
					local target = hittargets[1]
					if timer >= 10
					and timer <= 40
						if leveltime%5 == 0
							local avgx, avgy = 0, 0
							for i = 1, #targets
								avgx = $ + targets[i].x/FRACUNIT
								avgy = $ + targets[i].y/FRACUNIT
							end
							avgx = ($/#targets)	*FRACUNIT
							avgy = ($/#targets)	*FRACUNIT
						
							local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
							d.state = S_HOWL1
							d.color = SKINCOLOR_AETHER
							d.angle = mo.angle + ANG1*90
							d.scale = mo.scale*2
							d.scale = FRACUNIT*2
							d.destscale = FRACUNIT*7
							d.scalespeed = FRACUNIT/4
						end
					end
				
					if timer == 30
						local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
					end		
				
					if timer == 31
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end	
					end
				
					if time == 40
						local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
						playSound(mo.battlen, sfx_duastk)
						playSound(mo.battlen, sfx_duastk)
				
					elseif time == 41
						damageObject(target)
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end
					
						local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLSH
						s.frame = I|FF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_WHITE
					end	
				end
			end	
			if timer == 65 + (#hittargets-1)*6
				return true
			end
		end,
}

--Sky SC initial
attackDefs["tr_tcloak_dagger"] = {
		name = "True Cloak and Dagger",
		type = ATK_SLASH,
		power = 210,
		accuracy = 95,
		critical = 5,
		target = TGT_ENEMY,
		costtype = CST_HP,
		cost = 11,	
		desc = "Surprise attack aimed at an enemy's \nweak point. Medium Slash Damage, \nFlat 20% Deathblow Chance.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
		end,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 1
				ANIM_set(mo, mo.anim_special2)
				local g = P_SpawnGhostMobj(mo)
				g.colorized = true

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)

			elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
			and mo.k_savetime == nil
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				mo.angle = ang
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
					ANIM_set(mo, mo.anim_downloop)
					P_InstaThrust(mo, ang, FRACUNIT*64)
					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.colorized = true
					end
				else
					P_InstaThrust(mo, ang, FRACUNIT*32)
				end
			elseif mo.k_savetime == nil	-- attack connects

				mo.k_savetime = timer

				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)
				s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)

			elseif timer == mo.k_savetime + 2

				damageObject(target)
				tr_deathblow(target, 20)
				playSound(mo.battlen, sfx_bexpld)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*8
				s.scalespeed = FRACUNIT/2
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = G|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.tics = TICRATE/2
				s.fuse = s.tics
				s.destscale = FRACUNIT*10
				s.scalespeed = FRACUNIT/4
				s.color = SKINCOLOR_WHITE
			elseif timer == mo.k_savetime + TICRATE

				mo.k_savetime = nil
				return true
			end
		end,
}

--Sky SC level 81
--attackDefs["tr_evil_eye_2"] = {
--name = "Evil Eye EX", 

--In the Sky the 3rd (lvl 100 - lvl 200)

--Sky 3rd Initial
attackDefs["tr_sdual_strike"] = {
		name = "Supreme Dual Strike",
		type = ATK_SLASH,
		power = 620,
		accuracy = 91,
		costtype = CST_HPPERCENT,
		status = COND_POISON,
		statuschance = 25,
		--implicit = "jostimelesspummel",
		cost = 14,
		critical = 2,
		hits = 2,
		norandom = true,
		norogue = true,
		noenemycast = true,
		nometronome = true,			
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
		end,
		desc = "Medium Slash Damage to a enemy\nhitting twice. May inflict Poison",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				target.rolls = {}

			elseif timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_AETHER
				s.scale = FRACUNIT*3/2
				s.rollangle = P_RandomRange(0, 359)*ANG1
				target.rolls[#target.rolls+1] = s.rollangle
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_AETHER

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_AETHER
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_AETHER

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}

--Sky 3rd level 110
attackDefs["tr_sflicker"] = {
		name = "Supreme Flicker",
		type = ATK_SLASH,
		power = 350,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 19,
		critical = 7,
		technical = COND_FREEZE,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
		end,
		tr_castarea = 1,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Heavy Damage with quick slashes \n(Set Line S).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
		
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local time = timer - (i-1)*6
					local target = hittargets[1]
					if timer >= 10
					and timer <= 40
						if leveltime%5 == 0
							local avgx, avgy = 0, 0
							for i = 1, #targets
								avgx = $ + targets[i].x/FRACUNIT
								avgy = $ + targets[i].y/FRACUNIT
							end
							avgx = ($/#targets)	*FRACUNIT
							avgy = ($/#targets)	*FRACUNIT
						
							local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
							d.state = S_HOWL1
							d.color = SKINCOLOR_AETHER
							d.angle = mo.angle + ANG1*90
							d.scale = mo.scale*2
							d.scale = FRACUNIT*2
							d.destscale = FRACUNIT*7
							d.scalespeed = FRACUNIT/4
						end
					end
				
					if timer == 30
						local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
					end		
				
					if timer == 31
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end	
					end
				
					if time == 40
						local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
						playSound(mo.battlen, sfx_duastk)
						playSound(mo.battlen, sfx_duastk)
				
					elseif time == 41
						damageObject(target)
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end
					
						local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLSH
						s.frame = I|FF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_WHITE
					end	
				end
			end	
			if timer == 65 + (#hittargets-1)*6
				return true
			end
		end,
}

--Sky 3rd level 115
attackDefs["tr_scloak_dagger"] = {
		name = "Supreme Cloak and Dagger",
		type = ATK_SLASH,
		power = 400,
		accuracy = 95,
		critical = 5,
		target = TGT_ENEMY,
		costtype = CST_HP,
		cost = 14,	
		desc = "Surprise attack aimed at an enemy's \nweak point. Heavy Slash Damage, \nFlat 20% Deathblow Chance.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
		end,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 1
				ANIM_set(mo, mo.anim_special2)
				local g = P_SpawnGhostMobj(mo)
				g.colorized = true

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)

			elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
			and mo.k_savetime == nil
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				mo.angle = ang
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
					ANIM_set(mo, mo.anim_downloop)
					P_InstaThrust(mo, ang, FRACUNIT*64)
					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.colorized = true
					end
				else
					P_InstaThrust(mo, ang, FRACUNIT*32)
				end
			elseif mo.k_savetime == nil	-- attack connects

				mo.k_savetime = timer

				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)
				s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)

			elseif timer == mo.k_savetime + 2

				damageObject(target)
				tr_deathblow(target, 20)
				playSound(mo.battlen, sfx_bexpld)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*8
				s.scalespeed = FRACUNIT/2
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = G|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.tics = TICRATE/2
				s.fuse = s.tics
				s.destscale = FRACUNIT*10
				s.scalespeed = FRACUNIT/4
				s.color = SKINCOLOR_WHITE
			elseif timer == mo.k_savetime + TICRATE

				mo.k_savetime = nil
				return true
			end
		end,
}

--Sky 3rd level 128
--attackDefs["tr_evil_eye_3"] = {
--name = "Supreme Evil Eye", 

--of Coldsteel 4

--Coldsteel 4 Initial
attackDefs["tr_twinshadfang"] = {
		name = "Twin Shadow Fangs",
		type = ATK_SLASH,
		power = 996,
		accuracy = 91,
		costtype = CST_HPPERCENT,
		status = COND_POISON,
		statuschance = 25,
		cost = 16,
		critical = 2,
		hits = 2,
		norandom = true,
		norogue = true,
		noenemycast = true,
		nometronome = true,			
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
		end,
		tr_castarea = 3,
		tr_setmode = 2,
		desc = "Heavy Slash Damage to a enemy\nhitting twice. May inflict Poison",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				target.rolls = {}

			elseif timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_AETHER
				s.scale = FRACUNIT*3/2
				s.rollangle = P_RandomRange(0, 359)*ANG1
				target.rolls[#target.rolls+1] = s.rollangle
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_AETHER

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_AETHER
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_AETHER

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}

--From Zero

--Zero initial
attackDefs["tr_lightning_flash"] = {
		name = "Lightning Flash",
		type = ATK_SLASH,
		power = 620,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 18,
		critical = 3,
		technical = COND_FREEZE,
		desc = "Severe Damage to all enemies \nwith quick slashes",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
		end,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				ANIM_set(mo, mo.anim_downloop)
				mo.oldpos = {mo.x, mo.y}
			end	
			
			if timer == 19
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_WHITE
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end	
				for i = 1, 8
					local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 20)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_SILVER
					thok.tics = P_RandomRange(10, 20)
				end		
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_WHITE
					dust.scale = FRACUNIT*2
				end				
				mo.flags2 = $|MF2_DONTDRAW
				playSound(mo.battlen, sfx_josflh)
			end	
			
			for i = 1, #hittargets
				local target = hittargets[i]
				local time = timer - (i-1)*3
				
				if time == 1
					target.rolls = {}
					
				elseif time == 40
					mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
					P_InstaThrust(mo, mo.angle, FRACUNIT*60)
			
				elseif time == 45
				or time == 47
				or time == 49
					ANIM_set(mo, mo.anim_special2)
					mo.flags2 = $ & !MF2_DONTDRAW
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle	
					
				elseif time == 46
					damageObject(target)
					playSound(mo.battlen, sfx_josfl2)
				
				elseif time == 55
					mo.flags2 = $|MF2_DONTDRAW
					mo.momx = (mo.oldpos[1] - mo.x)/5
					mo.momy = (mo.oldpos[2] - mo.y)/5
					
					
				elseif time == 60
					P_SetObjectMomZ(mo, 70*FRACUNIT)
					P_InstaThrust(mo, mo.angle, 0)
									

				elseif time == 70
					ANIM_set(mo, mo.anim_stand)
					mo.flags2 = $ & !MF2_DONTDRAW
				end	
			end	
			
			if timer == 90 + (#hittargets-1)*3
				mo.oldpos = nil
				return true
			end
		end,
}


--bar edits crafts

	--In the Sky FC (lvl 1 - lvl 50)

	--Sky FC Initial
	attackDefs["tr_dual_strike_c"] = {
			name = "Dual Strike",
			type = ATK_SLASH,
			power = 90,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 6,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			hits = 2,
			desc = "Miniscule Slash Damage to a enemy\nhitting twice.",
			target = TGT_ENEMY,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
			end,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 15
				or timer == 40
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)

				elseif timer == 17
				or timer == 42
					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = C|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*3
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_WHITE

				elseif timer == 16
				or timer == 41

					damageObject(target)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_WHITE
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_WHITE

				elseif timer == 65
					target.slashsprite = nil
					return true
				end
			end,
	}

	--Sky FC level 13
	attackDefs["tr_flicker_c"] = {
			name = "Flicker",
			type = ATK_SLASH,
			power = 100,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 9,
			strengthoverride = true,
			forcetp = true,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
			end,
			tr_castarea = 1,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Light Damage with quick slashes \n(Set Line S).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local time = timer - (i-1)*6
					local target = hittargets[1]
					if timer >= 10
					and timer <= 40
						if leveltime%5 == 0
							local avgx, avgy = 0, 0
							for i = 1, #targets
								avgx = $ + targets[i].x/FRACUNIT
								avgy = $ + targets[i].y/FRACUNIT
							end
							avgx = ($/#targets)	*FRACUNIT
							avgy = ($/#targets)	*FRACUNIT
						
							local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
							d.state = S_HOWL1
							d.color = SKINCOLOR_AETHER
							d.angle = mo.angle + ANG1*90
							d.scale = mo.scale*2
							d.scale = FRACUNIT*2
							d.destscale = FRACUNIT*7
							d.scalespeed = FRACUNIT/4
						end
					end
				
					if timer == 30
						local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
					end		
				
					if timer == 31
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end	
					end
				
					if time == 40
						local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
						playSound(mo.battlen, sfx_duastk)
						playSound(mo.battlen, sfx_duastk)
				
					elseif time == 41
						damageObject(target)
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end
					
						local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLSH
						s.frame = I|FF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_WHITE
					end	
				end
			end	
			if timer == 65 + (#hittargets-1)*6
				return true
			end
		end,
}

	--Sky FC level 16
	--attackDefs["tr_taunt"] = {
	--name = "Taunt", 

	--Sky FC level 18
	attackDefs["tr_cloak_dagger_c"] = {
			name = "Cloak and Dagger",
			type = ATK_SLASH,
			power = 80,
			accuracy = 95,
			critical = 5,
			target = TGT_ENEMY,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 8,
			strengthoverride = true,
			forcetp = true,
			desc = "Surprise attack aimed at an enemy's \nweak point. Light Slash Damage, \nFlat 20% Deathblow Chance.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
			end,
			anim = function(mo, targets, hittargets, timer)

				local target = hittargets[1]

				if timer == 1
					ANIM_set(mo, mo.anim_special2)
					local g = P_SpawnGhostMobj(mo)
					g.colorized = true

					local cx = target.x + 168*cos(target.angle + ANG1*20)
					local cy = target.y + 168*sin(target.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					S_StartSound(mo, sfx_zoom)

				elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
				and mo.k_savetime == nil
					local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					mo.angle = ang
					if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
						ANIM_set(mo, mo.anim_downloop)
						P_InstaThrust(mo, ang, FRACUNIT*64)
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
						end
					else
						P_InstaThrust(mo, ang, FRACUNIT*32)
					end
				elseif mo.k_savetime == nil	-- attack connects

					mo.k_savetime = timer

					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)

				elseif timer == mo.k_savetime + 2

					damageObject(target)
					tr_deathblow(target, 20)
					playSound(mo.battlen, sfx_bexpld)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_RED
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_WHITE

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*8
					s.scalespeed = FRACUNIT/2
					s.color = SKINCOLOR_WHITE

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = SKINCOLOR_WHITE
				elseif timer == mo.k_savetime + TICRATE

					mo.k_savetime = nil
					return true
				end
			end,
	}

	--Sky FC level 26
	--attackDefs["tr_evil_eye"] = {
	--name = "Evil Eye", 

	--In the Sky SC (lvl 50 - lvl 100)

	--Sky SC initial
	attackDefs["tr_tdual_strike_c"] = {
			name = "True Dual Strike",
			type = ATK_SLASH,
			power = 210,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 13,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			hits = 2,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
			end,
			desc = "Light Slash Damage to a enemy\nhitting twice.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 15
				or timer == 40
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)

				elseif timer == 17
				or timer == 42
					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = C|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*3
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_ICY

				elseif timer == 16
				or timer == 41

					damageObject(target)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_ICY
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_ICY

				elseif timer == 65
					target.slashsprite = nil
					return true
				end
			end,
	}


	--Sky SC initial
	attackDefs["tr_tflicker_c"] = {
			name = "True Flicker",
			type = ATK_SLASH,
			power = 260,
			accuracy = 93,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 16,
			strengthoverride = true,
			forcetp = true,
			critical = 6,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
			end,
			tr_castarea = 1,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Medium Damage with quick slashes \n(Set Line S).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local time = timer - (i-1)*6
					local target = hittargets[1]
					if timer >= 10
					and timer <= 40
						if leveltime%5 == 0
							local avgx, avgy = 0, 0
							for i = 1, #targets
								avgx = $ + targets[i].x/FRACUNIT
								avgy = $ + targets[i].y/FRACUNIT
							end
							avgx = ($/#targets)	*FRACUNIT
							avgy = ($/#targets)	*FRACUNIT
						
							local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
							d.state = S_HOWL1
							d.color = SKINCOLOR_AETHER
							d.angle = mo.angle + ANG1*90
							d.scale = mo.scale*2
							d.scale = FRACUNIT*2
							d.destscale = FRACUNIT*7
							d.scalespeed = FRACUNIT/4
						end
					end
				
					if timer == 30
						local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
					end		
				
					if timer == 31
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end	
					end
				
					if time == 40
						local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
						playSound(mo.battlen, sfx_duastk)
						playSound(mo.battlen, sfx_duastk)
				
					elseif time == 41
						damageObject(target)
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end
					
						local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLSH
						s.frame = I|FF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_WHITE
					end	
				end
			end	
			if timer == 65 + (#hittargets-1)*6
				return true
			end
		end,
}

	--Sky SC initial
	attackDefs["tr_tcloak_dagger_c"] = {
			name = "True Cloak and Dagger",
			type = ATK_SLASH,
			power = 210,
			accuracy = 95,
			critical = 5,
			target = TGT_ENEMY,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 11,
			strengthoverride = true,
			forcetp = true,	
			desc = "Surprise attack aimed at an enemy's \nweak point. Medium Slash Damage, \nFlat 20% Deathblow Chance.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
			end,
			anim = function(mo, targets, hittargets, timer)

				local target = hittargets[1]

				if timer == 1
					ANIM_set(mo, mo.anim_special2)
					local g = P_SpawnGhostMobj(mo)
					g.colorized = true

					local cx = target.x + 168*cos(target.angle + ANG1*20)
					local cy = target.y + 168*sin(target.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					S_StartSound(mo, sfx_zoom)

				elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
				and mo.k_savetime == nil
					local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					mo.angle = ang
					if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
						ANIM_set(mo, mo.anim_downloop)
						P_InstaThrust(mo, ang, FRACUNIT*64)
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
						end
					else
						P_InstaThrust(mo, ang, FRACUNIT*32)
					end
				elseif mo.k_savetime == nil	-- attack connects

					mo.k_savetime = timer

					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)

				elseif timer == mo.k_savetime + 2

					damageObject(target)
					tr_deathblow(target, 20)
					playSound(mo.battlen, sfx_bexpld)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_RED
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_WHITE

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*8
					s.scalespeed = FRACUNIT/2
					s.color = SKINCOLOR_WHITE

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = SKINCOLOR_WHITE
				elseif timer == mo.k_savetime + TICRATE

					mo.k_savetime = nil
					return true
				end
			end,
	}

	--Sky SC level 81
	--attackDefs["tr_evil_eye_2"] = {
	--name = "Evil Eye EX", 

	--In the Sky the 3rd (lvl 100 - lvl 200)

	--Sky 3rd Initial
	attackDefs["tr_sdual_strike_c"] = {
			name = "Supreme Dual Strike",
			type = ATK_SLASH,
			power = 620,
			accuracy = 91,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 14,
			strengthoverride = true,
			forcetp = true,
			status = COND_POISON,
			statuschance = 25,
			critical = 2,
			hits = 2,
			norandom = true,
			norogue = true,
			noenemycast = true,
			nometronome = true,			
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
			end,
			desc = "Medium Slash Damage to a enemy\nhitting twice. May inflict Poison",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 1
					target.rolls = {}

				elseif timer == 15
				or timer == 40
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_AETHER
					s.scale = FRACUNIT*3/2
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)

				elseif timer == 17
				or timer == 42
					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = C|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*3
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_AETHER

				elseif timer == 16
				or timer == 41

					damageObject(target)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_AETHER
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_AETHER

				elseif timer == 65
					target.slashsprite = nil
					return true
				end
			end,
	}

	--Sky 3rd level 110
	attackDefs["tr_sflicker_c"] = {
			name = "Supreme Flicker",
			type = ATK_SLASH,
			power = 350,
			accuracy = 95,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 19,
			strengthoverride = true,
			forcetp = true,
			critical = 7,
			technical = COND_FREEZE,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
			end,
			tr_castarea = 1,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Heavy Damage with quick slashes \n(Set Line S).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local time = timer - (i-1)*6
					local target = hittargets[1]
					if timer >= 10
					and timer <= 40
						if leveltime%5 == 0
							local avgx, avgy = 0, 0
							for i = 1, #targets
								avgx = $ + targets[i].x/FRACUNIT
								avgy = $ + targets[i].y/FRACUNIT
							end
							avgx = ($/#targets)	*FRACUNIT
							avgy = ($/#targets)	*FRACUNIT
						
							local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
							d.state = S_HOWL1
							d.color = SKINCOLOR_AETHER
							d.angle = mo.angle + ANG1*90
							d.scale = mo.scale*2
							d.scale = FRACUNIT*2
							d.destscale = FRACUNIT*7
							d.scalespeed = FRACUNIT/4
						end
					end
				
					if timer == 30
						local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
					end		
				
					if timer == 31
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end	
					end
				
					if time == 40
						local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
						s.state = S_SLASHING_1_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3/2
						playSound(mo.battlen, sfx_duastk)
						playSound(mo.battlen, sfx_duastk)
				
					elseif time == 41
						damageObject(target)
						for i=1,10
							local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
							b.momx = P_RandomRange(-35, 35)*FRACUNIT
							b.momy = P_RandomRange(-35, 35)*FRACUNIT
							b.momz = P_RandomRange(-35, 35)*FRACUNIT
							b.color = SKINCOLOR_WHITE
							b.frame = A|FF_FULLBRIGHT
							b.scale = FRACUNIT/2
							b.destscale = FRACUNIT/12
							b.tics = 35
						end
					
						local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLSH
						s.frame = I|FF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_WHITE
					end	
				end
			end	
			if timer == 65 + (#hittargets-1)*6
				return true
			end
		end,
}

	--Sky 3rd level 115
	attackDefs["tr_scloak_dagger_c"] = {
			name = "Supreme Cloak and Dagger",
			type = ATK_SLASH,
			power = 400,
			accuracy = 95,
			critical = 5,
			target = TGT_ENEMY,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 14,
			strengthoverride = true,
			forcetp = true,
			desc = "Surprise attack aimed at an enemy's \nweak point. Heavy Slash Damage, \nFlat 20% Deathblow Chance.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
			end,
			anim = function(mo, targets, hittargets, timer)

				local target = hittargets[1]

				if timer == 1
					ANIM_set(mo, mo.anim_special2)
					local g = P_SpawnGhostMobj(mo)
					g.colorized = true

					local cx = target.x + 168*cos(target.angle + ANG1*20)
					local cy = target.y + 168*sin(target.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					S_StartSound(mo, sfx_zoom)

				elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
				and mo.k_savetime == nil
					local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					mo.angle = ang
					if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
						ANIM_set(mo, mo.anim_downloop)
						P_InstaThrust(mo, ang, FRACUNIT*64)
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
						end
					else
						P_InstaThrust(mo, ang, FRACUNIT*32)
					end
				elseif mo.k_savetime == nil	-- attack connects

					mo.k_savetime = timer

					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)

				elseif timer == mo.k_savetime + 2

					damageObject(target)
					tr_deathblow(target, 20)
					playSound(mo.battlen, sfx_bexpld)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_RED
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_WHITE

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*8
					s.scalespeed = FRACUNIT/2
					s.color = SKINCOLOR_WHITE

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = SKINCOLOR_WHITE
				elseif timer == mo.k_savetime + TICRATE

					mo.k_savetime = nil
					return true
				end
			end,
	}

	--Sky 3rd level 128
	--attackDefs["tr_evil_eye_3"] = {
	--name = "Supreme Evil Eye", 

	--of Coldsteel 4

	--Coldsteel 4 Initial
	attackDefs["tr_twinshadfang_c"] = {
			name = "Twin Shadow Fangs",
			type = ATK_SLASH,
			power = 996,
			accuracy = 91,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 16,
			strengthoverride = true,
			forcetp = true,
			status = COND_POISON,
			statuschance = 25,
			critical = 2,
			hits = 2,
			norandom = true,
			norogue = true,
			noenemycast = true,
			nometronome = true,			
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
			end,
			desc = "Heavy Slash Damage to a enemy\nhitting twice. May inflict Poison",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 1
					target.rolls = {}

				elseif timer == 15
				or timer == 40
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_AETHER
					s.scale = FRACUNIT*3/2
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)

				elseif timer == 17
				or timer == 42
					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = C|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*3
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_AETHER

				elseif timer == 16
				or timer == 41

					damageObject(target)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_AETHER
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_AETHER

				elseif timer == 65
					target.slashsprite = nil
					return true
				end
			end,
	}

	--From Zero

	--Zero initial
	attackDefs["tr_lightning_flash_c"] = {
			name = "Lightning Flash",
			type = ATK_SLASH,
			power = 620,
			accuracy = 95,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 18,
			strengthoverride = true,
			forcetp = true,
			critical = 3,
			technical = COND_FREEZE,
			desc = "Severe Damage to all enemies \nwith quick slashes",
			target = TGT_ALLENEMIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
			end,
			anim = function(mo, targets, hittargets, timer)
				
				if timer == 10
					ANIM_set(mo, mo.anim_downloop)
					mo.oldpos = {mo.x, mo.y}
				end	
				
				if timer == 19
					for i = 1,10
						local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_WHITE
						ol.scale = 1
						ol.destscale = mo.scale*3
						ol.scalespeed = (mo.scale*3)/15
						ol.frame = B|FF_TRANS80
						ol.tics = i + 5
					end	
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 20)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_SILVER
						thok.tics = P_RandomRange(10, 20)
					end		
					for i = 1,16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_WHITE
						dust.scale = FRACUNIT*2
					end				
					mo.flags2 = $|MF2_DONTDRAW
					playSound(mo.battlen, sfx_josflh)
				end	
				
				for i = 1, #hittargets
					local target = hittargets[i]
					local time = timer - (i-1)*3
					
					if time == 1
						target.rolls = {}
						
					elseif time == 40
						mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
						P_InstaThrust(mo, mo.angle, FRACUNIT*60)
				
					elseif time == 45
					or time == 47
					or time == 49
						ANIM_set(mo, mo.anim_special2)
						mo.flags2 = $ & !MF2_DONTDRAW
						local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						s.state = S_SLASHING_2_1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*3
						s.rollangle = P_RandomRange(0, 359)*ANG1
						target.rolls[#target.rolls+1] = s.rollangle	
						
					elseif time == 46
						damageObject(target)
						playSound(mo.battlen, sfx_josfl2)
					
					elseif time == 55
						mo.flags2 = $|MF2_DONTDRAW
						mo.momx = (mo.oldpos[1] - mo.x)/5
						mo.momy = (mo.oldpos[2] - mo.y)/5
						
						
					elseif time == 60
						P_SetObjectMomZ(mo, 70*FRACUNIT)
						P_InstaThrust(mo, mo.angle, 0)
										

					elseif time == 70
						ANIM_set(mo, mo.anim_stand)
						mo.flags2 = $ & !MF2_DONTDRAW
					end	
				end	
				
				if timer == 90 + (#hittargets-1)*3
					mo.oldpos = nil
					return true
				end
			end,
	}

if C2SBarEdits
	-- S-Crafts

	--Sky FC Initial
		attackDefs["tr_sever_c"] = {
			name = "Sever",
			type = ATK_SLASH,
			power = 200,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_JOSAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,			
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nJoshua's S-Craft\nFeinting assassin's attack.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam				
				
				if timer == 1	--face the camera
					mo.dbs = {}
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_joaoi4)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					--ANIM_set(mo, mo.anim_special4)	--sprites pending
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end						
				
				if timer == 12	--blades gleam
					mo.bod = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(20*FRACUNIT), MT_DUMMY)
					mo.bod.sprite = SPR_MEGI
					mo.bod.color = SKINCOLOR_WHITE
					mo.bod.frame = G|FF_FULLBRIGHT
					mo.bod.blendmode = AST_ADD
					mo.bod.renderflags = $|RF_FULLBRIGHT
					mo.bod.scale = FRACUNIT
					mo.bod.destscale = FRACUNIT/10
					mo.bod.scalespeed = FRACUNIT*2
					--mo.bod.momz = FRACUNIT*-1
					mo.bod.tics = 10
				end
				
				if timer > 12 and timer <= 22
					if mo.bod and mo.bod.valid
						mo.bod.rollangle = $-(3*ANG1)
					end
				end
				
					if mo.dbs and #mo.dbs
						for i = 1, #mo.dbs do
							local s = mo.dbs[i]
							if not s or not s.valid continue end	-- don't care
							if s.fuse == 9
								s.frame = $|FF_TRANS10
							elseif s.fuse == 8
								s.frame = $|FF_TRANS20
							elseif s.fuse == 7
								s.frame = $|FF_TRANS30
							elseif s.fuse == 6
								s.frame = $|FF_TRANS40
							elseif s.fuse == 5
								s.frame = $|FF_TRANS50
							elseif s.fuse == 4
								s.frame = $|FF_TRANS60
							elseif s.fuse == 3
								s.frame = $|FF_TRANS70
							elseif s.fuse == 2
								s.frame = $|FF_TRANS80
							elseif s.fuse == 1
								s.frame = $|FF_TRANS90
							end
						end
					end

				if timer == 20	--jump
					playSound(mo.battlen, sfx_joskl3)
					ANIM_set(mo, mo.anim_special2, true)
					mo.momz = FRACUNIT*20
				end
				
				if timer >= 20 and timer < 50
					local josghost = P_SpawnGhostMobj(mo)
					josghost.fuse = 10
					mo.dbs[#mo.dbs+1] = josghost
				end
					
				if timer >= 50 and timer < 200	--you're finished!
					if timer == 50	--situate the camera first
						P_TeleportMove(cam, target.x + 256 *cos(target.angle), target.y + 256*sin(target.angle), target.z+30*FRACUNIT)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.flags2 = $|MF2_DONTDRAW
					end
					
					if timer == 60
						mo.flags2 = $ & ~MF2_DONTDRAW
						P_TeleportMove(mo, target.x + 96*cos(target.angle+(90*ANG1)), target.y + 96*sin(target.angle+(90*ANG1)), mo.floorz)	--On your left!
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = (target.x - mo.x)/20
						mo.momy = (target.y - mo.y)/20
					end
					if timer == 70
						P_TeleportMove(mo, target.x + 48*cos(target.angle+(90*ANG1)), target.y + 48*sin(target.angle+(90*ANG1)), mo.floorz)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = 0
						mo.momy = 0
						--ANIM_set(mo, mo.anim_special4)	--sprites pending
						ANIM_set(mo, mo.anim_special2)	--placeholder
						playSound(mo.battlen, sfx_joskl4)
						playSound(mo.battlen, sfx_flickr)
						
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = K|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for i = 1, 12 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*1
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
					end
					if timer == 75
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.momx = (mo.x - target.x)/20
						mo.momy = (mo.y - target.y)/20
					end
					if timer >= 75 and timer < 90
						local josghost = P_SpawnGhostMobj(mo)
						josghost.fuse = 10
						mo.dbs[#mo.dbs+1] = josghost
					end
					
					if timer == 90
						P_TeleportMove(mo, target.x + 96*cos(target.angle-(90*ANG1)), target.y + 96*sin(target.angle-(90*ANG1)), mo.floorz)	--On your right!
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = (target.x - mo.x)/20
						mo.momy = (target.y - mo.y)/20
					end
					if timer == 100
						P_TeleportMove(mo, target.x + 48*cos(target.angle-(90*ANG1)), target.y + 48*sin(target.angle-(90*ANG1)), mo.floorz)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = 0
						mo.momy = 0
						--ANIM_set(mo, mo.anim_special4)	--sprites pending
						ANIM_set(mo, mo.anim_special2)	--placeholder
						playSound(mo.battlen, sfx_joskl3)
						playSound(mo.battlen, sfx_flickr)
						
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = J|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for i = 1, 12 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*1
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
					end
					if timer == 105
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.momx = (mo.x - target.x)/20
						mo.momy = (mo.y - target.y)/20
					end
					if timer >= 75 and timer < 120
						local josghost = P_SpawnGhostMobj(mo)
						josghost.fuse = 10
						mo.dbs[#mo.dbs+1] = josghost
					end
					
					if timer == 120
						mo.flags2 = $|MF2_DONTDRAW
					end
					
					if timer == 130
						mo.flags2 = $ & ~MF2_DONTDRAW
						ANIM_set(mo, mo.anim_atk, true)
						P_TeleportMove(mo, target.x + 32*cos(target.angle+(100*ANG1)), target.y + 32*sin(target.angle+(100*ANG1)), mo.floorz+(FRACUNIT*150))	--Above!
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					end
					if timer > 130 and timer < 150
						local elev = 150-(timer-130)
						P_TeleportMove(mo, target.x + 64*cos(target.angle+(100*ANG1)), target.y + 32*sin(target.angle+(100*ANG1)), mo.floorz+(FRACUNIT*elev))
					end
					
					if timer == 150
						P_TeleportMove(mo, target.x + 32*cos(target.angle+(100*ANG1)), target.y + 32*sin(target.angle+(100*ANG1)), mo.floorz)
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_josvr)
						playSound(mo.battlen, sfx_flickr)
						
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = K|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*3
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
						damageObject(target)
						playSound(mo.battlen, sfx_strslh)
					end
					
					if timer == 180
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.momx = (mo.x - target.x)/20
						mo.momy = (mo.y - target.y)/20
						mo.momz = FRACUNIT*25
					end
					if timer >= 180 and timer < 190
						local josghost = P_SpawnGhostMobj(mo)
						josghost.fuse = 10
						mo.dbs[#mo.dbs+1] = josghost
					end
				end
				if timer == 200
					mo.dbs = {}
					mo.hudcharx = nil
					return true
				end
			end,
		}

	--Sky FC level 23
		attackDefs["tr_blackfang_c"] = {
			name = "Black Fang",
			type = ATK_SLASH,
			power = 300,
			accuracy = 100,
			critical = 7,
			target = TGT_ALLENEMIES,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_JOSAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,			
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nJoshua's S-Craft\nCut down enemies with an \ninstantaneous attack.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end						
				
				if timer == 1	--face the camera
					mo.dbs = {}
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_joaoa3)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.oldangle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 12
					ANIM_set(mo, mo.anim_guard, true)
					mo.angle = $+(90*ANG1)
				end
				
					if mo.dbs and #mo.dbs
						for i = 1, #mo.dbs do
							local s = mo.dbs[i]
							if not s or not s.valid continue end	-- don't care
							if s.fuse == 9
								s.frame = $|FF_TRANS10
							elseif s.fuse == 8
								s.frame = $|FF_TRANS20
							elseif s.fuse == 7
								s.frame = $|FF_TRANS30
							elseif s.fuse == 6
								s.frame = $|FF_TRANS40
							elseif s.fuse == 5
								s.frame = $|FF_TRANS50
							elseif s.fuse == 4
								s.frame = $|FF_TRANS60
							elseif s.fuse == 3
								s.frame = $|FF_TRANS70
							elseif s.fuse == 2
								s.frame = $|FF_TRANS80
							elseif s.fuse == 1
								s.frame = $|FF_TRANS90
							end
						end
					end

				if timer == 20	--jump
					playSound(mo.battlen, sfx_joskl3)
					ANIM_set(mo, mo.anim_special2, true)
					P_InstaThrust(mo, mo.angle, 10*FRACUNIT)
					mo.momz = FRACUNIT*20
				end
				
				if timer >= 20 and timer < 50
					local josghost = P_SpawnGhostMobj(mo)
					josghost.fuse = 10
					mo.dbs[#mo.dbs+1] = josghost
				end
					
				if timer == 50	--situate the camera first
					ANIM_set(mo, mo.anim_downloop, true)
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					mo.angle = mo.oldangle
					P_TeleportMove(mo, avgx + 320*cos(mo.angle+(180*ANG1)), avgy + 320*sin(mo.angle+(180*ANG1)), mo.floorz+(90*FRACUNIT))	--get ready...!
					mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					mo.oldangle = mo.angle
					P_TeleportMove(cam, mo.x + 128 *cos(mo.angle+(180*ANG1)), mo.y + 128*sin(mo.angle+(180*ANG1)), mo.floorz+(40*FRACUNIT))
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end

				if timer == 80
					ANIM_set(mo, mo.anim_guard, true)
				end
				
				for i = 1, #hittargets
					local time = timer - (20*(i-1))
					local target = hittargets[i]
					if time == 100
						local camx = target.x + 256 *cos(mo.oldangle+(180*ANG1))
						local camy = target.y + 256 *sin(mo.oldangle+(180*ANG1))
						cam.momx = (camx - cam.x)/10
						cam.momy = (camy - cam.y)/10
						--server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, traget.x, target.y)
					end
					if time == 110
						cam.momx = 0
						cam.momy = 0
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_joskl1)
						playSound(mo.battlen, sfx_flickr)
						local hitx = target.x + 128 *cos(mo.angle)
						local hity = target.y + 128 *sin(mo.angle)
						mo.momx = (hitx - mo.x)/5
						mo.momy = (hity - mo.y)/5
					end
					if time == 115
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = K|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for j = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*3
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
						damageObject(target)
						playSound(mo.battlen, sfx_strslh)
					end
					if time == 120
						if i == #hittargets then mo.flags2 = $|MF2_DONTDRAW end
						mo.momx = 0
						mo.momy = 0
					end
				end
				if timer == 130 + (30*(#hittargets-1))
					mo.flags2 = $ & ~MF2_DONTDRAW
					mo.dbs = {}
					mo.hudcharx = nil
					return true
				end
			end,
		}

	--Sky SC initial
		attackDefs["tr_sever_c2"] = {
			name = "True Sever",
			type = ATK_SLASH,
			power = 600,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_JOSAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,			
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nJoshua's S-Craft\nFeinting assassin's attack.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end						
				
				if timer == 1	--face the camera
					mo.dbs = {}
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_joaoi4)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					--ANIM_set(mo, mo.anim_special4)	--sprites pending
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 12	--blades gleam
					mo.bod = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(20*FRACUNIT), MT_DUMMY)
					mo.bod.sprite = SPR_MEGI
					mo.bod.color = SKINCOLOR_WHITE
					mo.bod.frame = G|FF_FULLBRIGHT
					mo.bod.blendmode = AST_ADD
					mo.bod.renderflags = $|RF_FULLBRIGHT
					mo.bod.scale = FRACUNIT
					mo.bod.destscale = FRACUNIT/10
					mo.bod.scalespeed = FRACUNIT*2
					--mo.bod.momz = FRACUNIT*-1
					mo.bod.tics = 10
				end
				
				if timer > 12 and timer <= 22
					if mo.bod and mo.bod.valid
						mo.bod.rollangle = $-(3*ANG1)
					end
				end
				
					if mo.dbs and #mo.dbs
						for i = 1, #mo.dbs do
							local s = mo.dbs[i]
							if not s or not s.valid continue end	-- don't care
							if s.fuse == 9
								s.frame = $|FF_TRANS10
							elseif s.fuse == 8
								s.frame = $|FF_TRANS20
							elseif s.fuse == 7
								s.frame = $|FF_TRANS30
							elseif s.fuse == 6
								s.frame = $|FF_TRANS40
							elseif s.fuse == 5
								s.frame = $|FF_TRANS50
							elseif s.fuse == 4
								s.frame = $|FF_TRANS60
							elseif s.fuse == 3
								s.frame = $|FF_TRANS70
							elseif s.fuse == 2
								s.frame = $|FF_TRANS80
							elseif s.fuse == 1
								s.frame = $|FF_TRANS90
							end
						end
					end

				if timer == 20	--jump
					playSound(mo.battlen, sfx_joskl3)
					ANIM_set(mo, mo.anim_special2, true)
					mo.momz = FRACUNIT*20
				end
				
				if timer >= 20 and timer < 50
					local josghost = P_SpawnGhostMobj(mo)
					josghost.fuse = 10
					mo.dbs[#mo.dbs+1] = josghost
				end
					
				if timer >= 50 and timer < 200	--you're finished!
					if timer == 50	--situate the camera first
						P_TeleportMove(cam, target.x + 256 *cos(target.angle), target.y + 256*sin(target.angle), target.z+30*FRACUNIT)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.flags2 = $|MF2_DONTDRAW
					end
					
					if timer == 60
						mo.flags2 = $ & ~MF2_DONTDRAW
						P_TeleportMove(mo, target.x + 96*cos(target.angle+(90*ANG1)), target.y + 96*sin(target.angle+(90*ANG1)), mo.floorz)	--On your left!
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = (target.x - mo.x)/20
						mo.momy = (target.y - mo.y)/20
					end
					if timer == 70
						P_TeleportMove(mo, target.x + 48*cos(target.angle+(90*ANG1)), target.y + 48*sin(target.angle+(90*ANG1)), mo.floorz)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = 0
						mo.momy = 0
						--ANIM_set(mo, mo.anim_special4)	--sprites pending
						ANIM_set(mo, mo.anim_special2)	--placeholder
						playSound(mo.battlen, sfx_joskl4)
						playSound(mo.battlen, sfx_flickr)
						
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = K|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for i = 1, 12 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*1
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
					end
					if timer == 75
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.momx = (mo.x - target.x)/20
						mo.momy = (mo.y - target.y)/20
					end
					if timer >= 75 and timer < 90
						local josghost = P_SpawnGhostMobj(mo)
						josghost.fuse = 10
						mo.dbs[#mo.dbs+1] = josghost
					end
					
					if timer == 90
						P_TeleportMove(mo, target.x + 96*cos(target.angle-(90*ANG1)), target.y + 96*sin(target.angle-(90*ANG1)), mo.floorz)	--On your right!
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = (target.x - mo.x)/20
						mo.momy = (target.y - mo.y)/20
					end
					if timer == 100
						P_TeleportMove(mo, target.x + 48*cos(target.angle-(90*ANG1)), target.y + 48*sin(target.angle-(90*ANG1)), mo.floorz)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						mo.momx = 0
						mo.momy = 0
						--ANIM_set(mo, mo.anim_special4)	--sprites pending
						ANIM_set(mo, mo.anim_special2)	--placeholder
						playSound(mo.battlen, sfx_joskl3)
						playSound(mo.battlen, sfx_flickr)
						
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = J|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for i = 1, 12 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*1
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
					end
					if timer == 105
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.momx = (mo.x - target.x)/20
						mo.momy = (mo.y - target.y)/20
					end
					if timer >= 75 and timer < 120
						local josghost = P_SpawnGhostMobj(mo)
						josghost.fuse = 10
						mo.dbs[#mo.dbs+1] = josghost
					end
					
					if timer == 120
						mo.flags2 = $|MF2_DONTDRAW
					end
					
					if timer == 130
						mo.flags2 = $ & ~MF2_DONTDRAW
						ANIM_set(mo, mo.anim_atk, true)
						P_TeleportMove(mo, target.x + 32*cos(target.angle+(100*ANG1)), target.y + 32*sin(target.angle+(100*ANG1)), mo.floorz+(FRACUNIT*150))	--Above!
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					end
					if timer > 130 and timer < 150
						local elev = 150-(timer-130)
						P_TeleportMove(mo, target.x + 64*cos(target.angle+(100*ANG1)), target.y + 32*sin(target.angle+(100*ANG1)), mo.floorz+(FRACUNIT*elev))
					end
					
					if timer == 150
						P_TeleportMove(mo, target.x + 32*cos(target.angle+(100*ANG1)), target.y + 32*sin(target.angle+(100*ANG1)), mo.floorz)
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_josvr)
						playSound(mo.battlen, sfx_flickr)
						
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = K|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*3
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
						damageObject(target)
						playSound(mo.battlen, sfx_strslh)
					end
					
					if timer == 180
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_guard, true)
						mo.momx = (mo.x - target.x)/20
						mo.momy = (mo.y - target.y)/20
						mo.momz = FRACUNIT*25
					end
					if timer >= 180 and timer < 190
						local josghost = P_SpawnGhostMobj(mo)
						josghost.fuse = 10
						mo.dbs[#mo.dbs+1] = josghost
					end
				end
				if timer == 200
					mo.dbs = {}
					mo.hudcharx = nil
					return true
				end
			end,
		}


	--Sky SC level 77
		attackDefs["tr_blackfang_c2"] = {
			name = "True Black Fang",
			type = ATK_SLASH,
			power = 700,
			accuracy = 100,
			critical = 7,
			target = TGT_ALLENEMIES,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_JOSAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,			
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nJoshua's S-Craft\nCut down enemies with an \ninstantaneous attack.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end						
				
				if timer == 1	--face the camera
					mo.dbs = {}
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_joaoa3)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.oldangle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 12
					ANIM_set(mo, mo.anim_guard, true)
					mo.angle = $+(90*ANG1)
				end
				
					if mo.dbs and #mo.dbs
						for i = 1, #mo.dbs do
							local s = mo.dbs[i]
							if not s or not s.valid continue end	-- don't care
							if s.fuse == 9
								s.frame = $|FF_TRANS10
							elseif s.fuse == 8
								s.frame = $|FF_TRANS20
							elseif s.fuse == 7
								s.frame = $|FF_TRANS30
							elseif s.fuse == 6
								s.frame = $|FF_TRANS40
							elseif s.fuse == 5
								s.frame = $|FF_TRANS50
							elseif s.fuse == 4
								s.frame = $|FF_TRANS60
							elseif s.fuse == 3
								s.frame = $|FF_TRANS70
							elseif s.fuse == 2
								s.frame = $|FF_TRANS80
							elseif s.fuse == 1
								s.frame = $|FF_TRANS90
							end
						end
					end

				if timer == 20	--jump
					playSound(mo.battlen, sfx_joskl3)
					ANIM_set(mo, mo.anim_special2, true)
					P_InstaThrust(mo, mo.angle, 10*FRACUNIT)
					mo.momz = FRACUNIT*20
				end
				
				if timer >= 20 and timer < 50
					local josghost = P_SpawnGhostMobj(mo)
					josghost.fuse = 10
					mo.dbs[#mo.dbs+1] = josghost
				end
					
				if timer == 50	--situate the camera first
					ANIM_set(mo, mo.anim_downloop, true)
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					mo.angle = mo.oldangle
					P_TeleportMove(mo, avgx + 320*cos(mo.angle+(180*ANG1)), avgy + 320*sin(mo.angle+(180*ANG1)), mo.floorz+(90*FRACUNIT))	--get ready...!
					mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					mo.oldangle = mo.angle
					P_TeleportMove(cam, mo.x + 128 *cos(mo.angle+(180*ANG1)), mo.y + 128*sin(mo.angle+(180*ANG1)), mo.floorz+(40*FRACUNIT))
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end

				if timer == 80
					ANIM_set(mo, mo.anim_guard, true)
				end
				
				for i = 1, #hittargets
					local time = timer - (20*(i-1))
					local target = hittargets[i]
					if time == 100
						local camx = target.x + 256 *cos(mo.oldangle+(180*ANG1))
						local camy = target.y + 256 *sin(mo.oldangle+(180*ANG1))
						cam.momx = (camx - cam.x)/10
						cam.momy = (camy - cam.y)/10
						--server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, traget.x, target.y)
					end
					if time == 110
						cam.momx = 0
						cam.momy = 0
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_joskl1)
						playSound(mo.battlen, sfx_flickr)
						local hitx = target.x + 128 *cos(mo.angle)
						local hity = target.y + 128 *sin(mo.angle)
						mo.momx = (hitx - mo.x)/5
						mo.momy = (hity - mo.y)/5
					end
					if time == 115
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = K|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_FLAME

						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						for j = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*3
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-16, 16)*mo.scale
							p.momy = P_RandomRange(-16, 16)*mo.scale
							p.momz = P_RandomRange(-16, 16)*mo.scale
						end
						damageObject(target)
						playSound(mo.battlen, sfx_strslh)
					end
					if time == 120
						if i == #hittargets then mo.flags2 = $|MF2_DONTDRAW end
						mo.momx = 0
						mo.momy = 0
					end
				end
				if timer == 130 + (30*(#hittargets-1))
					mo.flags2 = $ & ~MF2_DONTDRAW
					mo.dbs = {}
					mo.hudcharx = nil
					return true
				end
			end,
		}


	--Sky SC level 85
	attackDefs["tr_phantomraid_c"] = {
			name = "Phantom Raid",
			type = ATK_PSY,
			power = 900,
			accuracy = 100,
			critical = 10,
			target = TGT_ALLENEMIES,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			--noenemycast = true,	--Should be enemy safe now.
			norogue = true,	
			nometronome = true,
			norandom = true,
			status = COND_SILENCE, //And lets make it possible to inflict silence
			statuschance = 5,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nJoshua's S-Craft\nDestroys enemies with illuosry copies of \nhimself and phantasmal slashes. May cause Silence",
			hits = 7,
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))	--bro just unlocked his SILVER WILL!!!
			end,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			hudfunc =     function(v, mo, timer)	
							if timer >= 105 and timer < 150
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_JOSAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
						
						
			anim = 	function(mo, targets, hittargets, timer)
			
			if timer == 90
				mo.hudcharx = -300
			end
			if timer > 105 and timer < 115
				mo.hudcharx = $+30
			end
			if timer == 115
				mo.hudcharx = 0
			end
			if timer >= 140 - 10
				mo.hudcharx = $+60
			end		
			local cam = server.P_BattleStatus[mo.battlen].cam
			
				if timer == 1
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					ANIM_set(mo, mo.anim_special3, true)
					playSound(mo.battlen, sfx_joaoi3)
					mo.sx = mo.x
					mo.sy = mo.y
					mo.sz = mo.z
					//playSound(mo.battlen, sfx_nopelol)
					//mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
				elseif timer == 2
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Looky me..
				elseif timer == 35
					for i = 1,72
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = mo.angle+((ANG1*5)*i)
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_SILVER
						dust.scale = FRACUNIT*2
					end
				playSound(mo.battlen, sfx_lydchr)
				elseif timer == 60
					P_SetObjectMomZ(mo,FRACUNIT*100)
					for i = 1,16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_WHITE
						dust.scale = FRACUNIT*2
					end
				playSound(mo.battlen, sfx_lydchr)
				elseif timer >= 80
				and timer < 115
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					if timer == 80
						playSound(mo.battlen, sfx_jopht)
						local cx = mo.x + 256*cos(mo.angle)
						local cy = mo.y + 256*sin(mo.angle)
						P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						playSound(mo.battlen, sfx_monton)
					end
				elseif timer >= 115
				and timer < 150
					if timer == 115
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 1, 10)
							end
						end
						playSound(mo.battlen, sfx_cutsky)
						playSound(mo.battlen, sfx_appear)
						playSound(mo.battlen, sfx_appear)
						local cx = mo.x + 384*cos(mo.angle)
						local cy = mo.y + 384*sin(mo.angle)
						P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						local lg = P_SpawnMobj(mo.x+128*cos((mo.angle)+ANGLE_45),mo.y+128*sin((mo.angle)+ANGLE_45), mo.z, MT_THOK)
						//lg.state = S_PHANTRAIDBUDDY
						lg.frame = A
						lg.tics = 9999
						lg.sprite = SPR_JPRD
						lg.color = mo.color
						lg.angle = mo.angle
						mo.lg = lg
						local rg = P_SpawnMobj(mo.x+128*cos((mo.angle)+ANGLE_315),mo.y+128*sin((mo.angle)+ANGLE_315),mo.z, MT_THOK)
						//rg.state = S_PHANTRAIDBUDDY
						rg.sprite = SPR_JPRD
						rg.tics = 9999
						rg.frame = A
						rg.color = mo.color
						rg.angle = mo.angle
						mo.rg = rg
					end
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
				P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
				elseif timer == 150
				P_TeleportMove(mo,mo.sx,mo.sy,mo.sz)
				ANIM_set(mo, mo.anim_special2, true)
				end
				for i = 1,#hittargets
					local target = hittargets[i]
					
					
					local time = timer - (i-1)*25
					if time >= 150
					and time < 175
						if time == 150
						mo.lg.frame = B
						mo.rg.frame = B
						P_TeleportMove(mo,mo.sx,mo.sy,mo.sz)
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
						local cx = target.x + 256*cos(target.angle)
						local cy = target.y + 256*sin(target.angle)
						P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*16)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						elseif time == 155
						P_InstaThrust(mo,mo.angle,128*FRACUNIT)
						elseif time == 158
						createSplat(mo)
						playSound(mo.battlen, sfx_slash)
						damageObject(target)
						end
						
					mo.lg.angle = mo.angle
					mo.rg.angle = mo.angle
					P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
					P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
					end
				end
				local atime = timer - (#hittargets-1)*25
				if atime == 175
				mo.lg.angle = mo.angle
				mo.rg.angle = mo.angle
				P_TeleportMove(mo,mo.sx,mo.sy,mo.sz + FRACUNIT*1000)
				P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
				P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				elseif atime >= 176
				and atime < 211
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					if atime == 176
					mo.rg.momx = (mo.x - mo.rg.x)/35
					mo.rg.momy = (mo.y - mo.rg.y)/35
					mo.rg.momz = (mo.z - mo.rg.z)/35
					mo.lg.momx = (mo.x - mo.lg.x)/35
					mo.lg.momy = (mo.y - mo.lg.y)/35
					mo.lg.momz = (mo.z - mo.lg.z)/35
					mo.rg.tics = 35
					mo.lg.tics = 35
					elseif atime == 210
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
						for i = 1,72
							local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							dust.angle = mo.angle+((ANG1*5)*i)
							dust.state = S_CDUST1
							P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
							dust.color = SKINCOLOR_WHITE
							dust.scale = FRACUNIT*3
						end
						playSound(mo.battlen, sfx_buff)
					end
				elseif atime == 211
				playSound(mo.battlen, sfx_jshptb)
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				local cx = mo.x + 256*cos(mo.angle+ANGLE_180)
				local cy = mo.y + 256*sin(mo.angle+ANGLE_180)
				P_TeleportMove(cam, cx, cy, mo.sz + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				mo.lg = nil
				mo.rg = nil
				end
				for i = 1,5
					if atime == 215 + 20*(i-1)
						for bruh = 1,#hittargets
							local target = hittargets[bruh]
							damageObject(target)
							playSound(mo.battlen, sfx_slash)
							createSplat(mo)
						end
					end
				end
				if atime >= 215
				and atime < 295
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				local rnd = P_RandomRange(1,#hittargets) //Stolen moment lmao
				local rtarget = hittargets[rnd]
				local s = P_SpawnMobj(rtarget.x + FRACUNIT*P_RandomRange(-128,128), rtarget.y + FRACUNIT*P_RandomRange(-128,128), rtarget.z + FRACUNIT*P_RandomRange(-128,128), MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = mo.color
				s.scale = FRACUNIT*3
				s.rollangle = P_RandomRange(0, 359)*ANG1
				local b = P_SpawnMobj(rtarget.x, rtarget.y, rtarget.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_RED
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/12
				b.tics = 35
				
				elseif atime >= 310
				and atime < 345
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					for bruh = 1,#hittargets
						local target = hittargets[bruh]
						if atime == 310
							local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							s.state = S_SLASHING_2_1
							s.color = mo.color
							s.scale = FRACUNIT*6
						elseif atime == 325
						playSound(mo.battlen, sfx_slash)
						createSplat(mo)
						damageObject(target)
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_RED
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
							for k,v in ipairs(mo.allies)
								if v and v.control and v.control.valid
									P_FlashPal(v.control, 4, 5)
								end
							end
							P_TeleportMove(mo,mo.sx,mo.sy,mo.sz + 128*FRACUNIT)
						ANIM_set(mo, mo.anim_aoa_end, true)
						mo.angle = R_PointToAngle2(mo.x, mo.y, cam.x, cam.y)
						end
					end
				elseif atime == 345
					mo.sx = nil
					mo.sy = nil
					mo.sz = nil
				elseif atime == 360
				mo.angle = $1+ANGLE_180
				elseif atime == 365
					return true
				end
				if atime > 325
				and atime < 365
				and P_IsObjectOnGround(mo)
				ANIM_set(mo, mo.anim_stand, true)
				end
			end,
	}

	--Sky SC level 85
	attackDefs["tr_phantomraid_c2"] = {
			name = "True Phantom Raid",
			type = ATK_PSY,
			power = 1200,
			accuracy = 100,
			critical = 20,
			target = TGT_ALLENEMIES,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			nometronome = true,
			--noenemycast = true,	--Should be enemy safe now.
			norandom = true,
			status = COND_SILENCE, //And lets make it possible to inflict silence
			statuschance = 10,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nJoshua's S-Craft\nDestroys enemies with illuosry copies of \nhimself and phantasmal slashes. May cause Silence",
			hits = 7,
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))	--bro just unlocked his SILVER WILL!!!
			end,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			hudfunc =     function(v, mo, timer)	
							if timer >= 105 and timer < 150
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_JOSAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
						
						
			anim = 	function(mo, targets, hittargets, timer)
			
			if timer == 90
				mo.hudcharx = -300
			end
			if timer > 105 and timer < 115
				mo.hudcharx = $+30
			end
			if timer == 115
				mo.hudcharx = 0
			end
			if timer >= 140 - 10
				mo.hudcharx = $+60
			end		
			local cam = server.P_BattleStatus[mo.battlen].cam
			
				if timer == 1
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end

					ANIM_set(mo, mo.anim_special3, true)
					playSound(mo.battlen, sfx_joaoi3)
					mo.sx = mo.x
					mo.sy = mo.y
					mo.sz = mo.z
					//playSound(mo.battlen, sfx_nopelol)
					//mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
				elseif timer == 2
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Looky me..
				elseif timer == 35
					for i = 1,72
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = mo.angle+((ANG1*5)*i)
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_SILVER
						dust.scale = FRACUNIT*2
					end
				playSound(mo.battlen, sfx_lydchr)
				elseif timer == 60
					P_SetObjectMomZ(mo,FRACUNIT*100)
					for i = 1,16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_WHITE
						dust.scale = FRACUNIT*2
					end
				playSound(mo.battlen, sfx_lydchr)
				elseif timer >= 80
				and timer < 115
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					if timer == 80
						playSound(mo.battlen, sfx_jopht)
						local cx = mo.x + 256*cos(mo.angle)
						local cy = mo.y + 256*sin(mo.angle)
						P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						playSound(mo.battlen, sfx_monton)
					end
				elseif timer >= 115
				and timer < 150
					if timer == 115
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 1, 10)
							end
						end
						playSound(mo.battlen, sfx_cutsky)
						playSound(mo.battlen, sfx_appear)
						playSound(mo.battlen, sfx_appear)
						local cx = mo.x + 384*cos(mo.angle)
						local cy = mo.y + 384*sin(mo.angle)
						P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						local lg = P_SpawnMobj(mo.x+128*cos((mo.angle)+ANGLE_45),mo.y+128*sin((mo.angle)+ANGLE_45), mo.z, MT_THOK)
						//lg.state = S_PHANTRAIDBUDDY
						lg.frame = A
						lg.tics = 9999
						lg.sprite = SPR_JPRD
						lg.color = mo.color
						lg.angle = mo.angle
						mo.lg = lg
						local rg = P_SpawnMobj(mo.x+128*cos((mo.angle)+ANGLE_315),mo.y+128*sin((mo.angle)+ANGLE_315),mo.z, MT_THOK)
						//rg.state = S_PHANTRAIDBUDDY
						rg.sprite = SPR_JPRD
						rg.tics = 9999
						rg.frame = A
						rg.color = mo.color
						rg.angle = mo.angle
						mo.rg = rg
					end
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
				P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
				elseif timer == 150
				P_TeleportMove(mo,mo.sx,mo.sy,mo.sz)
				ANIM_set(mo, mo.anim_special2, true)
				end
				for i = 1,#hittargets
					local target = hittargets[i]
					
					
					local time = timer - (i-1)*25
					if time >= 150
					and time < 175
						if time == 150
						mo.lg.frame = B
						mo.rg.frame = B
						P_TeleportMove(mo,mo.sx,mo.sy,mo.sz)
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
						local cx = target.x + 256*cos(target.angle)
						local cy = target.y + 256*sin(target.angle)
						P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*16)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						elseif time == 155
						P_InstaThrust(mo,mo.angle,128*FRACUNIT)
						elseif time == 158
						createSplat(mo)
						playSound(mo.battlen, sfx_slash)
						damageObject(target)
						end
						
					mo.lg.angle = mo.angle
					mo.rg.angle = mo.angle
					P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
					P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
					end
				end
				local atime = timer - (#hittargets-1)*25
				if atime == 175
				mo.lg.angle = mo.angle
				mo.rg.angle = mo.angle
				P_TeleportMove(mo,mo.sx,mo.sy,mo.sz + FRACUNIT*1000)
				P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
				P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				elseif atime >= 176
				and atime < 211
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					if atime == 176
					mo.rg.momx = (mo.x - mo.rg.x)/35
					mo.rg.momy = (mo.y - mo.rg.y)/35
					mo.rg.momz = (mo.z - mo.rg.z)/35
					mo.lg.momx = (mo.x - mo.lg.x)/35
					mo.lg.momy = (mo.y - mo.lg.y)/35
					mo.lg.momz = (mo.z - mo.lg.z)/35
					mo.rg.tics = 35
					mo.lg.tics = 35
					elseif atime == 210
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
						for i = 1,72
							local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							dust.angle = mo.angle+((ANG1*5)*i)
							dust.state = S_CDUST1
							P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
							dust.color = SKINCOLOR_WHITE
							dust.scale = FRACUNIT*3
						end
						playSound(mo.battlen, sfx_buff)
					end
				elseif atime == 211
				playSound(mo.battlen, sfx_jshptb)
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				local cx = mo.x + 256*cos(mo.angle+ANGLE_180)
				local cy = mo.y + 256*sin(mo.angle+ANGLE_180)
				P_TeleportMove(cam, cx, cy, mo.sz + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				mo.lg = nil
				mo.rg = nil
				end
				for i = 1,5
					if atime == 215 + 20*(i-1)
						for bruh = 1,#hittargets
							local target = hittargets[bruh]
							damageObject(target)
							playSound(mo.battlen, sfx_slash)
							createSplat(mo)
						end
					end
				end
				if atime >= 215
				and atime < 295
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				local rnd = P_RandomRange(1,#hittargets) //Stolen moment lmao
				local rtarget = hittargets[rnd]
				local s = P_SpawnMobj(rtarget.x + FRACUNIT*P_RandomRange(-128,128), rtarget.y + FRACUNIT*P_RandomRange(-128,128), rtarget.z + FRACUNIT*P_RandomRange(-128,128), MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = mo.color
				s.scale = FRACUNIT*3
				s.rollangle = P_RandomRange(0, 359)*ANG1
				local b = P_SpawnMobj(rtarget.x, rtarget.y, rtarget.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_RED
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/12
				b.tics = 35
				
				elseif atime >= 310
				and atime < 345
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					for bruh = 1,#hittargets
						local target = hittargets[bruh]
						if atime == 310
							local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							s.state = S_SLASHING_2_1
							s.color = mo.color
							s.scale = FRACUNIT*6
						elseif atime == 325
						playSound(mo.battlen, sfx_slash)
						createSplat(mo)
						damageObject(target)
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_RED
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
							for k,v in ipairs(mo.allies)
								if v and v.control and v.control.valid
									P_FlashPal(v.control, 4, 5)
								end
							end
							P_TeleportMove(mo,mo.sx,mo.sy,mo.sz + 128*FRACUNIT)
						ANIM_set(mo, mo.anim_aoa_end, true)
						mo.angle = R_PointToAngle2(mo.x, mo.y, cam.x, cam.y)
						end
					end
				elseif atime == 345
					mo.sx = nil
					mo.sy = nil
					mo.sz = nil
				elseif atime == 360
				mo.angle = $1+ANGLE_180
				elseif atime == 365
					return true
				end
				if atime > 325
				and atime < 365
				and P_IsObjectOnGround(mo)
				ANIM_set(mo, mo.anim_stand, true)
				end
			end,
	}

end
