freeslot("sfx_arcusu", "sfx_arcusd", "sfx_arcusl", "sfx_arcusb")



local function tr_addSkill (mo, skill)
			
	local check = false
					
	if #mo.skills
		for s = 1,#mo.skills
		local x = mo.skills[s]
			if skill == x
				check = true
			end
		end
	end
										
	if #mo.passiveskills
		for s = 1,#mo.passiveskills
		local x = mo.passiveskills[s]
			if skill == x
				check = true
				else
			end
		end
	end
									
	if not check
		if attackDefs[skill].type & ATK_PASSIVE
			mo.passiveskills[#mo.passiveskills+1] = skill
		else	
			mo.skills[#mo.skills+1] = skill
		end
	end
end

local function tr_removeSkill (mo, skill)
	
	local storenum = 0
				
	if #mo.skills
		for i = 1,#mo.skills
		local x = mo.skills[i]
			if skill == x
				storenum = i
			end
		end
	end
				
	if #mo.passiveskills
		for i = 1,#mo.passiveskills
			local x = mo.passiveskills[i]
			if skill == x
				storenum = i
			end
		end
	end
				
	if storenum
		if attackDefs[skill].type & ATK_PASSIVE
			table.remove(mo.passiveskills,storenum)
		else	
			table.remove(mo.skills,storenum)
		end
	end
end






attackDefs["tr_cherubicsmile"] = {
		name = "Cherubic Smile",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 15,
		desc = "Cheers up a ally increasing\ncritical hit rate",
		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("BRAVE_ORDER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ROSY))
		end,		
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["crit"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_courge)
				VFX_Play(target, VFX_SUMMON)
				buffStat(target, "crit")
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_ROSY
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50
				if leveltime%2 == 0
					for i = 1,16
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS70
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_ROSY
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_ROSY
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["tr_antidote"] = {
		name = "Antidote",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Poison",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_POISON
                            BTL_logMessage(targets[1].battlen, target.name.." is not poisoned")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_POISON
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_relaxant"] = {
		name = "Relaxant",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		desc = "Cures Shock",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_SHOCK
                            BTL_logMessage(targets[1].battlen, target.name.." is not paralyzed")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_SHOCK
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_tape"] = {
		name = "Insulating Tape",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		desc = "Cures Silence",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_SILENCE
                            BTL_logMessage(targets[1].battlen, target.name.." is not silenced")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_SILENCE
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_spray"] = {
		name = "Cooling Spray",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Burn",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_BURN
                            BTL_logMessage(targets[1].battlen, target.name.." is not burning")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_warmer"] = {
		name = "Warmer",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Freeze",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_FREEZE
                            BTL_logMessage(targets[1].battlen, target.name.." is not frozen")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_FREEZE
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_eye"] = {
		name = "Eye Drop",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Dizzy",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_DIZZY
                            BTL_logMessage(targets[1].battlen, target.name.." doesn't feel dizzy...")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_DIZZY
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_mint"] = {
		name = "Mint Drop",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Sleep",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_SLEEP
                            BTL_logMessage(targets[1].battlen, target.name.." is not sleeping...")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_SLEEP
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_sedative"] = {
		name = "Sedative",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		desc = "Cures Brainwash",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_BRAINWASH
                            BTL_logMessage(targets[1].battlen, target.name.." is not brainwashed")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_BRAINWASH
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_salts"] = {
		name = "Smelling Salts",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		desc = "Cures Rage/Hex",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_RAGE and target.status_condition ~= COND_FEAR
                            BTL_logMessage(targets[1].battlen, target.name.." is not angry or scared")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition ~= COND_RAGE and target.status_condition ~= COND_HEX
				else
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_scope"] = {
		name = "Battle Scope",
		type = ATK_SUPPORT,
		costtype = CST_EP,
		nometronome = true,
		norandom = true,
		cost = 1,
		desc = "Analyze 1 target, revealing\ntheir affinities.",
		target = TGT_ENEMY,
		norepel = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local btl = server.P_BattleStatus[mo.battlen]

			if mo.enemy
				return true	-- NO.
			end

			if timer == 15

				if not btl.saved_affs[target.enemy]
					playSound(mo.battlen, sfx_bascp)
					btl.saved_affs[target.enemy] = {0, 0, false}	-- failsafe?
				end
				btl.saved_affs[target.enemy][1] = 2147483647	-- INT32_MAX
				btl.saved_affs[target.enemy][2] = 2147483647	-- INT32_MAX
				btl.saved_affs[target.enemy][3] = true	-- stats

				playSound(mo.battlen, sfx_bascp)
				local t = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_THOK)
				t.tics = -1
				t.sprite = SPR_ANLY
				t.frame = FF_FULLBRIGHT
				t.scale = FRACUNIT*5/2
				t.fuse = TICRATE*2


				local g = P_SpawnGhostMobj(t)
				t.destscale = $*4
				t.scalespeed = $*4
				t.momz = FRACUNIT*4
				t.fuse = TICRATE/2
			end

			if timer >= 30
				if mo.control.mo.P_inputs[BT_JUMP] == 1
				and not mo.anl_closetimer

					mo.anl_closetimer = TICRATE

				end

				if mo.anl_closetimer
					mo.anl_closetimer = $-1
					if not mo.anl_closetimer

						mo.anl_closetimer = nil
						-- give me another turn
						local i = #btl.turnorder+1
						while i > 1
							btl.turnorder[i] = btl.turnorder[i-1]
							i = $-1
						end
						return true
					end
				end
			end

		end,

		-- hudfunc2 is layered above the regular UI
		hudfunc2 = function(v, mo, timer)

			local target = mo.targets[1]
			if timer > TICRATE and target.enemy

					local cmd = {
						{BUTT_A, "Close"},
					}

				if mo.anl_closetimer
					local t = mo.anl_closetimer - TICRATE/2
					if t > 0
						v.drawScaled(160<<FRACBITS, 100<<FRACBITS, max(0, min(64, t))*FRACUNIT/2, v.cachePatch("H_1M_B"), V_50TRANS)
						drawStats(v, target, max(t, -8), 1, 0, cmd)
					end
				else
					local t = timer - TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, max(0, min(64, t))*FRACUNIT/2, v.cachePatch("H_1M_B"), V_50TRANS)
					drawStats(v, target, max(t, -8), 1, 0, cmd)
				end
			end
		end,

}

attackDefs["tr_zeram_powder"] = {
		name = "Zeram Powder",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 31651620,
		desc = "Revives a ally with full HP and CP.",
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		target = TGT_DEAD,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				mo.minido = {} //Megidola support: making things
				target.landedonce = false
			end
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)	*FRACUNIT
			avgy = ($/#hittargets)	*FRACUNIT
			
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(mo, mo.anim_evoker, true)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_thelas)
			elseif timer < 60
			and timer > 25
				local ran = P_RandomRange(0, 359)*ANG1
				local dist = 256

				mo.minido[#mo.minido+1] = P_SpawnMobj(avgx + dist*cos(ran), avgy + dist*sin(ran), mo.z + 256*FRACUNIT, MT_DUMMY)
				local s = mo.minido[#mo.minido]
				s.angle = ran
				s.state = S_MEGITHOK
				s.scale = $/5
				s.extravalue1 = dist
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
			end
			if timer <= 115
				for i = 1, #mo.minido
					if timer < 115
					local s = mo.minido[i]
					s.angle = $ + ANG1*12
					s.extravalue1 = max(0, $ - 6)

					local x = avgx + s.extravalue1*cos(s.angle)
					local y = avgy + s.extravalue1*sin(s.angle)
					local sz = s.z - FRACUNIT*6
					if s.z > target.z + 16*FRACUNIT
						P_TeleportMove(s, x, y, sz)
					else
						P_TeleportMove(s, x, y, s.z)
						s.destscale = 1
						s.scalespeed = FRACUNIT/20
					end
					elseif timer == 115
						local s = mo.minido[i]
						s.fuse = 2
					end
				end
			end
			if timer == 115
				local heals = target.maxhp
				damageObject(target, -heals)
				if C2SBarEdits
					damageTP(target, -target.maxtp)
				else
					damageSP(target, -target.maxsp)
				end				
				playSound(mo.battlen, sfx_tear)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				target.momz = 6*FRACUNIT
				for i = 1, 64
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_ORANGE
					thok.frame = A
					thok.tics = 50
					thok.scale = (P_RandomRange(1, 10)*FRACUNIT)/8
					thok.scalespeed = FRACUNIT/50
					thok.destscale = 1
					thok.momz = P_RandomRange(3, 12)*FRACUNIT
					thok.momx = P_RandomRange(-15, 15)*FRACUNIT
					thok.momy = P_RandomRange(-15, 15)*FRACUNIT
				end
			end
			if timer > 115 and P_IsObjectOnGround(target) and not target.landedonce
				ANIM_set(target, target.anim_stand_hurt, true)
				target.landedonce = true
			end
			if timer == 165
				target.landedonce = nil
				mo.minido = nil
				return true
			end
		end,
}

attackDefs["tr_sp_charge1"] = {
		name = "SP Charge",
		type = ATK_HEAL,
		target = TGT_ALLY,
		costtype = CST_SP,
		cost = 0,
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		power = 50,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		showsp = true,	-- tell the game to display sp bars
		desc = "50 SP recovery to 1 ally.",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.sp >= target.maxsp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 5
					playSound(mo.battlen, sfx_spheal)
				end

				if timer <= 30
					local thok = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(0, 0)*FRACUNIT, MT_DUMMY)
					thok.state = S_MEGISTAR1
					thok.momz = (P_RandomRange(4, 8)/4)*FRACUNIT
					thok.color = SKINCOLOR_MAGENTA
					thok.tics = P_RandomRange(10, 25)
					thok.scale = FRACUNIT*3/2
				end

				if timer == 40
					damageSP(target, -50)
					playSound(mo.battlen, sfx_lsheal)
				elseif timer == 75
					return true
				end
		end,
}

attackDefs["tr_sp_charge2"] = {
		name = "SP Charge II",
		type = ATK_HEAL,
		target = TGT_ALLY,
		costtype = CST_SP,
		cost = 0,
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		power = 100,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		showsp = true,	-- tell the game to display sp bars
		desc = "100 SP recovery to 1 ally.",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.sp >= target.maxsp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 5
					playSound(mo.battlen, sfx_spheal)
				end

				if timer <= 30
					local thok = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(0, 0)*FRACUNIT, MT_DUMMY)
					thok.state = S_MEGISTAR1
					thok.momz = (P_RandomRange(4, 8)/4)*FRACUNIT
					thok.color = SKINCOLOR_MAGENTA
					thok.tics = P_RandomRange(10, 25)
					thok.scale = FRACUNIT*3/2
				end

				if timer == 40
					damageSP(target, -100)
					playSound(mo.battlen, sfx_lsheal)
				elseif timer == 75
					return true
				end
		end,
}

attackDefs["tr_sp_charge3"] = {
		name = "SP Charge III",
		type = ATK_HEAL,
		target = TGT_ALLY,
		costtype = CST_SP,
		cost = 0,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		power = 999,
		showsp = true,	-- tell the game to display sp bars
		desc = "Full SP recovery to 1 ally.",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.sp >= target.maxsp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_teara)
					end
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.colorized = true
							r.color = SKINCOLOR_MAGENTA
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.colorized = true
							q.color = SKINCOLOR_MAGENTA
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
							end
						end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_MAGENTA
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					playSound(mo.battlen, sfx_lsheal)
					damageSP(target, -target.maxsp)
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_link_attack"] = {	--depricated
		name = "Link Attack!",
		type = ATK_SLASH,
		power = 50,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 10,
		critical = 3,
		link = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ARCUS"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
		end,				
		desc = "Light Slash damage to\none enemy. Following allied attacks\ngain Link follow-ups.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 5
			playSound(mo.battlen, sfx_likatk)
			end

			if timer == 15
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_slash)

			elseif timer == 17
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE
			end

			if timer == 19

				damageObject(target)
				playSound(mo.battlen, sfx_likdo)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				
				for i=1,20
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-8, 8)*FRACUNIT
					b.momy = P_RandomRange(-8, 8)*FRACUNIT
					b.momz = P_RandomRange(-8, 8)*FRACUNIT
					b.state = S_SSPK1
				end		
				

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

			elseif timer == 45
				target.slashsprite = nil
				return true
			end
		end,
}

attackDefs["tr_gale"] = {
		name = "Gale",
		type = ATK_SLASH,
		power = 300,
		accuracy = 100,
		costtype = CST_HPPERCENT,
		cost = 16,
		critical = 3,
		technical = COND_FREEZE,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,				
		desc = "Slices up all enemies at high speed.\nMedium Slash Damage",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 1
				mo.sx = mo.x
				mo.sy = mo.y
				mo.sz = mo.z
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = mo.color
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
				playSound(mo.battlen, sfx_s3k9c)
				playSound(mo.battlen, sfx_cdfm12)
			end
			
			if timer == 10
				local s = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*2, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*4
				playSound(mo.battlen, sfx_cracom)
			end				
			
			
			if timer == 15
				P_TeleportMove(mo,mo.x,mo.y,mo.z + FRACUNIT*2)//A little Zorua cheat so we don't have to deal with friction
				mo.flags = $|MF_NOGRAVITY //So sneaky mwehehe
				ANIM_set(mo, mo.anim_run,true) //wheeee
			end
			
			for i = 1, #hittargets
				local target = hittargets[i]
				local time = timer - (i-1)*10
				//P_DiffMove is a rawset not here so uh,
				if time == 20
				
					mo.momx = (target.x - mo.x)/10
					mo.momy = (target.y - mo.y)/10
					//Don't look at the gross exposed function
					mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
					playSound(mo.battlen, sfx_mswing)
					playSound(mo.battlen, sfx_cdfm01)
					
				elseif time == 25
				
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					
				elseif time == 30
					damageObject(target)
					localquake(mo.battlen, FRACUNIT*10, 10)
					playSound(mo.battlen, sfx_bsnipe)
					playSound(mo.battlen, sfx_bexpld)
				end
				if time == 25
					for i = 1,10
						local ol = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_WHITE
						ol.scale = 1
						ol.destscale = mo.scale*3
						ol.scalespeed = (mo.scale*3)/15
						ol.frame = B|FF_TRANS80
						ol.tics = i + 5
					end
				end	
			end						

			
			if timer == 35 + (#hittargets-1)*10
				mo.flags = $ & !MF_NOGRAVITY
				ANIM_set(mo, mo.anim_move, true)
			end
			
			if timer == 50 + (#hittargets-1)*10//40, 20 tics to hop back
				P_TeleportMove(mo,mo.x,mo.y,mo.sz)//sod off I wanna lob without calculating stuff
				
				mo.momx = (mo.sx - mo.x)/20
				mo.momy = (mo.sy - mo.y)/20
				mo.angle = R_PointToAngle2(mo.x,mo.y,mo.sx,mo.sy)
				if mo.anim_atk and #mo.anim_atk
					ANIM_set(mo, mo.anim_atk,true) //Yahoo
				else
					ANIM_set(mo, mo.anim_stand,true) //stanced up i guess
				end
				mo.momz = mo.scale*5//I'm gonna assume gravity is the standard bc quite frankly, piss off
				
			elseif timer == 70 + (#hittargets-1)*10
				mo.sx = nil
				mo.sy = nil
				mo.sz = nil
				return true
			end
		end,
}

attackDefs["tr_motivate"] = {
		name = "Motivate",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 20,
		desc = "An encouraging shout to the allies.\nRaises Attack and Heals 5 SP/10 TP/20 CP",
		target = TGT_ALLALLIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RED))
		end,		
		buff = true,
		showsp = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*8
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					if C2SBarEdits and target ~= mo and not target.enemy and charStats[target.stats].tpbar	--only affects TP characters, but not the caster.
						local tpheal = 10
						if charStats[target.stats].cpuse then tpheal = 20 end
						if target.tpspuse
							damageSP(target, -tpheal, nil, nil, charStats[target.stats].tpspuse)
						else
							damageSP(target, -tpheal)
						end
					else
						local tpheal = 5
						damageSP(target, -tpheal)
					end
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_SUPERRED3
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*8 and timer <= 50 + (i-1)*8

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS70
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_KETCHUP
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_SALMON
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 70
				return true
			end
		end,
}

attackDefs["tr_flame_dragon"] = {
		name = "Flame Dragon",
		type = ATK_FIRE,
		power = 410,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 10,
		critical = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,		
		status = COND_BURN,
		statuschance = 10,
		desc = "Strikes all enemies with a Fire Move\ncausing Heavy Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				for i = 1, #hittargets
					local target = hittargets[i]

					local t = timer - (i-1)*6

				if timer == 15
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_RED
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_slash)

				elseif timer == 17
					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = C|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*3
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_RED

				elseif timer == 19

					DoExplosion(target)
					damageObject(target)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
					for i=1,20
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_QUICKBOOM1
						b.scale = FRACUNIT*3
					end
	
					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_RED

				elseif timer == 45 + (#hittargets-1)*6
					target.slashsprite = nil
					return true
				end
			end	
		end,
}

attackDefs["tr_sniper_shot"] = {
		name = "Sniper Shot",
		type = ATK_PIERCE,
		power = 410,
		accuracy = 150,
		costtype = CST_HPPERCENT,
		cost = 13,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,		
		critical = 5,
		desc = "Heavy Pierce Damage to a enemy.\nTakes aim to a enemy and shoots a\nquick and quiet bullet",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 1		
			local t = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_THOK)
				t.tics = -1
				t.sprite = SPR_ANLY
				t.frame = FF_FULLBRIGHT
				t.scale = FRACUNIT*5/2
				t.fuse = 35
				elseif timer == 5
				playSound(mo.battlen, sfx_emfind)
				elseif timer == 20
				playSound(mo.battlen, sfx_emfind)
				elseif timer == 36
				createSplat(mo)
				local shot = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				shot.state = S_SHOT1
				shot.scale = $ + P_RandomRange(0, 65535)*3
				P_StartQuake(FRACUNIT*2, 5)
				damageObject(hittargets[1])
			end
			
			if timer == 37
				playSound(mo.battlen, sfx_trfire)
				playSound(mo.battlen, sfx_rail1)
				playSound(mo.battlen, sfx_rail2)
				createSplat(mo)
				createSplat(mo)
				localquake(mo.battlen, FRACUNIT*10, 10)

				for i = 1, 32 do
					local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale*2
					p.colorized = true
					p.color = SKINCOLOR_AZURE
					p.angle = target.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-24, 24)*mo.scale
					P_InstaThrust(p, p.angle, mo.scale*64)
				end
			end	
			
			
			if timer == 70
			return true
			end
		end,
}

attackDefs["tr_quick_draw"] = {
		name = "Quick Draw",
		type = ATK_PIERCE,
		power = 500,
		accuracy = 92,
		costtype = CST_HPPERCENT,
		cost = 22,
		critical = 1,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,		
		desc = "Fires off several rounds\nin the blink of an eye.\nHeavy Pierce Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer >= 15 and timer <= 45
			and not (timer%2)

				local shot = P_SpawnMobj(avgx + P_RandomRange(-150, 150)*FRACUNIT, avgy + P_RandomRange(-150, 150)*FRACUNIT, mo.z + P_RandomRange(0, 150)*FRACUNIT, MT_DUMMY)
				if not (timer%4)
					playSound(mo.battlen, sfx_rail1)
				end
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_SILVER
				shot.scale = $ + P_RandomRange(0, 65535)*3

				if not (timer%8)
					createSplat(mo)
					localquake(mo.battlen, FRACUNIT*4, 4)
				end
			end	
			
			for i = 1,#hittargets
				local target = hittargets[i]
				if timer == 50 + 8*(i-1)
					local shot = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					shot.state = S_STAB_1_1
					shot.color = SKINCOLOR_SILVER
					shot.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_hit)

					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = A|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*4
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_SILVER

				elseif timer == 56 + 8*(i-1)
					playSound(mo.battlen, sfx_rail1)
					localquake(mo.battlen, FRACUNIT*10, 10)
					damageObject(target)
					for i = 1, 32 do
						local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SSPK1
						p.scale = mo.scale*2
						p.colorized = true
						p.color = SKINCOLOR_SUPERGOLD5
						p.angle = target.angle + P_RandomRange(-30, 30)*ANG1
						p.momz = P_RandomRange(-24, 24)*mo.scale
						P_InstaThrust(p, p.angle, mo.scale*64)
					end
				end	
			end			
			
			if timer == 95 + (#hittargets-1)*8
				return true
			end
		end,
}			

attackDefs["tr_wild_rage"] = {
		name = "Wild Rage",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		accuracy = 999,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,		
		desc = "A raging howl that boosts morale, \nrestoring 12 SP/25 TP/50 but damaging \nyourself for 30% of your max HP",
		target = TGT_CASTER,
		superbuff = true,
		/*nocast = function(targets, n)
						local zorua = targets[n]
						if zorua.hp <= (zorua.maxhp*7)/10
							BTL_logMessage(zorua.battlen, "You need more than "..((zorua.maxhp*7)/10).." HP to use this skill!")
							return true
						end
					end,*/	--it's supposed to kill the fool-hardy =)
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
		
			if timer >= 10 and timer <= 100
				if timer == 10
				or timer == 30
				or timer == 50
				or timer == 70
				or timer == 90	
					playSound(mo.battlen, sfx_lydchr)
					playSound(mo.battlen, sfx_fire1)
					localquake(mo.battlen, FRACUNIT*5, 10)
				end				
				
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_FLAME
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
					
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_FLAME
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_FLAME
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
			end		

			if timer >= 10 and timer < 100
				summonAura(target, SKINCOLOR_FLAME)
			end
			
			
			if timer == 10
			or timer == 30
			or timer == 50
			or timer == 70
			or timer == 90	
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_FLAME
					dust.scale = FRACUNIT*2
				end
			end	

			if timer == 101
				local hp = min(mo.hp - 1, (mo.maxhp*3)/10)
				damageObject(mo, hp, DMG_NORMAL, true)
				if C2SBarEdits and not target.enemy and charStats[target.stats].tpbar
					local tpheal = 25
					if charStats[target.stats].cpuse then tpheal = 50 end
					if target.tpspuse
						damageSP(target, -tpheal, nil, nil, charStats[target.stats].tpspuse)
					else
						damageSP(target, -tpheal)
					end
				else
					local tpheal = 12
					damageSP(target, -tpheal)
				end
                /*buffStat(target, "atk", 75)
				BTL_logMessage(targets[1].battlen, "Physical Attack up x3!")
				playSound(mo.battlen, sfx_buff)
				playSound(mo.battlen, sfx_hit2)
				playSound(mo.battlen, sfx_s2462)*/
			end
			
			if timer == 102
				for i = 1, 64
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_FLAME or SKINCOLOR_SALMON
					t.scale = FRACUNIT*1/2
				end
			end
			
			
			if timer == 125
				return true
			end
		end,
}

attackDefs["tr_wild_rage_2"] = {
		name = "Wild Rage 2",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		accuracy = 999,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,		
		desc = "A raging howl that boosts morale, \nrestoring 36 SP/75 TP/150 but damaging \nyourself for 70% of your max HP",
		target = TGT_CASTER,
		superbuff = true,
		/*nocast = function(targets, n)
						local zorua = targets[n]
						if zorua.hp <= (zorua.maxhp*7)/10
							BTL_logMessage(zorua.battlen, "You need more than "..((zorua.maxhp*7)/10).." HP to use this skill!")
							return true
						end
					end,*/	--it's supposed to kill the fool-hardy =)
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
		
			if timer >= 10 and timer <= 100
				if timer == 10
				or timer == 30
				or timer == 50
				or timer == 70
				or timer == 90	
					playSound(mo.battlen, sfx_lydchr)
					playSound(mo.battlen, sfx_fire1)
					localquake(mo.battlen, FRACUNIT*5, 10)
				end				
				
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_FLAME
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
					
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_FLAME
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_FLAME
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
			end		

			if timer >= 10 and timer < 100
				summonAura(target, SKINCOLOR_FLAME)
			end
			
			
			if timer == 10
			or timer == 30
			or timer == 50
			or timer == 70
			or timer == 90	
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_FLAME
					dust.scale = FRACUNIT*2
				end
			end	

			if timer == 101
				local hp = min(mo.hp - 1, (mo.maxhp*7)/10)
				damageObject(mo, hp, DMG_NORMAL, true)
				if C2SBarEdits and not target.enemy and charStats[target.stats].tpbar
					local tpheal = 75
					if charStats[target.stats].cpuse then tpheal = 150 end
					if target.tpspuse
						damageSP(target, -tpheal, nil, nil, charStats[target.stats].tpspuse)
					else
						damageSP(target, -tpheal)
					end
				else
					local tpheal = 36
					damageSP(target, -tpheal)
				end
                /*buffStat(target, "atk", 75)
				BTL_logMessage(targets[1].battlen, "Physical Attack up x3!")
				playSound(mo.battlen, sfx_buff)
				playSound(mo.battlen, sfx_hit2)
				playSound(mo.battlen, sfx_s2462)*/
			end
			
			if timer == 102
				for i = 1, 64
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_FLAME or SKINCOLOR_SALMON
					t.scale = FRACUNIT*1/2
				end
			end
			
			
			if timer == 125
				return true
			end
		end,
}

attackDefs["tr_s-tablet"] = {
		name = "S-Tablet",
		dekunda = true,	-- see above w/ dekaja
		type = ATK_SUPPORT,
		nometronome = true,
		norandom = true,		
		costtype = CST_SP,
		cost = 10,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TRAILS_ITEM"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,			
		desc = "Remove party debuffs",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_GOLD, SKINCOLOR_YELLOW, SKINCOLOR_LIME}
			local strs = {"atk", "mag", "def", "agi", "crit"}
			
			if timer == 20
				playSound(mo.battlen, sfx_curia)
			end

			for i = 1, #targets
				local target = targets[i]
				if timer == 20 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					for j = 1, #strs
						local t = targets[i]
						local s = strs[j]
						if t.buffs[s][1] < 0
							t.buffs[s][1] = 0
							t.buffs[s][2] = 0
						end
					end
					BTL_logMessage(targets[1].battlen, "Debuffs removed")
				end
			end
			if timer == TICRATE*3/2 + (#targets-1)*10
				return true
			end
		end,
}



attackDefs["tr_arcus_link"] = {
		name = "Arcus Link",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ARCUS"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
		end,				
		desc = "Form an Arcus Link with an ally to \nfollow-up eachother's physical attacks. \n100% Crit/Weak, 75% Tech,\n     50% Neutral, 25% Resist.",
		target = TGT_ALLY,
		nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
				local target = targets[n]
				if target == mo
					BTL_logMessage(targets[1].battlen, "Can't link with yourself.")
					return true
				end
				if target == mo.arcuslink
					BTL_logMessage(targets[1].battlen, "Already linked with "..target.name..".")
					return true
				end
			end,
		anim = function(mo, targets, hittargets, timer)
			local ally = hittargets[1]
			local time = timer
			if not mo.arcuslink and not ally.arcuslink and not mo.arcusanimskip
				mo.arcusanimskip = true
			end
			
			if mo.arcusanimskip
				time = $+45
			end
			for i = 1, #mo.enemies
				local foe = mo.enemies[i]
				if ally == foe then time = 100 end	--You shouldn't be able to do this anyway but just in case...
			end
			if ally == mo then time = 100 end	--dumbass bots I swear lmao.
			
			if time == 10	--break or swap old Arcus links.
				
				playSound(mo.battlen, sfx_arcusd)
				
				if mo.arcuslink --we'll start with our old partner
					for j = 1, 16
						local orb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_GOLD
					end
					
					for j = 1, 16
						local orb = P_SpawnMobj(mo.arcuslink.x, mo.arcuslink.y, mo.arcuslink.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_GOLD
					end
				end
			
				if ally.arcuslink --and then our new partner's old partner
					for j = 1, 16
						local orb = P_SpawnMobj(ally.x, ally.y, ally.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_CYAN
					end
					
					for j = 1, 16
						local orb = P_SpawnMobj(ally.arcuslink.x, ally.arcuslink.y, ally.arcuslink.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_CYAN
					end
				end
			
			elseif time == 55
			
				playSound(mo.battlen, sfx_arcusu)
				
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_GOLD
					dust.scale = FRACUNIT*2
				end
			
				for i = 1,16
					local dust = P_SpawnMobj(ally.x, ally.y, ally.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_GOLD
					dust.scale = FRACUNIT*2
				end
			
				if mo.arcuslink and ally.arcuslink
					for i = 1,16
						local dust = P_SpawnMobj(mo.arcuslink.x, mo.arcuslink.y, mo.arcuslink.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_CYAN
						dust.scale = FRACUNIT*2
					end
					
					for i = 1,16
						local dust = P_SpawnMobj(ally.arcuslink.x, ally.arcuslink.y, ally.arcuslink.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_CYAN
						dust.scale = FRACUNIT*2
					end
				end
			
			elseif time > 55 and time <= 85
			
				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_GOLD
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
					
					for i = 1,16

						local thok = P_SpawnMobj(ally.x+P_RandomRange(-70, 70)*FRACUNIT, ally.y+P_RandomRange(-70, 70)*FRACUNIT, ally.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_GOLD
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
						
					if mo.arcuslink and ally.arcuslink
						for i = 1,16

							local thok = P_SpawnMobj(mo.arcuslink.x+P_RandomRange(-70, 70)*FRACUNIT, mo.arcuslink.y+P_RandomRange(-70, 70)*FRACUNIT, mo.arcuslink.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_CYAN
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
						
						for i = 1,16

							local thok = P_SpawnMobj(ally.arcuslink.x+P_RandomRange(-70, 70)*FRACUNIT, ally.arcuslink.y+P_RandomRange(-70, 70)*FRACUNIT, ally.arcuslink.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_CYAN
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end
			
				end

				for i = 1, 8
					local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_GOLD
					thok.tics = P_RandomRange(10, 35)
				end
			
				for i = 1, 8
					local thok = P_SpawnMobj(ally.x+P_RandomRange(-70, 70)*FRACUNIT, ally.y+P_RandomRange(-70, 70)*FRACUNIT, ally.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_GOLD
					thok.tics = P_RandomRange(10, 35)
				end
			
				if mo.arcuslink and ally.arcuslink
					for i = 1, 8
						local thok = P_SpawnMobj(mo.arcuslink.x+P_RandomRange(-70, 70)*FRACUNIT, mo.arcuslink.y+P_RandomRange(-70, 70)*FRACUNIT, mo.arcuslink.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_CYAN
						thok.tics = P_RandomRange(10, 35)
					end
					
					for i = 1, 8
						local thok = P_SpawnMobj(ally.arcuslink.x+P_RandomRange(-70, 70)*FRACUNIT, ally.arcuslink.y+P_RandomRange(-70, 70)*FRACUNIT, ally.arcuslink.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_CYAN
						thok.tics = P_RandomRange(10, 35)
					end
				end
			
				if time == 85
					if mo.arcuslink and ally.arcuslink	--everyone has links!
						mo.arcuslink.arcuslink = ally.arcuslink
						ally.arcuslink.arcuslink = mo.arcuslink
					elseif mo.arcuslink and not ally.arcuslink --our partner wasn't previously linked
						mo.arcuslink.arcuslink = nil
					elseif not mo.arcuslink and ally.arcuslink --we weren't previously linked
						ally.arcuslink.arcuslink = nil
					end
					
					mo.arcuslink = ally
					ally.arcuslink = mo
				end
			elseif time == 100
				-- cheat the turnorder
				local btl = server.P_BattleStatus[mo.battlen]
				local i = #btl.turnorder +1
				while i > 1
					btl.turnorder[i] = btl.turnorder[i-1]
					i = $-1
				end
				
				tr_addSkill(mo, "tr_arcus_follow")
				btl.turnorder[2] = mo	-- we moved everyone back and gave ourselves an extra turn. :)
				mo.arcusanimskip = nil
				return true
			end
		end,
}

local tr_arcus = BTL_splitSkills
BTL_splitSkills = function(v)
	if v.arcuslink
		if v.passiveskills
			table.insert(v.passiveskills, "tr_arcus_follow")
		else
			table.insert(v.skills, "tr_arcus_follow")
		end
	end
	tr_arcus(v)
end

SRB2P_addHook("NextTurn", function(mo)
	if mo and mo.valid
		if mo.arcuslink
			tr_addSkill(mo, "tr_arcus_follow")
		else
			tr_removeSkill(mo, "tr_arcus_follow")
		end
		if mo.arcushit then mo.arcushit = nil end
		tr_removeSkill(mo, "tr_arcus_follow_2")
	end
end)

local function tr_arcusaura(mo, color)
	local dist = 12
	local angle = mo.angle+((leveltime%24)*15*ANG1)
	local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

	local aura = P_SpawnMobj(x, y, mo.z, MT_DUMMY)
	aura.state = S_AURA1
	--if not aura or not aura.valid continue end
	aura.angle = angle - ANGLE_90
	aura.color = color
	aura.frame = FF_FULLBRIGHT
	aura.blendmode = AST_ADD
	aura.renderflags = $|RF_FULLBRIGHT
	aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
	aura.scale = FRACUNIT/2
	aura.destscale = FRACUNIT*2
	P_InstaThrust(aura, angle, FRACUNIT/2)
end

local function getTP(mo, target)
	local btl = server.P_BattleStatus[mo.battlen]
	if mo.tpbar
	and not (mo.control and mo.control.bossselect) -- No.
		if target.damagestate ~= DMG_DRAIN
		and target.damagestate ~= DMG_BLOCK
		and target.damagestate ~= DMG_MISS
		and mo ~= target
		and mo.attack
		and not mo.attack.notpgain
		and (mo.attack.power and mo.attack.power > 0) -- no more aoa tp gain,,,
		and mo.attack.type ~= ATK_HEAL -- these can't exactly deal damage so
			local limit = ((mo.attack.physical and mo.weapon) and mo.weapon.atk) and 5*FixedSqrt(mo.weapon.atk/10) or 5*FixedSqrt(mo.attack.power)
			limit = max($/1000, 1)
			if mo.attack.hits and mo.attack.hits > 1 
				limit = max(1, $/mo.attack.hits) 
			end
			if mo.attack.tpboost
			and (mo.damagestate == DMG_WEAK
			or target.damagestate == DMG_TECHNICAL
			or target.damagestate == DMG_CRITICAL)
				dprint("TP Boost activated!")
				limit = $ + limit*mo.attack.tpboost/100
			end
			-- massive block of code incoming
			if isAttackPhysical(mo.attack) and not mo.attack.physical
				if mo.buffs["atk"][1]
					limit = $*(100+mo.buffs["atk"][1])/100 -- +/- 25%*amount of buffs
				end
				if mo.powercharge 
					limit = $*5/2 -- x2.5
				end
			else
				if mo.attack.costtype == CST_SP
				or mo.attack.costtype == CST_SPPERCENT
					if mo.buffs["mag"][1]
						limit = $*(100+mo.buffs["mag"][1])/100 -- +/- 25%*amount of buffs
					end
					if mo.mindcharge 
						limit = $*5/2 -- x2.5
					end
				else -- our skill must either cost ep or a custom thing, use the higher of the two stats
					if mo.strength > mo.magic
						if mo.buffs["atk"][1]
							limit = $*(100+mo.buffs["atk"][1])/100 -- +/- 25%*amount of buffs
						end
						if mo.powercharge 
							limit = $*5/2 -- x2.5
						end
					elseif mo.magic > mo.strength
						if mo.buffs["mag"][1]
							limit = $*(100+mo.buffs["mag"][1])/100 -- +/- 25%*amount of buffs
						end
						if mo.mindcharge 
							limit = $*5/2 -- x2.5
						end
					elseif mo.strength == mo.magic -- what have you wrought
						local strs = {"atk", "mag"}
						for i = 1, #strs
							local s = strs[i]
							if mo.buffs[s][1]
								limit = $*(mo.buffs[s][1])/100 -- +/- 25%*amount of buffs
							end
						end
						if mo.powercharge or mo.mindcharge
							if mo.powercharge and mo.mindcharge
								limit = $*5 -- christ almighty
							else
								limit = $*5/2 -- x2.5
							end
						end
					end
				end
			end
			-- ok it's over
			if target.damagestate == DMG_CRITICAL
			or target.damagestate == DMG_TECHNICAL
			or target.damagestate == DMG_WEAK
				limit = $*125/100
			end
			if target.damagestate == DMG_RESIST
				limit = max(1, $/3)
			end
			if mo.attack.instakill
				limit = $*3 -- we landed an instakill, give us hella tp
			end
			if mo.attack.target == TGT_ALLENEMIES
				limit = $/#mo.enemies
			elseif mo.attack.target == TGT_ALLALLIES
			and mo.allies -- weird flex but ok
				limit = $/#mo.allies
			elseif mo.attack.target == TGT_EVERYONE
				limit = $/#btl.fighters
			end
			if mo.status_condition and mo.status_condition == COND_DESPAIR
				limit = $/2 -- halve tp gain when inflicted with despair
			end
			--local randnum = P_RandomRange(-2, 2)
			--limit = $+randnum -- have a little bit of randomization in there
			limit = max(1, $) -- just in case
			mo.cptpfill = limit
		end
	end
end

local function tr_arcuslink(mo)
	if not mo or not mo.valid return end
	local btl = server.P_BattleStatus[mo.battlen]
	if btl and btl.running --only in battle
		if mo.attack and (mo.attack.target == TGT_ALLY)	--see our selected friend's links
			local tgt = mo.targets[mo.t_target] or mo.targets[1]
			if tgt and tgt ~= mo and tgt.arcuslink
				tr_arcusaura(tgt, SKINCOLOR_BLUE)
				tr_arcusaura(tgt.arcuslink, SKINCOLOR_BLUE)
			end
		end
		if mo.arcuslink	--we are linked!
			if btl.turnorder[1] == mo and btl.battlestate == BS_DOTURN	--see who we're linked with on our turn.
				tr_arcusaura(mo, SKINCOLOR_ORANGE)
				tr_arcusaura(mo.arcuslink, SKINCOLOR_ORANGE)
				for i = 1, #mo.allies
					local ally = mo.allies[i]
				end
			end
			if btl.battlestate == BS_DOTURN
				if not mo.hp and not mo.tr_arcussound	--ah bugger!
					playSound(mo.battlen, sfx_arcusb)
					for j = 1, 16
						local orb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_GOLD
					end
						
					for j = 1, 16
						local orb = P_SpawnMobj(mo.arcuslink.x, mo.arcuslink.y, mo.arcuslink.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_GOLD
					end
					--mo.arcuslink.arcuslink = nil
					--mo.arcuslink = nil
					mo.tr_arcussound = true	--we'll play it once without actually breaking the link
				elseif mo.hp and mo.hp > 0 and mo.tr_arcussound
					mo.tr_arcussound = nil	--ok we're not dead anymore!
				end
			end
			if btl.battlestate == BS_LINK
				if mo.arcushit	--Arcus Link follow-up
				and mo.arcushit.linkstate
				and mo.arcushit.linkstate.dmg
				and mo.arcushit.linkstate.dmg == 1	--forced link queing
					mo.arcuslink.attack = mo.arcuslink.melee and attackDefs[mo.arcuslink.melee] or attackDefs["slash_1"]
				end
				if mo.arcuscounter	--Arcus Link follow-up
				and mo.arcuscounter.linkstate
				and mo.arcuscounter.linkstate.dmg
				and mo.arcuscounter.linkstate.dmg == 1	--forced link queing
					mo.attack = mo.melee and attackDefs[mo.melee] or attackDefs["slash_1"]
				end
			end
			if btl.battlestate == BS_PRETURN
				mo.arcushit = nil
				mo.arcuscounter = nil
			end
		end
	end
end

addHook("MobjThinker", tr_arcuslink, MT_PFIGHTER)


attackDefs["tr_arcus_follow"] = { -- Code adapted from C2S Variety Pack
		name = "Arcus Follow-Up",
		type = ATK_PASSIVE,
		desc = "Follow-up melee attack for Arcus Links.",
		passive = PSV_ONDAMAGE,
		norandom = true,
		norogue = true,
		anim = function(mo, target)
			local btl = server.P_BattleStatus[mo.battlen]
			local ally = false
			for i = 1, #mo.allies
				if mo.allies[i] == target then ally = true end
			end
			--make sure we don't follow-up on someone who is GOING to die.
			local damage = 0
			if btl.dmg_hits and target.dmg_index and btl.dmg_hits[target.dmg_index] and #btl.dmg_hits[target.dmg_index]
				for i = 1, #btl.dmg_hits[target.dmg_index]
					if btl.dmg_hits[target.dmg_index][i] ~= "miss"
						damage = $+btl.dmg_hits[target.dmg_index][i]
					end
				end
			end
			dprint("Attempting Follow-Up...")
			if mo.hp and target.hp and target.hp > damage and mo ~= target and mo.attack and not mo.attack.scraft
			and (target.damagestate == DMG_WEAK or target.damagestate == DMG_CRITICAL	--Guaranteed on WEAK and CRIT
			or (target.damagestate == DMG_TECHNICAL and P_RandomRange(1, 4) > 1)	--75% on TECH
			or (target.damagestate == DMG_NORMAL and P_RandomRange(1, 4) > 2)	--50% on NORMAL
			or (target.damagestate == DMG_RESIST and P_RandomRange(1, 4) > 3))	--25% on RESIST
			and mo.attack ~= attackDefs["all_out"]	--bruh
			and not (target.damagestate == DMG_BLOCK or target.damagestate == DMG_REPEL or target.damagestate == DMG_DRAIN)
			and (isAttackPhysical(mo.attack) or mo.attack.forcetp)	--must be a physical attack, or a magic weapon attack, or a craft.
			and mo.arcuslink and mo.arcuslink.hp and not mo.arcuslink.down
			and not (mo.arcuslink.status_condition == COND_SHOCK or mo.arcuslink.status_condition == COND_SLEEP)
			and btl.battlestate == BS_ACTION
			and not mo.arcushit --only one Arcus Link hit.
			and (mo.attack.type ~= ATK_HEAL and mo.attack.type ~= ATK_SUPPORT) -- DON'T HIT OUR FRIENDS
			and not ally
				if mo.arcuslink.weapon and mo.arcuslink.weapon.ref
					local wep = weaponsList[mo.arcuslink.weapon.ref]
					if wep.melee and wep.melee ~= mo.arcuslink.melee
						mo.arcuslink.melee = wep.melee
					end
				end
				local dmgstate = target.damagestate
				
				mo.arcuslink.attack = mo.arcuslink.melee and attackDefs[mo.arcuslink.melee] or attackDefs["slash_1"]
				local enmaff = getAttackAff(target, mo.arcuslink.attack, mo.arcuslink)
				
				if mo.arcuslink.attack.target == TGT_ALLENEMIES or mo.arcuslink.attack.target == TGT_ENEMY	--your melee is an attack, RIGHT?
				and enmaff ~= DMG_BLOCK and enmaff ~= DMG_REPEL and enmaff ~= DMG_DRAIN	--no point
					dprint("Follow-Up success! striking with "..mo.arcuslink.attack.name)
					
					playSound(mo.battlen, sfx_arcusl)
					VFX_Play(mo.arcuslink, VFX_SUMMON)
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = SKINCOLOR_WHITE
					end
					
					--local gottendmg = getDamage(target, mo.arcuslink)
					--getTP(mo.arcuslink, target)
					mo.arcuslink.attack = nil
					if target.linkstate
						if not target.saved_counterlinkhits
							target.saved_counterlinkhits = {}
						end
						target.saved_counterlinkhits[#target.saved_counterlinkhits + 1] = copyTable(target.linkstate)
					end
					
					target.linkstate = {
						link = 0,
						maxlink = 1,
						linkboost = 0,
						atkref = mo.arcuslink.melee or attackDefs["slash_1"],
						entref = mo.arcuslink,
						dmg = 1,
						arcus = true,
					}
					btl.linkhits[#btl.linkhits+1] = target
					
					mo.arcushit = target
					tr_addSkill(mo.arcuslink, "tr_arcus_follow_2")
				end
			end
			if mo.attack == attackDefs["all_out"] and mo.arcushit
			and mo.arcushit == target and (btl.linkhits and #btl.linkhits)
				--check link hits
				local index = 0
				for i = 1, #btl.linkhits
					if btl.linkhits[i] == target then index = i end
				end
				if index > 0 then table.remove(btl.linkhits, index) end
				--check qued linkstates
				if target.saved_counterlinkhits and #target.saved_counterlinkhits
					local index = 0
					for i = 1, #target.saved_counterlinkhits
						if target.saved_counterlinkhits[i].entref == mo.arcuslink
						and target.saved_counterlinkhits[i].atkref == (mo.arcuslink.melee or attackDefs["slash_1"])
							index = i
						end
					end
					if index > 0 then table.remove(target.saved_counterlinkhits, index) end
				end
				--check linkstates
				if target.linkstate and target.linkstate.entref == mo.arcuslink
				and target.linkstate.atkref == (mo.arcuslink.melee or attackDefs["slash_1"])
					target.linkstate = nil
				end
				
				BTL_logMessage(mo.battlen, "Arcus follow-up cancelled.")
			end
		end,
	}

attackDefs["tr_arcus_counter"] = { -- Code adapted from C2S Variety Pack
		name = "Arcus Counter",
		type = ATK_PASSIVE,
		desc = "50% chance to counter a missed \nphysical attack with your own \nnormal attack.",
		passive = PSV_ONDAMAGE_RECEIVED,
		norandom = true,
		norogue = true,
		anim = function(mo, attacker)
			local btl = server.P_BattleStatus[mo.battlen]
			for i = 1, #mo.allies
				local ally = mo.allies[i]
			end
			dprint("Attempting Counter Attack...")
			if mo.hp and mo ~= attacker
			and attacker.attack
			and (mo.damagestate == DMG_MISS and P_RandomRange(1, 4) > 2)	--50% on MISS
			and isAttackPhysical(attacker.attack)	--must be a physical attack, or a magic weapon attack.
			and btl.battlestate == BS_ACTION
			and not (mo.status_condition == COND_SHOCK or mo.status_condition == COND_SLEEP)
			and not mo.arcuscounter --we only counter them once per attack.
			--and target.redhp and target.redhp > target.hp --we very clearly did NOT take damage (it's a MISS)
			and (attacker ~= ally and (attacker.attack.type ~= ATK_HEAL and attacker.attack.type ~= ATK_SUPPORT)) -- DON'T HIT OUR FRIENDS
				if mo.weapon and mo.weapon.ref
					local wep = weaponsList[mo.weapon.ref]
					if wep.melee and wep.melee ~= mo.melee
						mo.melee = wep.melee
					end
				end
				mo.attack = mo.melee and attackDefs[mo.melee] or attackDefs["slash_1"]
				local enmaff = getAttackAff(attacker, mo.attack, mo)
				
				if mo.attack.target == TGT_ALLENEMIES or mo.attack.target == TGT_ENEMY	--your melee is an attack, RIGHT?
				and enmaff ~= DMG_BLOCK and enmaff ~= DMG_REPEL and enmaff ~= DMG_DRAIN	--no point
					dprint("Counter Attack success! striking with "..mo.attack.name)
					
					VFX_Play(mo, VFX_SUMMON)
					mo.attack = nil
					mo.setonemore = nil
					if attacker.linkstate
						if not attacker.saved_counterlinkhits
							attacker.saved_counterlinkhits = {}
						end
						attacker.saved_counterlinkhits[#attacker.saved_counterlinkhits + 1] = copyTable(attacker.linkstate)
					end
					attacker.linkstate = {
						link = 0,
						maxlink = 1,
						linkboost = 0,
						atkref = mo.melee or attackDefs["slash_1"],
						entref = mo,
						dmg = 1,	--the handler override will take care of this
						arcus = true,
					}
					btl.linkhits[#btl.linkhits+1] = attacker
					mo.arcuscounter = attacker
					tr_addSkill(mo, "tr_arcus_follow_2")
				end
			end
		end,
	}


attackDefs["tr_arcus_follow_2"] = { -- linkstate safety
		name = "Arcus Follow-Up pt2",
		type = ATK_PASSIVE,
		desc = "Arcus Link Follow-Up attack \nlinkstate safety.",
		passive = PSV_ONDAMAGE,
		norandom = true,
		norogue = true,
		anim = function(mo, target)
			local btl = server.P_BattleStatus[mo.battlen]
			if btl.battlestate == BS_LINK
				dprint(mo.name.." struck!")
				dprint("Reverting enemy Link State.")
				if mo.cptpfill and mo.cptpfill > 0
					if mo.tpspuse
						mo.tp = $+(mo.cptpfill+P_RandomRange(-2, 2))
						if mo.tp > mo.maxtp then mo.tp = mo.maxtp end
					else
						mo.sp = $+(mo.cptpfill+P_RandomRange(-2, 2))
						if mo.sp > mo.maxsp then mo.sp = mo.maxsp end
					end
				end
				if btl.turnorder[1] == target and not target.hp --prevent turn skiping from this...
					local btl = server.P_BattleStatus[mo.battlen]
					local turnstuff = #btl.turnorder + 1
					while turnstuff > 1
						btl.turnorder[turnstuff] = btl.turnorder[turnstuff - 1]
						turnstuff = $ - 1
					end
					btl.turnorder[2] = btl.turnorder[3]
					target.saved_counterlinkhits = nil
				end
			end
		end,
	}



local BTL_linkHandler_ORIG = BTL_linkHandler
rawset(_G, "BTL_linkHandler", function(pn)
	local btl = server.P_BattleStatus[pn]
		
	-- do all links one by one.
	if #btl.linkhits

		local mo = btl.linkhits[1]
		
		if not (mo and mo.valid)
			table.remove(btl.linkhits, 1)
			return
		end
		
		if not mo.linkstate.arcus
			return BTL_linkHandler_ORIG(pn)
		end
		
		if not btl.dmg_hits
			dprint("Link Handle override!")

			if not mo.hp	-- happens if a link skill killed an enemy.
			or (mo.enemy and not mo.deathanim and enemyList[mo.enemy].deathanim)	-- Very funny bug that CAN actually happen.
			-- This happens with Monad final boss where the Link can happen during the cutscene because of that, it's really stupid
			or (mo.linkstate and (not mo.linkstate.entref or not mo.linkstate.entref.valid))	-- entity that cast the link has been removed somehow.

				table.remove(btl.linkhits, 1)
				return
			end

			btl.atktimer = 0
			btl.dmg_actor = mo.linkstate.entref

			mo.dmg_index = 1
			mo.atk_attacker = btl.dmg_actor
			mo.atk_hitby = BTL_copyAttackDefs(attackDefs[mo.linkstate.atkref])
			resetDamage(mo)

			btl.dmg_hits = {}	-- damage taken
			btl.dmg_downs = {}	-- damage knockdown	(won't happen here but needs resetting anyway)
			
			btl.dmg_hits[1] = {}	-- damage taken
			btl.dmg_downs[1] = {}	-- damage knockdown	(won't happen here but needs resetting anyway)
			-- link damage (base dmg + linkboost% * added links per new link)
			
			for i = 1, mo.atk_hitby.hits or 1
				
				-- link damage (base dmg + linkboost% * added links per new link)
				--local linkdamage = mo.linkstate.dmg + (mo.linkstate.dmg*mo.linkstate.linkboost/100)*mo.linkstate.link
				-- Arcus Follow-ups are supposed to CRIT and TECH, unlike normal link attacks
				mo.atk_attacker.attack = mo.atk_attacker.melee and attackDefs[mo.atk_attacker.melee] or attackDefs["slash_1"]
				
				btl.dmg_hits[1][i], btl.dmg_downs[1][i] = getDamage(mo, mo.atk_attacker)
				getTP(mo.atk_attacker, mo)
				
				dprint("Arcus Follow-Up: "..btl.dmg_hits[1][i].." Damage.")
				
				/*
				if btl.dmg_downs[1][i]	--For some reason, it's just not giving a onemore without this.
				--and not mo.down
				--and not (mo.allies == mo.allies)	-- don't onemore if we hit a teammate or ourselves
				--and not mo.boss
				--and mo.status_condition ~= COND_HYPER
				--and not (technical and not tech_downchance)	--this is at least already checked for.
				--and not mo.guard
					dprint("Arcus Follow-Up downs foe!")
					--mo.atk_attacker.setonemore = nil
					if not mo.down then dprint("Foe was standing.") end
					if not mo.boss then dprint("Foe is not boss.") end
					if mo.status_condition ~= COND_HYPER then dprint("Foe is not hyper.") end
					if not mo.guard then dprint("Foe was not guarding.") end
					mo.atk_attacker.arcuslink.setonemore = true
				end
				*/
				if mo.atk_attacker.setonemore
					mo.atk_attacker.setonemore = nil
					mo.atk_attacker.arcuslink.setonemore = true
				end
			end
			
			dprint("Registered "..#btl.dmg_downs[1].." hits.")
			BTL_logMessage(pn, mo.atk_hitby.name)
		end

		-- now use the skill
		btl.atktimer = $+1
		--print(btl.atktimer)

		if attackDefs[mo.linkstate.atkref].anim(mo.atk_attacker, {mo}, {mo}, btl.atktimer)
			mo.atk_attacker.t_forcecontrol = nil
			mo.atk_attacker.t_summoned = nil
			btl.dmg_hits = nil	-- we don't need those anymore, to the trash, boo!
			btl.dmg_downs = nil
			btl.dmg_actor = nil
			btl.dmg_usecritanim = nil
			btl.atktimer = 0
			local cam = btl.cam
			cam.tp_en = nil
			cam.tp_en2 = nil	-- don't use those during attack anims, it might not go well
			cam.plyranim = nil
			cam.done = nil

			-- increase links and remove linkstate if need be:
			mo.linkstate.link = $+1
			if mo.linkstate.link >= mo.linkstate.maxlink
				mo.linkstate = nil
			end

			table.remove(btl.linkhits, 1)
		end
	else	-- no more link hits to do
		return true
	end
end)

battlefunchandler ={
	[BS_START] 		=	{BTL_startHandler, 		BS_PRETURN},
	[BS_PRETURN] 	=	{BTL_preturnHandler, 	BS_DOTURN},
	[BS_DOTURN]		=	{BTL_turnHandler,		BS_ACTION},
	[BS_ACTION]		=	{BTL_actionHandler,		BS_ENDTURN},
	[BS_ENDTURN]	=	{BTL_endturnHandler,	nil},
	[BS_HOLDUP]		=	{BTL_holdupHandler,		nil},
	[BS_SHUFFLE]	=	{BTL_shuffleHandler,	nil},
	[BS_END]		=	{BTL_endHandler,		nil},
	[BS_LEVELUP]	=	{BTL_levelUpHandler,	nil},
	[BS_FINISH] 	=	{BTL_finish,			nil},
	[BS_MPFINISH]	=	{BTL_MPfinish,			nil},
	[BS_HYPERDIE]	=	{BTL_HyperDie,			nil},
	[BS_GAMEOVER]	=	{BTL_gameOver,			nil},
	[BS_PVPOVER]	=	{BTL_pvpOver,			nil},
	[BS_MOREENEMIES]=	{BTL_moreEnemiesHandler,nil},
	[BS_CHALLENGEEND]=	{BTL_challengeEndHandler,	nil},
	[BS_LINK] = 		{BTL_linkHandler, 		BS_ENDTURN},
}	--need to override through this or it runs the original anyway.


if not SafeLinkOverride	--[Catcocomics]: "Avenge didn't need this, but since we can't directly modify EVERY melee attackdef
						--specifically for this one thing, we pretty much need something like this. It shouldn't interefere
						--with skills that are actually meant for forced link attack overrides, though.

rawset(_G, "SafeLinkOverride", true)

	
local function tr_linksafety(mo)
	if not mo or not mo.valid return end
	local btl = server.P_BattleStatus[mo.battlen]
	if btl and btl.running --only in battle
		if not mo.linkstate and mo.saved_counterlinkhits and #mo.saved_counterlinkhits
			mo.linkstate = copyTable(mo.saved_counterlinkhits[#mo.saved_counterlinkhits])
			table.remove(mo.saved_counterlinkhits, #mo.saved_counterlinkhits)
			mo.linkstate.link = $-1 --fuck off...
			if not #mo.saved_counterlinkhits
				mo.saved_counterlinkhits = nil
			end
		end
	end
end

addHook("MobjThinker", tr_linksafety, MT_PFIGHTER)

end
