if not srb2p return end

local PREV_splitSkills = BTL_splitSkills
BTL_splitSkills = function(v)
    if v.impassiontimer
        table.insert(v.skills, "impassion_thinker")
        table.insert(v.skills, "impassion_reset")
    end
    
    PREV_splitSkills(v)
end

DNG_Abilities["tita"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.drawangle = mo.angle
					P_SetObjectMomZ(mo, FRACUNIT*10)
					local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					t.color = mo.color
					P_InstaThrust(mo,mo.angle,(32*FRACUNIT)/*(mo.scale)*/)
					S_StartSound(p.mo,sfx_spdpad)
				end,

		func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if not P_IsObjectOnGround(mo)
							if (leveltime%3)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							mo.p_abl = false
						end
					end
				end,
}

freeslot("SPR_BOOM", "SPR_SATB", "SPR_SATE", "sfx_tisho", "sfx_tiexp", "sfx_tiok", 
 "sfx_smocn", "sfx_darmat", "sfx_clokup", "sfx_chrdrv", "sfx_satpc", "SPR_MOCR", 
 "sfx_cremir", "sfx_areflx", "sfx_7thcal", "sfx_vitcan", "sfx_impaso","sfx_canimp", "sfx_tievy")

charStats["tita"] = {

		-- GENERAL

		name = "Tita",			-- This is only for bots / enemies
		basehp = 48,			-- base HP for level 1
		basesp = 59,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		--cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		tpmode = "craft points",
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_cannon_impulse_c", 1, 1}, {"tr_cannon_impulse_c2", 30, 1}, {"tr_satbeam_c", 60, 2}, {"tr_cannon_impulse_cf", 75, 1}, {"tr_satbeam_c2", 90, 2},
		},
		
		persona = "titaskillset",
		--persona_pvp = "titapvpset",
		melee_natk = "tr_explosion",	-- normal melee attack
		--melee_satk = "satbeam",

		supercolor_start = SKINCOLOR_SUPERTITA1,
		
		wep = "tr_p-03",		-- default weapon.
		weptype = WPT_GENERICRANGED,	-- Equippable weapon type(s)

		atk = 50,
		acc = 85,
		crit = 1,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,S,S,T,U,V,W,W,W, 4, "SPR2_TAL1"}, //108 Frames, a note for da stoopid Zoraxua
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_ROLL"},	
		anim_special3 =		{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, L, L, L, M, M, M, M, M, M, M, M, M, M, M, M, 4, "SPR2_TAL2"}, --gun comes out, fires. (64+ frames)
		anim_special4 =		{SPR_PLAY, N, 4, "SPR2_TAL2"},	--gun side-view
		anim_special5 =		{SPR_PLAY, O, 4, "SPR2_TAL2"},	--gun diagonal-view
		anim_special6 =		{SPR_PLAY, M, M, M, L, K, J, I, H, H, H, H, H, 4, "SPR2_TAL2"},	--gun stops (32+ frames)
		
		vfx_summon = {"sfx_tismn1", "sfx_tismn2", "sfx_tismn3", "sfx_tismn4"},
		vfx_skill = {"sfx_tiskl1", "sfx_tiskl2", "sfx_tiskl3", "sfx_tiskl4"},
		vfx_item = {"sfx_tidog1"}, 
		vfx_hurt = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_hurtx = {"sfx_tixht"},
		vfx_die = {"sfx_tirip1", "sfx_tirip2"},
		vfx_heal = {"sfx_tihel1", "sfx_tihel2"},
		vfx_healself = {"sfx_tihel2"},
		vfx_kill = {"sfx_tikil1", "sfx_tikil2"},
		vfx_1more = {"sfx_ti1mo", "sfx_ti1mo2"},
		vfx_crit = {"sfx_ticrt1", "sfx_ticrt2", "sfx_ticrt3", "sfx_ticrt4"},
		vfx_aoaask = {"sfx_tiaoi1", "sfx_tiaoi2"},
		vfx_aoado = {"sfx_tiaoa1", "sfx_tiaoa2", "sfx_tiaoa3", "sfx_tiaoa4"},
		vfx_aoarelent = {"sfx_timis1", "sfx_timis2"},
		vfx_miss = {"sfx_timis1", "sfx_timis2", "sfx_timis3"},
		vfx_dodge = {"sfx_tidog1", "sfx_tidog2"},
		vfx_win = {"sfx_tiwin1", "sfx_tiwin2", "sfx_tiwin3", "sfx_tiwin4"},
		vfx_levelup = {"sfx_tilevl"},
		vfx_tartarus_pit = {"sfx_tirip2"},
		vfx_tartarus_item = {"sfx_esjoti"},
		vfx_tartarus_spring = {"sfx_tispng"},
		vfx_tartarus_spike = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_tartarus_critspike = {"sfx_tixht"},
		vfx_tartarus_spikepit = {"sfx_tixht"},

		icon = "H_TITICO",	-- icon for net select and other menus
		hudbust = "H_TITBAR",			-- patch to draw on the stat hud
		hudaoa = "H_TITAOA",	-- patch for all out attack hud
		hudcutin = "TITA_A",	-- cut in
		hudscutin = "SITA_A",	-- super cut in
		aoa_quote = "P-Prepare to meet\nyour doom!",

		tip = "A young engineer from Zeiss Central Factory, equipped with an orbal cannon and a wide variety of Orbal arts. Particularly focused on using Space arts (nuke damage) and supporting allies."
}
	
VFX_freeslotC("tita")
	
personaList["titaskillset"] = {
		-- GENERAL
		name = "Tita",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = {SPR_NULL, A, 8},
		anim_atk = {SPR_NULL, A, 8},
		startframe = 0,

		strength = 4,
		magic = 9,
		endurance = 7,
		luck = 6,
		agility = 6,
		stab = ATK_NUCLEAR,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,
		skills = C2SBarEdits and {
					
							{"tr_photon shoot", 1}, {"tr_crest", 4},
							{"tr_smokecannon_c", 10}, {"tr_dark matter II", 13},
							{"tr_impassion", 16}, {"tr_dark matter", 20},
							{"tr_vital cannon_c", 23}, {"tr_a_reflex", 26},
							
							{"nuke boost", 30, "tr_photon shoot"},
							{"tr_golden halo", 34, "tr_dark matter II"}, 
							{"tr_a_crest", 38, "tr_crest"},
							{"tr_smokecannon_c2", 39, "tr_smokecannon_c"},
							{"tr_vital cannon_c2", 44, "tr_vital cannon_c"},
							{"tr_dark matter EX", 50, "tr_dark matter"}, {"tr_genesic_barrier", 55, "tr_a_reflex"},
							
							{"nuke amp", 59, "nuke boost"}, {"tr_fortuna", 64, "tr_a_crest"},
							{"tr_altair cannon", 69, "tr_golden halo"}, 
							{"tr_vital cannon_c3", 76, "tr_vital cannon_c2"},
							{"tr_crescent mirror", 80, "tr_genesic_barrier"},
				},
}
/*
personaList["titapvpset"] = {
		-- GENERAL
		name = "Tita",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = {SPR_NULL, A, 8},
		anim_atk = {SPR_NULL, A, 8},
		startframe = 0,

		strength = 4,
		magic = 9,
		endurance = 7,
		luck = 6,
		agility = 6,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,
		skills = C2SBarEdits and {
					
							{"tr_photon shoot", 1}, {"tr_clock_up", 4},
							{"tr_smokecannon_c", 10}, {"tr_golden sphere", 13},
							{"tr_impassion", 16}, {"tr_photon shoot II", 20},
							{"tr_vital cannon_c", 23}, {"tr_a_reflex", 26},
							{"nuke boost", 30, "tr_photon shoot"},
							{"tr_lost_mobius", 34, "tr_golden sphere"}, 
							{"tr_chrono_drive", 38, "tr_clock_up"},
							{"tr_smokecannon_c2", 39, "tr_smokecannon_c"},
							{"tr_vital cannon_c2", 44, "tr_vital cannon_c"},
							{"tr_last_disaster", 50, "tr_photon shoot II"}, 
							{"nuke amp", 54, "nuke boost"}, 
							{"tr_crescent mirror", 59, "tr_a_reflex"},
							{"tr_dark matter EX", 64, "tr_lost_mobius"}, 
							{"tr_vital cannon_c3", 67, "tr_vital cannon_c2"},
							--{"tr_seventh caliber", 75, "tr_last_disaster"},
				},
}
*/

-- Melee Attack


attackDefs["tr_explosion"] = {
		name = "Cannon Shot",
		type = ATK_STRIKE,
		power = 60,
		accuracy = 85,
		costtype = CST_HPPERCENT,
		cost = 0,
		tr_castarea = 4,
		desc = "Cause an explosion around\nyour general vicinity (Area M).",
		physical = true,
		nometronome = true,
		norandom = true,
		norogue = true,			
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				if timer == 10
					if mo.skin == "tita"
						ANIM_set(mo, mo.anim_special2, true)
						playSound(mo.battlen, sfx_tisho)
					end	
				end
					
				if timer == 25
					if mo.skin == "tita"
						ANIM_set(mo, mo.anim_stand, true)
					end	
				end					
				if timer == 10
					mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)

						local z = mo.z
						local hit = P_SpawnMobj(avgx & (64*FRACUNIT -1), avgy & (64*FRACUNIT -1), mo.z, MT_NULL)
						hit.tics = 55

						local dist = P_AproxDistance(avgx - mo.x, avgy - mo.y)
						local horizontal = dist / 55
						local vertical = FixedMul((gravity*90)/2, mo.scale)
						
						local bruh = P_SpawnMobj(mo.x,mo.y,mo.z,MT_FBOMB)
						
						bruh.momx = FixedMul(horizontal, cos(mo.angle))
						bruh.momy = FixedMul(horizontal, sin(mo.angle))
						bruh.momz = vertical
						bruh.scale = FRACUNIT*2
				end
				
				if timer == 45
					playSound(mo.battlen, sfx_tiexp)
					for k,v in ipairs(hittargets)
						damageObject(v)
					end
				end
				if timer == 72
					return true
				end
		end,
}	

-- Crafts--

--In the Sky FC (lvl 1 - lvl 50)

--Sky FC Initial
attackDefs["tr_smokecannon"] = {
		name = "Smoke Cannon",
		type = ATK_STRIKE,
		power = 30,
		accuracy = 90,
		statuschance = 60,
		status = COND_DIZZY,
		costtype = CST_SP,
		--luckbased = true,	-- use luck instead of agility
		cost = 6,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
		end,
		tr_castarea = 4,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Shoots enemies with a smoke \nround for Miniscule Strike Damage, \nHigh chance of Dizzy (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 10
				ANIM_set(mo, mo.anim_special2, true)
				playSound(mo.battlen, sfx_tisho)
			end
				
			if timer == 25
				ANIM_set(mo, mo.anim_stand, true)
			end				
			

			if timer == 30
				local boom = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
                boom.scale = FRACUNIT*5
				boom.colorized = true
				boom.color = SKINCOLOR_JET
                boom.state = S_FBOMB_EXPL1
			end
			if timer == 40
				local sm = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				sm.fuse = TICRATE
			end
			
			if #hittargets > 0	--In case we select nothing
				for k,v in ipairs(hittargets)
					if timer == 41
						damageObject(v)
					end	
				end
			end
				
			if timer == 55 
				return true
			end
			if timer == 30
				playSound(mo.battlen, sfx_smocn)
			end
		end,
}

--Sky FC level 23
attackDefs["tr_vital cannon"] = {
        name = "Vital Cannon",
        type = ATK_HEAL,
        costtype = CST_SP,
        cost = 12,
        power = 100,
		tr_castarea = 4,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AQUA))
		end,
        desc = "Loads a bullet that\nHeals 100 HP (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
        target = TGT_ALLALLIES,
        anim = function(mo, targets, hittargets, timer)
            local colors = {SKINCOLOR_CYAN}
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 10
				ANIM_set(mo, mo.anim_special2, true)
				playSound(mo.battlen, sfx_tisho)
			end
				
			if timer == 25
				ANIM_set(mo, mo.anim_stand, true)
			end	
			
			
			if timer == 30
				local bs = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
				bs.state = S_SEVENBOOM1
				bs.colorized = true
				bs.color = SKINCOLOR_SAPPHIRE
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				playSound(mo.battlen, sfx_vitcan)
				S_StartSoundAtVolume(nil,sfx_vitcan,70)
			end				
				
			if timer == 31
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(avgx, avgy, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_SUPERSPARK)
					ba.state, ba.scale = S_SSPK1, FRACUNIT*6/4
					ba.colorized = true
					ba.color = SKINCOLOR_SAPPHIRE
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(avgx, avgy, mo.z, MT_SUPERSPARK)
					bb.state, bb.scale = S_SSPK1, FRACUNIT*8/4
					bb.colorized = true
					bb.color = SKINCOLOR_SAPPHIRE
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i
					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_COINSPARKLE1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_SAPPHIRE			
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
			
            if timer == 50
                playSound(mo.battlen, sfx_lsheal)
            end
			if #targets > 0	--In case we select nothing
				for i = 1, #targets
					local target = targets[i]
					if timer == 50 + (i-1)*3
							--local heals = P_RandomRange(150, 160)
							damageObject(target, -100)
						for j = 1, 16
							local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							orb.momx = P_RandomRange(-16, 16)<<FRACBITS
							orb.momy = P_RandomRange(-16, 16)<<FRACBITS
							orb.momz = P_RandomRange(-16, 16)<<FRACBITS
							orb.destscale = 0
							orb.tics = 20
							orb.frame = A
							orb.color = colors[P_RandomRange(1, #colors)]
							
						end    
					end
				end
			end

            if timer == 75 + (#targets-1)*5
                return true
            end
        end,
}

--In the Sky SC (lvl 50 - lvl 100)

--Sky SC level 48
attackDefs["tr_smokecannon_2"] = {
		name = "Smoke Cannon 2",
		type = ATK_STRIKE,
		power = 90,
		accuracy = 90,
		statuschance = 60,
		status = COND_DIZZY,
		costtype = CST_SP,
		--luckbased = true,	-- use luck instead of agility
		cost = 12,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
		end,
		tr_castarea = 4,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Shoots enemies with a smoke \nround for Light Strike Damage, \nHigh chance of Dizzy (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 25
				ANIM_set(mo, mo.anim_stand, true)
			end				
			

			if timer == 30
				local boom = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
                boom.scale = FRACUNIT*5
				boom.colorized = true
				boom.color = SKINCOLOR_JET
                boom.state = S_FBOMB_EXPL1
			end
			if timer == 40
				local sm = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				sm.fuse = TICRATE
			end
			
			if #hittargets > 0	--In case we select nothing
				for k,v in ipairs(hittargets)
					if timer == 41
						damageObject(v)
					end	
				end
			end
			
			if timer == 55 
				return true
			end
			if timer == 30
				playSound(mo.battlen, sfx_smocn)
			end
		end,
}

--Sky SC level 63
attackDefs["tr_vital cannon_2"] = {
		name = "Vital Cannon 2",
		dekunda = true,
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 30,
		power= 350,
		tr_castarea = 4,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AQUA))
		end,
        desc = "Loads a bullet that Heals 350 HP \nand clears status and debuffs. (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_CYAN}
			local strs = {"atk", "mag", "def", "agi"}
			
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 10
				ANIM_set(mo, mo.anim_special2, true)
				playSound(mo.battlen, sfx_tisho)
			end
				
			if timer == 25
				ANIM_set(mo, mo.anim_stand, true)
			end	
			
			
			if timer == 30
				local bs = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
				bs.state = S_SEVENBOOM1
				bs.colorized = true
				bs.color = SKINCOLOR_SAPPHIRE
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				playSound(mo.battlen, sfx_vitcan)
				S_StartSoundAtVolume(nil,sfx_vitcan,70)
			end				
				
			if timer == 31
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(avgx, avgy, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_SUPERSPARK)
					ba.state, ba.scale = S_SSPK1, FRACUNIT*6/4
					ba.colorized = true
					ba.color = SKINCOLOR_SAPPHIRE
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(avgx, avgy, mo.z, MT_SUPERSPARK)
					bb.state, bb.scale = S_SSPK1, FRACUNIT*8/4
					bb.colorized = true
					bb.color = SKINCOLOR_SAPPHIRE
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i
					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_COINSPARKLE1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_SAPPHIRE			
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end
			
			if timer == 50
				playSound(mo.battlen, sfx_lsheal)
			end
			if #targets > 0	--In case we select nothing
				for i = 1, #targets
					local target = targets[i]
					if timer == 50 + (i-1)*3
							--local heals = target.maxhp
							damageObject(target, -350)
						for j = 1, 16
							local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							orb.momx = P_RandomRange(-16, 16)<<FRACBITS
							orb.momy = P_RandomRange(-16, 16)<<FRACBITS
							orb.momz = P_RandomRange(-16, 16)<<FRACBITS
							orb.destscale = 0
							orb.tics = 20
							orb.frame = A
							orb.color = colors[P_RandomRange(1, #colors)]
						end
						for j = 1, #strs
							local t = targets[i]
							local s = strs[j]
							if t.buffs[s][1] < 0
								t.buffs[s][1] = 0
								t.buffs[s][2] = 0
							end
						end
						if target.status_condition and target.status_condition < COND_HYPER
							cureStatus(target)
						end
					end
				end
			end
			if timer == 75 + (#targets-1)*5
				return true
			end
		end,
}

--In the Sky the 3rd (lvl 100 - lvl 200)

--Sky 3rd level 113
attackDefs["tr_vital cannon_3"] = {
		name = "Vital Cannon 3",
		dekunda = true,
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 45,
		power= 800,
		tr_castarea = 4,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AQUA))
		end,
        desc = "Loads a bullet that Heals 800 HP \nand clears status and debuffs. (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_CYAN}
			local strs = {"atk", "mag", "def", "agi"}
			
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 10
				ANIM_set(mo, mo.anim_special2, true)
				playSound(mo.battlen, sfx_tisho)
			end
				
			if timer == 25
				ANIM_set(mo, mo.anim_stand, true)
			end	
			
			
			if timer == 30
				local bs = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
				bs.state = S_SEVENBOOM1
				bs.colorized = true
				bs.color = SKINCOLOR_SAPPHIRE
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				playSound(mo.battlen, sfx_vitcan)
				S_StartSoundAtVolume(nil,sfx_vitcan,70)
			end				
				
			if timer == 31
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(avgx, avgy, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_SUPERSPARK)
					ba.state, ba.scale = S_SSPK1, FRACUNIT*6/4
					ba.colorized = true
					ba.color = SKINCOLOR_SAPPHIRE
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(avgx, avgy, mo.z, MT_SUPERSPARK)
					bb.state, bb.scale = S_SSPK1, FRACUNIT*8/4
					bb.colorized = true
					bb.color = SKINCOLOR_SAPPHIRE
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i
					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_COINSPARKLE1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_SAPPHIRE			
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end
			
			if timer == 50
				playSound(mo.battlen, sfx_lsheal)
			end
			if #targets > 0	--In case we select nothing
				for i = 1, #targets
					local target = targets[i]
					if timer == 50 + (i-1)*3
							--local heals = target.maxhp
							damageObject(target, -800)
						for j = 1, 16
							local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							orb.momx = P_RandomRange(-16, 16)<<FRACBITS
							orb.momy = P_RandomRange(-16, 16)<<FRACBITS
							orb.momz = P_RandomRange(-16, 16)<<FRACBITS
							orb.destscale = 0
							orb.tics = 20
							orb.frame = A
							orb.color = colors[P_RandomRange(1, #colors)]
						end
						for j = 1, #strs
							local t = targets[i]
							local s = strs[j]
							if t.buffs[s][1] < 0
								t.buffs[s][1] = 0
								t.buffs[s][2] = 0
							end
						end
						if target.status_condition and target.status_condition < COND_HYPER
							cureStatus(target)
						end
					end
				end
			end
			if timer == 75 + (#targets-1)*5
				return true
			end
		end,
}

--Sky 3rd Memory Door 1
	--attackDefs["tr_orbal_gear"] = {
	--name = "Orbal Gear", 

--bar edits crafts

	--In the Sky FC (lvl 1 - lvl 50)

	--Sky FC Initial
	attackDefs["tr_smokecannon_c"] = {
			name = "Smoke Cannon",
			type = ATK_STRIKE,
			power = 30,
			accuracy = 90,
			statuschance = 60,
			status = COND_DIZZY,
			costtype = CST_SP,
			cost = tpBar and 30 or 6,
			forcetp = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
			end,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Shoots enemies with a smoke \nround for Miniscule Strike Damage, \nHigh chance of Dizzy (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			anim = function(mo, targets, hittargets, timer)
				local avgx, avgy = 0, 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				
				if timer == 10
					ANIM_set(mo, mo.anim_special2, true)
					playSound(mo.battlen, sfx_tisho)
				end
					
				if timer == 25
					ANIM_set(mo, mo.anim_stand, true)
				end				
				

				if timer == 30
					local boom = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
					boom.scale = FRACUNIT*5
					boom.colorized = true
					boom.color = SKINCOLOR_JET
					boom.state = S_FBOMB_EXPL1
				end
				if timer == 40
					local sm = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
					sm.fuse = TICRATE
				end
				
				if #hittargets > 0	--In case we select nothing
					for k,v in ipairs(hittargets)
						if timer == 41
							damageObject(v)
						end	
					end
				end
				
				if timer == 55 
					return true
				end
				if timer == 30
					playSound(mo.battlen, sfx_smocn)
				end
			end,
	}

	--Sky FC level 23
	attackDefs["tr_vital cannon_c"] = {
			name = "Vital Cannon",
			type = ATK_HEAL,
			costtype = CST_SP,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 12,
			forcetp = true,
			power = 100,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AQUA))
			end,
			desc = "Loads a bullet that\nHeals 100 HP (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLALLIES,
			anim = function(mo, targets, hittargets, timer)
				local colors = {SKINCOLOR_CYAN}		
				local avgx = 0
				local avgy = 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				
				if timer == 10
					ANIM_set(mo, mo.anim_special2, true)
					playSound(mo.battlen, sfx_tisho)
				end
					
				if timer == 25
					ANIM_set(mo, mo.anim_stand, true)
				end	
				
				
				if timer == 30
					local bs = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
					bs.state = S_SEVENBOOM1
					bs.colorized = true
					bs.color = SKINCOLOR_SAPPHIRE
					bs.momz = P_RandomRange(-1, 1)*FRACUNIT
					playSound(mo.battlen, sfx_vitcan)
					S_StartSoundAtVolume(nil,sfx_vitcan,70)
				end				
					
				if timer == 31
					for i = 1, P_RandomRange(11, 20)
						local ba = P_SpawnMobj(avgx, avgy, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_SUPERSPARK)
						ba.state, ba.scale = S_SSPK1, FRACUNIT*6/4
						ba.colorized = true
						ba.color = SKINCOLOR_SAPPHIRE
						ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					end
					for i = 1, P_RandomRange(11, 20)
						local bb = P_SpawnMobj(avgx, avgy, mo.z, MT_SUPERSPARK)
						bb.state, bb.scale = S_SSPK1, FRACUNIT*8/4
						bb.colorized = true
						bb.color = SKINCOLOR_SAPPHIRE
						bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					end
					for i = 1, 9
						local curangle = ANG1*40*i
						local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale, dust.angle = S_COINSPARKLE1, FRACUNIT*5/4, curangle
						dust.destscale = FRACUNIT*8/2
						dust.scalespeed = FRACUNIT/18
						dust.colorized = true
						dust.color = SKINCOLOR_SAPPHIRE			
						P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
						dust.momz = 4*FRACUNIT
					end	
				end			
				
				if timer == 50
					playSound(mo.battlen, sfx_lsheal)
				end
				if #targets > 0	--In case we select nothing
					for i = 1, #targets
						local target = targets[i]
						if timer == 50 + (i-1)*3
								--local heals = P_RandomRange(150, 160)
								damageObject(target, -100)
							for j = 1, 16
								local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
								orb.momx = P_RandomRange(-16, 16)<<FRACBITS
								orb.momy = P_RandomRange(-16, 16)<<FRACBITS
								orb.momz = P_RandomRange(-16, 16)<<FRACBITS
								orb.destscale = 0
								orb.tics = 20
								orb.frame = A
								orb.color = colors[P_RandomRange(1, #colors)]
								
							end    
						end
					end
				end

				if timer == 75 + (#targets-1)*5
					return true
				end
			end,
	}

	--In the Sky SC (lvl 50 - lvl 100)

	--Sky SC level 48
	attackDefs["tr_smokecannon_c2"] = {
			name = "Smoke Cannon 2",
			type = ATK_STRIKE,
			power = 90,
			accuracy = 90,
			statuschance = 60,
			status = COND_DIZZY,
			costtype = CST_SP,
			cost = tpBar and 30 or 12,
			forcetp = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_DUSK))
			end,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Shoots enemies with a smoke \nround for Light Strike Damage, \nHigh chance of Dizzy (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			anim = function(mo, targets, hittargets, timer)
				local avgx, avgy = 0, 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				
				if timer == 10
					ANIM_set(mo, mo.anim_special2, true)
					playSound(mo.battlen, sfx_tisho)
				end
					
				if timer == 25
					ANIM_set(mo, mo.anim_stand, true)
				end				
				

				if timer == 30
					local boom = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
					boom.scale = FRACUNIT*5
					boom.colorized = true
					boom.color = SKINCOLOR_JET
					boom.state = S_FBOMB_EXPL1
				end
				if timer == 40
					local sm = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
					sm.fuse = TICRATE
				end
				
				if #hittargets > 0	--In case we select nothing
					for k,v in ipairs(hittargets)
						if timer == 41
							damageObject(v)
						end	
					end
				end
				
				if timer == 55 
					return true
				end
				if timer == 30
					playSound(mo.battlen, sfx_smocn)
				end
			end,
	}

	--Sky SC level 63
	attackDefs["tr_vital cannon_c2"] = {
			name = "Vital Cannon 2",
			dekunda = true,
			type = ATK_HEAL,
			costtype = CST_SP,
			cost = 30,
			forcetp = true,
			power= 350,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AQUA))
			end,
			desc = "Loads a bullet that Heals 350 HP \nand clears status and debuffs. (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLALLIES,
			anim = function(mo, targets, hittargets, timer)
				local colors = {SKINCOLOR_CYAN}
				local strs = {"atk", "mag", "def", "agi"}
				
				local avgx = 0
				local avgy = 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				

				if timer == 10
					ANIM_set(mo, mo.anim_special2, true)
					playSound(mo.battlen, sfx_tisho)
				end
					
				if timer == 25
					ANIM_set(mo, mo.anim_stand, true)
				end	
				
				
				if timer == 30
					local bs = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
					bs.state = S_SEVENBOOM1
					bs.colorized = true
					bs.color = SKINCOLOR_SAPPHIRE
					bs.momz = P_RandomRange(-1, 1)*FRACUNIT
					playSound(mo.battlen, sfx_vitcan)
					S_StartSoundAtVolume(nil,sfx_vitcan,70)
				end				
					
				if timer == 31
					for i = 1, P_RandomRange(11, 20)
						local ba = P_SpawnMobj(avgx, avgy, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_SUPERSPARK)
						ba.state, ba.scale = S_SSPK1, FRACUNIT*6/4
						ba.colorized = true
						ba.color = SKINCOLOR_SAPPHIRE
						ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					end
					for i = 1, P_RandomRange(11, 20)
						local bb = P_SpawnMobj(avgx, avgy, mo.z, MT_SUPERSPARK)
						bb.state, bb.scale = S_SSPK1, FRACUNIT*8/4
						bb.colorized = true
						bb.color = SKINCOLOR_SAPPHIRE
						bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					end
					for i = 1, 9
						local curangle = ANG1*40*i
						local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale, dust.angle = S_COINSPARKLE1, FRACUNIT*5/4, curangle
						dust.destscale = FRACUNIT*8/2
						dust.scalespeed = FRACUNIT/18
						dust.colorized = true
						dust.color = SKINCOLOR_SAPPHIRE			
						P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
						dust.momz = 4*FRACUNIT
					end	
				end
				
				if timer == 50
					playSound(mo.battlen, sfx_lsheal)
				end
				if #targets > 0	--In case we select nothing
					for i = 1, #targets
						local target = targets[i]
						if timer == 50 + (i-1)*3
								--local heals = target.maxhp
								damageObject(target, -350)
							for j = 1, 16
								local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
								orb.momx = P_RandomRange(-16, 16)<<FRACBITS
								orb.momy = P_RandomRange(-16, 16)<<FRACBITS
								orb.momz = P_RandomRange(-16, 16)<<FRACBITS
								orb.destscale = 0
								orb.tics = 20
								orb.frame = A
								orb.color = colors[P_RandomRange(1, #colors)]
							end
							for j = 1, #strs
								local t = targets[i]
								local s = strs[j]
								if t.buffs[s][1] < 0
									t.buffs[s][1] = 0
									t.buffs[s][2] = 0
								end
							end
							if target.status_condition and target.status_condition < COND_HYPER
								cureStatus(target)
							end
						end
					end
				end
				if timer == 75 + (#targets-1)*5
					return true
				end
			end,
	}

	--In the Sky the 3rd (lvl 100 - lvl 200)

	--Sky 3rd level 113
	attackDefs["tr_vital cannon_c3"] = {
			name = "Vital Cannon 3",
			dekunda = true,
			type = ATK_HEAL,
			costtype = CST_SP,
			cost = tpBar and 30 or 45,
			forcetp = true,
			power= 800,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_AQUA))
			end,
			desc = "Loads a bullet that Heals 350 HP \nand clears status and debuffs. (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLALLIES,
			anim = function(mo, targets, hittargets, timer)
				local colors = {SKINCOLOR_CYAN}
				local strs = {"atk", "mag", "def", "agi"}
				
				local avgx = 0
				local avgy = 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				

				if timer == 10
					ANIM_set(mo, mo.anim_special2, true)
					playSound(mo.battlen, sfx_tisho)
				end
					
				if timer == 25
					ANIM_set(mo, mo.anim_stand, true)
				end	
				
				
				if timer == 30
					local bs = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
					bs.state = S_SEVENBOOM1
					bs.colorized = true
					bs.color = SKINCOLOR_SAPPHIRE
					bs.momz = P_RandomRange(-1, 1)*FRACUNIT
					playSound(mo.battlen, sfx_vitcan)
					S_StartSoundAtVolume(nil,sfx_vitcan,70)
				end				
					
				if timer == 31
					for i = 1, P_RandomRange(11, 20)
						local ba = P_SpawnMobj(avgx, avgy, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_SUPERSPARK)
						ba.state, ba.scale = S_SSPK1, FRACUNIT*6/4
						ba.colorized = true
						ba.color = SKINCOLOR_SAPPHIRE
						ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					end
					for i = 1, P_RandomRange(11, 20)
						local bb = P_SpawnMobj(avgx, avgy, mo.z, MT_SUPERSPARK)
						bb.state, bb.scale = S_SSPK1, FRACUNIT*8/4
						bb.colorized = true
						bb.color = SKINCOLOR_SAPPHIRE
						bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					end
					for i = 1, 9
						local curangle = ANG1*40*i
						local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale, dust.angle = S_COINSPARKLE1, FRACUNIT*5/4, curangle
						dust.destscale = FRACUNIT*8/2
						dust.scalespeed = FRACUNIT/18
						dust.colorized = true
						dust.color = SKINCOLOR_SAPPHIRE			
						P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
						dust.momz = 4*FRACUNIT
					end	
				end
				
				if timer == 50
					playSound(mo.battlen, sfx_lsheal)
				end
				if #targets > 0	--In case we select nothing
					for i = 1, #targets
						local target = targets[i]
						if timer == 50 + (i-1)*3
								--local heals = target.maxhp
								damageObject(target, -800)
							for j = 1, 16
								local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
								orb.momx = P_RandomRange(-16, 16)<<FRACBITS
								orb.momy = P_RandomRange(-16, 16)<<FRACBITS
								orb.momz = P_RandomRange(-16, 16)<<FRACBITS
								orb.destscale = 0
								orb.tics = 20
								orb.frame = A
								orb.color = colors[P_RandomRange(1, #colors)]
							end
							for j = 1, #strs
								local t = targets[i]
								local s = strs[j]
								if t.buffs[s][1] < 0
									t.buffs[s][1] = 0
									t.buffs[s][2] = 0
								end
							end
							if target.status_condition and target.status_condition < COND_HYPER
								cureStatus(target)
							end
						end
					end
				end
				if timer == 75 + (#targets-1)*5
					return true
				end
			end,
	}

	--Sky 3rd Memory Door 1
		--attackDefs["tr_orbal_gear"] = {
		--name = "Orbal Gear", 


if C2SBarEdits
	-- S-Crafts

	--Sky FC Initial
		attackDefs["tr_cannon_impulse_c"] = {
			name = "Cannon Impulse",
			type = ATK_PIERCE,
			power = 120,
			accuracy = 100,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_TITAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			nometronome = true,
			norandom = true,
			anim_norepel = true,
			critical = 15,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_GREY))
			end,
			tr_castarea = 4,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nTita's S-Craft\nFires a wild fusilade of rounds \nupon the enemy (Area M).",
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			anim_norepel = true,
			anim = function(mo, targets, hittargets, timer)
			
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					ANIM_set(mo, mo.anim_special3)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_tiaoa1)	--"Prepare to meet your doom!"
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 50	--barrel flash
					playSound(mo.battlen, sfx_tiaoi3)
					playSound(mo.battlen, sfx_elgry)
					
					mo.bod = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(10*FRACUNIT), MT_DUMMY)
					mo.bod.sprite = SPR_MEGI
					mo.bod.color = SKINCOLOR_WHITE
					mo.bod.frame = G|FF_FULLBRIGHT
					mo.bod.blendmode = AST_ADD
					mo.bod.renderflags = $|RF_FULLBRIGHT
					mo.bod.scale = FRACUNIT*2
					mo.bod.destscale = FRACUNIT*4
					mo.bod.scalespeed = FRACUNIT/20
					mo.bod.momz = FRACUNIT*-1
					mo.bod.tics = 40
				end
				if timer > 50 and timer <= 70
					if mo.bod and mo.bod.valid
						mo.bod.rollangle = $-(1*ANG1)
					end
				end
				
				if timer >= 72 and timer <= 220	--ratatatatatatatatatatatattatatata-!
					if timer%3 == 0	and timer < 180
						local p = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(20*FRACUNIT), MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = FRACUNIT*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*FRACUNIT
						p.momy = P_RandomRange(-2, 2)*FRACUNIT
						p.momz = P_RandomRange(-2, 2)*FRACUNIT
						
						playSound(mo.battlen, sfx_s3k77)
					end
					
					if timer >= 100 and timer <= 135
						if timer == 100
							playSound(mo.battlen, sfx_canimp)
							ANIM_set(mo, mo.anim_special4, true)
						end
						P_TeleportMove(cam, mo.x + 256*cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						P_TeleportMove(cam, cam.x + (320-((timer-100)*8))*cos(cam.angle+(90*ANG1)), cam.y + (320-((timer-100)*8))*sin(cam.angle+(90*ANG1)), mo.floorz)
					end
					if timer >= 150 and timer <= 200
						if timer == 150
							P_TeleportMove(cam, mo.x + 256*cos(mo.angle+(150*ANG1)), mo.y + 256*sin(mo.angle+(150*ANG1)), mo.floorz)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
							ANIM_set(mo, mo.anim_special5, true)
						end
						if timer < 180
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(avgx + P_RandomRange(-320, 320)*FRACUNIT, avgy + P_RandomRange(-320, 320)*FRACUNIT, mo.floorz, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = FRACUNIT*2
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*FRACUNIT
							p.momy = P_RandomRange(-2, 2)*FRACUNIT
							p.momz = P_RandomRange(-2, 2)*FRACUNIT
							
							local shot = P_SpawnMobj(avgx + P_RandomRange(-320, 320)*FRACUNIT, avgy + P_RandomRange(-320, 320)*FRACUNIT, mo.floorz, MT_DUMMY)
							shot.scale = FRACUNIT*2
							shot.state = S_STAB_1_1
							shot.color = SKINCOLOR_FLAME
							shot.frame = $|FF_FULLBRIGHT
							shot.blendmode = AST_ADD
							shot.renderflags = A|RF_FULLBRIGHT
							shot.momx = P_RandomRange(-2, 2)*FRACUNIT
							shot.momy = P_RandomRange(-2, 2)*FRACUNIT
							shot.momz = P_RandomRange(-2, 2)*FRACUNIT
							
							playSound(mo.battlen, sfx_elgun)
						end
						end
						if timer == 180
							for i = 1,#hittargets
								local target = hittargets[i]
								damageObject(target)
							end
						end
					end
				end
				if timer == 200
					ANIM_set(mo, mo.anim_special6)
					playSound(mo.battlen, sfx_tikil1)
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 240
					mo.hudcharx = nil
					return true
				end
			end,
	}


	--Sky SC lvl 58
		attackDefs["tr_cannon_impulse_c2"] = {
			name = "Cannon Impulse 2",
			type = ATK_PIERCE,
			power = 360,
			accuracy = 100,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_TITAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			nometronome = true,
			norandom = true,
			anim_norepel = true,
			critical = 15,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_GREY))
			end,
			tr_castarea = 4,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nTita's S-Craft\nFires a wild fusilade of rounds \nupon the enemy (Area M).",
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			anim_norepel = true,
			anim = function(mo, targets, hittargets, timer)
			
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					ANIM_set(mo, mo.anim_special3)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_tiaoa1)	--"Prepare to meet your doom!"
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 50	--barrel flash
					playSound(mo.battlen, sfx_tiaoi3)
					playSound(mo.battlen, sfx_elgry)
					
					mo.bod = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(10*FRACUNIT), MT_DUMMY)
					mo.bod.sprite = SPR_MEGI
					mo.bod.color = SKINCOLOR_WHITE
					mo.bod.frame = G|FF_FULLBRIGHT
					mo.bod.blendmode = AST_ADD
					mo.bod.renderflags = $|RF_FULLBRIGHT
					mo.bod.scale = FRACUNIT*2
					mo.bod.destscale = FRACUNIT*4
					mo.bod.scalespeed = FRACUNIT/20
					mo.bod.momz = FRACUNIT*-1
					mo.bod.tics = 40
				end
				if timer > 50 and timer <= 70
					if mo.bod and mo.bod.valid
						mo.bod.rollangle = $-(1*ANG1)
					end
				end
				if timer == 60
					playSound(mo.battlen, sfx_tievy)
				end				
				if timer >= 72 and timer <= 220	--ratatatatatatatatatatatattatatata-!
					if timer%3 == 0	and timer < 180
						local p = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(20*FRACUNIT), MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = FRACUNIT*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*FRACUNIT
						p.momy = P_RandomRange(-2, 2)*FRACUNIT
						p.momz = P_RandomRange(-2, 2)*FRACUNIT
						
						playSound(mo.battlen, sfx_s3k77)
					end
					
					if timer >= 100 and timer <= 135
						if timer == 100
							playSound(mo.battlen, sfx_canimp)
							ANIM_set(mo, mo.anim_special4, true)
						end
						P_TeleportMove(cam, mo.x + 256*cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						P_TeleportMove(cam, cam.x + (320-((timer-100)*8))*cos(cam.angle+(90*ANG1)), cam.y + (320-((timer-100)*8))*sin(cam.angle+(90*ANG1)), mo.floorz)
					end
					if timer >= 150 and timer <= 200
						if timer == 150
							P_TeleportMove(cam, mo.x + 256*cos(mo.angle+(150*ANG1)), mo.y + 256*sin(mo.angle+(150*ANG1)), mo.floorz)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
							ANIM_set(mo, mo.anim_special5, true)
						end
						if timer < 180
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(avgx + P_RandomRange(-320, 320)*FRACUNIT, avgy + P_RandomRange(-320, 320)*FRACUNIT, mo.floorz, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = FRACUNIT*2
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*FRACUNIT
							p.momy = P_RandomRange(-2, 2)*FRACUNIT
							p.momz = P_RandomRange(-2, 2)*FRACUNIT
							
							local shot = P_SpawnMobj(avgx + P_RandomRange(-320, 320)*FRACUNIT, avgy + P_RandomRange(-320, 320)*FRACUNIT, mo.floorz, MT_DUMMY)
							shot.scale = FRACUNIT*2
							shot.state = S_STAB_1_1
							shot.color = SKINCOLOR_FLAME
							shot.frame = $|FF_FULLBRIGHT
							shot.blendmode = AST_ADD
							shot.renderflags = A|RF_FULLBRIGHT
							shot.momx = P_RandomRange(-2, 2)*FRACUNIT
							shot.momy = P_RandomRange(-2, 2)*FRACUNIT
							shot.momz = P_RandomRange(-2, 2)*FRACUNIT
							
							playSound(mo.battlen, sfx_elgun)
						end
						end
						if timer == 180
							for i = 1,#hittargets
								local target = hittargets[i]
								damageObject(target)
							end
						end
					end
				end
				if timer == 200
					ANIM_set(mo, mo.anim_special6)
					playSound(mo.battlen, sfx_tikil1)
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 240
					mo.hudcharx = nil
					return true
				end
			end,
	}

	--Sky SC lvl 71
	attackDefs["tr_satbeam_c"] = {
			name = "Satellite Beam",
			type = ATK_NUCLEAR,
			power = 900,	--doubled POW so un-focused enemies are dealt effective 225.
			accuracy = 999,
			costtype = CST_SP,
			hits = 2,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			--noenemycast = true,	--Should be enemy safe now.
			nometronome = true,
			norandom = true,
			anim_norepel = true,
			critical = 15,
			tr_castarea = 4,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nTita's S-Craft\nActivates a satellite to destroy enemies (Area M).\nFocuses a random target",
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_TITAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			anim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			local stgt = hittargets[1]
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
			
				if timer == 5
					playSound(mo.battlen, sfx_satpc)
				end	
				
				if timer == 1 //Everyone's favouite illiterate nuisance Zoraxua making messes again, time to comment
					//playSound(mo.battlen, sfx_) sound goeS here if you want lol
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_tiaoa2)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0 //Makse sure camera sits still
				elseif timer == 2
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, look at me
				ANIM_set(mo, mo.anim_special1, true) //Takes 108 frames
				playSound(mo.battlen, sfx_cutsky)
					local thok = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*1920, MT_DUMMY)	
					thok.frame = A|FF_FULLBRIGHT
					thok.tics = 99999
					thok.sprite = SPR_SATE
					thok.scale = FRACUNIT*2
					mo.satellite = thok //Lets set this puppy up, stay strong Mr Satellite!
				end
				if timer >= 2
				and timer < 58 //end at 56'th for sfx
					for i = 1,3
						local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_EMERALD
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 10 //Hackerlass
						thok.scale = FRACUNIT/4
						thok.scalespeed = (FRACUNIT/4)/9
						thok.destscale = 1
						thok.momz = P_RandomRange(8, 12)*FRACUNIT
						thok.momx = P_RandomRange(-10, 10)*FRACUNIT
						thok.momy = P_RandomRange(-10, 10)*FRACUNIT
					end
				elseif timer >= 58
				and timer < 70  //Make a signal effect or something
					local sigcol = {SKINCOLOR_EMERALD, SKINCOLOR_JET}
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + 16*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = sigcol[P_RandomRange(1, #sigcol)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(mo.x, mo.y, mo.z + 16*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = sigcol[P_RandomRange(1, #sigcol)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
					if timer == 58
						playSound(mo.battlen, sfx_3db06) //SFX go here lol
					end
				elseif timer == 110
					ANIM_set(mo, mo.anim_stand, true) //So go back to not using 0 angle sprites
					playSound(mo.battlen, sfx_tiok)
					local cx = mo.x + 384*cos(mo.angle) //And launch this camera up
					local cy = mo.y + 384*sin(mo.angle)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*1952)//YEET
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Don't lose focus, starcam
					playSound(mo.battlen, sfx_s3kbds)
				//Alright... Time to do something, painful but I don't wanna make an animated state
				//Satellite goes to Z..
				end
				if timer >= 111
				and timer <= 160 //I fucked up the mo.satellite so I'm using this lil hack
					local satellite = mo.satellite //Zoraxua has 2 IQ (verified science fact)
						local thok = P_SpawnMobj(satellite.x + P_RandomRange(-40, 40)*FRACUNIT, satellite.y + P_RandomRange(-40, 40)*FRACUNIT, satellite.z + P_RandomRange(8, 40)*FRACUNIT, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_EMERALD
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 5 //Hackerlass
						thok.scale = FRACUNIT/2
						thok.scalespeed = (FRACUNIT/2)/4
						thok.destscale = 1
						thok.momz = P_RandomRange(-10, 10)*FRACUNIT
						thok.momx = P_RandomRange(-10, 10)*FRACUNIT
						thok.momy = P_RandomRange(-10, 10)*FRACUNIT
						if not (leveltime%(P_RandomRange(4,10)))
							playSound(mo.battlen, sfx_s3k89)
						end
					if timer == 112
						satellite.frame = B|FF_FULLBRIGHT //Yep...
					elseif timer == 114
						satellite.frame = C|FF_FULLBRIGHT
					elseif timer == 116
						satellite.frame = D|FF_FULLBRIGHT
					elseif timer == 118
						satellite.frame = E|FF_FULLBRIGHT
					elseif timer == 120
						satellite.frame = F|FF_FULLBRIGHT
					elseif timer == 122
						satellite.frame = G|FF_FULLBRIGHT
					elseif timer == 124
						satellite.frame = H|FF_FULLBRIGHT
					elseif timer == 126
						satellite.frame = I|FF_FULLBRIGHT
						
						local ol = P_SpawnMobj(mo.x, mo.y, satellite.z + 32*FRACUNIT, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_EMERALD
						ol.scale = 1
						ol.destscale = FRACUNIT*32
						ol.scalespeed = FRACUNIT/5
						ol.frame = B|FF_FULLBRIGHT
						ol.tics = 20
						//Ping, im been hakk
						playSound(mo.battlen, sfx_s3k86)
						ol = P_SpawnMobj(mo.x, mo.y, satellite.z + 32*FRACUNIT, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_JET
						ol.scale = 1
						ol.destscale = FRACUNIT*32
						ol.scalespeed = FRACUNIT
						ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
						ol.tics = 8
						
					elseif timer == 128
						satellite.frame = J|FF_FULLBRIGHT
					elseif timer == 130
						satellite.frame = K|FF_FULLBRIGHT //I am SO sorry to anyone reading this, please don't do this stupid example of mine
					elseif timer == 132
						satellite.frame = L|FF_FULLBRIGHT
					elseif timer == 134
						satellite.frame = M|FF_FULLBRIGHT
					elseif timer == 136
						satellite.frame = N|FF_FULLBRIGHT
					elseif timer == 138
						satellite.frame = O|FF_FULLBRIGHT
					elseif timer == 140
						satellite.frame = P|FF_FULLBRIGHT
					elseif timer == 142
						satellite.frame = Q|FF_FULLBRIGHT
					elseif timer == 144
						satellite.frame = R|FF_FULLBRIGHT
					elseif timer == 146
						satellite.frame = S|FF_FULLBRIGHT
					elseif timer == 148
						satellite.frame = T|FF_FULLBRIGHT
					elseif timer == 150
						satellite.frame = U|FF_FULLBRIGHT
					elseif timer == 152
						satellite.frame = V|FF_FULLBRIGHT
					elseif timer == 154 //,,,I couldve used a  for i = 1,26 and done iftimer = i or something 
						satellite.frame = W|FF_FULLBRIGHT
					elseif timer == 156
						satellite.frame = X|FF_FULLBRIGHT
					elseif timer == 158 //No that wouldnt work anyways??? Right??? lol
						satellite.frame = Y|FF_FULLBRIGHT
					elseif timer == 160
						satellite.frame = Z|FF_FULLBRIGHT //wATCH me not get the DAMN ALPHABET correct
					end
				end// HOW DID I FORGET THIS END- yeah 2 IQ
				if timer >= 161
				and timer < 195 //fine dont work, i'll do this instead
					if not (leveltime%(P_RandomRange(3,10)))
						playSound(mo.battlen, sfx_s3k89)
					end
					if timer == 161
						playSound(mo.battlen, sfx_s3k84)
					end
					local satellite = mo.satellite
					local satx = mo.x + 48*cos(mo.angle +ANGLE_270) 
					local saty = mo.y + 48*sin(mo.angle +ANGLE_270)
					local cthok = P_SpawnMobj(satx, saty, satellite.z - 32*FRACUNIT, MT_DUMMY)
					cthok.flags = MF_NOBLOCKMAP
					cthok.color = SKINCOLOR_CYAN //Charge vfx which is actually to verify target
					cthok.frame = A
					cthok.tics = 2
					if timer < 170
					cthok.scale = FRACUNIT/4
					elseif timer < 180
					cthok.scale = FRACUNIT/2
					elseif timer < 190
					cthok.scale = FRACUNIT
					else
					cthok.scale = FRACUNIT*2
	//				cthok.destscale = 3*FRACUNIT //Make beeger
	//				cthok.scalespeed = (FRACUNIT*3)/20
					end
				end//I can't fire properly so... Lets just uh pretend we did LMAO
				if timer == 195
					local cx = stgt.x + 256*cos(stgt.angle)
					local cy = stgt.y + 256*sin(stgt.angle)
					P_TeleportMove(cam, cx, cy, stgt.z + FRACUNIT*16)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, stgt.x, stgt.y) //They're fucked lol
					mo.satellite.tics = 5
					mo.satellite = nil //Don't need this anymore
				end
				if timer >= 195
				and timer < 230
					if timer == 195
						playSound(mo.battlen, sfx_s3ka1)
					end
					for i = 1, 5
						local thoka = P_SpawnMobj(stgt.x + P_RandomRange(-256, 256)*FRACUNIT, stgt.y + P_RandomRange(-256, 256)*FRACUNIT, stgt.z, MT_DUMMY)
						thoka.flags = MF_NOBLOCKMAP
						thoka.color = SKINCOLOR_CYAN
						if timer%2 then thoka.color = SKINCOLOR_ICY end
						thoka.frame = A
						thoka.tics = 10 //Hackerlass
						thoka.scale = FRACUNIT/2
						thoka.scalespeed = (FRACUNIT/2)/9
						thoka.destscale = 1
						thoka.momz = P_RandomRange(12, 64)*FRACUNIT
					end
					localquake(mo.battlen, FRACUNIT*12, 2)
					if timer == 210
						local cx = stgt.x + 768*cos(stgt.angle)
						local cy = stgt.y + 768*sin(stgt.angle)
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, stgt.z + FRACUNIT*64, 50*FRACUNIT)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, stgt.x, stgt.y) //They're fucked lol
					end
				elseif timer >= 230
				and timer < 300 
					if not (leveltime%10)
						playSound(mo.battlen, sfx_s3kc4s)
						playSound(mo.battlen, sfx_s3kc4s)
					end
					if timer == 230
						playSound(mo.battlen, sfx_s3kd0s)
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 4, 5)
							end
						end
					end
					if timer == 298
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 5, 2)
							end
						end
					end
					if timer == 265
						--if stgt.boss
							damageObject(stgt)
						--else
						--	damageObject(stgt, stgt.hp)
						--end
					end
					localquake(mo.battlen, FRACUNIT*64, 10)
					local beam = P_SpawnMobj(stgt.x, stgt.y, stgt.z + FRACUNIT*640, MT_DUMMY)
					beam.flags = MF_NOBLOCKMAP
					beam.sprite = SPR_SATB
					beam.frame = A|FF_FULLBRIGHT
					beam.tics = 20 //Hackerlass
					beam.scale = 5*stgt.scale
					beam.momz = -48*FRACUNIT
				end
				
					local j = mo.columns and #mo.columns or 0
					while j
						local m = mo.columns[j]
						if not m or not m.valid
							j = $-1
							continue
						end

						for i = 1, 5
							local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.colorized = true
							boom.color = SKINCOLOR_CYAN
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*3
						end
						P_StartQuake(FRACUNIT*8, 1)
						j = $-1
					end
					
				if timer == 300
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 1, 10)
						end
					end
					for i = 1,#hittargets
						local target = hittargets[i]
						damageObject(target)
					end
					mo.fangle = (R_PointToAngle(stgt.x, stgt.y)) + ANG1*180
					mo.columns = {}
					playSound(mo.battlen, sfx_megi5)
					playSound(mo.battlen, sfx_s3k9f)

					local a = mo.fangle - ANG1*80

					for i = 1, 16
						local m = P_SpawnMobj(stgt.x, stgt.y, stgt.z, MT_DUMMY)
						P_InstaThrust(m, a, FRACUNIT*48)
						mo.columns[#mo.columns+1] = m
						m.state = S_INVISIBLE
						m.tics = TICRATE
						a = $+ ANG1*10
					end
				end
				if timer == 330
					mo.hudcharx = nil
					return true
				end
			end,
	}

	--Sky SC request
		attackDefs["tr_cannon_impulse_cf"] = {
			name = "Cannon Impulse F",
			type = ATK_PIERCE,
			power = 720,
			accuracy = 100,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_TITAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			nometronome = true,
			norandom = true,
			anim_norepel = true,
			critical = 15,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_GREY))
			end,
			tr_castarea = 4,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nTita's S-Craft\nFires a wild fusilade of rounds \nupon the enemy (Set Line XL).",
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			anim_norepel = true,
			anim = function(mo, targets, hittargets, timer)
			
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				local avgx = 0
				local avgy = 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end				
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					ANIM_set(mo, mo.anim_special3)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_tiaoa1)	--"Prepare to meet your doom!"
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 50	--barrel flash
					playSound(mo.battlen, sfx_tiaoi3)
					playSound(mo.battlen, sfx_elgry)
					
					mo.bod = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(10*FRACUNIT), MT_DUMMY)
					mo.bod.sprite = SPR_MEGI
					mo.bod.color = SKINCOLOR_WHITE
					mo.bod.frame = G|FF_FULLBRIGHT
					mo.bod.blendmode = AST_ADD
					mo.bod.renderflags = $|RF_FULLBRIGHT
					mo.bod.scale = FRACUNIT*2
					mo.bod.destscale = FRACUNIT*4
					mo.bod.scalespeed = FRACUNIT/20
					mo.bod.momz = FRACUNIT*-1
					mo.bod.tics = 40
				end
				if timer > 50 and timer <= 70
					if mo.bod and mo.bod.valid
						mo.bod.rollangle = $-(1*ANG1)
					end
				end
				if timer == 60
					playSound(mo.battlen, sfx_tievy)
				end				
				if timer >= 72 and timer <= 220	--ratatatatatatatatatatatattatatata-!
					if timer%3 == 0	and timer < 180
						local p = P_SpawnMobj(mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle), mo.z+(20*FRACUNIT), MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = FRACUNIT*3
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*FRACUNIT
						p.momy = P_RandomRange(-2, 2)*FRACUNIT
						p.momz = P_RandomRange(-2, 2)*FRACUNIT
						
						playSound(mo.battlen, sfx_s3k77)
					end
					
					if timer >= 100 and timer <= 135
						if timer == 100
							playSound(mo.battlen, sfx_canimp)
							ANIM_set(mo, mo.anim_special4, true)
						end
						P_TeleportMove(cam, mo.x + 256*cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						P_TeleportMove(cam, cam.x + (320-((timer-100)*8))*cos(cam.angle+(90*ANG1)), cam.y + (320-((timer-100)*8))*sin(cam.angle+(90*ANG1)), mo.floorz)
					end
					if timer >= 150 and timer <= 200
						if timer == 150
							P_TeleportMove(cam, mo.x + 256*cos(mo.angle+(150*ANG1)), mo.y + 256*sin(mo.angle+(150*ANG1)), mo.floorz)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
							ANIM_set(mo, mo.anim_special5, true)
						end
						if timer < 180
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(avgx + P_RandomRange(-320, 320)*FRACUNIT, avgy + P_RandomRange(-320, 320)*FRACUNIT, mo.floorz, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = FRACUNIT*2
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*FRACUNIT
							p.momy = P_RandomRange(-2, 2)*FRACUNIT
							p.momz = P_RandomRange(-2, 2)*FRACUNIT
							
							local shot = P_SpawnMobj(avgx + P_RandomRange(-320, 320)*FRACUNIT, avgy + P_RandomRange(-320, 320)*FRACUNIT, mo.floorz, MT_DUMMY)
							shot.scale = FRACUNIT*2
							shot.state = S_STAB_1_1
							shot.color = SKINCOLOR_FLAME
							shot.frame = $|FF_FULLBRIGHT
							shot.blendmode = AST_ADD
							shot.renderflags = A|RF_FULLBRIGHT
							shot.momx = P_RandomRange(-2, 2)*FRACUNIT
							shot.momy = P_RandomRange(-2, 2)*FRACUNIT
							shot.momz = P_RandomRange(-2, 2)*FRACUNIT
							
							playSound(mo.battlen, sfx_elgun)
						end
						end
						if timer == 180
							if #hittargets > 0	--In case we select nothing
								for i = 1, #hittargets
									damageObject(hittargets[i])	--this should just hit everything highlighted
								end
							end
						end
					end
				end
				if timer == 200
					ANIM_set(mo, mo.anim_special6)
					playSound(mo.battlen, sfx_tikil1)
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 240
					mo.hudcharx = nil
					return true
				end
			end,
	}

	--Sky 3rd lvl 124
	attackDefs["tr_satbeam_c2"] = {
			name = "Satellite Beam 2",
			type = ATK_NUCLEAR,
			power = 1200,	--doubled POW so un-focused enemies are dealt effective 300.
			accuracy = 100,
			costtype = CST_SP,
			hits = 2,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			--noenemycast = true,	--Should be enemy safe now.
			nometronome = true,
			norandom = true,
			anim_norepel = true,
			critical = 15,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
			end,
			tr_castarea = 4,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nTita's S-Craft\nActivates a satellite to destroy enemies (Area M).\nFocuses a random target",
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_TITAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			anim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			local stgt = hittargets[1]
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
			
				if timer == 5
					playSound(mo.battlen, sfx_satpc)
				end	
				
				if timer == 1 //Everyone's favouite illiterate nuisance Zoraxua making messes again, time to comment
					//playSound(mo.battlen, sfx_) sound goeS here if you want lol
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_tiaoa2)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0 //Makse sure camera sits still
				elseif timer == 2
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, look at me
				ANIM_set(mo, mo.anim_special1, true) //Takes 108 frames
				playSound(mo.battlen, sfx_cutsky)
					local thok = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*1920, MT_DUMMY)	
					thok.frame = A|FF_FULLBRIGHT
					thok.tics = 99999
					thok.sprite = SPR_SATE
					thok.scale = FRACUNIT*2
					mo.satellite = thok //Lets set this puppy up, stay strong Mr Satellite!
				end
				if timer >= 2
				and timer < 58 //end at 56'th for sfx
					for i = 1,3
						local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_EMERALD
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 10 //Hackerlass
						thok.scale = FRACUNIT/4
						thok.scalespeed = (FRACUNIT/4)/9
						thok.destscale = 1
						thok.momz = P_RandomRange(8, 12)*FRACUNIT
						thok.momx = P_RandomRange(-10, 10)*FRACUNIT
						thok.momy = P_RandomRange(-10, 10)*FRACUNIT
					end
				elseif timer >= 58
				and timer < 70  //Make a signal effect or something
					local sigcol = {SKINCOLOR_EMERALD, SKINCOLOR_JET}
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + 16*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = sigcol[P_RandomRange(1, #sigcol)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(mo.x, mo.y, mo.z + 16*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = sigcol[P_RandomRange(1, #sigcol)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
					if timer == 58
						playSound(mo.battlen, sfx_3db06) //SFX go here lol
					end
				elseif timer == 110
					ANIM_set(mo, mo.anim_stand, true) //So go back to not using 0 angle sprites
					playSound(mo.battlen, sfx_tiok)
					local cx = mo.x + 384*cos(mo.angle) //And launch this camera up
					local cy = mo.y + 384*sin(mo.angle)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*1952)//YEET
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Don't lose focus, starcam
					playSound(mo.battlen, sfx_s3kbds)
				//Alright... Time to do something, painful but I don't wanna make an animated state
				//Satellite goes to Z..
				end
				if timer >= 111
				and timer <= 160 //I fucked up the mo.satellite so I'm using this lil hack
					local satellite = mo.satellite //Zoraxua has 2 IQ (verified science fact)
						local thok = P_SpawnMobj(satellite.x + P_RandomRange(-40, 40)*FRACUNIT, satellite.y + P_RandomRange(-40, 40)*FRACUNIT, satellite.z + P_RandomRange(8, 40)*FRACUNIT, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_EMERALD
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 5 //Hackerlass
						thok.scale = FRACUNIT/2
						thok.scalespeed = (FRACUNIT/2)/4
						thok.destscale = 1
						thok.momz = P_RandomRange(-10, 10)*FRACUNIT
						thok.momx = P_RandomRange(-10, 10)*FRACUNIT
						thok.momy = P_RandomRange(-10, 10)*FRACUNIT
						if not (leveltime%(P_RandomRange(4,10)))
							playSound(mo.battlen, sfx_s3k89)
						end
					if timer == 112
						satellite.frame = B|FF_FULLBRIGHT //Yep...
					elseif timer == 114
						satellite.frame = C|FF_FULLBRIGHT
					elseif timer == 116
						satellite.frame = D|FF_FULLBRIGHT
					elseif timer == 118
						satellite.frame = E|FF_FULLBRIGHT
					elseif timer == 120
						satellite.frame = F|FF_FULLBRIGHT
					elseif timer == 122
						satellite.frame = G|FF_FULLBRIGHT
					elseif timer == 124
						satellite.frame = H|FF_FULLBRIGHT
					elseif timer == 126
						satellite.frame = I|FF_FULLBRIGHT
						
						local ol = P_SpawnMobj(mo.x, mo.y, satellite.z + 32*FRACUNIT, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_EMERALD
						ol.scale = 1
						ol.destscale = FRACUNIT*32
						ol.scalespeed = FRACUNIT/5
						ol.frame = B|FF_FULLBRIGHT
						ol.tics = 20
						//Ping, im been hakk
						playSound(mo.battlen, sfx_s3k86)
						ol = P_SpawnMobj(mo.x, mo.y, satellite.z + 32*FRACUNIT, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_JET
						ol.scale = 1
						ol.destscale = FRACUNIT*32
						ol.scalespeed = FRACUNIT
						ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
						ol.tics = 8
						
					elseif timer == 128
						satellite.frame = J|FF_FULLBRIGHT
					elseif timer == 130
						satellite.frame = K|FF_FULLBRIGHT //I am SO sorry to anyone reading this, please don't do this stupid example of mine
					elseif timer == 132
						satellite.frame = L|FF_FULLBRIGHT
					elseif timer == 134
						satellite.frame = M|FF_FULLBRIGHT
					elseif timer == 136
						satellite.frame = N|FF_FULLBRIGHT
					elseif timer == 138
						satellite.frame = O|FF_FULLBRIGHT
					elseif timer == 140
						satellite.frame = P|FF_FULLBRIGHT
					elseif timer == 142
						satellite.frame = Q|FF_FULLBRIGHT
					elseif timer == 144
						satellite.frame = R|FF_FULLBRIGHT
					elseif timer == 146
						satellite.frame = S|FF_FULLBRIGHT
					elseif timer == 148
						satellite.frame = T|FF_FULLBRIGHT
					elseif timer == 150
						satellite.frame = U|FF_FULLBRIGHT
					elseif timer == 152
						satellite.frame = V|FF_FULLBRIGHT
					elseif timer == 154 //,,,I couldve used a  for i = 1,26 and done iftimer = i or something 
						satellite.frame = W|FF_FULLBRIGHT
					elseif timer == 156
						satellite.frame = X|FF_FULLBRIGHT
					elseif timer == 158 //No that wouldnt work anyways??? Right??? lol
						satellite.frame = Y|FF_FULLBRIGHT
					elseif timer == 160
						satellite.frame = Z|FF_FULLBRIGHT //wATCH me not get the DAMN ALPHABET correct
					end
				end// HOW DID I FORGET THIS END- yeah 2 IQ
				if timer >= 161
				and timer < 195 //fine dont work, i'll do this instead
					if not (leveltime%(P_RandomRange(3,10)))
						playSound(mo.battlen, sfx_s3k89)
					end
					if timer == 161
						playSound(mo.battlen, sfx_s3k84)
					end
					local satellite = mo.satellite
					local satx = mo.x + 48*cos(mo.angle +ANGLE_270) 
					local saty = mo.y + 48*sin(mo.angle +ANGLE_270)
					local cthok = P_SpawnMobj(satx, saty, satellite.z - 32*FRACUNIT, MT_DUMMY)
					cthok.flags = MF_NOBLOCKMAP
					cthok.color = SKINCOLOR_CYAN //Charge vfx which is actually to verify target
					cthok.frame = A
					cthok.tics = 2
					if timer < 170
					cthok.scale = FRACUNIT/4
					elseif timer < 180
					cthok.scale = FRACUNIT/2
					elseif timer < 190
					cthok.scale = FRACUNIT
					else
					cthok.scale = FRACUNIT*2
	//				cthok.destscale = 3*FRACUNIT //Make beeger
	//				cthok.scalespeed = (FRACUNIT*3)/20
					end
				end//I can't fire properly so... Lets just uh pretend we did LMAO
				if timer == 195
					local cx = stgt.x + 256*cos(stgt.angle)
					local cy = stgt.y + 256*sin(stgt.angle)
					P_TeleportMove(cam, cx, cy, stgt.z + FRACUNIT*16)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, stgt.x, stgt.y) //They're fucked lol
					mo.satellite.tics = 5
					mo.satellite = nil //Don't need this anymore
				end
				if timer >= 195
				and timer < 230
					if timer == 195
						playSound(mo.battlen, sfx_s3ka1)
					end
					for i = 1, 5
						local thoka = P_SpawnMobj(stgt.x + P_RandomRange(-256, 256)*FRACUNIT, stgt.y + P_RandomRange(-256, 256)*FRACUNIT, stgt.z, MT_DUMMY)
						thoka.flags = MF_NOBLOCKMAP
						thoka.color = SKINCOLOR_CYAN
						if timer%2 then thoka.color = SKINCOLOR_ICY end
						thoka.frame = A
						thoka.tics = 10 //Hackerlass
						thoka.scale = FRACUNIT/2
						thoka.scalespeed = (FRACUNIT/2)/9
						thoka.destscale = 1
						thoka.momz = P_RandomRange(12, 64)*FRACUNIT
					end
					localquake(mo.battlen, FRACUNIT*12, 2)
					if timer == 210
						local cx = stgt.x + 768*cos(stgt.angle)
						local cy = stgt.y + 768*sin(stgt.angle)
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, stgt.z + FRACUNIT*64, 50*FRACUNIT)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, stgt.x, stgt.y) //They're fucked lol
					end
				elseif timer >= 230
				and timer < 300 
					if not (leveltime%10)
						playSound(mo.battlen, sfx_s3kc4s)
						playSound(mo.battlen, sfx_s3kc4s)
					end
					if timer == 230
						playSound(mo.battlen, sfx_s3kd0s)
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 4, 5)
							end
						end
					end
					if timer == 298
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 5, 2)
							end
						end
					end
					if timer == 265
						--if stgt.boss
							damageObject(stgt)
						--else
						--	damageObject(stgt, stgt.hp)
						--end
					end
					localquake(mo.battlen, FRACUNIT*64, 10)
					local beam = P_SpawnMobj(stgt.x, stgt.y, stgt.z + FRACUNIT*640, MT_DUMMY)
					beam.flags = MF_NOBLOCKMAP
					beam.sprite = SPR_SATB
					beam.frame = A|FF_FULLBRIGHT
					beam.tics = 20 //Hackerlass
					beam.scale = 5*stgt.scale
					beam.momz = -48*FRACUNIT
				end
				
					local j = mo.columns and #mo.columns or 0
					while j
						local m = mo.columns[j]
						if not m or not m.valid
							j = $-1
							continue
						end

						for i = 1, 5
							local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.colorized = true
							boom.color = SKINCOLOR_CYAN
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*3
						end
						P_StartQuake(FRACUNIT*8, 1)
						j = $-1
					end
					
				if timer == 300
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 1, 10)
						end
					end
					for i = 1,#hittargets
						local target = hittargets[i]
						damageObject(target)
					end
					mo.fangle = (R_PointToAngle(stgt.x, stgt.y)) + ANG1*180
					mo.columns = {}
					playSound(mo.battlen, sfx_megi5)
					playSound(mo.battlen, sfx_s3k9f)

					local a = mo.fangle - ANG1*80

					for i = 1, 16
						local m = P_SpawnMobj(stgt.x, stgt.y, stgt.z, MT_DUMMY)
						P_InstaThrust(m, a, FRACUNIT*48)
						mo.columns[#mo.columns+1] = m
						m.state = S_INVISIBLE
						m.tics = TICRATE
						a = $+ ANG1*10
					end
				end
				if timer == 330
					mo.hudcharx = nil
					return true
				end
			end,
	}

end
