freeslot("sfx_trbuff", "sfx_mstquz")

personaList["lloydskillset"].trait = "tr_masterforce"
attackDefs["tr_masterforce"] = {
		name = "Force",
		type = ATK_PASSIVE,
		passive = PSV_ONDAMAGE,
		implicit = "tr_masterforce.pt2",
		desc = C2SBarEdits and "Killing enemies restores some CP.\nHP below 20% eventually gains a STR Buff\nand a lot of CP once per fight."
		or "Killing enemies restores some SP.\nHP below 20% eventually gains a STR Buff\nand a lot of SP once per fight.",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
		anim = 	function(mo, target)
					if target != mo and not target.hp
						local regen = 5
						if mo.level > 80
							regen = 25
						elseif mo.level > 60
							regen = 20
						elseif mo.level > 40
							regen = 15
						elseif mo.level > 20
							regen = 10
						end
						if C2SBarEdits
							damageTP(mo, -regen)
						else
							damageSP(mo, -regen)
						end
						playSound(mo.battlen, sfx_mstquz)
						for i = 1,10
							local ol = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*30, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_SUPERRED5
							ol.scale = 1
							ol.destscale = mo.scale*3
							ol.scalespeed = (mo.scale*3)/15
							ol.frame = B|FF_TRANS80|FF_FULLBRIGHT
							ol.tics = i + 5
						end						
					end
				end,
	}

attackDefs["tr_masterforce.pt2"] = {
		name = "Force",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Low HP portiong of the Force Master Quartz.",
		norandom = true,
		norogue = true,
		anim = function(mo, targets, hittargets, timer)
			if mo.hp <= mo.maxhp/5 and not mo.masterforce_used
			or mo.continue_masterforce --in case you somehow get healed while the anim is playing
				mo.continue_masterforce = true
				if timer == 15
					playSound(mo.battlen, sfx_trbuff)
					playSound(mo.battlen, sfx_mstquz)
					if mo.level > 40
						buffStat(mo, "atk", 50)
					else
						buffStat(mo, "atk", 25)
					end
				elseif timer > 15 and timer <= 30
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 20 and mo.level > 40
					for i = 1,10
						local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_SUPERRED5
						ol.scale = 1
						ol.destscale = mo.scale*3
						ol.scalespeed = (mo.scale*3)/15
						ol.frame = B|FF_TRANS80
						ol.tics = i + 5
					end
					local regen = 50
					if mo.level > 80
						regen = 200
					elseif mo.level > 60
						regen = 100
					end
					if C2SBarEdits
						damageTP(mo, -regen)
					else
						damageSP(mo, -regen)
					end


				elseif timer == 35
					mo.continue_masterforce = nil
					mo.masterforce_used = true
					return true
				end
			else		
				return true
			end
		end,
	}

local function force_reset(mo)
	if not mo or not mo.valid return end
	local btl = server.P_BattleStatus[mo.battlen]
	if btl and not btl.running and mo.masterforce_used
		mo.masterforce_used = nil
	end
end

addHook("MobjThinker", force_reset, MT_PFIGHTER)


personaList["estelleskillset"].trait = "tr_mastercanon"
attackDefs["tr_mastercanon"] = {
		name = "Canon",
		type = ATK_PASSIVE|ATK_HEAL,
		desc = "Increases healing power by 25%.\nRecovers 4% HP per turn",
		power = 25,
		passive = PSV_BOOST,
		implicit = "tr_mastercanon.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
	}

attackDefs["tr_mastercanon.pt2"] = {
		name = "Canon",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Increases healing power by 25%.\nRecovers 4% HP per turn",
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = max(1, target.maxhp*4 / 100)
				playSound(mo.battlen, sfx_mstquz)
				damageObject(target, -heals, DMG_NORMAL, true)
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*30, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BLUE
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer >= 1 and timer <= 10
			and (timer%5) == 0
				local s = P_SpawnMobj(mo.x + P_RandomRange(-58, 58)<<FRACBITS, mo.y + P_RandomRange(-58, 58)<<FRACBITS, mo.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1			
			
			elseif timer == 20
				return true
			end
		end,
	}
	
personaList["joshuaskillset"].trait = "tr_mastersubaru"
attackDefs["tr_mastersubaru"] = {
		name = "Subaru",
		type = ATK_PASSIVE|ATK_SLASH|ATK_STRIKE|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC|ATK_PSY|ATK_NUCLEAR|ATK_CURSE|ATK_BLESS,
		desc = "Dodges all attacks by 7%(Almighty excluded).\nWhen HP is below 20% gains \n2 stage AGI Buff.",
		power = 7,
		passive = PSV_DODGE,
		implicit = "tr_mastersubaru.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
	}

attackDefs["tr_mastersubaru.pt2"] = {
		name = "Subaru",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Dodges all attacks by 7%(Almighty excluded).\nWhen HP is below 20% gains a AGI Buff.",
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			if mo.hp <= mo.maxhp/5
			or mo.continue_masterforce --in case you somehow get healed while the anim is playing
				mo.continue_masterforce = true
				if timer == 15
					playSound(mo.battlen, sfx_trbuff)
					playSound(mo.battlen, sfx_mstquz)
					buffStat(mo, "agi", 50)
				elseif timer > 15 and timer <= 30
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_EMERALD
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 35
					mo.continue_masterforce = nil
					return true
				end
			else		
				return true
			end
		end,
	}	
	
personaList["titaskillset"].trait = "tr_masterdunamis"
attackDefs["tr_masterdunamis"] = {
		name = "Dunamis",
		type = ATK_PASSIVE,
		desc = "Recover a little bit of SP when \nattacking. When HP is 20%\ngain a MAG buff..",
		passive = PSV_TRIGGERDAMAGE,
		implicit = "tr_masterdunamis.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,		
		anim = function(mo, target, dmg, crit)
			if dmg
				damageSP(mo, -(dmg/20))
				playSound(mo.battlen, sfx_mstquz)
			end	
		end,
	}

attackDefs["tr_masterdunamis.pt2"] = {
		name = "Dunamis",
		type = ATK_PASSIVE,
		desc = "Recover a little bit of SP when \nattacking. When HP is 20%\n gains a MAG buff.",
		passive = PSV_STARTTURN,
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			if mo.hp <= mo.maxhp/5
			or mo.continue_masterdunamis --in case you somehow get healed while the anim is playing
				mo.continue_masterdunamis = true
				if timer == 15
					playSound(mo.battlen, sfx_trbuff)
					playSound(mo.battlen, sfx_mstquz)
					buffStat(mo, "mag", 50)
				elseif timer > 15 and timer <= 30
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_TEAL
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 35
					mo.continue_masterdunamis = nil
					return true
				end
			else		
				return true
			end
		end,
	}	
	
personaList["elieskillset"].trait = "tr_masterpixie"
attackDefs["tr_masterpixie"] = {	
		name = "Pixie",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Recovers 4% SP per turn. \nAttacks have a random \nchance to cause status.",
		implicit = "tr_masterpixie.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",		
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = max(1, target.maxsp*4 / 100)
				playSound(mo.battlen, sfx_mstquz)
				damageSP(target, -heals, DMG_NORMAL, true)
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_MAGENTA
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer >= 1 and timer <= 10
			and (timer%5) == 0
				local s = P_SpawnMobj(mo.x + P_RandomRange(-58, 58)<<FRACBITS, mo.y + P_RandomRange(-58, 58)<<FRACBITS, mo.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1			
			
			elseif timer == 20
				return true
			end
		end,
	}
	
attackDefs["tr_masterpixie.pt2"] = {		
		name = "Pixie",
		type = ATK_PASSIVE,
		passive = PSV_TRIGGERDAMAGE,
		desc = "Recovers 4% SP per turn. \nAttacks have a random \nchance to cause status.",
		traitheader = "\x82".."Master Quartz".."\x80"..":",		
		norandom = true,
		norogue = true,		
		anim = function(mo, target, dmg, crit)
			local cond = {COND_BURN,COND_FREEZE,COND_SHOCK,COND_BRAINWASH,COND_DIZZY,COND_HEX,COND_SILENCE,COND_SLEEP,COND_DESPAIR,COND_RAGE,COND_HUNGER,COND_POISON}
			local bossres = 0
			
			if target.boss
				bossres = (target.status_res or 0)*4
			else
				bossres = 0
			end

			if (P_RandomRange(0, 100) <= 20 + (mo.luck - bossres - target.luck))
				target.cachestatus = cond[P_RandomRange(1,#cond)]
			end	
		end,
}


--Echoes


personaList["estelleskillset_fire"].trait = "tr_masterchevalier"
attackDefs["tr_masterchevalier"] = {
		name = "Chevalier",
		type = ATK_PASSIVE,
		desc = "Critical Chance x1.3,\nPhsyical/Craft Attacks \nmay inflict Shock.",
		implicit = "tr_masterchevalier.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
		norandom = true,
		norogue = true,
		passive = PSV_CRITBOOST,
		power = 30,
	}


attackDefs["tr_masterchevalier.pt2"] = {
		name = "Chevalier",
		type = ATK_PASSIVE,
		passive = PSV_ONDAMAGE,
		desc = "Physical attacks may inflict shock.",
		norandom = true,
		norogue = true,		
		anim = 	function(mo, target)
			local acc = 5
			if mo.level > 30 then acc = $+5 end
			if mo.level > 60 then acc = $+5 end
			acc = $+(mo.luck - target.luck)*3/4
			if target.boss then acc = $/2 end
			for i = 1, #mo.allies
				local ally = mo.allies[i]
				if target == ally or target == mo then return true end
			end
			if P_RandomRange(0,100) < acc
			and target.damagestate ~= DMG_MISS
			and target.damagestate ~= DMG_BLOCK
			and target.damagestate ~= DMG_DRAIN
			and not target.status_condition
			and target.hp
			and (mo.attack and isAttackPhysical(mo.attack))
				inflictStatus(target, COND_SHOCK)
			end
		end,
	}






