if ComboCrafts return end

rawset(_G, "ComboCrafts", true)



local Combo_Craft = BTL_splitSkills	--Combo Crafts
BTL_splitSkills = function(v)
	if v and v.valid and v.stats and charStats[v.stats] and charStats[v.stats].persona and not v.enemy
		if charStats[v.stats].c_craft and v.level and v.skin
			if server.gamemode == GM_VOIDRUN
				return
			end
			local ccraft = {}	--compile valid at-level combo crafts
			for k,j in ipairs(charStats[v.stats].c_craft or {false})
				if j
					if not j[1]
						print("\x82".."Warning: ".."\x80".."Combo Craft slot missing a target partner! Please make sure the first entry in your slot is a valid skin name.")
						playSound(v.battlen, sfx_not)
						break
					else
						local allycheck = false
						for i = 1, #v.allies_noupdate do
							if v.allies_noupdate[i].skin == j[1] then allycheck = true end
						end
						if not allycheck
							dprint(v.name.."'s Combo Craft target partner does not exist within the party, skipping.")
							break
						end
					end
					if not j[2]
						print("\x82".."Warning: ".."\x80".."Combo Craft slot missing a skill! Please make sure the second entry in your slot is a valid attack skill.")
						playSound(v.battlen, sfx_not)
						break
					end
					if v.level >= j[3]
						-- check skill flags
						if not attackDefs[j[2]].nometronome	--Probably a good idea not to let Metronome pull these.
						or not attackDefs[j[2]].norandom	--Ditto above.
						or not attackDefs[j[2]].norogue		--It'd be fine if not for Emerl and Kirby.
						or not attackDefs[j[2]].nocast		--I can't check the exact function here but you better have it anyway.
						or not attackDefs[j[2]].noenemycast	--There is no way these moves are safe in the hands of non-player fighters.
							print("\x82".."Warning: ".."\x80".."Loaded skill is not a valid Combo Craft. Please be sure your Combo Craft skill meets the required criteria.")
							playSound(v.battlen, sfx_not)
							break
						end
						-- check for prior versions, add
						local leveldown = false
						for l,m in ipairs(ccraft)
							if m and m[1] == j[1]
								if m[3] <= j[3]
									table.remove(ccraft, l)
									dprint(v.name.."'s Combo Craft successfully updated to level "..j[3]..".")
								else
									leveldown = true
									dprint(v.name.."'s new Combo Craft is lower level, keeping existing.")
								end
							end
						end
						if not leveldown
							ccraft[#ccraft+1] = j
							dprint(v.name.."'s Combo Craft successfully registered.")
						end
					end
				end
			end
			for l,m in ipairs(ccraft)
				v.skills[#v.skills+1] = m[2]
				dprint(v.name.." successfully added "..m[2].." Combo Craft to skill list.")
			end
			-- autosort skills
			table.sort(v.skills, attackSortFunc)
		end
	end
	Combo_Craft(v)
end






















