--Safe skill adding

local tr_addSkill = function(mo, skill)
			
	local check = false
					
	if #mo.skills
		for s = 1,#mo.skills
		local x = mo.skills[s]
			if skill == x
				check = true
			end
		end
	end
										
	if #mo.passiveskills
		for s = 1,#mo.passiveskills
		local x = mo.passiveskills[s]
			if skill == x
				check = true
				else
			end
		end
	end
									
	if not check
		if attackDefs[skill].type & ATK_PASSIVE
			mo.passiveskills[#mo.passiveskills+1] = skill
		else	
			mo.skills[#mo.skills+1] = skill
		end
	end
end




------{ Earth Arts }------

--ATTACK ARTS

--"Light" Single


	attackDefs["tr_stone_hammer"] = {
		name = "Stone Hammer",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 3,
		tr_orbal = true,	--custom aura effect & sounds
		desc = bionis and "Orbal Art (Liberlian) \nLight Earth Damage to one enemy."
			or "Orbal Art (Liberlian) \nLight Strike Damage to one enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
				
			if timer == 1
				playSound(mo.battlen, sfx_stoham)
				local rock = P_SpawnMobj(hittargets[1].x + FRACUNIT,
				hittargets[1].y + FRACUNIT,
				hittargets[1].z + P_RandomRange(1400, 1600)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*4
				rock.fuse = 20 
			end
			
			if timer == 25
				local target = hittargets[1]
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stohab)
				damageObject(hittargets[1])
				local boom = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z+20*FRACUNIT, MT_BOSSEXPLODE)
				boom.scale = 1
				boom.state = S_TNTDUST_1
				boom.destscale = FRACUNIT*7
				boom.colorized = true
				boom.scalespeed = ((207*FRACUNIT)/4)/15
				boom.color = SKINCOLOR_BROWN
			end	
			
			if timer == 27
				local target = hittargets[1]
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), target.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end		
					
			if timer == 45 
				return true
			end	
		end,
	}

	attackDefs["tr_stone_spike"] = {
		name = "Stone Spike",
		type = bionis and ATK_EARTH or ATK_PIERCE,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		status = bionis and COND_PETRIFY or COND_FREEZE,
		statuschance = 5,
		desc = bionis and "Orbal Art (Enigma series) \nLight Earth Damage to one enemy, \nMay Petrify."
			or "Orbal Art (Enigma series) \nLight Pierce Damage to one enemy, \nMay Freeze.",
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				playSound(mo.battlen, sfx_stospk)
			end		
		
			if timer == 20
				local m = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
				localquake(mo.battlen, FRACUNIT*5, 5)
				m.state = S_STONESPIKE1
				damageObject(hittargets[1])
			end
			
			if timer == 21
				local target = hittargets[1]
				local rndang = P_RandomRange(1,360)*ANG1
				for i = 1, 36
					local boom = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					boom.angle = rndang+(ANG10*i)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_BROWN
					boom.scale = FRACUNIT*1
					P_InstaThrust(boom,boom.angle,50*FRACUNIT)
					
					if (i%2)
						local b = P_SpawnMobj(target.x, target.y, target.z, MT_BOOMPARTICLE)
						b.momx = P_RandomRange(-32, 32)<<FRACBITS
						b.momy = P_RandomRange(-32, 32)<<FRACBITS
						b.momz = P_RandomRange(0, 16)<<FRACBITS
						b.fuse = TICRATE*6
					end
				end	
			end
			
			
			if timer == 40
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stosp2)
				for i = 1,5
					local rock = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z + FRACUNIT*3, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-6, 6)*FRACUNIT
					rock.momy = P_RandomRange(-6, 6)*FRACUNIT
					rock.momz = 5*FRACUNIT
					rock.fuse = TICRATE/2
					rock.scale = FRACUNIT*2
				end
			end
					
			if timer == 65 then return true end
		end,
	}

	attackDefs["tr_ivy_nail"] = {	--anim pending, desc pending
		name = "Ivy Nail",
		type = bionis and ATK_FOREST or ATK_PIERCE,	    		
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_POISON,
		statuschance = 20,
		desc = bionis and "Orbal Art (Arcus series) \nLight Forest Damage to one enemy."
			or "Orbal Art (Arcus series) \nLight Pierce Damage to one enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
				
			if timer == 1
				playSound(mo.battlen, sfx_stoham)
				local rock = P_SpawnMobj(hittargets[1].x + FRACUNIT,
				hittargets[1].y + FRACUNIT,
				hittargets[1].z + P_RandomRange(1400, 1600)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*4
				rock.fuse = 20 
			end
			
			if timer == 25
				local target = hittargets[1]
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stohab)
				damageObject(hittargets[1])
				local boom = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z+20*FRACUNIT, MT_BOSSEXPLODE)
				boom.scale = 1
				boom.state = S_TNTDUST_1
				boom.destscale = FRACUNIT*7
				boom.colorized = true
				boom.scalespeed = ((207*FRACUNIT)/4)/15
				boom.color = SKINCOLOR_BROWN
			end	
			
			if timer == 27
				local target = hittargets[1]
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), target.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end		
					
			if timer == 45 
				return true
			end	
		end,
	}


--"Light" Group


	attackDefs["tr_stone_impact"] = {
		name = "Stone Impact",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = bionis and "Orbal Art (Liberlian) \nLight Earth Damage (Area M)."
			or "Orbal Art (Liberlian) \nLight Strike Damage (Area M).",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)	
			local target = targets[1]
		
		
			if timer == 1
				playSound(mo.battlen, sfx_stoham)
				local rock = P_SpawnMobj(target.x + FRACUNIT,
				target.y + FRACUNIT,
				mo.z + P_RandomRange(1400, 1400)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*7
				rock.fuse = 22
			end
			
			if timer == 25
				localquake(mo.battlen, FRACUNIT*20, 20)
				playSound(mo.battlen, sfx_stohab)
				local boom = P_SpawnMobj(target.x, target.y, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
				boom.scale = 1
				boom.state = S_TNTDUST_1
				boom.frame = A|FF_FULLBRIGHT
				boom.destscale = FRACUNIT*15
				boom.colorized = true
				boom.color = SKINCOLOR_BROWN
				boom.scalespeed = ((207*FRACUNIT)/4)/15
			end
			
			if timer == 25
				for i = 1, #hittargets
					damageObject(hittargets[i])	--this should just hit everything highlighted
				end
			end
			
			if timer == 27
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
			
			if timer == 27
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
		
					
			if timer == 45 + 10*(#hittargets-1)
				return true
			end	
		end,
	}

	attackDefs["tr_quake"] = {
		name = "Quake",
		type = bionis and ATK_EARTH or ATK_STRIKE,
		power = 75,
		accuracy = 90,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = bionis and "Orbal Art (Enigma series) \nLight Earth Damage (Area M)."
			or "Orbal Art (Enigma series) \nLight Strike Damage (Area M).",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

		
			if timer == 1 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 2 and timer <= 10
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	

			
			if timer == 25 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 25 and timer <= 38
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	
		
			if timer == 50 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end
			
			if timer >= 50 and timer <= 59
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end				
			
			if timer == 60 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 60 and timer <= 70
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	

			
			if timer == 65
				playSound(mo.battlen, sfx_stosp2)
			end	
		
			for k,v in ipairs(hittargets)
				if timer == 65
					localquake(mo.battlen, FRACUNIT*25, 30)
					for i = 1,5
						local rock = P_SpawnMobj(v.x, v.y, v.z, MT_FALLINGROCK)
						rock.momx = P_RandomRange(-6, 6)*FRACUNIT
						rock.momy = P_RandomRange(-6, 6)*FRACUNIT
						rock.momz = 5*FRACUNIT
						rock.fuse = TICRATE/2
					end
					damageObject(v) --this should just hit everything highlighted
				end
			end
			
			if timer == 80 + #hittargets*3 then return true end
		end,
	}

	attackDefs["tr_needle_shoot_ii"] = {	--anim pending
		name = "Needle Shoot II",
		type = bionis and ATK_EARTH or ATK_PIERCE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = bionis and "Orbal Art (Arcus series) \nLight Earth Damage (Area M)."
			or "Orbal Art (Arcus series) \nLight Pierce Damage (Area M).",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

		
			if timer == 1 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 2 and timer <= 10
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	

			
			if timer == 25 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 25 and timer <= 38
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	
		
			if timer == 50 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end
			
			if timer >= 50 and timer <= 59
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end				
			
			if timer == 60 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 60 and timer <= 70
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	

			
			if timer == 65
				playSound(mo.battlen, sfx_stosp2)
			end	
		
			for k,v in ipairs(hittargets)
				if timer == 65
					localquake(mo.battlen, FRACUNIT*25, 30)
					for i = 1,5
						local rock = P_SpawnMobj(v.x, v.y, v.z, MT_FALLINGROCK)
						rock.momx = P_RandomRange(-6, 6)*FRACUNIT
						rock.momy = P_RandomRange(-6, 6)*FRACUNIT
						rock.momz = 5*FRACUNIT
						rock.fuse = TICRATE/2
					end
					damageObject(v) --this should just hit everything highlighted
				end
			end
			
			if timer == 80 + #hittargets*3 then return true end
		end,
	}


--"Medium" Single


	attackDefs["tr_petrify_breath"] = {
		name = "Petrify Breath",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 10,
		tr_orbal = true,	--custom aura effect & sounds
		status = bionis and COND_PETRIFY or COND_FREEZE,
		statuschance = 10,
		desc = bionis and "Orbal Art (Liberlian) \nMedium Earth Damage to one enemy. \n10% Petrify chance."
			or "Orbal Art (Liberlian) \nLight Medium Pierce to one enemy.. \n10% Freeze chance.",
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			
			if timer >= 10 and timer < 80
				if timer == 10
					playSound(mo.battlen, sfx_trpbrt)
				end
				if leveltime%2 == 0
					local thok = P_SpawnMobj(target.x+P_RandomRange(-60, 60)*FRACUNIT, target.y+P_RandomRange(-60, 60)*FRACUNIT, target.z+P_RandomRange(0, 20)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momz = P_RandomRange(3, 10)*FRACUNIT/3
					thok.color = SKINCOLOR_BEIGE
					thok.colorized = true
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*5
					
					local r = P_SpawnMobj(target.x + P_RandomRange(-40,40)*FRACUNIT,target.y + P_RandomRange(-40,40)*FRACUNIT, target.z, MT_THOK)
					r.flags = MF_NOGRAVITY
					r.sprite = SPR_BFUC
					r.frame = A
					r.fuse = 20
					r.colorized = true
					r.color = SKINCOLOR_BEIGE
					r.scale = FRACUNIT/5
					r.destscale = FRACUNIT*5
					r.scalespeed = (FRACUNIT*5)/20
				end

			elseif timer >= 80 and timer < 110
			
				if leveltime%2 == 0
					local thok = P_SpawnMobj(target.x+P_RandomRange(-30, 30)*FRACUNIT, target.y+P_RandomRange(-30, 30)*FRACUNIT, target.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-30, 30)*FRACUNIT/10
					thok.momy = P_RandomRange(-30, 30)*FRACUNIT/10
					thok.momz = P_RandomRange(10, 40)*FRACUNIT/3
					thok.color = SKINCOLOR_BEIGE
					thok.colorized = true
					thok.tics = 30
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*15
					thok.scalespeed = (FRACUNIT*15)/30
					
					local thok = P_SpawnMobj(target.x+P_RandomRange(-10, 10)*FRACUNIT, target.y+P_RandomRange(-10, 10)*FRACUNIT, target.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT/10
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT/10
					thok.momz = 16*FRACUNIT
					thok.color = SKINCOLOR_BEIGE
					thok.colorized = true
					thok.tics = 30
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*15
					thok.scalespeed = (FRACUNIT*15)/30
				end
			elseif timer == 130
				damageObject(target)
				playSound(mo.battlen, sfx_eethit)
				
			elseif timer == 150
				return true
			end
		end,

}


--"Medium" Group


	attackDefs["tr_grand_press"] = {
		name = "Grand Press",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 14,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = bionis and "Orbal Art (Arcus series) \nMedium Earth Damage (Set Area M), \nReduces Agility by 1 stage.".."\x82".."\n   Custom 1 for Pos Mode."
			or "Orbal Art (Arcus series) \nMedium Strike Damage (Set Area M), \nReduces Agility by 1 stage.".."\x82".."\n   Custom 1 for Pos Mode.",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)	
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2

			
			local cam = server.P_BattleStatus[mo.battlen].cam
			
			
			if timer == 1
				playSound(mo.battlen, sfx_grapre)
				S_StartSoundAtVolume(nil,sfx_grapre,70)
			end	

			if timer < 85
				if not (leveltime%10)
					local j = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)
					j.sprite = SPR_NTHK
					j.frame = FF_FULLBRIGHT|B
					j.color = SKINCOLOR_BROWN
					j.colorized = true
					j.fuse = TICRATE
					j.scale = 10*FRACUNIT
					j.destscale = 40*FRACUNIT
					j.momz = P_RandomRange(1, 5)*FRACUNIT
					j.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
					j.flags2 = MF2_SPLAT

					P_CreateFloorSpriteSlope(j)
					j.floorspriteslope.o = {
						x = j.x+32*FRACUNIT,
						y = j.y+32*FRACUNIT,
						z = j.z
					}
				end
			end

			if timer == 1 
				localquake(mo.battlen, FRACUNIT*5, 10)			
			end
			
			if timer == 25 
				localquake(mo.battlen, FRACUNIT*25, 10)
				local m = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)				
				m.state = S_LASERFLAME5
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 45
				m.scale = FRACUNIT*6	
				m.angle = cam.angle + ANGLE_90
			end
				
			if timer == 65
				playSound(mo.battlen, sfx_s1b9)
				localquake(mo.battlen, FRACUNIT*69, 75)
			end

			if timer == 65		
				local m = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = A
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
				localquake(mo.battlen, FRACUNIT*30, 30)
			
			elseif timer == 68
				local m = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = B
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
				
			elseif timer == 71
				local m = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = C
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
				
			elseif timer == 74
				local m = P_SpawnMobj(target.x, target.y, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = D
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
			end

			if timer >= 65 and timer <= 90
				if not (leveltime%3)
					for i = 1, 8
						local thok = P_SpawnMobj(target.x+(P_RandomRange(-312, 312)*FRACUNIT), target.y+(P_RandomRange(-312, 312)*FRACUNIT), mo.z+(P_RandomRange(0, 100)*FRACUNIT), MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = 30*FRACUNIT
						thok.scale = FRACUNIT*2
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 35)
					end	
				end	
			end	
			
			if timer == 65
				if #hittargets > 0	--In case we select nothing
					for k,v in ipairs(hittargets)
						damageObject(v) --this should just hit everything highlighted
						if v.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and v.damagestate ~= DMG_BLOCK
						and v.damagestate ~= DMG_DRAIN
							buffStat(v, "agi", -BUFFSTEP)	-- negative values lower a stat
						end
					end
				end
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end					
				
			if timer > 65 and timer < 100
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-138,138)*FRACUNIT
					local ry = target.y + P_RandomRange(-138,138)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, mo.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA //maybe?
					t.scale = 4*FRACUNIT
					t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
					t.fuse = 75
				end
			end	
					
			if timer == 115
				return true
			end	
		end,
	}

	attackDefs["tr_titanic_roar"] = {
		name = "Titanic Roar",
		type = bionis and ATK_EARTH or ATK_STRIKE,   		
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = bionis and "Orbal Art (Liberlian) \nMedium Earth Damage to all enemies."
			or "Orbal Art (Liberlian) \nMedium Strike Damage to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_cdfm14)
				localquake(mo.battlen, FRACUNIT*7, 5)
			end
			
			if timer == 20
				playSound(mo.battlen, sfx_s3kcbl)
				playSound(mo.battlen, sfx_cdfm19)
			end			
	
		
			if timer >= 20 and timer <= 90
				localquake(mo.battlen, FRACUNIT*10, 10)

				local rock = P_SpawnMobj(avgx + P_RandomRange(-500, 500)*FRACUNIT, avgy + P_RandomRange(-500, 500)*FRACUNIT, mo.z, MT_FALLINGROCK)
				rock.scale = P_RandomRange(FRACUNIT/8, FRACUNIT)
				rock.momz = P_RandomRange(1, 5)*FRACUNIT
				rock.fuse = 70
			end
			
			if timer >= 20 and timer <= 90
				if not (timer%5)			
					for i=1,10
						local bb = P_SpawnMobj(avgx + P_RandomRange(-300, 300)*FRACUNIT, avgy + P_RandomRange(-300, 300)*FRACUNIT, mo.z + mo.height/2, MT_ROCKCRUMBLE2)		
						bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
						bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
						bb.colorized = true
						bb.color = SKINCOLOR_BROWN
					end	
				end
			end	
				
			if timer >= 20 and timer <= 90
				if not (timer%10)
					playSound(mo.battlen, sfx_s3k59)
				end
			end	
				
			if timer == 100
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stosp2)
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
					for r = 1,5
						local rock = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*3, MT_FALLINGROCK)
						rock.momx = P_RandomRange(-6, 6)*FRACUNIT
						rock.momy = P_RandomRange(-6, 6)*FRACUNIT
						rock.momz = 5*FRACUNIT
						rock.fuse = TICRATE/2
						rock.scale = FRACUNIT*1
					end
				end
			end
			
			if timer == 120 then return true end
		end,
	}

	attackDefs["tr_petrify_cloud"] = {
		name = "Petrify Cloud",
		type = bionis and ATK_EARTH or ATK_STRIKE,   		
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		status = bionis and COND_PETRIFY or COND_FREEZE,
		statuschance = 10,
		tr_castarea = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = bionis and "Orbal Art (Liberlian) \nMedium Earth Damage (Area M). \n10% Petrify chance."
			or "Orbal Art (Liberlian) \nMedium Strike Damage (Area M). \n10% Freeze chance.",
		target = TGT_ALLENEMIES,	
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2
		
				
				
				
				
			if timer >= 10 and timer < 70
				if timer == 10
					playSound(mo.battlen, sfx_trpcld)
					playSound(mo.battlen, sfx_eethit)
					--playSound(mo.battlen, sfx_stohab)
					for i = 1, #hittargets
						local targ = hittargets[i]
						damageObject(targ)
					end
				end
				
				local portal = P_SpawnMobj(target.x, target.y, target.floorz+10*FRACUNIT, MT_DUMMY)
				portal.sprite = SPR_SHOT
				portal.scale = FRACUNIT*5
				portal.frame = E
				portal.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
				portal.frame = FF_FULLBRIGHT
				portal.blendmode = AST_ADD
				portal.colorized = true
				portal.color = SKINCOLOR_BEIGE
				portal.tics = 2
				
				if leveltime%2 == 0
					local thok = P_SpawnMobj(target.x+P_RandomRange(-30, 30)*FRACUNIT, target.y+P_RandomRange(-30, 30)*FRACUNIT, target.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-30, 30)*FRACUNIT
					thok.momy = P_RandomRange(-30, 30)*FRACUNIT
					thok.momz = P_RandomRange(10, 40)*FRACUNIT/5
					thok.color = SKINCOLOR_BEIGE
					thok.colorized = true
					thok.tics = 20
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*15
					thok.scalespeed = (FRACUNIT*15)/20
					
					local thok = P_SpawnMobj(target.x+P_RandomRange(-10, 10)*FRACUNIT, target.y+P_RandomRange(-10, 10)*FRACUNIT, target.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
					thok.momz = 16*FRACUNIT
					thok.color = SKINCOLOR_BEIGE
					thok.colorized = true
					thok.tics = 20
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*15
					thok.scalespeed = (FRACUNIT*15)/20
					
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 24
					local x, y = target.x+P_RandomRange(-180, 180)*FRACUNIT, target.y+P_RandomRange(-180, 180)*FRACUNIT
					for i = 1, 12
						local boom = P_SpawnMobj(x+P_RandomRange(-18, 18)*FRACUNIT, y+P_RandomRange(-18, 18)*FRACUNIT, target.floorz, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.colorized = true
						boom.color = SKINCOLOR_GOLD
						boom.momx = P_RandomRange(-4, 4)*FRACUNIT
						boom.momy = P_RandomRange(-4, 4)*FRACUNIT
						boom.momz = P_RandomRange(32, 96)*FRACUNIT
						boom.frame = FF_FULLBRIGHT
						boom.blendmode = AST_ADD
						boom.renderflags = $|RF_FULLBRIGHT

					end
				end	
				
			elseif timer == 90
				return true
			end
		end,
	}


--"Heavy" Single


	attackDefs["tr_earth_lance"] = {
		name = "Earth Lance",
		type = bionis and ATK_EARTH or ATK_PIERCE,	    		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		desc = bionis and "Orbal Art (Liberlian) \nHeavy Earth Damage to one enemy."
			or "Orbal Art (Liberlian) \nHeavy Pierce Damage to one enemy.",
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			
			if timer == 10
			or timer == 15
			or timer == 20
				local m = P_SpawnMobj(target.x, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)				
				m.sprite = SPR_EALC
				m.frame = D
				m.flags2 = $|MF2_SPLAT
				m.tics = 15
				m.scale = FRACUNIT*4
				localquake(mo.battlen, FRACUNIT*5, 5)
			end
			
			
			if timer == 10
			or timer == 15
			or timer == 20
				local m = P_SpawnMobj(target.x, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)				
				m.state = S_EARTHLANCE1
				m.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_erhlan)
				for i=1,10
				local bb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_ROCKCRUMBLE2)
					bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
					bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
				end
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
	
			elseif timer == 30
				damageObject(target)
				playSound(mo.battlen, sfx_erhla2)
			elseif timer == 50
				return true
			end
		end,

}


--"Heavy" Group


	attackDefs["tr_atlas_hammer"] = {
		name = "Atlas Hammer",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 14,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = bionis and "Orbal Art (Liberlian) \nHevay Earth Damage (Area M)."
			or "Orbal Art (Liberlian) \nHeavy Strike Damage (Area M).",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 10
				
				localquake(mo.battlen, 3*FRACUNIT, 40)
				playSound(mo.battlen, sfx_rocks3)
				mo.bod = {}
				mo.dbs = nil
				playSound(mo.battlen, sfx_traham)
			end
			
			if timer > 10 and timer < 90
				if timer < 50 and not (timer%3)
					
					local angle = P_RandomRange(1, 360)*ANG1
					local dist = 240
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					
					local rock = P_SpawnMobj(x, y, mo.z, MT_DUMMY)
					rock.state = S_ROCKCRUMBLEA
					rock.tics = -1
					rock.fuse = 80
					rock.scale = FRACUNIT*1
					rock.dist = 240
					rock.elev = 0
					rock.angle = angle
					mo.bod[#mo.bod+1] = rock
					
					for i = 1, 8
						local thok = P_SpawnMobj(rock.x+P_RandomRange(-24, 24)*FRACUNIT, rock.y+P_RandomRange(-24, 24)*FRACUNIT, rock.z, MT_DUMMY)
						thok.state = S_CDUST1
						thok.frame = $|FF_TRANS50
						thok.flags = MF_NOGRAVITY
						thok.momx = P_RandomRange(-20, 20)*FRACUNIT/10
						thok.momy = P_RandomRange(-20, 20)*FRACUNIT/10
						thok.momz = P_RandomRange(10, 40)*FRACUNIT/3
						thok.color = SKINCOLOR_BEIGE
						thok.colorized = true
						thok.tics = 10
						thok.scale = FRACUNIT
						thok.destscale = FRACUNIT*15
						thok.scalespeed = (FRACUNIT*15)/30
					end
				end
				if timer == 50
					mo.dbs = P_SpawnMobj(avgx, avgy, mo.z+(FRACUNIT*240), MT_DUMMY)
					mo.dbs.sprite = SPR_STLG
					mo.dbs.frame = B
					mo.dbs.tics = 60
					mo.dbs.flags = MF_NOGRAVITY
					mo.dbs.color = SKINCOLOR_FLAME
					mo.dbs.rollangle = 180*ANG1
					mo.dbs.colorized = true
					mo.dbs.spriteyscale = FRACUNIT*5/2
					mo.dbs.scale = FRACUNIT/3
					mo.dbs.scalespeed = FRACUNIT/12
					mo.dbs.destscale = FRACUNIT*3
					mo.dbs.momz = FRACUNIT/-2
				end
				if  mo.bod and #mo.bod
					for i = 1, #mo.bod do
						local s = mo.bod[i]
						if not s or not s.valid continue end	-- don't care

						s.angle = $+ ANG1*18
						if s.dist > 0
							s.dist = max(0, $-12)
						end
						if s.elev < 360
							s.elev = $+24
						elseif s.elev ~= 401
							s.elev = 401
							s.state = S_INVISIBLE
							for i = 1, 8
								local thok = P_SpawnMobj(s.x+P_RandomRange(-24, 24)*FRACUNIT, s.y+P_RandomRange(-24, 24)*FRACUNIT, s.z, MT_DUMMY)
								thok.state = S_CDUST1
								thok.frame = $|FF_TRANS50
								thok.flags = MF_NOGRAVITY
								thok.momx = P_RandomRange(-20, 20)*FRACUNIT/10
								thok.momy = P_RandomRange(-20, 20)*FRACUNIT/10
								thok.momz = P_RandomRange(-20, 20)*FRACUNIT/3
								thok.color = SKINCOLOR_BEIGE
								thok.colorized = true
								thok.tics = 10
								thok.scale = FRACUNIT
								thok.destscale = FRACUNIT*15
								thok.scalespeed = (FRACUNIT*15)/30
							end
						end
						P_TeleportMove(s, avgx + s.dist *cos(s.angle), avgy + s.dist*sin(s.angle), mo.floorz + s.elev*FRACUNIT)
					end
				end
			elseif timer == 90
				mo.dbs.flags = $ & ~MF_NOGRAVITY
				mo.dbs.momz = (mo.z - mo.dbs.z)/(6)
			elseif timer == 100
				for i = 1, 10
					local m = P_SpawnMobj(avgx, avgy, mo.floorz-20*FRACUNIT, MT_DUMMY)
					m.color = SKINCOLOR_FLAME
					m.colorized = true
					m.blendmode = AST_ADD
					m.renderflags = $|RF_FULLBRIGHT
					m.frame = A|FF_FULLBRIGHT
					m.sprite = SPR_BEAM
					m.scale = FRACUNIT*20
					m.tics = 20-i
					
					local portal = P_SpawnMobj(avgx, avgy, mo.floorz+10, MT_DUMMY)
					portal.sprite = SPR_SHOT
					portal.scale = FRACUNIT*2
					portal.frame = E
					portal.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
					portal.frame = FF_FULLBRIGHT
					portal.blendmode = AST_ADD
					portal.colorized = true
					portal.color = SKINCOLOR_FLAME
					portal.tics = 40-i
				end
				playSound(mo.battlen, sfx_tquake)
				playSound(mo.battlen, sfx_eethit)
				for i = 1, #hittargets
					damageObject(hittargets[i])	--this should just hit everything highlighted
				end
			elseif timer > 100 and timer < 130
				local grow = (timer-100)
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 160*grow/10
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					
					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_FLAME
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(1, 4)*FRACUNIT*grow/10
					aura.scale = FRACUNIT*4
					aura.destscale = FRACUNIT*10
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
			elseif timer == 130
				mo.bod = nil
				mo.dbs = nil
				return true
			end
		end,
	}

	attackDefs["tr_geo_cata"] = {
		name = "Geo Catastrophe",
		type = bionis and ATK_EARTH or ATK_STRIKE,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 18,
		tr_orbal = true,	--custom aura effect & sounds
		desc = bionis and "Orbal Art (Liberlian) \nHeavy Earth Damage to all enemies."
			or "Orbal Art (Liberlian) \nHeavy Strike Damage to all enemies.",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			

			if timer == 10
				playSound(mo.battlen, sfx_trgect)
				localquake(mo.battlen, FRACUNIT*5, 10)
				local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = SKINCOLOR_BRONZE
				ol.scale = FRACUNIT*1
				ol.destscale = FRACUNIT*70
				ol.scalespeed = FRACUNIT*2
				ol.flags2 = $|MF2_SPLAT
				ol.frame = B|FF_FULLBRIGHT
				ol.blendmode = AST_ADD
				ol.tics = 35
				ol.flags = $|MF_NOGRAVITY
				ol.momz = FRACUNIT*20
				
				mo.bod = {}
			end

			if timer > 10 and timer <= 80
				if not (timer%25)
					playSound(mo.battlen, sfx_stosp2)
					localquake(mo.battlen, FRACUNIT*10, 25)
				end
				if not (timer%5)
					
					local s = P_SpawnMobj(avgx + P_RandomRange(-300, 300)*FRACUNIT, avgy + P_RandomRange(-300, 300)*FRACUNIT, mo.z, MT_THOK)
					s.state = S_INVISIBLE
					s.fuse = 10
					mo.bod[#mo.bod+1] = s
				end
				
				if leveltime%2 == 0
					local thok = P_SpawnMobj(avgx+P_RandomRange(-30, 30)*FRACUNIT, avgy+P_RandomRange(-30, 30)*FRACUNIT, mo.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-30, 30)*FRACUNIT/10
					thok.momy = P_RandomRange(-30, 30)*FRACUNIT/10
					thok.momz = P_RandomRange(10, 40)*FRACUNIT/3
					thok.color = SKINCOLOR_BRONZE
					thok.colorized = true
					thok.tics = 30
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*15
					thok.scalespeed = (FRACUNIT*15)/30
					
					local thok = P_SpawnMobj(avgx+P_RandomRange(-30, 30)*FRACUNIT, avgy+P_RandomRange(-30, 30)*FRACUNIT, mo.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT/10
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT/10
					thok.momz = 24*FRACUNIT
					thok.color = SKINCOLOR_BEIGE
					thok.colorized = true
					thok.tics = 30
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*15
					thok.scalespeed = (FRACUNIT*15)/30
				end
			end	

			
			if  timer > 10 and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					
					if s.fuse == 10
						localquake(mo.battlen, FRACUNIT*25, 10)
						for i = 1,5
							local rock = P_SpawnMobj(s.x, s.y, s.z, MT_FALLINGROCK)
							rock.momx = P_RandomRange(-6, 6)*FRACUNIT
							rock.momy = P_RandomRange(-6, 6)*FRACUNIT
							rock.momz = 5*FRACUNIT
							rock.fuse = TICRATE/2
						end
						
						local ol = P_SpawnMobj(s.x, s.y, s.z, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_BRONZE
						ol.scale = FRACUNIT/3
						ol.destscale = FRACUNIT*70/3
						ol.scalespeed = FRACUNIT*2/3
						ol.flags2 = $|MF2_SPLAT
						ol.frame = B|FF_FULLBRIGHT
						ol.blendmode = AST_ADD
						ol.tics = 10
						ol.flags = $|MF_NOGRAVITY
						ol.momz = FRACUNIT*12
					end
					
					if leveltime%2 == 0
						local thok = P_SpawnMobj(s.x+P_RandomRange(-15, 15)*FRACUNIT, s.y+P_RandomRange(-15, 15)*FRACUNIT, s.z, MT_DUMMY)
						thok.state = S_CDUST1
						thok.frame = $|FF_TRANS50
						thok.flags = MF_NOGRAVITY
						thok.momx = P_RandomRange(-30, 30)*FRACUNIT/20
						thok.momy = P_RandomRange(-30, 30)*FRACUNIT/20
						thok.momz = P_RandomRange(10, 40)*FRACUNIT/6
						thok.color = SKINCOLOR_BRONZE
						thok.blendmode = AST_ADD
						thok.colorized = true
						thok.tics = 30
						thok.scale = FRACUNIT/2
						thok.destscale = FRACUNIT*8
						thok.scalespeed = (FRACUNIT*8)/30
						
						local thok = P_SpawnMobj(s.x+P_RandomRange(-15, 15)*FRACUNIT, s.y+P_RandomRange(-15, 15)*FRACUNIT, s.z, MT_DUMMY)
						thok.state = S_CDUST1
						thok.frame = $|FF_TRANS50
						thok.flags = MF_NOGRAVITY
						thok.momx = P_RandomRange(-10, 10)*FRACUNIT/20
						thok.momy = P_RandomRange(-10, 10)*FRACUNIT/20
						thok.momz = 16*FRACUNIT
						thok.color = SKINCOLOR_BEIGE
						thok.blendmode = AST_ADD
						thok.colorized = true
						thok.tics = 30
						thok.scale = FRACUNIT/2
						thok.destscale = FRACUNIT*8
						thok.scalespeed = (FRACUNIT*8)/30
					end
				end
			end
			
			
			
			
			if timer == 95
				localquake(mo.battlen, FRACUNIT*25, 30)
				playSound(mo.battlen, sfx_eethit)
				for k,v in ipairs(hittargets)
					for i = 1,5
						local rock = P_SpawnMobj(v.x, v.y, v.z, MT_FALLINGROCK)
						rock.momx = P_RandomRange(-6, 6)*FRACUNIT
						rock.momy = P_RandomRange(-6, 6)*FRACUNIT
						rock.momz = 5*FRACUNIT
						rock.fuse = TICRATE/2
					end
					damageObject(v) --this should just hit everything highlighted
				end
			end
			
			if timer == 120 then return true end
		end,
	}


--"Severe" Single



--"Severe" Group



--Support


attackDefs["tr_crest"] = {
		name = "Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art (Liberlian).\nRaises defence to 1 ally \nby 1 stage",
		target = TGT_ALLY,
		buff = true,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ORANGE))
		end,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["def"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_crest)
			end	
			
			
			if timer >= 10 and timer <= 70
				if not (timer%7)
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
					ol.sprite = SPR_CRST
					ol.scale = 1
					ol.destscale = FRACUNIT*1
					ol.scalespeed = FRACUNIT/3
					ol.frame = A|FF_TRANS50
					ol.tics = 13
				end
			end
			if timer == 70
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_ORANGE
					dust.scale = FRACUNIT*2
				end
			
			
			elseif timer == 71
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "def")
				
					
			elseif timer == 90
				return true
			end
		end,
}

attackDefs["tr_la_crest"] = {
		name = "La Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 9,
		tr_castarea = 4,
		desc = "Orbal Art (Liberlian).\nRaises defence by 1 stage (Area M)",
		target = TGT_ALLALLIES,
		buff = true,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ORANGE))
		end,
		anim = function(mo, targets, hittargets, timer)
			for i = 1,#hittargets
				local target = hittargets[i]
				
				if timer == 10 + (i-1)*4
					playSound(mo.battlen, sfx_crest)
				end	
				
				if timer >= 10 and timer <= 70 + (i-1)*4
					if not (timer%7)
						local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
						ol.sprite = SPR_CRST
						ol.scale = 1
						ol.destscale = FRACUNIT*1
						ol.scalespeed = FRACUNIT/3
						ol.frame = A|FF_TRANS50
						ol.tics = 13
					end
				end
				if timer == 70 + (i-1)*4
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_ORANGE
						dust.scale = FRACUNIT*2
					end
			
			
				elseif timer == 71 + (i-1)*4
					playSound(mo.battlen, sfx_buff)
					
					buffStat(target, "def")
				
					
				elseif timer == 90 + #hittargets*4
					return true
				end
			end	
		end,
}

attackDefs["tr_adamantine_shield"] = {
	name = "Adamantine Shield",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 24,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 3,
	desc = "Orbal Art (Arcus series).\nGive allies a barrier that \nblocks one physical attack each (Area M).",
	target = TGT_ALLY,
	nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
		local cancel = true
		for i = 1, #targets
		local target = targets[i]
			if not target.tr_craftGuard
				cancel = false
			end
		end
		if cancel
			BTL_logMessage(targets[1].battlen, "Crafts Guard already active!")
			return true
		end
	end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
	end,
	anim = function(mo, targets, hittargets, timer)
		for i = 1, #hittargets
			local target = hittargets[i]
			local avgx = 0
			local avgy = 0
			
			if timer == 10 and i == 1
				playSound(mo.battlen, sfx_adashd)
			end
			
			if timer == 10
				local x = target.x + 48*cos(target.angle)
				local y = target.y + 48*sin(target.angle)
				local m = P_SpawnMobj(x, y, target.z, MT_DUMMY)
				m.sprite = SPR_ADSL
				m.scale = FRACUNIT*1
				m.frame = A|FF_TRANS10|FF_PAPERSPRITE
				m.angle = target.angle + ANG1*90
				m.tics = 80
				target.shield = m
			elseif timer == 60
				target.shield.frame = A|FF_TRANS50|FF_PAPERSPRITE
			elseif timer == 65
				target.shield.frame = A|FF_TRANS60|FF_PAPERSPRITE
			elseif timer == 70	
				target.shield.frame = A|FF_TRANS70|FF_PAPERSPRITE
			elseif timer == 75	
				target.shield.frame = A|FF_TRANS80|FF_PAPERSPRITE
			elseif timer == 80	
				target.shield.frame = A|FF_TRANS90|FF_PAPERSPRITE	
			end	

			
			if timer >= 10 and timer <= 80
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_APRICOT
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					thok.frame = A|FF_TRANS70
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end

			
			if timer >= 10 and timer <= 80
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[i]
					avgx = $+ t.x/FRACUNIT
					avgy = $+ t.y/FRACUNIT
					local s = P_SpawnMobj(t.x + P_RandomRange(-58, 58)<<FRACBITS, t.y + P_RandomRange(-58, 58)<<FRACBITS, t.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end	
			end	
			
			if timer == 85
				local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
				target.tr_craftGuard = 1 --give them the tag 
				tr_addSkill(target, "tr_guard_check")
				BTL_logMessage(mo.battlen, target.name.." gains Crafts Guard (Physical nullifcation)!")
			end
		end
		
		if timer == 105
			return true
		end
	end,	
}



attackDefs["tr_earth_guard"] = {
	name = "Earth Guard",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 30,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nGive an ally a barrier that \nperfectly blocks one attack.",
	target = TGT_ALLY,
	nocast = function(targets, n)	-- we can't cast this skill if this function returns true
		local target = targets[n]
		if target.tr_perfectGuard
			BTL_logMessage(targets[1].battlen, "Perfect Guard already active!")
			return true
		end
	end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
	end,		
	anim = function(mo, targets, hittargets, timer)
	
		local target = hittargets[1]
		if timer == 10
			playSound(mo.battlen, sfx_ertgrd)
		end	
		
		if timer >= 10 and timer < 100
			summonAura(target, SKINCOLOR_GREEN)
		end	

		if timer > 10 and timer < 100
			if not (leveltime%5)
				local rx = target.x + P_RandomRange(-40,40)*FRACUNIT
				local ry = target.y + P_RandomRange(-40,40)*FRACUNIT
				local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
				t.state = S_ROCKCRUMBLEA
				t.colorized = true
				t.color = SKINCOLOR_BROWN
				t.scale = FRACUNIT*2
				t.momz = (P_RandomRange(4,8)/2)*FRACUNIT
				t.fuse = 30
			end
		end
		
		if timer == 10
		local cx = target.x + 64*cos(target.angle)
		local cy = target.y + 64*sin(target.angle)
		local fthok = P_SpawnMobj(cx, cy, target.z+16*FRACUNIT, MT_DUMMY)
			fthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
			fthok.color = SKINCOLOR_GREEN
			fthok.frame = A|FF_FULLBRIGHT
			fthok.tics = 9999
			fthok.angle = target.angle + ANGLE_90
			fthok.scale = FRACUNIT/2
			mo.fatom = fthok
		local dx = target.x + 64*cos(target.angle + ANGLE_180)
		local dy = target.y + 64*sin(target.angle + ANGLE_180)
			local bthok = P_SpawnMobj(dx, dy, target.z+16*FRACUNIT, MT_DUMMY)
			bthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
			bthok.color = SKINCOLOR_GREEN
			bthok.frame = A|FF_FULLBRIGHT
			bthok.tics = 9999
			bthok.angle = target.angle + ANGLE_270
			bthok.scale = FRACUNIT/2
			mo.batom = bthok
		end 
		
		if timer > 10
		and timer < 100
			P_InstaThrust(mo.fatom,mo.fatom.angle, FRACUNIT*40)
			mo.fatom.angle = $ + ANG1*25
			local thokf = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
			thokf.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
			thokf.color = SKINCOLOR_GREEN
			thokf.frame = A|FF_TRANS50
			thokf.tics = 5
			thokf.scale = FRACUNIT/4
			local thokff = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
			thokff.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
			thokff.color = SKINCOLOR_GREEN
			thokff.frame = A|FF_TRANS70
			thokff.tics = 10
			thokff.scale = FRACUNIT/4
			P_InstaThrust(mo.batom,mo.batom.angle, FRACUNIT*40)
			mo.batom.angle = $ + ANG1*25
			local thokb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
			thokb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
			thokb.color = SKINCOLOR_GREEN
			thokb.frame = A|FF_TRANS50
			thokb.tics = 5
			thokb.scale = FRACUNIT/4
			local thokbb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
			thokbb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
			thokbb.color = SKINCOLOR_GREEN
			thokbb.frame = A|FF_TRANS70
			thokbb.tics = 10
			thokbb.scale = FRACUNIT/4
		end
		
		if timer == 98
			mo.fatom.tics = 2
			mo.batom.tics = 2	
		end

		if timer == 105
			local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
			thok.state = S_INVISIBLE
			thok.tics = 1
			A_OldRingExplode(thok, MT_SUPERSPARK)
			target.tr_perfectGuard = 1 --give them the tag 
			tr_addSkill(target, "tr_guard_check")
			BTL_logMessage(mo.battlen, target.name.." gains Perfect Guard (Attack nullifcation)!")
			playSound(mo.battlen, sfx_hamas2)
			playSound(mo.battlen, sfx_curia)
		end

		
		if timer == 140
			mo.fatom = nil
			mo.batom = nil
			return true	
		end
	end,
}	

attackDefs["tr_earth_wall"] = {
	name = "Earth Wall",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 40,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 2,
	desc = "Orbal Art (Liberlian).\nGive allies a barrier that \nperfectly blocks one attack each (Area S).",
	target = TGT_ALLY,
	nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
		local cancel = true
		for i = 1, #targets
		local target = targets[i]
			if not target.tr_perfectGuard
				cancel = false
			end
		end
		if cancel
			BTL_logMessage(targets[1].battlen, "Perfect Guard already active!")
			return true
		end
	end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
	end,	
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			mo.fatom = {}
			mo.batom = {}
		end
		
		for i = 1, #targets
			local target = targets[i]
			if timer == 10 + (i-1)*16
				playSound(mo.battlen, sfx_ertgrd)
			end	
			
			if timer >= 10 + (i-1)*16 and timer < 100 + (i-1)*16
				summonAura(target, SKINCOLOR_GREEN)
			end	

			if timer > 10 + (i-1)*16 and timer < 100 + (i-1)*16
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-40,40)*FRACUNIT
					local ry = target.y + P_RandomRange(-40,40)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.colorized = true
					t.color = SKINCOLOR_BROWN
					t.scale = FRACUNIT*2
					t.momz = (P_RandomRange(4,8)/2)*FRACUNIT
					t.fuse = 30
				end
			end
			
			if timer == 10 + (i-1)*16
			local cx = target.x + 64*cos(target.angle)
			local cy = target.y + 64*sin(target.angle)
			local fthok = P_SpawnMobj(cx, cy, target.z+16*FRACUNIT, MT_DUMMY)
				fthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				fthok.color = SKINCOLOR_GREEN
				fthok.frame = A|FF_FULLBRIGHT
				fthok.tics = 9999
				fthok.angle = target.angle + ANGLE_90
				fthok.scale = FRACUNIT/2
				mo.fatom[#mo.fatom+1] = fthok
			local dx = target.x + 64*cos(target.angle + ANGLE_180)
			local dy = target.y + 64*sin(target.angle + ANGLE_180)
				local bthok = P_SpawnMobj(dx, dy, target.z+16*FRACUNIT, MT_DUMMY)
				bthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				bthok.color = SKINCOLOR_GREEN
				bthok.frame = A|FF_FULLBRIGHT
				bthok.tics = 9999
				bthok.angle = target.angle + ANGLE_270
				bthok.scale = FRACUNIT/2
				mo.batom[#mo.batom+1] = bthok
			end 
			
			if timer > 10 + (i-1)*16
			and timer < 100 + (i-1)*16
				P_InstaThrust(mo.fatom[i],mo.fatom[i].angle, FRACUNIT*40)
				mo.fatom[i].angle = $ + ANG1*25
				local thokf = P_SpawnMobj(mo.fatom[i].x, mo.fatom[i].y, mo.fatom[i].z+8*FRACUNIT, MT_DUMMY)
				thokf.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokf.color = SKINCOLOR_GREEN
				thokf.frame = A|FF_TRANS50
				thokf.tics = 5
				thokf.scale = FRACUNIT/4
				local thokff = P_SpawnMobj(mo.fatom[i].x, mo.fatom[i].y, mo.fatom[i].z+8*FRACUNIT, MT_DUMMY)
				thokff.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokff.color = SKINCOLOR_GREEN
				thokff.frame = A|FF_TRANS70
				thokff.tics = 10
				thokff.scale = FRACUNIT/4
				P_InstaThrust(mo.batom[i],mo.batom[i].angle, FRACUNIT*40)
				mo.batom[i].angle = $ + ANG1*25
				local thokb = P_SpawnMobj(mo.batom[i].x, mo.batom[i].y, mo.batom[i].z+8*FRACUNIT, MT_DUMMY)
				thokb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokb.color = SKINCOLOR_GREEN
				thokb.frame = A|FF_TRANS50
				thokb.tics = 5
				thokb.scale = FRACUNIT/4
				local thokbb = P_SpawnMobj(mo.batom[i].x, mo.batom[i].y, mo.batom[i].z+8*FRACUNIT, MT_DUMMY)
				thokbb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokbb.color = SKINCOLOR_GREEN
				thokbb.frame = A|FF_TRANS70
				thokbb.tics = 10
				thokbb.scale = FRACUNIT/4
			end
			
			if timer == 98 + (i-1)*16
				mo.fatom[i].tics = 3
				mo.batom[i].tics = 3
				
			elseif timer == 100 + (i-1)*16
				--we're going to hold the positions our particles previously took with a dummy string so the remaining particles don't get bumped out of order.
				mo.fatom[i] = "done"
				mo.batom[i] = "done"
			end

			if timer == 105 + (i-1)*16
				local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
				target.tr_perfectGuard = 1 --give them the tag 
				tr_addSkill(target, "tr_guard_check")
				BTL_logMessage(mo.battlen, target.name.." gains Perfect Guard (Attack nullifcation)!")
				playSound(mo.battlen, sfx_hamas2)
				playSound(mo.battlen, sfx_curia)
			end
		end
		
		if timer == 140 + (#targets-1)*16
			mo.fatom = nil
			mo.batom = nil
			return true	
		end
	end,
}	

attackDefs["tr_gaia_shield"] = {
	name = "Gaia Shield",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 80,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nGive all allies a barrier that \nperfectly blocks one attack each.",
	target = TGT_ALLALLIES,
	nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
		local cancel = true
		for i = 1, #targets
		local target = targets[i]
			if not target.tr_perfectGuard
				cancel = false
			end
		end
		if cancel
			BTL_logMessage(targets[1].battlen, "Perfect Guard already active!")
			return true
		end
	end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
	end,
	anim = function(mo, targets, hittargets, timer)
	
		local avgx, avgy = 0, 0
		for i = 1, #targets -- Get average position of targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = ($/#targets)*FRACUNIT
		avgy = ($/#targets)*FRACUNIT
	
		if timer == 1
			mo.fatom = {}
			mo.batom = {}
		end
			
		if timer == 10
			playSound(mo.battlen, sfx_trgai1)
		end
		
		for i = 1, 4
			local time = timer - (5*(i-1))
			if time == 10
				local ang = 90*ANG1*i
				local x = avgx + 360 *cos(ang)
				local y = avgy + 360 *sin(ang)
				
				local c = P_SpawnMobj(x, y, mo.z, MT_DUMMY)
				c.sprite = SPR_STLG
				c.frame = B
				c.tics = 140
				c.spriteyscale = FRACUNIT*3
				c.scale = FRACUNIT/3
				c.scalespeed = FRACUNIT/3
				c.destscale = FRACUNIT*2
			end
			
			if time == 150
				for r = 1, 5
					local ang = 90*ANG1*i
					local x = avgx + 480 *cos(ang)
					local y = avgy + 480 *sin(ang)
				
					local nrock = P_SpawnMobj(x, y, mo.z+(60*FRACUNIT), MT_FALLINGROCK)
					nrock.momx = P_RandomRange(-6, 6)*FRACUNIT
					nrock.momy = P_RandomRange(-6, 6)*FRACUNIT
					nrock.momz = P_RandomRange(1,3)*FRACUNIT
					nrock.fuse = TICRATE/2
				end
			end
		end
		if timer == 20
			playSound(mo.battlen, sfx_ertgrd)
		end
		if timer > 20 and timer <= 50
			if timer == 21
				playSound(mo.battlen, sfx_trgai2)	--placeholder
			end
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 240
			for i = 0, 12
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, mo.z+i*FRACUNIT, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_GOLD
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(1, 5)*FRACUNIT
				aura.scale = FRACUNIT*5
				aura.destscale = FRACUNIT*25
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(20, 40))
			end
			if not (timer%2)
				for i = 1, #targets
					local target = targets[i]
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.color = SKINCOLOR_GOLD
					m.colorized = true
					m.blendmode = AST_ADD
					m.renderflags = $|RF_FULLBRIGHT
					m.frame = A|FF_FULLBRIGHT
					m.sprite = SPR_BEAM
					m.scale = FRACUNIT*(60-timer)/5
					m.tics = 50
				end
			end
		end
		
		for i = 1, #targets
			local target = targets[i]
			if timer >= 40
				summonAura(target, SKINCOLOR_GREEN)
			end	

			if timer > 40
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-40,40)*FRACUNIT
					local ry = target.y + P_RandomRange(-40,40)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.colorized = true
					t.color = SKINCOLOR_BROWN
					t.scale = FRACUNIT*2
					t.momz = (P_RandomRange(4,8)/2)*FRACUNIT
					t.fuse = 30
				end
			end
			
			if timer == 40
			local cx = target.x + 64*cos(target.angle)
			local cy = target.y + 64*sin(target.angle)
			local fthok = P_SpawnMobj(cx, cy, target.z+16*FRACUNIT, MT_DUMMY)
				fthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				fthok.color = SKINCOLOR_GREEN
				fthok.frame = A|FF_FULLBRIGHT
				fthok.tics = 9999
				fthok.angle = target.angle + ANGLE_90
				fthok.scale = FRACUNIT/2
				mo.fatom[#mo.fatom+1] = fthok
			local dx = target.x + 64*cos(target.angle + ANGLE_180)
			local dy = target.y + 64*sin(target.angle + ANGLE_180)
				local bthok = P_SpawnMobj(dx, dy, target.z+16*FRACUNIT, MT_DUMMY)
				bthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				bthok.color = SKINCOLOR_GREEN
				bthok.frame = A|FF_FULLBRIGHT
				bthok.tics = 9999
				bthok.angle = target.angle + ANGLE_270
				bthok.scale = FRACUNIT/2
				mo.batom[#mo.batom+1] = bthok
			end 
			
			if timer > 40
			and timer < 130
				P_InstaThrust(mo.fatom[i],mo.fatom[i].angle, FRACUNIT*40)
				mo.fatom[i].angle = $ + ANG1*25
				local thokf = P_SpawnMobj(mo.fatom[i].x, mo.fatom[i].y, mo.fatom[i].z+8*FRACUNIT, MT_DUMMY)
				thokf.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokf.color = SKINCOLOR_GREEN
				thokf.frame = A|FF_TRANS50
				thokf.tics = 5
				thokf.scale = FRACUNIT/4
				local thokff = P_SpawnMobj(mo.fatom[i].x, mo.fatom[i].y, mo.fatom[i].z+8*FRACUNIT, MT_DUMMY)
				thokff.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokff.color = SKINCOLOR_GREEN
				thokff.frame = A|FF_TRANS70
				thokff.tics = 10
				thokff.scale = FRACUNIT/4
				P_InstaThrust(mo.batom[i],mo.batom[i].angle, FRACUNIT*40)
				mo.batom[i].angle = $ + ANG1*25
				local thokb = P_SpawnMobj(mo.batom[i].x, mo.batom[i].y, mo.batom[i].z+8*FRACUNIT, MT_DUMMY)
				thokb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokb.color = SKINCOLOR_GREEN
				thokb.frame = A|FF_TRANS50
				thokb.tics = 5
				thokb.scale = FRACUNIT/4
				local thokbb = P_SpawnMobj(mo.batom[i].x, mo.batom[i].y, mo.batom[i].z+8*FRACUNIT, MT_DUMMY)
				thokbb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokbb.color = SKINCOLOR_GREEN
				thokbb.frame = A|FF_TRANS70
				thokbb.tics = 10
				thokbb.scale = FRACUNIT/4
			end
			
			if timer == 128
				mo.fatom[i].tics = 3
				mo.batom[i].tics = 3
				
			elseif timer == 130
				--we're going to hold the positions our particles previously took with a dummy string so the remaining particles don't get bumped out of order.
				mo.fatom[i] = "done"
				mo.batom[i] = "done"
			end

			if timer == 135
				local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
				target.tr_perfectGuard = 1 --give them the tag 
				tr_addSkill(target, "tr_guard_check")
				BTL_logMessage(mo.battlen, target.name.." gains Perfect Guard (Attack nullifcation)!")
				if i == 1
					playSound(mo.battlen, sfx_hamas2)
					playSound(mo.battlen, sfx_curia)
				end
			end
		end
		
		if timer == 180
			mo.fatom = nil
			mo.batom = nil
			return true	
		end
	end,
}	


attackDefs["tr_petrosphere"] = {
	name = "Petrosphere",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 15,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 2,
	desc = "Orbal Art (Liberlian).\nReduces enemy Agiliy by 2 stages (Area S).",
	target = TGT_ALLENEMIES,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
	end,		
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy, avgz = 0, 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
			avgz = $ + targets[i].z/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT
		avgz = ($/#targets)	*FRACUNIT
		
		if timer == 10
			playSound(mo.battlen, sfx_trpts2)
		end
		
		for t = 1, 4
			local time = timer - (20*(t-1))
			if time >= 10 and time <= 40	--dark circles
				local grow = (50-time)
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 128*grow/10
				for i = 0, 8
					local angle = baseangle + i*18*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.color = SKINCOLOR_VIOLET
					aura.momz = FRACUNIT*-1
					aura.scale = FRACUNIT*1*grow/10
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
				if timer == 80
					playSound(mo.battlen, sfx_trptsp)
				end
			end
		end
		
		if timer > 80 and timer <= 90	--green, up 1st
			local grow = (timer-80)
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT*(grow+10)/6
				aura.scale = FRACUNIT*(grow+10)/10
				aura.destscale = FRACUNIT*4
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
			end
		elseif timer > 90 and timer <= 100	--down 1st
			local grow = (100-timer)
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT*(grow+10)/6
				aura.scale = FRACUNIT*(grow+10)/10
				aura.destscale = FRACUNIT*4
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
			end
		elseif timer > 100 and timer <= 115	--up 2nd
			local grow = (timer-100)*2
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT*(grow+10)/6
				aura.scale = FRACUNIT*(grow+10)/10
				aura.destscale = FRACUNIT*4
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
			end
		elseif timer > 115 and timer <= 130	--down 2nd
			local grow = (130-timer)*2
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT*(grow+10)/6
				aura.scale = FRACUNIT*(grow+10)/10
				aura.destscale = FRACUNIT*4
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
			end
		elseif timer > 130 and timer <= 160	--up final
			local grow = (timer-130)*3
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT*(grow+10)/6
				aura.scale = FRACUNIT*(grow+10)/10
				aura.destscale = FRACUNIT*4
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
			end
		elseif timer > 160 and timer <= 190	--down final
			local grow = (190-timer)*3
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT*(grow+10)/6
				aura.scale = FRACUNIT*(grow+10)/10
				aura.destscale = FRACUNIT*4
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
			end
			if timer == 190
				for i = 1, #targets do
					local target = targets[i]
					buffStat(target, "agi", -BUFFSTEP*2)	-- negative values lower a stat
				end
			end
		elseif timer > 190 and timer < 230	--bubbles
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 128
			for i = 0, 24
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.color = SKINCOLOR_LIME
				aura.momz = P_RandomRange(1, 4)*FRACUNIT/2
				aura.scale = FRACUNIT/2
				aura.destscale = FRACUNIT*2
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				
			end
			
			for i = 1, 4
				local r = P_SpawnMobj(avgx + P_RandomRange(-128,128)*FRACUNIT,avgy + P_RandomRange(-128,128)*FRACUNIT, avgz+P_RandomRange(20,60)*FRACUNIT, MT_THOK)
				r.flags = MF_NOGRAVITY
				r.sprite = SPR_BFUC
				r.frame = A
				r.fuse = 20
				r.colorized = true
				r.blendmode = AST_ADD
				r.renderflags = $|RF_FULLBRIGHT
				r.color = SKINCOLOR_LIME
				r.scale = FRACUNIT/5
				r.destscale = FRACUNIT*8
				r.scalespeed = (FRACUNIT*8)/20
			end
		elseif timer == 230
			return true
		end
	end,
}	











-- Attack Guard effects


attackDefs["tr_guard_check"] = {
		name = "Do you think a barrier will work?",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_PIERCE|ATK_SLASH,
		desc = "I think a barrier will work.",
		passive = PSV_ONDAMAGE_RECEIVED,
		anim = 	function(mo, attacker)
			if mo and mo.valid and mo.passiveskills and attacker and attacker.valid and attacker.attack and attacker.attack.type
				local atk = attacker.attack
				local atktype = attacker.attack.type
				dprint(mo.name.."Guard check passive is runnning.")
				
				if mo.damagestate ~= DMG_REPEL	--tetrakarn/makarakarn take priority
				and mo.damagestate ~= DMG_MISS	--I guess we dodge it or something lol
				and mo.damagestate ~= DMG_DRAIN	--idk, just to cover our asses I guess
				and not mo.tr_useGuard -- because multi-hits are fucky
				and not (atk.target == TGT_ALLY or atk.target == TGT_ALLALLIES or atk.target == TGT_SELF or atk.type == ATK_PASSIVE)
				and (mo.tr_perfectGuard	--perfect guard take priority because it's the most powerful
				or (isAttackPhysical(atk) and mo.tr_craftGuard)	--crafts and physicals
				or (not isAttackPhysical(atk) and mo.tr_artGuard)	--arts and magic
				or atktype == ATK_ALMIGHTY)	--fuck your shields!
					--We're very much using the barrier to block the attack, which barrier are we using?
					if mo.tr_perfectGuard	--we're using Perfect Guard first, since it's the strongest.
						dprint(mo.name.."Perfect Guard effect confirmed, removing...")
						if mo.tr_perfectGuard > 1	--to support 2-layer Perfect Guard S-Crafts being a thing.
							mo.tr_perfectGuard = $-1
						else
							mo.tr_perfectGuard = nil
						end
						
						local x, y = mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle)
						local s = P_SpawnMobj(x, y, mo.z+mo.height/2, MT_DUMMY)
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*3
						s.scalespeed = FRACUNIT/3
						s.fuse = TICRATE
						s.sprite = SPR_ADSL
						s.frame = $|FF_PAPERSPRITE|FF_FULLBRIGHT
						s.angle = mo.angle + ANG1*90
						s.colorized = true
						s.color = SKINCOLOR_WHITE
						
						BTL_logMessage(mo.battlen, mo.name.." protected by Perfect Guard!")
						
						if (mo.tr_craftGuard or mo.tr_artGuard) and atktype == ATK_ALMIGHTY	--Nope, sorry, we can't protect the other barriers from Almighty!
							mo.tr_craftGuard = nil
							mo.tr_artGuard = nil
							
							if not (mo.makarakarn or mo.tetrakarn or mo.tetraja)	--these will play the same sound, so why bother?
								playSound(mo.battlen, sfx_bufu6)
							end
						end
					elseif (isAttackPhysical(atk) and mo.tr_craftGuard and atktype ~= ATK_ALMIGHTY)	--do we have a physical guard to burn?
						dprint(mo.name.."Craft Guard effect confirmed, removing...")
						mo.tr_craftGuard = nil
						
						local x, y = mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle)
						local s = P_SpawnMobj(x, y, mo.z+mo.height/2, MT_DUMMY)
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*3
						s.scalespeed = FRACUNIT/3
						s.fuse = TICRATE
						s.sprite = SPR_ADSL
						s.frame = $|FF_PAPERSPRITE|FF_FULLBRIGHT
						s.angle = mo.angle + ANG1*90
						
						BTL_logMessage(mo.battlen, mo.name.." protected by Crafts Guard!")
					elseif (not isAttackPhysical(atk) and mo.tr_artGuard and atktype ~= ATK_ALMIGHTY)	--do we have a magical guard to burn?
						dprint(mo.name.."Art Guard effect confirmed, removing...")
						mo.tr_artGuard = nil
						
						local x, y = mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle)
						local s = P_SpawnMobj(x, y, mo.z+mo.height/2, MT_DUMMY)
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*3
						s.scalespeed = FRACUNIT/3
						s.fuse = TICRATE
						s.sprite = SPR_ADSL
						s.frame = $|FF_PAPERSPRITE|FF_FULLBRIGHT
						s.angle = mo.angle + ANG1*90
						s.colorized = true
						s.color = SKINCOLOR_YELLOW
						
						BTL_logMessage(mo.battlen, mo.name.." protected by Arts Guard!")
					elseif (mo.tr_craftGuard or mo.tr_artGuard) and atktype == ATK_ALMIGHTY
						BTL_logMessage(mo.battlen, mo.name.."'s barrier couldn't\nwithstand the Almighty attack!")
						mo.tr_craftGuard = nil
						mo.tr_artGuard = nil
						
						if not (mo.makarakarn or mo.tetrakarn or mo.tetraja)	--these will play the same sound, so why bother?
							playSound(mo.battlen, sfx_bufu6)
						end
					end
					mo.tr_useGuard = true
				end
			end
		end,
	}

	
	
local TrailsBarrier_SplitSkills = BTL_splitSkills
BTL_splitSkills = function(v)
	if v.tr_artGuard or v.tr_craftGuard or (v.tr_perfectGuard and v.tr_perfectGuard > 0)
		table.insert(v.skills, "tr_guard_check")
	end
	TrailsBarrier_SplitSkills(v)
end	


-- isWeak(e, a) returns the attack affinity of 'mo' towards the attack 'atk'
local function tr_getGuardAff(mo, atk, attacker)
	
	if leveltime%35 == 0
		dprint("Override successful, checking guard type...")
	end

	if not atk return end
	local atktype = getAttackType(attacker, atk)

	-- element resist/weakness buffs/debuffs
	local buff = mo.buffs[atktype] and mo.buffs[atktype][1] and mo.buffs[atktype][1] > 0
	local debuff = mo.buffs[atktype] and mo.buffs[atktype][1] and mo.buffs[atktype][1] < 0

	-- if mo is super, then blcok it unless it's almighty.
	if mo.status_condition == COND_SUPER and atk.type ~= ATK_ALMIGHTY
		return DMG_BLOCK
	end

	-- check for tetrakarns and whatnot...~
	if isAttackPhysical(atk) and mo.tetrakarn
	or not isAttackPhysical(atk) and mo.makarakarn

		if atk.target ~= TGT_ALLY and atk.target ~= TGT_ALLALLIES
		and atktype ~= ATK_ALMIGHTY	-- fuck repels
		and not atk.norepel	-- prevents repel altogether
			return DMG_REPEL
		end
	end
	
	if bionis
		-- Can we hit this mobj?
		if attacker ~= mo and mo.canhit and mo.canhit.check and not mo.canhit.check(mo) then
			return DMG_BLOCK
		end
	end
	
	if mo.tetraja and atk.instakill	-- tetraja blocks any instant kills
	and atktype ~= ATK_ALMIGHTY	-- (but not almighty)
		return DMG_BLOCK
	end
	
	if mo.tr_perfectGuard and atktype == ATK_ALMIGHTY
		return DMG_RESIST
	end
	
	-- ok so we're here because we have a Trails Guard effect, which one is it?
	if (mo.tr_perfectGuard	--nothing is getting through, not even Almighty
	or (isAttackPhysical(atk) and mo.tr_craftGuard and atktype ~= ATK_ALMIGHTY)	--non-almighty crafts will be blocked
	or (not isAttackPhysical(atk) and mo.tr_artGuard and atktype ~= ATK_ALMIGHTY))	--non-almighty arts will be blocked
	and not (atk.target == TGT_ALLY or atk.target == TGT_ALLALLIES or atk.target == TGT_SELF or atk.type == ATK_PASSIVE)
		if leveltime%35 == 0
			dprint(mo.name.."'s Guard effect blocks the attack.")
		end
		return DMG_BLOCK
	end
	
	-- attacks with no power value should ignore affinities altogether.
	if not atk.power
		return DMG_NORMAL
	end

	-- Technical damage bypasses all affinities besides weak!
	local technical = isAttackTechnical(mo, atk, atktype)
	debuff = $ or technical	-- this counts, too


	-- check if our passive skills block the attack
	local bestaff = DMG_NORMAL
	for i = 1, #mo.passiveskills
		local psv = mo.passiveskills[i]
		if attackDefs[psv]
			psv = attackDefs[$]

			if psv.type & atktype

				if (psv.passive == PSV_BLOCK and not debuff)
					bestaff = max($, DMG_BLOCK)

				elseif (psv.passive == PSV_REPEL and not debuff and not (psv.accuracy and psv.accuracy < 100))	-- chance repels don't count!
					bestaff = max($, DMG_REPEL)

				elseif (psv.passive == PSV_RESIST and not debuff)
					bestaff = max($, DMG_RESIST)

				elseif (psv.passive == PSV_DRAIN and not debuff)
					bestaff = max($, DMG_DRAIN)
				end
			end
		end
	end

	-- we found something better than normal resistance in our passive skills
	if bestaff > DMG_NORMAL
		return bestaff
	end


	-- very special case.
	if mo.guard
		--return DMG_RESIST
		buff = true	-- yes!
	end

	-- for technicals:
	if technical and not ((mo.weak & atktype) and not buff)
		return DMG_TECHNICAL
	end

	-- maybe check here for elemental barriers etc
	-- return DMG_RESIST for those

	-- now we check for real affinities
	if mo.drain & atktype and not debuff
		return DMG_DRAIN	-- drain, top priority
	elseif mo.repel & atktype and not debuff
		return DMG_REPEL	-- repel, 2nd priority
	elseif mo.block & atktype and not debuff
		return DMG_BLOCK
	elseif mo.resist & atktype and not debuff
		return DMG_RESIST
	elseif mo.weak & atktype and not buff
		return DMG_WEAK
	end

	return DMG_NORMAL	-- welp I guess there's nothing then :shrug: !
end




local getAttackAff_ORIG = getAttackAff	--no goofy ass "blocked but still one-more" shit here, please and thanks!
rawset(_G, "getAttackAff", function(mo, atk, attacker)
	if mo and mo.valid and (mo.tr_perfectGuard or mo.tr_artGuard or mo.tr_craftGuard)	--this will simplify a LOT for us
		--if leveltime%35 == 0
			--dprint(mo.name.." has a Guard effect, engaging AFF check override.")
		--end
		return tr_getGuardAff(mo, atk, attacker)
	else
		--if leveltime%35 == 0
			--dprint(mo.name.." is clear of Guard effects, run as normal.")
		--end
		return getAttackAff_ORIG(mo, atk, attacker)
	end
end)


-- Guard Shields


local function tr_shield(mo)
	if not mo or not mo.valid return end
	local btl = server.P_BattleStatus[mo.battlen]
	if btl and btl.running --only in battle
		if (mo.tr_perfectGuard or mo.tr_artGuard or mo.tr_craftGuard)
		and not (mo.tetrakarn or mo.makarakarn or mo.tetraja)
		and mo.hp
		and leveltime%2
			local x, y = mo.x + 32*cos(mo.angle), mo.y + 32*sin(mo.angle)
			local s = P_SpawnMobj(x, y, mo.z+mo.height/2, MT_DUMMY)
			s.scale = mo.scale
			s.fuse = 2
			s.colorized = true
			s.sprite = SPR_ADSL
			s.color = SKINCOLOR_ORANGE
			if mo.tr_perfectGuard
				s.sprite = SPR_PITY
				s.color = SKINCOLOR_SILVER
				if mo.tr_perfectGuard > 1
					s.color = SKINCOLOR_WHITE
				end
			elseif mo.tr_artGuard
				s.color = SKINCOLOR_AQUA
			end
			s.frame = $|FF_PAPERSPRITE|FF_FULLBRIGHT |FF_TRANS50
			s.angle = mo.angle + ANG1*90
		end
		if mo.tr_useGuard and btl.battlestate ~= BS_ACTION
			mo.tr_useGuard = nil
		end
	else
		if (mo.tr_perfectGuard or mo.tr_artGuard or mo.tr_craftGuard)
			dprint("Battle ended, clearing lingering Guard effects.")
			mo.tr_perfectGuard = nil
			mo.tr_artGuard = nil
			mo.tr_craftGuard = nil
		end
	end
end

addHook("MobjThinker", tr_shield, MT_PFIGHTER)

















