------{ Fire Arts }------

--ATTACK ARTS

--"Light" Single


attackDefs["tr_firebolt"] = {
		name = "Fire Bolt",
		type = ATK_FIRE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		status = COND_BURN,
		statuschance = 5,
		desc = "Orbal Art (Liberlian).\nLight Fire Damage to one enemy.\nMay Burn.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]		
			
			if timer == 10
				mo.fireballs = {}
			end
			
			if timer > 10 and timer < 30
				local b = P_SpawnMobj(mo.x, mo.y, mo.z + 10*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-15, 15)*FRACUNIT
				b.momy = P_RandomRange(-15, 15)*FRACUNIT
				b.momz = P_RandomRange(-15, 15)*FRACUNIT
				b.sprite = SPR_DFLM
				b.frame = H|FF_FULLBRIGHT
				b.blendmode = AST_ADD
				b.renderflags = $|RF_FULLBRIGHT
				b.scale = FRACUNIT*2/3
				b.destscale = FRACUNIT/12
				b.tics = TICRATE/4
			end	
			
			if timer == 30
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				thok.sprite = SPR_FLAM
				thok.frame = M|FF_FULLBRIGHT
				thok.scale = FRACUNIT/4
				thok.tics = -1
				thok.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
				thok.flags = $ & ~MF_NOGRAVITY
				thok.blendmode = AST_ADD
				thok.renderflags = $|RF_FULLBRIGHT
				thok.angle = R_PointToAngle2(thok.x, thok.y, target.x, target.y)
				thok.totaldistance = P_AproxDistance(target.x - thok.x, target.y - thok.y)/FRACUNIT
				thok.distancetraveled = 0
				thok.fuse = 40
				
				mo.fireballs[#mo.fireballs + 1] = thok
				mo.fireballdelay = -1
			end
			
			if mo.fireballs and #mo.fireballs
			and mo.fireballs[1] and mo.fireballs[1].valid
				mo.fireballdelay = $ + 1
				local fb = mo.fireballs[1]
				fb.distancetraveled = fb.totaldistance * mo.fireballdelay / 40
				
				local x = mo.x + fb.distancetraveled*cos(fb.angle)
				local y = mo.y + fb.distancetraveled*sin(fb.angle)
				--you know parabolas are quite useful when trying to make something launch "naturally"
				--shout outs to wood man for this
				if fb.totaldistance == 0 then fb.totaldistance = 1 end	--Divides by 0 on Repel
				local highpoint = 250
				local z = mo.z + ((-highpoint*(fb.distancetraveled^2))/(fb.totaldistance^2) + (highpoint*fb.distancetraveled)/fb.totaldistance)*FRACUNIT --+ mo.height
				P_TeleportMove(fb, x, y, z)		

				for z = 1, 8
					local fire = P_SpawnMobj(fb.x + P_RandomRange(-10, 10)*cos(fb.angle + ANGLE_90), fb.y + P_RandomRange(-10, 10)*sin(fb.angle + ANGLE_90), fb.z + P_RandomRange(5, -5)*FRACUNIT, MT_DUMMY)
					fire.sprite = SPR_FLAM
					fire.blendmode = AST_ADD
					fire.renderflags = $|RF_FULLBRIGHT
					fire.frame = M|FF_FULLBRIGHT|TR_TRANS70
					fire.scale = FRACUNIT/4
					fire.momz = P_RandomRange(1, 3)*FRACUNIT
					fire.scalespeed = FRACUNIT/20
					fire.destscale = 1
					fire.tics = 5
					fire.blendmode = AST_ADD
				end
			end	
					
            if timer == 71
                local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_BOSSEXPLODE)
                boom.scale = FRACUNIT*3
                boom.state = S_PFIRE1
				boom.blendmode = AST_ADD
				boom.renderflags = $|RF_FULLBRIGHT
                damageObject(target)


                for i = 1, 8
					local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
					smoke.scale = FRACUNIT*1
					smoke.momx = P_RandomRange(-5, 5)*FRACUNIT
					smoke.momy = P_RandomRange(-5, 5)*FRACUNIT
					smoke.momz = P_RandomRange(3, 6)*FRACUNIT
                end

                local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
                sm.fuse = TICRATE/2
                sm.scale = target.scale*3/2

                elseif timer == 90
					mo.fireballdelay = nil
					mo.fireballs = nil				
                    return true
                end
				
			if timer == 10
			or timer == 12
			or timer == 14
			or timer == 16
				playSound(mo.battlen, sfx_fire1)
			end	
            if timer == 30
                playSound(mo.battlen, sfx_firbol)
            elseif timer == 71
                playSound(mo.battlen, sfx_fire2)
                localquake(mo.battlen, FRACUNIT*32, 8)
            end
        end,	
}


--"Light" Group


attackDefs["tr_firebolt_ex"] = {
		name = "Fire Bolt EX",
		type = ATK_FIRE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		status = COND_BURN,
		statuschance = 3,
		tr_castarea = 3,
		desc = "Orbal Art (Liberlian).\nLight Fire Damage (Area M).\nMay Burn.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)		
			if timer == 10
				mo.fireballs = {}
			end
			
			if timer > 10 and timer < 30
				local b = P_SpawnMobj(mo.x, mo.y, mo.z + 10*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-15, 15)*FRACUNIT
				b.momy = P_RandomRange(-15, 15)*FRACUNIT
				b.momz = P_RandomRange(-15, 15)*FRACUNIT
				b.sprite = SPR_DFLM
				b.frame = H|FF_FULLBRIGHT
				b.blendmode = AST_ADD
				b.renderflags = $|RF_FULLBRIGHT
				b.scale = FRACUNIT*2/3
				b.destscale = FRACUNIT/12
				b.tics = TICRATE/4
			end	
			for i = 1, #hittargets
				local target = hittargets[i]
				local time = timer - (10*(i-1))
				
				if time == 30
					local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					thok.sprite = SPR_FLAM
					thok.frame = M|FF_FULLBRIGHT
					thok.scale = FRACUNIT/4
					thok.tics = -1
					thok.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
					thok.flags = $ & ~MF_NOGRAVITY
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.angle = R_PointToAngle2(thok.x, thok.y, target.x, target.y)
					thok.totaldistance = P_AproxDistance(target.x - thok.x, target.y - thok.y)/FRACUNIT
					thok.distancetraveled = 0
					thok.fireballdelay = -1
					thok.fuse = 40
					
					mo.fireballs[#mo.fireballs + 1] = thok
				end
				
				if time == 30
					playSound(mo.battlen, sfx_firbol)
				elseif time == 71
					playSound(mo.battlen, sfx_fire2)
					localquake(mo.battlen, FRACUNIT*32, 8)
				end
				
				if time == 71
					local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_BOSSEXPLODE)
					boom.scale = FRACUNIT*3
					boom.state = S_PFIRE1
					boom.blendmode = AST_ADD
					boom.renderflags = $|RF_FULLBRIGHT
					damageObject(target)


					for i = 1, 8
						local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
						smoke.scale = FRACUNIT*1
						smoke.momx = P_RandomRange(-5, 5)*FRACUNIT
						smoke.momy = P_RandomRange(-5, 5)*FRACUNIT
						smoke.momz = P_RandomRange(3, 6)*FRACUNIT
					end

					local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
					sm.fuse = TICRATE/2
					sm.scale = target.scale*3/2
				end
			end
			
			if mo.fireballs and #mo.fireballs
				for i = 1, #mo.fireballs
					local fb = mo.fireballs[i]
					if not fb or not fb.valid continue end	-- don't care
					fb.fireballdelay = $ + 1
					fb.distancetraveled = fb.totaldistance * fb.fireballdelay / 40
					
					local x = mo.x + fb.distancetraveled*cos(fb.angle)
					local y = mo.y + fb.distancetraveled*sin(fb.angle)
					--you know parabolas are quite useful when trying to make something launch "naturally"
					--shout outs to wood man for this
					if fb.totaldistance == 0 then fb.totaldistance = 1 end	--Divides by 0 on Repel
					local highpoint = 250
					local z = mo.z + ((-highpoint*(fb.distancetraveled^2))/(fb.totaldistance^2) + (highpoint*fb.distancetraveled)/fb.totaldistance)*FRACUNIT --+ mo.height
					P_TeleportMove(fb, x, y, z)		

					for z = 1, 8
						local fire = P_SpawnMobj(fb.x + P_RandomRange(-10, 10)*cos(fb.angle + ANGLE_90), fb.y + P_RandomRange(-10, 10)*sin(fb.angle + ANGLE_90), fb.z + P_RandomRange(5, -5)*FRACUNIT, MT_DUMMY)
						fire.sprite = SPR_FLAM
						fire.blendmode = AST_ADD
						fire.renderflags = $|RF_FULLBRIGHT
						fire.frame = M|FF_FULLBRIGHT|TR_TRANS70
						fire.scale = FRACUNIT/4
						fire.momz = P_RandomRange(1, 3)*FRACUNIT
						fire.scalespeed = FRACUNIT/20
						fire.destscale = 1
						fire.tics = 5
						fire.blendmode = AST_ADD
					end
				end
			end
			
			if timer == 10
			or timer == 12
			or timer == 14
			or timer == 16
				playSound(mo.battlen, sfx_fire1)
			end	
			
			if timer == 90 + (10*(#hittargets-1))
				mo.fireballs = nil				
				return true
			end
        end,	
}

attackDefs["tr_heatwave"] = {
		name = "Heatwave",
		type = ATK_FIRE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		desc = "Orbal Art (Enigma series).\nLight Fire Damage (Area M).",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for tg = 1,#hittargets
				local t = hittargets[tg]
				local time = timer + ((tg - 1) * 5)
				if time == 1
					playSound(mo.battlen, sfx_s3kc2s)
				elseif time == 30
					playSound(mo.battlen, sfx_s3k43)
				elseif time == 50
					playSound(mo.battlen, sfx_s3k3e)
				end
				if time > 0
					if time < 30
						local fume = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
						fume.state = S_CDUST1
						fume.angle = P_RandomRange(1,360)*ANG1
						fume.colorized = true
						fume.color = SKINCOLOR_KETCHUP
						fume.scale = FRACUNIT*3
						P_InstaThrust(fume,fume.angle,(40*FRACUNIT))
						localquake(mo.battlen, FRACUNIT*6, 10)
					elseif time < 70
						for b = 1,4
							local fume = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
							fume.state = S_CDUST1
							fume.angle = P_RandomRange(1,360)*ANG1
							fume.colorized = true
							fume.color = SKINCOLOR_KETCHUP
							fume.scale = FRACUNIT*3
							P_InstaThrust(fume,fume.angle,(40*FRACUNIT))
						end
						for b = 1,2
							local rx = t.x + P_RandomRange(-64,64)*FRACUNIT
							local ry = t.y + P_RandomRange(-64,64)*FRACUNIT
							local fume = P_SpawnMobj(rx,ry,t.z,MT_DUMMY)
							fume.state = S_CDUST1
							fume.angle = P_RandomRange(1,360)*ANG1
							fume.colorized = true
							fume.color = SKINCOLOR_KETCHUP
							fume.scale = FRACUNIT*3
							fume.momz = P_RandomRange(15,35)*FRACUNIT
						end
					end
					if time < 70 and time >= 50
						local rx = t.x + P_RandomRange(-32,32)*FRACUNIT
						local ry = t.y + P_RandomRange(-32,32)*FRACUNIT
						local fiya = P_SpawnMobj(rx,ry,t.z,MT_DUMMY)
						fiya.sprite = SPR_FLME
						fiya.frame = I|FF_FULLBRIGHT
						fiya.scale = FRACUNIT*3
						fiya.fuse = 35
						fiya.momz = P_RandomRange(35,70)*FRACUNIT
						fiya.momx = P_RandomRange(-32,32)*FRACUNIT
						localquake(mo.battlen, FRACUNIT*24, 10)
					end
					if time < 50 and time >= 30
						localquake(mo.battlen, FRACUNIT*12, 10)
					end
					if time == 70
						damageObject(t)
						DoExplosion(t)
						localquake(mo.battlen, FRACUNIT*48, 15)
					end
					if time == 80
						localquake(mo.battlen, FRACUNIT*24, 10)
					end
					if time == 90
						localquake(mo.battlen, FRACUNIT*12, 5)
					end
					if time == 95
						localquake(mo.battlen, FRACUNIT*9, 5)
					end
					if time == 100
						localquake(mo.battlen, FRACUNIT*6, 5)
					end
					if time == 105
						localquake(mo.battlen, FRACUNIT*3, 10)
					end
				end
			end
			if timer == 105 + ((#hittargets - 1) * 5)
				return true
			end
		end,
}


--"Medium" Single


attackDefs["tr_flare_arrow"] = {
		name = "Flare Arrow",
		type = ATK_FIRE,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 8,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nMedium Fire Damage to one enemy\nMay burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_blueab)
                playSound(mo.battlen, sfx_firbol)
			end

			if timer > 10 and timer <= 20
				for i = 1, 4
					local thok = P_SpawnMobj(target.x+P_RandomRange(-3, 3)*FRACUNIT, target.y+P_RandomRange(-3, 3)*FRACUNIT, target.z+(360+(20*i))*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = FRACUNIT*-20
					thok.color = SKINCOLOR_RED
					thok.spriteyscale = FRACUNIT*10
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.tics = 12+i
				end
			end

			if timer > 20 and timer <= 30
			
				local f = P_SpawnMobj(target.x + P_RandomRange(-2, 2)*FRACUNIT, target.y + P_RandomRange(-2, 2)*FRACUNIT, target.z + P_RandomRange(-2, 2)*FRACUNIT, MT_DUMMY)
				f.state = S_QUICKBOOM1
				f.momx = P_RandomRange(-6, 6)*FRACUNIT
				f.momy = P_RandomRange(-6, 6)*FRACUNIT
				f.momz = P_RandomRange(-6, 6)*FRACUNIT
				f.colorized = true
				f.color = SKINCOLOR_FLAME
				f.scale = FRACUNIT*2/5
				f.blendmode = AST_ADD
				f.renderflags = $|RF_FULLBRIGHT
			
				local sb = P_SpawnMobj(target.x, target.y, target.z+target.height/2, MT_DUMMY)
				sb.state = S_THOK
				sb.colorized = true
				sb.color = SKINCOLOR_FLAME
				sb.frame = FF_FULLBRIGHT
				sb.blendmode = AST_ADD
				sb.renderflags = $|RF_FULLBRIGHT
				sb.scale = FRACUNIT/5
				sb.momx = P_RandomRange(-12, 12)*FRACUNIT
				sb.momy = P_RandomRange(-12, 12)*FRACUNIT
				sb.momz = P_RandomRange(-12, 12)*FRACUNIT
				sb.tics = 30
				
				if timer == 30
					playSound(mo.battlen, sfx_eethit)
					DoExplosion(target)	
					DoExplosion(target)	
					damageObject(target)
					
					
					for	 i = 1, 4
						local smoke = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.floorz+P_RandomRange(-20, 20)*FRACUNIT, MT_SMOKE)
						smoke.momx = P_RandomRange(-4, 4)*FRACUNIT
						smoke.momy = P_RandomRange(-4, 4)*FRACUNIT
						smoke.momz = P_RandomRange(2, 5)*FRACUNIT
					end
				end
			end
			if timer == 50
				return true
			end
		end,
	}

attackDefs["tr_magna_blaze"] = {
		name = "Magna Blaze",
		type = ATK_FIRE,
		power = 170,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 15,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Enigma series).\nMedium Fire Damage to one enemy.\n15% Burn chance.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_firbol)
			end

			if timer >= 10 and timer <= 40
				local boom = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
			
			
			elseif timer >= 41 and timer <= 80
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)

				if timer%4 == 0
					playSound(mo.battlen, sfx_fire1)
				end
				
			elseif timer == 82
				damageObject(target)
				DoExplosion(target)	
				DoExplosion(target)	


			elseif timer == 100
				return true
			end
		end,
	}


--"Medium" Group


attackDefs["tr_spiral_flare"] = {
		name = "Spiral Flare",
		type = ATK_FIRE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 3,
		tr_castarea = 3,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nMedium Fire Damage (Area M).\nMay Burn.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if timer == 10
                playSound(mo.battlen, sfx_firbol)
                playSound(mo.battlen, sfx_trspfl)
			end

			if timer > 10 and timer <= 60 and not (timer%4)
				local x = avgx+P_RandomRange(-180, 180)*FRACUNIT
				local y = avgy+P_RandomRange(-180, 180)*FRACUNIT
                --playSound(mo.battlen, sfx_elgun)	--placeholder
				for i = 1, 4
					local thok = P_SpawnMobj(x, y, mo.z+(360+(20*i))*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = FRACUNIT*-20
					thok.color = SKINCOLOR_RED
					thok.spriteyscale = FRACUNIT*2
					thok.scale = FRACUNIT*3
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.tics = 12+i
				end
			end

			if timer > 20 and timer <= 70
			
				local f = P_SpawnMobj(avgx + P_RandomRange(-180, 180)*FRACUNIT, avgy + P_RandomRange(-180, 180)*FRACUNIT, mo.z + P_RandomRange(-20, 60)*FRACUNIT, MT_DUMMY)
				f.state = S_QUICKBOOM1
				f.momx = P_RandomRange(-12, 12)*FRACUNIT
				f.momy = P_RandomRange(-12, 12)*FRACUNIT
				f.momz = P_RandomRange(-12, 12)*FRACUNIT
				f.colorized = true
				f.color = SKINCOLOR_FLAME
				f.scale = FRACUNIT*5
				f.blendmode = AST_ADD
				f.renderflags = $|RF_FULLBRIGHT
			
				local sb = P_SpawnMobj(avgx, avgy, mo.z+mo.height/2, MT_DUMMY)
				sb.state = S_THOK
				sb.colorized = true
				sb.color = SKINCOLOR_FLAME
				sb.frame = FF_FULLBRIGHT
				sb.blendmode = AST_ADD
				sb.renderflags = $|RF_FULLBRIGHT
				sb.scale = FRACUNIT*2
				sb.momx = P_RandomRange(-12, 12)*FRACUNIT
				sb.momy = P_RandomRange(-12, 12)*FRACUNIT
				sb.momz = P_RandomRange(-12, 12)*FRACUNIT
				sb.tics = 30
				
				if timer == 70
					playSound(mo.battlen, sfx_eethit)
					for i = 1, #hittargets
						local target = hittargets[i]
						DoExplosion(target)	
						damageObject(target)
						for	 s = 1, 4
							local smoke = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.floorz+P_RandomRange(-20, 20)*FRACUNIT, MT_SMOKE)
							smoke.momx = P_RandomRange(-4, 4)*FRACUNIT
							smoke.momy = P_RandomRange(-4, 4)*FRACUNIT
							smoke.momz = P_RandomRange(2, 5)*FRACUNIT
						end
					end
					
				end
			end
			if timer == 90
				return true
			end
		end,
	}

attackDefs["tr_flare_butterfly"] = {
		name = "Flare Butterfly",
		type = ATK_FIRE,
		power = 170,
		accuracy = 90,
		costtype = CST_SP,
		cost = 17,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_BURN,
		statuschance = 7,
		tr_castarea = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		desc = "Orbal Art (Enigma series).\nMedium Fire Damage (Area L)\nMay burn.",
		target = TGT_ALLENEMIES,
		anim = 			function(mo, targets, hittargets, timer)

							local avgx = 0
							local avgy = 0

							for i = 1, #hittargets
								local t = hittargets[i]

								avgx = $+ t.x/FRACUNIT
								avgy = $+ t.y/FRACUNIT

								local time = timer - 10*(i-1)

								if time >= 20 and time <= 30
								and (time%5) == 0
								for i = 4,5
									local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
									s.state = S_QUICKBOOM1
									s.scale = $*2 + P_RandomRange(0, 65535)
									end
									playSound(mo.battlen, sfx_fire1)
								end
							end

							if timer == 40 + 10*(#hittargets-1)
								-- get average coords from what we had before
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT

								local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*128, MT_DUMMY)
								s.state = S_QUICKBOOM1
								s.scale = FRACUNIT*4
								playSound(mo.battlen, sfx_fire1)
							elseif timer == 50 + 10*(#hittargets-1)
								-- explode lol
								playSound(mo.battlen, sfx_fire2)
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT
								local an = 0
								for i = 1, 32

									local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.state = S_PFIRE1
									s.scale = $/2
									s.fuse = TICRATE*2
									P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

									s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.state = S_PFIRE1
									s.scale = $/4
									s.fuse = TICRATE*2
									P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

									an = $ + (360/32)
								end

								for i = 1, #hittargets do
									damageObject(hittargets[i])
									DoExplosion(hittargets[i])
								end
							elseif timer == 100 + 10*(#hittargets-1)
								return true
							end
						end

}


--"Heavy" Single


attackDefs["tr_napalm_breath"] = {
		name = "Napalm Breath",
		type = ATK_FIRE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nHeavy Fire Damage to one enemy\nMay burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 10
                playSound(mo.battlen, sfx_firbol)
			end

			if timer >= 10 and timer <= 60
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 24
				for i = 0, 12
					local angle = baseangle + i*12*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, target.z + (i*FRACUNIT*3), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_FLAME
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT*2
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
				local dist = 48
				for i = 0, 12
					local angle = baseangle + i*12*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, target.z + (i*FRACUNIT*3), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_FLAME
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT/2
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
				
				if timer == 50
					playSound(mo.battlen, sfx_eethit)
					damageObject(target)
				end
			end
			if timer == 80
				return true
			end
		end,
	}


--"Heavy" Group


attackDefs["tr_volcanic_rave"] = {
		name = "Volcanic Rave",
		type = ATK_FIRE,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 3,
		tr_castarea = 3,
		cost = 18,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nHeavy Fire Damage (Area M).\nMay Burn.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if timer == 10
                playSound(mo.battlen, sfx_debuff)
				localquake(mo.battlen, FRACUNIT*8, 30)
			end

			if timer > 10 and timer <= 40
				local grow = (timer)
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 30*grow/10
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					
					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_FLAME
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(1, 4)*FRACUNIT*grow/5
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4)*grow/5)
				end
			end
			if timer == 40
                playSound(mo.battlen, sfx_bgxpld)
				localquake(mo.battlen, FRACUNIT*32, 60)
				
				for i = 1, 16
					local krm = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					krm.state = S_FLAME
					krm.frame = FF_FULLBRIGHT
					krm.blendmode = AST_ADD
					krm.renderflags = $|RF_FULLBRIGHT
					krm.scale = FRACUNIT*2/P_RandomRange(1, 8)*2
					krm.momx = P_RandomRange(-12, 12)*FRACUNIT
					krm.momy = P_RandomRange(-12, 12)*FRACUNIT
					krm.momz = P_RandomRange(12, 24)*FRACUNIT
					krm.fuse = 30
					
					local sb = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					sb.state = S_THOK
					sb.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_FLAME
					sb.frame = FF_FULLBRIGHT
					sb.blendmode = AST_ADD
					sb.renderflags = $|RF_FULLBRIGHT
					sb.scale = FRACUNIT*2/P_RandomRange(4, 12)*2
					sb.momx = P_RandomRange(-12, 12)*FRACUNIT
					sb.momy = P_RandomRange(-12, 12)*FRACUNIT
					sb.momz = P_RandomRange(12, 24)*FRACUNIT
					sb.tics = 30
				end
			end

			if timer > 40 and timer <= 100
				if timer < 70
					local grow = (timer-40)*2
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
						
						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_FLAME
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
				
				local boom = P_SpawnMobj(avgx+P_RandomRange(-60, 60)*FRACUNIT, avgy+P_RandomRange(-60, 60)*FRACUNIT, mo.floorz, MT_DUMMY)
				boom.scale = FRACUNIT*16
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_FLAME
				boom.momx = P_RandomRange(-24, 24)*FRACUNIT
				boom.momy = P_RandomRange(-24, 24)*FRACUNIT
				boom.momz = P_RandomRange(12, 60)*FRACUNIT
				boom.frame = FF_FULLBRIGHT
				boom.blendmode = AST_ADD
				boom.renderflags = $|RF_FULLBRIGHT
				
				if timer == 100
					playSound(mo.battlen, sfx_eethit)
					playSound(mo.battlen, sfx_tiexp)
					for i = 1, #hittargets
						local target = hittargets[i]
						damageObject(target)
						for	 s = 1, 4
							local smoke = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.floorz+P_RandomRange(-20, 20)*FRACUNIT, MT_SMOKE)
							smoke.momx = P_RandomRange(-4, 4)*FRACUNIT
							smoke.momy = P_RandomRange(-4, 4)*FRACUNIT
							smoke.momz = P_RandomRange(2, 5)*FRACUNIT
						end
					end
				end
			end
			if timer == 120
				return true
			end
		end,
	}

attackDefs["tr_meteo_fall"] = {
		name = "Meteo Fall",
		type = ATK_FIRE,
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 3,
		tr_castarea = 5,
		cost = 21,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nHeavy Fire Damage (Area M).\nMay Burn.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if timer == 10
                playSound(mo.battlen, sfx_stohab)
				localquake(mo.battlen, FRACUNIT*12, 80)
			end
			if timer == 20
                playSound(mo.battlen, sfx_stoham)
				
				mo.bod = P_SpawnMobj(avgx+P_RandomRange(-240, 240)*FRACUNIT, avgy+P_RandomRange(-240, 240)*FRACUNIT, mo.floorz+400*FRACUNIT, MT_DUMMY)
				mo.bod.state = S_ROCKCRUMBLEA
				mo.bod.colorized = true
				mo.bod.color = SKINCOLOR_FLAME
				mo.bod.frame = FF_FULLBRIGHT
				mo.bod.scale = FRACUNIT*8
				mo.bod.tics = -1
				mo.bod.fuse = 21
				mo.bod.momx = (avgx - mo.bod.x)/(20)
				mo.bod.momy = (avgy - mo.bod.y)/(20)
				mo.bod.momz = (mo.z - mo.bod.z)/(20)
			end
			
			if timer > 20 and timer < 40
			and mo.bod and mo.bod.valid
				local boom = P_SpawnMobj(mo.bod.x, mo.bod.y, mo.bod.z, MT_DUMMY)
				boom.scale = mo.bod.scale
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_FLAME
				boom.momx = P_RandomRange(-8, 8)*FRACUNIT
				boom.momy = P_RandomRange(-8, 8)*FRACUNIT
				boom.momz = P_RandomRange(-8, 8)*FRACUNIT
				boom.frame = FF_FULLBRIGHT
				boom.blendmode = AST_ADD
				boom.renderflags = $|RF_FULLBRIGHT
			end
			
			if timer == 40
				DoExplosion(mo.bod)
				DoExplosion(mo.bod)
                playSound(mo.battlen, sfx_stosp2)
				
				for i = 1,8
					local rock = P_SpawnMobj(avgx, avgy, mo.z, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-6, 6)*FRACUNIT
					rock.momy = P_RandomRange(-6, 6)*FRACUNIT
					rock.momz = 5*FRACUNIT
					rock.fuse = TICRATE/2
					rock.color = SKINCOLOR_FLAME
					rock.colorized = true
					--rock.blendmode = AST_ADD
					rock.renderflags = $|RF_FULLBRIGHT
				end
				
				for i = 1, 24
					local thok = P_SpawnMobj(avgx+P_RandomRange(-30, 30)*FRACUNIT, avgy+P_RandomRange(-30, 30)*FRACUNIT, mo.z, MT_DUMMY)
					thok.state = S_CDUST1
					thok.frame = $|FF_TRANS50
					thok.flags = MF_NOGRAVITY
					thok.momx = P_RandomRange(-30, 30)*FRACUNIT
					thok.momy = P_RandomRange(-30, 30)*FRACUNIT
					thok.momz = P_RandomRange(10, 30)*FRACUNIT
					thok.color = SKINCOLOR_FLAME
					thok.colorized = true
					thok.tics = 60
					thok.scale = FRACUNIT
					thok.destscale = FRACUNIT*20
					thok.scalespeed = (FRACUNIT*20)/30
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
				end
			end
			
			if timer > 40 and timer <= 90
				if timer < 70
					local grow = (timer-40)*2
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
						
						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_FLAME
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
			end
			
			if timer >= 60
				for i = 1, #hittargets
					local time = timer - (6*(i-1))
					local target = hittargets[i]
					if time == 60
						playSound(mo.battlen, sfx_eethit)
						damageObject(target)
					end
				end
			end
			
			if timer == 90 + (6*(#hittargets-1))
				return true
			end
		end,
	}


--"Severe" Single


attackDefs["tr_cyclone_napalm"] = {
		name = "Cyclone Napalm",
		type = ATK_FIRE,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 10,
		cost = 32,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nSevere Fire Damage to one enemy\nMay Burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_cycnal)
			end	
			
			if not (timer%8) and timer <= 60
				local sx = target.x + P_RandomRange(-512,512)*FRACUNIT
				local sy = target.y + P_RandomRange(-512,512)*FRACUNIT
				local sz = target.floorz + P_RandomRange(64,512)*FRACUNIT
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local rz = target.floorz
				local rh = P_RandomRange(15,25)
				local st = P_SpawnMobj(sx,sy,sz,MT_FBOMB)
				st.state = S_TRAILS_FIREBOLT1
				st.scale = FRACUNIT*1
				st.colorized = true
				st.color = SKINCOLOR_ORANGE
				st.flags = $|MF_NOGRAVITY
				st.momx = (rx - st.x)/rh
				st.momy = (ry - st.y)/rh
				st.momz = (rz - st.z)/rh
				target.bruhn = st
			end
			
			if timer == 61
				DoExplosion(target)
			end

			if timer >= 62
			and timer < 105
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*7
				summonAura(thok, SKINCOLOR_ORANGE)
				thok.tics = 2
			end	
				
				
			
			if timer >= 62
			and timer < 105
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)			
			end	
			
			if timer == 110
				local smol = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
			
			if timer == 112
				damageObject(target)	
				
			elseif timer == 130
				return true
			end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_ORANGE
			end					
		end,
}

attackDefs["tr_crimson_ray"] = {
		name = "Crimson Ray",
		type = ATK_FIRE,
		power = 720,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 10,
		cost = 40,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Enigma series).\nSevere Fire Damage to one enemy\nMay burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				local sun = P_SpawnMobj(target.x,target.y,target.z + FRACUNIT*256,MT_DUMMY)
				sun.sprite = SPR_FLAM
				sun.frame = M|FF_FULLBRIGHT
				sun.colorized = true
				sun.color = SKINCOLOR_KETCHUP
				sun.tics = -1
				mo.sun = sun
				playSound(mo.battlen, sfx_lorinf)
				DoExplosion(sun)
				
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				local tgtx = target.x + 192*cos(target.angle)
				local tgty = target.y + 192*sin(target.angle)

			end
			if timer < 30
				local t = P_SpawnMobj (mo.sun.x,mo.sun.y,mo.sun.z,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT
				t.momz = (target.z - t.z)/10
				t.tics = 10
			elseif timer < 70
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT/2
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
				t.tics = 20
			elseif timer < 100
				local rangle = P_RandomRange(0, 359)
				local cx = target.x + 128*cos(target.angle + ANG1*(rangle))
				local cy = target.y + 128*sin(target.angle + ANG1*(rangle))
					
				local thok = P_SpawnMobj(cx, cy, target.z, MT_DUMMY)	
				thok.sprite = SPR_FLAM
				thok.frame = M|FF_FULLBRIGHT
				thok.colorized = true
				thok.color = SKINCOLOR_KETCHUP
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 15
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT/2)/15
				thok.scale = FRACUNIT/2
				thok.momx = (target.x - thok.x)/15
				thok.momy = (target.y - thok.y)/15
				thok.momz = (target.z - thok.z)/15
			elseif timer < 120
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT*3
				t.momz = FRACUNIT*20
				t.tics = 20
			elseif timer < 140
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT*2
				t.momz = FRACUNIT*20
				t.tics = 20
			elseif timer < 160
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT
				t.momz = FRACUNIT*20
				t.tics = 20
			end
			if timer > 120 and timer < 170
				local rndx = target.x + (P_RandomRange(-24,24)*target.scale)
				local rndy = target.y + (P_RandomRange(-24,24)*target.scale)
				local rndz = target.z + (P_RandomRange(-2,48)*target.scale)
				local adrip = P_SpawnMobj(rndx,rndy,rndz,MT_WATERDROP)
				if adrip and adrip.valid
					adrip.colorized = true
					adrip.color = SKINCOLOR_KETCHUP
					adrip.frame = $|FF_TRANS10
					adrip.flags = $1|MF_NOCLIPTHING
				end
			end
			if timer == 30
				for i = 1,72
					local icegas = P_SpawnMobj(target.x,target.y,target.z,MT_DUMMY)
					icegas.state = S_CDUST1
					icegas.angle = target.angle + ((ANG1 * 5) * i)
					icegas.colorized = true
					icegas.color = SKINCOLOR_RED
					icegas.scale = FRACUNIT*2
					P_InstaThrust(icegas,icegas.angle,(60*FRACUNIT))
				end
			end
			if timer == 100
				playSound(mo.battlen, sfx_fortun)
				mo.sun.destscale = 1
				mo.sun.scalespeed = mo.sun.scale/20
				mo.sun.tics = 20
				DoExplosion(target)
				damageObject(target)
				localquake(mo.battlen, FRACUNIT*64, 30)
			end
			if timer == 130
				localquake(mo.battlen, FRACUNIT*32, 10)
			end
			if timer == 140
				localquake(mo.battlen, FRACUNIT*16, 10)
			end
			if timer == 150
				localquake(mo.battlen, FRACUNIT*8, 10)
			end
			if timer == 160
				localquake(mo.battlen, FRACUNIT*4, 10)
			end
			if timer == 170
				return true
			end
		end,
}


--"Severe" Group


attackDefs["tr_arc_prom"] = {
		name = "Arc Prominence",
		type = ATK_FIRE,
		power = 650,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 7,
		cost = 64,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nSevere Fire Damage to all enemies.\nMay Burn.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if timer == 10	--big sun of death
				playSound(mo.battlen, sfx_trpcld)
				mo.bod = {}
				mo.zap = P_SpawnMobj(avgx, avgy, mo.z+FRACUNIT*480, MT_THOK)
				mo.zap.sprite = SPR_SFBR
				mo.zap.frame = H|FF_FULLBRIGHT
				mo.zap.tics = 110	--thiswill die naturally on timer == 120
				mo.zap.color = SKINCOLOR_FLAME
				mo.zap.colorized = true
				mo.zap.scale = FRACUNIT*3
				mo.zap.blendmode = AST_ADD
				mo.zap.renderflags = $|RF_FULLBRIGHT
				mo.zap.flags = $|MF_NOGRAVITY
				
				local cam = server.P_BattleStatus[mo.battlen].cam

				local x = cam.x - 120*cos(cam.angle)
				local y = cam.y - 120*sin(cam.angle)
				CAM_goto(cam, x, y, cam.floorz + FRACUNIT*480)
			end
			
			if timer > 10 and timer < 70	--charging orbs
				--if not (timer%10) then playSound(mo.battlen, sfx_firbol) end
				
				if not (timer%3)
					local angle = P_RandomRange(1, 360)*ANG1
					local dist = P_RandomRange(240, 480)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
						
					local s = P_SpawnMobj(x, y, mo.z+FRACUNIT*480, MT_DUMMY)
					s.sprite = SPR_SFBR
					s.frame = H|FF_FULLBRIGHT
					s.color = SKINCOLOR_FLAME
					s.colorized = true
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.scale = FRACUNIT/10
					s.destscale = FRACUNIT
					s.scalespeed = FRACUNIT/20
					s.tics = 20	--these will die naturally on timer == 60
					s.dist = dist
					s.elev = P_RandomRange(360, 600)
					s.angle = angle
					mo.bod[#mo.bod+1] = s
				end
			end
			
			if  timer >= 10 and mo.bod and #mo.bod	--fire orbs
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					if not mo.zap or not mo.zap.valid continue end	-- didn't ask
					
					s.angle = $+ ANG1*6
					if s.dist > 0
						s.dist = max(0, $-24)
					end
					
					if s.elev > 481
						s.elev = max(480, $-6)
					elseif s.elev < 479
						s.elev = min(480, $+6)
					elseif not s.elev == 480
						s.elev = 480
					end
					
					P_TeleportMove(s, mo.zap.x + s.dist *cos(s.angle), mo.zap.y + s.dist*sin(s.angle), mo.zap.z + (s.elev-480)*FRACUNIT)
					
					local g = P_SpawnGhostMobj(s)
					s.sprite = SPR_SFBR
					s.frame = H|FF_FULLBRIGHT
					s.color = SKINCOLOR_FLAME
					s.colorized = true
					g.tics = 15
					g.scale = s.scale*2
					g.destscale = s.scale/100
					g.scalespeed = s.scale/6
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
				end
			end
			
			if mo.zap and mo.zap.valid	--descending fireball
				if timer < 90
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_BFUE
					g.frame = G|FF_FULLBRIGHT
					g.color = SKINCOLOR_FLAME
					g.colorized = true
					g.tics = 10
					g.rollangle = timer*12*ANG1
					g.scale = mo.zap.scale
					g.destscale = mo.zap.scale*2
					g.scalespeed = mo.zap.scale/5
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*12
					if timer < 70 and not (timer%3)
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z, MT_DUMMY)
						g.sprite = SPR_NTHK
						g.frame = B|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.color = SKINCOLOR_FLAME
						g.fuse = 10
						g.scale = mo.zap.scale
						g.destscale = mo.zap.scale*5
						g.scalespeed = mo.zap.scale/2
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*12
					end
					if timer == 70
						mo.zap.momz = (mo.zap.floorz - mo.zap.z)/20
						local cam = server.P_BattleStatus[mo.battlen].cam

						local x = cam.x - 360*cos(cam.angle)
						local y = cam.y - 360*sin(cam.angle)
						CAM_goto(cam, x, y, cam.floorz + FRACUNIT*120)
					end
					if mo.zap.z < mo.zap.floorz then mo.zap.z = mo.zap.floorz end
				end
				if timer == 90
					playSound(mo.battlen, sfx_erhlan)
					mo.zap.color = SKINCOLOR_WHITE
					mo.zap.scalespeed = FRACUNIT*3/2
					mo.zap.destscale = FRACUNIT*30
					mo.zap.momz = 0
					mo.zap.z = mo.zap.floorz
				end
				if timer > 90 and timer < 120	--SHINE LIKE THE SUN!!!
					if not (timer%3)
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.floorz+FRACUNIT*96, MT_DUMMY)
						g.sprite = SPR_NTHK
						g.frame = B|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.color = SKINCOLOR_WHITE
						g.fuse = 10
						g.scale = mo.zap.scale
						g.destscale = mo.zap.scale/2
						g.scalespeed = mo.zap.scale*5
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						g.momz = FRACUNIT*48
					end
					local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.floorz+FRACUNIT*96, MT_DUMMY)
					g.sprite = SPR_BFUE
					g.frame = G|FF_FULLBRIGHT
					g.color = SKINCOLOR_WHITE
					g.colorized = true
					g.rollangle = 0
					g.tics = 10
					g.scale = mo.zap.scale
					g.destscale = mo.zap.scale
					g.scalespeed = mo.zap.scale*10
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*48
				end
			end
			
			if timer >= 120 and timer < 150	--Heat death of the arena
				if timer == 120
					playSound(mo.battlen, sfx_traprm)
					playSound(mo.battlen, sfx_eethit)
					for i = 1, #hittargets
						local target = hittargets[i]
						damageObject(target)
					end
					
					for i = 1,8
						local rock = P_SpawnMobj(avgx, avgy, mo.z, MT_FALLINGROCK)
						rock.momx = P_RandomRange(-12, 12)*FRACUNIT
						rock.momy = P_RandomRange(-12, 12)*FRACUNIT
						rock.momz = P_RandomRange(24, 48)*FRACUNIT
						rock.fuse = TICRATE/2
						rock.scale = 6*FRACUNIT
						rock.renderflags = $|RF_FULLBRIGHT
					end
				end
				
				local grow = (timer-120)*3
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 160*grow/10
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					
					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = leveltime%2 and SKINCOLOR_GOLD or SKINCOLOR_FLAME
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(1, 4)*FRACUNIT*5
					aura.scale = FRACUNIT*6
					aura.destscale = FRACUNIT*24
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4)*2)
				end
				
				local boom = P_SpawnMobj(avgx+P_RandomRange(-30, 30)*FRACUNIT, avgy+P_RandomRange(-30, 30)*FRACUNIT, mo.floorz, MT_DUMMY)
				boom.scale = FRACUNIT*12
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_WHITE
				boom.momx = P_RandomRange(-12, 12)*FRACUNIT
				boom.momy = P_RandomRange(-12, 12)*FRACUNIT
				boom.momz = P_RandomRange(30, 60)*FRACUNIT
				boom.frame = FF_FULLBRIGHT
				boom.blendmode = AST_ADD
				boom.renderflags = $|RF_FULLBRIGHT
				
				local boom = P_SpawnMobj(avgx+P_RandomRange(-60, 60)*FRACUNIT, avgy+P_RandomRange(-60, 60)*FRACUNIT, mo.floorz, MT_DUMMY)
				boom.scale = FRACUNIT*8
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_WHITE
				boom.momx = P_RandomRange(-48, 48)*FRACUNIT
				boom.momy = P_RandomRange(-48, 48)*FRACUNIT
				boom.momz = P_RandomRange(12, 24)*FRACUNIT
				boom.frame = FF_FULLBRIGHT
				boom.blendmode = AST_ADD
				boom.renderflags = $|RF_FULLBRIGHT
			end
			
			if timer >= 150 and timer < 240	--the donuts
				for rings = 0, 1
					local grow = (timer-150)*2
					if rings and timer < 180 continue end
					if rings then grow = (timer-180)*2 end
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 160*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
						
						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_BLACK
						aura.frame = FF_FULLBRIGHT
						--aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT|RF_FLOORSPRITE|RF_SPLATMASK
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT
						aura.scale = FRACUNIT*10
						aura.destscale = FRACUNIT*40
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
				local boom = P_SpawnMobj(avgx+P_RandomRange(-60, 60)*FRACUNIT, avgy+P_RandomRange(-60, 60)*FRACUNIT, mo.floorz, MT_DUMMY)
				boom.scale = FRACUNIT*2
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_WHITE
				boom.momx = P_RandomRange(-6, 6)*FRACUNIT
				boom.momy = P_RandomRange(-6, 6)*FRACUNIT
				boom.momz = P_RandomRange(0, 6)*FRACUNIT
				boom.frame = FF_FULLBRIGHT
				boom.blendmode = AST_ADD
				boom.renderflags = $|RF_FULLBRIGHT
			end
			
			if timer == 240
				mo.bod = nil
				mo.zap = nil
				return true
			end
		end,
	}

attackDefs["tr_lord_inferno"] = {
		name = "Lord Inferno",
		type = ATK_FIRE,
		power = 800,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 10,
		cost = 80,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		desc = "Orbal Art (Enigma series).\nSevere Fire Damage to all enemies\n10% Burn chance.",
		target = TGT_ALLENEMIES,
		hudfunc = function(v, mo, timer)
					if timer >= 75 and timer < 155
						v.fadeScreen(35, min(5,(timer - 70)/2))
					elseif timer >= 155 and timer < 170
						v.fadeScreen(35, max(0,5 - max(0,((timer - 150)/6))))
					end
				end,		
		anim = function(mo, targets, hittargets, timer)
			local spice = {SKINCOLOR_KETCHUP, SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_FLAME, SKINCOLOR_SUNSET}
			local timex = 170 //This is literally just bc I'm lazy and can't be bothered to constantly adjust timer for return true
			for i = 1, #hittargets
				local target = hittargets[i]
				if timer == 1
					target.puddles = {} //Setup
				end
				if timer < 35 //Make skybeams - I could make a beam that cuts horizontally but that seems like agony to piss with on multiple targets, sooo... SKYBEAMS
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					for zt = 1,50
						local zh = target.z + (zt*8)*FRACUNIT
						local thok = P_SpawnMobj(rx,ry,zh, MT_THOK)
						thok.scale = FRACUNIT/4
						thok.tics = 1
						thok.color = spice[P_RandomRange(1,#spice)]
						local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
					end
					local thok = P_SpawnMobj(rx,ry,target.floorz, MT_THOK)
					thok.scale = FRACUNIT*2
					thok.flags2 = $|MF2_SPLAT
					thok.tics = -1
					thok.color = spice[P_RandomRange(1,#spice)]
					target.puddles[#target.puddles+1] = thok //This is our target's puddle!
				end
				if timer < 70 and timer > 2
					for p = 1,#target.puddles
					local pud = target.puddles[p]
						if not ((timer+p)%5)
							local thok = P_SpawnMobj(pud.x,pud.y,pud.floorz, MT_THOK)
							thok.scale = FRACUNIT/4
							thok.tics = 35
							thok.color = spice[P_RandomRange(1,#spice)]
							thok.momx = P_RandomRange(-12,12)*FRACUNIT
							thok.momy = P_RandomRange(-12,12)*FRACUNIT
							thok.momz = P_RandomRange(5,12)*FRACUNIT
						end
					end
				end
				if timer > 60 and timer < 165 //To be safe
					for f = 1,#target.puddles
						local pud = target.puddles[f]
						if timer >= (69 + f) and timer < (104 + f)
							if timer == 69 + f
								pud.tics = 35
							end
							local boom = P_SpawnMobj(pud.x,pud.y,pud.floorz, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.colorized = true
							boom.color = pud.color
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*3/2
						end
					end
				end
				if timer == 120
					damageObject(target)
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						DoExplosion(target)
					end
				end
				if timer == timex - 1
					target.puddles = nil
				end
			end
			if timer == timex
				return true
			end//That's that
			
			if timer < 35
			S_StartSoundAtVolume(nil,sfx_lorinf,80)//Quiet bc we doing this every damn frame - Volume ranges from 0 - 250 iIrc
			elseif timer == 35
				playSound(mo.battlen, sfx_s237) //Lava puddles are settled and reacting
			end
			if timer >= 70 and timer < 140
				playSound(mo.battlen, sfx_s3k95) //Lava bursts
			end
			//Explosion sfx handles itself
		end,
}


--Support


attackDefs["tr_forte"] = {
		name = "Forte",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nRaises attack for one ally \nby one stage",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		target = TGT_ALLY,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_trlaur)
			end

			if timer >= 10 and timer <= 80
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 32
				for i = 0, 12
					local angle = baseangle + i*12*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, target.z + (i*FRACUNIT*3), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_GOLD
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT*2
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*7
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 3))
				end
				
				if not (leveltime%5)
					local s = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z + P_RandomRange(20, 100)*FRACUNIT, MT_DUMMY)
					s.color = SKINCOLOR_GOLD
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end
				
				if timer == 80
					playSound(mo.battlen, sfx_curia)
					buffStat(target, "atk", BUFFSTEP)
				end
			end
			if timer == 100
				return true
			end
		end,
	}

attackDefs["tr_la_forte"] = {
		name = "La Forte",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 10,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 4,
		desc = "Orbal Art (Liberlian).\nRaises attack for allies \nby one stage (Area M)",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
			
			for t = 1, #hittargets
				local time = timer - (6*(t-1))
				local target = hittargets[t]

				if time == 10
					playSound(mo.battlen, sfx_trlaur)
				end

				if time >= 10 and time <= 80
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 32
					for i = 0, 12
						local angle = baseangle + i*12*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, target.z + (i*FRACUNIT*3), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_GOLD
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(6, 24)*FRACUNIT*2
						aura.scale = FRACUNIT*3
						aura.destscale = FRACUNIT*7
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 3))
					end
					
					if not (leveltime%5)
						local s = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z + P_RandomRange(20, 100)*FRACUNIT, MT_DUMMY)
						s.color = SKINCOLOR_GOLD
						s.state = S_MEGISTAR1
						s.scale = FRACUNIT*1
					end
					
					if time == 80
						playSound(mo.battlen, sfx_curia)
						buffStat(target, "atk", BUFFSTEP)
					end
				end
			end
			if timer == 100 + (6*(#hittargets-1))
				return true
			end
		end,
	}


attackDefs["tr_impassion"] = {
	name = "Impassion",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art.\nRaises an ally's spririt.\nRestores 5 SP/10 TP/20 CP for 4 turns.",
	target = TGT_ALLY,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
	end,
	
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1] //I would never want this to repel

		
		//Z_DupeCheck for local calls
		//Z_ always stands for Zorua_ because         guess.
		
		local function Z_DupeCheck_LOCAL(user, skill)
	
			if #user.skills
				for i = 1,#user.skills
				local x = user.skills[i]
					if skill == x
						return true
					end
				end
			end
			
			if #user.passiveskills
				for i = 1,#user.passiveskills
				local x = user.passiveskills[i]
					if skill == x
						return true
					end
				end
			end
				
		end
		

		if timer == 10
			playSound(mo.battlen, sfx_impaso)
		end	
	
		if timer >= 10 and timer < 70
			summonAura(target, SKINCOLOR_FLAME)
		end
		
		if timer >= 10 and timer < 70
			if not (leveltime%9)
				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_SALMON
					thok.tics = P_RandomRange(10, 20)
				end	
			end
		end	
		
		if timer == 40
			for i = 1,10
				local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = SKINCOLOR_RED
				ol.scale = 1
				ol.destscale = target.scale*3
				ol.scalespeed = (target.scale*3)/15
				ol.frame = B|FF_TRANS80
				ol.tics = i + 5
			end		
			
			
			
			if Z_DupeCheck_LOCAL(target,"tr_impassion_thinker")
				BTL_logMessage(target.battlen, target.name.."'s Impassion has been renewed!")
			else
				BTL_logMessage(target.battlen, target.name.." will recover SP/TP/CP for 4 turns.")
				table.insert(target.passiveskills,"tr_impassion_thinker")
				if not Z_DupeCheck_LOCAL(target,"tr_impassion_reset")
					table.insert(target.passiveskills,"tr_impassion_reset")
				end
			end
			target.impassiontimer = 4
		end	
		
		if timer == 90
			return true
		end
	end,
}

attackDefs["tr_impassion_thinker"] = {
		name = "Impassion",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		nometronome = true,
		norandom = true,		
		desc = "Thinker for Impassion",
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				if not mo.impassiontimer//oh. Uhm... okay..!
					local storenum = 0
					
					local skill = "tr_impassion_thinker"
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if storenum
						table.remove(mo.passiveskills,storenum)//See ya :3
					end
					
					return true
				end
			end
			if timer > 1 and timer < 55
				if mo.impassiontimer > 1
					if mo.impassiontimer == 2
						BTL_logMessage(mo.battlen, mo.name.." regen will be over next turn.")
					else
						BTL_logMessage(mo.battlen, mo.name.."'s regen runs out for "..(mo.impassiontimer - 1).." more turns.")
					end
				elseif mo.impassiontimer == 1
					if timer == 3
						playSound(mo.battlen, sfx_absorb)
						for i = 1, 10
							local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							thok.state = S_THOK
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_RED
							thok.scale = FRACUNIT*3/2
							thok.tics = TICRATE
							
							P_InstaThrust(thok, i*10*ANG1, 20*FRACUNIT)
						end						
					end
					BTL_logMessage(mo.battlen, mo.name.." regen ran out.")
					
				end
			end
			if timer == 1
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_FLAME
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer == 1 and mo.impassiontimer //~= 1 4 turns right? this would make it 3
				local target = hittargets[1]
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				--local heals = max(1, target.maxsp*6 / 100)
				playSound(mo.battlen, sfx_lsheal)
				--damageSP(target, -heals, DMG_NORMAL, true)		
				if C2SBarEdits and not target.enemy and charStats[target.stats].tpbar
					local tpheal = 10
					if charStats[target.stats].cpuse then tpheal = 20 end
					damageTP(target, -tpheal)
				else
					local tpheal = 5
					damageSP(target, -tpheal)
				end
			end
			
			if timer >= 1 and timer <= 10 and mo.impassiontimer// ~= 1
			and (timer%5) == 0
				local s = P_SpawnMobj(mo.x + P_RandomRange(-58, 58)<<FRACBITS, mo.y + P_RandomRange(-58, 58)<<FRACBITS, mo.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1	
			end
			if timer == 55
				mo.impassiontimer = $ - 1
				if not mo.impassiontimer
					//Oh yeah Z_ConsumeSkill but local ish
					local storenum = 0
					
					local skill = "tr_impassion_thinker"
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if storenum
						table.remove(mo.passiveskills,storenum)//Have to do this at the end of the skill coz Assists and Enemies will    die otherwise
					end
				end
				
				return true
			end
		end,
	}

attackDefs["tr_impassion_reset"] = {
		name = "Impassion Reset",
		type = ATK_PASSIVE,
		nometronome = true,
		norandom = true,
		desc = "Reset Impassion timer on battle start",
		passive = PSV_ENDBATTLE,
		anim = function(mo, targets, hittargets, timer)
			if mo.impassiontimer
				dprint("Reset Impassion timer for "..mo.name)
				mo.impassiontimer = 0
			end
		end,
	}	

