------{ Mirage Arts }------

--ATTACK ARTS

--"Light" Single


	attackDefs["tr_ascension"] = {
		name = "Ascension",
		type = ATK_PSY,	    		
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		statuschance = 10,
		status = COND_SILENCE,
		desc = "Orbal Art (Liberlian).\nLight Psy Damage to one enemy. \n10% Silence chance.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			--local cam = server.P_BattleStatus[mo.battlen].cam
			
			if timer == 1
				mo.bod = {}
				mo.dbs = {}
			end
			
			for i = 1, 5
				local time = timer - (5*(i-1))
				if time == 10
					if i < 5
						local ang = target.angle+(270*ANG1)+(-90*ANG1*i)	--from 11:30 going clockwise by 3-hour intervals
						local x = target.x + 128 *cos(ang)
						local y = target.y + 128 *sin(ang)
						
						local c = P_SpawnMobj(x, y, target.floorz+192*FRACUNIT, MT_DUMMY)
						c.sprite = SPR_SVTH
						c.frame = A
						c.angle = target.angle
						c.tics = 120
						c.scale = FRACUNIT/2
						c.flags = $ & !MF_NOCLIPHEIGHT
						c.momz = (target.floorz - c.z)/10
						mo.bod[#mo.bod+1] = c
					else
						local c = P_SpawnMobj(target.x, target.y, target.floorz+192*FRACUNIT, MT_DUMMY)
						c.sprite = SPR_SVTH
						c.frame = A
						c.angle = target.angle
						c.tics = 120
						c.scale = FRACUNIT/2
						c.flags = $ & !MF_NOCLIPHEIGHT
						mo.bod[#mo.bod+1] = c
					end
					if i > 1
						playSound(mo.battlen, sfx_erhlan)
					end
				end
			end

			if mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					if s.tics < 100
						local grow = min(20, 100-s.tics)
						local grow2 = FRACUNIT*grow*P_RandomRange(80, 120)/2000
						local sb = P_SpawnMobj(s.x, s.y, s.z+(30*FRACUNIT)+(10*grow2), MT_DUMMY)
						sb.state = S_THOK
						sb.color = SKINCOLOR_RUBY
						sb.frame = FF_FULLBRIGHT
						sb.blendmode = AST_ADD
						sb.renderflags = $|RF_FULLBRIGHT
						sb.scale = grow2*2
						sb.tics = 2
						
						local sb = P_SpawnMobj(s.x, s.y, s.z+(30*FRACUNIT)+(10*grow2*2), MT_DUMMY)
						sb.state = S_THOK
						sb.color = SKINCOLOR_SALMON
						sb.frame = FF_FULLBRIGHT
						sb.blendmode = AST_ADD
						sb.renderflags = $|RF_FULLBRIGHT
						sb.scale = grow2
						sb.tics = 2
					end
					if timer >= 119
						s.tics = min(1, $)
					end
				end
			end

			if timer == 40
				local m = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)			
				m.sprite = SPR_MUDO
				m.scale = FRACUNIT*4
				m.frame = A
				m.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
				m.colorized = true
				m.color = SKINCOLOR_VIOLET
				m.tics = 60
			end
			
			if timer == 50
				playSound(mo.battlen, sfx_ascion)
				
				for i = 1, 8
					if i < 5
						local ang = target.angle+(45*ANG1)+(90*ANG1*i)
						local x = target.x + 96 *cos(ang)
						local y = target.y + 96 *sin(ang)
						
						local m = P_SpawnMobj(x, y, target.floorz, MT_DUMMY)		
						m.sprite = SPR_ASCI
						--m.colorized = true
						--m.color = SKINCOLOR_VAPOR
						m.frame = A|FF_TRANS20--|FF_PAPERSPRITE
						m.blendmode = AST_ADD
						m.angle = ang--+(90*ANG1)
						m.scale = FRACUNIT*4
						m.tics = 59
						m.pitch = 30*ANG1
						mo.dbs[#mo.dbs+1] = m
					else
						local ang = target.angle+(45*ANG1)+(90*ANG1*i)
						local x = target.x + 48 *cos(ang)
						local y = target.y + 48 *sin(ang)
						
						local m = P_SpawnMobj(x, y, target.floorz, MT_DUMMY)		
						m.sprite = SPR_ASCI
						--m.colorized = true
						--m.color = SKINCOLOR_VAPOR
						m.frame = A|FF_TRANS20--|FF_PAPERSPRITE
						m.blendmode = AST_ADD
						m.angle = ang--+(90*ANG1)
						m.scale = FRACUNIT*4
						m.tics = 59
						m.pitch = 30*ANG1
						mo.dbs[#mo.dbs+1] = m
					end
				end
			end
			if mo.dbs and #mo.dbs
				for i = 1, #mo.dbs do
					local s = mo.dbs[i]
					if not s or not s.valid continue end	-- don't care
					if timer <= 60 and i < 5
						local dist = max(48, 96*(20-(timer-50))/20)
						P_TeleportMove(s, target.x + dist *cos(s.angle), target.y + dist*sin(s.angle), target.floorz)
					end
					if timer == 100
						if  i < 5
							P_InstaThrust(s, s.angle+(45*ANG1/2), 20*FRACUNIT)
						else
							P_InstaThrust(s, s.angle-(45*ANG1/2), 20*FRACUNIT)
						end
						s.momz = FRACUNIT*(P_RandomRange(0, 20))
						s.scale = FRACUNIT
						s.destscale = FRACUNIT/4
						s.scalespeed = FRACUNIT/4
					end
				end
			end

			if timer >= 65
			and timer <= 80
				if not (timer%4)
					for i = 1,16
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						thok.state = S_SSPK1
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end	
				end
			end	
			
			if timer == 100		
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
				m.state = S_GOLDENHALOBEAM1
				m.scale = FRACUNIT*4
				m.color = SKINCOLOR_MAGENTA
			end
					
			if timer == 110
				DoExplosion(target)
			end	
			
			if timer == 130
				damageObject(target)
			end
			
			if timer == 155
				return true
			end	
		end,
	}

	attackDefs["tr_chaos_brand_ii"] = {
		name = "Chaos Brand II",
		type = ATK_PSY,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		statuschance = 5,
		status = COND_BRAINWASH,
		desc = "Orbal Art (Enigma series).\nLight Psy Damage to one enemy. \nMay Brainwash.",
		target = TGT_ENEMY,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local psiocolors = {SKINCOLOR_MAGENTA, SKINCOLOR_WHITE}

			if timer >= 10 and timer <= 100
				if timer == 10
					playSound(mo.battlen, sfx_karin)
				end
				if not (timer%4)
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*10, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
				end
			end
			
			if timer >= 30 and timer <= 50
				if not (timer%4)
					local z = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.floorz, MT_DUMMY)
					z.state = S_MEGISTAR1
					z.momz = 70*FRACUNIT
					z.scale = FRACUNIT*1
					z.color = SKINCOLOR_MAGENTA
					playSound(mo.battlen, sfx_hamas1)
				end	
			end	
			
			if timer == 50
				playSound(mo.battlen, sfx_debuff)
			end	
			
			if timer >= 50 and timer <= 100
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*4
				summonAura(thok, psiocolors[P_RandomRange(1, #psiocolors)])
				thok.tics = 2
			end	

			if timer == 80
			or timer == 90
			or timer == 100
				local x = target.x + P_RandomRange(-96, 96)<<FRACBITS
				local y = target.y + P_RandomRange(-96, 96)<<FRACBITS
				local z = target.z + P_RandomRange(0, 96)<<FRACBITS

				local s = P_SpawnMobj(x, y, z, MT_DUMMY)
				s.state = S_CHAOSSPEAREXPLOSION1	
				s.color = psiocolors[P_RandomRange(1, #psiocolors)]
				s.colorized = true
				s.scale = FRACUNIT*2
				playSound(mo.battlen, sfx_eethit)
			end	
				
			
			if timer == 105
				playSound(mo.battlen, sfx_hamas2)
				damageObject(target)
			
			elseif timer == 130
				return true
			end
		end,
	}


--"Light" Group


	attackDefs["tr_silver_thorn_ii"] = {
		name = "Silver Thorn II",
		type = ATK_PSY,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		statuschance = 10,
		status = COND_BRAINWASH,	
		tr_castarea = 3,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		desc = "Orbal Art (Enigma series)\nLight Psy Damage (Set Area M).\n10% Brainwash chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		hudfunc = function(v, mo, timer)
			local palnum = 252
			
			if timer >= 55
			and timer < 65
				v.fadeScreen(palnum,65 - timer)
			end
			
			if timer >= 85
			and timer < 100
				v.fadeScreen(palnum,min(10,100 - timer))
			end
		end,
		anim = function(mo, targets, hittargets, timer)
		
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 5
				playSound(mo.battlen, sfx_silthr)
			end	
				
			if timer == 10//Just the one spawn I'll do here
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), min(mo.floorz + 1024*FRACUNIT,mo.ceilingz - 128*FRACUNIT), MT_DUMMY)
					c.sprite = SPR_SVTH
					c.frame = A
					c.angle = ang+ANG1*90
					c.tics = 120
					c.flags = $ & !MF_NOCLIPHEIGHT
					c.momz = (mo.floorz - c.z)/20//GET UR .[Poink] DOWN THERE!!!!!
				end
			elseif timer == 30
				//sfx for sword smak
				playSound(mo.battlen, sfx_s3k90)
				//splode dust for the bonk
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.floorz, MT_FBOMB)
					c.colorized = true
					c.color = SKINCOLOR_WHITE
					P_ExplodeMissile(c)
				end
			end	
			
			
			
			if timer >= 55 and timer < 130
				for i = 1, 2
					local m = P_SpawnMobj(avgx + P_RandomRange(-10, 10)*FRACUNIT, avgy  + P_RandomRange(-10, 10)*FRACUNIT, mo.floorz - 100*FRACUNIT, MT_DUMMY)
					m.tics = -1
					m.color = SKINCOLOR_BUBBLEGUM
					m.frame = FF_FULLBRIGHT
					m.scale = FRACUNIT*15
					m.momz = FRACUNIT*64
					m.fuse = TICRATE
					m.sprite = SPR_THOK
				end	
			end
			
			if timer >= 55 and timer < 130
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-120, 120)*FRACUNIT, avgy + P_RandomRange(-120, 120)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_WHITE
					if timer%2 then thok.color = SKINCOLOR_BUBBLEGUM end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 15)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end		
			
			
			if timer == 130
				for i = 1, 64
					local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_BUBBLEGUM
					t.scale = FRACUNIT*2
				end
				
				mo.btwthisislikealongvariablesoitdoesntclash = {}
				
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					//ASPLOD1!!! can't use Scale Momentum (not vanilla) so the Zorua will simply use... annoying repetition calls
					
					local rua = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.z + FRACUNIT*24, MT_GHOST)
					rua.sprite = SPR_NTHK
					rua.color = SKINCOLOR_RASPBERRY
					rua.scale = 1
					rua.flags2 = $|MF2_SPLAT
					rua.frame = B|FF_FULLBRIGHT|FF_ADD
					rua.tics = -1
					rua.fuse = 35
					//this looks fiiiine.. Now...
					table.insert(mo.btwthisislikealongvariablesoitdoesntclash,rua)
				end
			end
			
			if timer == 131
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
			end
			
			if timer == 165
				mo.btwthisislikealongvariablesoitdoesntclash = nil
				return true
			end
			
			if mo.btwthisislikealongvariablesoitdoesntclash and #mo.btwthisislikealongvariablesoitdoesntclash
				local zor = mo.btwthisislikealongvariablesoitdoesntclash
				for rua = 1,#zor
					if zor[rua] and zor[rua].valid
						local fox = zor[rua]//can you tell I like Zoruas
						fox.scale = $ + FRACUNIT
						//Why not just use destscale? Sounds like it'd be easier yeah?
						//Destscale doesn't work on MF2_SPLAT objects because that'd be too easy! Nu uh! No way!
					end
				end
			end
			
		end,
	}


--"Medium" Single



--"Medium" Group


	attackDefs["tr_luminous_ray"] = {
			name = "Luminous Ray",
			type = ATK_PSY,	    		
			power = 140,
			accuracy = 95,
			costtype = CST_SP,
			cost = 10,
			tr_orbal = true,	--custom aura effect & sounds
			tr_castarea = 2,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Orbal Art (Arcus series).\nMedium Psy Damage (Set Line 2).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ENEMY,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
			end,
			anim = function(mo, targets, hittargets, timer)local target
				if not mo.tr_lockskill
					target = hittargets[1]
				else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
					target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
					target.state = S_INVISIBLE
					target.fuse = 2
				end
				if timer < 36
				
					if timer == 1
						playSound(mo.battlen, sfx_lumray)
					end
					local h_angle = P_RandomRange(1, 359)*ANG1
					local v_angle = P_RandomRange(1, 359)*ANG1
					local dist = 256
					local spd = P_RandomRange(40, 50)

					local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
					local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
					local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
					
				elseif timer < 71
					
					P_StartQuake(FRACUNIT*50, 10)
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_THOK
					s.tics = -1
					s.fuse = 10
					s.scale = 2*FRACUNIT
					s.color = SKINCOLOR_WHITE
					P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_THOK
					s.tics = -1
					s.fuse = 10
					s.scale = 2*FRACUNIT
					s.color = SKINCOLOR_WHITE
					P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_THOK
					s.tics = -1
					s.fuse = 10
					s.scale = 2*FRACUNIT
					s.color = SKINCOLOR_WHITE
					P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
					
					
					
					if timer == 38
						if #hittargets > 0	--In case we select nothing
							for i = 1, #hittargets
								damageObject(hittargets[i])	--this should just hit everything highlighted
							end
						end
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 5, 10)
							end
						end
					end
				end
				if timer == 80
					return true
				end
			end,
	}

	attackDefs["tr_silver_thorn"] = {
		name = "Silver Thorn",
		type = ATK_PSY,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 18,
		tr_orbal = true,	--custom aura effect & sounds
		statuschance = 50,
		status = COND_BRAINWASH,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
		end,
		tr_castarea = 3,
		desc = "Orbal Art\nLight Psy Damage (Area M).\n50% Brainwash chance.",
		target = TGT_ALLENEMIES,
		hudfunc = function(v, mo, timer)
			local palnum = 252
			
			if timer >= 55
			and timer < 65
				v.fadeScreen(palnum,65 - timer)
			end
			
			if timer >= 85
			and timer < 100
				v.fadeScreen(palnum,min(10,100 - timer))
			end
		end,
		anim = function(mo, targets, hittargets, timer)
		
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 5
				playSound(mo.battlen, sfx_silthr)
			end	
				
			if timer == 10//Just the one spawn I'll do here
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), min(mo.floorz + 1024*FRACUNIT,mo.ceilingz - 128*FRACUNIT), MT_DUMMY)
					c.sprite = SPR_SVTH
					c.frame = A
					c.angle = ang+ANG1*90
					c.tics = 120
					c.flags = $ & !MF_NOCLIPHEIGHT
					c.momz = (mo.floorz - c.z)/20//GET UR .[Poink] DOWN THERE!!!!!
				end
			elseif timer == 30
				//sfx for sword smak
				playSound(mo.battlen, sfx_s3k90)
				//splode dust for the bonk
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.floorz, MT_FBOMB)
					c.colorized = true
					c.color = SKINCOLOR_WHITE
					P_ExplodeMissile(c)
				end
			end	
			
			
			
			if timer >= 55 and timer < 130
				for i = 1, 2
					local m = P_SpawnMobj(avgx + P_RandomRange(-10, 10)*FRACUNIT, avgy  + P_RandomRange(-10, 10)*FRACUNIT, mo.floorz - 100*FRACUNIT, MT_DUMMY)
					m.tics = -1
					m.color = SKINCOLOR_BUBBLEGUM
					m.frame = FF_FULLBRIGHT
					m.scale = FRACUNIT*15
					m.momz = FRACUNIT*64
					m.fuse = TICRATE
					m.sprite = SPR_THOK
				end	
			end
			
			if timer >= 55 and timer < 130
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-120, 120)*FRACUNIT, avgy + P_RandomRange(-120, 120)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_WHITE
					if timer%2 then thok.color = SKINCOLOR_BUBBLEGUM end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 15)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end		
			
			
			if timer == 130
				for i = 1, 64
					local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_BUBBLEGUM
					t.scale = FRACUNIT*2
				end
				
				mo.btwthisislikealongvariablesoitdoesntclash = {}
				
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					//ASPLOD1!!! can't use Scale Momentum (not vanilla) so the Zorua will simply use... annoying repetition calls
					
					local rua = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.z + FRACUNIT*24, MT_GHOST)
					rua.sprite = SPR_NTHK
					rua.color = SKINCOLOR_RASPBERRY
					rua.scale = 1
					rua.flags2 = $|MF2_SPLAT
					rua.frame = B|FF_FULLBRIGHT|FF_ADD
					rua.tics = -1
					rua.fuse = 35
					//this looks fiiiine.. Now...
					table.insert(mo.btwthisislikealongvariablesoitdoesntclash,rua)
				end
			end
			
			if timer == 131
				local btl = server.P_BattleStatus[mo.battlen]
				for i = 1, #hittargets
					local targ = hittargets[i]
					local damage = btl.dmg_hits and btl.dmg_hits[targ.dmg_index][1] or 0
					if damage and damage ~= "miss" then damage = $*654/1000 end	--the rough power difference from 140 to 60
					btl.dmg_hits[targ.dmg_index][1] = damage
					damageObject(targ)	--this should just hit everything highlighted
				end
			end
			
			if timer == 165
				mo.btwthisislikealongvariablesoitdoesntclash = nil
				return true
			end
			
			if mo.btwthisislikealongvariablesoitdoesntclash and #mo.btwthisislikealongvariablesoitdoesntclash
				local zor = mo.btwthisislikealongvariablesoitdoesntclash
				for rua = 1,#zor
					if zor[rua] and zor[rua].valid
						local fox = zor[rua]//can you tell I like Zoruas
						fox.scale = $ + FRACUNIT
						//Why not just use destscale? Sounds like it'd be easier yeah?
						//Destscale doesn't work on MF2_SPLAT objects because that'd be too easy! Nu uh! No way!
					end
				end
			end
			
		end,
	}


--"Heavy" Single



--"Heavy" Group


	attackDefs["tr_avalon_gate"] = {
		name = "Avalon Gate",
		type = ATK_PSY,	
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		desc = "Orbal Art (Enigma series)\nHeavy Psy Damage to all enemies",
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 1
				mo.megithoks = {}
			
			elseif timer > 10 and timer <= 70
				local navgx = avgx - 128*cos(mo.angle - ANG1*0)
				local navgy = avgy - 128*sin(mo.angle - ANG1*0)
				mo.megithoks[#mo.megithoks+1] = P_SpawnMobj(navgx + P_RandomRange(-256, 256)*FRACUNIT, navgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z + FRACUNIT*512, MT_DUMMY)
				local m = mo.megithoks[#mo.megithoks]
				m.state = S_MEGITHOK
				m.scale = $*2
				m.momz = -FRACUNIT*64
				P_InstaThrust(m, mo.angle - ANG1*0, 32*FRACUNIT)
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_avagat)
			end	
			
			if timer == 70
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32

					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*2/3
				end
			end
			
			if timer >= 70 and timer <= 100
				local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
				bs.state, bs.color = S_MEGISTAR1, SKINCOLOR_WHITE
				bs.momz = -15*FRACUNIT
			end		
					
			if timer == 70
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_WHITE
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end					
				
				
			elseif timer == 100
				mo.megithoks = nil
				return true
			end
			
			local i = #mo.megithoks
			while i
				local m = mo.megithoks[i]
				if not m or not m.valid
					table.remove(mo.megithoks, i)
					i = $-1
					continue
				end

				-- ghost trail:
				P_SpawnGhostMobj(m)

				if m.z <= m.floorz

					P_RemoveMobj(m)
					i = $-1
					continue
				end


				i = $-1
			end
		end,
	}

attackDefs["tr_phantom_phobia"] = {
		name = "Phantom Phobia",
		type = ATK_PSY,	
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Arcus series).\nHeavy Psy Damage (Area L). \n1 Stage random stat down.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		debuff = true,
		anim = function(mo, targets, hittargets, timer)
			local strs = {"atk", "mag", "def", "agi", "crit"}
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			
			if timer == 25
				playSound(mo.battlen, sfx_eih4)
			end
			
			if timer >= 20 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-40, 40)*FRACUNIT, avgy + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT
					thok.scalespeed = FRACUNIT/16
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			elseif timer >= 51 and timer <= 60
				if timer == 52
					for i = 1,16
						local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
						if i%2 then thok.color = SKINCOLOR_MAGENTA else thok.color = SKINCOLOR_WHITE end
						thok.frame = A
						thok.destscale = 1
						thok.tics = 30
						thok.scalespeed = FRACUNIT/6
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end
				end
				for i = 1,8
					local thok = P_SpawnMobj(avgx + P_RandomRange(-40, 40)*FRACUNIT, avgy + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					if i == 1
						thok.color = SKINCOLOR_WHITE
					end
					thok.frame = A
					thok.tics = 35
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(15, 30)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end
			
			if timer == 20
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				orb.sprite = SPR_PHPN
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT/6
				orb.scalespeed = FRACUNIT/16
				orb.destscale = FRACUNIT*4
				orb.tics = 2*TICRATE-15
				orb.momz = FRACUNIT*4
				orb.color = SKINCOLOR_WHITE

			elseif timer == 50
				for i = 1, #hittargets
					local hit = hittargets[i]
					damageObject(hit)
					if hit.damagestate ~= DMG_MISS
					and hit.damagestate ~= DMG_BLOCK
					and hit.damagestate ~= DMG_DRAIN 
						buffStat(hit, strs[P_RandomRange(1, #strs)], -25)
					end
				end
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(avgx, avgy, mo.z+mo.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2

			elseif timer == 75
				return true
			end
		end,
}


--"Severe" Single



--"Severe" Group


	attackDefs["tr_claiomh_solarion"] = {
		name = "Claiomh Solarion",
		type = ATK_PSY,	    		
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 48,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Arcus series)\nSevere Psy Damage to all enemies.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_clasol)
			end	
			
					
			if timer >= 10 and timer <= 90
				local cam = server.P_BattleStatus[mo.battlen].cam
				local hang = cam.angle + ANG1*90
				local vang = ANG1*P_RandomRange(1,359)
				local dist = 300
				local x, y = 0, 0
				while x > -300 and x < 300 and y > -300 and y < 300
					x = mo.x + P_RandomRange(-300, 300)*FRACUNIT
					y = mo.y + P_RandomRange(-300, 300)*FRACUNIT
				end
				local z = (mo.z + 580*FRACUNIT) + (P_RandomRange(-300,300))*FRACUNIT
				local ol = P_SpawnMobj(x, y, z, MT_THOK)
				ol.state = S_MEGITHOK
				ol.scale = FRACUNIT*1
				ol.fuse = 25
				ol.momx = $ + (avgx-ol.x)/32
				ol.momy = $ + (avgy-ol.y)/32
				ol.momz = $ + ((mo.z+580*FRACUNIT)-ol.z)/32
			end
			
			if timer == 120
				localquake(mo.battlen, FRACUNIT*10, 30)
			end	
			
			
			if timer == 140
				local st = P_SpawnMobj(avgx, avgy, mo.z + 120*FRACUNIT*4, MT_DUMMY)
				st.state = S_MEGITHOK
				st.color = SKINCOLOR_WHITE
				st.flags = $ & ~MF_NOGRAVITY
				st.momz = -20*FRACUNIT
				st.fuse = 15
				st.scale = FRACUNIT*4
			end
			
			
			if timer == 160
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 2)
					end
				end
			end	
					
			if timer == 160		
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = D
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				localquake(mo.battlen, FRACUNIT*30, 30)
			
			elseif timer == 165
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = C
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				
			elseif timer == 170
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = B
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				
			elseif timer == 175
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = A
				m.color = SKINCOLOR_WHITE
				m.tics = 5
			end
			
			
			if timer > 159 and timer < 180
				if not (leveltime%1)
					local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
					local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.scale = 3*FRACUNIT
					t.momz = (P_RandomRange(8,64)/2)*FRACUNIT
					t.fuse = 105
				end
			end
			
			
			if timer == 160
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32
					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*3/5
				end
			end

				
			if timer == 161
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
			
			elseif timer == 190
				return true
			end
		end,	
	}


--Support


attackDefs["tr_archdrain"] = {
		name = "Arch Drain",
		type = ATK_ALMIGHTY,
		power = 50,
		accuracy = 999,
		costtype = CST_SP,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		showsp = true,
		desc = "Orbal Art (Liberlian).\nDrains 20 SP from all enemies.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,		
		anim = function(mo, targets, hittargets, timer)
					
					if timer >= 20 and timer <= 40
						for i = 1, #hittargets
							local target = hittargets[i]
							if timer == 20
								playSound(mo.battlen, sfx_arcdrn)
							elseif timer == 30
								damageSP(target, 20)
							end

							for s = 1,2
								local thok = P_SpawnMobj(target.x, target.y, target.z+mo.height/2, MT_DUMMY)
								thok.color = SKINCOLOR_SAPPHIRE
								thok.momx = P_RandomRange(-10, 10)*FRACUNIT
								thok.momy = P_RandomRange(-10, 10)*FRACUNIT
								thok.momz = P_RandomRange(-10, 10)*FRACUNIT
								thok.scale = FRACUNIT/10
								thok.destscale = FRACUNIT*2
							end
						end

					elseif timer >= 50 and timer <= 70

						if timer == 60
							playSound(mo.battlen, sfx_lsheal)
							local heals = 20*#hittargets
							damageSP(mo, -heals)
						end

						local h_angle = P_RandomRange(1, 359)*ANG1
						local v_angle = P_RandomRange(1, 359)*ANG1
						local dist = 256
						local spd = P_RandomRange(40, 50)

						local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
						local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
						local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

						local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

						s.frame = A
						s.color = SKINCOLOR_SAPPHIRE
						s.scale = FRACUNIT*3/2
						s.destscale = FRACUNIT/5
						s.target = target
						s.tics = 10
						s.momx = (mo.x - s.x)/10
						s.momy = (mo.y - s.y)/10
						s.momz = (mo.z - s.z)/10
					end

					if timer == 110
						return true
					end
				end,
}


attackDefs["tr_saint"] = {
		name = "Saint",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nRaises attack and defense for one ally \nby one stage",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		target = TGT_ALLY,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_trlaur)
			end

			if timer >= 10 and timer <= 80
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 64
				for i = 0, 12
					local angle = baseangle + i*12*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, target.z + (i*FRACUNIT*3), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_GOLD
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*7
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end
				
				if not (leveltime%5)
					local s = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z + P_RandomRange(20, 100)*FRACUNIT, MT_DUMMY)
					s.color = SKINCOLOR_GOLD
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end
				
				if timer == 80
					playSound(mo.battlen, sfx_curia)
					buffStat(target, "atk")
					buffStat(target, "def")
					BTL_logMessage(targets[1].battlen, "Physical Attack up!\nDefense up!")
				end
			end
			
			if timer >= 80 and timer <= 100
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 32
				for i = 0, 12
					local angle = baseangle + i*12*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, target.z + (i*FRACUNIT*3), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_GOLD
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 24)*FRACUNIT*2
					aura.scale = FRACUNIT/3
					aura.destscale = FRACUNIT*2
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 3))
				end
			end
			if timer == 100
				return true
			end
		end,
	}

attackDefs["tr_zodiac"] = {
		name = "Zodiac",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 24,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art.\nRaises physical attack and defense\n to all allies by 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
		
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 100
				playSound(mo.battlen, sfx_lydchr)
			end	
			
			if timer == 140
				playSound(mo.battlen, sfx_buff)
			end	
			
			if timer == 1
				mo.megi = {}
			elseif timer >= 10 and timer <= 90 and timer%2 == 0
				if timer == 20
					playSound(mo.battlen, sfx_zodiac)
					P_StartQuake(FRACUNIT, 120)
					mo.charge = P_SpawnMobj(avgx, avgy, mo.z + 200*FRACUNIT, MT_THOK)
					local charge = mo.charge
					charge.state = S_ZODIAC_1
					charge.flags = MF_NOGRAVITY
					charge.fuse = 121
					charge.scale = FRACUNIT*3/4
					charge.destscale = FRACUNIT*3
					charge.scalespeed = FRACUNIT/24
				end
				local cam = server.P_BattleStatus[mo.battlen].cam
				local hang = cam.angle + ANG1*90
				local vang = ANG1*P_RandomRange(1,359)
				local dist = 300
				local x, y = 0, 0
				while x > -400 and x < 400 and y > -400 and y < 400
					x = mo.x + P_RandomRange(-500, 500)*FRACUNIT
					y = mo.y + P_RandomRange(-500, 500)*FRACUNIT
				end
				local z = (mo.z + 200*FRACUNIT) + (P_RandomRange(-200,200))*FRACUNIT
				local ol = P_SpawnMobj(x, y, z, MT_THOK)
				ol.state = S_MEGITHOK
				ol.scale = FRACUNIT/4
				ol.fuse = 25
				ol.momx = $ + (avgx-ol.x)/32
				ol.momy = $ + (avgy-ol.y)/32
				ol.momz = $ + ((mo.z+200*FRACUNIT)-ol.z)/32
			elseif timer == 100
				P_StartQuake(FRACUNIT*5, 10)
				playSound(mo.battlen, sfx_zodac2)
				local charge = mo.charge
				charge.destscale = 1
				charge.scalespeed = FRACUNIT/8
				for i = 1, 16
					local ol = P_SpawnMobj(charge.x, charge.y, charge.z, MT_THOK)
					ol.state = S_MEGITHOK
					ol.fuse = 40
					ol.scale = FRACUNIT/4
					ol.momx = FRACUNIT*P_RandomRange(-20,20)
					ol.momy = FRACUNIT*P_RandomRange(-20,20)
					ol.flags = MF_NOBLOCKMAP
				end
			elseif timer > 100 and timer < 140
				for i = 1, #hittargets
					local target = hittargets[i]
					summonAura(target, SKINCOLOR_GOLD)
				end
			elseif timer == 140
				for i = 1, #hittargets
					local target = hittargets[i]
					buffStat(target, "atk")
					buffStat(target, "def")
					BTL_logMessage(target.battlen, "Physical Attack up!\nDefense up!")
					for i = 1,8
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_GOLD
						dust.scale = FRACUNIT*2
					end
				end
			elseif timer > 140 and timer <= 170
				for i = 1, #hittargets
					local target = hittargets[i]
					if leveltime%2 == 0
						for i = 1,8

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_ZODI
							thok.frame = B|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_GOLD
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 4
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_ZODI
						thok.frame = A|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_GOLD
						thok.tics = P_RandomRange(10, 35)
					end
				end
			elseif timer == 200
				return true
			end
		end,
}

attackDefs["tr_saintly_force"] = {
		name = "Saintly Force",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 24,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Arcus series).\nRemoves stat decreases and \nraises STR, DEF, AGI for an ally by 1 stage",
		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["atk"][1] >= 75
						and target.buffs["def"][1] >= 75
						and target.buffs["agi"][1] >= 75
						and target.buffs["mag"][1] >= 0
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]	
			
			if timer == 10
				playSound(mo.battlen, sfx_sanfor)
			end	

			if timer >= 10 and timer < 50
				summonAura(target, SKINCOLOR_WHITE)
			end
			
			if timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*50, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*4
				playSound(mo.battlen, sfx_hamas2)
			end	
			
			if timer == 50
				for i = 1,72
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = mo.angle+((ANG1*5)*i)
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SILVER
					dust.scale = FRACUNIT*2
				end	
			end
			
			
			if timer == 50
				local strs = {"atk", "mag", "def", "agi", "crit"}
				playSound(mo.battlen, sfx_buff)
				for i = 1, #strs
					local s = strs[i]
					if target.buffs[s][1] < 0
						target.buffs[s][1] = 0
						target.buffs[s][2] = 0
					end
				end
				buffStat(target, "atk")
				buffStat(target, "def")
				buffStat(target, "agi")
				BTL_logMessage(mo.battlen, "Stat penalties cleared, \nSTR/DEF/AGI up!")
			elseif timer == 80
				return true
			end
		end,
}

attackDefs["tr_crescent mirror"] = {
	name = "Crescent Mirror",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 40,
		tr_orbal = true,	--custom aura effect & sounds
	target = TGT_ALLALLIES,
	desc = "Orbal Art (Arcus series). \nProvides a magic barrier and a one stage \nMagic increase to all allies.",
	superbuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_cremir)
			playSound(mo.battlen, sfx_cremir)
		end
		
		if timer >= 1 and timer < 100
			local moon = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)	
			moon.scale = 1 
			moon.tics = 60
			moon.scale = FRACUNIT*5 
			moon.sprite = SPR_MOCR
			moon.frame = A|FF_TRANS20
		end			
		
		if timer >= 10 and timer <= 40
		and (timer%5) == 0
			for i = 1, #hittargets
				local t = hittargets[i]
				avgx = $+ t.x/FRACUNIT
				avgy = $+ t.y/FRACUNIT
				local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = $*2 + P_RandomRange(0, 65535)
			end	
		end	
		
		if timer >= 40 and timer < 120
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_WHITE)
			end	
		end
		
		
		if timer == 120
			for i = 1,#hittargets
				local t = hittargets[i]
				local mirror = P_SpawnMobj(t.x, t.y, t.z, MT_DUMMY)	
				mirror.scale = 1 
				mirror.tics = 60
				mirror.destscale = FRACUNIT*2 
				mirror.sprite = SPR_FORC
				mirror.colorized = true
				mirror.color = SKINCOLOR_WHITE
				mirror.frame = A|FF_TRANS20
				mirror.scalespeed = (FRACUNIT*6)/80
			end
		end
		
		if timer == 150
			for i = 1,#hittargets
				local t = hittargets[i]
				local thok = P_SpawnMobj(t.x, t.y, t.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
				t.makarakarn = true
				buffStat(t, "mag")
			end	
		end
		
		if timer == 151
			BTL_logMessage(targets[1].battlen, "All party members received\na magic barrier!")
		end	

		if timer == 170 + (#hittargets-1)*6
			return true
		end
	end,

}



	attackDefs["tr_chaos_brand"] = {
		name = "Chaos Brand",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 60,
		statuschance = 60,
		status = COND_BRAINWASH,
		costtype = CST_SP,
		cost = 8,
		tr_orbal = true,	--custom aura effect & sounds
		luckbased = true,	-- use luck instead of agility
		desc = "Orbal Art (Liberlian)\nHigh chance of inflicting Brainwash \nto one enemy.",
		target = TGT_ENEMY,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local psiocolors = {SKINCOLOR_MAGENTA, SKINCOLOR_WHITE}

			if timer >= 10 and timer <= 100
				if timer == 10
					playSound(mo.battlen, sfx_karin)
				end
				if not (timer%4)
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*10, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
				end
			end
			
			if timer >= 30 and timer <= 50
				if not (timer%4)
					local z = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.floorz, MT_DUMMY)
					z.state = S_MEGISTAR1
					z.momz = 70*FRACUNIT
					z.scale = FRACUNIT*1
					z.color = SKINCOLOR_MAGENTA
					playSound(mo.battlen, sfx_hamas1)
				end	
			end	
			
			if timer == 50
				playSound(mo.battlen, sfx_debuff)
			end	
			
			if timer >= 50 and timer <= 100
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*4
				summonAura(thok, psiocolors[P_RandomRange(1, #psiocolors)])
				thok.tics = 2
			end	

			if timer == 80
			or timer == 90
			or timer == 100
				local x = target.x + P_RandomRange(-96, 96)<<FRACBITS
				local y = target.y + P_RandomRange(-96, 96)<<FRACBITS
				local z = target.z + P_RandomRange(0, 96)<<FRACBITS

				local s = P_SpawnMobj(x, y, z, MT_DUMMY)
				s.state = S_CHAOSSPEAREXPLOSION1	
				s.color = psiocolors[P_RandomRange(1, #psiocolors)]
				s.colorized = true
				s.scale = FRACUNIT*2
				playSound(mo.battlen, sfx_eethit)
			end	
				
			
			if timer == 105
				playSound(mo.battlen, sfx_hamas2)
				damageObject(target)
			
			elseif timer == 130
				return true
			end
		end,
	}

attackDefs["tr_enfeeble"] = {
		name = "Enfeeble",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 10,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 4,
		desc = "Orbal Art (Liberlian).\nLowers defence by 1 stage (Area M).",
		target = TGT_ALLENEMIES,
		debuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
		end,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			
			if timer == 1
				playSound(mo.battlen, sfx_clokdw)
			end
			
			if timer == 5
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				m.sprite = SPR_ENFE
				m.color = SKINCOLOR_MAGENTA
				m.scale = FRACUNIT*1
				m.flags2 = $|MF2_SPLAT
				m.flags = MF_NOBLOCKMAP
				m.renderflags = $|RF_NOCOLORMAPS
				m.tics = 90
			end	
				
			if timer > 5
			and timer < 100
				if leveltime & 10
					local thok = P_SpawnMobj(avgx, avgy, mo.z + mo.height + 80*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_ANSP
					thok.frame = B| TR_TRANS30
					thok.momz = -10*FRACUNIT 
					thok.color = SKINCOLOR_BLUEBELL
					thok.colorized = true
					thok.tics = 10
					thok.scale = FRACUNIT*3
				end	
			end	
				
				
			
			if timer == 5
				playSound(mo.battlen, sfx_frei1)

			elseif timer > 5
			and timer < 100

				if leveltime & 1
					for i = 1, 2

						local s = P_SpawnMobj(avgx, avgy, mo.z + mo.scale*32, MT_DUMMY)
						if i == 1
							s.z = $ - mo.scale*32
						else
							s.z = $ + mo.scale*100
						end

						s.sprite = SPR_SLAS
						s.frame = K+(i-1) | FF_FULLBRIGHT | TR_TRANS30
						s.color = SKINCOLOR_BLUEBELL
						s.scale = FRACUNIT/8
						s.destscale = FRACUNIT*3
						s.scalespeed = FRACUNIT/2
						s.tics = TICRATE/2

						s.momx = P_RandomRange(-2, 2)*FRACUNIT
						s.momy = P_RandomRange(-2, 2)*FRACUNIT
						s.momz = P_RandomRange(-2, 2)*FRACUNIT

					end
				end
			end	

				
			if timer == 100
				playSound(mo.battlen, sfx_debuff)
				for i = 1, #hittargets
					buffStat(hittargets[i], "def", -25)
					local dbuff = P_SpawnMobj(hittargets[i].x, hittargets[i].y, hittargets[i].z+hittargets[i].height, MT_DUMMY)
					dbuff.state = S_DBUFF1
					dbuff.color = SKINCOLOR_WHITE
					dbuff.scale = FRACUNIT*5/2
				end
			end
			
			if timer == 130
				return true
			end
		end,
}

attackDefs["tr_phantom_pain"] = {
	name = "Phantom Pain",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 9,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 3,
	tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
	desc = "Orbal Art (Liberlian).\nLowers attack by 1 stage. (Set Area M)".."\x82".."\n   Custom 1 for Pos Mode.",
	target = TGT_ALLENEMIES,
	debuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
	end,
	anim = function(mo, targets, hittargets, timer)

		local avgx = 0
		local avgy = 0
		if not mo.tr_lockskill
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
		else
			avgx = mo.tr_cursorPos[1]
			avgy = mo.tr_cursorPos[2]
		end
			
		if timer == 25
			playSound(mo.battlen, sfx_eih4)
		end

		if timer >= 20 and timer <= 50
			for i = 1,3
				local thok = P_SpawnMobj(avgx + P_RandomRange(-80, 80)*FRACUNIT, avgy + P_RandomRange(-80, 80)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_MAGENTA
				if timer%2 then thok.color = SKINCOLOR_WHITE end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-6, 6)*FRACUNIT
				thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			end
		elseif timer == 51
			for i = 1, 64
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_WHITE
				t.scale = FRACUNIT*2
			end
		end

		if timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			orb.sprite = SPR_PHPN
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*5
			orb.scalespeed = FRACUNIT/32
			orb.destscale = 1
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_WHITE

		elseif timer == 51
			if #hittargets > 0	--In case we select nothing
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					buffStat(target, "atk", -25)	-- negative values lower a stat
					local dbuff = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					dbuff.state = S_DBUFF1
					dbuff.color = SKINCOLOR_WHITE
					dbuff.scale = FRACUNIT*5/2
				end
			end
		end

		if timer == 60 + #targets*16
			return true
		end
	end,
}

attackDefs["tr_silent_cross"] = {
	name = "Silent Cross",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nLowers critical by 1 stage for all enemies.",
	target = TGT_ALLENEMIES,
	debuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
	end,
	anim = function(mo, targets, hittargets, timer)

		local avgx = 0
		local avgy = 0
		for i = 1, #targets do
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = $ / #targets *FRACUNIT
		avgy = $ / #targets *FRACUNIT
		
		if timer >= 10 and timer < 100
			if timer == 20
				playSound(mo.battlen, sfx_trscrs)
			end
			
			if timer <= 60 and timer%2
				local colors = {SKINCOLOR_AETHER, SKINCOLOR_PURPLE, SKINCOLOR_BLACK}
				for i = 1, #colors
					local g = P_SpawnMobj(avgx, avgy, mo.z+60*FRACUNIT, MT_DUMMY)
					g.sprite = SPR_STAB
					g.frame = A|FF_FULLBRIGHT
					g.rollangle = timer*12*ANG1
					g.color = colors[i]
					g.fuse = 10
					g.scale = (FRACUNIT*timer*i)/20
					g.destscale = (FRACUNIT*timer*i)/200
					g.scalespeed = (FRACUNIT*timer*i)/200
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
				end
			end
			
			if timer > 30 and timer <= 50
				local colors = {SKINCOLOR_AETHER, SKINCOLOR_VIOLET}
					for i = 1, #colors
					local g = P_SpawnMobj(avgx, avgy, mo.z+60*FRACUNIT, MT_DUMMY)
					g.sprite = SPR_MEGI
					g.frame = G|FF_FULLBRIGHT
					g.rollangle = timer*36*ANG1
					g.color = colors[i]
					g.fuse = 5
					g.scale = FRACUNIT*(FRACUNIT*(timer-30)*i)
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
				end
				if timer == 50
					playSound(mo.battlen, sfx_trimpd)
				end
			elseif timer > 50 and timer <= 60
				local colors = {SKINCOLOR_AETHER, SKINCOLOR_VIOLET}
					for i = 1, #colors
					local g = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					g.sprite = SPR_MEGI
					g.frame = H|FF_FULLBRIGHT
					g.rollangle = timer*90*ANG1
					g.color = colors[i]
					g.fuse = 5
					g.scale = (FRACUNIT*20*i)
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
				end
			elseif timer > 60 and timer <= 80
				local colors = {SKINCOLOR_AETHER, SKINCOLOR_VIOLET}
					for i = 1, #colors
					local g = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					g.sprite = SPR_MEGI
					g.frame = timer < 70 and (70-timer)|FF_FULLBRIGHT or A|FF_FULLBRIGHT
					g.rollangle = timer*36*ANG1
					g.color = colors[i]
					g.fuse = 5
					g.scale = (FRACUNIT*(80-timer)*i)
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
				end
			end
			if timer > 60
				
				local grow = (timer-60)
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 160*grow/10
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = (timer%2) and SKINCOLOR_BLACK or SKINCOLOR_VIOLET
					aura.frame = FF_FULLBRIGHT
					if not (timer%2) then aura.blendmode = AST_ADD end
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(1, 4)*FRACUNIT
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT*4
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4)*(grow+20)/20)
				end
			end
		end
		
		if timer > 70
			for i = 1,#targets -- damageObject must be used on all enemies individually.
				local target = targets[i]
				local time = timer - (4*(i-1))
				if time > 70 and time < 100
					if time == 80
						playSound(mo.battlen, sfx_eethit)
						buffStat(target, "crit", -25)-- negative values lower a stat
						for i = 1, 12
							local sb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							sb.state = S_THOK
							sb.color = i and SKINCOLOR_SAPPHIRE or SKINCOLOR_COBALT
							sb.frame = FF_FULLBRIGHT
							sb.blendmode = AST_ADD
							sb.renderflags = $|RF_FULLBRIGHT
							sb.scale = FRACUNIT/3
							sb.momx = P_RandomRange(-24, 24)*FRACUNIT
							sb.momy = P_RandomRange(-24, 24)*FRACUNIT
							sb.momz = P_RandomRange(-6, 6)*FRACUNIT
							sb.tics = 20
						end
					end
					
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 64
					for i = 0, 12
						local angle = baseangle + i*12*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, target.floorz + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = (timer%2) and SKINCOLOR_SAPPHIRE or SKINCOLOR_COBALT
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/4
						aura.scale = FRACUNIT*1
						aura.destscale = FRACUNIT*4
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
				end
			end
		end

		if timer == 110 + (4*(#targets-1))
			
			return true
		end
	end,
}















