--Safe skill adding

local tr_addSkill = function(mo, skill)
			
	local check = false
					
	if #mo.skills
		for s = 1,#mo.skills
		local x = mo.skills[s]
			if skill == x
				check = true
			end
		end
	end
										
	if #mo.passiveskills
		for s = 1,#mo.passiveskills
		local x = mo.passiveskills[s]
			if skill == x
				check = true
				else
			end
		end
	end
									
	if not check
		if attackDefs[skill].type & ATK_PASSIVE
			mo.passiveskills[#mo.passiveskills+1] = skill
		else	
			mo.skills[#mo.skills+1] = skill
		end
	end
end




------{ Space Arts }------

--ATTACK ARTS

--"Light" Single


attackDefs["tr_photon shoot"] = {
		name = "Photon Shoot",
		type = ATK_NUCLEAR,
		costtype = CST_SP,
		cost = 4,
		tr_orbal = true,	--custom aura effect & sounds
		power = 60,
		accuracy = 95,
		desc = "Orbal Art (Enigma series).\nLight Nuke Damage to one enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
				playSound(mo.battlen, sfx_karin)
                local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*1
                boom.state = S_THOK
				boom.color = SKINCOLOR_WHITE
				boom.fuse = 15
				boom.momx = (target.x - boom.x)/15
				boom.momy = (target.y - boom.y)/15
				boom.momz = (target.z - boom.z)/15

			elseif timer == 30
				damageObject(target)
				playSound(mo.battlen, sfx_hamas2)
				for i = 1, 64
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.sprite = SPR_THOK
					m.frame = A
					m.tics = TICRATE
					m.fuse = TICRATE
					m.destscale = 1
					m.color = SKINCOLOR_WHITE
					m.flags = MF_NOCLIPTHING|MF_NOCLIPHEIGHT
					m.momx = P_RandomRange(-64, 64)*FRACUNIT
					m.momy = P_RandomRange(-64, 64)*FRACUNIT
					m.momz = P_RandomRange(0, 64)*FRACUNIT
				end

			elseif timer == 70
				return true
			end
		end,
}


--"Light" Group


attackDefs["tr_dark matter II"] = {
    name = "Dark Matter II",
    type = ATK_NUCLEAR,
    power = 60,
    accuracy = 90,
    costtype = CST_SP,
    cost = 9,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 5,
	tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
    desc = "Orbal Art (Enigma series).\nLight Nuke Damage (Set Area L).\nLowers agility.".."\x82".."\n   Custom 1 for Pos Mode.",
    target = TGT_ALLENEMIES,
    hudfunc =     function(v, mo, timer)

                        if timer >= TICRATE*2
                        and timer <= TICRATE*2+15
                            local t = timer-TICRATE*2
                            local p = "H_ATR"..t/2
                            if v.patchExists(p)
                                drawScreenwidePatch(v, v.cachePatch(p))
                            end
                        end
                    end,
    
    
    anim =     function(mo, targets, hittargets, timer)
    
        local battleStatus = server.P_BattleStatus[mo.battlen]
        
        if timer == 20
			mo.st = P_SpawnMobj(battleStatus.arena_coords[1], battleStatus.arena_coords[2], battleStatus.arena_coords[3] - FRACUNIT*52, MT_DUMMY)
            mo.st.state = S_DARKMATTER
            mo.st.fuse = TICRATE*2
            mo.st.scale = FRACUNIT*1/4
            mo.st.destspeed = TICRATE/2
            mo.st.destscale = FRACUNIT*500
            playSound(mo.battlen, sfx_darmat)
        end
        
		if #hittargets > 0	--In case we select nothing
			for i = 1,#hittargets
				local target = hittargets[i]
				if timer > 20 and timer <= TICRATE*2
					local squish = timer-20
					target.spritexscale = FRACUNIT + squish*FRACUNIT/16
					target.spriteyscale = FRACUNIT - squish*FRACUNIT/64
				end
			end	
		end
		
		
        if mo.st and mo.st.valid
            if timer%5 == 0
                local st = P_SpawnMobj(mo.st.x + P_RandomRange(-128, 128)<<FRACBITS, mo.st.y + P_RandomRange(-128, 128)<<FRACBITS, mo.st.z + P_RandomRange(-192, 192)<<FRACBITS, MT_DUMMY)
                st.color = SKINCOLOR_AZURE
                st.state = S_MEGISTAR1
                st.scale = mo.st.scale + P_RandomRange(0, 65535)
                st.target = mo.st
            end
			local thok = P_SpawnMobj(mo.st.x, mo.st.y, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP|MF_NOCLIP
			thok.color = SKINCOLOR_PURPLE
			if timer%2 then thok.color = SKINCOLOR_NEON end
			thok.frame = A
			thok.tics = 70
			thok.scale = FRACUNIT
			thok.scalespeed = FRACUNIT/32
			thok.destscale = 1
			thok.momz = P_RandomRange(8, 12)*FRACUNIT
			thok.momx = P_RandomRange(-10, 10)*FRACUNIT
			thok.momy = P_RandomRange(-10, 10)*FRACUNIT
        end
        
		if #hittargets > 0	--In case we select nothing
			for k,e in ipairs(hittargets)
				local target = e
				if timer == TICRATE*2
					target.spritexscale = FRACUNIT
					target.spriteyscale = FRACUNIT
					damageObject(target)			
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN  
						buffStat(target, "agi", -25)
					end    
				end
			end
		end
        
        if timer == TICRATE*3
            return true
        end
    end
}

attackDefs["tr_golden sphere"] = {
		name = "Golden Sphere",
		type = ATK_NUCLEAR,
		power = 75,
		accuracy = 90,
		costtype = CST_SP,
		cost = 10,	--self-tech fee I guess
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		statuschance = 12,
		status = COND_DIZZY,
		desc = "Orbal Art (Enigma series).\nLight Nuke damage (Set Area S).\n12% Dizzy chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_hama3)
				end 
				
				if timer > 10 and timer < 50
					
					local thok = P_SpawnMobj(avgx,avgy,mo.z + ((50 - timer)*16)*FRACUNIT,MT_DUMMY)
					
					thok.tics = 2
					thok.sprite = SPR_THOK
					thok.frame = A
					thok.scale = FRACUNIT*2
					thok.color = SKINCOLOR_GOLD
					
					for sprinkle = 1,8
						local ang = ((leveltime%5)*ANG1)*9 + (ANGLE_45*sprinkle)
						local dist = 32 + ((50 - timer)*4)
						local rx = thok.x + dist*cos(ang)
						local ry = thok.y + dist*sin(ang)
						
						local thok2 = P_SpawnMobj(rx,ry,thok.z + 36*FRACUNIT,MT_DUMMY)
						thok2.tics = 2
						thok2.sprite = SPR_THOK
						thok2.frame = A
						thok2.scale = FRACUNIT*1
						thok2.color = SKINCOLOR_GOLD			
					end
				end	

				if timer == 60
					playSound(mo.battlen, sfx_hamas2)
					playSound(mo.battlen, sfx_megi5)

					if #hittargets > 0	--In case we select nothing
						for i = 1, #hittargets
							damageObject(hittargets[i])	--this should just hit everything highlighted
						end
					end
				end

				if timer > 61 and timer < 70
					local ol = P_SpawnMobj(avgx, avgy, mo.z + (mo.height/2), MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_GOLD
					ol.scale = (FRACUNIT/2)*(timer-40)
					ol.flags2 = $|MF2_SPLAT
					ol.frame = B|FF_ADD
					ol.tics = 2
					
					for i = 1,8
						local g = P_SpawnGhostMobj(ol)
						g.fuse = 4
						g.frame = B|FF_TRANS50|FF_ADD|FF_PAPERSPRITE
						g.angle = mo.angle + (ANGLE_45*i)
					end
				end	
				
				if timer == 61
				or timer == 62
				or timer == 63
				or timer == 64
					for j = 1, 32
						local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
						st.state = S_THOK
						st.flags = $ & ~MF_NOGRAVITY
						st.momx = P_RandomRange(-128, 128)*FRACUNIT
						st.momy = P_RandomRange(-128, 128)*FRACUNIT
						st.momz = P_RandomRange(0, 128)*FRACUNIT
						st.fuse = TICRATE*4
						st.scale = FRACUNIT*2/3
						st.color = SKINCOLOR_GOLD
					end			
				end
				
				if timer >= 60 and timer <= 80
				and (timer%5) == 0
					if #hittargets > 0	--In case we select nothing
						for i = 1, #hittargets
							local t = hittargets[i]
							avgx = $+ t.x/FRACUNIT
							avgy = $+ t.y/FRACUNIT
							local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
							s.color = SKINCOLOR_GOLD
							s.state = S_MEGISTAR1
							s.scale = $*2 + P_RandomRange(0, 65535)
						end
					end
				end					
				
				
			if timer == 90
				return true
			end
		end,
}


--"Medium" Single


attackDefs["tr_dark matter"] = {
    name = "Dark Matter",
    type = ATK_NUCLEAR,
    power = 140,
    accuracy = 90,
    costtype = CST_SP,
    cost = 8,
	tr_orbal = true,	--custom aura effect & sounds
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
    desc = "Orbal Art (Liberlian).\nMedium Nuke Damage (Set Area M).\nLowers agility.".."\x82".."\n   Custom 1 for Pos Mode.",
    target = TGT_ENEMY,
    hudfunc =     function(v, mo, timer)

                        if timer >= TICRATE*2
                        and timer <= TICRATE*2+15
                            local t = timer-TICRATE*2
                            local p = "H_ATR"..t/2
                            if v.patchExists(p)
                                drawScreenwidePatch(v, v.cachePatch(p))
                            end
                        end
                    end,
    
    
    anim =     function(mo, targets, hittargets, timer)
    
        local battleStatus = server.P_BattleStatus[mo.battlen]
		local target = hittargets[1]
        
        if timer == 20
			mo.st = P_SpawnMobj(battleStatus.arena_coords[1], battleStatus.arena_coords[2], battleStatus.arena_coords[3] - FRACUNIT*52, MT_DUMMY)
            mo.st.state = S_DARKMATTER
            mo.st.fuse = TICRATE*2
            mo.st.scale = FRACUNIT*1/6
            mo.st.destspeed = TICRATE/2
            mo.st.destscale = FRACUNIT*300
            playSound(mo.battlen, sfx_darmat)
        end
        
		if timer > 20 and timer <= TICRATE*2
			local squish = timer-20
			target.spritexscale = FRACUNIT + squish*FRACUNIT/16
			target.spriteyscale = FRACUNIT - squish*FRACUNIT/64
		end
		
        if mo.st and mo.st.valid
            if timer%5 == 0
                local st = P_SpawnMobj(mo.st.x + P_RandomRange(-128, 128)<<FRACBITS, mo.st.y + P_RandomRange(-128, 128)<<FRACBITS, mo.st.z + P_RandomRange(-192, 192)<<FRACBITS, MT_DUMMY)
                st.color = SKINCOLOR_AZURE
                st.state = S_MEGISTAR1
                st.scale = mo.st.scale + P_RandomRange(0, 65535)
                st.target = mo.st
            end
			local thok = P_SpawnMobj(mo.st.x, mo.st.y, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP|MF_NOCLIP
			thok.color = SKINCOLOR_PURPLE
			if timer%2 then thok.color = SKINCOLOR_NEON end
			thok.frame = A
			thok.tics = 70
			thok.scale = FRACUNIT
			thok.scalespeed = FRACUNIT/32
			thok.destscale = 1
			thok.momz = P_RandomRange(8, 12)*FRACUNIT
			thok.momx = P_RandomRange(-10, 10)*FRACUNIT
			thok.momy = P_RandomRange(-10, 10)*FRACUNIT
        end
        
		if timer == TICRATE*2
			target.spritexscale = FRACUNIT
			target.spriteyscale = FRACUNIT
			damageObject(target)  
		end
				
        if timer == TICRATE*3
            return true
        end
    end
}


--"Medium" Group


attackDefs["tr_lost_mobius"] = {
	name = "Lost Mobius",
	type = ATK_NUCLEAR,
	power = 140,
	accuracy = 90,
	costtype = CST_SP,
	cost = 9,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 4,
	tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
	desc = "Orbal Art (Liberlian).\nMedium Nuke Damage (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
	target = TGT_ALLENEMIES,
    hudfunc = function(v, mo, timer)
        if timer > 70 and timer <= 100
            v.fadeScreen(0, min(10,(timer - 10)))
        elseif timer > 100 and timer < 170
            v.fadeScreen(0, max(0,10 - max(0,((timer - 100)/2))))
        end
    end,   
	
	anim = function(mo, targets, hittargets, timer)
		local avgx = 0
		local avgy = 0
		local avgz = 0
		if not mo.tr_lockskill
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
				avgz = $ + hittargets[i].z/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			avgz = $ / #hittargets *FRACUNIT
		else
			avgx = mo.tr_cursorPos[1]
			avgy = mo.tr_cursorPos[2]
			avgz = mo.floorz
		end
		
		if timer == 10
			playSound(mo.battlen, sfx_darmat)
			local firebol = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*170, MT_DUMMY)
			firebol.scale = 1 
			firebol.tics = 60
			firebol.destscale = FRACUNIT*6 
			firebol.sprite = SPR_THOK
			firebol.color = SKINCOLOR_BLACK
			firebol.frame = A|FF_TRANS20
			firebol.scalespeed = (FRACUNIT*6)/80
		end

		if timer >= 30 and timer <= 70
			local thok = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_DUMMY)
			thok.sprite = SPR_SUMN
			thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
			thok.momz = P_RandomRange(6, 16)*FRACUNIT
			thok.color = SKINCOLOR_WHITE
			thok.tics = P_RandomRange(10, 35)
		end	
			
		if timer >= 30 and timer <= 70
			local b = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*170, MT_DUMMY)
			b.momx = P_RandomRange(-35, 35)*FRACUNIT
			b.momy = P_RandomRange(-35, 35)*FRACUNIT
			b.momz = P_RandomRange(-35, 35)*FRACUNIT
			b.color = SKINCOLOR_WHITE
			b.frame = A|FF_FULLBRIGHT
			b.scale = FRACUNIT*2
			b.destscale = 1
			b.scalespeed = FRACUNIT/4
			b.tics = TICRATE/4
			localquake(mo.battlen, FRACUNIT*10, 10)
		end	
				
		if timer == 30
			playSound(mo.battlen, sfx_zodiac)
		end	

		if timer == 70
			playSound(mo.battlen, sfx_megi5)
			playSound(mo.battlen, sfx_hamas2)
			playSound(mo.battlen, sfx_tiexp)
		end
		
		if timer == 78
			playSound(mo.battlen, sfx_orbal2)
		end
		
		if timer >= 73
		and timer <= 130
			local baseangle = P_RandomRange(1, 380)*ANG1
			local dist = 500
			for i = 1, 16
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
				aura.state = S_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_BLACK
				aura.momz = P_RandomRange(6, 16)*FRACUNIT
				aura.scale = FRACUNIT*3
				aura.destscale = FRACUNIT*5
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
			end
		end		

		if timer >= 73
		and timer < 130
			local thok = P_SpawnMobj(avgx, avgy, mo.z - FRACUNIT*20, MT_THOK)
			thok.state = S_INVISIBLE
			thok.scale = FRACUNIT*10
			summonAura(thok, SKINCOLOR_GREY)
			thok.tics = 2
		end	

		if timer >= 73 and timer <= 130
		and (timer%5) == 0
			local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_DUMMY)
			bs.state, bs.color = S_THOK, SKINCOLOR_WHITE
			bs.momz = P_RandomRange(3, 10)*FRACUNIT
			bs.tics = P_RandomRange(10, 35)
		end	
		
		if timer == 120
			playSound(mo.battlen, sfx_eethit)
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					damageObject(hittargets[i])	--this should just hit everything highlighted
				end
			end
		end
		
		if timer == 140
			return true
		end	
	end,
}

attackDefs["tr_golden halo"] = {
	name = "Golden Halo",
	type = ATK_NUCLEAR,
	power = 140,
	accuracy = 90,
	costtype = CST_SP,
	cost = 14,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 6,
	tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
	desc = "Orbal Art\nMedium Bless damage (Area L).\nLowers Defense.".."\x82".."\n   Custom 1 for Pos Mode.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		if not mo.tr_lockskill
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
		else
			avgx = mo.tr_cursorPos[1]
			avgy = mo.tr_cursorPos[2]
		end
				
		if timer == 1
			mo.megi = {}
			mo.flair = {}
			mo.alphabeam = {}
		
		elseif timer >= 24 and timer < 80 and timer%4 == 0
			local megi
			local dist = P_RandomRange(-400,400)
			while dist <= 300 and dist >= -300
				dist = P_RandomRange(-400,400)
			end
			local ang = P_RandomRange(0, 359)*ANG1
			playSound(mo.battlen, sfx_s3k74)
			megi = P_SpawnMobj(avgx + dist*cos(ang), avgy + dist*sin(ang), mo.z + P_RandomRange(100, 400)*FRACUNIT, MT_DUMMY)
			megi.state = S_HALOBOMB
			megi.angle = ang
			megi.dist = dist
			megi.dismom = 1
			megi.color = SKINCOLOR_GOLD
			megi.fuse = 120 - timer
			megi.scale = FRACUNIT
			megi.extravalue1 = 1
			mo.megi[#mo.megi+1] = megi
			local g = P_SpawnMobj(avgx, avgy, mo.z + P_RandomRange(70, 400)*FRACUNIT, MT_HTRAIL)
			local step = P_RandomRange(1,10)
			g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
			if step == 2
				g.jizzcolor = true
			end
			g.frame = A|FF_FULLBRIGHT|TR_TRANS30
			g.sx = avgx
			g.sy = avgy
			g.dist = P_RandomRange(-400, 400)
			g.tics = 120 - timer
			g.lowquality = true
		
		elseif timer == 120
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_StartQuake(FRACUNIT*17, 20)
					P_FlashPal(v.control, 1, 10) //v.control, pallette, tics active, 5 is the inverted palette, 4 is the Arma's red flash pal, rest are just white flash excl 0
				end
			end
			for k,v in ipairs(mo.enemies)
				if v and v.control and v.control.valid
					P_StartQuake(FRACUNIT*17, 20)
					P_FlashPal(v.control, 1, 10) //v.control, pallette, tics active, 5 is the inverted palette, 4 is the Arma's red flash pal, rest are just white flash excl 0
				end
			end
			for i = 1, 5
				local beam = P_SpawnMobj(avgx, avgy, mo.z+(3+100*(i-1))*FRACUNIT, MT_DUMMY)
				beam.sprite = SPR_BEAM
				beam.frame = C|FF_FULLBRIGHT
				beam.color = SKINCOLOR_GOLD
				beam.scale = FRACUNIT*2
				beam.tics = 30
				beam.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				mo.alphabeam[#mo.alphabeam+1] = beam
			end
			for j = 1, 96
				local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
				st.state = S_MEGITHOK
				st.flags = $ & ~MF_NOGRAVITY
				st.momx = P_RandomRange(-128, 128)*FRACUNIT
				st.momy = P_RandomRange(-128, 128)*FRACUNIT
				st.momz = P_RandomRange(0, 128)*FRACUNIT
				st.fuse = TICRATE*4
				st.scale = FRACUNIT*2/3
			end
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN 
						buffStat(target, "def", -25)
					end					
				end
			end
		elseif timer == 140 or timer == 145
			for i = 1, 5
				local beam = mo.alphabeam[i]
				beam.frame = timer == 140 and B|FF_FULLBRIGHT or A|FF_FULLBRIGHT
			end
		elseif timer == 170
			return true
		end
		
		if timer == 1
			playSound(mo.battlen, sfx_golhal)
		end	
		
		if timer == 101
			playSound(mo.battlen, sfx_utstr)
		end
		
		if timer == 120
			playSound(mo.battlen, sfx_golhl2)
		end	
		
		local j = #mo.megi
		while j
			local h = mo.megi[j]
			if not h or not h.valid
				table.remove(mo.megi, j)
				j = $-1
				continue
			end
			
			if timer <= 100
				
				if h.dismom < 10 and timer <= 80
					h.dismom = $ + 1
					h.dist = $ + 10
				elseif timer > 90
					h.dismom = $ - 1
				end
				
				h.angle = $ + h.dismom*ANG1
				P_TeleportMove(h, avgx + h.dist*cos(h.angle), avgy + h.dist*sin(h.angle), h.z)
			elseif timer > 100 and timer < 120
				h.momx = $ + (avgx-h.x)/128
				h.momy = $ + (avgy-h.y)/128
				h.momz = $ + (mo.z-h.z)/128
			end
			
			j = $ - 1
		end
	end,
	}


--"Heavy" Single



--"Heavy" Group


	attackDefs["tr_last_disaster"] = {
		name = "Last Disaster",
		type = ATK_NUCLEAR,	    		
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 18,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Orbal Art (Enigma series)\nHeavy Nuke Damage (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		hudfunc = function(v, mo, timer)
			if timer >= 260 and timer < 270
				v.fadeScreen(0, (timer - 259))
			elseif timer >= 270 and timer < 300
				v.fadeScreen(0, 10)
			elseif timer >= 300 and timer < 310
				v.fadeScreen(0, (310 - timer))
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			
			local dist = 200
			local angle = mo.angle
			
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
			else
				angle = mo.tr_csetpos[2]
			end
			if timer >= 85 and timer <= 260
				dist = 2*(timer+15)
			end
			local rayx = mo.x + dist*cos(angle)
			local rayy = mo.y + dist*sin(angle)
			
			target = P_SpawnMobj(rayx, rayy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2
			
			
			local psiocolors = {SKINCOLOR_GREY, SKINCOLOR_CLOUDY, SKINCOLOR_BONE, SKINCOLOR_WHITE}
			
			if timer > 1 and timer < 25
				localquake(mo.battlen, FRACUNIT*10, 30)
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_BRICKDEBRIS
					t.scale = FRACUNIT*2
					t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
					t.fuse = 75
				end
			end
			
			if timer == 15
				playSound(mo.battlen, sfx_latdis)
			end	

			
			if timer >= 20 and timer <= 55
				if timer == 20
					playSound(mo.battlen, sfx_s3k74)
				end
				if not (timer%4)

					local ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
				end
			end	
			
			if timer == 25 
				localquake(mo.battlen, FRACUNIT*25, 10)
			end
			
			if timer == 45 
				localquake(mo.battlen, FRACUNIT*25, 10)
			end
			
			
			if timer == 80
				DoExplosion(target)
			end
			
			if timer == 85
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 10)
					end
				end	
			end	

			if timer >= 85 and timer <= 260
				local cang = R_PointToAngle(target.x, target.y)
				local cx = target.x - 48*cos(cang)
				local cy = target.y - 48*sin(cang)			
				for i = 1,16
					local dust = P_SpawnMobj(cx, cy, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SILVER
					dust.scale = FRACUNIT*2
				end		
				for i = 1, 8
					local thok = P_SpawnMobj(cx+P_RandomRange(-70, 70)*FRACUNIT, cy+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_GREY
					thok.tics = P_RandomRange(10, 35)
					thok.blendmode = AST_SUBTRACT
				end				
				for i = 1, 8
					local thok = P_SpawnMobj(cx+P_RandomRange(-70, 70)*FRACUNIT, cy+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.flags = MF_RUNSPAWNFUNC
					thok.frame = B
					thok.momz = P_RandomRange(1, 2)*FRACUNIT
					thok.color = SKINCOLOR_WHITE
					thok.scale = FRACUNIT*3
					thok.tics = P_RandomRange(10, 35)
				end
			end	


				
			if timer >= 85 and timer <= 260
				for i = 1, 2
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.color = SKINCOLOR_SILVER
					m.frame = D|FF_FULLBRIGHT|FF_TRANS50
					m.sprite = SPR_BEAM
					m.scale = FRACUNIT*4
				end	
			end
			
			if timer > 85 and timer < 260
				localquake(mo.battlen, FRACUNIT*50, 75)
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.colorized = true
					t.color = SKINCOLOR_BROWN
					t.scale = 2*FRACUNIT
					t.momz = (P_RandomRange(4,75)/2)*FRACUNIT
					t.fuse = 75
				end
			end
			
			if timer >= 260 and timer <= 310
				local bs = P_SpawnMobj(target.x+(P_RandomRange(-512, 512)*FRACUNIT), target.y+(P_RandomRange(-512, 512)*FRACUNIT), target.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
				bs.state, bs.color = S_MEGISTAR1, SKINCOLOR_WHITE
				bs.momz = -15*FRACUNIT
			end				
			
			if timer == 260
				playSound(mo.battlen, sfx_s3kb8)
			end	
			
			
			if timer == 300
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
				playSound(mo.battlen, sfx_lydhit)
				
			elseif timer == 320
				return true
			end	
		end,					
	}

attackDefs["tr_dark matter EX"] = {
    name = "Dark Matter EX",
    type = ATK_NUCLEAR,
    power = 350,
    accuracy = 90,
    costtype = CST_SP,
    cost = 25,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 4,
	tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
    desc = "Orbal Art (Liberlian).\nHeavy Nuke Damage (Set Area M).\nLowers agility.".."\x82".."\n   Custom 1 for Pos Mode.",
    target = TGT_ALLENEMIES,
    hudfunc =     function(v, mo, timer)

                        if timer >= TICRATE*2
                        and timer <= TICRATE*2+15
                            local t = timer-TICRATE*2
                            local p = "H_ATR"..t/2
                            if v.patchExists(p)
                                drawScreenwidePatch(v, v.cachePatch(p))
                            end
                        end
                    end,
    
    
    anim =     function(mo, targets, hittargets, timer)
    
        local battleStatus = server.P_BattleStatus[mo.battlen]
        
        if timer == 20
			mo.st = P_SpawnMobj(battleStatus.arena_coords[1], battleStatus.arena_coords[2], battleStatus.arena_coords[3] - FRACUNIT*52, MT_DUMMY)
            mo.st.state = S_DARKMATTER
            mo.st.fuse = TICRATE*2
            mo.st.scale = FRACUNIT*1/4
            mo.st.destspeed = TICRATE/2
            mo.st.destscale = FRACUNIT*500
            playSound(mo.battlen, sfx_darmat)
        end
        
		if #hittargets > 0	--In case we select nothing
			for i = 1,#hittargets
				local target = hittargets[i]
				if timer > 20 and timer <= TICRATE*2
					local squish = timer-20
					target.spritexscale = FRACUNIT + squish*FRACUNIT/16
					target.spriteyscale = FRACUNIT - squish*FRACUNIT/64
				end
			end	
		end
		
		
        if mo.st and mo.st.valid
            if timer%5 == 0
                local st = P_SpawnMobj(mo.st.x + P_RandomRange(-128, 128)<<FRACBITS, mo.st.y + P_RandomRange(-128, 128)<<FRACBITS, mo.st.z + P_RandomRange(-192, 192)<<FRACBITS, MT_DUMMY)
                st.color = SKINCOLOR_AZURE
                st.state = S_MEGISTAR1
                st.scale = mo.st.scale + P_RandomRange(0, 65535)
                st.target = mo.st
            end
			local thok = P_SpawnMobj(mo.st.x, mo.st.y, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP|MF_NOCLIP
			thok.color = SKINCOLOR_PURPLE
			if timer%2 then thok.color = SKINCOLOR_NEON end
			thok.frame = A
			thok.tics = 70
			thok.scale = FRACUNIT
			thok.scalespeed = FRACUNIT/32
			thok.destscale = 1
			thok.momz = P_RandomRange(8, 12)*FRACUNIT
			thok.momx = P_RandomRange(-10, 10)*FRACUNIT
			thok.momy = P_RandomRange(-10, 10)*FRACUNIT
        end
        
		if #hittargets > 0	--In case we select nothing
			for k,e in ipairs(hittargets)
				local target = e
				if timer == TICRATE*2
					target.spritexscale = FRACUNIT
					target.spriteyscale = FRACUNIT
					damageObject(target)			
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN  
						buffStat(target, "agi", -25)
					end    
				end
			end
		end
        
        if timer == TICRATE*3
            return true
        end
    end
}

attackDefs["tr_altair cannon"] = {
		name = "Altair Cannon",
		type = ATK_NUCLEAR,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 45,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
		end,
		desc = "Orbal Art (Arcus series). \nHeavy Nuke Damage to all enemies.\nLowers Magic Attack and Defense.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2

			if timer == 15
			or timer == 25
			or timer == 35
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT

				for i = 1, 32
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = TICRATE

				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)
			end
			
			if timer == 15
			or timer == 25
			or timer == 35
				local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z , MT_DUMMY)
				boom.state = S_GOLDENHALOBEAM1
				boom.color = SKINCOLOR_YELLOW
				boom.scale = FRACUNIT*4
				playSound(mo.battlen, sfx_hamas2)
			end	
			
			if timer == 40
				DoExplosion(target)
			end	

			if timer == 45
				playSound(mo.battlen, sfx_megi5)
				for i = 1, #hittargets
					local hit = hittargets[i]
					damageObject(hit)
					if hit.damagestate ~= DMG_MISS
					and hit.damagestate ~= DMG_BLOCK
					and hit.damagestate ~= DMG_DRAIN 
						buffStat(hit, "mag", -25)
						buffStat(hit, "def", -25)
						BTL_logMessage(hit.battlen, "Magic Attack down!\nDefense down!")
					end
				end

			elseif timer == 70
				return true
			end
		end,
}

attackDefs["tr_seventh caliber"] = {
		name = "Seventh Caliber",
		type = ATK_NUCLEAR,
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 48,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		desc = "Orbal Art (Arcus II).\nHeavy Nuke Damage to all enemies.\n50% Random Ailment chance.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT		
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2
			
			local colors = {SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_BLUE, SKINCOLOR_GREEN, SKINCOLOR_ORANGE, SKINCOLOR_PURPLE, SKINCOLOR_MAGENTA}
			local effects = {COND_BURN, COND_FREEZE, COND_SHOCK, COND_BRAINWASH, COND_DIZZY, COND_SILENCE, COND_SLEEP, COND_HEX, COND_DESPAIR,
				COND_RAGE, COND_HUNGER, COND_POISON}
			if bionis
				effects ={COND_BURN, COND_FREEZE, COND_SHOCK, COND_BRAINWASH, COND_DIZZY, COND_SILENCE, COND_SLEEP, COND_HEX, COND_DESPAIR,
				COND_RAGE, COND_HUNGER, COND_POISON, COND_TIMESLOW, COND_BLEED, COND_EGO, COND_FATIGUE, COND_PARANOIA, COND_PETRIFY}
			end		
			
			if timer == 1
				S_StartSound(nil, sfx_7thcal)
				S_StartSoundAtVolume(nil,sfx_7thcal,80)
			end	
			
			if timer == 45
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_GOLD
				mo.thing.frame = A
				mo.thing.tics = 100
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end
			
			if timer == 55
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_PURPLE
				mo.thing.frame = A
				mo.thing.tics = 104
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end
			
			if timer == 57
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_BLUE
				mo.thing.frame = A
				mo.thing.tics = 103
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			if timer == 59
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_GREEN
				mo.thing.frame = A
				mo.thing.tics = 102
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			if timer == 61
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_SILVER
				mo.thing.frame = A
				mo.thing.tics = 103
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			
			if timer == 61
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_RED
				mo.thing.frame = A
				mo.thing.tics = 102
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			if timer == 63
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_ORANGE
				mo.thing.frame = A
				mo.thing.tics = 105
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
				
				
			if timer == 65
			or timer == 70
			or timer == 75
			or timer == 77
			or timer == 79
				local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
				sm.fuse = TICRATE*2
				sm.scale = FRACUNIT*3/2
				for i = 1, 16
					local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*16, 10)
			end	
				
				
			if timer >= 90 and timer <= 180 and not (leveltime%8)
				local bs = P_SpawnMobj(target.x+(P_RandomRange(-212, 212)*FRACUNIT), target.y+(P_RandomRange(-212, 212)*FRACUNIT), target.z+(P_RandomRange(0, 212)*FRACUNIT), MT_BUFU)
				bs.state = S_SEVENBOOM1
				bs.colorized = true
				bs.scale = FRACUNIT*2
				bs.color = colors[P_RandomRange(1, #colors)]
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
			end	
			
			
			if timer >= 80
			and timer <= 160
			and not (leveltime%8)
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.flags = $ & ~MF_NOGRAVITY
					boom.colorized = true
					boom.color = colors[P_RandomRange(1, #colors)]
					boom.scale = FRACUNIT*2
					boom.momz = 8*FRACUNIT
				end	
			end	
			
			if timer >= 72
			and timer <= 160
			and not (leveltime%8)
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.flags = $ & ~MF_NOGRAVITY
					boom.colorized = true
					boom.color = colors[P_RandomRange(1, #colors)]
					boom.scale = FRACUNIT*1
					boom.momz = 8*FRACUNIT

				end	
			end	
			
			if timer == 150
			or timer == 160
			or timer == 170
				playSound(mo.battlen, sfx_bkpoof)
				local rndang = P_RandomRange(1,360)*ANG1
				for i = 1, 36
					local boom = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					boom.angle = rndang+(ANG10*i)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.scale = FRACUNIT*2
					P_InstaThrust(boom,boom.angle,50*FRACUNIT)
					
					if (i%2)
						local b = P_SpawnMobj(target.x, target.y, target.z, MT_BOOMPARTICLE)
						b.momx = P_RandomRange(-32, 32)<<FRACBITS
						b.momy = P_RandomRange(-32, 32)<<FRACBITS
						b.momz = P_RandomRange(0, 16)<<FRACBITS
						b.fuse = TICRATE*6
					end
				end
			end			
			
			
			if timer == 180
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 10)
					end
				end
			end
		
			
			if timer == 180
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32
					local st = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*2/3
				end
			end		
		
		
			if timer >= 181
			and timer <= 250
			and not (leveltime%8)
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT
				if not (leveltime%4)
					local b = P_SpawnMobj(bx, by, bz, MT_BOOMPARTICLE)
					b.momx = P_RandomRange(-32, 32)<<FRACBITS
					b.momy = P_RandomRange(-32, 32)<<FRACBITS
					b.momz = P_RandomRange(0, 16)<<FRACBITS
					b.fuse = TICRATE*6
				end
				for i = 1, 16
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = 20
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)
			end			
		
			
			if timer >= 181
			and timer <= 250
			and not (leveltime%4)
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT
				if not (leveltime%12)
					local b = P_SpawnMobj(bx, by, bz, MT_BOOMPARTICLE)
					b.momx = P_RandomRange(-32, 32)<<FRACBITS
					b.momy = P_RandomRange(-32, 32)<<FRACBITS
					b.momz = P_RandomRange(0, 16)<<FRACBITS
					b.fuse = TICRATE*6
				end
				for i = 1, 16
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = 20
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)
			end	
			
			if timer > 181 and timer < 250
				localquake(mo.battlen, FRACUNIT*50, 75)
				if not (leveltime%2)
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.colorized = true
					t.color = SKINCOLOR_CARBON
					t.scale = 4*FRACUNIT
					t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
					t.fuse = 75
				end
			end			
			
			
			if timer == 181		
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*6
				m.frame = D
				m.color = SKINCOLOR_GOLD
				m.tics = 70
			end
		
			if timer >= 181
			and timer <= 250	
				localquake(mo.battlen, FRACUNIT*50, 30)	
			end	
	
	
			local j = mo.columns and #mo.columns or 0
			while j
				local m = mo.columns[j]
				if not m or not m.valid
					j = $-1
					continue
				end

				for i = 1,5
					local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_GOLD
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)
				j = $-1
			end
			
			if timer == 182
				mo.fangle = (R_PointToAngle(target.x, target.y)) + ANG1*180
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)

				local a = mo.fangle - ANG1*80

				for i = 1, 16
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					P_InstaThrust(m, a, FRACUNIT*48)
					mo.columns[#mo.columns+1] = m
					m.state = S_INVISIBLE
					m.tics = TICRATE
					a = $+ ANG1*10
				end
			end	
	
	
			
			if timer == 230
				DoExplosion(target)
				DoExplosion(target)
				local btl = server.P_BattleStatus[mo.battlen]
				for i = 1, #hittargets
					local hit = hittargets[i]
					damageObject(hit)
					if hit.damagestate ~= DMG_MISS
					and hit.damagestate ~= DMG_BLOCK
					and hit.damagestate ~= DMG_DRAIN
					and P_RandomRange(0,1) == 1
						inflictStatus(hit, effects[P_RandomRange(1,#effects)])
					end
				end
			end	

			if timer == 260
				return true
			end
		end,
	}


--"Severe" Single



--"Severe" Group


attackDefs["tr_dev_blast"] = {
		name = "Devastation Blast",
		type = ATK_NUCLEAR,
		power = 650,
		accuracy = 90,
		costtype = CST_SP,
		cost = 48,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nSevere Nuke Damage to all enemies.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if timer == 10	--big sun of death
				playSound(mo.battlen, sfx_trdbl1)
				mo.bod = {}
				mo.zap = P_SpawnMobj(avgx, avgy, mo.z+FRACUNIT*480, MT_THOK)
				mo.zap.frame = A|FF_FULLBRIGHT
				mo.zap.tics = 300	--this will die naturally on timer == 310
				mo.zap.color = SKINCOLOR_PINK
				mo.zap.colorized = true
				mo.zap.scale = FRACUNIT/2
				mo.zap.destscale = FRACUNIT*5
				mo.zap.scalespeed = FRACUNIT*5/40
				mo.zap.blendmode = AST_ADD
				mo.zap.renderflags = $|RF_FULLBRIGHT
				mo.zap.flags = $|MF_NOGRAVITY
				
				local cam = server.P_BattleStatus[mo.battlen].cam

				local x = cam.x - 120*cos(cam.angle)
				local y = cam.y - 120*sin(cam.angle)
				CAM_goto(cam, x, y, cam.floorz + FRACUNIT*480)
			end
			
			if timer > 10 and timer < 40	--charging orbs
				
				if not (timer%3)
					local angle = P_RandomRange(1, 360)*ANG1
					local dist = P_RandomRange(180, 360)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
						
					local s = P_SpawnMobj(x, y, mo.z+FRACUNIT*320, MT_DUMMY)
					--s.sprite = SPR_SFBR
					s.frame = A|FF_FULLBRIGHT
					s.color = SKINCOLOR_PINK
					s.colorized = true
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.scale = FRACUNIT/10
					s.destscale = FRACUNIT*2
					s.scalespeed = FRACUNIT/10
					s.fuse = 20
					s.tics = 20
					s.dist = dist
					s.elev = P_RandomRange(-360, 360)
					s.angle = angle
					mo.bod[#mo.bod+1] = s
				end
			end
			
			if  timer >= 10 and mo.bod and #mo.bod	--fire orbs
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					if not mo.zap or not mo.zap.valid continue end	-- didn't ask
					
					if timer < 90
						if s.dist > 0
							s.dist = max(0, $-18)
						end
						
						if s.elev > 1
							s.elev = max(0, $-18)
						elseif s.elev < -1
							s.elev = min(0, $+18)
						elseif not s.elev == 0
							s.elev = 0
						end
						
						P_TeleportMove(s, mo.zap.x + s.dist *cos(s.angle), mo.zap.y + s.dist*sin(s.angle), mo.zap.z + s.elev*FRACUNIT)
						
						local g = P_SpawnGhostMobj(s)
						--s.sprite = SPR_SFBR
						g.frame = A|FF_FULLBRIGHT
						g.color = SKINCOLOR_PINK
						g.colorized = true
						g.tics = 15
						g.fuse = 15
						g.scale = s.scale*2
						g.destscale = s.scale/100
						g.scalespeed = s.scale/6
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
					else
						if timer > 220
							if s.dist > 0
								s.dist = max(0, $-72)
							end
							
							if s.elev > 1
								s.elev = max(0, $-72)
							elseif s.elev < -1
								s.elev = min(0, $+72)
							elseif not s.elev == 0
								s.elev = 0
							end
						end
						
						P_TeleportMove(s, mo.zap.x + s.dist *cos(s.angle), mo.zap.y + s.dist*sin(s.angle), mo.zap.z + s.elev*FRACUNIT)
						
						if timer >= 240
							local g = P_SpawnGhostMobj(s)
							--s.sprite = SPR_SFBR
							g.frame = A|FF_FULLBRIGHT
							g.color = SKINCOLOR_WHITE
							g.colorized = true
							g.tics = 15
							g.fuse = 15
							g.scale = s.scale*2
							g.destscale = s.scale/100
							g.scalespeed = s.scale/6
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
						end
					end
				end
			end
			
			if mo.zap and mo.zap.valid	--descending fireball
				if timer < 40
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_BFUE
					g.frame = G|FF_FULLBRIGHT
					g.color = SKINCOLOR_MAGENTA
					g.colorized = true
					g.tics = 10
					g.rollangle = timer*12*ANG1
					g.scale = mo.zap.scale*10
					g.destscale = mo.zap.scale/10
					g.scalespeed = mo.zap.scale
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*-36
					
					local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+ FRACUNIT*80, MT_DUMMY)
					g.sprite = SPR_NTHK
					g.frame = B|FF_FULLBRIGHT
					g.rollangle = timer*12*ANG1
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 10
					g.scale = mo.zap.scale
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					--g.momz = FRACUNIT*12
				end
				if timer > 40
					local g = P_SpawnGhostMobj(mo.zap)
					--g.sprite = SPR_NTHK
					g.frame = A|FF_FULLBRIGHT
					g.rollangle = timer*12*ANG1
					g.color = SKINCOLOR_PINK
					g.fuse = 10
					g.scale = mo.zap.scale
					g.destscale = mo.zap.scale*12/10
					g.scalespeed = mo.zap.scale/50
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					--g.momz = FRACUNIT*12
				end
				if timer == 70
					mo.zap.momz = (mo.zap.floorz - mo.zap.z)/100
					local cam = server.P_BattleStatus[mo.battlen].cam
					
					local x = cam.x - 360*cos(cam.angle)
					local y = cam.y - 360*sin(cam.angle)
					CAM_goto(cam, x, y, cam.floorz + FRACUNIT*120)
				end
				if mo.zap.z < mo.zap.floorz then mo.zap.z = mo.zap.floorz end
				
				if timer > 70 and timer < 180	--powerful aura of impending doom
					local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+ FRACUNIT*40, MT_DUMMY)
					g.sprite = SPR_BFUE
					g.frame = G|FF_FULLBRIGHT
					g.color = SKINCOLOR_MAGENTA
					g.colorized = true
					g.tics = 10
					g.rollangle = timer*12*ANG1
					g.scale = mo.zap.scale*2
					g.destscale = mo.zap.scale*3
					g.scalespeed = mo.zap.scale/10
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					--g.momz = FRACUNIT*24
					
					
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 120
					for i = 0, 12
						local angle = baseangle + i*6*ANG1
						local x, y = mo.zap.x + dist*cos(angle), mo.zap.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, mo.zap.z+i*FRACUNIT*2, MT_DUMMY)
						aura.state = S_BUFUDYNE_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = timer > 130 and SKINCOLOR_WHITE or SKINCOLOR_MAGENTA
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(10, 15)*FRACUNIT
						aura.scale = FRACUNIT*5
						aura.destscale = FRACUNIT*25
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(20, 40))
					end
					if timer > 100
						local baseangle = P_RandomRange(1, 360)*ANG1
						local dist = 240
						for i = 0, 24
							local angle = baseangle + i*6*ANG1
							local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
							
							local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = timer > 130 and SKINCOLOR_WHITE or SKINCOLOR_MAGENTA
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							aura.momz = P_RandomRange(1, 4)*FRACUNIT*3
							aura.scale = timer > 130 and FRACUNIT*6 or FRACUNIT*2
							aura.destscale = timer > 130 and FRACUNIT*15 or FRACUNIT*5
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4)*3)
						end
					end
					if timer > 160 and timer < 200
						local g = P_SpawnGhostMobj(mo.zap)
						g.sprite = SPR_NTHK
						g.frame = D|FF_FULLBRIGHT
						--g.rollangle = timer*12*ANG1
						g.color = SKINCOLOR_WHITE
						g.fuse = 10
						g.scale = mo.zap.scale
						g.destscale = mo.zap.scale*(timer-150)
						g.scalespeed = mo.zap.scale*(timer-150)/10
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						g.momz = FRACUNIT*12
					end
				end
				if timer == 170	--touch-down!
					mo.zap.sprite = SPR_NTHK
					mo.zap.frame = D|FF_FULLBRIGHT
					mo.zap.momz = 0
					mo.zap.fuse = mo.zap.tics	--bruh
					playSound(mo.battlen, sfx_trdbl2)
				end
				if timer > 210 and timer <= 220
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					g.color = SKINCOLOR_FOREST
					g.fuse = 2
					g.scale = mo.zap.scale*(32)/6
					g.destscale = mo.zap.scale*(32)/60
					--g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_DTHK
					g.frame = D|FF_FULLDARK
					--g.color = SKINCOLOR_JET
					g.fuse = 2
					g.scale = mo.zap.scale*(30)/6
					g.destscale = mo.zap.scale*(30)/60
					--g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLDARK
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 2
					g.scale = mo.zap.scale*(6)/6
					--g.destscale = mo.zap.scale*(6)/60
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 2
					g.scale = mo.zap.scale*(3)/6
					--g.destscale = mo.zap.scale*(3)/60
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					
					if timer == 211
						for i = 1, 24
							local angle = P_RandomRange(1, 360)*ANG1
							local dist = P_RandomRange(360, 720)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
								
							local s = P_SpawnMobj(x, y, mo.z+FRACUNIT*320, MT_DUMMY)
							--s.sprite = SPR_SFBR
							s.frame = A|FF_FULLBRIGHT
							s.color = SKINCOLOR_WHITE
							s.colorized = true
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT
							s.fuse = 50
							s.tics = 50
							s.dist = dist
							s.elev = P_RandomRange(0, 720)
							s.angle = angle
							mo.bod[#mo.bod+1] = s
						end
					end
				end
				if timer == 221
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					g.color = SKINCOLOR_FOREST
					g.fuse = 20
					g.scale = mo.zap.scale*(32)/6
					g.destscale = mo.zap.scale*(32)/60
					g.scalespeed = mo.zap.scale*(32)/120
					--g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*-30
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_DTHK
					g.frame = D|FF_FULLDARK
					--g.color = SKINCOLOR_JET
					g.fuse = 20
					g.scale = mo.zap.scale*(30)/6
					g.destscale = mo.zap.scale*(30)/60
					g.scalespeed = mo.zap.scale*(30)/120
					--g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLDARK
					g.momz = FRACUNIT*-30
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 20
					g.scale = mo.zap.scale*(6)/6
					g.destscale = mo.zap.scale*(6)/60
					g.scalespeed = mo.zap.scale*(6)/120
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*-30
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 20
					g.scale = mo.zap.scale*(3)/6
					g.destscale = mo.zap.scale*(3)/60
					g.scalespeed = mo.zap.scale*(3)/120
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momz = FRACUNIT*-30
					
				end
				if timer == 240
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 2, 10) //v.control, pallette, tics active, 5 is the inverted palette, 4 is the Arma's red flash pal, rest are just white flash excl 0
						end
					end

					for k,v in ipairs(mo.enemies)	-- Also perform the check on enemies.
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 2, 10) //v.control, pallette, tics active, 5 is the inverted palette, 4 is the Arma's red flash pal, rest are just white flash excl 0
						end
					end
				end
				if timer > 250 and timer < 310
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					--g.rollangle = timer*12*ANG1
					g.color = SKINCOLOR_RED
					g.fuse = 10
					g.scale = mo.zap.scale*(timer-250)/12
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					
					local g = P_SpawnGhostMobj(mo.zap)
					g.sprite = SPR_NTHK
					g.frame = D|FF_FULLBRIGHT
					--g.rollangle = timer*12*ANG1
					g.color = SKINCOLOR_PINK
					g.fuse = 10
					g.scale = mo.zap.scale*(timer-250)/10
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					--g.momz = FRACUNIT*-12
					
					local grow = (timer-250)*3
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 80*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
						
						local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_MAGENTA
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT
						aura.scale = FRACUNIT*3
						aura.destscale = FRACUNIT*12
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end
					
					if timer == 290
						playSound(mo.battlen, sfx_eethit)
						for i = 1, #hittargets
							local target = hittargets[i]
							damageObject(target)
						end
					end
				end
			end
			
			if timer == 350
				mo.bod = nil
				mo.zap = nil
				return true
			end
		end,
	}


--Support


attackDefs["tr_innocence_arc"] = {
		name = "Innocence Arc",
		dekunda = true,	-- see above w/ dekaja
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 10,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		desc = "Orbal Art (Enigma series)\nRemove party debuffs",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			local colors = {SKINCOLOR_GOLD, SKINCOLOR_YELLOW, SKINCOLOR_LIME}
			local strs = {"atk", "mag", "def", "agi", "crit"}
			
			
			if timer == 10
				local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*6
				playSound(mo.battlen, sfx_hamas1)
			end				
			
			if timer == 15
				local b = P_SpawnMobj(avgx, avgy, mo.z + 200*FRACUNIT, MT_DUMMY)
				b.momz = -15*FRACUNIT
				b.tics = -1
				b.color = SKINCOLOR_WHITE
				b.frame = A
				b.state = S_MEGISTAR1
				b.scale = FRACUNIT*3
				b.fuse = TICRATE*8
				playSound(mo.battlen, sfx_s3kb8)
			end			
			
			if timer == 50
				playSound(mo.battlen, sfx_s3k9f)
				playSound(mo.battlen, sfx_spheal)
			end	
			
			if timer == 50
				playSound(mo.battlen, sfx_hamas2)
				for j = 1, 32

					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_SSPK1
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*5
				end
			end			
			
			if timer > 50 and timer < 70
				local ol = P_SpawnMobj(avgx, avgy, mo.z + (mo.height/2), MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = SKINCOLOR_YELLOW
				ol.scale = (FRACUNIT/2)*(timer-40)
				ol.flags2 = $|MF2_SPLAT
				ol.frame = B|FF_ADD
				ol.tics = 2
				
				for i = 1,8
					local g = P_SpawnGhostMobj(ol)
					g.fuse = 4
					g.frame = B|FF_TRANS50|FF_ADD|FF_PAPERSPRITE
					g.angle = mo.angle + (ANGLE_45*i)
				end
			end			
			
			
			if timer == 60
				playSound(mo.battlen, sfx_curia)
			end

			for i = 1, #targets
				local target = targets[i]
				if timer == 70 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					for j = 1, #strs
						local t = targets[i]
						local s = strs[j]
						if t.buffs[s][1] < 0
							t.buffs[s][1] = 0
							t.buffs[s][2] = 0
						end
					end
					BTL_logMessage(targets[1].battlen, "Debuffs removed")
				end
			end
			if timer == 90
				return true
			end
		end,
}

attackDefs["tr_a_crest"] = {
		name = "A-Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = "Orbal Art (Liberlian).\nRaises defence by 1 stage (Area M)",
		target = TGT_ALLALLIES,
		buff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		anim = function(mo, targets, hittargets, timer)
			for i = 1,#hittargets
				local target = hittargets[i]
				
				if timer == 10 + (i-1)*4
					playSound(mo.battlen, sfx_crest)
				end	
				
				if timer >= 10 and timer <= 70 + (i-1)*4
					if not (timer%7)
						local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
						ol.sprite = SPR_CRST
						ol.scale = 1
						ol.destscale = FRACUNIT*1
						ol.scalespeed = FRACUNIT/3
						ol.frame = A|FF_TRANS50
						ol.colorized = true
						ol.color = SKINCOLOR_EMERALD
						ol.tics = 13
					end
				end
				if timer == 70 + (i-1)*4
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_EMERALD
						dust.scale = FRACUNIT*2
					end
			
			
				elseif timer == 71 + (i-1)*4
					playSound(mo.battlen, sfx_buff)
					
					buffStat(target, "def")
				
					
				elseif timer == 90 + #hittargets*4
					return true
				end
			end	
		end,
}

attackDefs["tr_fortuna"] = {
		name = "Fortuna",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 21,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		tr_castarea = 5,
		desc = "Orbal Art (Enigma series).\nRaises magic attack and defence\n by 1 stage (Area L).",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				local sun = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*256,MT_DUMMY)
				sun.sprite = SPR_FLAM
				sun.frame = M|FF_FULLBRIGHT
				sun.colorized = true
				sun.color = SKINCOLOR_SUPERGOLD1
				sun.tics = -1
				mo.sun = sun
				playSound(mo.battlen, sfx_s3k9f)
				playSound(mo.battlen, sfx_fortun)
			end
			for tg = 1,#hittargets
				if mo.sun and mo.sun.valid
					local t = hittargets[tg]
					local sun = mo.sun
					local tx = t.x + P_RandomRange(-64,64)*FRACUNIT
					local ty = t.y + P_RandomRange(-64,64)*FRACUNIT
					if P_RandomRange(0,1) and timer <= 60
						local thok = P_SpawnMobj(sun.x,sun.y,sun.z + FRACUNIT*8,MT_DUMMY)
						thok.scale = FRACUNIT/2
						thok.frame = A|FF_FULLBRIGHT
						thok.color = SKINCOLOR_SUPERGOLD2
						thok.tics = 30
						thok.momx = (tx - thok.x)/30
						thok.momy = (ty - thok.y)/30
						thok.momz = (t.z - thok.z)/30
					end
				end
				if timer == 35
					local t = hittargets[tg]
					buffStat(t, "mag")
					buffStat(t, "def")
					BTL_logMessage(targets[1].battlen, "Magic Attack up!\nDefence up!")
				end
				if timer >= 35 and timer < 70
					local t = hittargets[tg]
					summonAura(t, SKINCOLOR_SUPERGOLD2)
				end
			end
			if timer == 35
				playSound(mo.battlen, sfx_heal2)
				playSound(mo.battlen, sfx_buff)
			end
			if timer == 70
				mo.sun.fuse = 20
				mo.sun.destscale = 1
				mo.sun.scalepseed = FRACUNIT/20
				mo.sun = nil
				return true
			end
		end,
}

attackDefs["tr_genesic_barrier"] = {
	name = "Genesic Barrier",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 32,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nGive all allies a barrier \nthat blocks one magical attack each.",
	target = TGT_ALLALLIES,
	nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
		local cancel = true
		for i = 1, #targets
		local target = targets[i]
			if not target.tr_artGuard
				cancel = false
			end
		end
		if cancel
			BTL_logMessage(targets[1].battlen, "Arts Guard already active!")
			return true
		end
	end,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD3))
	end,
	anim = function(mo, targets, hittargets, timer)
		for i = 1, #hittargets
			local target = hittargets[i]
			local avgx = 0
			local avgy = 0
			
			if timer == 10 and i == 1
				playSound(mo.battlen, sfx_adashd)
			end
			
			if timer == 10
				local x = target.x + 48*cos(target.angle)
				local y = target.y + 48*sin(target.angle)
				local m = P_SpawnMobj(x, y, target.z, MT_DUMMY)
				m.sprite = SPR_ADSL
				m.scale = FRACUNIT*1
				m.frame = A|FF_TRANS10|FF_PAPERSPRITE
				m.angle = target.angle + ANG1*90
				m.tics = 80
				m.colorized = true
				m.color = SKINCOLOR_AQUA
				target.shield = m
			elseif timer == 60
				target.shield.frame = A|FF_TRANS50|FF_PAPERSPRITE
			elseif timer == 65
				target.shield.frame = A|FF_TRANS60|FF_PAPERSPRITE
			elseif timer == 70	
				target.shield.frame = A|FF_TRANS70|FF_PAPERSPRITE
			elseif timer == 75	
				target.shield.frame = A|FF_TRANS80|FF_PAPERSPRITE
			elseif timer == 80	
				target.shield.frame = A|FF_TRANS90|FF_PAPERSPRITE	
			end	

			
			if timer >= 10 and timer <= 80
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_APRICOT
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					thok.frame = A|FF_TRANS70
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end

			
			if timer >= 10 and timer <= 80
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[i]
					avgx = $+ t.x/FRACUNIT
					avgy = $+ t.y/FRACUNIT
					local s = P_SpawnMobj(t.x + P_RandomRange(-58, 58)<<FRACBITS, t.y + P_RandomRange(-58, 58)<<FRACBITS, t.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end	
			end	
			
			if timer == 85
				local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
				target.tr_artGuard = 1 --give them the tag 
				tr_addSkill(target, "tr_guard_check")
				BTL_logMessage(mo.battlen, target.name.." gains Arts Guard (Magical nullifcation)!")
			end
		end
		
		if timer == 105
			return true
		end
	end,	
}

attackDefs["tr_a_reflex"] = {
	name = "A-Reflex",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 16,
	tr_orbal = true,	--custom aura effect & sounds
	target = TGT_ALLY,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD3))
	end,
	superbuff = true,
	desc = "Orbal Art (Enigma series).\nGive a barrier that repels \nmagic attacks to one ally.",
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		if target.cards
			local cam = server.P_BattleStatus[mo.battlen].cam
			for kk, vv in ipairs(target.cards)

				if not target continue end
				if not vv continue end

				if timer <= 90

					local target_x = target.x + 80*(cos(vv.angle - ANG1*80))
					local target_y = target.y + 80*(sin(vv.angle - ANG1*80))
					vv.frame = A|FF_PAPERSPRITE
					vv.scale = FRACUNIT + FRACUNIT/3
					vv.angle = $-ANG1*35

					P_TeleportMove(vv, target_x, target_y, vv.z)
				else
					if vv and vv.valid
						vv.momz = 0
					end
				end

				if timer == 90
				and vv.valid
					P_RemoveMobj(vv)
				end
			end
		end

		if timer == 90
			target.cards = nil
		end		
		
		if timer == 10
			playSound(mo.battlen, sfx_areflx)
		end	
		
		if timer >= 10 and timer < 40
		and (timer%5) == 0
			local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.flags = MF_NOBLOCKMAP
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*1
		end	
		
		if timer >= 40 and timer <= 80
			if not (timer%3)
				local thok = P_SpawnMobj(target.x + P_RandomRange(-54, 54)*FRACUNIT, target.y + P_RandomRange(-54, 54)*FRACUNIT, target.z, MT_DUMMY)
				thok.state = S_SSPK1
				thok.color = SKINCOLOR_YELLOW
				thok.colorized = true
				thok.momz = P_RandomRange(1, 20)*FRACUNIT
				thok.scale = FRACUNIT*1
			end	
		end	
		
		
		if timer >= 40
		and timer <= 80		
			if not (timer%4)
				if not target.cards then target.cards = {} end
				for i = 1,4
					local angle = P_RandomRange(1, 359)*ANG1
					local x = target.x + 64*(cos(angle))
					local y = target.y + 64*(sin(angle))
					local item = P_SpawnMobj(x, y, target.z, MT_DUMMY)
					item.tics = -1
					item.sprite = SPR_FORC
					item.frame = A|FF_PAPERSPRITE|FF_TRANS50
					item.scale = FRACUNIT*1/2
					item.colorized = true
					item.color = SKINCOLOR_SUPERGOLD3				
					item.angle = angle - ANG1*80
					item.momz = 3*FRACUNIT
					table.insert(target.cards, item)
				end
			end
		end	
		
		if timer == 80
			for i = 1, 64
				local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_SUPERGOLD2 or SKINCOLOR_SUPERGOLD1
				t.scale = FRACUNIT*1/2
			end
		end
		
		if timer == 81
			local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
			thok.state = S_INVISIBLE
			thok.tics = 1
			A_OldRingExplode(thok, MT_SUPERSPARK)
			target.makarakarn = true
			BTL_logMessage(targets[1].battlen, target.name.." has\na magic barrier!")
		end
		
		if timer == 100
			return true
		end
	end,
}








