------{ Time Arts }------

--ATTACK ARTS

--"Light" Single


attackDefs["tr_soul_blur"] = {
		name = "Soul Blur",
		type = ATK_CURSE,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_SHOCK,
		statuschance = 10,
		desc = "Orbal Art (Liberlian).\nLight Curse Damage to one enemy.\n10% Shock chance.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				S_StartSound(nil,sfx_solblu)
			end	
			
			if timer < 35
				summonAura(mo, SKINCOLOR_PURPLE)
			end
			
			if timer > 1 and timer < 20
				local b = P_SpawnMobj(mo.x, mo.y, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_SILVER
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/12
				b.tics = TICRATE/4
			end			
			
			if timer == 20
			or timer == 25
			or timer == 30
			or timer == 35
			or timer == 40
				local thok = P_SpawnMobj(mo.x + P_RandomRange(-80, 80)*FRACUNIT, mo.y +P_RandomRange(-80, 80)*FRACUNIT , mo.z + 32*FRACUNIT, MT_DUMMY)	
				if P_RandomRange(0,1)
					thok.color = SKINCOLOR_JET
				else
					thok.color = SKINCOLOR_PURPLE
				end
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 10
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/10
				thok.momy = (target.y - thok.y)/10
				thok.momz = ((target.z + 32*FRACUNIT) - thok.z)/10
				target.bruhn = thok
				
				S_StartSound(nil,sfx_s3k81)
			end
			if timer == 20
			or timer == 25
			or timer == 30
			or timer == 35
			or timer == 40
				mo.sx = target.x
				mo.sy = target.y
				mo.sz = target.z
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + 10*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_JET
					ol.scale = 1
					ol.destscale = target.scale*3
					ol.scalespeed = (target.scale*3)/15
					ol.frame = B|FF_TRANS80|FF_FULLBRIGHT
					ol.tics = i + 5	
				end	
				if timer == 40
					damageObject(target)
					S_StartSound(nil,sfx_hit)
				else
					S_StartSound(nil,sfx_slash)
				end
			end
			if timer == 80
				return true
			end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.flags2 = $|MF2_SPLAT
				if P_RandomRange(0,1)
					srbtwomoment.color = SKINCOLOR_JET
				else
					srbtwomoment.color = SKINCOLOR_PURPLE
				end
			end			
		end,
}


--"Light" Group


attackDefs["tr_calamity_edge"] = {
		name = "Calamity Edge",
		type = ATK_CURSE,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = "Orbal Art (Enigma series).\nLight Curse Damage (Set Line M).\nFlat 20% Deathblow chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			
			if timer == 1
				playSound(mo.battlen, sfx_caledg)
			end
			if timer < 50
				local rangle = P_RandomRange(0, 359)
				local cx = mo.x + 128*cos(mo.angle + ANG1*(rangle))
				local cy = mo.y + 128*sin(mo.angle + ANG1*(rangle))
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 15
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT/2)/15
				thok.scale = FRACUNIT/2
				thok.momx = (mo.x - thok.x)/15
				thok.momy = (mo.y - thok.y)/15
				thok.momz = (mo.z - thok.z)/15
			end //I will never not stop borrowing from myself
			if timer == 50
				playSound(mo.battlen, sfx_s3k81)
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)	
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				thok.tics = 20
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/20
				thok.momy = (target.y - thok.y)/20
				thok.momz = (target.z - thok.z)/20
				mo.bruhn = thok
			end
			
			if timer == 60
				playSound(mo.battlen, sfx_eih4)	--changed so you only hear the screams of the damned as they sink into Gehenna.
			end
			
			if timer >= 60 and timer <= 74
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_JET
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_PURPLE
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_DUSK
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
			end			
			
			
			if timer == 75
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
				playSound(mo.battlen, sfx_cdpcm9)
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				thok.tics = 10
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/10
				thok.momy = (target.y - thok.y)/10
				thok.momz = (target.z - thok.z)/10
			end
			if timer == 80
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						local hit = hittargets[i]
						damageObject(hit)	--this should just hit everything highlighted
						tr_deathblow(hit, 20)
					end
				end
				playSound(mo.battlen, sfx_s3k4e)
				if target.damagestate ~= DMG_MISS
					for i = 1,50
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = SKINCOLOR_JET
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				end
			end
			
			if timer > 81 and timer < 105
				localquake(mo.battlen, FRACUNIT*7, 10)
				local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}					
				if leveltime%2 == 0
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = C|TR_TRANS10
					t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/6
				end

				if leveltime%3 == 0
					local caman = R_PointToAngle(target.x, target.y)

					local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = D|TR_TRANS10
					t.color = SKINCOLOR_PURPLE
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/4
				end
			end					
			
			if mo.bruhn and mo.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(mo.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_DUSK
			end
			
			if timer == 120 
				mo.bruhn = nil
				return true
			end
        end,
}


--"Medium" Single


attackDefs["tr_hell_gate"] = {
		name = "Hell Gate",
		type = ATK_CURSE,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		status = COND_SHOCK,
		statuschance = 10,
		desc = "Orbal Art (Liberlian).\nMedium Curse Damage (Area S). \n10% Shock chance.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			for ht = 1,#hittargets
				local target = hittargets[ht]
				
				if timer >= 1 and timer <= 74
					for i = 1,3
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_PURPLE
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 35
						thok.scale = FRACUNIT/1
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(5, 10)*FRACUNIT
						thok.momx = P_RandomRange(-6, 6)*FRACUNIT
						thok.momy = P_RandomRange(-6, 6)*FRACUNIT
					end	
				end

				
				if timer > 25
				and timer <= 75
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if P_RandomRange(0,1)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 35
					thok.scale = FRACUNIT*1
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/105
					thok.momx = P_RandomRange(-5,5)*FRACUNIT
					thok.momy = P_RandomRange(-5,5)*FRACUNIT
					thok.momz = P_RandomRange(10,30)*FRACUNIT
				end
				if timer == 75
					damageObject(target)
				end
			end
			
			if timer == 1
				S_StartSound(nil,sfx_helgat)
			end	
	
			if timer == 25
				S_StartSound(nil,sfx_s3k9b)
			end
			if timer == 75
				S_StartSound(nil,sfx_slash)
			end
			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_shadow_spear"] = {
	name = "Shadow Spear",
	type = ATK_CURSE,
	power = 170,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian) \nMedium Curse Damage to one enemy.\nFlat 20% Deathblow chance.",
	target = TGT_ENEMY,	
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
	end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 10
			playSound(mo.battlen, sfx_trshsp)
		end
		
		if timer >= 10 and timer <= 130	-- portal
			local portal = P_SpawnMobj(target.x, target.y, target.floorz+360*FRACUNIT, MT_DUMMY)			
			portal.sprite = SPR_MUDO
			portal.scale = FRACUNIT*timer/50
			portal.frame = A
			portal.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
			portal.frame = FF_FULLBRIGHT
			portal.blendmode = AST_ADD
			portal.colorized = true
			portal.color = SKINCOLOR_MAGENTA
			portal.tics = 10
			
			if not (timer%5)
				local ol = P_SpawnMobj(target.x, target.y, target.floorz+360*FRACUNIT, MT_DUMMY)
				ol.flags = $|MF_NOGRAVITY
				ol.sprite = SPR_NTHK
				ol.color = SKINCOLOR_MAGENTA
				ol.scale = FRACUNIT/2
				ol.scalespeed = FRACUNIT/2
				ol.destscale = FRACUNIT*10
				ol.flags2 = $|MF2_SPLAT
				ol.frame = B|FF_FULLBRIGHT
				ol.blendmode = AST_ADD
				ol.tics = 20
				ol.momz = FRACUNIT*10
			end
		end
		
		if timer == 130
			--playSound(mo.battlen, sfx_erhlan)
			
			local ang = (360/6 *i)*ANG1
			local c = P_SpawnMobj(target.x, target.y, target.floorz+360*FRACUNIT, MT_DUMMY)
			c.sprite = SPR_PHPN
			c.frame = B|FF_FULLBRIGHT
			c.blendmode = AST_ADD
			c.renderflags = $|RF_FULLBRIGHT
			--c.colorized = true
			--c.color = SKINCOLOR_MAGENTA
			c.scale = FRACUNIT*3/2
			c.angle = ang+ANG1*90
			c.tics = 60
			c.flags = $ & !MF_NOCLIPHEIGHT
			c.momz = (mo.floorz - c.z)/15
			
			for i = 1, 24
				local sb = P_SpawnMobj(target.x, target.y, target.floorz+360*FRACUNIT, MT_DUMMY)
				sb.state = S_THOK
				sb.colorized = true
				sb.color = SKINCOLOR_MAGENTA
				sb.frame = FF_FULLBRIGHT
				sb.blendmode = AST_ADD
				sb.renderflags = $|RF_FULLBRIGHT
				sb.scale = FRACUNIT/4
				sb.momx = P_RandomRange(-8, 8)*FRACUNIT
				sb.momy = P_RandomRange(-8, 8)*FRACUNIT
				sb.momz = P_RandomRange(-12, -8)*FRACUNIT
				sb.tics = 40
			end
		elseif timer == 135
			local ol = P_SpawnMobj(target.x, target.y, target.floorz+60*FRACUNIT, MT_DUMMY)
			ol.flags = $|MF_NOGRAVITY
			ol.sprite = SPR_NTHK
			ol.color = SKINCOLOR_MAGENTA
			ol.scale = FRACUNIT/2
			ol.scalespeed = FRACUNIT/2
			ol.destscale = FRACUNIT*10
			ol.flags2 = $|MF2_SPLAT
			ol.frame = B|FF_FULLBRIGHT
			ol.blendmode = AST_ADD
			ol.tics = 20
			ol.momz = FRACUNIT*10
		
		
		elseif timer == 145
			localquake(mo.battlen, FRACUNIT*6, 12)
			
		elseif timer == 190
			damageObject(target)
			playSound(mo.battlen, sfx_eethit)
			playSound(mo.battlen, sfx_firbol)
			tr_deathblow(target, 20)
			
		elseif timer > 190 and timer <= 200
			for i = 1, 6
				local sb = P_SpawnMobj(target.x+(P_RandomRange(-40, 40)*FRACUNIT), target.y+(P_RandomRange(-40, 40)*FRACUNIT), target.floorz+(P_RandomRange(0, 40)*FRACUNIT), MT_DUMMY)
				sb.sprite = SPR_BFUE
				sb.colorized = true
				sb.color = SKINCOLOR_MAGENTA
				sb.frame = G|FF_FULLBRIGHT
				sb.blendmode = AST_ADD
				sb.renderflags = $|RF_FULLBRIGHT
				sb.scale = FRACUNIT
				sb.momx = P_RandomRange(-4, 4)*FRACUNIT
				sb.momy = P_RandomRange(-4, 4)*FRACUNIT
				sb.momz = P_RandomRange(3, 6)*FRACUNIT
				sb.tics = 20
			end
		elseif timer == 220
			return true
		end
	end,

}


--"Medium" Group


attackDefs["tr_white_gehenna"] = {	--placeholder sounds
		name = "White Gehenna",
		type = ATK_CURSE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		status = COND_SHOCK,
		statuschance = 7,
		desc = "Orbal Art (Liberlian).\nMedium Curse Damage (Area M). \n7% Shock chance.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2
		
			if timer < 40
				local portal = P_SpawnMobj(target.x, target.y, target.floorz+10*FRACUNIT, MT_DUMMY)
				portal.sprite = SPR_SHOT
				portal.scale = FRACUNIT*2
				portal.frame = E
				portal.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
				portal.frame = FF_FULLBRIGHT
				portal.blendmode = AST_ADD
				portal.colorized = true
				portal.color = SKINCOLOR_LILAC
				if timer > 15 then portal.color = SKINCOLOR_JET end
				portal.tics = 2
				
				if timer%2
					local thok = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = P_RandomRange(2, 5)|FF_FULLBRIGHT
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.scale = FRACUNIT
					thok.color = SKINCOLOR_LILAC
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 40
				playSound(mo.battlen, sfx_icibrk)
				playSound(mo.battlen, sfx_lzap)
				for i = 1, 12
					local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = P_RandomRange(1, 4)|FF_FULLBRIGHT
					thok.momz = P_RandomRange(12, 32)*FRACUNIT
					thok.scale = FRACUNIT*5
					thok.color = SKINCOLOR_LILAC
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer > 40 and timer < 80
				local portal = P_SpawnMobj(target.x, target.y, target.floorz+10*FRACUNIT, MT_DUMMY)
				portal.sprite = SPR_SHOT
				portal.scale = FRACUNIT*5
				portal.frame = F
				portal.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
				portal.frame = FF_FULLBRIGHT
				portal.blendmode = AST_ADD
				portal.colorized = true
				portal.color = SKINCOLOR_LILAC
				if timer > 45 then portal.color = SKINCOLOR_JET end
				portal.tics = 2
				for i = 1, 2
					local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = P_RandomRange(1, 4)|FF_FULLBRIGHT
					thok.momz = P_RandomRange(12, 32)*FRACUNIT
					thok.scale = FRACUNIT*3
					thok.color = SKINCOLOR_LILAC
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.tics = P_RandomRange(10, 35)
				end
			end
			
			if timer == 1
				playSound(mo.battlen, sfx_trwhgh)
			end
			
			if timer >= 80 and timer < 170	--portal's open
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 0
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z+(FRACUNIT*5)+(i*20), MT_DUMMY)
					aura.state = S_CDUST1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_LILAC
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT|RF_FLOORSPRITE|RF_SPLATMASK
					aura.momz = 0
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*12
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 15))
				end	
			end
			
			if timer >= 80 and timer < 160	--electric skull pillar
				if timer == 80
					mo.bod = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					mo.bod.state = S_JETFUME1
					mo.bod.colorized = true
					mo.bod.frame = FF_FULLBRIGHT
					mo.bod.color = SKINCOLOR_VIOLET
					mo.bod.blendmode = AST_ADD
					mo.bod.renderflags = $|RF_FULLBRIGHT
					mo.bod.tics = 50
					mo.bod.fuse = 50
					mo.bod.scale = FRACUNIT*3
					mo.bod.momz = FRACUNIT*24
				end
				if mo.bod and mo.bod.valid
					for i = 0, 3
						local g = P_SpawnGhostMobj(mo.bod)
						g.sprite = SPR_STAB
						g.frame = i|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.fuse = 2
						g.scale = FRACUNIT*3
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						g.momz = FRACUNIT*24
					end
					for i = 0, 3
						local g = P_SpawnGhostMobj(mo.bod)
						g.sprite = SPR_STAB
						g.frame = i|FF_FULLBRIGHT
						g.rollangle = -timer*12*ANG1
						g.fuse = 2
						g.scale = FRACUNIT*3
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						g.momz = FRACUNIT*24
					end
				end
				if timer > 80
					local sk = P_SpawnMobj(target.x+P_RandomRange(-60, 60)*FRACUNIT, target.y+P_RandomRange(-60, 60)*FRACUNIT, target.z+10*FRACUNIT, MT_DUMMY)
					sk.sprite = SPR_PHPN
					sk.frame = P_RandomRange(0, 1) and A|FF_FULLBRIGHT or A|FF_FULLBRIGHT|FF_HORIZONTALFLIP
					sk.colorized = true
					sk.color = SKINCOLOR_DUSK
					sk.tics = 50
					sk.scale = FRACUNIT*3/2
					sk.blendmode = AST_ADD
					sk.renderflags = $|RF_FULLBRIGHT
					sk.momz = FRACUNIT*24
					
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 0
					for i = 0, 6
						local angle = baseangle + i*12*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, target.z+(FRACUNIT*5)+(i*20), MT_DUMMY)
						aura.state = S_THOK
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_BLACK
						aura.momz = FRACUNIT*P_RandomRange(12, 24)
						aura.scale = FRACUNIT/2
						aura.destscale = FRACUNIT*2
						aura.fuse = 10
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(20, 80))
					end	
				end
			end
			
			if timer > 95 and timer < 180
				
				local sb = P_SpawnMobj(target.x+P_RandomRange(-300, 300)*FRACUNIT, target.y+P_RandomRange(-300, 300)*FRACUNIT, target.z+P_RandomRange(60, 300)*FRACUNIT, MT_DUMMY)
				--sb.state = S_THOK
				sb.colorized = true
				sb.color = SKINCOLOR_LILAC
				sb.frame = FF_FULLBRIGHT
				sb.blendmode = AST_ADD
				sb.renderflags = $|RF_FULLBRIGHT
				sb.scale = FRACUNIT/2
				sb.destscale = FRACUNIT*8
				sb.tics = 12
			end
			
			if timer == 150
				for i = 1, #hittargets
					local targ = hittargets[i]
					damageObject(targ)
				end
			end
			
			if timer == 200
				mo.bod = nil
				return true
			end
			
		end,
}

attackDefs["tr_death_spiral"] = {
		name = "Death Spiral",
		type = ATK_CURSE,
		power = 170,
		accuracy = 90,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = "Orbal Art (Enigma series).\nMedium Curse Damage (Area M).\nFlat 10% Deathblow chance.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			for hit = 1,#hittargets
				local target = hittargets[hit]

				if timer >= 38 and timer <= 110
					if not (leveltime%6)
						local avgx, avgy = 0, 0
						for i = 1, #hittargets -- Get average position of targets
							avgx = $ + hittargets[i].x/FRACUNIT
							avgy = $ + hittargets[i].y/FRACUNIT
						end
						avgx = ($/#hittargets)*FRACUNIT
						avgy = ($/#hittargets)*FRACUNIT					
						if leveltime%2 == 0
							local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
							t.fuse = TICRATE/2
							t.sprite = SPR_MUDO
							t.tics = -1
							t.frame = C|TR_TRANS10
							t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
							t.scale = FRACUNIT/3
							t.destscale = FRACUNIT*3
							t.scalespeed = FRACUNIT/6
						end

						if leveltime%4 == 0
							local caman = R_PointToAngle(avgx, avgy)
							local t = P_SpawnMobj(avgx + 2*cos(caman), avgy + 2*cos(caman), mo.z, MT_THOK)
							t.fuse = TICRATE/2
							t.sprite = SPR_MUDO
							t.tics = -1
							t.frame = D|TR_TRANS10
							t.color = SKINCOLOR_PURPLE
							t.scale = FRACUNIT/3
							t.destscale = FRACUNIT*3
							t.scalespeed = FRACUNIT/4
						end
						for i = 1, 8
							local thok = P_SpawnMobj(avgx+(P_RandomRange(-312, 312)*FRACUNIT), avgy+(P_RandomRange(-312, 312)*FRACUNIT), mo.z+(P_RandomRange(0, 100)*FRACUNIT), MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = 30*FRACUNIT
							thok.scale = FRACUNIT*3
							thok.color = SKINCOLOR_PURPLE
							thok.tics = P_RandomRange(10, 35)
						end							
					end	
				end		

				
				if timer == 18
					target.rotspike = {}
					for i = 1,4
						local tgtx = target.x + 72*cos(target.angle + (ANGLE_90*i))
						local tgty = target.y + 72*sin(target.angle + (ANGLE_90*i))
						local thok = P_SpawnMobj(tgtx, tgty, target.floorz, MT_DUMMY)	
						thok.sprite = SPR_USPK
						thok.frame = A|FF_FULLBRIGHT
						thok.colorized = true
						thok.color = SKINCOLOR_CRIMSON
						thok.tics = -1
						thok.scale = 1
						thok.destscale = target.scale * 2
						thok.scalespeed = (target.scale * 2)/5
						target.rotspike[i] = thok
					end
				end
				if timer > 35
				and timer <= 118
					for i = 1,4
						local s = target.rotspike[i]
						local tgtx = target.x + (118 - timer)*cos((target.angle + (ANGLE_90*i)) + (ANG10*timer))
						local tgty = target.y + (118 - timer)*sin((target.angle + (ANGLE_90*i)) + (ANG10*timer))
						P_TeleportMove(s,tgtx,tgty,target.floorz)
						if timer == 36
							s.destscale = target.scale * 10
							s.scalespeed = ((target.scale * 10) - (target.scale * 2))/70
						end
					end
					summonAura(target, SKINCOLOR_NEON)
					localquake(mo.battlen, FRACUNIT*5, 10)
				end
				if timer == 118
					for i = 1,4
						local s = target.rotspike[i]
						s.fuse = 2
					end
					for i = 1,40
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						if (i%2)
							thok.color = SKINCOLOR_JET
						else
							thok.color = SKINCOLOR_PURPLE
						end
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
					damageObject(target)
					tr_deathblow(target, 10)
				end
				if timer == 145
					target.rotspike = nil
					return true
				end
			end
			
		
			
			//Sound test!
			if timer == 1
				S_StartSound(nil,sfx_deaspl)
				S_StartSound(nil,sfx_deaspl)
			end
			
			if timer == 18
				S_StartSound(nil,sfx_spkdth)
			end
			
			if timer == 36
				S_StartSound(nil,sfx_debuff)
			end
			if timer == 118
				S_StartSound(nil,sfx_bsnipe)
			end
			if timer == 150
				return true //this is just a failsafe
			end
		end,
}

attackDefs["tr_calvary_edge"] = {
		name = "Calvary Edge",
		type = ATK_CURSE,
		power = 170,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		desc = "Orbal Art (Arcus II)\nMedium Curse Damage (Area M).",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT		
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2
			
			if timer == 1
				local thok = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*100, MT_DUMMY)	
				thok.sprite = SPR_USPK
				thok.frame = A
				thok.colorized = true
				thok.color = SKINCOLOR_NEON
				thok.tics = 130
				thok.scale = 1
				thok.destscale = target.scale * 7
				thok.scalespeed = (target.scale * 10)/10
				S_StartSound(nil,sfx_calved)
				S_StartSound(nil,sfx_calved)
			end
			if timer == 10
				S_StartSound(nil,sfx_bsnipe)//fukin idk
				--not curse enough, blow shit up
				for i = 1,75
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if (i%2)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end
			end
			
			if timer == 49
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer >= 50 and timer <= 130
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[1]
					local s = P_SpawnMobj(t.x +P_RandomRange(-120, 120)*FRACUNIT, t.y +P_RandomRange(-120, 120)*FRACUNIT, t.z +P_RandomRange(0, 120)*FRACUNIT, MT_DUMMY)
					s.color = SKINCOLOR_MAGENTA
					s.state = S_MEGISTAR1
					s.scale = $*2 + P_RandomRange(0, 65535)
				end	
			end	
			
			if timer >= 50 and timer <= 130
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				m.color = SKINCOLOR_PURPLE
				m.frame = D|TR_TRANS80
				m.scale = FRACUNIT*3
				m.sprite = SPR_BEAM
				m.tics = 20	
				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = 30*FRACUNIT
					thok.color = SKINCOLOR_NEON
					thok.tics = P_RandomRange(10, 35)
				end				
			end

			if timer >= 50 and timer <= 130
			and (timer%15) == 0
				local bs = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z + P_RandomRange(0, 175)*FRACUNIT, MT_DUMMY)
				bs.state = S_TRSPARKLE1
				bs.color = SKINCOLOR_MAGENTA
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				bs.scale = 15/4*FRACUNIT
				bs.destscale = 3/2*FRACUNIT
				localquake(mo.battlen, FRACUNIT*10, 10)
			end	
			
			if timer >= 50 and timer <= 130
			and (timer%7) == 0
				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_THOK
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_NEON
					thok.fuse = 65 - timer
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT/2
				end	
			end	
			
			if timer == 120
				playSound(mo.battlen, sfx_eih4)
			end	
			
			
			if timer == 131
				mo.buf_damage = 0
				for i = 1, #hittargets
					local hit = hittargets[i]
					damageObject(hit)
					if hit.damagestate ~= DMG_MISS		-- make sure we landed the attack
					and hit.damagestate ~= DMG_BLOCK
					and hit.damagestate ~= DMG_DRAIN
						mo.hpsucc = true
						mo.buf_damage = $+hit.damagetaken
					end
				end
			end	
			if timer == 140
			and mo.hpsucc
				playSound(mo.battlen, sfx_lsheal)
				damageObject(mo, -mo.buf_damage, DMG_NORMAL)
			end
			
			if timer == 150
				return true
			end
		end,
}


--"Heavy" Single


attackDefs["tr_energy_drain"] = {
		name = "Energy Drain",
		type = ATK_CURSE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BLACK))
		end,
		desc = "Orbal Art (Liberlian).\nHeavy Curse Damage to one enemy.\n100% HP Drain.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 24
				playSound(mo.battlen, sfx_endrn)
			end
			if timer == 25
			and target == mo
				return true
			end
			if timer == 10 and target ~= mo
				damageObject(target)
				if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					playSound(mo.battlen, sfx_bufu6)
					mo.hpsucc = true
					mo.buf_damage = target.damagetaken
				end
			end
			
			if timer == 35 and not mo.hpsucc
				mo.hpsucc = nil
				return true
			end
			if timer < 60 and mo.hpsucc
				local rx = target.x + P_RandomRange(-32,32)*FRACUNIT
				local ry = target.y + P_RandomRange(-32,32)*FRACUNIT
				local rz = target.z + P_RandomRange(0,32)*FRACUNIT
				local thok = P_SpawnMobj(rx,ry,rz,MT_THOK)
					thok.sprite = SPR_THOK
					thok.frame = A|FF_FULLBRIGHT
					thok.color = SKINCOLOR_CYAN
					thok.tics = 15
					thok.momx = (mo.x - thok.x)/15
					thok.momy = (mo.y - thok.y)/15
					thok.momz = ((mo.z + FRACUNIT*32) - thok.z)/15
			end
			if timer == 70
			and target ~= mo
				mo.atk_attacker = mo
				playSound(mo.battlen, sfx_lsheal)
				damageObject(mo, -mo.buf_damage, DMG_NORMAL)
			end
			if timer == 100
				mo.buf_damage = nil
				mo.hpsucc = nil
				return true
			end
		end,
	}


--"Heavy" Group


attackDefs["tr_abyss_fall"] = {
		name = "Abyss Fall",
		type = ATK_CURSE,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 27,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_SHOCK,
		statuschance = 10,
		tr_castarea = 5,
		desc = "Orbal Art (Liberlian)\nHeavy Curse Damage (Area L).\n10% Shock chance.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}
			local acolors = {SKINCOLOR_JET, SKINCOLOR_BLACK, SKINCOLOR_CARBON, SKINCOLOR_PURPLE, SKINCOLOR_NEON, SKINCOLOR_COBALT, SKINCOLOR_CRIMSON}
			
			local angle = mo.angle+ANGLE_180
			local x = mo.x + 384*cos(angle)
			local y = mo.y + 384*sin(angle)
			local target = P_SpawnMobj(x, y, mo.floorz+5, MT_DUMMY)			
			target.sprite = SPR_MUDO
			target.scale = FRACUNIT*6
			target.frame = A
			target.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
			target.colorized = true
			target.color = SKINCOLOR_NEON
			target.tics = 2
			
			if timer == 1
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
			end
					
			if timer == 10	--aim the camera at the snake portal and watch the fireworks
				playSound(mo.battlen, sfx_crest)
				local cam = server.P_BattleStatus[mo.battlen].cam
				angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
				cam.momx = 0
				cam.momy = 0
				cam.momz = 0
				P_TeleportMove(cam, target.x + 360 *cos(angle), target.y + 360*sin(angle), cam.floorz+80*FRACUNIT)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
			end			
			
			if timer >= 10 and timer <= 40
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_BLACK
					if timer%2 then thok.color = SKINCOLOR_PURPLE end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end		

			if timer == 20
				playSound(mo.battlen, sfx_helgat)
			end
			
			if timer >= 40 and timer <= 60
				if timer == 40
					playSound(mo.battlen, sfx_eih4)
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 5, 5)
						end
					end
				end
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 48
				for i = 0, 12
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_BUFUDYNE_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_NEON
					aura.momz = P_RandomRange(2, 12)*FRACUNIT
					aura.scale = FRACUNIT*4
					aura.destscale = FRACUNIT*2
					aura.frame = TR_TRANS70
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 11))
				end
				if (timer%3) == 0
					for i = 1, 8
						local fire = P_SpawnMobj(target.x + P_RandomRange(-90, 90)*FRACUNIT, target.y + P_RandomRange(-90, 90)*FRACUNIT, target.z + P_RandomRange(-130, 130)*FRACUNIT, MT_GHOST)
						fire.state = S_FLAMEPARTICLE
						fire.colorized = true
						fire.momz = FRACUNIT*1
						fire.scale = FRACUNIT*2
						fire.color = SKINCOLOR_NEON
						fire.tics = -1
						fire.fuse = 30
					end	
				end	
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*7
				summonAura(thok, rcol[P_RandomRange(1,#rcol)])
				thok.tics = 2
				localquake(mo.battlen, FRACUNIT*10, 20)
				if (timer%8) == 0
					local ol = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.z + P_RandomRange(0, 100)<<FRACBITS, MT_DUMMY)
					ol.sprite = SPR_MUDO
					ol.colorized = true
					ol.color = SKINCOLOR_PURPLE
					ol.scale = 1
					ol.destscale = FRACUNIT*7
					ol.scalespeed = FRACUNIT/5
					ol.frame = B
					ol.tics = 20

					ol = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.z + P_RandomRange(0, 100)<<FRACBITS, MT_DUMMY)
					ol.sprite = SPR_MUDO
					ol.colorized = true
					ol.color = SKINCOLOR_VIOLET
					ol.scale = 1
					ol.destscale = FRACUNIT*3
					ol.scalespeed = FRACUNIT
					ol.frame = B|TR_TRANS50
					ol.tics = 8
				end	
			end	

			if timer == 55
				playSound(mo.battlen, sfx_eih3)
				local renus = P_SpawnMobj(target.x, target.y, target.z - FRACUNIT*8, MT_DUMMY)
				renus.sprite = SPR_VIPR	
				renus.scale = FRACUNIT*5/2
				renus.frame = B|FF_FULLBRIGHT	
				renus.tics = 20
				renus.color = SKINCOLOR_NEON
				renus.colorized = true
				renus.renderflags = RF_NOCOLORMAPS
			end
			
			if timer >= 56 and timer <= 64
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_JET
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_PURPLE
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_DUSK
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
			end				
			
			if timer == 75
				local renus = P_SpawnMobj(target.x, target.y, target.z - FRACUNIT*8, MT_DUMMY)
				renus.sprite = SPR_VIPR	
				renus.scale = FRACUNIT*5/2
				renus.color = SKINCOLOR_NEON
				renus.colorized = true
				renus.frame = A|FF_FULLBRIGHT	
				renus.tics = 60
				renus.renderflags = RF_NOCOLORMAPS
			end

			if timer > 65 and timer < 70					
					for i = 1,20
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = rcol[P_RandomRange(1,#rcol)]
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 175
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/175
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				
				if leveltime%2 == 0
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = C|TR_TRANS10
					t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/6
				end

				if leveltime%3 == 0
					local caman = R_PointToAngle(target.x, target.y)

					local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = D|TR_TRANS10
					t.color = SKINCOLOR_PURPLE
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/4
				end
			end
			
			--Ok, now the snake has appeared, so let's launch a giant fucking energy ball into the air!
			
			if timer == 66
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
					
				mo.bod = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height/2, MT_DUMMY)
				mo.bod.state = S_JETFUME1
				mo.bod.colorized = true
				mo.bod.frame = FF_FULLBRIGHT
				mo.bod.color = SKINCOLOR_DUSK
				mo.bod.tics = -1
				mo.bod.fuse = 30
				mo.bod.scale = FRACUNIT*4
				mo.bod.blendmode = AST_ADD
				mo.bod.renderflags = $|RF_FULLBRIGHT

				mo.bod.momx = (avgx - mo.bod.x)/(30)
				mo.bod.momy = (avgy - mo.bod.y)/(30)
				mo.bod.momz = (mo.z - mo.bod.z)/(30)
				mo.bod.momz = $+(20*FRACUNIT)
				
				--We'll have another circle on the impact area
				mo.dbs = P_SpawnMobj(avgx, avgy, mo.floorz+(120*FRACUNIT), MT_DUMMY)			
				mo.dbs.sprite = SPR_MUDO
				mo.dbs.scale = FRACUNIT*6
				mo.dbs.frame = A
				mo.dbs.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
				mo.dbs.colorized = true
				mo.dbs.color = SKINCOLOR_NEON
				mo.dbs.tics = 90
				
			elseif timer > 76 and timer < 96
				mo.bod.momz = $-(2*FRACUNIT)
				if timer == 90
					playSound(mo.battlen, sfx_solblu)
					mo.bod.momx = 0
					mo.bod.momy = 0
				end
				for h = 1, #hittargets
					local hit = hittargets[h]
					local angle = h*(360*ANG1)/#hittargets
					P_TeleportMove(hit, mo.dbs.x + 120 *cos(angle), mo.dbs.y + 120 *sin(angle), mo.dbs.z)
				end
			end
			
			if mo.bod and mo.bod.valid
				if timer%2
					local g = P_SpawnGhostMobj(mo.bod)
					g.fuse = TICRATE/3
					g.scalespeed = FRACUNIT/2
					g.detscale = mo.bod.scale/2
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
				end
			end
			
			if timer == 76
				local cam = server.P_BattleStatus[mo.battlen].cam
				angle = R_PointToAngle2(mo.x, mo.y, mo.dbs.x, mo.dbs.y)+(60*ANG1)
				cam.momx = 0
				cam.momy = 0
				cam.momz = 0
				P_TeleportMove(cam, mo.dbs.x + 640 *cos(angle), mo.dbs.y + 640*sin(angle), mo.dbs.z+(160*FRACUNIT))
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.dbs.x, mo.dbs.y)
			end
			
			--THE GRAND FINALE
			if timer >= 100 and timer <= 200
				if timer == 100
					mo.dbs.state = S_INVISIBLE
				end
				for h = 1, #hittargets
					local hit = hittargets[h]
					local angle = h*(360*ANG1)/#hittargets
					local dist = 120-((timer-100)*2)
					P_TeleportMove(hit, mo.dbs.x + max(0, dist) *cos(angle), mo.dbs.y + max(0, dist) *sin(angle), mo.dbs.z+(dist*FRACUNIT))
					
					if timer == 200
						damageObject(hit)
					end
				end
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 512*timer/100
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = mo.dbs.x + dist*cos(angle), mo.dbs.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.dbs.z, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_NEON
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(2, 8)*FRACUNIT/6
					aura.spriteyscale = FRACUNIT*2
					aura.scale = FRACUNIT*6
					aura.destscale = FRACUNIT*24
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 8))
				end
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = mo.dbs.x + 32*cos(angle), mo.dbs.y + 32*sin(angle)
					local sink = 100*FRACUNIT*(timer-100)/100

					local aura = P_SpawnMobj(x, y, mo.dbs.z-sink, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = acolors[P_RandomRange(1, #acolors)]
					aura.frame = A|FF_FULLBRIGHT
					aura.renderflags = $|RF_FULLBRIGHT|RF_FLOORSPRITE|RF_SPLATMASK
					aura.momz = sink/5
					aura.scale = FRACUNIT*8
					aura.destscale = FRACUNIT*32
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(48, 192))
				end
			end
			
			
			if timer == 210
				return true
			end
		end,
	}

attackDefs["tr_death_scream"] = {
	name = "Death Scream",
	type = ATK_CURSE,
	power = 350,
	accuracy = 90,
	costtype = CST_SP,
	cost = 30,
		tr_orbal = true,	--custom aura effect & sounds
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
	end,
	desc = "Orbal Art (Liberlian)\nHeavy Curse Damage to all enemies.\nFlat 20% Deathblow chance.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
	
		local colors = {SKINCOLOR_PURPLE, SKINCOLOR_NEON, SKINCOLOR_VIOLET, SKINCOLOR_BLACK, SKINCOLOR_MAGENTA}
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			S_StartSound(nil,sfx_crest)
		end
		
		if timer >= 10 and timer <= 55
			localquake(mo.battlen, FRACUNIT*10, 10)
		end	
		
		if timer >= 10 and timer <= 55
		and (timer%7) == 0
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			m.sprite = SPR_NTHK
			m.color = colors[P_RandomRange(1, #colors)]
			m.scale = FRACUNIT*12
			m.flags2 = $|MF2_SPLAT
			m.flags = MF_NOBLOCKMAP
			m.renderflags = $|RF_NOCOLORMAPS
			m.frame = A|FF_TRANS70
	
		end	
		
		if timer >= 10
		and timer < 105
			local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
			thok.state = S_INVISIBLE
			thok.scale = FRACUNIT*6
			summonAura(thok, colors[P_RandomRange(1, #colors)])
			thok.tics = 2
		end	


		if timer >= 10 and timer <= 55
		and (timer%8) == 0
			local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			thok.sprite = SPR_ANSP
			thok.frame = B|TR_TRANS30
			thok.momz = 30*FRACUNIT 
			thok.color = SKINCOLOR_NEON
			thok.colorized = true
			thok.tics = 20
			thok.scale = FRACUNIT*10
		end
		
		
		if timer == 30
			S_StartSound(nil,sfx_helgat)
		end
		
		if timer > 55 and timer < 80
			local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}
			
			for i = 1,10
				local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)	
				if (i%2)
					thok.color = SKINCOLOR_JET
				else
					thok.color = SKINCOLOR_PURPLE
				end
					thok.frame = A|FF_FULLBRIGHT
				thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
				thok.tics = 105
				thok.scale = mo.scale/2
				thok.destscale = 1
				thok.scalespeed = (mo.scale/2)/105
				thok.momx = P_RandomRange(-15,15)*FRACUNIT
				thok.momy = P_RandomRange(-15,15)*FRACUNIT
				thok.momz = P_RandomRange(5,15)*FRACUNIT
			end	
				
			if leveltime%2 == 0
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.tics = -1
				t.frame = C|TR_TRANS10
				t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/6
			end

			if leveltime%3 == 0
				local caman = R_PointToAngle(avgx, avgy)
				local t = P_SpawnMobj(avgx + 2*cos(caman), avgy + 2*cos(caman), mo.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.tics = -1
				t.frame = D|TR_TRANS10
				t.color = SKINCOLOR_PURPLE
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/4
			end
			
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
			m.fuse = 2
			m.sprite = SPR_ENM1
			m.tics = 2
			m.frame = D|FF_FULLBRIGHT
			m.blendmode = AST_ADD
			m.renderflags = $|RF_FULLBRIGHT
			m.color = SKINCOLOR_MAGENTA
			m.colorized = true
			m.scale = FRACUNIT*(timer-65)
			m.angle = R_PointToAngle2(m.x, m.y, mo.x, mo.y)
		end


		if timer == 60
			for i = 1,#hittargets
				local target = hittargets[i]
				damageObject(target)
				tr_deathblow(target, 20)
			end	
		end	
		
		if timer == 100
			return true
		end
	end,
}


--"Severe" Single



--"Severe" Group


attackDefs["tr_calamitous_blast"] = {
	name = "Calamitous Blast",
	type = ATK_CURSE,
	power = 720,
	accuracy = 90,
	costtype = CST_SP,
	cost = 80,
		tr_orbal = true,	--custom aura effect & sounds
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	desc = "Orbal Art (Liberlian)\nSevere Curse damage to all enemies. \nReduces defense by one stage.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			playSound(mo.battlen, sfx_trcbls)
			local firebol = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
			firebol.scale = 1 
			firebol.tics = 160
			firebol.destscale = FRACUNIT*3 
			firebol.sprite = SPR_THOK
			firebol.color = SKINCOLOR_MAGENTA
			firebol.frame = A|FF_TRANS20
			firebol.scalespeed = (FRACUNIT*6)/80
		end
		
		if timer >= 90 and timer <= 200	--weirdly had three of these same timer checks...
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.color = SKINCOLOR_FLAME
			orb.destscale = FRACUNIT*7
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
			localquake(mo.battlen, FRACUNIT*10, 10)
			
			if leveltime%8 == 0
				playSound(mo.battlen, sfx_zio2)
			end	
			
			local range = 1024
			local z2 = P_SpawnMobj(avgx + P_RandomRange(-range, range)*mo.scale, avgy + P_RandomRange(-range, range)*mo.scale, mo.z, MT_DUMMY)
			z2.state, z2.scale, z2.color = S_NZIO21, FRACUNIT*4, SKINCOLOR_FLAME
			z2.destscale = FRACUNIT*1
		end	
		
		if timer == 201
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				darkzio(target, SKINCOLOR_FLAME, FRACUNIT*3/2)
				damageObject(target)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN 
					buffStat(target, "def", -25)
				end		
			end	
		end	
		
		if timer == 220
			return true
		end
	end,


}


--Support



attackDefs["tr_antisept"] = {
		name = "Anti-Sept",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 60,
		statuschance = 60,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		desc = "Orbal Art (Liberlian).\nHigh chance of inflicting Silence \non one enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISEPTART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70
					return true
				end
		end,
}

//The screams of Zoruxa and Hajime have ceased...

attackDefs["tr_antiseptall"] = { 
		name = "Anti-Sept All",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 50,
		statuschance = 50,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		desc = "Orbal Art (Liberlian).\nHigh chance of inflicting Silence \n(Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				if not mo.tr_lockskill
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT
				else
					avgx = mo.tr_cursorPos[1]
					avgy = mo.tr_cursorPos[2]
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(avgx, avgy, mo.z + mo.height + 80*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISEPTART1
                    thok.momz = -6*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = mo.scale*3
					thok.scalespeed = (mo.scale*3)/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(avgx, avgy, mo.z + mo.height + 80*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*3
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(avgx, avgy, mo.z + mo.height + 80*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*3
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*3)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					if #hittargets > 0	--In case we select nothing
						for i = 1, #hittargets
							damageObject(hittargets[i])	--this should just hit everything highlighted
						end
					end
				elseif timer == 70 + (#hittargets-1)*6
					return true
				end
			end,
}

attackDefs["tr_orbal_down"] = {
		name = "Orbal Down",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 30,
		tr_orbal = true,	--custom aura effect & sounds
		statuschance = 50,
		status = COND_SILENCE,
		accuracy = 50,
		luckbased = true,	-- use luck instead of agility
		desc = "Orbal Art (Liberlian).\nLowers defence to all enemies\nby 1 stage, High Silence chance.",
		target = TGT_ALLENEMIES,
		debuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BLACK))
		end,
		hudfunc = function(v, mo, timer)
					if timer >= 90 and timer < 155
						v.fadeScreen(149, min(5,(timer - 70)/2))
					elseif timer >= 155 and timer < 170
						v.fadeScreen(149, max(0,5 - max(0,((timer - 150)/6))))
					end
				end,			
		anim = function(mo, targets, hittargets, timer)

				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
				
				if timer == 10
					local orbal = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*100, MT_DUMMY)			
					orbal.state = S_ORBALEVOKER3
					orbal.scale = FRACUNIT*1
					orbal.destscale = FRACUNIT*2
					orbal.scalespeed = FRACUNIT/5
				end	
						
				
				if timer == 10
					playSound(mo.battlen, sfx_orbald)
				end

				if timer >= 15
				and timer <= 89
					local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*200, MT_DUMMY)
					s.scale = FRACUNIT/4
					s.sprite = SPR_SLAS
					s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
					s.destscale = FRACUNIT*9
					s.scalespeed = FRACUNIT
					s.tics = TICRATE/3
					s.color = SKINCOLOR_SLATE
					localquake(mo.battlen, FRACUNIT*5, 10)	
				end
				
				if timer == 90
					playSound(mo.battlen, sfx_orbal2)
					playSound(mo.battlen, sfx_debuff)
					for k,v in ipairs(hittargets)
						damageObject(v)
						buffStat(v, "def", -25)
					end
				end

				if timer == 91
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 5, 5)
						end
					end	
				end	
				
				if timer >= 90 and timer <= 150
				and (timer%5) == 0
					local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_DUMMY)
					bs.state, bs.color = S_THOK, SKINCOLOR_SLATE
					bs.momz = P_RandomRange(3, 10)*FRACUNIT
					bs.tics = P_RandomRange(10, 35)
				end	
				
				if timer >= 90
				and timer <= 150
					local b = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*200, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_BLUE
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT*2
					b.destscale = 1
					b.scalespeed = FRACUNIT/4
					b.tics = TICRATE/4
					localquake(mo.battlen, FRACUNIT*15, 10)		
				end

				if timer == 165
					return true
				end
		end,
	}





attackDefs["tr_clock_up"] = {
	name = "Clock Up",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nRaises crit rate for one ally \nby one stage",
	target = TGT_ALLY,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["crit"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local targ = hittargets[1]
		local clockupcolors = {SKINCOLOR_ORANGE, SKINCOLOR_SUNSET, SKINCOLOR_PEACHY}
		
		if timer == 1
			playSound(mo.battlen, sfx_clokup)
		end
		
		
		if timer == 1
			mo.circleMobjs = {}
			mo.smallHand = {}
			mo.longHand = {}
		end

		if timer == 100
			local thok = P_SpawnMobj(targ.x, targ.y, targ.z, MT_THOK)
			thok.destscale = 5*FRACUNIT
			thok.color = SKINCOLOR_PEACHY
			thok.tics = 35
			thok.fuse = 50
		end

		if timer >= 155
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then P_RemoveMobj(v) end
			end
			
			mo.circleMobjs = nil
			mo.smallHand = nil
			mo.longHand = nil
			return true
		end
		
		if timer == 2
			for i = -18, 18
				local x = FixedMul(100*cos(targ.angle+ANGLE_90), cos(i*ANG10))
				local y = FixedMul(100*sin(targ.angle+ANGLE_90), cos(i*ANG10))
				local z = (50*FRACUNIT) + (100*sin(i*ANG10))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/2
				thok.color = SKINCOLOR_APRICOT

				table.insert(mo.circleMobjs, thok)
			end

			for i = 1, 10
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/3
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.longHand, thok)
			end

			for i = 1, 6
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/4
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.smallHand, thok)
			end
		end

		local trans = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60, FF_TRANS50, FF_TRANS40, FF_TRANS30, FF_TRANS20, FF_TRANS10}
		if timer >= 3 and timer <= 12
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end
		end

		if timer >= 141 and timer <= 150
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end
		end

		if timer >= 30
			if not (timer%10)
				local ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end

			if timer <= 40
				if not (timer%20) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2
		
						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 50
				if not (timer%15) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+(ANG2*3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+ANG1

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 60
				if not (timer%10) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG10

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG2*2)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 70
				if not (timer%7) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG20

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG2*4)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 170
				if not (timer%5) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANGLE_45

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+ANG10

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			end	
			if timer == 100
				playSound(mo.battlen, sfx_buff)
				buffStat(targ, "crit")
			end
		end
	end,
}

attackDefs["tr_clock_up_ex"] = {
	name = "Clock Up EX",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nRaises crit rate for one ally \nby two stages.",
	target = TGT_ALLY,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			playSound(mo.battlen, sfx_clokup)
		end
		
		if timer == 20
			local m = P_SpawnMobj(target.x, target.y, target.z+120*FRACUNIT, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT/2
			--m.flags2 = $|MF2_SPLAT
			m.color = SKINCOLOR_GOLD
		end	
		if timer >= 20 and timer < 79
			summonAura(target, SKINCOLOR_GOLD)
		end		
			
		if timer >= 10 and timer <= 60
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 20
			for i = 0, 12
				local angle = baseangle + i*6*ANG1
				local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_GOLD
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(2, 3)*FRACUNIT
				aura.scale = FRACUNIT*2/4
				aura.destscale = FRACUNIT*1
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
			end	
		end	
				
		for i = 1,#targets
			local target = hittargets[i]			
			if timer == 60 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_GOLD
					dust.scale = FRACUNIT*2
				end
	
			
			elseif timer == 61 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "crit", BUFFSTEP*2)
			end	
		end	
		
		if timer == 75 + #targets*4
			return true
		end
	end,
}


attackDefs["tr_chrono_drive"] = {
	name = "Chrono Drive",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 18,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 3,
	desc = "Orbal Art (Arcus series).\nRaises crit rate and agility \nby one stage (Area M).",
	target = TGT_ALLALLIES,
	buff = true,	-- is a buff
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_chrdrv)
			playSound(mo.battlen, sfx_chrdrv)
		end
		
		if timer == 60
			playSound(mo.battlen, sfx_buff)
		end	
		
		if timer == 20
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT*3
			m.flags2 = $|MF2_SPLAT
			m.color = SKINCOLOR_AZURE
		end	
		if timer >= 20 and timer < 79
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_AZURE)
			end	
		end		
			
		for i = 1,#targets
			local target = hittargets[i]			
			if timer == 60 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_AZURE
					dust.scale = FRACUNIT*2
				end
	
			
			elseif timer == 61 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "crit")
				buffStat(target, "agi")
			end	
		end	
		
		if timer == 75 + #targets*4
			return true
		end
	end,
}

attackDefs["tr_chrono_down"] = {
	name = "Chrono Down",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 9,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 3,
	desc = "Orbal Art (Enigma series).\nLowers crit rate by one stage \n(Area M).",
	target = TGT_ALLENEMIES,
	debuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_chrdwn)
			playSound(mo.battlen, sfx_chrdwn)
		end
		
		if timer == 106
			playSound(mo.battlen, sfx_debuff)
		end	
		
		if timer == 20
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT*3
			m.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
			m.color = SKINCOLOR_PURPLE
		end	
		if timer >= 20 and timer < 75
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_DUSK)
			end	
		end
		
		if timer >= 50 and timer <= 100
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 8
					local spread = (timer-30)
					local x = P_RandomRange(-spread, spread)*FRACUNIT +e.x
					local y = P_RandomRange(-spread, spread)*FRACUNIT +e.y
					local z = P_RandomRange(-spread, spread)*FRACUNIT +e.z + e.height/2

					local t = P_SpawnMobj(x, y, z, MT_THOK)
					t.fuse = t.tics
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.frame = A
					t.scale = FRACUNIT/4 + (spread*FRACUNIT/32)
					t.momz = -FRACUNIT/12
				end
			end
		end	

		if timer == 105
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 64
					local t = P_SpawnMobj(e.x, e.y, e.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.scale = FRACUNIT*3/2
				end	
			end
		end	
				
			
		if timer == 106
			for i = 1,#hittargets
				local target = hittargets[i]
				buffStat(target, "crit", -25)
			end
		elseif timer == 120 + #targets*16
			return true
		end
	end,
}

attackDefs["tr_chrono_break"] = {
	name = "Chrono Break",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 18,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 3,
	desc = "Orbal Art (Arcus series).\nLowers crit rate and agility \nby one stage (Area M).",
	target = TGT_ALLENEMIES,
	debuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_chrdwn)
			playSound(mo.battlen, sfx_chrdwn)
		end
		
		if timer == 106
			playSound(mo.battlen, sfx_debuff)
		end	
		
		if timer == 20
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT*3
			m.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
			m.color = SKINCOLOR_PURPLE
		end	
		if timer >= 20 and timer < 75
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_DUSK)
			end	
		end
		
		if timer >= 50 and timer <= 100
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 8
					local spread = (timer-30)
					local x = P_RandomRange(-spread, spread)*FRACUNIT +e.x
					local y = P_RandomRange(-spread, spread)*FRACUNIT +e.y
					local z = P_RandomRange(-spread, spread)*FRACUNIT +e.z + e.height/2

					local t = P_SpawnMobj(x, y, z, MT_THOK)
					t.fuse = t.tics
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.frame = A
					t.scale = FRACUNIT/4 + (spread*FRACUNIT/32)
					t.momz = -FRACUNIT/12
				end
			end
		end	

		if timer == 105
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 64
					local t = P_SpawnMobj(e.x, e.y, e.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.scale = FRACUNIT*3/2
				end	
			end
		end	
				
			
		if timer == 106
			for i = 1,#hittargets
				local target = hittargets[i]
				buffStat(target, "crit", -25)
				buffStat(target, "agi", -25)
			end
		elseif timer == 120 + #targets*16
			return true
		end
	end,
}

attackDefs["tr_clock_down"] = {
	name = "Clock Down",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 18,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 3,
	desc = "Orbal Art (Liberlian).\nLowers enemy crit rate \nby two stages (Area M).",
	target = TGT_ALLENEMIES,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local avgx = 0
		local avgy = 0
		for i = 1, #hittargets do
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = $ / #hittargets *FRACUNIT
		avgy = $ / #hittargets *FRACUNIT
		local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
		target.state = S_INVISIBLE
		target.fuse = 2

		
		if timer == 1
			playSound(mo.battlen, sfx_clokdw)
		end
		
		if timer == 20
			local m = P_SpawnMobj(target.x, target.y, target.z+180*FRACUNIT, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT
			--m.flags2 = $|MF2_SPLAT
			m.color = SKINCOLOR_MAGENTA
		end	
		if timer >= 20 and timer < 79
			summonAura(target, SKINCOLOR_MAGENTA)
		end		
			
		if timer >= 10 and timer <= 60
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 200
			for i = 0, 12
				local angle = baseangle + i*6*ANG1
				local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, target.z+(FRACUNIT*180)-(i*FRACUNIT*2), MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_MAGENTA
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(-20, -40)*FRACUNIT
				aura.scale = FRACUNIT*2/3
				aura.destscale = FRACUNIT*1
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(10, 10))
			end	
		end	
				
		for i = 1,#targets
			local t = hittargets[i]			
			if timer == 60 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(t.x, t.y, t.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_MAGENTA
					dust.scale = FRACUNIT*2
				end
	
			
			elseif timer == 61 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(t, "crit", -BUFFSTEP*2)
			end	
		end	
		
		if timer == 75 + #targets*4
			return true
		end
	end,
}






/*
attackDefs["tr_clock_down"] = {	--preserved
		name = "Clock Down",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers crit rate to one enemy \nby one stage",
		target = TGT_ENEMY,
		debuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BLACK))
		end,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["agi"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
	anim = function(mo, targets, hittargets, timer)
		local targ = hittargets[1]
		local clockupcolors = {SKINCOLOR_AETHER, SKINCOLOR_SLATE, SKINCOLOR_BLUEBELL}
		
		if timer == 1
			playSound(mo.battlen, sfx_clokdw)
		end
		
		
		if timer == 1
			mo.circleMobjs = {}
			mo.smallHand = {}
			mo.longHand = {}
		end

		if timer == 100
			local thok = P_SpawnMobj(targ.x, targ.y, targ.z, MT_THOK)
			thok.destscale = 5*FRACUNIT
			thok.color = SKINCOLOR_BLUEBELL
			thok.tics = 35
			thok.fuse = 50
		end

		if timer >= 155
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then P_RemoveMobj(v) end
			end
			
			mo.circleMobjs = nil
			mo.smallHand = nil
			mo.longHand = nil
			return true
		end
		
		if timer == 2
			for i = -18, 18
				local x = FixedMul(100*cos(targ.angle+ANGLE_90), cos(i*ANG10))
				local y = FixedMul(100*sin(targ.angle+ANGLE_90), cos(i*ANG10))
				local z = (50*FRACUNIT) + (100*sin(i*ANG10))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/2
				thok.color = SKINCOLOR_BLUEBELL

				table.insert(mo.circleMobjs, thok)
			end

			for i = 1, 10
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/3
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.longHand, thok)
			end

			for i = 1, 6
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/4
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.smallHand, thok)
			end
		end

		local trans = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60, FF_TRANS50, FF_TRANS40, FF_TRANS30, FF_TRANS20, FF_TRANS10}
		if timer >= 3 and timer <= 12
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end
		end

		if timer >= 141 and timer <= 150
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end
		end

		if timer >= 30
			if not (timer%10)
				local ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end

			if timer <= 40
				if not (timer%20) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2
		
						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 50
				if not (timer%15) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 60
				if not (timer%10) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 70
				if not (timer%7) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 170
				if not (timer%5) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			end	
			if timer == 100
				playSound(mo.battlen, sfx_debuff)
				buffStat(targ, "crit", -25)
			end
		end
	end,
}
*/



-- Death Blow effect

if not tr_deathblow

	rawset(_G, "tr_deathblow", function(target, acc)
		if P_RandomRange(1, 100) < acc	--flat Deathblow Chance
		and target.damagestate ~= DMG_MISS		-- make sure we landed the attack
		and target.damagestate ~= DMG_BLOCK
		and target.damagestate ~= DMG_DRAIN
			if target.hp
			and server.gamemode ~= GM_PVP
			and not target.boss
			and not target.tetraja
				damageObject(target, target.hp*9, DMG_NORMAL) --death
				resetDamage(target)
			end
			playSound(target.battlen, sfx_eih3)
				
			local sb = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+(40*FRACUNIT), MT_DUMMY)
			sb.state = S_SSPK1
			sb.colorized = true
			sb.color = SKINCOLOR_WHITE
			sb.frame = FF_FULLBRIGHT
			sb.blendmode = AST_ADD
			sb.renderflags = $|RF_FULLBRIGHT
			sb.scale = FRACUNIT*3
			sb.momx = P_RandomRange(-12, 12)*FRACUNIT
			sb.momy = P_RandomRange(-12, 12)*FRACUNIT
			sb.momz = P_RandomRange(0, 96)*FRACUNIT
			sb.tics = 30
		end
	end)		

end


