if not Trails_AreaLines
	rawset(_G, "Trails_AreaLines", true)
	
	------{Custom Utility Functions}------
	
	local function tr_highlight(mo, attacker)
		local dummy = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
		dummy.fuse = 2
		dummy.blendmode = AST_ADD
		--dummy.renderflags = $|RF_FULLBRIGHT

		if mo.skin
			dummy.skin = mo.skin
		end
		dummy.state = mo.state
		dummy.sprite = mo.sprite
		dummy.sprite2 = mo.sprite2

		dummy.angle = mo.angle
		dummy.frame = FF_FULLBRIGHT|mo.frame
		dummy.scale = mo.scale
		dummy.spritexoffset = mo.spritexoffset
		dummy.spriteyoffset = mo.spriteyoffset
		dummy.spritexscale = mo.spritexscale
		dummy.spriteyscale = mo.spriteyscale
		dummy.flags2 = mo.flags2
		dummy.color = SKINCOLOR_RED
		if attacker.attack.target == TGT_ALLY
		or attacker.attack.target == TGT_ALLALLIES
		or attacker.attack.target == TGT_CASTER
			dummy.color = SKINCOLOR_BLUE
		end
		dummy.colorized = true
	end
	
	
	
	local function tr_findcursor(mo)
		if not mo.tr_csetpos return end	--Just in case...
		
		local dist = mo.tr_csetpos[1]
		local angle = mo.tr_csetpos[2]
		
		local rayx = mo.x + dist*cos(angle)
		local rayy = mo.y + dist*sin(angle)
		
		local cursor = P_SpawnMobj(rayx, rayy, mo.floorz+(80*FRACUNIT)+(40*sin((200 + leveltime)*ANG1*8)), MT_DUMMY)
		cursor.state = S_LOCKON1
		cursor.fuse = 2
		cursor.spritexscale = FRACUNIT/2
		cursor.scale = FRACUNIT*3
		cursor.color = mo.color
		cursor.colorized = true
		mo.tr_cursorPos = {rayx, rayy}
	end
	
	
	
	local function tr_areaDisplay(mo)	--particle displays for the different targetting modes
		local atarget = mo.targets[mo.t_target]
		if not (atarget and atarget.valid) return end
		local radius = 60*FRACUNIT*mo.attack.tr_castarea
		
		mo.tr_drawtargets = {}
		
		if mo.attack.tr_setmode and mo.attack.tr_setmode == 2
			--radius = 40*FRACUNIT*mo.attack.tr_castarea	--reduce search radius since we're aiming in a line.
			
			local angle
			if mo.tr_lockskill and mo.tr_cursorPos	--Set Position Mode override
				angle = R_PointToAngle2(mo.x, mo.y, mo.tr_cursorPos[1] ,mo.tr_cursorPos[2])
			else
				angle = R_PointToAngle2(mo.x, mo.y, atarget.x, atarget.y)
			end
			
			local dist = (R_PointToDist2(mo.x,mo.y,atarget.x,atarget.y)/FRACUNIT)*2
			local rayx = mo.x + 12*cos(angle + ANGLE_45)
			local rayy = mo.y + 12*sin(angle + ANGLE_45)
			
			for	 ray = 1, (dist/12)
				local rx = rayx + (ray*12)*cos(angle)
				local ry = rayy + (ray*12)*sin(angle)
				for i = 1, #mo.targets
					local target = mo.targets[i]
					local dist2 = R_PointToDist2(target.x,target.y,rx,ry)
					if dist2 <= radius and not target.tr_scanned	--no duplicates, thanks!
						tr_highlight(target, mo)
						if not (leveltime%40)
							dprint("Found "..target.name.." at "..dist.." ("..(dist/FRACUNIT).." FU), "..mo.attack.name.." Area: "..radius.." ("..(radius/FRACUNIT).." FU) from Line.")
						end
						target.tr_scanned = true
						mo.tr_drawtargets[#mo.tr_drawtargets+1] = target
					end
				end
			end
			for i = 1, #mo.targets
				local target = mo.targets[i]
				target.tr_scanned = nil
			end
			
			for ray = 1, 2
				local angle2 = angle+ANGLE_90
				if ray == 2 then angle2 = angle-ANGLE_90 end
				
				local dist2 = 80*mo.attack.tr_castarea
				local rayx, rayy = 0
				
				if ray == 2
					local rayx2 = mo.x + dist2*cos(angle2 + ANGLE_45)
					local rayy2 = mo.y + dist2*sin(angle2 + ANGLE_45)
					
					rayx = rayx2 + 24*cos(angle + ANGLE_45)
					rayy = rayy2 + 24*sin(angle + ANGLE_45)
					else
					local rayx2 = mo.x + dist2*cos(angle2 - ANGLE_45)
					local rayy2 = mo.y + dist2*sin(angle2 - ANGLE_45)
					
					rayx = rayx2 + 24*cos(angle + ANGLE_45)
					rayy = rayy2 + 24*sin(angle + ANGLE_45)
				end
				
				for i = 0, 9
				
					local rx = rayx + (((leveltime%35)+i)*24)*cos(angle)
					local ry = rayy + (((leveltime%35)+i)*24)*sin(angle)
					
					local aura = P_SpawnMobj(rx, ry, atarget.floorz, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle
					--if ray == 2 then aura.angle = angle+ANGLE_90 end
					aura.color = SKINCOLOR_ORANGE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.spritexscale = FRACUNIT/5
					aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
					aura.scale = FRACUNIT*mo.attack.tr_castarea
					aura.destscale = FRACUNIT*mo.attack.tr_castarea*4
					P_InstaThrust(aura, angle, FRACUNIT/2)
				end
			end
		else
			if mo.tr_lockskill and not (mo.attack.tr_setmode and mo.attack.tr_setmode == 1)
				mo.tr_lockskill = nil
			end
			for i = 1, #mo.targets
				local target = mo.targets[i]
				local dist = R_PointToDist2(target.x,target.y,atarget.x,atarget.y)
				if mo.tr_lockskill and mo.tr_cursorPos	--Set Position Mode override
					dist = R_PointToDist2(target.x,target.y,mo.tr_cursorPos[1],mo.tr_cursorPos[2])
				end
				if dist <= radius
					tr_highlight(target, mo)
					mo.tr_drawtargets[#mo.tr_drawtargets+1] = target
				end
				if not (leveltime%40)
					dprint(target.name.." Distance: "..dist.." ("..(dist/FRACUNIT).." FU), "..mo.attack.name.." Area: "..radius.." ("..(radius/FRACUNIT).." FU).")
				end
			end
			
			local dist = 60*mo.attack.tr_castarea
			local angle = (leveltime%24)*15*ANG1
			local x, y = atarget.x + dist*cos(angle), atarget.y + dist*sin(angle)
			
			if mo.tr_lockskill and mo.tr_cursorPos	--Set Position Mode override
				x = mo.tr_cursorPos[1] + dist*cos(angle)
				y = mo.tr_cursorPos[2] + dist*sin(angle)
			end
			
			local aura = P_SpawnMobj(x, y, atarget.floorz, MT_DUMMY)
			aura.state = S_AURA1
			--if not aura or not aura.valid continue end
			aura.angle = angle - ANGLE_90
			aura.color = SKINCOLOR_ORANGE
			aura.frame = FF_FULLBRIGHT
			aura.blendmode = AST_ADD
			aura.renderflags = $|RF_FULLBRIGHT
			aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
			aura.scale = FRACUNIT*mo.attack.tr_castarea/2
			aura.destscale = FRACUNIT*mo.attack.tr_castarea*2
			P_InstaThrust(aura, angle, FRACUNIT/2)
		end
	end
	
	
	
	local function tr_areaTargets(mo, targets)	--Enemy finder for the different targetting modes
		local atarget = targets[mo.t_target]
		local radius = 60*FRACUNIT*mo.attack.tr_castarea
		
		local struck = {}
		
		if mo.attack.tr_setmode and mo.attack.tr_setmode == 2
			--radius = 40*FRACUNIT*mo.attack.tr_castarea	--reduce search radius since we're aiming in a line.
			
			local angle
			if mo.tr_lockskill and mo.tr_cursorPos	--Set Position Mode override
				angle = R_PointToAngle2(mo.x, mo.y, mo.tr_cursorPos[1] ,mo.tr_cursorPos[2])
			else
				angle = R_PointToAngle2(mo.x, mo.y, atarget.x, atarget.y)
			end
			
			local dist = (R_PointToDist2(mo.x,mo.y,atarget.x,atarget.y)/FRACUNIT)*2
			local rayx = mo.x + 12*cos(angle + ANGLE_45)
			local rayy = mo.y + 12*sin(angle + ANGLE_45)
			
			for	 ray = 1, (dist/12)
				local rx = rayx + (ray*12)*cos(angle)
				local ry = rayy + (ray*12)*sin(angle)
				for i = 1, #targets
					local target = targets[i]
					local dist2 = R_PointToDist2(target.x,target.y,rx,ry)
					if dist2 <= radius and not target.tr_scanned	--no duplicates, thanks!
						if not (leveltime%40)
							dprint("Found "..target.name.." at "..dist.." ("..(dist/FRACUNIT).." FU), "..mo.attack.name.." Area: "..radius.." ("..(radius/FRACUNIT).." FU) from Line.")
						end
						target.tr_scanned = true
						struck[#struck+1] = target
					end
				end
			end
			for i = 1, #struck
				local target = struck[i]
				target.tr_scanned = nil
			end
		else
			if mo.tr_lockskill and not (mo.attack.tr_setmode and mo.attack.tr_setmode == 1)
				mo.tr_lockskill = nil
			end
			for i = 1, #targets
				local target = targets[i]
				local dist = R_PointToDist2(target.x,target.y,atarget.x,atarget.y)
				if mo.tr_lockskill and mo.tr_cursorPos	--Set Position Mode override
					dist = R_PointToDist2(target.x,target.y,mo.tr_cursorPos[1],mo.tr_cursorPos[2])
				end
				if dist <= radius
					struck[#struck+1] = target
				end
				if not (leveltime%40)
					dprint(target.name.." Distance: "..dist.." ("..(dist/FRACUNIT).." FU), "..mo.attack.name.." Area: "..radius.." ("..(radius/FRACUNIT).." FU).")
				end
			end
		end
		return struck
	end
	
	
	
	
	------{Vanilla Function Overrides}------
	
	
	
	
	
	local function tr_drawtargets(v, p, c, mo)
		
		local ret_anim = {4, 3, 2, 1}

		if not mo.t_target return end
		if not mo.tr_drawtargets return end
		
		local btl = server.P_BattleStatus[mo.battlen]

		PDraw(v, 320 + mo.t_ctarget*24, 0, v.cachePatch("H_BOX_I"), V_SNAPTOTOP|V_SNAPTORIGHT|V_30TRANS)



		if not (mo.tr_drawtargets and #mo.tr_drawtargets) return end
		for i = 1, #mo.tr_drawtargets
			local tgt = mo.tr_drawtargets[i]
			if not tgt or not tgt.valid return end
			local x,y = R_GetScreenCoords(v, p, c, tgt.x, tgt.y, tgt.z + tgt.target_zoffs*tgt.scale)

			local aff = getAttackAff(tgt, mo.attack, mo)

			if mo.t_ctarget <= 8
				PDraw(v, x>>FRACBITS, y>>FRACBITS, v.cachePatch(mo.t_ctarget and "TGT_"..ret_anim[max(1, mo.t_ctarget/2)] or "TGT_"..5+(leveltime%20/10)))
				-- block / repel warning

				local atktype = 0
				if mo.attack
					atktype = getAttackType(mo, mo.attack)
				end

				-- target is weak to attack we've used before?
				if tgt.enemy and btl.saved_affs[tgt.enemy][1] & atktype
					if (mo.attack and (aff == DMG_BLOCK or aff == DMG_DRAIN))
						PDraw(v, x>>FRACBITS, y>>FRACBITS, v.cachePatch("TGT_NO"))
					elseif (mo.attack and aff == DMG_REPEL)
						PDraw(v, x>>FRACBITS, y>>FRACBITS, v.cachePatch("TGT_NOR"))
					end
				end
			end

			-- draw bar
			drawTargetHP(v, x, y, mo, tgt, aff)
			
			if tgt == mo.enemies[mo.t_target] or tgt == mo.allies[mo.t_target] or #mo.tr_drawtargets == 1
				
				V_drawString(v, 310 + mo.t_ctarget*24, 5, tgt.name, "NFNT", V_SNAPTORIGHT|V_SNAPTOTOP, "right", 0, 31)
				V_drawString(v, 240 + mo.t_ctarget*24, 5, "\nLV"..tgt.level, "NFNT", V_SNAPTORIGHT|V_SNAPTOTOP, nil, 0, 31)

				-- draw buffs and debuffs
				local stats = {"atk", "mag", "def", "agi", "crit"}
				local drawx = 310 + mo.t_ctarget*24
				for i = 1, #stats do
					local s = stats[i]

					if tgt.buffs[s] and tgt.buffs[s][1]
						-- draw the arrow pointing up or down.
						local pp = tgt.buffs[s][1] < 0 and "H_STATDW" or "H_STATUP"
						local patch = v.cachePatch(pp)

						V_drawString(v, drawx, 25, s:upper(), "NFNT", V_SNAPTORIGHT|V_SNAPTOTOP, "right", 0, 31)

						for i = 1, abs(tgt.buffs[s][1]/BUFFSTEP)
							v.drawIndex((drawx-3 - (i-1)*5)*FRACUNIT, 30*FRACUNIT, FRACUNIT/2, patch, V_SNAPTORIGHT|V_SNAPTOTOP, 31)
							PDraw(v, drawx-4 - (i-1)*5, 29, patch, V_SNAPTORIGHT|V_SNAPTOTOP)
						end

						-- draw for how long this is in effect:
						--V_drawString(v, drawx-12, 40, "("..(tgt.buffs[s][1]/25)..")", "NFNT", V_SNAPTORIGHT|V_SNAPTOTOP, "center", 0, 31)

						drawx = $- 28
					end
				end
			end
		end
	end
	
	
	
	
	local function tr_targetselect(mo)	--target selection override
		if not mo.targets return end
		local maxt = #mo.targets

		if mo.t_ctarget then mo.t_ctarget = $-1 end	-- used for animation handler
		if not mo.t_cmem
			mo.t_cmem = {1, 1}	-- cursor mem for enemy, ally
		end
		
		
		local inputs = mo.control.mo.P_inputs

		if mo.attack.tr_range and mo.attack.tr_range > 0	--range limiter
			mo.tr_range = mo.attack.tr_range*(30+mo.agility)*2
		else
			mo.tr_range = 900
		end
		
		if not mo.tr_csetpos --reset cursor position if we change targets
			if not mo.t_target or mo.t_target > #mo.targets
				mo.t_target = 1
			end
			local target = mo.targets[mo.t_target]	--we're going to start the cursor on the last enemy you had selected.
			local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local dist = R_PointToDist2(mo.x, mo.y, target.x, target.y)/FRACUNIT
			if dist > mo.tr_range then dist = mo.tr_range end
			mo.tr_csetpos = {dist, angle}	--Distance, Angle-offset
		end
		if mo.tr_lockskill	--We've temporarily disabled skill selection to allow 2D positioning
			if mo.tr_lockskill == 1
				if inputs["left"]
					mo.tr_csetpos[2] = $+ANG1
				elseif inputs["right"]
					mo.tr_csetpos[2] = $-ANG1
				end
				if inputs[BT_CUSTOM1]==1
					mo.tr_lockskill = 2
					playSound(mo.battlen, sfx_confir, mo)
					BTL_logMessage(mo.battlen, "Move Away with Left, Move Closer with Right")
				end
			else
				if inputs["left"]
					mo.tr_csetpos[1] = $+10
					if mo.tr_csetpos[1] > mo.tr_range then mo.tr_csetpos[1] = mo.tr_range end
				elseif inputs["right"]
					mo.tr_csetpos[1] = $-10
					if mo.tr_csetpos[1] < 60 then mo.tr_csetpos[1] = 60 end
				end
				if inputs[BT_CUSTOM1]==1 or mo.attack.tr_setmode == 2
					mo.tr_lockskill = nil
					playSound(mo.battlen, sfx_cancel, mo)
					BTL_logMessage(mo.battlen, "Canceled positioning mode.")
				end
			end
			tr_findcursor(mo)
		else
			tr_findcursor(mo)
			if inputs["left"] == 1
				mo.t_target = $-1
				if not mo.t_target
					mo.t_target = maxt
				end
				mo.t_ctarget = 12
				playSound(mo.battlen, sfx_hover, mo)
				mo.tr_csetpos = nil	--we moved the cursor while out of Set mode, so we have to reset it's position to the new target.
			elseif inputs["right"] == 1
				mo.t_target = $+1
				if mo.t_target > maxt
					mo.t_target = 1
				end
				mo.t_ctarget = 12
				playSound(mo.battlen, sfx_hover, mo)
				mo.tr_csetpos = nil	--we moved the cursor while out of Set mode, so we have to reset it's position to the new target.
			end
			if inputs[BT_CUSTOM1]==1 and mo.attack.tr_setmode
				mo.tr_lockskill = 1
				playSound(mo.battlen, sfx_confir, mo)
				BTL_logMessage(mo.battlen, "Aim with Left/Right")
			end
		end
		tr_areaDisplay(mo)

		-- update cmem
		-- regardless of cursormemory because this is too big of a QoL change

		if mo.attack.target == TGT_ENEMY or mo.attack.target == TGT_ALLENEMIES
			mo.t_cmem[1] = mo.t_target
		elseif mo.attack.target == TGT_ALLY or mo.attack.target == TGT_ALLALLIES
			mo.t_cmem[2] = mo.t_target
		end
	end

	
	
	
	
	
	local function tr_setTargets(mo, targettype)	--skill target setting override
		local newtargets
		if targettype == TGT_ENEMY or targettype == TGT_ALLENEMIES
			newtargets = mo.enemies
		elseif targettype == TGT_ALLY or targettype == TGT_ALLALLIES or targettype == TGT_CASTER
			newtargets = mo.allies
		elseif targettype == TGT_CASTER
			newtargets = {mo}
		elseif targettype == TGT_DEAD
			newtargets = mo.allies_noupdate
		elseif targettype == TGT_EVERYONE
			newtargets = {}
			for i = 1, #mo.allies
				newtargets[#newtargets+1] = mo.allies[i]
			end
			for i = 1, #mo.enemies
				newtargets[#newtargets+1] = mo.enemies[i]
			end
		end

		if mo.targets ~= newtargets or mo.targettype ~= targettype

			-- for tgt_dead; check if we have dead allies to begin with.
			local deadallieslist = {}
			if targettype == TGT_DEAD

				for i = 1, #mo.allies_noupdate
					if mo.allies_noupdate[i].hp <= 0
						deadallieslist[#deadallieslist+1] = mo.allies_noupdate[i]
					end
				end
				if not #deadallieslist
					mo.targets = nil
					return
				end
				newtargets = deadallieslist
			end

			mo.targettype = targettype
			mo.t_ctarget = 12
			playSound(mo.battlen, sfx_hover, mo)
			-- update camera, it wasn't made for THIS particular switch so we'll handle it here:
			if (not mo.targets or (mo.targets == mo.allies or (mo.targets and #mo.targets == 1 and mo.targets[1] == mo) or mo.targets == nil or mo.targets == deadallieslist)) and newtargets == mo.enemies
				mo.targets = newtargets or $

				local x, y, z, an, ai = CAM_defaultcoords(mo, true)
				local cam = server.P_BattleStatus[mo.battlen].cam
				P_TeleportMove(cam, x, y, z)
				cam.angle = an
				cam.aiming = ai
				CAM_stop(cam)
			end

			mo.targets = newtargets or $

			if mo.attack.tr_castarea
				if targettype == TGT_ALLY or targettype == TGT_ALLALLIES
				and mo.t_cmem[2]
				and newtargets[mo.t_cmem[2]]
					mo.t_target = mo.t_cmem[2]
				elseif targettype == TGT_ENEMY or targettype == TGT_ALLENEMIES
				and mo.t_cmem[1]
				and newtargets[mo.t_cmem[1]]
					mo.t_target = mo.t_cmem[1]
				else
					mo.t_target = 1
				end
			else
				if targettype == TGT_ALLY
				and mo.t_cmem[2]
				and newtargets[mo.t_cmem[2]]
					mo.t_target = mo.t_cmem[2]
				elseif targettype == TGT_ENEMY
				and mo.t_cmem[1]
				and newtargets[mo.t_cmem[1]]
					mo.t_target = mo.t_cmem[1]
				else
					mo.t_target = 1
				end
			end
		end
	end
	
	
	
	local function tr_skilltargets(mo)	--final skill target-setting override (what we'll actually hit)
		local atk = mo.attack
		if not atk return end
		
		if mo.attack.tr_castarea
			if atk.target == TGT_ENEMY or atk.target == TGT_ALLENEMIES
				mo.targets = tr_areaTargets(mo, mo.enemies)
			elseif atk.target == TGT_ALLY or atk.target == TGT_ALLALLIES or atk.target == TGT_CASTER
				mo.targets = tr_areaTargets(mo, mo.allies)
			elseif atk.target == TGT_DEAD
				mo.targets = tr_areaTargets(mo, mo.allies_noupdate)
			elseif atk.target == TGT_EVERYONE
				local newtargets = {}
				for i = 1, #mo.allies
					newtargets[#newtargets+1] = mo.allies[i]
				end
				for i = 1, #mo.enemies
					newtargets[#newtargets+1] = mo.enemies[i]
				end
				mo.targets = tr_areaTargets(mo, newtargets)
			end
		else
			if atk.target == TGT_ALLY or atk.target == TGT_ENEMY or atk.target == TGT_DEAD or atk.target == TGT_CASTER
				local starget = mo.targets[mo.t_target]
				mo.targets = {starget}
			end
		end
	end

	
	
	
	
	--BOT HELPER--
	
	local function tr_smartAreaSelect(mo)	--this isn't meant to be used IN a thinker, but after the thinker has already acted.
		
		dprint(mo.name.." running bot Smart Area Select for skill: "..mo.attack.name)
		--Skill is already set, what we need to do now is make the bot use it with some degree of intelligence...
		
		if not mo.attack.tr_castarea	--excuse me the fuck?
			dprint(mo.attack.name.." does NOT have a Cast Area, ABORT!!")
			return
		end
		local atk = mo.attack
		
		if atk.target == TGT_ENEMY or atk.target == TGT_ALLENEMIES
		or (mo.status_condition == COND_BRAINWASH and (atk.target == TGT_ALLY or atk.target == TGT_ALLALLIES or atk.target == TGT_CASTER))
			local priority = {}
			mo.t_target = 1
			local pain = 0
			for i = 1, #mo.enemies
				local a = mo.enemies[i]
				local suffering = 100+P_RandomRange(-20, 20)
				
				if #mo.allies > 2	--we have more than two enemies, we should probably aim more for the middle
				and (i == 1 or i == #mo.enemies) --this ally is on the edge, we'll probably hit less enemies if we target this one.
					suffering = min(80+P_RandomRange(-16, 16), $*(#mo.enemies*atk.tr_castarea*60)/1000) --bigger areas and more enemies means less waste.
				end
				
				local aff = getAttackAff(a, atk, mo)
				if aff == DMG_WEAK	--target is WEAK to our attack, we should try to hit them.
					suffering = $*2	--High priority, +100%
				elseif aff == DMG_TECHNICAL	--our attack will yield a TECHNICAL, let's go for it.
					suffering = $*3/2	--Good priority, +50%
				elseif aff == DMG_RESIST	--target RESISTs our attack, not ideal.
					suffering = $/2	--Low priority, -50%
				elseif aff == DMG_BLOCK or aff == DMG_REPEL or aff == DMG_DRAIN	--Nope no, we DON'T want to hit that!
					suffering = $/10	--BZZZT! Incorrect! -90%
				end
				
				if atk.power	--this skill will probably hurt someone
					suffering = $*a.maxhp/a.hp	--The more savagely wounded our foe is, the more we should KILL them!
				end
				
				if atk.ghastlywail and (a.status_condition and a.status_condition == COND_HEX)	--will we Ghastly Wail with this?
					suffering = 9000000 + P_RandomRange(-999999, 999999)	--Ayyo, check this bitch out!
				end
				
				if a.dekaja or a.debuff	--will remove buffs or apply debuffs with this.
					local strs = {"atk", "mag", "def", "agi", "crit"}
					for j = 1, #strs
						local s = strs[j]
						suffering = $*(100+a.buffs[s][1])/100	--priority scales exponentially with more and more buffs lmao
					end
				end
				
				priority[#priority+1] = suffering	--Who is missing the most HP?
			end
			
			for i = 1, #priority
				if priority[i] > pain
					mo.t_target = i
					pain = priority[i]
				end
			end
			mo.targets = tr_areaTargets(mo, mo.enemies)
		elseif atk.target == TGT_ALLY or atk.target == TGT_ALLALLIES or atk.target == TGT_CASTER --ok so we're using a supporting skill...
		or (mo.status_condition == COND_BRAINWASH and (atk.target == TGT_ENEMY or atk.target == TGT_ALLENEMIES))
			local priority = {}
			mo.t_target = 1
			local pain = 0
			for i = 1, #mo.allies
				local a = mo.allies[i]
				local suffering = 100+P_RandomRange(-20, 20)	--so they don't just attack the same guy over and over...
				
				if #mo.allies > 2	--we have more than two allies, we should probably aim for the middle
				and (i == 1 or i == #mo.allies) --this ally is on the edge, we'll probably hit less allies if we target this one.
					suffering = min(80+P_RandomRange(-16, 16), $*(#mo.allies*atk.tr_castarea*60)/1000) --bigger areas and more allies means less waste.
				end
				
				if atk.power	--this skill will probably heal someone
					suffering = $*a.maxhp/a.hp	--The more savagely wounded our friend is, the more we should help them!
				end
				
				if atk.patra and (a.status_condition and a.status_condition < COND_HYPER)	--will we cure an ailment with this?
					suffering = $*2	--bonus priority for being afflicted with something
				end
				
				if a.dekunda or a.buff	--will remove debuffs or apply buffs with this.
					local strs = {"atk", "mag", "def", "agi", "crit"}
					for j = 1, #strs
						local s = strs[j]
						suffering = $*(100-a.buffs[s][1])/100	--priority scales exponentially with more and more debuffs lmao
					end
				end
				
				priority[#priority+1] = suffering	--Who is missing the most HP?
			end
			
			for i = 1, #priority
				if priority[i] > pain
					mo.t_target = i
					pain = priority[i]
				end
			end
			mo.targets = tr_areaTargets(mo, mo.allies)
		elseif atk.target == TGT_EVERYONE
			local newtargets = {}
			for i = 1, #mo.allies
				newtargets[#newtargets+1] = mo.allies[i]
			end
			for i = 1, #mo.enemies
				newtargets[#newtargets+1] = mo.enemies[i]
			end
			mo.t_target = P_RandomRange(1, #newtargets)	--Let the chaos reign =)
			mo.targets = tr_areaTargets(mo, newtargets)
		end
		--for MOVE compatibility
		if mo.attack.tr_range and mo.attack.tr_range > 0	--range limiter
			mo.tr_range = mo.attack.tr_range*(30+mo.agility)*2
		else
			mo.tr_range = 900
		end
		if not mo.tr_csetpos	--Area "set mode" Cursor Position
			if not mo.t_target or mo.t_target > #mo.targets
				mo.t_target = 1
			end
			local target = mo.targets[mo.t_target]	--we're going to start the cursor on the last enemy you had selected.
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local dist = R_PointToDist2(mo.x, mo.y, target.x, target.y)/FRACUNIT
			if dist > mo.tr_range then dist = mo.tr_range end
			mo.tr_csetpos = {dist, mo.angle}	--Distance, Angle-offset
		end
		tr_findcursor(mo)
	end
	
	
	
	--oops wait, I need to make the enemies not rely on their thinker for setting a area/line target!
	local function tr_setAreaAttack(mo, atk)
		dprint(mo.name.." running bot Set Attack override.")
		mo.attackref = atk	-- for attack synching
		mo.attack = BTL_copyAttackDefs(attackDefs[atk])
		tr_smartAreaSelect(mo)
	end

	
	
	--Movement
	local function tr_movedEntityPositions(pn)
		--dprint("Reseting battle entities coordinates...")
		local battle = server.P_BattleStatus[pn]
		for i = 1, #battle.fighters
			battle.crit_seeds[i] = P_RandomRange(0, 100)
			battle.evasion_seeds[i] = P_RandomRange(0, 100)

			-- set teleport points / teleport objects back to their intended positions.

			local e = battle.fighters[i]
			if not e or not e.valid continue end
			if not e.tr_movePos
				e.tr_movePos = {e.x, e.y, e.z, e.angle}
			else
				P_TeleportMove(e, e.tr_movePos[1], e.tr_movePos[2], e.z)	-- useful after physical attacks / dying from repel etc
				if e.tr_movePos[4] ~= nil
					e.angle = e.tr_movePos[4]
				end	-- just in case since i'm not sure if it's always set...
			end
			e.attack = nil
			P_InstaThrust(e, 0, 0)

			if e.plyr
			and e.hp > 0	-- Don't change that if you're dead already.
				e.state = S_PLAY_STND	-- reset state
			end
			e.anim = nil
			ANIM_set(e, e.down and e.anim_downloop or e.guard and e.anim_guard or e.anim_stand, true)

			e.ondamage_recursion = 0

			if e.hp <= 0
			and not e.extra	-- these guys will blow up, don't kill em yet
				-- dead
				e.flags2 = $|MF2_DONTDRAW
				if e.status_condition
					cureStatus(e)
					e.status_condition = nil
					e.status_turns = 0	-- just in case
				end
			end
		end
	end
	
	
	
	
	
	
	------{Vanilla Function Switchers}------
	
	
	local drawPlayerTarget_ORIG = drawPlayerTarget
	rawset(_G, "drawPlayerTarget", function(v, p, c, mo)
		if mo.attack and mo.attack.tr_castarea then tr_drawtargets(v, p, c, mo)
		else drawPlayerTarget_ORIG(v, p, c, mo) end
	end)

	
	local BTL_handletargetselection_ORIG = BTL_handletargetselection
	rawset(_G, "BTL_handletargetselection", function(mo)
		if mo.attack and mo.attack.tr_castarea then tr_targetselect(mo)
		else
			if mo.tr_lockskill then mo.tr_lockskill = nil end
			if mo.tr_csetpos then mo.tr_csetpos = nil end
			BTL_handletargetselection_ORIG(mo)
		end
	end)


	local BTL_setSkillTargets_ORIG = BTL_setSkillTargets
	rawset(_G, "BTL_setSkillTargets", function(mo, targettype)
		if mo.attack and mo.attack.tr_castarea then tr_setTargets(mo, targettype)
		else BTL_setSkillTargets_ORIG(mo, targettype) end
	end)
	
	local BTL_updateTargetForAttack_ORIG = BTL_updateTargetForAttack
	rawset(_G, "BTL_updateTargetForAttack", function(mo)
		if mo.attack and mo.attack.tr_castarea then tr_skilltargets(mo)
		else BTL_updateTargetForAttack_ORIG(mo) end
	end)

	local BTL_setAttack_ORIG = BTL_setAttack	--this is the only way I can universally make enemies work with Area/Lines properly.
	rawset(_G, "BTL_setAttack", function(mo, atk)
		if attackDefs[atk] and attackDefs[atk].tr_castarea
		and (mo.thinker or mo.thinker_n or not mo.plyr
		or mo.status_condition == COND_BRAINWASH)	--we don't need this for normally-controlled players.
			tr_setAreaAttack(mo, atk)
		else
			BTL_setAttack_ORIG(mo, atk)
		end
	end)
	
	
	--MOVE BITCH, GET OUT THE WAY!--
	
	attackDefs["tr_move"] = {
		name = "Move",
		type = ATK_SUPPORT,
		costtype = CST_HP,
		cost = 0,
		desc = "Move to a new default position in the battle arena.".."\x82".."\n   Custom 1 to toggle Pos Modes.",
		target = TGT_EVERYONE,
		tr_range = 5,	--default move range
		tr_castarea = 1,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		powercharge = true,				-- do not remove power charge status after using this skill.
		mindcharge = true,	-- used to know that we shouldn't remove mindcharge after using this skill.
		nometronome = true,
		norandom = true,
		norogue = true,
		nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if mo.tr_moved
							BTL_logMessage(mo.battlen, "Already moved this turn!")
							return true
						end
						--if targets
						--	BTL_logMessage(mo.battlen, "Can't move there! use Custom 1 to aim.")
						--	return true
						--end
					end,
		anim = function(mo, targets, hittargets, timer)
			local x = mo.tr_cursorPos[1]
			local y = mo.tr_cursorPos[2]
			
			if timer == 1	--let's move
				mo.angle = R_PointToAngle2(mo.x, mo.y, x, y)
				ANIM_set(mo, mo.anim_move, true)
				mo.momx = (x - mo.x)/10
				mo.momy = (y - mo.y)/10
			elseif timer == 30
				mo.momx = 0
				mo.momy = 0
				P_TeleportMove(mo, x , y, mo.floorz)
				ANIM_set(mo, mo.anim_stand, true)
			
			elseif timer == 60
				-- cheat the turnorder
				local btl = server.P_BattleStatus[mo.battlen]
				local i = #btl.turnorder +1
				while i > 1
					btl.turnorder[i] = btl.turnorder[i-1]
					i = $-1
				end
				mo.tr_defaultcoords = mo.defaultcoords
				mo.defaultcoords = {mo.x, mo.y, mo.floorz, mo.angle}
				mo.tr_moved = true	--you can move once per turn
				
				return true
			end
		end,
	}
	
	/*
	local tr_move_SplitSkills = BTL_splitSkills
	BTL_splitSkills = function(v)
		table.insert(v.skills, "tr_move")
		tr_move_SplitSkills(v)
	end	



	local function tr_move(mo)
		if not mo or not mo.valid return end
		local btl = server.P_BattleStatus[mo.battlen]
		if btl and btl.running --only in battle
			if mo.tr_moved and btl.turnorder[1] ~= mo and (btl.battlestate == BS_DOTURN or mo.cutin)-- "It's NOT my turn!"
				mo.tr_moved = false
			end
		else
			if mo.tr_defaultcoords
				mo.tr_moved = false
				mo.defaultcoords = mo.tr_defaultcoords
				mo.tr_defaultcoords = nil
			end
		end
	end

	addHook("MobjThinker", tr_move, MT_PFIGHTER)


	*/





end











