------{ Water Arts }------

--ATTACK ARTS

--"Light" Single


	attackDefs["tr_aqua_bleed"] = {
		name = "Aqua Bleed",
		type = bionis and ATK_WATER or ATK_ICE,	    		
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 3,
		tr_orbal = true,	--custom aura effect & sounds
		desc = bionis and "Orbal Art (Liberlian) \nLight Water Damage to one enemy."
			or "Orbal Art (Liberlian) \nLight Ice Damage to one enemy.",
		technical = COND_BURN,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ENEMY,		
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}
				
				if timer == 1
					target.drops = {}
				end	
				
				if timer == 15
					local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.state = S_ELEM1
					boom.color = SKINCOLOR_BLUE
					boom.fuse = 45
					boom.momx = (target.x - boom.x)/40
					boom.momy = (target.y - boom.y)/40
					boom.momz = (target.z - boom.z)/40
					target.bruhn = boom 

				elseif timer == 45
					local boom = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					boom.state = S_AQUA1
					boom.scale = FRACUNIT*5/2
					boom.colorized = true
					boom.color = SKINCOLOR_SKY
					damageObject(target)
					for i = 1, 13 do
						local drop = P_SpawnMobj(target.x, target.y, target.floorz + 5*FRACUNIT, MT_DUMMY)
						drop.momx = P_RandomRange(-6, 6)*FRACUNIT
						drop.momy = P_RandomRange(-6, 6)*FRACUNIT
						drop.momz = P_RandomRange(6,12)*FRACUNIT
						drop.tics = TICRATE*3
						drop.scale = FRACUNIT/3
						drop.flags = MF_NOBLOCKMAP
						drop.frame = $|FF_FULLBRIGHT
						drop.color = aquacolors[P_RandomRange(1,6)]
						target.drops[#target.drops + 1] = drop
					end					
				end	

				for i = 1, #target.drops do
					local m = target.drops[i]
					if not m or not m.valid then continue end

					m.momz = $ - FRACUNIT/3
					if m.z <= m.floorz then P_RemoveMobj(m) end
				end

					if timer == 70
						return true
					end
					
				if timer == 10
					playSound(mo.battlen, sfx_splash)
					S_StartSound(nil, sfx_bluimp)
				elseif timer == 45
					playSound(mo.battlen, sfx_eethit)
					playSound(mo.battlen, sfx_aquble)
				end
				
				if target.bruhn and target.bruhn.valid
					local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
					srbtwomoment.colorized = true
					srbtwomoment.color = SKINCOLOR_BLUE			
				end
			end,	
	}

attackDefs["tr_icicle_edge"] = {
		name = "Icicle Edge",
		type = ATK_ICE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_FREEZE,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art (Enigma series) \nLight ice damage to one enemy, \nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)	
			local t = hittargets[1]
			if timer == 1
				S_StartSound(nil, sfx_iciedg)
			end
			if timer < 35
				summonAura(mo, SKINCOLOR_ICY)
			end
			if timer == 35
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = FRACUNIT*2
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_ICY
				thok.flags2 = $|MF2_SPLAT 
				thok.tics = 15
				thok.momx = (t.x - thok.x)/15
				thok.momy = (t.y - thok.y)/15
				thok.momz = (t.z - thok.z)/15
				//SOUND HERE ALSO
				S_StartSound(nil, sfx_s3k7f)
				
			end
			if timer == 50
				damageObject(t)
				if t.damagestate ~= DMG_MISS
				and t.damagestate ~= DMG_BLOCK
				and t.damagestate ~= DMG_DRAIN
					S_StartSound(nil, sfx_icibrk)
					 local freeze = P_SpawnMobj(t.x,t.y,t.floorz,MT_THOK)
					 freeze.flags2 = $ & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
					 freeze.scale = 1
					 freeze.destscale = (t.scale * 5)
					 freeze.scalespeed = (t.scale)
					 freeze.state = S_FHZICE2
					 freeze.fuse = 40
				end
			end
			if timer == 85
				return true
			end
		end,
	}

attackDefs["tr_crystal_edge"] = {
		name = "Crystal Edge",
		type = ATK_ICE,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 7,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_FREEZE,
		statuschance = 10,
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art (Arcus II) \nLight ice damage (Set Line M), \n10% Freeze chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			
			if timer == 1
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				mo.coc = {} //mwehehe
			end
			if timer == 10
				playSound(mo.battlen, sfx_cryedg)
				playSound(mo.battlen, sfx_cryedg)
				local cx = mo.x + 128*cos(mo.angle)
				local cy = mo.y + 128*sin(mo.angle)
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.state = S_CRYSTAL_EDGE1
				thok.frame = $|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(cx,cy,target.x,target.y)
				thok.tics = -1
				thok.scale = 1
				thok.scalespeed = (FRACUNIT*2)/10
				thok.destscale = FRACUNIT*2
				mo.coc[1] = thok
			elseif timer == 20
				local cx = mo.x + 128*cos(mo.angle + ANG30)
				local cy = mo.y + 128*sin(mo.angle + ANG30)
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.state = S_CRYSTAL_EDGE1
				thok.frame = $|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(cx,cy,target.x,target.y)
				thok.scale = 1
				thok.scalespeed = (FRACUNIT*2)/20
				thok.destscale = FRACUNIT*2
				mo.coc[2] = thok
				
				
				local cx = mo.x + 128*cos(mo.angle - ANG30)
				local cy = mo.y + 128*sin(mo.angle - ANG30)
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.state = S_CRYSTAL_EDGE1
				thok.frame = $|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(cx,cy,target.x,target.y)
				thok.scale = 1
				thok.scalespeed = (FRACUNIT*2)/10
				thok.destscale = FRACUNIT*2
				mo.coc[3] = thok
			end
			if timer == 35
				S_StartSound(nil, sfx_froeg2)
				for i = 1,3
					local thok = mo.coc[i]
					thok.momx = (target.x - thok.x)/15
					thok.momy = (target.y - thok.y)/15
					thok.momz = (target.z - thok.z)/15
					thok.fuse = 50
				end
			end
			if timer < 50 and timer > 10
				for i = 1,#mo.coc
					local b = mo.coc[i]
					summonAura(b, SKINCOLOR_CYAN)
				end
			end
			if timer == 50
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
			end
			if timer < 85 and timer == 35
				for i = 1,3
					local a = mo.coc[i]
					local g = P_SpawnGhostMobj(a)
					g.fuse = 4
				end
			end
			if timer == 85
				mo.coc = nil
				return true
			end
		end,
}


--"Light" Group


	attackDefs["tr_blue_drop"] = {
		name = "Blue Drop",
		type = bionis and ATK_WATER or ATK_ICE,	
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		desc = bionis and "Orbal Art (Enigma series) \nLight Water Damage (Area S)."
			or "Orbal Art (Enigma series) \nLight Ice Damage (Area S).",
		target = TGT_ALLENEMIES,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if Trails_AreaLines
				avgx = target.x
				avgy = target.y
			end
			
			if timer == 1
				playSound(mo.battlen, sfx_bludrp)
			end	
			
			if timer == 10
				local b = P_SpawnMobj(avgx, avgy, mo.z + 300*FRACUNIT, MT_DUMMY)
				b.momz = -15*FRACUNIT
				b.tics = -1
				b.color = SKINCOLOR_CERULEAN
				b.frame = A
				b.state = S_MEGISTAR1
				b.scale = FRACUNIT*1
				b.fuse = TICRATE*8
			end
			
			if timer == 50
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer == 50
				local b = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				b.state = S_ELEM1
				b.scale = FRACUNIT*4
				b.fuse = 80
				b.frame= A|FF_FULLBRIGHT
			end
			
			if timer >= 50 and timer <= 120
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-80, 80)*FRACUNIT, avgy + P_RandomRange(-80, 80)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*1
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
				end
			end	
			
			if timer == 122
				for i = 1, 64
					local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_SAPPHIRE or SKINCOLOR_ICY
					t.scale = FRACUNIT*3/2
				end
			end
				
			if timer == 123
				for i = 1, #hittargets
					damageObject(hittargets[i])	--this should just hit everything highlighted
				end
				
			elseif timer == 145
				return true
			end	
		end,
	}

attackDefs["tr_ice_hammer"] = {
		name = "Ice Hammer",
		type = ATK_ICE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 7,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_FREEZE,
		statuschance = 10,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		tr_castarea = 3,
		desc = "Orbal Art (Enigma series) \nLight ice damage (Area M), \n10% Freeze chance.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for tg = 1,#hittargets
				local t = hittargets[tg]
				local tgz = t.z + FRACUNIT*256
				local time = timer - ((tg-1) * 10)
				if timer == 10
				playSound(mo.battlen, sfx_icehmr)
				end
				if time < 50
					for i = 1,10
						local thok = P_SpawnMobj(t.x+P_RandomRange(-70, 70)*FRACUNIT, t.y+P_RandomRange(-70, 70)*FRACUNIT, tgz+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_ICY
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end
				if time == 50
					local sang = P_RandomRange(1,360)*ANG1 //Outside of i = 1,36 bc we wanna have this CONSISTENT!
					for i = 1,36 
						local icegas = P_SpawnMobj(t.x,t.y,tgz,MT_DUMMY)
						icegas.state = S_CDUST0
						icegas.angle = sang + (ANG10*i)
						icegas.colorized = true
						icegas.color = SKINCOLOR_ICY
						icegas.scale = FRACUNIT*2
						P_InstaThrust(icegas,icegas.angle,(30*FRACUNIT))
					end
					local flatice = P_SpawnMobj(t.x,t.y,tgz,MT_THOK)
					flatice.state = S_FHZICE2
					flatice.scale = FRACUNIT*3
					flatice.flags = $|MF_NOGRAVITY //buh... why nogravity? WELL if we gonna squish em we gotta time it right so it doesn't look JANK af! So we use OUR functions!
					t.hammer = flatice //Registered! Mwehehe!
					
				end
				if time == 70
					local bonk = t.hammer
					bonk.momz = (t.z - bonk.z)/5
					//Sfx maybe
					S_StartSound(nil, sfx_s3k51)
				end
				if time == 75
					local bonk = t.hammer
					bonk.momx = 0
					bonk.momy = 0
					bonk.momz = 0
					damageObject(t)	--this should just hit everything highlighted
					if t.damagestate ~= DMG_MISS
					and t.damagestate ~= DMG_BLOCK
					and t.damagestate ~= DMG_DRAIN
						 t.flags2 = $|MF2_SPLAT
					end
					for i = 1,72
						local icegas = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
						icegas.state = S_CDUST1
						icegas.angle = t.angle + ((ANG1 * 5) * i)
						icegas.colorized = true
						icegas.color = SKINCOLOR_ICY
						icegas.scale = FRACUNIT*2
						P_InstaThrust(icegas,icegas.angle,(60*FRACUNIT))
					end
					//SFX
					S_StartSound(nil, sfx_icehmb)
				end
			end
			if timer == 115 + ((#hittargets - 1) * 10)
				for tg = 1,#hittargets
				local t = hittargets[tg]
					t.hammer.fuse = 5
					t.hammer = nil
					t.flags2 = $ & !MF2_SPLAT
				end
				return true
			end
		end,
}


--"Medium" Single


	attackDefs["tr_blue_impact"] = {
		name = "Blue Impact",
		type = bionis and ATK_WATER or ATK_ICE,	  		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		desc = bionis and "Orbal Art (Liberlian) \nMedium Water Damage to one enemy."
			or "Orbal Art (Liberlian) \nMedium Ice Damage to one enemy.",
		technical = COND_BURN,
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}
			
			if timer == 1
				target.drops = {}
				S_StartSound(nil, sfx_bluimp)
			end	
			
			if timer >= 1 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end	
			
			if timer == 10 
				--local spout = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				--spout.scale = FRACUNIT*5
				--spout.state = S_AQUS1
				for i = 1, 13 do
					local drop = P_SpawnMobj(target.x, target.y, target.floorz + 5*FRACUNIT, MT_DUMMY)
					drop.momx = P_RandomRange(-6, 6)*FRACUNIT
					drop.momy = P_RandomRange(-6, 6)*FRACUNIT
					drop.momz = P_RandomRange(6,12)*FRACUNIT
					drop.tics = TICRATE*3
					drop.scale = FRACUNIT/3
					drop.flags = MF_NOBLOCKMAP
					drop.frame = $|FF_FULLBRIGHT
					drop.color = aquacolors[P_RandomRange(1,6)]
					target.drops[#target.drops + 1] = drop
				end					
			end
			
			
			if timer >= 10 and timer <= 50
				/*
				local water = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.floorz, MT_THOK)
				water.sprite = SPR_AQUS
				water.frame = K|FF_FULLBRIGHT|TR_TRANS20
				water.colorized = true
				water.scale = 2*FRACUNIT
				water.color = SKINCOLOR_WAVE
				water.momz = 30*FRACUNIT
				water.flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
				water.tics = 45
				water.rollangle = ANGLE_180
				*/
				
				local grow = (timer-10)*2
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 64*grow/20
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, target.floorz + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_BLUE
					aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*4
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
				end
				
				for i = 1, 6
					local drop
					drop = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.floorz + 5*FRACUNIT, MT_DUMMY)
					drop.momx = P_RandomRange(-3, 3)*FRACUNIT*3/2
					drop.momy = P_RandomRange(-3, 3)*FRACUNIT*3/2
					drop.momz = P_RandomRange(12, 48)*FRACUNIT*3/2
					drop.tics = TICRATE
					drop.scale = FRACUNIT
					drop.flags = MF_NOBLOCKMAP
					drop.frame = $|FF_FULLBRIGHT
					drop.color = aquacolors[P_RandomRange(1,6)]
				end
			end
			
			if timer == 5
				playSound(mo.battlen, sfx_eethit)
				playSound(mo.battlen, sfx_aquble)
				damageObject(target)
			end

			for i = 1, #target.drops do
				local m = target.drops[i]
				if not m or not m.valid then continue end

				m.momz = $ - FRACUNIT/3
				if m.z <= m.floorz then P_RemoveMobj(m) end
			end

					
			if timer == 65
				target.drops = nil
				return true
			end
		end,
	}

attackDefs["tr_frost_edge"] = {
		name = "Frost Edge",
		type = ATK_ICE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_FREEZE,
		statuschance = 10,
		tr_castarea = 3,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art (Arcus series) \nMedium Ice Damage (Set Area M), \n10% Freeze chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local t
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				t = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				t.state = S_INVISIBLE
				t.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				t = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				t.state = S_INVISIBLE
				t.fuse = 2
			end
			
			if timer == 1
				mo.portals = {}
			end
			local rnda = P_RandomRange(1,360)
			for bworb = 1,4
				local brnd = rnda + (ANGLE_90 * bworb)
				local rx = t.x + 256*cos(brnd)
				local ry = t.y + 256*sin(brnd)
				if timer == bworb * 10 //Check timer HERE with cool bworbs
					local thok = P_SpawnMobj(rx,ry,mo.z + FRACUNIT*32,MT_DUMMY)
					thok.scale = FRACUNIT*2
					thok.frame = A|FF_FULLBRIGHT
					thok.color = SKINCOLOR_ICY
					thok.angle = R_PointToAngle2(thok.x,thok.y,t.x,t.y)
					thok.tics = -1
					mo.portals[bworb] = thok
					//SOUND HERE ALSO
					S_StartSound(nil, sfx_froedg)
				end
			end
			if timer >= 70 and timer < 100
				if timer == 70
					S_StartSound(nil, sfx_s3k7f)
				end
				for z = 1,4
					if mo.portals[z] and mo.portals[z].valid
						summonAura(mo.portals[z], SKINCOLOR_ICY)
						if timer == 70 + (z * 5)
							mo.portals[z].destscale = 1
							mo.portals[z].scalespeed = (FRACUNIT*2)/5
							mo.portals[z].tics = 15
							local thok = P_SpawnMobj(mo.portals[z].x,mo.portals[z].y,mo.portals[z].z + FRACUNIT*32,MT_DUMMY)
							thok.scale = FRACUNIT/2
							thok.sprite = SPR_BFDA
							thok.frame = J|FF_FULLBRIGHT
							thok.color = SKINCOLOR_ICY
							thok.tics = 10
							thok.momx = (t.x - thok.x)/8
							thok.momy = (t.y - thok.y)/8
							thok.momz = (t.z - thok.z)/8
							//SOUND HERE ALSO
							S_StartSound(nil, sfx_froeg2)
						end
					end
				end
				if timer == 90
					if #hittargets > 0	--In case we select nothing
						for i = 1, #hittargets
							damageObject(hittargets[i])	--this should just hit everything highlighted
						end
					end
					S_StartSound(nil, sfx_s3k83)
				end
			end
			if timer == 130
				mo.portals = nil
				return true
			end
		end,
}


--"Medium" Group


	attackDefs["tr_hydro_cannon"] = {
		name = "Hydro Cannon",
		type = bionis and ATK_WATER or ATK_ICE,	   		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 3,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		desc = bionis and "Orbal Art (Enigma series) \nMedium Water Damage (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode."
			or "Orbal Art (Enigma series) \nMedium Ice Damage (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				--local target = hittargets[1]
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				--if Trails_AreaLines
				--	avgx = target.x
				--	avgy = target.y
				--end
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_hydcan)
			end	
			
			if timer >= 10 and timer <= 80
				for i = 1,3
					local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end	
			
			if timer == 39
				if #hittargets > 0	--In case we select nothing
					for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
						localquake(mo.battlen, FRACUNIT*10, 20)
						local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						shot.state = S_HYDROCANNON_1
						shot.scale = FRACUNIT*2
						shot.momx = (avgx - shot.x)/5
						shot.momy = (avgy - shot.y)/5
						shot.momz = (mo.z - shot.z)/5
						target.bruhn = shot
					end
				end
				
			elseif timer == 70
				if #hittargets > 0	--In case we select nothing
					for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
						localquake(mo.battlen, FRACUNIT*15, 20)
						local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						shot.state = S_HYDROCANNON_1
						shot.scale = FRACUNIT*2
						shot.momx = (avgx - shot.x)/5
						shot.momy = (avgy - shot.y)/5
						shot.momz = (mo.z - shot.z)/5
						target.bruhn = shot
					end
				end
			end
			
			if timer == 80
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
			elseif timer == 110
				return true
			end
			
			if #hittargets > 0	--In case we select nothing
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					if target.bruhn and target.bruhn.valid
						local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
						srbtwomoment.colorized = true
						srbtwomoment.color = SKINCOLOR_CERULEAN
					end	
				end
			end
		end,	
	}

attackDefs["tr_diamond_dust"] = {
		name = "Diamond Dust",
		type = ATK_ICE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_FREEZE,
		statuschance = 10,
		tr_castarea = 2,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art (Liberlian) \nMedium Ice Damage (Set Area S), \n10% Freeze chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
					local avgx = 0
					local avgy = 0
					if not mo.tr_lockskill
						--local target = hittargets[1]
						for i = 1, #hittargets do
							avgx = $ + hittargets[i].x/FRACUNIT
							avgy = $ + hittargets[i].y/FRACUNIT
						end
						avgx = $ / #hittargets *FRACUNIT
						avgy = $ / #hittargets *FRACUNIT
						
						--if Trails_AreaLines
						--	avgx = target.x
						--	avgy = target.y
						--end
					else
						avgx = mo.tr_cursorPos[1]
						avgy = mo.tr_cursorPos[2]
					end
					

					if timer == TICRATE*4 - 30
						if #hittargets > 0	--In case we select nothing
							for i = 1, #hittargets
								playSound(mo.battlen, sfx_icebrk)
								damageObject(hittargets[i])	--this should just hit everything highlighted
							end
						end
					end

					if timer == 1
						mo.meteors = {}
					
					elseif timer >= 20 and timer <= TICRATE*4

						-- get an average of the enemy coords:
						local avgx = 0
						local avgy = 0
						if not mo.tr_lockskill
							--local target = hittargets[1]
							for i = 1, #hittargets do
								avgx = $ + hittargets[i].x/FRACUNIT
								avgy = $ + hittargets[i].y/FRACUNIT
							end
							avgx = $ / #hittargets *FRACUNIT
							avgy = $ / #hittargets *FRACUNIT
							
							--if Trails_AreaLines
							--	avgx = target.x
							--	avgy = target.y
							--end
						else
							avgx = mo.tr_cursorPos[1]
							avgy = mo.tr_cursorPos[2]
						end
						
						local navgx = avgx - 128*cos(mo.angle - ANG1*90)
						local navgy = avgy - 128*sin(mo.angle - ANG1*90)

						-- spawn meteors
						mo.meteors[#mo.meteors+1] = P_SpawnMobj(navgx + P_RandomRange(-256, 256)*FRACUNIT, navgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z + FRACUNIT*512, MT_DUMMY)
						local m = mo.meteors[#mo.meteors]
						m.momz = -FRACUNIT*64
						m.state = S_BUFU_PARTICLE_A
						m.sprite = SPR_BFLA
						m.frame = A
						m.scale = $*2
						P_InstaThrust(m, mo.angle - ANG1*90, 32*FRACUNIT)
						
						local baseangle = P_RandomRange(1, 360)*ANG1
						local dist = 256
						for i = 0, 24
							local angle = baseangle + i*6*ANG1
							local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_SAPPHIRE
							aura.momz = P_RandomRange(4, 16)*FRACUNIT
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*5
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
						end
			
						for i = 0, 24
							local angle = baseangle + i*6*ANG1
							local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_SLATE
							aura.momz = P_RandomRange(4, 16)*FRACUNIT
							aura.scale = FRACUNIT
							aura.destscale = FRACUNIT*3
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
						end					

						if timer >= TICRATE and leveltime%8 == 0						    
							local t = P_SpawnMobj(avgx + P_RandomRange(-256, 256)*FRACUNIT, avgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z, MT_DUMMY)
							t.flags2 = $|MF2_DONTDRAW
							for i = 1, 2
								local bp = P_SpawnMobj(m.x, m.y, m.floorz, MT_BUFU_PARTICLE)
								bp.state, bp.scale = S_BUFULA_PARTICLE, FRACUNIT*3/2
								bp.momx, bp.momy, bp.momz = P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(13, 18)*FRACUNIT
							end
							for i = 1, 2
								local ba = P_SpawnMobj(m.x, m.y, m.floorz, MT_BUFU_PARTICLE)
								ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*3/2
								ba.momx, ba.momy, ba.momz = P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(5, 11)*FRACUNIT
							end
							local bb = P_SpawnMobj(m.x, m.y, m.floorz, MT_BUFU_PARTICLE)
							bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*3/2
							bb.momx, bb.momy, bb.momz = P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							for i = 1, 9
								local curangle = ANG1*40*i

								local dust = P_SpawnMobj(m.x+(18*cos(curangle)), m.y+(18*sin(curangle)), m.floorz+(5*FRACUNIT), MT_DUMMY)
								dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
								dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5, curangle
								dust.destscale = FRACUNIT*12/4
								dust.scalespeed = FRACUNIT/15
								P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
								dust.momz = 5*FRACUNIT/2
							end
						end
						
					elseif timer == TICRATE*5 + 10
						mo.meteors = nil
						return true
					end
					
					if timer == 10
					playSound(mo.battlen, sfx_diadst)
					playSound(mo.battlen, sfx_diadst)
					end
					

					-- iterate thru meteors:
					local i = #mo.meteors
					while i
						local m = mo.meteors[i]
						if not m or not m.valid
							table.remove(mo.meteors, i)
							i = $-1
							continue
						end

						-- ghost trail:
						P_SpawnGhostMobj(m)

						if m.z <= m.floorz

							P_RemoveMobj(m)
							i = $-1
							continue
						end


						i = $-1
					end

				end,
}


--"Heavy" Single


	attackDefs["tr_blue_ascension"] = {
			name = "Blue Ascension",
			type = bionis and ATK_WATER or ATK_ICE,			
			power = 350,
			accuracy = 95,
			costtype = CST_SP,
			cost = 9,
			tr_orbal = true,	--custom aura effect & sounds
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = bionis and "Orbal Art (Liberlian) \nHeavy Water Damage to one enemy."
				or "Orbal Art (Liberlian) \nHeavy Ice Damage to one enemy.",
			target = TGT_ENEMY,		
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}

				if timer == 10
					playSound(mo.battlen, sfx_blueas)
				end

				if timer >= 10 and timer <= 60
					local h_angle = P_RandomRange(1, 359)*ANG1
					local v_angle = P_RandomRange(1, 359)*ANG1
					local dist = 256
					local spd = P_RandomRange(40, 50)

					local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
					local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
					local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (target.x - s.x)/10
					s.momy = (target.y - s.y)/10
					s.momz = (target.z - s.z)/10
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_SAPPHIRE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (target.x - s.x)/10
					s.momy = (target.y - s.y)/10
					s.momz = (target.z - s.z)/10
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (target.x - s.x)/10
					s.momy = (target.y - s.y)/10
					s.momz = (target.z - s.z)/10
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
				end



				if timer >= 10 and timer <= 70
					for i = 1,3
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_SAPPHIRE
						if timer%2 then thok.color = SKINCOLOR_ICY end
						thok.frame = A
						thok.tics = 35
						thok.scale = FRACUNIT/2
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(5, 10)*FRACUNIT
						thok.momx = P_RandomRange(-5, 5)*FRACUNIT
						thok.momy = P_RandomRange(-5, 5)*FRACUNIT
						thok.blendmode = AST_ADD
						thok.renderflags = $|RF_FULLBRIGHT
					end
				end
				
				/*
				if timer == 72 
					damageObject(target)
					playSound(mo.battlen, sfx_blueab)
					localquake(mo.battlen, FRACUNIT*25, 10)
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.state = S_AQUS1
					m.colorized = true
					m.color = SKINCOLOR_SKY
					m.scale = FRACUNIT*6
					m.flags = MF_NOBLOCKMAP
					m.tics = 5 
				end
				*/
				
				if timer == 72 
					damageObject(target)
					playSound(mo.battlen, sfx_blueab)
					localquake(mo.battlen, FRACUNIT*25, 10)
				end
				
				if timer > 72
				and timer <= 85
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if P_RandomRange(0,1)
						thok.color = SKINCOLOR_SAPPHIRE
					else
						thok.color = SKINCOLOR_ICY
					end
					thok.frame = A|FF_TRANS30
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/105
					thok.momx = P_RandomRange(-5,5)*FRACUNIT
					thok.momy = P_RandomRange(-5,5)*FRACUNIT
					thok.momz = P_RandomRange(10,30)*FRACUNIT
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					
					local grow = (timer-72)*3
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 80*grow/10
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, target.floorz + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = leveltime%2 and SKINCOLOR_BLUE or SKINCOLOR_SEAFOAM
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*7
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 4))
					end

					for i = 1, 8
						local drop
						drop = P_SpawnMobj(target.x+P_RandomRange(-30, 30)*FRACUNIT, target.y+P_RandomRange(-30, 30)*FRACUNIT, target.floorz + 5*FRACUNIT, MT_DUMMY)
						drop.momx = P_RandomRange(-12, 12)*FRACUNIT
						drop.momy = P_RandomRange(-12, 12)*FRACUNIT
						drop.momz = P_RandomRange(24, 96)*FRACUNIT
						drop.tics = TICRATE
						drop.scale = FRACUNIT*4
						drop.flags = MF_NOBLOCKMAP
						drop.frame = $|FF_FULLBRIGHT
						drop.blendmode = AST_ADD
						drop.renderflags = $|RF_FULLBRIGHT
						drop.color = aquacolors[P_RandomRange(1,6)]
					end
				elseif timer == 100
					return true
				end
			end,
	}


--"Heavy" Group


	attackDefs["tr_genesis_flood"] = {
		name = "Genesis Flood",
		type = bionis and ATK_WATER or ATK_ICE,	   		
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 18,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = bionis and "Orbal Art (Enigma series) \nHeavy Water Damage to all enemies."
			or "Orbal Art (Enigma series) \nHeavy Ice Damage to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 20
				playSound(mo.battlen, sfx_blueab)
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				m.state = S_GENEFLOOD1
				m.color = SKINCOLOR_WHITE 
				m.scale = FRACUNIT*10
				
			elseif timer == 30
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					damageObject(target)
					playSound(mo.battlen, sfx_eethit)
				end
			elseif timer == 50
				return true
			end
		end,
				
	}

attackDefs["tr_cocytus"] = {
	name = "Cocytus",
	type = ATK_ICE,
	power = 350,
	accuracy = 90,
	costtype = CST_SP,
	cost = 30,
	tr_orbal = true,	--custom aura effect & sounds
	status = COND_FREEZE,
	statuschance = 10,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
	end,
	desc = "Orbal Art (Liberlian)\nHeavy ice damage to all enemies, \n10% Freeze chance.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		if timer == 1
			mo.coc = {}
		end
		
		if timer == 10
			playSound(mo.battlen, sfx_cocyt)
		end	
		
		if timer >= 10 and timer <= 80
			local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
			bs.state, bs.color = S_BUFU_PARTICLE_D, SKINCOLOR_SKY
			bs.momz = P_RandomRange(-1, 1)*FRACUNIT
		end	
		
		if timer == 10	
		or timer == 15
		or timer == 20
		or timer == 25
		or timer == 35
		or timer == 40
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			local bd = P_SpawnMobj(rx, ry, mo.z, MT_DUMMY)
			bd.state = S_COCYTUS1
			bd.scale = P_RandomRange(1, 2)*FRACUNIT
			mo.coc[#mo.coc+1] = bd
		end	
		
		if timer == 80
			if mo.coc and #mo.coc
				for gay = 1,#mo.coc
					mo.coc[gay].state = S_NULL
				end
			end
		end
		
		if timer >= 10
		and timer <= 80
			local baseangle = P_RandomRange(1, 380)*ANG1
			local dist = 256
			for i = 1, 16
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_WHITE
				aura.momz = P_RandomRange(6, 16)*FRACUNIT
				aura.scale = FRACUNIT*3/4
				aura.destscale = FRACUNIT*2
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
			end
		end
			
		if timer == 80
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(rx, ry, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(rx, ry, mo.z, MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i
				local dust = P_SpawnMobj(rx+(24*cos(curangle)), ry+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
			
		if timer == 80
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(rx, ry, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(rx, ry, mo.z, MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i
				local dust = P_SpawnMobj(rx+(24*cos(curangle)), ry+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
			
		if timer == 80
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(rx, ry, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(rx, ry, mo.z, MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i
				local dust = P_SpawnMobj(rx+(24*cos(curangle)), ry+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
		
		if timer == 80
			playSound(mo.battlen, sfx_icebrk)
		end	
			
		if timer == 81
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end

		if timer == 100 + 10*(#hittargets-1)
			mo.coc = nil
			return true
		end
	end,
}

attackDefs["tr_diamond_nova"] = {
		name = "Diamond Nova",
		type = ATK_ICE,
		power = 350,	--we're actually going to do 140 POW with an override, this is for Rogue placement.
		accuracy = 90,
		costtype = CST_SP,
		cost = 21,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_FREEZE,
		statuschance = 40,
		tr_castarea = 5,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art (Arcus II) \nMedium ice damage (Set Area L), \n40% Freeze chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				--local target = hittargets[1]
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				--if Trails_AreaLines
				--	avgx = target.x
				--	avgy = target.y
				--end
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			
			if timer >= 20 and timer <= 120	
				if not (timer%8)
					for i = 1, 9
						local dust = P_SpawnMobj(avgx+P_RandomRange(-256, 256)*FRACUNIT, avgy+P_RandomRange(-256, 256)*FRACUNIT, mo.floorz+(5*FRACUNIT), MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale = S_BUFUDYNE_DUST1, FRACUNIT*5
						dust.destscale = FRACUNIT*10/4
						dust.scalespeed = FRACUNIT/15
						P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
						dust.momz = 5*FRACUNIT/2
					end	
				end	
			end
			
			if timer >= 1 and timer <= 130
				local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
				bs.state, bs.color = S_BUFU_PARTICLE_D, SKINCOLOR_SKY
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
			end	
			
			if timer == 1
				playSound(mo.battlen, sfx_dianov)
			end	
			
			
			if timer == 1
				mo.meteors = {}	
			
			elseif timer >= 20 and timer <= 120
				local tarx = avgx - 128*cos(mo.angle - ANG1*90)
				local tary = avgy - 128*sin(mo.angle - ANG1*90)

				-- spawn meteors
				mo.meteors[#mo.meteors+1] = P_SpawnMobj(tarx + P_RandomRange(-256, 256)*FRACUNIT, tary + P_RandomRange(-256, 256)*FRACUNIT, mo.z + FRACUNIT*512, MT_DUMMY)
				local m = mo.meteors[#mo.meteors]
				m.momz = -FRACUNIT*64
				m.state = S_BUFU_PARTICLE_A
				m.sprite = SPR_BFUA
				m.frame = A
				m.scale = FRACUNIT*1
				P_InstaThrust(m, mo.angle - ANG1*90, 32*FRACUNIT)

			
			elseif timer >= 125 and timer <= 190
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 48
				for i = 0, 12
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z+i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_BUFUDYNE_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_WHITE
					aura.momz = P_RandomRange(2, 9)*FRACUNIT
					aura.scale = FRACUNIT*3/4
					aura.destscale = FRACUNIT*2
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 8))
				end
			end


			if timer == 155
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	
			
			if timer == 157
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	
			
			if timer == 159
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	

			if timer == 161
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	

			if timer == 163
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	


			if timer == 165
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end
			
			if timer == 155
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 50
			end	
			
			if timer == 157
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 48
			end	
			
			if timer == 159
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 46
			end	

			if timer == 161
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 44
			end	

			if timer == 163
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.tics = 42
				icicle.scale = FRACUNIT*2
			end	


			if timer == 165
				local icicle = P_SpawnMobj(avgx+P_RandomRange(-100, 100)*FRACUNIT, avgy+P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.tics = 40
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
			end		
			
			if timer == 200
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end
			
			if timer == 200
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end
			
			if timer == 200
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
			
			if timer == 201
				local btl = server.P_BattleStatus[mo.battlen]
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						local targ = hittargets[i]
						local damage = btl.dmg_hits and btl.dmg_hits[targ.dmg_index][1] or 0
						if damage and damage ~= "miss" then damage = $*654/1000 end	--the rough power difference from 350 to 140
						btl.dmg_hits[targ.dmg_index][1] = damage
						damageObject(targ)	--this should just hit everything highlighted
					end
				end
			end	

			if timer == 230
				mo.meteors = nil
				return true
			end


			-- iterate thru meteors:
			local i = #mo.meteors
			while i
				local m = mo.meteors[i]
				if not m or not m.valid
					table.remove(mo.meteors, i)
					i = $-1
					continue
				end

				-- ghost trail:
				P_SpawnGhostMobj(m)

				if m.z <= m.floorz

					P_RemoveMobj(m)
					i = $-1
					continue
				end
				i = $-1
			end		
		end,
}


--"Severe" Single



--"Severe" Group


	attackDefs["tr_maelstorm"] = {
		name = "Maelstorm",
		type = bionis and ATK_WATER or ATK_ICE,	    		
		power = 650,
		accuracy = 90,
		costtype = CST_SP,
		cost = 48,
		tr_orbal = true,	--custom aura effect & sounds
		desc = bionis and "Orbal Art (Arcus series) \nSevere Water Damage to all enemies."
			or "Orbal Art (Arcus series) \nSevere Ice Damage to all enemies.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			
			if timer == 1
				S_StartSound(nil,  sfx_maelst)
			end
			
			
			if timer == 10
				local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				thok.sprite = SPR_THOK
				thok.frame = A|FF_TRANS50
				thok.tics = 150-60
				thok.fuse = 150-60
				thok.scale = $/64
				thok.destscale = FRACUNIT*5
				thok.scalespeed = $*2
				thok.color = SKINCOLOR_CERULEAN
			end
			
			if timer >= 30 and timer <= 90
				local thok = P_SpawnMobj(avgx + P_RandomRange(-70, 70)*FRACUNIT, avgy + P_RandomRange(-70, 70)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = aquacolors[P_RandomRange(1,6)]
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*1
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
			end	
						
			
			if timer == 90
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 10)
					end	
				end				
			end
			
			if timer >= 90 and timer <= 150
				localquake(mo.battlen, FRACUNIT*25, 70)
				local water = P_SpawnMobj(avgx + P_RandomRange(-40, 40)*FRACUNIT, avgy + P_RandomRange(-40, 40)*FRACUNIT, mo.floorz, MT_THOK)
				water.sprite = SPR_NTHK
				water.frame = A|FF_FULLBRIGHT|TR_TRANS40
				water.color = aquacolors[P_RandomRange(1,6)]
				water.momz = 30*FRACUNIT
				water.tics = 45
				
				local drop = P_SpawnMobj(water.x, water.y, mo.floorz + FRACUNIT, MT_DUMMY)
				drop.momx = P_RandomRange(-8, 8)*FRACUNIT
				drop.momy = P_RandomRange(-8, 8)*FRACUNIT
				drop.momz = P_RandomRange(10,16)*FRACUNIT
				drop.tics = TICRATE*2
				drop.scale = FRACUNIT/3
				drop.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				drop.frame = $|FF_FULLBRIGHT
				drop.color = aquacolors[P_RandomRange(1,6)]				
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-20, 20)*FRACUNIT, avgy + P_RandomRange(-20, 20)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = aquacolors[P_RandomRange(1,6)]	
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = FRACUNIT*7
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end
			
			if timer == 151
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
			
			elseif timer == 180
				return true
			end
		end,
	}


--Support



attackDefs["tr_tear"] = {
		name = "Tear",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		power = 50,
		desc = "Orbal Art (Liberlian).\n50 HP recovery for one ally\nand Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_tear)
					end
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(50, 60)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -50)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_la_tear"] = {
		name = "La Tear",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		power = 50,
		tr_castarea = 2,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art (Liberlian).\n50 HP recovery (Area S) \nand Cures Burn",
	nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
		
			for e = 1, #hittargets

				local time = timer - 10*(e-1)

				local target = hittargets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.sprite = SPR_BFUC
						r.frame = A
						r.fuse = 20
						r.scale = (FRACUNIT*2)
						r.momx = (target.x - r.x)/20
						r.momy = (target.y - r.y)/20
						r.momz = (target.z - r.z)/20
						r.destscale = 1
						r.scalespeed = (FRACUNIT*2)/20
						local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
						q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						q.sprite = SPR_BFUC
						q.frame = D
						q.fuse = 55
						q.tics = q.fuse
						q.scale = (FRACUNIT*2)/3
						q.momz = (P_RandomRange(5, 15))*FRACUNIT
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(50, 60)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -50)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
			end

			if timer == 110 + (#hittargets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_tear) 
			end
		end,
}

attackDefs["tr_teara"] = {
		name = "Teara",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 10,
		tr_orbal = true,	--custom aura effect & sounds
		power = 150,
		desc = "Orbal Art.\n150 HP recovery for one ally\nand Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_teara)
					end
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
							end
						end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(150, 160)
					--playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -150)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_la_teara"] = {
		name = "La Teara",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		power = 150,
		tr_castarea = 4,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art (Liberlian).\n150 HP recovery (Area M) \nand Cures Burn",
		nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)

			for e = 1, #hittargets

				local time = timer - 10*(e-1)

				local target = hittargets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(150, 160)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -150)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
			end

			if timer == 110 + (#hittargets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_teara) 
			end
		end,
}

attackDefs["tr_tearal"] = {
		name = "Tearal",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		power = 325,
		desc = "Orbal Art (Liberlian).\n325 HP recovery for one ally\nand Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_tearal)
					end
					if time < 50
						for i = 1, 5
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/2
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -325)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_la_tearal"] = {
		name = "La Tearal",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 27,
		tr_orbal = true,	--custom aura effect & sounds
		power = 325,
		norandom = true,
		norogue = true,
		--noenemycast = true,
		nometronome = true,	
		tr_castarea = 6,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art (Liberlian).\n325 HP recovery (Area L) \nand Cures Burn",
		nocast = function(targets, n, mo)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
				anim = function(mo, targets, hittargets, timer)

			for e = 1, #hittargets

				local time = timer - 10*(e-1)

				local target = hittargets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						for i = 1, 5
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -325)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
			end

			if timer == 110 + (#hittargets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_tearal) 
			end
		end,

}

attackDefs["tr_tear-all"] = {
		name = "Tear-All",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 20,
		tr_orbal = true,	--custom aura effect & sounds
		power = 1200,
		desc = "Orbal Art (Liberlian).\nFull HP recovery for one ally\nand Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		anim = function(mo, targets, hittargets, timer)

				local target = hittargets[1]
				if timer == 10
					playSound(mo.battlen, sfx_terall)
				end
				
				if timer >= 10 and timer <= 70
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 20
					for i = 0, 12
						local angle = baseangle + i*6*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
						aura.state = S_BUFUDYNE_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WHITE
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(2, 3)*FRACUNIT
						aura.scale = FRACUNIT*2/4
						aura.destscale = FRACUNIT*1
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
					end	
				end	
				
				if timer == 45
					local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*250, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGITHOK
					s.scale = FRACUNIT*1/2
					s.momz = -10*FRACUNIT
					s.fuse = 25
				end	
				
				if timer == 70
					for i = 1, 70
						local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
						thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
						thokka.color = SKINCOLOR_WHITE
						thokka.frame = A|FF_TRANS30
						thokka.blendmode = AST_ADD
						thokka.renderflags = $|RF_FULLBRIGHT						
						thokka.tics = P_RandomRange(15,30)
						thokka.scale = FRACUNIT/4
						thokka.scalespeed = (FRACUNIT/4)/50
						thokka.destscale = 1
						thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
						thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
						thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
					end
					
					for i = 1,10
						local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_CYAN
						ol.scale = 1
						ol.blendmode = AST_ADD
						ol.renderflags = $|RF_FULLBRIGHT						
						ol.destscale = target.scale*3
						ol.scalespeed = (target.scale*3)/15
						ol.frame = A|FF_TRANS80
						ol.tics = i + 5
					end						
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_teral2)
					damageObject(target, -1200)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
				
				if timer >= 70 and timer <= 90
				and (timer%5) == 0
					local s = P_SpawnMobj(target.x + P_RandomRange(-58, 58)<<FRACBITS, target.y + P_RandomRange(-58, 58)<<FRACBITS, target.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end	

				if timer == 110
					return true
				end
			end,
}

attackDefs["tr_la_tear-all"] = {
		name = "La Tear-All",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 40,
		tr_orbal = true,	--custom aura effect & sounds
		power = 1200,
		norandom = true,
		norogue = true,
		--noenemycast = true,
		nometronome = true,			
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art (Liberlian).\nFull HP recovery for all allies\nand Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
				anim = function(mo, targets, hittargets, timer)

				for e = 1, #targets

					local time = timer - 10*(e-1)

					local target = targets[e]
					
					if time >= 10 and time <= 70
						local baseangle = P_RandomRange(1, 360)*ANG1
						local dist = 20
						for i = 0, 12
							local angle = baseangle + i*6*ANG1
							local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
							local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
							aura.state = S_BUFUDYNE_AURA1
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_WHITE
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							aura.momz = P_RandomRange(2, 3)*FRACUNIT
							aura.scale = FRACUNIT*2/4
							aura.destscale = FRACUNIT*1
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
						end	
					end	
					
					if time == 45
						local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*250, MT_DUMMY)
						s.color = SKINCOLOR_WHITE
						s.state = S_MEGITHOK
						s.scale = FRACUNIT*1/2
						s.momz = -10*FRACUNIT
						s.fuse = 25
					end	
					
					if time == 70
						for i = 1, 70
							local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
							thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
							thokka.color = SKINCOLOR_WHITE
							thokka.frame = A|FF_TRANS30
							thokka.blendmode = AST_ADD
							thokka.renderflags = $|RF_FULLBRIGHT						
							thokka.tics = P_RandomRange(15,30)
							thokka.scale = FRACUNIT/4
							thokka.scalespeed = (FRACUNIT/4)/50
							thokka.destscale = 1
							thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
							thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
							thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
						end
						
						for i = 1,10
							local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_CYAN
							ol.scale = 1
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT						
							ol.destscale = target.scale*3
							ol.scalespeed = (target.scale*3)/15
							ol.frame = A|FF_TRANS80
							ol.tics = i + 5
						end						
						P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
						--local heals = target.maxhp
						playSound(mo.battlen, sfx_teral2)
						damageObject(target, -1200)
						if target.status_condition and target.status_condition == COND_BURN
						cureStatus(target)
						end
					end
					
					if time >= 70 and time <= 90
					and (timer%5) == 0
						local s = P_SpawnMobj(target.x + P_RandomRange(-58, 58)<<FRACBITS, target.y + P_RandomRange(-58, 58)<<FRACBITS, target.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
						s.color = SKINCOLOR_WHITE
						s.state = S_MEGISTAR1
						s.scale = FRACUNIT*1
					end	
				end	

				if timer == 110 + (#targets-1)*10
					return true
				end
				if timer == 10
					playSound(mo.battlen, sfx_terall)
				end	
			end,
	}

attackDefs["tr_thelas"] = {
		name = "Thelas",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 15,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nRevives an ally with half HP",
		target = TGT_DEAD,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_TEAL))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				mo.minido = {} //Megidola support: making things
				target.landedonce = false
			end
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)	*FRACUNIT
			avgy = ($/#hittargets)	*FRACUNIT
			
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_thelas)
			elseif timer < 60
			and timer > 25
				local ran = P_RandomRange(0, 359)*ANG1
				local dist = 256

				mo.minido[#mo.minido+1] = P_SpawnMobj(avgx + dist*cos(ran), avgy + dist*sin(ran), mo.z + 256*FRACUNIT, MT_DUMMY)
				local s = mo.minido[#mo.minido]
				s.angle = ran
				s.state = S_MEGITHOK
				s.scale = $/5
				s.extravalue1 = dist
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
			end
			if timer <= 115
				for i = 1, #mo.minido
					if timer < 115
					local s = mo.minido[i]
					s.angle = $ + ANG1*12
					s.extravalue1 = max(0, $ - 6)

					local x = avgx + s.extravalue1*cos(s.angle)
					local y = avgy + s.extravalue1*sin(s.angle)
					local sz = s.z - FRACUNIT*6
					if s.z > target.z + 16*FRACUNIT
						P_TeleportMove(s, x, y, sz)
					else
						P_TeleportMove(s, x, y, s.z)
						s.destscale = 1
						s.scalespeed = FRACUNIT/20
					end
					elseif timer == 115
						local s = mo.minido[i]
						s.fuse = 2
					end
				end
			end
			if timer == 115
				local heals = target.maxhp/2
				damageObject(target, -heals)
				playSound(mo.battlen, sfx_tear)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				target.momz = 6*FRACUNIT
				for i = 1, 64
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_ORANGE
					thok.frame = A
					thok.tics = 50
					thok.scale = (P_RandomRange(1, 10)*FRACUNIT)/8
					thok.scalespeed = FRACUNIT/50
					thok.destscale = 1
					thok.momz = P_RandomRange(3, 12)*FRACUNIT
					thok.momx = P_RandomRange(-15, 15)*FRACUNIT
					thok.momy = P_RandomRange(-15, 15)*FRACUNIT
				end
			end
			if timer > 115 and P_IsObjectOnGround(target) and not target.landedonce
				ANIM_set(target, target.anim_stand_hurt, true)
				target.landedonce = true
			end
			if timer == 165
				target.landedonce = nil
				mo.minido = nil
				return true
			end
		end,
}

attackDefs["tr_athelas"] = {
		name = "Athelas",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 30,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nRevives an ally with full HP",
		target = TGT_DEAD,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_TEAL))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				P_TeleportMove(target,target.x,target.y,target.z + FRACUNIT*10)
				local thok = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*16, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thok.color = SKINCOLOR_WHITE
				thok.frame = A|FF_TRANS90
				thok.tics = 9999
				thok.scale = 1
				mo.atom = thok
			end
			if timer < 160
				target.momz = 0
			end
			if timer > 25 and timer < 130
				mo.atom.momz = -((FRACUNIT*16)/(TICRATE*4))
			end
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_athela)
				
			end
			if timer == 25
			local cx = target.x + 64*cos(target.angle)
			local cy = target.y + 64*sin(target.angle)
				local fthok = P_SpawnMobj(cx, cy, target.z+16*FRACUNIT, MT_DUMMY)
				fthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				fthok.color = SKINCOLOR_WHITE
				fthok.frame = A|FF_FULLBRIGHT
				fthok.tics = 9999
				fthok.angle = target.angle + ANGLE_90
				fthok.scale = FRACUNIT/2
				mo.fatom = fthok
			local dx = target.x + 64*cos(target.angle + ANGLE_180)
			local dy = target.y + 64*sin(target.angle + ANGLE_180)
				local bthok = P_SpawnMobj(dx, dy, target.z+16*FRACUNIT, MT_DUMMY)
				bthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				bthok.color = SKINCOLOR_WHITE
				bthok.frame = A|FF_FULLBRIGHT
				bthok.tics = 9999
				bthok.angle = target.angle + ANGLE_270
				bthok.scale = FRACUNIT/2
				mo.batom = bthok
				mo.atom.destscale = FRACUNIT*2
				mo.atom.scalespeed = (FRACUNIT*2)/(TICRATE*4)
			end 
			if timer == 35
				mo.atom.frame = A|FF_TRANS80
			elseif timer == 45
				mo.atom.frame = A|FF_TRANS70
			elseif timer == 55
				mo.atom.frame = A|FF_TRANS60
			elseif timer == 65
				mo.atom.frame = A|FF_TRANS50
			elseif timer == 75
				mo.atom.frame = A|FF_TRANS40
			elseif timer == 85
				mo.atom.frame = A|FF_TRANS30
			elseif timer == 95
				mo.atom.frame = A|FF_TRANS20
			elseif timer == 105
				mo.atom.frame = A|FF_TRANS10
			elseif timer == 115
				mo.atom.frame = A|FF_FULLBRIGHT
			end
			if timer > 25
			and timer < 130
				P_InstaThrust(mo.fatom,mo.fatom.angle, FRACUNIT*40)
				mo.fatom.angle = $ + ANG1*25
				local thokf = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
				thokf.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokf.color = SKINCOLOR_WHITE
				thokf.frame = A|FF_TRANS50
				thokf.tics = 5
				thokf.scale = FRACUNIT/4
				local thokff = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
				thokff.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokff.color = SKINCOLOR_WHITE
				thokff.frame = A|FF_TRANS70
				thokff.tics = 10
				thokff.scale = FRACUNIT/4
				P_InstaThrust(mo.batom,mo.batom.angle, FRACUNIT*40)
				mo.batom.angle = $ + ANG1*25
				local thokb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
				thokb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokb.color = SKINCOLOR_WHITE
				thokb.frame = A|FF_TRANS50
				thokb.tics = 5
				thokb.scale = FRACUNIT/4
				local thokbb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
				thokbb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokbb.color = SKINCOLOR_WHITE
				thokbb.frame = A|FF_TRANS70
				thokbb.tics = 10
				thokbb.scale = FRACUNIT/4
			end
			if timer == 128
				mo.fatom.tics = 2
				mo.batom.tics = 2
			elseif timer == 130
				local heals = target.maxhp
				damageObject(target, -heals)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				for i = 1, 128
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_WHITE
					thokka.frame = A|FF_TRANS30
					thokka.tics = 50
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
			elseif timer == 150
				mo.atom.tics = 10
			elseif timer == 160
				ANIM_set(target, target.anim_stand_bored, true)
				for i = 1, 128
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_WHITE
					thokka.frame = A|FF_TRANS30
					thokka.tics = P_RandomRange(15,30)
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
			elseif timer == 180
				mo.fatom = nil
				mo.batom = nil
				mo.atom = nil
				return true
			end
		end,
}

attackDefs["tr_curia"] = {
		name = "Curia",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		desc = "Orbal Art (Liberlian).\nCures ailments for one ally",
		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_TEAL))
		end,
		anim = function(mo, targets, hittargets, timer)

			local target = targets[1]
				
			if timer >= 10 and timer <= 70
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 20
				for i = 0, 12
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
					aura.state = S_BUFUDYNE_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_TEAL
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(2, 3)*FRACUNIT
					aura.scale = FRACUNIT*2/4
					aura.destscale = FRACUNIT*1
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
				end	
				
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
				thok.momz = P_RandomRange(6, 16)*FRACUNIT
				thok.color = SKINCOLOR_TEAL
				thok.blendmode = AST_ADD
				thok.renderflags = $|RF_FULLBRIGHT
				thok.tics = P_RandomRange(10, 35)
			end	
			
			if timer == 70
				for i = 1, 70
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_TEAL
					thokka.frame = A|FF_TRANS30
					thokka.blendmode = AST_ADD
					thokka.renderflags = $|RF_FULLBRIGHT						
					thokka.tics = P_RandomRange(15,30)
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
						
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_CYAN
					ol.scale = 1
					ol.blendmode = AST_ADD
					ol.renderflags = $|RF_FULLBRIGHT						
					ol.destscale = target.scale*3
					ol.scalespeed = (target.scale*3)/15
					ol.frame = A|FF_TRANS80
					ol.tics = i + 5
				end						
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				--local heals = target.maxhp
				playSound(mo.battlen, sfx_curia)
				if target.status_condition
					cureStatus(target)
				end
			end
					
			if timer >= 70 and timer <= 90
			and (timer%5) == 0
				local s = P_SpawnMobj(target.x + P_RandomRange(-58, 58)<<FRACBITS, target.y + P_RandomRange(-58, 58)<<FRACBITS, target.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_TEAL
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1
			end

			if timer == 110
				return true
			end
			if timer == 10
				playSound(mo.battlen, sfx_terall)
			end	
		end,
	}


attackDefs["tr_la_curia"] = {
		name = "La Curia",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 5,	--1 is Area S/Line S, 2 is Area M/Line M, 3 is Area L/Line L
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art (Liberlian).\nCures ailments for allies (Area L)",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 10 and time <= 70
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 20
					for i = 0, 12
						local angle = baseangle + i*6*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
						aura.state = S_BUFUDYNE_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_TEAL
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(2, 3)*FRACUNIT
						aura.scale = FRACUNIT*2/4
						aura.destscale = FRACUNIT*1
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
					end	
							
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_TEAL
					thok.blendmode = AST_ADD
					thok.renderflags = $|RF_FULLBRIGHT
					thok.tics = P_RandomRange(10, 35)
				end	
				
				if time == 70
					for i = 1, 70
						local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
						thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
						thokka.color = SKINCOLOR_TEAL
						thokka.frame = A|FF_TRANS30
						thokka.blendmode = AST_ADD
						thokka.renderflags = $|RF_FULLBRIGHT						
						thokka.tics = P_RandomRange(15,30)
						thokka.scale = FRACUNIT/4
						thokka.scalespeed = (FRACUNIT/4)/50
						thokka.destscale = 1
						thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
						thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
						thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
					end
							
					for i = 1,10
						local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_CYAN
						ol.scale = 1
						ol.blendmode = AST_ADD
						ol.renderflags = $|RF_FULLBRIGHT						
						ol.destscale = target.scale*3
						ol.scalespeed = (target.scale*3)/15
						ol.frame = A|FF_TRANS80
						ol.tics = i + 5
					end						
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_curia)
					if target.status_condition
						cureStatus(target)
					end
				end
						
				if time >= 70 and time <= 90
				and (timer%5) == 0
					local s = P_SpawnMobj(target.x + P_RandomRange(-58, 58)<<FRACBITS, target.y + P_RandomRange(-58, 58)<<FRACBITS, target.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_TEAL
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
					end	
				end	

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 10
				playSound(mo.battlen, sfx_terall)
			end	
		end,
	}





