------{ Wind Arts }------

--ATTACK ARTS

--"Light" Single


attackDefs["tr_air_strike"] = {
		name = "Air Strike",
		type = ATK_WIND,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 3,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art (Liberlian).\nLight Wind Damage to one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local t = hittargets[1]

			if timer == 20

				for i = 1, 5
					local g = P_SpawnMobj(mo.x, mo.y, mo.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
					g.target = mo
					g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
					if i == 3
						g.jizzcolor = true
						g.invertrotation = true
					end
					g.dist = P_RandomRange(25, 50)
					g.tics = 20
				end

			elseif timer == 30
				playSound(mo.battlen, sfx_wind1)
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = 1
				thok.destscale = FRACUNIT*2
				thok.scalespeed = (FRACUNIT*2)/10
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_EMERALD
				thok.tics = 10
			end
			if timer >= 35 and timer <= 42
				if timer == 42
					damageObject(t)
					playSound(mo.battlen, sfx_rail1)
					playSound(mo.battlen, sfx_rail2)
				end
				local ax = t.x + P_RandomRange(-20,20)*FRACUNIT
				local ay = t.y + P_RandomRange(-20,20)*FRACUNIT
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = FRACUNIT
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_GREEN
				thok.flags2 = $|MF2_SPLAT 
				thok.tics = 6
				thok.momx = (ax - thok.x)/6
				thok.momy = (ay - thok.y)/6
				thok.momz = (t.z - thok.z)/6
			end
			if timer == 75
				return true
			end
		end,
}

attackDefs["tr_aero_sickle"] = {
		name = "Aero Sickle",
		type = ATK_WIND,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art (Enigma series).\nLight Wind Damage to a (Set Line M).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end

			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local wepz = mo.z + FRACUNIT*40

			if timer == 1 
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)

			end
			if timer < 35
				local s = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)
				s.scale = FRACUNIT
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = FRACUNIT/5
				s.tics = 5
				s.rollangle = ANG1*P_RandomRange(1,360)
				//Wind "energy"
			end
			if timer == 35
				local thok = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)	
				thok.color = SKINCOLOR_EMERALD
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 50 //2* target hit time - make it resume on
				thok.scale = mo.scale
				thok.momx = (target.x - thok.x)/25
				thok.momy = (target.y - thok.y)/25
				thok.momz = (target.z - thok.z)/25

				mo.windblob = thok //Okay set this as an object so we can throw bullshit around!
				playSound(mo.battlen, sfx_s3k4b)
			end
			
			if timer == 60
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						local t = hittargets[i]
						damageObject(t)	--this should just hit everything highlighted
						if t.damagestate ~= DMG_MISS
						and t.damagestate ~= DMG_BLOCK
						and t.damagestate ~= DMG_DRAIN
							P_SetObjectMomZ(t,FRACUNIT*17,true)
							playSound(mo.battlen, sfx_aersik)
						else
							playSound(mo.battlen, sfx_s3k47)
						end	
					end
				end
				for i = 1,20
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					thok.color = SKINCOLOR_MINT
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end
			end

			if timer < 85 and mo.windblob
				local s = P_SpawnMobj(mo.windblob.x, mo.windblob.y, mo.windblob.z, MT_DUMMY)
				s.scale = FRACUNIT/2
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = (FRACUNIT/2)/min(5,mo.windblob.tics)
				s.tics = min(5,mo.windblob.tics)
				s.rollangle = ANG1*P_RandomRange(1,360)
				s.momx = mo.windblob.momx
				s.momy = mo.windblob.momy
			end 

			if timer == 85
				if mo.windblob
					mo.windblob = nil
				end
				return true
			end
			if timer == 10
			playSound(mo.battlen, sfx_preaer) 
			end
		end,
}

attackDefs["tr_sparkle"] = {
		name = "Sparkle",
		type = ATK_ELEC,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SILENCE,
		statuschance = 5,
		cost = 4,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art (Enigma series).\nLight Electric Damage to one enemy.\nMay inflict Shock.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_zio1)
				local firebol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*580, MT_DUMMY)
				firebol.scale = 1 
				firebol.tics = 15
				firebol.destscale = FRACUNIT*2 
				firebol.sprite = SPR_THOK
				firebol.color = SKINCOLOR_YELLOW
				firebol.frame = A|FF_TRANS20
				firebol.scalespeed = (FRACUNIT*6)/80
			end
			
			if timer >= 15 and timer <= 30
				local orb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*580, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_GOLD
				orb.destscale = FRACUNIT*7
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end	
					
			if timer == 15
				playSound(mo.battlen, sfx_zio1)
			end	
			
			if timer == 25
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*600, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_YELLOW
					ol.scale = 1
					ol.destscale = target.scale*3
					ol.scalespeed = (target.scale*3)/15
					ol.frame = B|FF_TRANS80|FF_FULLBRIGHT
					ol.tics = i + 5	
				end	
				playSound(mo.battlen, sfx_s3k9c)
			end	
				
            if timer == 30
				local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_TRSPARKLE1	, target.scale*15/4, SKINCOLOR_YELLOW
				z2.destscale = target.scale*3/2
				playSound(mo.battlen, sfx_elspk)
				damageObject(target)
			end
			
			if timer == 31
				local f = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				f.state = S_KSPARK1
				f.scale = FRACUNIT*2
				f.color = SKINCOLOR_YELLOW
				f.colorized = true	
				
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["tr_spark_arrow"] = {
		name = "Spark Arrow",
		type = ATK_ELEC,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SILENCE,
		statuschance = 10,
		cost = 6,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 1,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art (Arcus series).\nLight Electric Damage (Set Line S).\n10% Silence chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_spaarw)
				playSound(mo.battlen, sfx_zio4)
			end	
			
			if timer >= 10 and timer <= 70
				local orb = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_CYAN
				orb.destscale = FRACUNIT*4
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end
			
			if timer >= 10
			and timer <= 70
			and leveltime%3 == 0


				local range = 60
				if timer >= 50
					range = 100
				end

				local s = P_SpawnMobj(mo.x + P_RandomRange(-range, range)*mo.scale, mo.y + P_RandomRange(-range, range)*mo.scale, mo.z + P_RandomRange(0, 100)*mo.scale, MT_SUPERSPARK)
			end
			
			
			
			if timer == 40
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				s.state = S_INVISIBLE
				s.fuse = 100
				s.momx = (target.x - mo.x)/5
				s.momy = (target.y - mo.y)/5
				s.momz = (target.z - s.z)/5			
				mo.zap = s
			end		
			
			
			if timer == 40
			or timer == 45
			or timer == 50
			or timer == 55
                local boom = P_SpawnMobj(mo.zap.x,mo.zap.y,mo.zap.z + FRACUNIT*32,MT_DUMMY)
                boom.scale = FRACUNIT*1
				boom.sprite = SPR_MAGN
				boom.colorized = true
				boom.color = SKINCOLOR_CYAN
				boom.frame = A|FF_FULLBRIGHT
				boom.fuse = 17
				target.bruhn = boom
				playSound(mo.battlen, sfx_s3k40)
			end
			
			if timer == 65
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						damageObject(hittargets[i])	--this should just hit everything highlighted
					end
				end
				S_StartSound(nil, sfx_s3k83)
			
			elseif timer == 90
				return true
			end
				
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_CYAN
			end
        end,				
}


--"Light" Group


attackDefs["tr_aerial"] = {
		name = "Aerial",
		type = ATK_WIND,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 5,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		tr_castarea = 3,
		desc = "Orbal Art (Liberlian).\nLight Wind Damage (Area M)",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
			if timer < 20
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_LIME
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
			elseif timer >= 20 and timer < 60
				local t = P_SpawnMobj (avgx,avgy,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_EMERALD
				t.scale = FRACUNIT*#hittargets
				t.momz = 20*FRACUNIT
				t.tics = 35
				for h = 1,#hittargets
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,(FRACUNIT*(timer - 20))/10)
					end	
				end
			end
			if timer == 17
				local dust = P_SpawnMobj(avgx,avgy,mo.floorz,MT_DUSTDEVIL)
				dust.scale = (FRACUNIT/2)*#hittargets
				mo.nado = dust
			end

			if timer == 60
				playSound(mo.battlen, sfx_hit)
				for h = 1,#hittargets
					damageObject(hittargets[h])
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,FRACUNIT*20)
					end	
				end
				
				mo.nado.fuse = 1
				mo.nado = nil
			end
			if timer == 1
				playSound(mo.battlen, sfx_aerial)
			end
			if timer == 90
				return true
			end
		end,
}


--"Medium" Single


attackDefs["tr_lightning"] = {
		name = "Lightning",
		type = ATK_ELEC,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SILENCE,
		statuschance = 10,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 1,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art (Liberlian).\nMedium Electric Damage (Set Line S).\n10% Silence chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			local hightick = 0
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local t = hittargets[i]
					local time = timer - (5*(i-1))
					local disttick = R_PointToDist2(mo.x, mo.y, t.x, t.y)/(16*FRACUNIT)
					if disttick > hightick then hightick = disttick end
					if time >= disttick+10 and time <= disttick+30
						local orb = P_SpawnMobj(t.x, t.y, t.z+20*FRACUNIT, MT_DUMMY)
						orb.sprite = SPR_DELK
						orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
						orb.color = SKINCOLOR_MAGENTA
						orb.blendmode = AST_ADD
						orb.renderflags = $|RF_FULLBRIGHT
						orb.destscale = FRACUNIT*7
						orb.scalespeed = FRACUNIT/4
						orb.tics = TICRATE/8
						
						for i = 1, 4
							local g = P_SpawnMobj(t.x, t.y, t.z+20*FRACUNIT, MT_DUMMY)
							g.sprite = SPR_STAB
							g.frame = (i-1)|FF_FULLBRIGHT
							g.rollangle = timer*12*ANG1
							g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
							g.fuse = 2
							g.scale = FRACUNIT*2/i
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
							
							local g = P_SpawnMobj(t.x, t.y, t.z+20*FRACUNIT, MT_DUMMY)
							g.sprite = SPR_STAB
							g.frame = (i-1)|FF_FULLBRIGHT
							g.rollangle = -timer*12*ANG1
							g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
							g.fuse = 2
							g.scale = FRACUNIT*2/i
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
						end
						
						if time == disttick+10
							playSound(mo.battlen, sfx_trzap)
						elseif time == disttick+30
							playSound(mo.battlen, sfx_eethit)
							damageObject(t)	--this should just hit everything highlighted
						end
					end
				end
			end
			
			if timer <= 20
				local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_MAGENTA
				orb.blendmode = AST_ADD
				orb.renderflags = $|RF_FULLBRIGHT
				orb.destscale = FRACUNIT*7
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end
			
			if timer == 10
				mo.bod = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				mo.bod.state = S_JETFUME1
				mo.bod.colorized = true
				mo.bod.frame = FF_FULLBRIGHT
				mo.bod.color = SKINCOLOR_VIOLET
				mo.bod.blendmode = AST_ADD
				mo.bod.renderflags = $|RF_FULLBRIGHT
				mo.bod.tics = 50
				mo.bod.fuse = 50
				mo.bod.angle = R_PointToAngle2(mo.bod.x, mo.bod.y, target.x, target.y)
				mo.bod.scale = FRACUNIT*2
				P_InstaThrust(mo.bod, mo.bod.angle, FRACUNIT*16)
				playSound(mo.battlen, sfx_trlzap)
			end
			
			if mo.bod and mo.bod.valid
				for i = 0, 3
					local g = P_SpawnGhostMobj(mo.bod)
					g.sprite = SPR_STAB
					g.frame = i|FF_FULLBRIGHT
					g.rollangle = timer*12*ANG1
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 2
					g.scale = FRACUNIT*2
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momx = mo.bod.momx
					g.momy = mo.bod.momy
				end
				for i = 0, 3
					local g = P_SpawnGhostMobj(mo.bod)
					g.sprite = SPR_STAB
					g.frame = i|FF_FULLBRIGHT
					g.rollangle = -timer*12*ANG1
					g.color = SKINCOLOR_MAGENTA
					g.fuse = 2
					g.scale = FRACUNIT*2
					g.blendmode = AST_ADD
					g.renderflags = $|RF_FULLBRIGHT
					g.momx = mo.bod.momx
					g.momy = mo.bod.momy
				end
				local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_MAGENTA
				orb.blendmode = AST_ADD
				orb.renderflags = $|RF_FULLBRIGHT
				orb.destscale = FRACUNIT*12
				orb.scalespeed = FRACUNIT/3
				orb.tics = P_RandomRange(3, 30)
				--if timer >= 20 and timer < 60 and not (timer%5)
				--	playSound(mo.battlen, sfx_zio2)	--placeholder
				--end
			end
			
			if timer == hightick+55
				mo.bod = nil 
				return true
			end
		end,
}


--"Medium" Group


attackDefs["tr_judgement_bolt"] = {
		name = "Judgement Bolt",
		type = ATK_ELEC,
		power = 170,
		accuracy = 100,
		costtype = CST_SP,
		status = COND_SILENCE,
		statuschance = 25,
		cost = 16,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art (Arcus series).\nMedium Electric Damage (Set Line M).\n25% Silence chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		hudfunc = 	function(v, mo, timer)
			
			local beamgo = 59
			local flashtbl = {3,4,5,6,5,5,4,4,4,3,3,3,3,2,2,2,2,2,1,1,1,1,1,1,1}
			
			for zorua = 1,#flashtbl
				if timer == beamgo + zorua
					local fd = flashtbl[zorua]
					v.fadeScreen(98, fd)
				end
			end
		end,
		anim = function(mo, tg, ht, timer)	--bro, why are you changing the variable names?!
			local t
			if not mo.tr_lockskill
				t = ht[1]
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				t = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				t.state = S_INVISIBLE
				t.fuse = 85
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_spaarw)
				playSound(mo.battlen, sfx_zio4)
			end	
			
			local cam = server.P_BattleStatus[mo.battlen].cam
			
			if timer == 1
				P_SpawnMobj(mo.x,mo.y,mo.z + (mo.height*3)/4,MT_SUPERSPARK)
				mo.angle = R_PointToAngle2(mo.x,mo.y,t.x,t.y)
				playSound(mo.battlen, sfx_s227)
				CAM_stop(cam)
				
				local ang = mo.angle + (ANG20)
					
				local dist = 384
				
				local cx = mo.x + dist*cos(ang)
				local cy = mo.y + dist*sin(ang)
				local cz = cam.z + FRACUNIT*32
				
				P_TeleportMove(cam,cx,cy,cz)
				
				cam.angle = mo.angle + (ANG20*10)
				
				cam.momz = -(FRACUNIT/2)
				
				
				
			elseif timer == 10
				playSound(mo.battlen, sfx_judbol)
			end

			local beamgo = 60 //Adjust for the time you want
			
			
			if timer > 10
				if timer < 15
					local zht = {16,16,64,64,96}
					local angt = {ANG60,-ANG60,(ANG10*4),-(ANG10*4),0}
					local dist = 64
					
					
					local nx = mo.x + dist*cos(mo.angle)
					local ny = mo.y + dist*sin(mo.angle)
					local nz = mo.z + FRACUNIT*32
					
					local nultg = P_SpawnMobj(nx,ny,nz,MT_NULL)//This is specifically only to make a 'target' for diff move
					
					//For now...
					
					
					for bzt = 1,5
						local ang = mo.angle + (angt[bzt])
						local zh = (zht[bzt])*FRACUNIT
						
						local cx = mo.x + dist*cos(ang)
						local cy = mo.y + dist*sin(ang)
						local cz = mo.z + zh
						
						local b = P_SpawnMobj(cx,cy,cz,MT_DUMMY)
						b.frame = P_RandomRange(0,11)|FF_FULLBRIGHT
						b.fuse = 2
						b.sprite = SPR_MAGN
						b.drawangle = P_RandomRange(1,360)*ANG1
						b.colorized = true
						b.color = SKINCOLOR_MINT
						b.scale = FRACUNIT/2
						
						for zzy = 1,3
							local rx = b.x + P_RandomRange(-32,32)*FRACUNIT
							local ry = b.y + P_RandomRange(-32,32)*FRACUNIT
							local rz = b.z + P_RandomRange(-16,48)*FRACUNIT
							
							local zp = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
							zp.drawangle = P_RandomRange(1,360)*ANG1
							zp.colorized = true
							zp.color = SKINCOLOR_SEAFOAM
							
							
							
							local nultgz = nultg.z + (nultg.height/2)
							zp.momx = (nultg.x - zp.x)/5
							zp.momy = (nultg.y - zp.y)/5
							zp.momz = (nultgz - zp.z)/5
							
						end
					end
					
				elseif timer < (beamgo)
					
					
					local zht = {16,16,64,64,96}
					local angt = {ANG60,-ANG60,(ANG10*4),-(ANG10*4),0}
					local dist = 64
					
					local nx = mo.x + dist*cos(mo.angle)
					local ny = mo.y + dist*sin(mo.angle)
					local nz = mo.z + FRACUNIT*32
					
					local n = P_SpawnMobj(nx,ny,nz,MT_DUMMY)
					
					
					
					
					n.frame = P_RandomRange(0,11)|FF_FULLBRIGHT
					n.fuse = 2
					n.sprite = SPR_MAGN 
					n.drawangle = P_RandomRange(1,360)*ANG1
					n.colorized = true
					n.color = SKINCOLOR_PERIDOT
					n.scale = (FRACUNIT)
					
					for zzy = 1,5
						local rx = n.x + P_RandomRange(-48,48)*FRACUNIT
						local ry = n.y + P_RandomRange(-48,48)*FRACUNIT
						local rz = n.z + P_RandomRange(-24,64)*FRACUNIT
						
						local zzp = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
						zzp.drawangle = P_RandomRange(1,360)*ANG1
						zzp.colorized = true
						zzp.color = SKINCOLOR_EMERALD
						
					end
					
					
					for bzt = 1,5
						local ang = mo.angle + (angt[bzt])
						local zh = (zht[bzt])*FRACUNIT
						
						local cx = mo.x + dist*cos(ang)
						local cy = mo.y + dist*sin(ang)
						local cz = mo.z + zh
						
						local b = P_SpawnMobj(cx,cy,cz,MT_DUMMY)
						b.frame = P_RandomRange(0,11)|FF_FULLBRIGHT
						b.fuse = 2
						b.sprite = SPR_MAGN 
						b.drawangle = P_RandomRange(1,360)*ANG1
						b.colorized = true
						b.color = SKINCOLOR_MINT
						b.scale = FRACUNIT/2
						
						for zzy = 1,3
							local rx = b.x + P_RandomRange(-32,32)*FRACUNIT
							local ry = b.y + P_RandomRange(-32,32)*FRACUNIT
							local rz = b.z + P_RandomRange(-16,48)*FRACUNIT
							
							local zp = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
							zp.drawangle = P_RandomRange(1,360)*ANG1
							zp.colorized = true
							zp.color = SKINCOLOR_SEAFOAM
							
							
							
							local nultgz = n.z + (n.height/2)
							zp.momx = (n.x - zp.x)/5
							zp.momy = (n.y - zp.y)/5
							zp.momz = (nultgz - zp.z)/5
							
						end
					end
					
				elseif timer < (beamgo + 55)//change as needed
					
					if timer == (beamgo)
						local fourbreak = R_PointToDist2(mo.x,mo.y,t.x,t.y)/8
						
						for nyachain = 1,16
						
							local dist = (fourbreak*nyachain)/FRACUNIT
							
							local cx = mo.x + dist*cos(mo.angle)
							local cy = mo.y + dist*sin(mo.angle)
							local cz = mo.z + FRACUNIT*96
							
							local br = P_SpawnMobj(cx,cy,cz,MT_GHOST)
							br.fuse = 30
							br.tics = -1
							br.scale = 1
							br.destscale = FRACUNIT*5
							br.scalespeed = (FRACUNIT*5)/30
							br.colorized = true
							br.color = SKINCOLOR_AQUA
							//br.sprite = SPR_STAB wh, why was this changed in vanilla SRB2P? 
							br.sprite = SPR_NTHK
							br.frame = B|FF_ADD
							
						end
						
						//Cam control
						
						CAM_stop(cam)
						cam.momz = 0 //Juuuuust in case...
						
						local ang = mo.angle + (ANG10*16)
					
						local dist = 256
						
						local cx = mo.x + dist*cos(ang)
						local cy = mo.y + dist*sin(ang)
						local cz = mo.z + FRACUNIT*96
						
						P_TeleportMove(cam,cx,cy,cz)
						
						cam.angle = R_PointToAngle2(cam.x,cam.y,tg[1].x,tg[1].y)
						
					end
					
					local dist = 64
					
					local nx = mo.x + dist*cos(mo.angle)
					local ny = mo.y + dist*sin(mo.angle)
					local nz = mo.z + FRACUNIT*16
					
					local gigavolt = P_SpawnMobj(nx,ny,nz,MT_WATERZAP)//hehe hehe hehe like Maxwell
					gigavolt.drawangle = P_RandomRange(1,360)*ANG1
					gigavolt.colorized = true
					gigavolt.color = SKINCOLOR_FOREST
					gigavolt.scale = FRACUNIT*7
					
					for zapping = 1,15

						
						local rx = nx + P_RandomRange(-96,96)*FRACUNIT
						local ry = ny + P_RandomRange(-96,96)*FRACUNIT
						local rz = nz + P_RandomRange(-8,128)*FRACUNIT
						
						local d = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
						
						local motg = R_PointToDist2(mo.x,mo.y,t.x,t.y)
						d.drawangle = P_RandomRange(1,360)*ANG1
						d.colorized = true
						d.color = SKINCOLOR_MINT
						local push = P_RandomRange(3,10)
						d.tics = push*4
						
						P_InstaThrust(d,mo.angle,motg/push)//this may be fucky for mo target but...
						
						
						
					end
					
					//now  beam attack
						
					local zorua = P_SpawnMobj(nx,ny,mo.floorz,MT_DUMMY)
					zorua.colorized = true
					zorua.color = SKINCOLOR_LIME
					zorua.drawangle = P_RandomRange(1,360)*ANG1
					zorua.scale = FRACUNIT*2
					zorua.sprite = SPR_MAGN
					zorua.frame = P_RandomRange(0,11)|FF_ADD|FF_TRANS30
					zorua.tics = -1
					zorua.fuse = 15
					local motg = R_PointToDist2(mo.x,mo.y,t.x,t.y)
					P_InstaThrust(zorua,mo.angle,motg/5)
					
					
				elseif timer == (beamgo + 55)
					if #ht > 0	--In case we select nothing
						for i = 1, #ht
							damageObject(ht[i])	--this should just hit everything highlighted
						end
					end
					playSound(mo.battlen, sfx_zio3)
				elseif timer == (beamgo + 95)
					return true
				end
			end
		end,
}

attackDefs["tr_gale_lance"] = {
	name = "Gale Lance",
	type = ATK_WIND,
	power = 140,
	accuracy = 90,
	costtype = CST_SP,
	cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	tr_castarea = 3,
	tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
	desc = "Orbal Art (Liberlian). \nMedium Wind Damage (Line L)",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		local avgx = 0
		local avgy = 0
		if not mo.tr_lockskill
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
		else
			avgx = mo.tr_cursorPos[1]
			avgy = mo.tr_cursorPos[2]
		end
			
		if timer == 1
			mo.oldangle = mo.angle

			mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)	
		end	
		if timer == 10
			S_StartSound(nil, sfx_gallan)
		end	
		
		if timer >= 10
		and timer <= 50
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*5
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
				localquake(mo.battlen, FRACUNIT*10, 10)
			end
		end	
		
		if timer >= 10
		and timer <= 50
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.sprite = SPR_SLAS
				d.color = SKINCOLOR_AETHER
				d.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				d.angle = mo.angle + ANG1*90
				d.scale = FRACUNIT*9
				d.tics = TICRATE/3
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
			end
		end	
		
		if timer == 40
		and #hittargets > 0
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
		
		if timer == 65 + 10*(#hittargets-1)
			return true
		end	
	end,
}

attackDefs["tr_aero_storm"] = {
		name = "Aero Storm",
		type = ATK_WIND,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 10,	
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 5,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art (Liberlian).\nMedium Wind Damage (Set Area L).".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
				-- average position of the enemies
			if timer < 20
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_LIME
				t.scale = 2*FRACUNIT
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
			end
			if timer == 15
				local dust = P_SpawnMobj(avgx,avgy,mo.floorz,MT_DUSTDEVIL)
				dust.scale = max((FRACUNIT/2)*#hittargets,(FRACUNIT/2)*3)
				mo.nado = dust
			end
			if mo.nado and mo.nado.valid
				summonAura(mo.nado, SKINCOLOR_EMERALD)
			end
			if timer > 15 and timer < 105
				for h = 1,#hittargets
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,(FRACUNIT*(timer))/5)
					end	
				end
				if not (leveltime%3)
					local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
					local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
					t.color = SKINCOLOR_LIME
					t.state = S_ROCKCRUMBLEA //maybe?
					t.scale = 2*FRACUNIT
					t.momz = (P_RandomRange(8,64)/2)*FRACUNIT
					t.fuse = 105
				end
			end
			if timer == 105
				mo.nado.fuse = 1
				mo.nado = nil
				if #hittargets > 0	--In case we select nothing
					for h = 1,#hittargets
						local target = hittargets[h]
						target.momz = (target.floorz - target.z)/15
						target.flags = $|MF_NOGRAVITY
					end
				end
			end
			if timer == 120
				if #hittargets > 0	--In case we select nothing
					for h = 1,#hittargets
						local target = hittargets[h]
						damageObject(target)
						target.flags = $ & !MF_NOGRAVITY
						if target.damagestate ~= DMG_MISS
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							P_SetObjectMomZ(target,FRACUNIT*10)
						end	
					end
				end
				playSound(mo.battlen, sfx_pstop)
				localquake(mo.battlen, FRACUNIT*32, 25)
			end
			if timer == 1
				playSound(mo.battlen, sfx_aersto)
			end	
			if timer == 155
				return true
			end
		end,
}


--"Heavy" Single


--"Heavy" Group


attackDefs["tr_plasma_wave"] = {
		name = "Plasma Wave",
		type = ATK_ELEC,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SILENCE,
		statuschance = 10,
		cost = 16,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art (Liberlian).\nHeavy Electric Damage (Set Line M).\n10% Silence chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			local hightick = 0
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local t = hittargets[i]
					local time = timer - (5*(i-1))
					local disttick = R_PointToDist2(mo.x, mo.y, t.x, t.y)/(32*FRACUNIT)
					if disttick > hightick then hightick = disttick end
					if time >= disttick+80 and time <= disttick+100
						local orb = P_SpawnMobj(t.x, t.y, t.z+20*FRACUNIT, MT_DUMMY)
						orb.sprite = SPR_DELK
						orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
						orb.color = SKINCOLOR_MAGENTA
						orb.blendmode = AST_ADD
						orb.renderflags = $|RF_FULLBRIGHT
						orb.destscale = FRACUNIT*10
						orb.scalespeed = FRACUNIT/3
						orb.tics = TICRATE/8
						
						for i = 1, 4
							local g = P_SpawnMobj(t.x+(FRACUNIT*P_RandomRange(-30, 30)), t.y+(FRACUNIT*P_RandomRange(-30, 30)), t.z+(FRACUNIT*P_RandomRange(0, 60)), MT_DUMMY)
							g.sprite = SPR_STAB
							g.frame = (i-1)|FF_FULLBRIGHT
							g.rollangle = timer*12*ANG1
							g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
							g.fuse = 2
							g.scale = FRACUNIT*2/i
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
							
							local g = P_SpawnMobj(t.x+(FRACUNIT*P_RandomRange(-30, 30)), t.y+(FRACUNIT*P_RandomRange(-30, 30)), t.z+(FRACUNIT*P_RandomRange(0, 60)), MT_DUMMY)
							g.sprite = SPR_STAB
							g.frame = (i-1)|FF_FULLBRIGHT
							g.rollangle = -timer*12*ANG1
							g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
							g.fuse = 2
							g.scale = FRACUNIT*2/i
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
						end
						
						if time == disttick+80
							playSound(mo.battlen, sfx_trzap)
						elseif time == disttick+100
							playSound(mo.battlen, sfx_eethit)
							damageObject(t)	--this should just hit everything highlighted
						end
					end
				end
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_trrzap)
				mo.bod = {}
				for i = 1, 30
				
					local angle = P_RandomRange(1, 360)*ANG1
					local dist = P_RandomRange(240, 360)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
						
					local s = P_SpawnMobj(x, y, mo.z+FRACUNIT*120, MT_DUMMY)
					s.frame = A
					s.color = SKINCOLOR_PINK
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.scale = FRACUNIT/5
					s.tics = 30	--these will die naturally on timer == 40
					s.dist = dist
					s.elev = P_RandomRange(80, 160)
					s.angle = angle
					mo.bod[#mo.bod+1] = s
				end
				
				mo.zap = P_SpawnMobj(mo.x, mo.y, mo.z+FRACUNIT*120, MT_THOK)
				mo.zap.state = S_INVISIBLE
				mo.zap.fuse = 110	--this will die naturally on timer == 120
				mo.zap.color = SKINCOLOR_MAGENTA
				mo.zap.scale = FRACUNIT/10
				mo.zap.destscale = FRACUNIT
				mo.zap.scalespeed = FRACUNIT/30
				mo.zap.blendmode = AST_ADD
				mo.zap.renderflags = $|RF_FULLBRIGHT
				mo.zap.flags = $|MF_NOGRAVITY
			end	
			
			if  timer >= 10 and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					
					s.angle = $+ ANG1*18
					if s.dist > 0
						s.dist = max(0, $-12)
					end
					if s.elev > 121
						s.elev = max(120, $-2)
					elseif s.elev < 119
						s.elev = min(120, $+2)
					elseif not s.elev == 120
						s.elev = 120
					end
					P_TeleportMove(s, mo.zap.x + s.dist *cos(s.angle), mo.zap.y + s.dist*sin(s.angle), mo.zap.floorz + s.elev*FRACUNIT)
					
					for t = 0, 1
						local g = P_SpawnGhostMobj(s)
						g.sprite = SPR_STAB
						g.frame = t|FF_FULLBRIGHT
						g.rollangle = i%2 and timer*12*ANG1 or -timer*12*ANG1
						g.color = t and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 1
						g.scale = s.scale
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
					end
				end
			end
			
			if mo.zap and mo.zap.valid
				if timer < 40
					for i = 1, 4
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+20*FRACUNIT, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 2
						g.scale = mo.zap.scale
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+20*FRACUNIT, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = -timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 2
						g.scale = mo.zap.scale
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
					end
				elseif timer == 40	--charge complete!
					playSound(mo.battlen, sfx_trpzap)
					local fire = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z, MT_THOK)
					fire.state = S_LZIO11
					fire.scale = mo.zap.scale*2
					fire.color = SKINCOLOR_MAGENTA
					fire.blendmode = AST_ADD
					fire.renderflags = $|RF_FULLBRIGHT
					for i = 1, 4
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+20*FRACUNIT, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 20
						g.scale = mo.zap.scale
						g.destscale = mo.zap.scale*5
						g.scalespeed = mo.zap.scale/5
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+20*FRACUNIT, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = -timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 20
						g.scale = mo.zap.scale
						g.destscale = mo.zap.scale*5
						g.scalespeed = mo.zap.scale/5
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
					end
				elseif timer >= 80 and not (timer%5)
					playSound(mo.battlen, sfx_zio2)	--placeholder
					
					local x, y = mo.zap.x, mo.zap.y
					x = $+P_RandomRange(-120, 120)*FRACUNIT
					y = $+P_RandomRange(-120, 120)*FRACUNIT
					for i = 1, 4
						local g = P_SpawnMobj(x, y, mo.zap.z+20*FRACUNIT, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 2
						g.scale = mo.zap.scale
						if timer > 80 then g.scale = $*4 end
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						
						local g = P_SpawnMobj(x, y, mo.zap.z+20*FRACUNIT, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = -timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 2
						g.scale = mo.zap.scale
						if timer > 80 then g.scale = $*4 end
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						
						local fire = P_SpawnMobj(x, y, mo.zap.z, MT_THOK)
						fire.state = S_LZIO11
						fire.scale = mo.zap.scale*4
						fire.spritexscale = FRACUNIT*2
						fire.color = SKINCOLOR_MAGENTA
						fire.blendmode = AST_ADD
						fire.renderflags = $|RF_FULLBRIGHT
					end
					for i = 1, 16
						local sb = P_SpawnMobj(x+(P_RandomRange(-20,20)*FRACUNIT), y+(P_RandomRange(-20,20)*FRACUNIT), mo.zap.floorz+(P_RandomRange(0,10)*FRACUNIT), MT_DUMMY)
						sb.state = S_CDUST1
						sb.color = leveltime%2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						sb.frame = $|FF_FULLBRIGHT
						sb.blendmode = AST_ADD
						sb.renderflags = $|RF_FULLBRIGHT
						sb.scale = FRACUNIT*P_RandomRange(4, 12)
						sb.momx = P_RandomRange(-12, 12)*FRACUNIT
						sb.momy = P_RandomRange(-12, 12)*FRACUNIT
						sb.momz = P_RandomRange(-4, 4)*FRACUNIT
						sb.tics = 16
					end
				end
			end
			
			
			if timer == 80
				playSound(mo.battlen, sfx_trpzap)
				mo.zap.angle = R_PointToAngle2(mo.zap.x, mo.zap.y, target.x, target.y)
				P_InstaThrust(mo.zap, mo.zap.angle, FRACUNIT*32)
			end	
			
			if timer == 111
				playSound(mo.battlen, sfx_elthr)
				localquake(mo.battlen, FRACUNIT*8, 8)
			end
			
			if timer == hightick+135
				mo.bod = nil
				mo.zap = nil
				return true
			end
		end,
}

attackDefs["tr_grand_stream"] = {
		name = "Grand Stream",
		type = ATK_WIND,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 18,
		tr_orbal = true,	--custom aura effect & sounds
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art (Liberlian).\nHeavy Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #targets
				avgx = $ + targets[i].x/FRACUNIT
				avgy = $ + targets[i].y/FRACUNIT
			end
			avgx = ($/#targets)	*FRACUNIT
			avgy = ($/#targets)	*FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_grastr)
			end	

			if timer > 20
			and timer < 110
			and leveltime%2 == 0
				local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*140, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*7
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end

			if timer >= 20 and timer <= 110
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-20, 20)*FRACUNIT, avgy + P_RandomRange(-20, 20)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_GREEN
					if timer%2 then thok.color = SKINCOLOR_MINT end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end

			if timer > 20
			and timer < 110
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 180
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_EMERALD
					aura.momz = P_RandomRange(2, 16)*FRACUNIT
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end		
			
			elseif timer == 111
				for i = 1, #hittargets
					local target = hittargets[i]
					playSound(mo.battlen, sfx_hit)
					damageObject(target)
				end
			elseif timer == 135
				for i = 1, #targets
					local target = targets[i]
					target.elec = nil
				end
				return true
			end

			for i = 1, #targets
				local target = targets[i]
				if target.elec
				and target.elec.valid
				and not (leveltime%2)
					target.elec.frame = P_RandomRange(A, L)
				end
			end
		end,
}

attackDefs["tr_ragna_vortex"] = {
		name = "Ragna Vortex",
		type = ATK_ELEC,
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		tr_orbal = true,	--custom aura effect & sounds
		status = COND_SILENCE,
		statuschance = 10,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art (Arcus series).\nHeavy Electric Damage to all enemies. \n10% Silence chance.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_YELLOW, SKINCOLOR_EMERALD, SKINCOLOR_MAGENTA}
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			local target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			target.state = S_INVISIBLE
			target.fuse = 2
			
			
			if timer == 1
				playSound(mo.battlen, sfx_ragvor)
			end	
			if timer == 5
				local dust = P_SpawnMobj(avgx, avgy, mo.floorz,MT_DUSTDEVIL)
				dust.scale = (FRACUNIT*1)*#hittargets
				mo.nado = dust
			end
			
			if timer > 1
			and timer < 80
			and leveltime%2 == 0
				local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*140, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*7
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end			

			if timer == 80
				lightningblast(target, SKINCOLOR_EMERALD, FRACUNIT*3)
			end	
			
			if timer == 82
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			if timer >= 83 and timer <= 170
				local bs = P_SpawnMobj(avgx + P_RandomRange(-120, 144)*FRACUNIT, avgy + P_RandomRange(-120, 144)*FRACUNIT, mo.z + P_RandomRange(0, 175)*FRACUNIT, MT_DUMMY)
				bs.state = S_TRSPARKLE1
				bs.color = colors[P_RandomRange(1, #colors)]
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				bs.scale = 15/4*FRACUNIT
				bs.destscale = 3/2*FRACUNIT
				localquake(mo.battlen, FRACUNIT*10, 10)
			end	
			
			if timer >= 83 and timer <= 170
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 180
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_EMERALD
					aura.momz = P_RandomRange(2, 16)*FRACUNIT
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end	
			end	
			
			if timer == 171
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
				mo.nado.fuse = 5
				mo.nado = nil
				
			elseif timer == 200
				return true
			end			
		end,			
}


--"Severe" Single


--"Severe" Group


attackDefs["tr_ragna_blast"] = {
		name = "Ragna Blast",
		type = ATK_ELEC,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SILENCE,
		statuschance = 10,
		cost = 40,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 2,
		tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art (Liberlian).\nSevere Electric Damage (Set Line M).\n10% Silence chance.".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target
			if not mo.tr_lockskill
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				target = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
				target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
				target.state = S_INVISIBLE
				target.fuse = 2
			end
			local hightick = 0
			
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local t = hittargets[i]
					local time = timer - (5*(i-1))
					local disttick = R_PointToDist2(mo.x, mo.y, t.x, t.y)/(32*FRACUNIT)
					if disttick > hightick then hightick = disttick end
					if time >= disttick+80 and time <= disttick+100
						local orb = P_SpawnMobj(t.x, t.y, t.z+20*FRACUNIT, MT_DUMMY)
						orb.sprite = SPR_DELK
						orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
						orb.color = SKINCOLOR_MAGENTA
						orb.blendmode = AST_ADD
						orb.renderflags = $|RF_FULLBRIGHT
						orb.destscale = FRACUNIT*10
						orb.scalespeed = FRACUNIT/3
						orb.tics = TICRATE/8
						
						for i = 1, 4
							local g = P_SpawnMobj(t.x+(FRACUNIT*P_RandomRange(-30, 30)), t.y+(FRACUNIT*P_RandomRange(-30, 30)), t.z+(FRACUNIT*P_RandomRange(0, 60)), MT_DUMMY)
							g.sprite = SPR_STAB
							g.frame = (i-1)|FF_FULLBRIGHT
							g.rollangle = timer*12*ANG1
							g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
							g.fuse = 2
							g.scale = FRACUNIT*2/i
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
							
							local g = P_SpawnMobj(t.x+(FRACUNIT*P_RandomRange(-30, 30)), t.y+(FRACUNIT*P_RandomRange(-30, 30)), t.z+(FRACUNIT*P_RandomRange(0, 60)), MT_DUMMY)
							g.sprite = SPR_STAB
							g.frame = (i-1)|FF_FULLBRIGHT
							g.rollangle = -timer*12*ANG1
							g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
							g.fuse = 2
							g.scale = FRACUNIT*2/i
							g.blendmode = AST_ADD
							g.renderflags = $|RF_FULLBRIGHT
						end
						
						if time == disttick+80
							playSound(mo.battlen, sfx_trzap)
						elseif time == disttick+100
							playSound(mo.battlen, sfx_eethit)
							damageObject(t)	--this should just hit everything highlighted
						end
					end
				end
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_trrzap)
				mo.bod = {}
				for i = 1, 30
				
					local angle = P_RandomRange(1, 360)*ANG1
					local dist = P_RandomRange(240, 360)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
						
					local s = P_SpawnMobj(x, y, mo.z+FRACUNIT*120, MT_DUMMY)
					s.frame = A
					s.color = SKINCOLOR_PINK
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.scale = FRACUNIT/10
					s.destscale = FRACUNIT
					s.scalespeed = FRACUNIT/20
					s.tics = 50	--these will die naturally on timer == 60
					s.dist = dist
					s.elev = P_RandomRange(80, 160)
					s.angle = angle
					mo.bod[#mo.bod+1] = s
				end
				
				mo.zap = P_SpawnMobj(mo.x, mo.y, mo.z+FRACUNIT*120, MT_THOK)
				mo.zap.frame = A
				mo.zap.tics = 110	--thiswill die naturally on timer == 120
				mo.zap.color = SKINCOLOR_MAGENTA
				mo.zap.scale = FRACUNIT/10
				mo.zap.destscale = FRACUNIT
				mo.zap.scalespeed = FRACUNIT/30
				mo.zap.blendmode = AST_ADD
				mo.zap.renderflags = $|RF_FULLBRIGHT
				mo.zap.flags = $|MF_NOGRAVITY
			end	
			
			if  timer >= 10 and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					
					
					if timer < 40	--swirl in to charge up the big zap
						s.angle = $+ ANG1*18
						if s.dist > 0
							s.dist = max(0, $-12)
						end
						if s.elev > 121
							s.elev = max(120, $-2)
						elseif s.elev < 119
							s.elev = min(120, $+2)
						elseif not s.elev == 120
							s.elev = 120
						end
					else	--disperse, the big zap is charged up!
						if s.dist > 0
							s.dist = $+24
							s.spritexscale = $+(FRACUNIT/2)
						end
						if not s.elev == 120
							s.elev = 120
						end
					end
					P_TeleportMove(s, mo.zap.x + s.dist *cos(s.angle), mo.zap.y + s.dist*sin(s.angle), mo.zap.floorz + s.elev*FRACUNIT)
					
					for t = 0, 1
						local g = P_SpawnGhostMobj(s)
						g.sprite = SPR_STAB
						g.frame = t|FF_FULLBRIGHT
						g.rollangle = i%2 and timer*12*ANG1 or -timer*12*ANG1
						g.color = t and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 1
						g.scale = s.scale
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
					end
				end
			end
			
			if mo.zap and mo.zap.valid
				if timer < 40	--charging
					local orb = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z+30*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_MAGENTA
					orb.blendmode = AST_ADD
					orb.renderflags = $|RF_FULLBRIGHT
					orb.destscale = mo.zap.scale*2
					orb.scalespeed = mo.zap.scale/4
					orb.tics = 4
				elseif timer == 40	--charge complete!
					playSound(mo.battlen, sfx_trlzip)
					local fire = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z, MT_THOK)
					fire.state = S_LZIO11
					fire.scale = mo.zap.scale*2
					fire.color = SKINCOLOR_MAGENTA
					fire.blendmode = AST_ADD
					fire.renderflags = $|RF_FULLBRIGHT
				else	--ball of energy now!
					for i = 1, 4
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 2
						g.scale = mo.zap.scale
						if timer > 80 then g.scale = $*4 end
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						
						local g = P_SpawnMobj(mo.zap.x, mo.zap.y, mo.zap.z, MT_DUMMY)
						g.sprite = SPR_STAB
						g.frame = (i-1)|FF_FULLBRIGHT
						g.rollangle = -timer*12*ANG1
						g.color = i > 2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
						g.fuse = 2
						g.scale = mo.zap.scale
						if timer > 80 then g.scale = $*4 end
						g.blendmode = AST_ADD
						g.renderflags = $|RF_FULLBRIGHT
						
						if timer > 80
							local fire = P_SpawnMobj(mo.zap.x + P_RandomRange(-100, 100)*FRACUNIT, mo.zap.y + P_RandomRange(-100, 100)*FRACUNIT, mo.zap.floorz, MT_THOK)
							fire.state = S_LZIO11
							fire.scale = mo.zap.scale*4
							fire.spritexscale = FRACUNIT*2
							fire.color = SKINCOLOR_MAGENTA
							fire.blendmode = AST_ADD
							fire.renderflags = $|RF_FULLBRIGHT
							
							for i = 1, 2
								local sb = P_SpawnMobj(x+(P_RandomRange(-40,40)*FRACUNIT), y+(P_RandomRange(-40,40)*FRACUNIT), mo.zap.floorz+(P_RandomRange(0,20)*FRACUNIT), MT_DUMMY)
								sb.state = S_CDUST1
								sb.color = leveltime%2 and SKINCOLOR_PINK or SKINCOLOR_MAGENTA
								sb.frame = $|FF_FULLBRIGHT
								sb.blendmode = AST_ADD
								sb.renderflags = $|RF_FULLBRIGHT
								sb.scale = FRACUNIT*P_RandomRange(4, 12)*2
								sb.momx = P_RandomRange(-24, 24)*FRACUNIT
								sb.momy = P_RandomRange(-24, 24)*FRACUNIT
								sb.momz = P_RandomRange(-8, 8)*FRACUNIT
								sb.tics = 12
							end
							
							if not (timer%15)
								lightningblast(mo.zap, SKINCOLOR_MAGENTA, FRACUNIT*3/2)
							end
						end
					end
				end
			end
			
			
			if timer == 80
				playSound(mo.battlen, sfx_ragblt)
				mo.zap.angle = R_PointToAngle2(mo.zap.x, mo.zap.y, target.x, target.y)
				P_InstaThrust(mo.zap, mo.zap.angle, FRACUNIT*32)
			end	
			
			if timer >= 80 and timer <= 100
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 120
				for i = 0, 12
					local angle = baseangle + i*6*ANG1
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z+i*FRACUNIT*2, MT_DUMMY)
					aura.state = S_BUFUDYNE_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_MAGENTA
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(10, 15)*FRACUNIT
					aura.scale = FRACUNIT*5
					aura.destscale = FRACUNIT*25
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(20, 40))
				end
			end	
			
			if timer == 111
				playSound(mo.battlen, sfx_elthr)
				localquake(mo.battlen, FRACUNIT*8, 8)
			end
			
			if timer == hightick+135
				mo.bod = nil
				mo.zap = nil
				return true
			end
		end,
}


--Support



attackDefs["tr_sylphen_wing"] = {
	name = "Sylphen Wing",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nRaises agility for one ally \nby one stage.",
	target = TGT_ALLY,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FOREST))
	end,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			playSound(mo.battlen, sfx_trsygr)	--placeholder
		end
		/*
		if timer == 20
			local m = P_SpawnMobj(target.x, target.y, target.z+120*FRACUNIT, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT/2
			--m.flags2 = $|MF2_SPLAT
			m.color = SKINCOLOR_MINT
		end	
		if timer >= 20 and timer < 79
			summonAura(target, SKINCOLOR_MINT)
		end		
		*/
		if timer >= 10 and timer <= 60
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 20
			for i = 0, 12
				local angle = baseangle + i*6*ANG1
				local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_MINT
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(2, 3)*FRACUNIT
				aura.scale = FRACUNIT*2/4
				aura.destscale = FRACUNIT*1
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
			end	
			
			local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
			thok.sprite = SPR_SUMN
			thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
			thok.momz = P_RandomRange(6, 16)*FRACUNIT
			thok.color = SKINCOLOR_MINT
			thok.blendmode = AST_ADD
			thok.renderflags = $|RF_FULLBRIGHT
			thok.tics = P_RandomRange(10, 35)
		end	
				
		for i = 1,#targets
			local target = hittargets[i]			
			if timer == 60 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_MINT
					dust.scale = FRACUNIT*2
				end
	
			
			elseif timer == 61 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "agi", BUFFSTEP)
			end	
		end	
		
		if timer == 75 + #targets*4
			return true
		end
	end,
}

attackDefs["tr_sylphen_guard"] = {	--placeholder sounds
	name = "Sylphen Guard",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
		tr_orbal = true,	--custom aura effect & sounds
	desc = "Orbal Art (Liberlian).\nRaises agility for one ally \nby two stages.",
	target = TGT_ALLY,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FOREST))
	end,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			playSound(mo.battlen, sfx_trsygr)	--placeholder
		end
		/*
		if timer == 20
			local m = P_SpawnMobj(target.x, target.y, target.z+120*FRACUNIT, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT/2
			--m.flags2 = $|MF2_SPLAT
			m.color = SKINCOLOR_MINT
		end	
		if timer >= 20 and timer < 79
			summonAura(target, SKINCOLOR_MINT)
		end		
		*/
		if timer >= 10 and timer <= 60
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 20
			for i = 0, 12
				local angle = baseangle + i*6*ANG1
				local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_MINT
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(2, 3)*FRACUNIT
				aura.scale = FRACUNIT*2/4
				aura.destscale = FRACUNIT*1
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
			end
			for i = 0, 4
				local angle = baseangle + i*24*ANG1
				local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
				--aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_MINT
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(12, 30)*FRACUNIT
				aura.scale = FRACUNIT/6
				--aura.destscale = FRACUNIT*1
				aura.fuse = 20
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 3))
			end
		end	
		
		for i = 1,#targets
			local target = hittargets[i]			
			if timer == 60 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_MINT
					dust.scale = FRACUNIT*2
				end
	
			
			elseif timer == 61 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "agi", BUFFSTEP*2)
			end	
		end	
		
		if timer == 75 + #targets*4
			return true
		end
	end,
}

attackDefs["tr_sylpharion"] = {	--placeholder sounds/sprites
	name = "Sylpharion",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 15,
	tr_orbal = true,	--custom aura effect & sounds
	tr_castarea = 2,
	desc = "Orbal Art (Liberlian).\nRaises agility for allies \nby two stages (Area S).",
	target = TGT_ALLALLIES,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FOREST))
	end,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy, avgz = 0, 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
			avgz = $ + targets[i].z/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT
		avgz = ($/#targets)	*FRACUNIT
		
		if timer == 10
			playSound(mo.battlen, sfx_trsyar)	-- bird appears sound
			
			mo.bod = P_SpawnMobj(avgx, avgy, avgz+FRACUNIT*240, MT_DUMMY)
			mo.bod.state = S_THOK
			mo.bod.tics = -1
			mo.bod.fuse = 171
			mo.bod.angle = ANG1*(timer%72)/2
			mo.bod.color = SKINCOLOR_MINT
			mo.bod.blendmode = AST_ADD
			mo.bod.renderflags = $|RF_FULLBRIGHT
			mo.bod.momz = P_RandomRange(-12, 12)*FRACUNIT
			mo.bod.scale = FRACUNIT*15
			mo.bod.dist = 360
			mo.bod.altitude = 240
			--we'll just steal the Kannon camera :)
			local cam = server.P_BattleStatus[mo.battlen].cam

			local x = cam.x - 380*cos(cam.angle)
			local y = cam.y - 380*sin(cam.angle)
			CAM_goto(cam, x, y, cam.z + FRACUNIT*120)
		end
		
		if timer >= 10 and timer < 180
		and mo.bod and mo.bod.valid
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 150
			for i = 0, 4
				local angle = baseangle + i*24*ANG1
				local x, y = mo.bod.x + dist*cos(angle), mo.bod.y + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, mo.bod.z+i*FRACUNIT*P_RandomRange(0, 150), MT_DUMMY)
				--aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_MINT
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(-18, 18)*FRACUNIT
				aura.scale = FRACUNIT
				--aura.destscale = FRACUNIT*1
				aura.fuse = 20
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 3))
			end
			if timer%2
				local g = P_SpawnGhostMobj(mo.bod)
				g.fuse = 8
				g.scalespeed = FRACUNIT*2
				g.detscale = FRACUNIT/5
			end
		end
		
		if timer >= 10 and timer < 60	--arrive
			mo.bod.angle = ANG1*(timer%60)*6
			mo.bod.dist = 780-(timer*6)
			mo.bod.altitude = 480-(timer*2)

			P_TeleportMove(mo.bod, avgx + mo.bod.dist *cos(mo.bod.angle-(ANG1*90)), avgy + mo.bod.dist*sin(mo.bod.angle-(ANG1*90)), avgz+(mo.bod.altitude*FRACUNIT))
		elseif timer >= 60 and timer < 150	--one lap around
			mo.bod.angle = ANG1*(timer%60)*6
			mo.bod.dist = 420
			mo.bod.altitude = 360

			P_TeleportMove(mo.bod, avgx + mo.bod.dist *cos(mo.bod.angle-(ANG1*90)), avgy + mo.bod.dist*sin(mo.bod.angle-(ANG1*90)), avgz+(mo.bod.altitude*FRACUNIT))
		elseif timer >= 150 and timer < 180	--dive
			mo.bod.angle = (ANG1*(timer%60)*6)-(ANG1*90)
			mo.bod.dist = 420-((timer-150)*14)
			mo.bod.altitude = 360-((timer-150)*12)
			
			P_TeleportMove(mo.bod, avgx + mo.bod.dist *cos(mo.bod.angle), avgy + mo.bod.dist*sin(mo.bod.angle), avgz+(mo.bod.altitude*FRACUNIT))
		end	
		
		if timer >= 180 and timer <= 240
			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 120
			for i = 0, 12
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, avgz+i*FRACUNIT*2, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_MINT
				aura.blendmode = AST_ADD
				aura.renderflags = $|RF_FULLBRIGHT
				aura.momz = P_RandomRange(10, 15)*FRACUNIT
				aura.scale = FRACUNIT*5
				aura.destscale = FRACUNIT*25
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(20, 40))
			end
		end	
		
		for i = 1,#targets
			local target = targets[i]			
			if timer == 240 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_MINT
					dust.scale = FRACUNIT*2
				end
	
			elseif timer == 181 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "agi", BUFFSTEP*2)
			end	
		end	
		
		if timer == 260 + #targets*4
			return true
		end
	end,
}


attackDefs["tr_recuria"] = {
		name = "Recuria",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 9,
		tr_orbal = true,	--custom aura effect & sounds
		tr_castarea = 5,	--1 is Area S/Line S, 2 is Area M/Line M, 3 is Area L/Line L
		desc = "Orbal Art (Enigma series).\nCures ailments (Area L)",
		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FOREST))
		end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}
			local avgx = 0
			local avgy = 0
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_recuri)
				S_StartSoundAtVolume(nil,sfx_recuri,70)
			end

			if timer >= 10 and timer <= 40
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[i]
					avgx = $+ t.x/FRACUNIT
					avgy = $+ t.y/FRACUNIT
					local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end	
			end	


			if timer >= 10 and timer <= 80
			and (timer%7) == 0
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				m.sprite = SPR_NTHK
				m.color = SKINCOLOR_LIME
				m.scale = FRACUNIT*7
				m.flags2 = $|MF2_SPLAT
				m.flags = MF_NOBLOCKMAP
				m.renderflags = $|RF_NOCOLORMAPS
				m.frame = A|FF_TRANS70
			end	

			if timer >= 10 and timer <= 60
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[i]
					avgx = $+ t.x/FRACUNIT
					avgy = $+ t.y/FRACUNIT
					local thok = P_SpawnMobj(t.x + P_RandomRange(-128, 128)*FRACUNIT, t.y + P_RandomRange(-128, 128)*FRACUNIT, t.z + P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_THOK
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_PERIDOT
					thok.fuse = 55 - timer
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT/2
				end	
			end



			if timer >= 10
			and timer <= 80
				local baseangle = P_RandomRange(1, 380)*ANG1
				local dist = 256
				for i = 1, 16
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
					aura.state = S_RECURIAAURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_MINT
					aura.momz = P_RandomRange(3, 5)*FRACUNIT
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
				end
			end


			for i = 1, #hittargets
				local target = hittargets[i]
				if timer == 70 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					if target.status_condition and target.status_condition < COND_HYPER
						cureStatus(target)
					end
					BTL_logMessage(hittargets[1].battlen, "Ailments cured")
				end
			end
			if timer == 90 + (#hittargets-1)*5
				return true
			end
		end,
}







