if not srb2p return end

DNG_Abilities["lloyd"] = {

    jfunc =     function(p)
                    local mo = p.mo

                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(50*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					mo.state = S_PLAY_FLOAT
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%3)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}

freeslot("sfx_lydhit", "sfx_lydchr", "sfx_courge", "sfx_lsheal", "sfx_rissun", "sfx_cutlyd", "sfx_scraft", 
"sfx_lroar", "sfx_ltchr", "sfx_bascp", "sfx_lorinf", "sfx_firbol", "sfx_rinwdj", "sfx_burhea", "sfx_cycnal",
"sfx_encour","sfx_tigch4")



sfxinfo[sfx_rissun].caption = "Rising Sun!" //Caption says this
sfxinfo[sfx_rissun].priority = "99999" //Make it high so NOTHING can interrupt this one

charStats["lloyd"] = {

		-- GENERAL

		name = "Lloyd",			-- This is only for bots / enemies
		basehp = 65,			-- base HP for level 1
		basesp = 50,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		--cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		tpmode = "craft points",
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_tigercharge_c", 1, 1}, {"tr_risingsun_c", 32, 2}, {"tr_tigercharge_c2", 60, 1}, {"tr_risingsun_c2", 72, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"elie", "tr_starblast_c", 25}, {"elie", "tr_starblast_c2", 50}, {"elie", "tr_starblast_c3", 75},
			}
			or {
				{"elie", "tr_starblast", 25}, {"elie", "tr_starblast_2", 50}, {"elie", "tr_starblast_3", 75},
		},
		
		persona = "lloydskillset",
		persona_pvp = "lloydpvpset",
		melee_natk = "tr_tonfas_m",	-- normal melee attack
		--melee_satk = "tr_tonfas_m", 
		
		supercolor_start = SKINCOLOR_SUPERLLOYD1,
		
		wep = "tr_striker",		-- default weapon.
		weptype = WPT_GENERICMELEE,	-- Equippable weapon type(s)

		atk = 45,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, B, C, D, E, F, G, 4, "SPR2_MLEL"},	-- attack
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_DASH"},	-- dash
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"}, // Rising
		anim_special4 =		{SPR_PLAY, G, 35, "SPR2_TRNS"}, // SUUUUUN
		anim_special5 =		{SPR_PLAY, A, 35, "SPR2_MLEE"},
		anim_special6 =		{SPR_PLAY, B, 35, "SPR2_TAL0"}, //Burning Heart
		anim_special7 =		{SPR_PLAY, C, 35, "SPR2_TAL0"},
		anim_special8 =		{SPR_PLAY, A, B, C, D, E, F, G, 2, "SPR2_MLEL"},	-- beat down
		
		vfx_summon = {"sfx_llsmn1", "sfx_llsmn2", "sfx_llsmn3", "sfx_llsmn4", "sfx_llsmn5"},
		vfx_skill = {"sfx_llskl1", "sfx_llskl2", "sfx_llskl3", "sfx_llskl4"},
		vfx_item = {"sfx_llitem"},
		vfx_hurt = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_hurtx = {"sfx_llxhr", "sfx_llxhr2"},
		vfx_die = {"sfx_lldie", "sfx_lldie2"},
		vfx_heal = {"sfx_llheal", "sfx_llhel2", "sfx_llhels"},
		vfx_healself = {"sfx_llhels"},
		vfx_kill = {"sfx_llkil1", "sfx_llkil2", "sfx_llkil3"},
		vfx_1more = {"sfx_ll1mor", "sfx_ll1mo"},
		vfx_crit = {"sfx_llcrt1", "sfx_llcrt2", "sfx_llcrt3", "sfx_llcrt4"},
		vfx_aoaask = {"sfx_llaoi1", "sfx_llaoi2", "sfx_llaoi3"},
		vfx_aoado = {"sfx_llaoa1", "sfx_llaoa2", "sfx_llaoa3", "sfx_llaoa4"},
		vfx_aoarelent = {"sfx_llaor1"},
		vfx_miss = {"sfx_llmis1", "sfx_llmis2", "sfx_llmis3"},
		vfx_dodge = {"sfx_lldog1", "sfx_lldog2", "sfx_lldog3"},
		vfx_win = {"sfx_llwin1", "sfx_llwin2", "sfx_llwin3", "sfx_llwin4"},
		vfx_levelup = {"sfx_llkil2", "sfx_lllevl", "sfx_lllev2"},
		vfx_tartarus_pit = {"sfx_llxhr2"},
		vfx_tartarus_item = {"sfx_lyelit"},
		vfx_tartarus_spring = {"sfx_lyspng"},
		vfx_tartarus_spike = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_tartarus_critspike = {"sfx_llxhr"},
		vfx_tartarus_spikepit = {"sfx_lympit"},

		icon = "H_LYDICO",	-- icon for net select and other menus
		hudbust = "H_LYDBAR",			-- patch to draw on the stat hud
		hudaoa = "H_LYDAOA",	-- patch for all out attack hud
		hudcutin = "LLYD_A",	-- cut in
		hudscutin = "LLYS_A",	-- super cut in
		aoa_quote = "Let's overcome this \nbarrier together!",

		tip = "The Leader of the CPD's Special Support Section. A powerful attack with physical and supporting crafts, backed by Fire and Earth arts aimed at inflicting ailments."
}
	
VFX_freeslotC("lloyd")
	
personaList["lloydskillset"] = {
		-- GENERAL
		name = "Lloyd",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 10,
		magic = 6,
		endurance = 7,
		luck = 10,
		agility = 7,
		stab = {ATK_FIRE,ATK_STRIKE},
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,
		skills = {
						
						{"tr_firebolt", 1}, {"tr_stun_break_c", 3}, --2 skills
						{"tr_tear", 7}, {"tr_axle_rush_c", 10},	--4 skills
						{"tr_stone_spike", 13}, {"tr_encourage_c", 16},	--6 skills
						{"tr_brave_smash_c", 17}, {"tr_magna_blaze", 20},	--8 skills
						
						{"tr_burning_heart_c", 23, "tr_firebolt"}, {"tr_teara", 25, "tr_tear"},
						{"tr_stun_break_c2", 29, "tr_stun_break_c"},
						{"tr_raging_spin_c", 31, "tr_axle_rush_c"},
						{"tr_petrify_breath", 33, "tr_stone_spike"},
						{"tr_extend_hearts_c", 36, "tr_encourage_c"},
						{"tr_brave_smash_c2", 40, "tr_brave_smash_c"},
						
						{"tr_stun_break_c3", 41, "tr_stun_break_c2"},
						{"tr_tearal", 45, "tr_teara"},
						{"tr_zero_breaker_c", 49, "tr_raging_spin_c"},
						{"tr_napalm_breath", 52, "tr_magna_blaze"},
						
						{"tr_brave_smash_c3", 55, "tr_brave_smash_c2"},
						{"tr_petrify_cloud", 59, "tr_petrify_breath"},
						{"tr_burning_heart_c2", 62, "tr_burning_heart_c"},
						--{"tigercharge", 66, "stun_break"}, //Zoraxua note - added this
						{"tr_tear-all", 66, "tr_tearal"},
						{"tr_crimson_ray", 75, "tr_napalm_breath"},
						{"tr_burning_heart_c3", 84, "tr_burning_heart_c2"}
						
					},
}

personaList["lloydpvpset"] = {
		-- GENERAL
		name = "Lloyd",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 10,
		magic = 6,
		endurance = 7,
		luck = 7,
		agility = 7,
		stab = {ATK_FIRE,ATK_STRIKE},
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,
		skills = {
						
						{"tr_firebolt", 1}, {"tr_stun_break_c", 3}, --2 skills
						{"tr_tear", 7}, {"tr_axle_rush_c", 10},	--4 skills
						{"tr_stone_spike", 13}, {"tr_encourage_c", 16},	--6 skills
						{"tr_brave_smash_c", 17}, {"tr_magna_blaze", 20},	--8 skills
						
						{"tr_burning_heart_c", 23, "tr_firebolt"}, {"tr_teara", 25, "tr_tear"},
						{"tr_stun_break_c2", 29, "tr_stun_break_c"},
						{"tr_raging_spin_c", 31, "tr_axle_rush_c"},
						{"tr_petrify_breath", 33, "tr_stone_spike"},
						{"tr_extend_hearts_c", 36, "tr_encourage_c"},
						{"tr_brave_smash_c2", 40, "tr_brave_smash_c"},
						
						{"tr_stun_break_c3", 41, "tr_stun_break_c2"},
						{"tr_tearal", 45, "tr_teara"},
						{"tr_zero_breaker_c", 49, "tr_raging_spin_c"},
						{"tr_napalm_breath", 52, "tr_magna_blaze"},
						
						{"tr_brave_smash_c3", 55, "tr_brave_smash_c2"},
						{"tr_petrify_cloud", 59, "tr_petrify_breath"},
						--{"tr_burning_heart_c2" or "tr_burning_heart_2", 62, "tr_burning_heart_c" or "tr_burning_heart"},
						--{"tigercharge", 66, "stun_break"}, //Zoraxua note - added this
						{"tr_tear-all", 66, "tr_tearal"},
						{"tr_crimson_ray", 75, "tr_napalm_breath"},
						--{"tr_burning_heart_c3" or "tr_burning_heart_3", 84, "tr_burning_heart_c2" or "tr_burning_heart_2"}
				},
}


-- Melee Attack


attackDefs["tr_tonfas_m"] = {
		name = "Tonfa Strikes",
		type = ATK_STRIKE,
		power = 20,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 0,
		critical = 2,
		physical = true,
		norandom = true,
		desc = "Light Strike damage to \none enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

					
			if timer == 10
				ANIM_set(mo, mo.anim_special1)
			elseif timer == 15
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_ORANGE
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_slash)

			elseif timer == 17
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_ORANGE

			elseif timer == 19
			or timer == 34

				if timer == 34 then damageObject(target) end
				playSound(mo.battlen, sfx_lydhit)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = B|FF_FULLBRIGHT
				if timer == 34 then s.frame = B|FF_FULLBRIGHT|FF_HORIZONTALFLIP end
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_ORANGE

			elseif timer == 59
				target.slashsprite = nil
				return true
			end
		end,
	}


-- Passives


attackDefs ["arts master"] = {
		name = "Arts Master",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_SLASH|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC|ATK_NUCLEAR|ATK_PSY|ATK_BLESS|ATK_CURSE|ATK_ALMIGHTY,
		desc = "Boosts damage by 120% - bless test",
		power = 120,
		passive = PSV_BOOST,
	}

local oneunder = (COND_HYPER - 1)//might help with custom status things like Bionis?

local function burningheartaura(mo)
    if mo and mo.valid and mo.hp and mo.hp >= 0
    and mo.burninghearttimer
        summonAura(mo, SKINCOLOR_SUPERORANGE4)
    end
end


addHook("MobjThinker", burningheartaura, MT_PFIGHTER)

attackDefs["tr_burning_heart_blocker"] = {
        name = "Burning Null",
        type = ATK_PASSIVE,
        desc = "Nullify odds of being inflicted status.\nHope it works!", 
        passive = PSV_COND_RESIST,
        power = 100,
        status = oneunder,
}

attackDefs["tr_burningheart_thinker"] = {
		name = "Burnt Out Heart",
		type = ATK_PASSIVE,
		implicit = "tr_burningheart_reset",
		passive = PSV_STARTTURN,
		nometronome = true,
		norandom = true,		
		desc = "Thinker for Burning Heart",
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				if not mo.burninghearttimer
					return true
				elseif mo.status_condition and mo.status_condition == (COND_HYPER or COND_SUPER)
					mo.burninghearttimer = 0 //Hyper Super cure it
					return true
				end
			end
			if timer > 1 and timer < 55
				if mo.burninghearttimer > 1
					if mo.burninghearttimer == 2
						BTL_logMessage(mo.battlen, mo.name.." will faint next turn!")
					else
						BTL_logMessage(mo.battlen, mo.name.."'s heart burns for "..(mo.burninghearttimer - 1).." more turns.")
					end
				elseif mo.burninghearttimer == 1
					if timer == 3
						cureStatus(mo)
						ANIM_set(mo, mo.anim_downloop, true)
						inflictStatus(mo,COND_SHOCK)
						
					end
					BTL_logMessage(mo.battlen, mo.name.."'s heart burned up!")
					
					local skill = "tr_burning_heart_blocker"
					//My poor little pawsies hurt from typing all day, thankfully most of this is just copypasta from rawsets I have
					
					local storenum = 0
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if storenum
						table.remove(mo.passiveskills,storenum)//Byeeee :3
					end
					
				end
			end
			if timer > 1 and timer <= 35 and mo.burninghearttimer ~= 1
				if not (leveltime%5)
					S_StartSound(nil, sfx_fire1) //sfx
				end
				for b = 1,3
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_SUPERORANGE4
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
			end
			if timer == 55
				mo.burninghearttimer = $ - 1
				return true
			end
		end,
	}

attackDefs["tr_burningheart_reset"] = {
		name = "Extinguished Heart",
		type = ATK_PASSIVE,
		nometronome = true,
		norandom = true,
		desc = "Reset Burning Heart timer on battle start",
		passive = PSV_STARTBATTLE,
		anim = function(mo, targets, hittargets, timer)
			dprint("Reset Burning Hearts timer for "..mo.name)
			mo.burninghearttimer = 0
		end,
	}

attackDefs["tr_burningheart_thinker_2"] = {
	name = "Burnt Out Heart 2",
	type = ATK_PASSIVE,
	implicit = "tr_burningheart_reset",
	passive = PSV_STARTTURN,
	nometronome = true,
	norandom = true,		
	desc = "Thinker for Burning Heart\n T W O",
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			if not mo.burninghearttimer
				return true
			elseif mo.status_condition and mo.status_condition >= (COND_HYPER)
				mo.burninghearttimer = 0 //Hyper Super cure it
				return true
			elseif mo.burninghearttimer ~= 1 //Okay heal
				local heals = (mo.maxhp*3)/50
				damageObject(mo,-heals,DMG_NORMAL,true)//Unaffected by De/Buffs or other PSVs
				playSound(mo.battlen, sfx_lsheal)
			end
		end
		if timer > 1 and timer < 55
			if mo.burninghearttimer > 1
				if mo.burninghearttimer == 2
					BTL_logMessage(mo.battlen, mo.name.." will faint next turn!")
				else
					BTL_logMessage(mo.battlen, mo.name.."'s heart burns for "..(mo.burninghearttimer - 1).." more turns.")
				end
			elseif mo.burninghearttimer == 1
				if timer == 3
					cureStatus(mo)
					ANIM_set(mo, mo.anim_downloop, true)
					inflictStatus(mo,COND_SHOCK)
					
				end
				BTL_logMessage(mo.battlen, mo.name.."'s heart burned up!")
				
				local skill = "tr_burning_heart_blocker"

				
				local storenum = 0
				
				if #mo.skills
					for i = 1,#mo.skills
					local x = mo.skills[i]
						if skill == x
							storenum = i
						end
					end
				end
				
				if #mo.passiveskills
					for i = 1,#mo.passiveskills
					local x = mo.passiveskills[i]
						if skill == x
							storenum = i
						end
					end
				end
				
				if storenum
					table.remove(mo.passiveskills,storenum)//Byeee
				end
				
			end
		end
		if timer > 1 and timer <= 35 and mo.burninghearttimer ~= 1
			if not (leveltime%5)
				S_StartSound(nil, sfx_fire1) //sfx
			end
			for b = 1,3
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
			end
		end
		if timer == 55
			mo.burninghearttimer = $ - 1
			return true
		end
	end,
}

-- Crafts--


--From Zero (lvl 1 - lvl 50)

--Zero Initial
attackDefs["tr_axle_rush"] = {
		name = "Axle Rush",
		type = ATK_STRIKE,
		power = 80,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 9,
		critical = 2,
		tr_castarea = 2,
		tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_APRICOT))
		end,
		desc = "Light Strike Damage with shockwaves \n(Set Area S)".."\x82".."\n   Custom 1 for Pos Mode.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 1	--menacingly approach the enemy
				mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
				ANIM_set(mo, mo.anim_move, true)
				mo.momx = (avgx - mo.x)/20
				mo.momy = (avgy - mo.y)/20
				--mo.momz = (target.z - mo.z)/20
			end
					
			if timer == 29
				mo.bod = {}
				ANIM_set(mo, mo.anim_guard, true)
				mo.angle_old = mo.angle
			end

			if timer >= 30 and timer <= 60	--charge up
			and mo.bod
				
				if timer == 30 then playSound(playSound(mo.battlen, sfx_ltchr)) end
				local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
				d.sprite = SPR_HOWL
				d.color = SKINCOLOR_SAPPHIRE
				d.colorized = true
				d.frame = (leveltime%3)|FF_FULLBRIGHT
				d.blendmode = AST_ADD
				d.renderflags = $|RF_FULLBRIGHT
				d.scale = mo.scale*2
				d.destscale = mo.scale/10
				d.scalespeed = mo.scale/5
				
				for i = 1, 3
					local h_angle = P_RandomRange(1, 359)*ANG1
					local v_angle = P_RandomRange(1, 359)*ANG1
					local dist = 256
					local spd = P_RandomRange(40, 50)

					local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
					local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
					local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_TEAL
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.scale = FRACUNIT
					s.destscale = FRACUNIT/10
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
				end
			end
			
			if timer == 80
			or timer == 90
				if timer == 80
					ANIM_set(mo, mo.anim_special1)
					playSound(mo.battlen, sfx_stabl1)
				end
				local dist = 64
				for i = 0, 59
					local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_ORANGE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
					aura.scale = FRACUNIT*3/2
					aura.destscale = FRACUNIT*6
					P_InstaThrust(aura, angle, FRACUNIT*9)
				end		
				local dist = 64
				for i = 0, 20
					local angle = mo.angle+(i*6*ANG1)-(60*ANG1)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_SAPPHIRE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
					aura.scale = FRACUNIT*3/2
					aura.destscale = FRACUNIT*6
					P_InstaThrust(aura, angle, FRACUNIT*27)
				end		
			end
			
			-- spawn said smoke:
			if timer >= 110 and timer <= 130
			and mo.bod

				for spin = 1, 2
					if spin == 1
						local dist = 64
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*9)
						end
						
						for i = 0, 5
							local angle = mo.angle-(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle + ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*8
							P_InstaThrust(aura, angle, FRACUNIT*12)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 130
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 110
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					local t = timer - 6*(i-1)

					if t == 115
						damageObject(target)
						if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
							P_InstaThrust(target, angle, FRACUNIT*20)
						end
					end
				end
			end
			
			if timer == 135 + (#hittargets-1)*6
				if Trails_Move then TR_MoveTo(mo) end
				return true
			end
		end,
	}

--Zero Level 6
attackDefs["tr_stun_break"] = {
			name = "Stun Break",
			type = ATK_STRIKE,
			power = 90,
			accuracy = 90,
			costtype = CST_HPPERCENT,
			cost = 7,
			status = COND_SHOCK,
			statuschance = 10,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YOGURT))
			end,
			desc = "Light Strike damage to one enemy, \nmay inflict Shock from high voltage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					playSound(mo.battlen, sfx_trzap)
					playSound(mo.battlen, sfx_s3k40)
				end	
				
				if timer >= 10 and timer <= 40
					local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_CYAN
					orb.destscale = FRACUNIT*7
					orb.scalespeed = FRACUNIT/4
					orb.tics = TICRATE/8
				end
				
				if timer >= 10 and timer <= 40
					local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.sprite = SPR_MAGN
					boom.colorized = true
					boom.color = SKINCOLOR_CYAN
					boom.frame = A|FF_TRANS70|FF_ANIMATE
					boom.tics = TICRATE/8
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_pstop)
					localquake(mo.battlen, 7*FRACUNIT, 5)
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
				
				if timer == 40
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					
				elseif timer == 60
					return true
				end
			end,
		}
		
--Zero level 15
		
attackDefs["tr_encourage"] = {
			name = "Encourage",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = 10,
			tr_castarea = 5,
			desc = "Encourages allies.\nRaises attack by 1 stage (Area M).",
			target = TGT_ALLALLIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE3))
			end,
			buff = true,
			anim = function(mo, targets, hittargets, timer)				
				if timer == 1
					mo.waves = {}
				end
					
				if timer >= 21 and timer <= 50
					if not (leveltime%6)
						local shit = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_GHOST)
						shit.sprite = SPR_NTHK
						shit.color = SKINCOLOR_ORANGE
						shit.scale = 1
						shit.flags2 = $|MF2_SPLAT
						shit.frame = B|FF_FULLBRIGHT|FF_ADD
						shit.tics = -1
						shit.fuse = 20
						table.insert(mo.waves,shit)	
					end	
					localquake(mo.battlen, FRACUNIT*8, 1)
				end				
					
				for i = 1,#targets
					local target = hittargets[i]				
					if timer == 50 + (i-1)*8
						playSound(mo.battlen, sfx_courge)
						VFX_Play(target, VFX_SUMMON)
						buffStat(target, "atk")
						summonAura(target, SKINCOLOR_ORANGE)
						for i = 1, 8
							local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(6, 16)*FRACUNIT
							thok.color = SKINCOLOR_ORANGE
							thok.tics = P_RandomRange(10, 20)
						end	
					end
				end	
				
				if timer == 10
					VFX_Play(mo, VFX_AOADO)
				end
					
				if timer == 20
					playSound(mo.battlen, sfx_encour)
					playSound(mo.battlen, sfx_encour)
				end				
				
				if mo.waves and #mo.waves
					local work = mo.waves
					for shit = 1,#work
						if work[shit] and work[shit].valid
							local fuck = work[shit]
							fuck.scale = $ + FRACUNIT
						end
					end
				end	
				if timer == 80 + (#targets-1)*8
					mo.waves = nil
					return true
				end		
			end,
	}

--Zero level 21
attackDefs["tr_brave_smash"] = {
			name = "Brave Smash",
			type = ATK_STRIKE,
			power = 80,
			accuracy = 90,
			critical = 2,
			target = TGT_ENEMY,
			costtype = CST_HPPERCENT,
			cost = 9,
			status = COND_SILENCE,
			statuschance = 35,
			norandom = true,
			norogue = true,		
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			tr_castarea = 3,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Light Strike damage to one enemy, \nHigh chance to inflict Silence (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--physical = true,	-- don't play the summoning anim for phys attacks, duh
			anim = 	function(mo, targets, hittargets, timer)
						local target
						if not mo.tr_lockskill
							target = hittargets[1]
						else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
							target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
							target.state = S_INVISIBLE
							target.fuse = 2
						end
						if timer == 1
							ANIM_set(mo, mo.anim_special2, true)
							mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

							local cx = target.x + 168*cos(target.angle + ANG1*20)
							local cy = target.y + 168*sin(target.angle + ANG1*20)
							CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
							CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
							S_StartSound(mo, sfx_msovd1)
						end

						local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						s.state =  	S_FLAMEDASH1
						P_InstaThrust(mo, mo.angle, FRACUNIT*60)

						if not mo.reachedtarget

							if mo.anim ~= mo.anim_special2
								ANIM_set(mo, mo.anim_special2, true)
							end

							mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

							if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

								if #hittargets > 0	--In case we select nothing
									for i = 1, #hittargets
										damageObject(hittargets[i])	--this should just hit everything highlighted
									end
								end
								playSound(mo.battlen, sfx_bkpoof)
								mo.reachedtarget = timer

								for i=1,24
									local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
									b.momx = P_RandomRange(-32, 32)*FRACUNIT
									b.momy = P_RandomRange(-32, 32)*FRACUNIT
									b.momz = P_RandomRange(4, 16)*FRACUNIT
									b.state = S_AOADUST1
									b.frame = A|FF_FULLBRIGHT
									b.scale = FRACUNIT*3
									b.destscale = FRACUNIT/12
								end
								for i = 1, 4
									createSplat(mo)
								end
							end
						else

							if timer - mo.reachedtarget > 40
								return true
							end
						end
					end,
	}

--Zero level 26
attackDefs["tr_burning_heart"] = {
			name = "Burning Heart",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = 22,
			desc = "Charges up the user.\nRaises attack,defense and \nagility by 1 stage.\nImmune to status temporarily",
			target = TGT_CASTER,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
			end,
			implicit = "tr_burningheart_thinker",
			superbuff = true,
			nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
							local target = targets[n]
							if target.buffs["atk"][1] >= 75
							and target.buffs["agi"][1] >= 75
							and target.buffs["def"][1] >= 75
								BTL_logMessage(targets[1].battlen, "You reached your limit.")
								return true
							end
						end,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					S_StartSound(nil, sfx_burhea)
					ANIM_set(mo, mo.anim_special6, true)
				elseif timer >= 10 and timer <= 125
					summonAura(mo, SKINCOLOR_SUPERORANGE4)
					localquake(mo.battlen, FRACUNIT*5, 10)
				end	

				if timer == 90
					ANIM_set(mo, mo.anim_special7, true)
					buffStat(target, "atk")
					buffStat(target, "def")
					buffStat(target, "agi")
					if not mo.burninghearttimer
						mo.burninghearttimer = 4
					end
					BTL_logMessage(targets[1].battlen, "Physical Attack up!\nDefense up!\nAgility up!\nTemporarily immune to status.")
					playSound(mo.battlen, sfx_buff)
					
					//For the immunity to work
					
					local skill = "tr_burning_heart_blocker"
					
					local check = false
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								check = true
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								check = true
							end
						end
					end
					
					if not check
						mo.passiveskills[#mo.passiveskills+1] = skill
					end
					
				end
				
				if timer == 70
				or timer == 80
					for i = 1,16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_SUPERORANGE4
						dust.scale = FRACUNIT*2
					end
				end	
				
				if timer > 90 and timer < 125
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_SUPERORANGE4
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
					localquake(mo.battlen, FRACUNIT*20, 10)
				end	
				
				if timer > 90 and timer < 125
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_SUPERORANGE4
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
					localquake(mo.battlen, FRACUNIT*20, 10)
				end	

				if timer == 145
					return true
				end
			end,
	}
	
--Zero story unlock, we can put it more around lvl 25
attackDefs["tr_extend_hearts"] = {
			name = "Extend Hearts",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = 36,
			desc = "Encourages allies with burning passion\nRaises Atk and Agi by 1 stage and \nrestores 15 TP/30 CP.",
			target = TGT_ALLALLIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT2"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE3))
			end,
			buff = true,
			anim = function(mo, targets, hittargets, timer)
					
					if timer == 1
						mo.waves = {}
					end
					
					if timer >= 21 and timer <= 50
						if not (leveltime%6)
							local shit = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_GHOST)
							shit.sprite = SPR_NTHK
							shit.color = SKINCOLOR_FLAME
							shit.scale = 1
							shit.flags2 = $|MF2_SPLAT
							shit.frame = B|FF_FULLBRIGHT|FF_ADD
							shit.tics = -1
							shit.fuse = 20
							table.insert(mo.waves,shit)	
						end	
						localquake(mo.battlen, FRACUNIT*8, 1)
					end		
					
				for i = 1,#targets
					local target = targets[i]								
					if timer == 51 + (i-1)*8
						playSound(mo.battlen, sfx_courge)
						VFX_Play(target, VFX_SUMMON)
						buffStat(target, "atk")
						buffStat(target, "agi")
						if target ~= mo	and C2SBarEdits --If it affected us, we could spam it for ever and ever.
							local tpheal = 15
							if (target.cpuse or (target.stats and charStats[target.stats].cpuse) or (target.enemy and enemyList[target.enemy].cpuse)) then tpheal = 30 end
							damageTP(target, -tpheal)
						end
						BTL_logMessage(targets[1].battlen, "Physical Attack up!\nAgility up!")
						summonAura(target, SKINCOLOR_FLAME)
						for i = 1, 8
							local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(6, 16)*FRACUNIT
							thok.color = SKINCOLOR_FLAME
							thok.tics = P_RandomRange(10, 20)
						end	
					end
				end	
				
				if timer == 10
					VFX_Play(mo, VFX_AOADO)
				end
					
				if timer == 20
					playSound(mo.battlen, sfx_encour)
					playSound(mo.battlen, sfx_encour)
				end				
				

				if timer == 80 + (#targets-1)*8
					mo.waves = nil
					return true
				end
				if mo.waves and #mo.waves
					local work = mo.waves
					for shit = 1,#work
						if work[shit] and work[shit].valid
							local fuck = work[shit]
							fuck.scale = $ + FRACUNIT
						end
					end
				end			
			end,
	}

--To Azure (lvl 50 - lvl 100+
	
--Azure level 54
attackDefs["tr_stun_break_2"] = {
			name = "Stun Break 2",
			type = ATK_STRIKE,
			power = 280,
			accuracy = 90,
			costtype = CST_HPPERCENT,
			cost = 11,
			status = COND_SHOCK,
			statuschance = 20,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YOGURT))
			end,
			desc = "Medium Strike damage to one enemy, \nmay inflict Shock from high voltage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					playSound(mo.battlen, sfx_trzap)
					playSound(mo.battlen, sfx_s3k40)
				end	
				
				if timer >= 10 and timer <= 40
					local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_CYAN
					orb.destscale = FRACUNIT*7
					orb.scalespeed = FRACUNIT/4
					orb.tics = TICRATE/8
				end
				
				if timer >= 10 and timer <= 40
					local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.sprite = SPR_MAGN
					boom.colorized = true
					boom.color = SKINCOLOR_CYAN
					boom.frame = A|FF_TRANS70|FF_ANIMATE
					boom.tics = TICRATE/8
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_pstop)
					localquake(mo.battlen, 7*FRACUNIT, 5)
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
				
				if timer == 40
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					
				elseif timer == 60
					return true
				end
			end,
		}
		
--Azure level 54
attackDefs["tr_raging_spin"] = {
			name = "Raging Spin",
			type = ATK_STRIKE,
			power = 200,
			accuracy = 90,
			costtype = CST_HPPERCENT,
			cost = 11,
			critical = 5,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Medium Damage to all enemies with \nstrong shockwaves (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_PEACHY))
			end,
			anim = function(mo, targets, hittargets, timer)

		local avgx = 0
		local avgy = 0
		if not mo.tr_lockskill
			for i = 1, #hittargets do
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = $ / #hittargets *FRACUNIT
			avgy = $ / #hittargets *FRACUNIT
		else
			avgx = mo.tr_cursorPos[1]
			avgy = mo.tr_cursorPos[2]
		end
		
		if timer == 1	--menacingly approach the enemy
			mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
			ANIM_set(mo, mo.anim_move, true)
			mo.momx = (avgx - mo.x)/20
			mo.momy = (avgy - mo.y)/20
			--mo.momz = (target.z - mo.z)/20
		end
				
		if timer == 29
			mo.bod = {}
			ANIM_set(mo, mo.anim_special1)
			mo.angle_old = mo.angle
		end

		if timer >= 30 and timer <= 44	--vortex
		and mo.bod

			if timer == 30 then playSound(mo.battlen, sfx_stabl1) end
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					local angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
					P_InstaThrust(target, angle, FRACUNIT*2)
				end
			end
			for spin = 1, 2
				if spin == 1
					local dist = 480
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WAVE
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, -FRACUNIT*6)
					end
					dist = 160
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_SLATE
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/4
						aura.destscale = FRACUNIT*3
						P_InstaThrust(aura, angle, -FRACUNIT*3)
					end
				end
				local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
				s.sprite = SPR_DELK
				s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				s.colorized = true
				s.color = SKINCOLOR_VAPOR
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle+90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.fuse = 40
				s.tics = 40
				
				local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
				s.sprite = SPR_DELK
				s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				s.colorized = true
				s.color = SKINCOLOR_ICY
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle-90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.fuse = 40
				s.tics = 40
			end
			
		end

		-- spawn said smoke:
		if timer >= 60 and timer <= 80
		and mo.bod
			if timer == 60
				 playSound(mo.battlen, sfx_stabl1)
			end

			for spin = 1, 2
				if spin == 1
					local dist = 64
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_ORANGE
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*9)
					end
					
					for i = 0, 5
						local angle = mo.angle-(i*6*ANG1)+(180*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle + ANGLE_90
						aura.color = SKINCOLOR_FLAME
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*8
						P_InstaThrust(aura, angle, FRACUNIT*12)
					end
				end
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle+90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_FLAME
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle-90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
			end
			
			if timer == 80
				mo.angle = mo.angle_old
				mo.angle_old = nil
			end
		end

			-- rotate the flames
		if timer >= 60
		and mo.bod and #mo.bod
			for i = 1, #mo.bod do
				local s = mo.bod[i]
				if not s or not s.valid continue end	-- don't care

				s.angle = $+ ANG1*18
				--s.dist = min(256, $+16)

				P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
			end
		end
		
		-- hit targets
		if #hittargets > 0	--In case we select nothing
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == 65
					damageObject(target)
					if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						P_InstaThrust(target, angle, FRACUNIT*20)
					end
				end
			end
		end
		
		if timer == 105 + (#hittargets-1)*6
			if Trails_Move then TR_MoveTo(mo) end
			return true
		end
	end,
}

--Azure level 80
attackDefs["tr_brave_smash_2"] = {
			name = "Brave Smash 2",
			type = ATK_STRIKE,
			power = 240,
			accuracy = 95,
			critical = 2,
			target = TGT_ENEMY,
			costtype = CST_HPPERCENT,
			cost = 11,
			status = COND_SILENCE,
			statuschance = 35,
			norandom = true,
			norogue = true,		
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			tr_castarea = 3,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Medium Strike damage to one enemy, \nHigh chance to inflict Silence (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--physical = true,	-- don't play the summoning anim for phys attacks, duh
			anim = 	function(mo, targets, hittargets, timer)
						local target
						if not mo.tr_lockskill
							target = hittargets[1]
						else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
							target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
							target.state = S_INVISIBLE
							target.fuse = 2
						end
						if timer == 1
							ANIM_set(mo, mo.anim_special2, true)
							mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

							local cx = target.x + 168*cos(target.angle + ANG1*20)
							local cy = target.y + 168*sin(target.angle + ANG1*20)
							CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
							CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
							S_StartSound(mo, sfx_msovd1)
						end

						local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						s.state =  	S_FLAMEDASH1
						P_InstaThrust(mo, mo.angle, FRACUNIT*60)

						if not mo.reachedtarget

							if mo.anim ~= mo.anim_special2
								ANIM_set(mo, mo.anim_special2, true)
							end

							mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

							if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

								if #hittargets > 0	--In case we select nothing
									for i = 1, #hittargets
										damageObject(hittargets[i])	--this should just hit everything highlighted
									end
								end
								playSound(mo.battlen, sfx_bkpoof)
								mo.reachedtarget = timer

								for i=1,24
									local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
									b.momx = P_RandomRange(-32, 32)*FRACUNIT
									b.momy = P_RandomRange(-32, 32)*FRACUNIT
									b.momz = P_RandomRange(4, 16)*FRACUNIT
									b.state = S_AOADUST1
									b.frame = A|FF_FULLBRIGHT
									b.scale = FRACUNIT*3
									b.destscale = FRACUNIT/12
								end
								for i = 1, 4
									createSplat(mo)
								end
							end
						else

							if timer - mo.reachedtarget > 40
								return true
							end
						end
					end,
	}

--Azure level 103
attackDefs["tr_burning_heart_2"] = {
		name = "Burning Heart 2",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 44,
		desc = "Charges up the user.\nRaises atk, def and agi by 1 stage.\nBecome status-immune during, and recover 6% HP every turn.\nBe warned, you'll need to rest after 3 turns.",
		target = TGT_CASTER,
		overrideicon = "TR_CRAFT",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
		end,	
		implicit = "tr_burningheart_thinker_2",
		superbuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
		end,	
		nocast = 	function(targets, n, mo)
			if mo.burninghearttimer
				BTL_logMessage(mo.battlen, "Your heart is still burning!")
				return true
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				S_StartSound(nil, sfx_burhea)
				ANIM_set(mo, mo.anim_special6, true)
			elseif timer >= 10 and timer <= 125
				summonAura(mo, SKINCOLOR_SUPERORANGE4)
				localquake(mo.battlen, FRACUNIT*5, 10)
			end	

			if timer == 90
				if mo.status_condition and (mo.status_condition < COND_HYPER) then cureStatus(mo) end
				ANIM_set(mo, mo.anim_special7, true)
				buffStat(target, "atk")
				buffStat(target, "def")
				buffStat(target, "agi")
				if not mo.burninghearttimer
					mo.burninghearttimer = 4
				end
				BTL_logMessage(mo.battlen, "Physical Attack, Defense and Agility up!\nAilments cured!\nTemporarily immune to status.")

				playSound(mo.battlen, sfx_buff)
				
				//For the immunity to work
				
				local skill = "tr_burning_heart_blocker"
				
				local check = false
				
				if #mo.skills
					for i = 1,#mo.skills
					local x = mo.skills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if #mo.passiveskills
					for i = 1,#mo.passiveskills
					local x = mo.passiveskills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if not check
					table.insert(mo.passiveskills,skill)
				end
				
			end
			
			if timer == 70
			or timer == 80
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SUPERORANGE4
					dust.scale = FRACUNIT*2
				end
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	

			if timer == 145
				return true
			end
		end,
	}

--no origin
attackDefs["tr_stun_break_3"] = {
			name = "Stun Break 3",
			type = ATK_STRIKE,
			power = 540,
			accuracy = 90,
			costtype = CST_HPPERCENT,
			cost = 14,
			status = COND_SHOCK,
			statuschance = 25,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YOGURT))
			end,
			desc = "Heavy Strike damage to one enemy, \nmay inflict Shock from high voltage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					playSound(mo.battlen, sfx_trzap)
					playSound(mo.battlen, sfx_s3k40)
				end	
				
				if timer >= 10 and timer <= 40
					local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_CYAN
					orb.destscale = FRACUNIT*7
					orb.scalespeed = FRACUNIT/4
					orb.tics = TICRATE/8
				end
				
				if timer >= 10 and timer <= 40
					local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.sprite = SPR_MAGN
					boom.colorized = true
					boom.color = SKINCOLOR_CYAN
					boom.frame = A|FF_TRANS70|FF_ANIMATE
					boom.tics = TICRATE/8
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_pstop)
					localquake(mo.battlen, 7*FRACUNIT, 5)
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
				
				if timer == 40
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					
				elseif timer == 60
					return true
				end
			end,
		}
		
--Coldsteel 4 Initial
attackDefs["tr_zero_breaker"] = {
			name = "Zero Breaker",
			type = ATK_STRIKE,
			power = 460,
			accuracy = 95,
			costtype = CST_HPPERCENT,
			cost = 24,
			critical = 3,
			tr_castarea = 3,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Heavy Strike Damage with powerful shockwaves, \nreduces enemy defense (Set Area M).",
			target = TGT_ALLENEMIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
			end,
			anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 1	--menacingly approach the enemy
				mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
				ANIM_set(mo, mo.anim_move, true)
				mo.momx = (avgx - mo.x)/20
				mo.momy = (avgy - mo.y)/20
				--mo.momz = (target.z - mo.z)/20
			end
					
			if timer == 29
				mo.bod = {}
				ANIM_set(mo, mo.anim_special1)
				mo.angle_old = mo.angle
			end

			if timer >= 30 and timer <= 44	--vortex
			and mo.bod

				if timer == 30 then playSound(mo.battlen, sfx_stabl1) end
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						local target = hittargets[i]
						local angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
						P_InstaThrust(target, angle, FRACUNIT*2)
					end
				end
				for spin = 1, 2
					if spin == 1
						local dist = 480
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, -FRACUNIT*6)
						end
						dist = 160
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/4
							aura.destscale = FRACUNIT*3
							P_InstaThrust(aura, angle, -FRACUNIT*3)
						end
					end
					local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.colorized = true
					s.color = SKINCOLOR_VAPOR
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.fuse = 40
					s.tics = 40
					
					local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.colorized = true
					s.color = SKINCOLOR_ICY
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.fuse = 40
					s.tics = 40
				end
				
			end

			-- spawn said smoke:
			if timer >= 60 and timer <= 80
			and mo.bod
				if timer == 60
					 playSound(mo.battlen, sfx_stabl1)
				end

				for spin = 1, 2
					if spin == 1
						local dist = 64
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*9)
						end
						
						for i = 0, 5
							local angle = mo.angle-(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle + ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*8
							P_InstaThrust(aura, angle, FRACUNIT*12)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 80
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 60
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					local t = timer - 6*(i-1)

					if t == 65
						damageObject(target)
						if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							buffStat(target, "def", -BUFFSTEP)	-- negative values lower a stat
							local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
							P_InstaThrust(target, angle, FRACUNIT*20)
						end
					end
				end
			end
			
			if timer == 105 + (#hittargets-1)*6
				if Trails_Move then TR_MoveTo(mo) end
				return true
			end
		end,
	}

--Reverie
attackDefs["tr_brave_smash_3"] = {
			name = "Brave Smash 3",
			type = ATK_STRIKE,
			power = 480,
			accuracy = 95,
			critical = 2,
			target = TGT_ENEMY,
			costtype = CST_HPPERCENT,
			cost = 13,
			status = COND_SILENCE,
			statuschance = 35,
			norandom = true,
			norogue = true,		
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			tr_castarea = 3,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Heavy Strike damage to one enemy, \nHigh chance to inflict Silence (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--physical = true,	-- don't play the summoning anim for phys attacks, duh
			anim = 	function(mo, targets, hittargets, timer)
						local target
						if not mo.tr_lockskill
							target = hittargets[1]
						else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
							target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
							target.state = S_INVISIBLE
							target.fuse = 2
						end
						if timer == 1
							ANIM_set(mo, mo.anim_special2, true)
							mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

							local cx = target.x + 168*cos(target.angle + ANG1*20)
							local cy = target.y + 168*sin(target.angle + ANG1*20)
							CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
							CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
							S_StartSound(mo, sfx_msovd1)
						end

						local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						s.state =  	S_FLAMEDASH1
						P_InstaThrust(mo, mo.angle, FRACUNIT*60)

						if not mo.reachedtarget

							if mo.anim ~= mo.anim_special2
								ANIM_set(mo, mo.anim_special2, true)
							end

							mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

							if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

								if #hittargets > 0	--In case we select nothing
									for i = 1, #hittargets
										damageObject(hittargets[i])	--this should just hit everything highlighted
									end
								end
								playSound(mo.battlen, sfx_bkpoof)
								mo.reachedtarget = timer

								for i=1,24
									local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
									b.momx = P_RandomRange(-32, 32)*FRACUNIT
									b.momy = P_RandomRange(-32, 32)*FRACUNIT
									b.momz = P_RandomRange(4, 16)*FRACUNIT
									b.state = S_AOADUST1
									b.frame = A|FF_FULLBRIGHT
									b.scale = FRACUNIT*3
									b.destscale = FRACUNIT/12
								end
								for i = 1, 4
									createSplat(mo)
								end
							end
						else

							if timer - mo.reachedtarget > 40
								return true
							end
						end
					end,
	}

--Coldsteel 4 Initial
attackDefs["tr_burning_heart_3"] = {
		name = "Burning Heart 3",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 66,
		desc = "Charges up the user.\nClears Debuffs, then raises atk, def and agi.\nBecome status-immune and heal 6% HP each turn.",
		target = TGT_CASTER,
		overrideicon = "TR_CRAFT",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
		end,	
		implicit = "tr_burningheart_thinker_2",
		superbuff = true,
		nocast = 	function(targets, n, mo)
			if mo.burninghearttimer
				BTL_logMessage(mo.battlen, "Your heart is still burning!")
				return true
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				S_StartSound(nil, sfx_burhea)
				ANIM_set(mo, mo.anim_special6, true)
			elseif timer >= 10 and timer <= 125
				summonAura(mo, SKINCOLOR_SUPERORANGE4)
				localquake(mo.battlen, FRACUNIT*5, 10)
			end	

			if timer == 90
				if mo.status_condition and (mo.status_condition < COND_HYPER) then cureStatus(mo) end //WOOOOOO STATUS CUUUUUUUUUUURE
				
				ANIM_set(mo, mo.anim_special7, true)
				
				local strs = {"atk", "mag", "def", "agi", "crit"}
				
				for j = 1, #strs
					local s = strs[j]
					if mo.buffs[s][1] < 0
						mo.buffs[s][1] = 0
						mo.buffs[s][2] = 0
					end
				end
				
				//Rad, NOW... we can buff
				
				buffStat(target, "atk")
				buffStat(target, "def")
				buffStat(target, "agi")
				if not mo.burninghearttimer
					mo.burninghearttimer = 4
				end
				BTL_logMessage(mo.battlen, "Physical Attack, Defense and Agility up!\nDebuffs and Ailments cured!\nTemporarily immune to status.")
				playSound(mo.battlen, sfx_buff)
				
				//For the immunity to work
				
				local skill = "tr_burning_heart_blocker"
				
				local check = false
				
				if #mo.skills
					for i = 1,#mo.skills
					local x = mo.skills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if #mo.passiveskills
					for i = 1,#mo.passiveskills
					local x = mo.passiveskills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if not check
					table.insert(mo.passiveskills,skill)
				end
				
			end
			
			if timer == 70
			or timer == 80
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SUPERORANGE4
					dust.scale = FRACUNIT*2
				end
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	

			if timer == 145
				return true
			end
		end,
	}

-- S-Crafts

--Zero Initial
attackDefs["tr_tigercharge"] = { //Zoraxua be tired but im fukin bALLIN' 
			name = "Tiger Charge", 
			type = ATK_STRIKE,
			power = 680, 
			accuracy = 100,
			status = COND_SILENCE,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_LYDAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			statuschance = 15,
			costtype = CST_HPPERCENT,
			cost = 22,
			nometronome = true,
			norandom = true,
			norogue = true,	
			critical = 5, //Thats 1 in 3 almost (!wow!)
			desc = "Charges like a tiger into an enemy\ncausing Severe Strike Damage\nHigh chance of Silence",
			target = TGT_ENEMY,
			norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
			end,
			anim_norepel = true,
			--noenemycast = true,	--Should be enemy safe now.
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_cutlyd)
					playSound(mo.battlen, sfx_llsmn4)	--"right!"
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 15	--ready up
					ANIM_set(mo, mo.anim_guard, true)
				end
				if timer == 30	--"let's go!"
					playSound(mo.battlen, sfx_llsmn3)
				end
				
				if timer == 45	--dash towards the enemy
					ANIM_set(mo, mo.anim_special2, true)
					mo.momx = (target.x - mo.x)/10
					mo.momy = (target.y - mo.y)/10
				end
				
				if timer >= 70 and timer <= 320	--beat them up!
					if timer == 70
						ANIM_set(mo, mo.anim_stand, true)
						P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.floorz)	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						playSound(mo.battlen, sfx_llaoa3)	--placeholder for his yell
					end
					
					if timer >= 85 and timer < 180
						if timer == 85
							ANIM_set(mo, mo.anim_special8, true)
						end
						if timer%5 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer == 180	--leap back
						ANIM_set(mo, mo.anim_aoa_end, true)
						playSound(mo.battlen, sfx_tigch4)	--TIGER... CHARGE!
						mo.momx = (target.x - mo.x)/8
						mo.momy = (target.y - mo.y)/8
						mo.momz = 5*FRACUNIT
						mo.momx = $*-2
						mo.momy = $*-2
					end
					if timer > 180 and timer <= 270
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					end
					if timer == 200	--ready...
						ANIM_set(mo, mo.anim_special5, true)
						playSound(mo.battlen, sfx_ltchr)
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
					end
					if timer > 200 and timer <= 220
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = (leveltime%3)|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.scale = mo.scale*10
						d.destscale = mo.scale/2
						d.scalespeed = mo.scale
						
						for i = 1, 3
							local h_angle = P_RandomRange(1, 359)*ANG1
							local v_angle = P_RandomRange(1, 359)*ANG1
							local dist = 256
							local spd = P_RandomRange(40, 50)

							local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
							local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
							local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

							local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.target = target
							s.tics = 10
							s.momx = (mo.x - s.x)/10
							s.momy = (mo.y - s.y)/10
							s.momz = (mo.z - s.z)/10
						end
					end
					if timer == 235	--CHARGE!!
						playSound(mo.battlen, sfx_lroar)
						ANIM_set(mo, mo.anim_special2, true)
						mo.momx = (target.x - mo.x)/10
						mo.momy = (target.y - mo.y)/10
					end
					if timer > 235 and timer <= 240
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = A|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*5
						d.destscale = mo.scale/4
						d.scalespeed = mo.scale/2
						P_InstaThrust(d, d.angle, FRACUNIT*8)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 5
							s.momx = FRACUNIT*P_RandomRange(-16, 16)
							s.momy = FRACUNIT*P_RandomRange(-16, 16)
							s.momz = FRACUNIT*P_RandomRange(-16, 16)
						end
					end
					if timer == 240	--slow motion
						mo.momx = (target.x - mo.x)/40
						mo.momy = (target.y - mo.y)/40
					end
					if timer > 240 and timer <= 270
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = A|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*5
						d.destscale = mo.scale/4
						d.scalespeed = mo.scale/8
						P_InstaThrust(d, d.angle, FRACUNIT*2)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z+(FRACUNIT*16), MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 20
							s.momx = FRACUNIT*P_RandomRange(-4, 4)
							s.momy = FRACUNIT*P_RandomRange(-4, 4)
							s.momz = FRACUNIT*P_RandomRange(-4, 4)
						end
					end
					if timer == 270	--speed back up
						mo.momx = (target.x - mo.x)
						mo.momy = (target.y - mo.y)
						P_TeleportMove(cam, target.x + 256 *cos(mo.angle+(90*ANG1)), target.y + 256*sin(mo.angle+(90*ANG1)), target.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
					end
					if timer > 270 and timer <= 300
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = B|FF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*10
						d.destscale = mo.scale/2
						d.scalespeed = mo.scale/4
						P_InstaThrust(d, d.angle, FRACUNIT/2)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 5
							s.momx = FRACUNIT*P_RandomRange(-16, 16)
							s.momy = FRACUNIT*P_RandomRange(-16, 16)
							s.momz = FRACUNIT*P_RandomRange(-16, 16)
						end
					end
					
					if timer == 280	--Kablam!!
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_GOLD
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*4
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						for i = 1, 10 do
							local ol = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*90, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_SAPPHIRE
							ol.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ol.scale = FRACUNIT+(FRACUNIT*i/10)
							ol.scalespeed = FRACUNIT+(FRACUNIT*i/10)*5
							ol.destscale = FRACUNIT*150+(FRACUNIT*i*15)
							ol.flags2 = $|MF2_SPLAT
							ol.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT
							ol.tics = 35
							ol.momz = FRACUNIT*10
						end
						
						damageObject(target)
					end
					if timer > 280 and timer <= 320
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = leveltime%2 and SKINCOLOR_SAPPHIRE or SKINCOLOR_GOLD
						d.colorized = true
						d.frame = (leveltime%3)|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.scale = mo.scale/2
						d.destscale = mo.scale*10
						d.scalespeed = mo.scale
					end
				end

				if timer == 330
					mo.hudcharx = nil
					return true
				end
			end,
	}
	


--bar edits crafts

--From Zero (lvl 1 - lvl 50)
	
	--Zero Initial
	attackDefs["tr_axle_rush_c"] = {
			name = "Axle Rush",
			type = ATK_STRIKE,
			power = 80,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 9,
			strengthoverride = true,
			forcetp = true,
			critical = 2,
			tr_castarea = 2,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_APRICOT))
			end,
			desc = "Light Strike Damage with shockwaves \n(Set Area S)".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 1	--menacingly approach the enemy
				mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
				ANIM_set(mo, mo.anim_move, true)
				mo.momx = (avgx - mo.x)/20
				mo.momy = (avgy - mo.y)/20
				--mo.momz = (target.z - mo.z)/20
			end
					
			if timer == 29
				mo.bod = {}
				ANIM_set(mo, mo.anim_guard, true)
				mo.angle_old = mo.angle
			end

			if timer >= 30 and timer <= 60	--charge up
			and mo.bod
				
				if timer == 30 then playSound(playSound(mo.battlen, sfx_ltchr)) end
				local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
				d.sprite = SPR_HOWL
				d.color = SKINCOLOR_SAPPHIRE
				d.colorized = true
				d.frame = (leveltime%3)|FF_FULLBRIGHT
				d.blendmode = AST_ADD
				d.renderflags = $|RF_FULLBRIGHT
				d.scale = mo.scale*2
				d.destscale = mo.scale/10
				d.scalespeed = mo.scale/5
				
				for i = 1, 3
					local h_angle = P_RandomRange(1, 359)*ANG1
					local v_angle = P_RandomRange(1, 359)*ANG1
					local dist = 256
					local spd = P_RandomRange(40, 50)

					local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
					local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
					local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_TEAL
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.scale = FRACUNIT
					s.destscale = FRACUNIT/10
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
				end
			end
			
			if timer == 80
			or timer == 90
				if timer == 80
					ANIM_set(mo, mo.anim_special1)
					playSound(mo.battlen, sfx_stabl1)
				end
				local dist = 64
				for i = 0, 59
					local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_ORANGE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
					aura.scale = FRACUNIT*3/2
					aura.destscale = FRACUNIT*6
					P_InstaThrust(aura, angle, FRACUNIT*9)
				end		
				local dist = 64
				for i = 0, 20
					local angle = mo.angle+(i*6*ANG1)-(60*ANG1)
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_SAPPHIRE
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
					aura.scale = FRACUNIT*3/2
					aura.destscale = FRACUNIT*6
					P_InstaThrust(aura, angle, FRACUNIT*27)
				end		
			end
			
			-- spawn said smoke:
			if timer >= 110 and timer <= 130
			and mo.bod

				for spin = 1, 2
					if spin == 1
						local dist = 64
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*9)
						end
						
						for i = 0, 5
							local angle = mo.angle-(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle + ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*8
							P_InstaThrust(aura, angle, FRACUNIT*12)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 130
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 110
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					local t = timer - 6*(i-1)

					if t == 115
						damageObject(target)
						if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
							P_InstaThrust(target, angle, FRACUNIT*20)
						end
					end
				end
			end
			
			if timer == 135 + (#hittargets-1)*6
				if Trails_Move then TR_MoveTo(mo) end
				return true
			end
		end,
	}

	--Zero Level 6
	attackDefs["tr_stun_break_c"] = {
			name = "Stun Break",
			type = ATK_STRIKE,
			power = 90,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 7,
			strengthoverride = true,
			forcetp = true,
			status = COND_SHOCK,
			statuschance = 10,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YOGURT))
			end,
			desc = "Light Strike damage to one enemy, \nmay inflict Shock from high voltage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					playSound(mo.battlen, sfx_trzap)
					playSound(mo.battlen, sfx_s3k40)
				end	
				
				if timer >= 10 and timer <= 40
					local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_CYAN
					orb.destscale = FRACUNIT*7
					orb.scalespeed = FRACUNIT/4
					orb.tics = TICRATE/8
				end
				
				if timer >= 10 and timer <= 40
					local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.sprite = SPR_MAGN
					boom.colorized = true
					boom.color = SKINCOLOR_CYAN
					boom.frame = A|FF_TRANS70|FF_ANIMATE
					boom.tics = TICRATE/8
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_pstop)
					localquake(mo.battlen, 7*FRACUNIT, 5)
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
				
				if timer == 40
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					
				elseif timer == 60
					return true
				end
			end,
		}
		
	--Zero level 15
	
	attackDefs["tr_encourage_c"] = {
			name = "Encourage",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = tpBar and 20 or 10,
			forcetp = true,
			tr_castarea = 5,
			desc = "Encourages allies.\nRaises attack by 1 stage (Area M).",
			target = TGT_ALLALLIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE3))
			end,
			target = TGT_ALLALLIES,
			buff = true,
			anim = function(mo, targets, hittargets, timer)	
					if timer == 1
						mo.waves = {}
					end
					
					if timer >= 21 and timer <= 50
						if not (leveltime%6)
							local shit = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_GHOST)
							shit.sprite = SPR_NTHK
							shit.color = SKINCOLOR_ORANGE
							shit.scale = 1
							shit.flags2 = $|MF2_SPLAT
							shit.frame = B|FF_FULLBRIGHT|FF_ADD
							shit.tics = -1
							shit.fuse = 20
							table.insert(mo.waves,shit)	
						end	
						localquake(mo.battlen, FRACUNIT*8, 1)
					end				
					
					
				for i = 1,#targets
					local target = hittargets[i]				
					if timer == 50 + (i-1)*8
						playSound(mo.battlen, sfx_courge)
						VFX_Play(target, VFX_SUMMON)
						buffStat(target, "atk")
						summonAura(target, SKINCOLOR_ORANGE)
						for i = 1, 8
							local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(6, 16)*FRACUNIT
							thok.color = SKINCOLOR_ORANGE
							thok.tics = P_RandomRange(10, 20)
						end	
					end
				end	
				
				if timer == 10
					VFX_Play(mo, VFX_AOADO)
				end
					
				if timer == 20
					playSound(mo.battlen, sfx_encour)
					playSound(mo.battlen, sfx_encour)
				end				
				

				if timer == 80 + (#targets-1)*8
					mo.waves = nil
					return true
				end
				if mo.waves and #mo.waves
					local work = mo.waves
					for shit = 1,#work
						if work[shit] and work[shit].valid
							local fuck = work[shit]
							fuck.scale = $ + FRACUNIT
						end
					end
				end			
			end,
	}

	--Zero level 21
	attackDefs["tr_brave_smash_c"] = {
			name = "Brave Smash",
			type = ATK_STRIKE,
			power = 80,
			accuracy = 90,
			critical = 2,
			target = TGT_ENEMY,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 20 or 9,
			strengthoverride = true,
			forcetp = true,
			status = COND_SILENCE,
			statuschance = 15,
			norandom = true,
			norogue = true,		
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			tr_castarea = 3,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Light Strike damage to one enemy, \nLow chance to inflict Silence (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--physical = true,	-- don't play the summoning anim for phys attacks, duh
			anim = 	function(mo, targets, hittargets, timer)
							local target
							if not mo.tr_lockskill
								target = hittargets[1]
							else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
								target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
								target.state = S_INVISIBLE
								target.fuse = 2
							end
							if timer == 1
								ANIM_set(mo, mo.anim_special2, true)
								mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

								local cx = target.x + 168*cos(target.angle + ANG1*20)
								local cy = target.y + 168*sin(target.angle + ANG1*20)
								CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
								CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
								S_StartSound(mo, sfx_msovd1)
							end

							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.state =  	S_FLAMEDASH1
							P_InstaThrust(mo, mo.angle, FRACUNIT*60)

							if not mo.reachedtarget

								if mo.anim ~= mo.anim_special2
									ANIM_set(mo, mo.anim_special2, true)
								end

								mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

								if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

									if #hittargets > 0	--In case we select nothing
										for i = 1, #hittargets
											damageObject(hittargets[i])	--this should just hit everything highlighted
										end
									end
									playSound(mo.battlen, sfx_bkpoof)
									mo.reachedtarget = timer

									for i=1,24
										local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
										b.momx = P_RandomRange(-32, 32)*FRACUNIT
										b.momy = P_RandomRange(-32, 32)*FRACUNIT
										b.momz = P_RandomRange(4, 16)*FRACUNIT
										b.state = S_AOADUST1
										b.frame = A|FF_FULLBRIGHT
										b.scale = FRACUNIT*3
										b.destscale = FRACUNIT/12
									end
									for i = 1, 4
										createSplat(mo)
									end
								end
							else

								if timer - mo.reachedtarget > 40
									return true
								end
							end
						end,
		}

	--Zero level 26
	attackDefs["tr_burning_heart_c"] = {
			name = "Burning Heart",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = tpBar and 40 or 22,
			forcetp = true,
			desc = "Charges up the user.\nRaises attack,defense and \nagility by 1 stage.\nImmune to status temporarily",
			target = TGT_CASTER,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
			end,
			implicit = "tr_burningheart_thinker",
			superbuff = true,
			nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
							local target = targets[n]
							if target.buffs["atk"][1] >= 75
							and target.buffs["agi"][1] >= 75
							and target.buffs["def"][1] >= 75
								BTL_logMessage(targets[1].battlen, "You reached your limit.")
								return true
							end
						end,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					S_StartSound(nil, sfx_burhea)
					ANIM_set(mo, mo.anim_special6, true)
				elseif timer >= 10 and timer <= 125
					summonAura(mo, SKINCOLOR_SUPERORANGE4)
					localquake(mo.battlen, FRACUNIT*5, 10)
				end	

				if timer == 90
					ANIM_set(mo, mo.anim_special7, true)
					buffStat(target, "atk")
					buffStat(target, "def")
					buffStat(target, "agi")
					if not mo.burninghearttimer
						mo.burninghearttimer = 4
					end
					BTL_logMessage(targets[1].battlen, "Physical Attack up!\nDefense up!\nAgility up!\nTemporarily immune to status.")
					playSound(mo.battlen, sfx_buff)
					
					//For the immunity to work
					
					local skill = "tr_burning_heart_blocker"
					
					local check = false
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								check = true
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								check = true
							end
						end
					end
					
					if not check
						mo.passiveskills[#mo.passiveskills+1] = skill
					end
					
				end
				
				if timer == 70
				or timer == 80
					for i = 1,16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_SUPERORANGE4
						dust.scale = FRACUNIT*2
					end
				end	
				
				if timer > 90 and timer < 125
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_SUPERORANGE4
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
					localquake(mo.battlen, FRACUNIT*20, 10)
				end	
				
				if timer > 90 and timer < 125
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_SUPERORANGE4
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
					localquake(mo.battlen, FRACUNIT*20, 10)
				end	

				if timer == 145
					return true
				end
			end,
	}
	
	--Zero story unlock, we can put it more around lvl 25
	attackDefs["tr_extend_hearts_c"] = {
			name = "Extend Hearts",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = 30,
			forcetp = true,
			desc = "Encourages allies with burning passion\nRaises Atk and Agi by 1 stage and \nrestores 15 TP/30 CP.",
			target = TGT_ALLALLIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT2"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE3))
			end,
			buff = true,
			anim = function(mo, targets, hittargets, timer)
					
					if timer == 1
						mo.waves = {}
					end
					
					if timer >= 21 and timer <= 50
						if not (leveltime%6)
							local shit = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_GHOST)
							shit.sprite = SPR_NTHK
							shit.color = SKINCOLOR_FLAME
							shit.scale = 1
							shit.flags2 = $|MF2_SPLAT
							shit.frame = B|FF_FULLBRIGHT|FF_ADD
							shit.tics = -1
							shit.fuse = 20
							table.insert(mo.waves,shit)	
						end	
						localquake(mo.battlen, FRACUNIT*8, 1)
					end		
					
				for i = 1,#targets
					local target = targets[i]								
					if timer == 51 + (i-1)*8
						playSound(mo.battlen, sfx_courge)
						VFX_Play(target, VFX_SUMMON)
						buffStat(target, "atk")
						buffStat(target, "agi")
						if target ~= mo	--If it affected us, we could spam it for ever and ever.
							local tpheal = 15
							if (target.cpuse or (target.stats and charStats[target.stats].cpuse) or (target.enemy and enemyList[target.enemy].cpuse)) then tpheal = 30 end
							damageTP(target, -tpheal)
						end
						BTL_logMessage(targets[1].battlen, "Physical Attack up!\nAgility up!")
						summonAura(target, SKINCOLOR_FLAME)
						for i = 1, 8
							local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(6, 16)*FRACUNIT
							thok.color = SKINCOLOR_FLAME
							thok.tics = P_RandomRange(10, 20)
						end	
					end
				end	
				
				if timer == 10
					VFX_Play(mo, VFX_AOADO)
				end
					
				if timer == 20
					playSound(mo.battlen, sfx_encour)
					playSound(mo.battlen, sfx_encour)
				end				
				

				if timer == 80 + (#targets-1)*8
					mo.waves = nil
					return true
				end
				if mo.waves and #mo.waves
					local work = mo.waves
					for shit = 1,#work
						if work[shit] and work[shit].valid
							local fuck = work[shit]
							fuck.scale = $ + FRACUNIT
						end
					end
				end			
			end,
	}

	--To Azure (lvl 50 - lvl 100+
	
	--Azure level 54
	attackDefs["tr_stun_break_c2"] = {
			name = "Stun Break 2",
			type = ATK_STRIKE,
			power = 280,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 11,
			strengthoverride = true,
			forcetp = true,
			status = COND_SHOCK,
			statuschance = 20,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YOGURT))
			end,
			desc = "Medium Strike damage to one enemy, \nmay inflict Shock from high voltage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					playSound(mo.battlen, sfx_trzap)
					playSound(mo.battlen, sfx_s3k40)
				end	
				
				if timer >= 10 and timer <= 40
					local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_CYAN
					orb.destscale = FRACUNIT*7
					orb.scalespeed = FRACUNIT/4
					orb.tics = TICRATE/8
				end
				
				if timer >= 10 and timer <= 40
					local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.sprite = SPR_MAGN
					boom.colorized = true
					boom.color = SKINCOLOR_CYAN
					boom.frame = A|FF_TRANS70|FF_ANIMATE
					boom.tics = TICRATE/8
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_pstop)
					localquake(mo.battlen, 7*FRACUNIT, 5)
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
				
				if timer == 40
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					
				elseif timer == 60
					return true
				end
			end,
		}
		
	--Azure level 54
	attackDefs["tr_raging_spin_c"] = {
			name = "Raging Spin",
			type = ATK_STRIKE,
			power = 200,
			accuracy = 90,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 11,
			strengthoverride = true,
			forcetp = true,
			critical = 5,
			tr_castarea = 4,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Medium Damage to all enemies with \nstrong shockwaves (Set Area M).".."\x82".."\n   Custom 1 for Pos Mode.",
			target = TGT_ALLENEMIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_PEACHY))
			end,
			anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 1	--menacingly approach the enemy
				mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
				ANIM_set(mo, mo.anim_move, true)
				mo.momx = (avgx - mo.x)/20
				mo.momy = (avgy - mo.y)/20
				--mo.momz = (target.z - mo.z)/20
			end
					
			if timer == 29
				mo.bod = {}
				ANIM_set(mo, mo.anim_special1)
				mo.angle_old = mo.angle
			end

			if timer >= 30 and timer <= 44	--vortex
			and mo.bod

				if timer == 30 then playSound(mo.battlen, sfx_stabl1) end
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						local target = hittargets[i]
						local angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
						P_InstaThrust(target, angle, FRACUNIT*2)
					end
				end
				for spin = 1, 2
					if spin == 1
						local dist = 480
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_WAVE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, -FRACUNIT*6)
						end
						dist = 160
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_SLATE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/4
							aura.destscale = FRACUNIT*3
							P_InstaThrust(aura, angle, -FRACUNIT*3)
						end
					end
					local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.colorized = true
					s.color = SKINCOLOR_VAPOR
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.fuse = 40
					s.tics = 40
					
					local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.colorized = true
					s.color = SKINCOLOR_ICY
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.fuse = 40
					s.tics = 40
				end
				
			end

			-- spawn said smoke:
			if timer >= 60 and timer <= 80
			and mo.bod
				if timer == 60
					 playSound(mo.battlen, sfx_stabl1)
				end

				for spin = 1, 2
					if spin == 1
						local dist = 64
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*9)
						end
						
						for i = 0, 5
							local angle = mo.angle-(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle + ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*8
							P_InstaThrust(aura, angle, FRACUNIT*12)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 80
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 60
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					local t = timer - 6*(i-1)

					if t == 65
						damageObject(target)
						if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
							P_InstaThrust(target, angle, FRACUNIT*20)
						end
					end
				end
			end
			
			if timer == 105 + (#hittargets-1)*6
				if Trails_Move then TR_MoveTo(mo) end
				return true
			end
		end,
	}

	--Azure level 80
	attackDefs["tr_brave_smash_c2"] = {
			name = "Brave Smash 2",
			type = ATK_STRIKE,
			power = 240,
			accuracy = 95,
			critical = 2,
			target = TGT_ENEMY,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 35 or 11,
			strengthoverride = true,
			forcetp = true,
			status = COND_SILENCE,
			statuschance = 37,
			norandom = true,
			norogue = true,		
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			tr_castarea = 3,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Medium Strike damage to one enemy, \nHigh chance to inflict Silence (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--physical = true,	-- don't play the summoning anim for phys attacks, duh
			anim = 	function(mo, targets, hittargets, timer)
							local target
							if not mo.tr_lockskill
								target = hittargets[1]
							else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
								target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
								target.state = S_INVISIBLE
								target.fuse = 2
							end
							if timer == 1
								ANIM_set(mo, mo.anim_special2, true)
								mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

								local cx = target.x + 168*cos(target.angle + ANG1*20)
								local cy = target.y + 168*sin(target.angle + ANG1*20)
								CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
								CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
								S_StartSound(mo, sfx_msovd1)
							end

							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.state =  	S_FLAMEDASH1
							P_InstaThrust(mo, mo.angle, FRACUNIT*60)

							if not mo.reachedtarget

								if mo.anim ~= mo.anim_special2
									ANIM_set(mo, mo.anim_special2, true)
								end

								mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

								if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

									if #hittargets > 0	--In case we select nothing
										for i = 1, #hittargets
											damageObject(hittargets[i])	--this should just hit everything highlighted
										end
									end
									playSound(mo.battlen, sfx_bkpoof)
									mo.reachedtarget = timer

									for i=1,24
										local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
										b.momx = P_RandomRange(-32, 32)*FRACUNIT
										b.momy = P_RandomRange(-32, 32)*FRACUNIT
										b.momz = P_RandomRange(4, 16)*FRACUNIT
										b.state = S_AOADUST1
										b.frame = A|FF_FULLBRIGHT
										b.scale = FRACUNIT*3
										b.destscale = FRACUNIT/12
									end
									for i = 1, 4
										createSplat(mo)
									end
								end
							else

								if timer - mo.reachedtarget > 40
									return true
								end
							end
						end,
		}

	--Azure level 103
	attackDefs["tr_burning_heart_c2"] = {
		name = "Burning Heart 2",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = tpBar and 40 or 44,
		forcetp = true,
		desc = "Charges up the user.\nRaises atk, def and agi by 1 stage.\nBecome status-immune during, and recover 6% HP every turn.\nBe warned, you'll need to rest after 3 turns.",
		target = TGT_CASTER,
		overrideicon = "TR_CRAFT",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
		end,	
		implicit = "tr_burningheart_thinker_2",
		superbuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
		end,	
		nocast = 	function(targets, n, mo)
			if mo.burninghearttimer
				BTL_logMessage(mo.battlen, "Your heart is still burning!")
				return true
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				S_StartSound(nil, sfx_burhea)
				ANIM_set(mo, mo.anim_special6, true)
			elseif timer >= 10 and timer <= 125
				summonAura(mo, SKINCOLOR_SUPERORANGE4)
				localquake(mo.battlen, FRACUNIT*5, 10)
			end	

			if timer == 90
				if mo.status_condition and (mo.status_condition < COND_HYPER) then cureStatus(mo) end
				ANIM_set(mo, mo.anim_special7, true)
				buffStat(target, "atk")
				buffStat(target, "def")
				buffStat(target, "agi")
				if not mo.burninghearttimer
					mo.burninghearttimer = 4
				end
				BTL_logMessage(mo.battlen, "Physical Attack, Defense and Agility up!\nAilments cured!\nTemporarily immune to status.")

				playSound(mo.battlen, sfx_buff)
				
				//For the immunity to work
				
				local skill = "tr_burning_heart_blocker"
				
				local check = false
				
				if #mo.skills
					for i = 1,#mo.skills
					local x = mo.skills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if #mo.passiveskills
					for i = 1,#mo.passiveskills
					local x = mo.passiveskills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if not check
					table.insert(mo.passiveskills,skill)
				end
				
			end
			
			if timer == 70
			or timer == 80
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SUPERORANGE4
					dust.scale = FRACUNIT*2
				end
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	

			if timer == 145
				return true
			end
		end,
	}
	
	--
	attackDefs["tr_stun_break_c3"] = {
			name = "Stun Break 3",
			type = ATK_STRIKE,
			power = 540,
			accuracy = 90,
			costtype = CST_SP,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 30 or 14,
			strengthoverride = true,
			forcetp = true,
			status = COND_SHOCK,
			statuschance = 25,
			critical = 5,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YOGURT))
			end,
			desc = "Heavy Strike damage to one enemy, \nmay inflict Shock from high voltage.",
			target = TGT_ENEMY,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				if timer == 10
					playSound(mo.battlen, sfx_trzap)
					playSound(mo.battlen, sfx_s3k40)
				end	
				
				if timer >= 10 and timer <= 40
					local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					orb.sprite = SPR_DELK
					orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					orb.color = SKINCOLOR_CYAN
					orb.destscale = FRACUNIT*7
					orb.scalespeed = FRACUNIT/4
					orb.tics = TICRATE/8
				end
				
				if timer >= 10 and timer <= 40
					local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.sprite = SPR_MAGN
					boom.colorized = true
					boom.color = SKINCOLOR_CYAN
					boom.frame = A|FF_TRANS70|FF_ANIMATE
					boom.tics = TICRATE/8
				end
				
				if timer == 10
					playSound(mo.battlen, sfx_pstop)
					localquake(mo.battlen, 7*FRACUNIT, 5)
					for i=1,16
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_AOADUST1
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
				
				if timer == 40
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					
				elseif timer == 60
					return true
				end
			end,
		}
		
	--Coldsteel 4 Initial
	attackDefs["tr_zero_breaker_c"] = {
			name = "Zero Breaker",
			type = ATK_STRIKE,
			power = 460,
			accuracy = 95,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 60 or 24,
			strengthoverride = true,
			forcetp = true,
			critical = 5,
			tr_castarea = 3,
			tr_setmode = 1, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Heavy Strike Damage with powerful shockwaves, \nreduces enemy defense (Set Area M).",
			target = TGT_ALLENEMIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUNSET))
			end,
			anim = function(mo, targets, hittargets, timer)

			local avgx = 0
			local avgy = 0
			if not mo.tr_lockskill
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
			else
				avgx = mo.tr_cursorPos[1]
				avgy = mo.tr_cursorPos[2]
			end
			
			if timer == 1	--menacingly approach the enemy
				mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
				ANIM_set(mo, mo.anim_move, true)
				mo.momx = (avgx - mo.x)/20
				mo.momy = (avgy - mo.y)/20
				--mo.momz = (target.z - mo.z)/20
			end
					
			if timer == 29
				mo.bod = {}
				ANIM_set(mo, mo.anim_special1)
				mo.angle_old = mo.angle
			end

			if timer >= 30 and timer <= 44	--vortex
			and mo.bod

				if timer == 30 then playSound(mo.battlen, sfx_stabl1) end
				if #hittargets > 0	--In case we select nothing
					for i = 1, #hittargets
						local target = hittargets[i]
						local angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
						P_InstaThrust(target, angle, FRACUNIT*2)
					end
				end
				for spin = 1, 2
					if spin == 1
						local dist = 480
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, -FRACUNIT*6)
						end
						dist = 160
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/4
							aura.destscale = FRACUNIT*3
							P_InstaThrust(aura, angle, -FRACUNIT*3)
						end
					end
					local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.colorized = true
					s.color = SKINCOLOR_VAPOR
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.fuse = 40
					s.tics = 40
					
					local s = P_SpawnMobj(mo.x+P_RandomRange(-128, 128)*FRACUNIT, mo.y+P_RandomRange(-128, 128)*FRACUNIT, mo.z+(mo.height/2), MT_DUMMY)
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.colorized = true
					s.color = SKINCOLOR_ICY
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.fuse = 40
					s.tics = 40
				end
				
			end

			-- spawn said smoke:
			if timer >= 60 and timer <= 80
			and mo.bod
				if timer == 60
					 playSound(mo.battlen, sfx_stabl1)
				end

				for spin = 1, 2
					if spin == 1
						local dist = 64
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*9)
						end
						
						for i = 0, 5
							local angle = mo.angle-(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle + ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*8
							P_InstaThrust(aura, angle, FRACUNIT*12)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 80
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 60
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			if #hittargets > 0	--In case we select nothing
				for i = 1, #hittargets
					local target = hittargets[i]
					local t = timer - 6*(i-1)

					if t == 65
						damageObject(target)
						if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							buffStat(target, "def", -BUFFSTEP)	-- negative values lower a stat
							local angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
							P_InstaThrust(target, angle, FRACUNIT*20)
						end
					end
				end
			end
			
			if timer == 105 + (#hittargets-1)*6
				if Trails_Move then TR_MoveTo(mo) end
				return true
			end
		end,
	}

	--Azure level 80
	attackDefs["tr_brave_smash_c3"] = {
			name = "Brave Smash 3",
			type = ATK_STRIKE,
			power = 480,
			accuracy = 95,
			critical = 2,
			target = TGT_ENEMY,
			costtype = tpBar and CST_SP or CST_HPPERCENT,
			cost = tpBar and 40 or 13,
			strengthoverride = true,
			forcetp = true,
			status = COND_SILENCE,
			statuschance = 40,
			norandom = true,
			norogue = true,		
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			tr_castarea = 3,
			tr_setmode = 2, --Mode 1 is Set Area, Mode 2 is Set Line
			desc = "Heavy Strike damage to one enemy, \nHigh chance to inflict Silence (Set Line L).".."\x82".."\n   Custom 1 for Pos Mode.",
			anim_norepel = true,	-- do not bounce back our ANIMATION
			--physical = true,	-- don't play the summoning anim for phys attacks, duh
			anim = 	function(mo, targets, hittargets, timer)
							local target
							if not mo.tr_lockskill
								target = hittargets[1]
							else	--we might not HAVE a target selected, so we'll just spawn a temporary dummy at the cursor position.
								target = P_SpawnMobj(mo.tr_cursorPos[1], mo.tr_cursorPos[2], mo.z, MT_DUMMY)
								target.state = S_INVISIBLE
								target.fuse = 2
							end
							if timer == 1
								ANIM_set(mo, mo.anim_special2, true)
								mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

								local cx = target.x + 168*cos(target.angle + ANG1*20)
								local cy = target.y + 168*sin(target.angle + ANG1*20)
								CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
								CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
								S_StartSound(mo, sfx_msovd1)
							end

							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.state =  	S_FLAMEDASH1
							P_InstaThrust(mo, mo.angle, FRACUNIT*60)

							if not mo.reachedtarget

								if mo.anim ~= mo.anim_special2
									ANIM_set(mo, mo.anim_special2, true)
								end

								mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

								if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

									if #hittargets > 0	--In case we select nothing
										for i = 1, #hittargets
											damageObject(hittargets[i])	--this should just hit everything highlighted
										end
									end
									playSound(mo.battlen, sfx_bkpoof)
									mo.reachedtarget = timer

									for i=1,24
										local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
										b.momx = P_RandomRange(-32, 32)*FRACUNIT
										b.momy = P_RandomRange(-32, 32)*FRACUNIT
										b.momz = P_RandomRange(4, 16)*FRACUNIT
										b.state = S_AOADUST1
										b.frame = A|FF_FULLBRIGHT
										b.scale = FRACUNIT*3
										b.destscale = FRACUNIT/12
									end
									for i = 1, 4
										createSplat(mo)
									end
								end
							else

								if timer - mo.reachedtarget > 40
									return true
								end
							end
						end,
		}

	--Coldsteel 4 Initial
	attackDefs["tr_burning_heart_c3"] = {
		name = "Burning Heart 3",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = tpBar and 40 or 66,
		forcetp = true,
		desc = "Charges up the user.\nClears Debuffs, then raises atk, def and agi.\nBecome status-immune and heal 6% HP each turn.",
		target = TGT_CASTER,
		overrideicon = "TR_CRAFT",
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERORANGE2))
		end,	
		implicit = "tr_burningheart_thinker_2",
		superbuff = true,
		nocast = 	function(targets, n, mo)
			if mo.burninghearttimer
				BTL_logMessage(mo.battlen, "Your heart is still burning!")
				return true
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				S_StartSound(nil, sfx_burhea)
				ANIM_set(mo, mo.anim_special6, true)
			elseif timer >= 10 and timer <= 125
				summonAura(mo, SKINCOLOR_SUPERORANGE4)
				localquake(mo.battlen, FRACUNIT*5, 10)
			end	

			if timer == 90
				if mo.status_condition and (mo.status_condition < COND_HYPER) then cureStatus(mo) end //WOOOOOO STATUS CUUUUUUUUUUURE
				
				ANIM_set(mo, mo.anim_special7, true)
				
				local strs = {"atk", "mag", "def", "agi", "crit"}
				
				for j = 1, #strs
					local s = strs[j]
					if mo.buffs[s][1] < 0
						mo.buffs[s][1] = 0
						mo.buffs[s][2] = 0
					end
				end
				
				//Rad, NOW... we can buff
				
				buffStat(target, "atk")
				buffStat(target, "def")
				buffStat(target, "agi")
				if not mo.burninghearttimer
					mo.burninghearttimer = 4
				end
				BTL_logMessage(mo.battlen, "Physical Attack, Defense and Agility up!\nDebuffs and Ailments cured!\nTemporarily immune to status.")
				playSound(mo.battlen, sfx_buff)
				
				//For the immunity to work
				
				local skill = "tr_burning_heart_blocker"
				
				local check = false
				
				if #mo.skills
					for i = 1,#mo.skills
					local x = mo.skills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if #mo.passiveskills
					for i = 1,#mo.passiveskills
					local x = mo.passiveskills[i]
						if skill == x
							check = true
						end
					end
				end
				
				if not check
					table.insert(mo.passiveskills,skill)
				end
				
			end
			
			if timer == 70
			or timer == 80
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SUPERORANGE4
					dust.scale = FRACUNIT*2
				end
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	

			if timer == 145
				return true
			end
		end,
	}

	-- S-Crafts
if C2SBarEdits

	--Zero Initial
	attackDefs["tr_tigercharge_c"] = { //Zoraxua be tired but im fukin bALLIN' 
			name = "Tiger Charge", 
			type = ATK_STRIKE,
			power = 200, 
			accuracy = 100,
			status = COND_SILENCE,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_LYDAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			statuschance = 50,		--this is so bullshit bruh lmao
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			nometronome = true,
			norandom = true,
			norogue = true,	
			critical = 15, //Thats 1 in 3 almost (!wow!)
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nCharges like a tiger to a enemy\ncausing Medium Damage,\nhigh chance of Silence.",
			target = TGT_ENEMY,
			--norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
			end,
			anim_norepel = true,
			--noenemycast = true,	--Should be enemy safe now.
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_cutlyd)
					playSound(mo.battlen, sfx_llsmn4)	--"right!"
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 15	--ready up
					ANIM_set(mo, mo.anim_guard, true)
				end
				if timer == 30	--"let's go!"
					playSound(mo.battlen, sfx_llsmn3)
				end
				
				if timer == 45	--dash towards the enemy
					ANIM_set(mo, mo.anim_special2, true)
					mo.momx = (target.x - mo.x)/10
					mo.momy = (target.y - mo.y)/10
				end
				
				if timer >= 70 and timer <= 320	--beat them up!
					if timer == 70
						ANIM_set(mo, mo.anim_stand, true)
						P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.floorz)	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						playSound(mo.battlen, sfx_llaoa3)	--placeholder for his yell
					end
					
					if timer >= 85 and timer < 180
						if timer == 85
							ANIM_set(mo, mo.anim_special8, true)
						end
						if timer%5 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer == 180	--leap back
						ANIM_set(mo, mo.anim_aoa_end, true)
						playSound(mo.battlen, sfx_tigch4)	--TIGER... CHARGE!
						mo.momx = (target.x - mo.x)/8
						mo.momy = (target.y - mo.y)/8
						mo.momz = 5*FRACUNIT
						mo.momx = $*-2
						mo.momy = $*-2
					end
					if timer > 180 and timer <= 270
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					end
					if timer == 200	--ready...
						ANIM_set(mo, mo.anim_special5, true)
						playSound(mo.battlen, sfx_ltchr)
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
					end
					if timer > 200 and timer <= 220
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = (leveltime%3)|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.scale = mo.scale*10
						d.destscale = mo.scale/2
						d.scalespeed = mo.scale
						
						for i = 1, 3
							local h_angle = P_RandomRange(1, 359)*ANG1
							local v_angle = P_RandomRange(1, 359)*ANG1
							local dist = 256
							local spd = P_RandomRange(40, 50)

							local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
							local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
							local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

							local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.target = target
							s.tics = 10
							s.momx = (mo.x - s.x)/10
							s.momy = (mo.y - s.y)/10
							s.momz = (mo.z - s.z)/10
						end
					end
					if timer == 235	--CHARGE!!
						playSound(mo.battlen, sfx_lroar)
						ANIM_set(mo, mo.anim_special2, true)
						mo.momx = (target.x - mo.x)/10
						mo.momy = (target.y - mo.y)/10
					end
					if timer > 235 and timer <= 240
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = A|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*5
						d.destscale = mo.scale/4
						d.scalespeed = mo.scale/2
						P_InstaThrust(d, d.angle, FRACUNIT*8)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 5
							s.momx = FRACUNIT*P_RandomRange(-16, 16)
							s.momy = FRACUNIT*P_RandomRange(-16, 16)
							s.momz = FRACUNIT*P_RandomRange(-16, 16)
						end
					end
					if timer == 240	--slow motion
						mo.momx = (target.x - mo.x)/40
						mo.momy = (target.y - mo.y)/40
					end
					if timer > 240 and timer <= 270
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = A|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*5
						d.destscale = mo.scale/4
						d.scalespeed = mo.scale/8
						P_InstaThrust(d, d.angle, FRACUNIT*2)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z+(FRACUNIT*16), MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 20
							s.momx = FRACUNIT*P_RandomRange(-4, 4)
							s.momy = FRACUNIT*P_RandomRange(-4, 4)
							s.momz = FRACUNIT*P_RandomRange(-4, 4)
						end
					end
					if timer == 270	--speed back up
						mo.momx = (target.x - mo.x)
						mo.momy = (target.y - mo.y)
						P_TeleportMove(cam, target.x + 256 *cos(mo.angle+(90*ANG1)), target.y + 256*sin(mo.angle+(90*ANG1)), target.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
					end
					if timer > 270 and timer <= 300
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = B|FF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*10
						d.destscale = mo.scale/2
						d.scalespeed = mo.scale/4
						P_InstaThrust(d, d.angle, FRACUNIT/2)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 5
							s.momx = FRACUNIT*P_RandomRange(-16, 16)
							s.momy = FRACUNIT*P_RandomRange(-16, 16)
							s.momz = FRACUNIT*P_RandomRange(-16, 16)
						end
					end
					
					if timer == 280	--Kablam!!
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_GOLD
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*4
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						for i = 1, 10 do
							local ol = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*90, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_SAPPHIRE
							ol.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ol.scale = FRACUNIT+(FRACUNIT*i/10)
							ol.scalespeed = FRACUNIT+(FRACUNIT*i/10)*5
							ol.destscale = FRACUNIT*150+(FRACUNIT*i*15)
							ol.flags2 = $|MF2_SPLAT
							ol.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT
							ol.tics = 35
							ol.momz = FRACUNIT*10
						end
						
						damageObject(target)
					end
					if timer > 280 and timer <= 320
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = leveltime%2 and SKINCOLOR_SAPPHIRE or SKINCOLOR_GOLD
						d.colorized = true
						d.frame = (leveltime%3)|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.scale = mo.scale/2
						d.destscale = mo.scale*10
						d.scalespeed = mo.scale
					end
				end

				if timer == 330
					mo.hudcharx = nil
					return true
				end
			end,
	}
	
	--Zero level 32
	attackDefs["tr_risingsun_c"] = {
			name = "Rising Sun",
			type = ATK_FIRE,
			power = 600,
			accuracy = 100,
			status = COND_BURN, //And lets make burn likely
			statuschance = 25,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			nometronome = true,
			norandom = true,
			norogue = true,	
			tr_castarea = 4,
			--noenemycast = true,	--Should be enemy safe now.
			critical = 10,
			hits = 3, //Mmh tasty bonus damage lol
			anim_norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."Lloyd's S-Craft\nDestroys enemies with tons\nof smacking and fire (Area M)", //Put one here ya want :p
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			hudfunc =     function(v, mo, timer)	
							if timer >= 150 and timer < 200
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_LYDAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,

							
			anim = function(mo, targets, hittargets, timer)
			
			if timer == 1
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
			end
			
			if timer == 120
				mo.hudcharx = -300
			end
			if timer > 150 and timer < 160
				mo.hudcharx = $+30
			end
			if timer == 161
				mo.hudcharx = 0
			end
			if timer >= 190 - 10
				mo.hudcharx = $+60
			end		
			
			local cam = server.P_BattleStatus[mo.battlen].cam
				
			
			for i = 1, #hittargets
				local target = hittargets[i]
					if timer == 1 //LAUNCH (BASE ZONE)
						for i = 1, 8 //Garu stuffs to simulate da wind
							local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
							g.target = target
							g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
							if i == 1 or i == 8
								g.jizzcolor = true
							end
							if i%2
								g.invertrotation = true
							end
							g.dist = P_RandomRange(45, 90)
							g.tics = 24
						end
					elseif timer == 5
						playSound(mo.battlen, sfx_rinwdj)
					elseif timer == 20 //ZOOM
						P_SetObjectMomZ(target, 60*FRACUNIT)
					elseif timer == 25 //ZOOM 2
						P_SetObjectMomZ(mo, 70*FRACUNIT) //Bye Lloyd lol
					elseif timer > 35
					and timer < 315
					mo.momz = 0
					target.momz = 0
					end //Momz lol, that's sorted now
				end
				
				if timer == 35 //Oi camera, move
						local cx = mo.x + 21*cos(mo.angle + ANG1*20)
						local cy = mo.y + 21*sin(mo.angle + ANG1*20)
							if #hittargets < 3
								P_TeleportMove(cam, cx, cy, hittargets[1].z + FRACUNIT*16)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[1].x, hittargets[1].y) 
							elseif #hittargets > 4
								P_TeleportMove(cam, cx, cy, hittargets[3].z + FRACUNIT*16)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[3].x, hittargets[3].y) 
							else
								P_TeleportMove(cam, cx, cy, hittargets[2].z + FRACUNIT*16)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[2].x, hittargets[2].y) 
							end
		
				elseif timer >= 40 //so 40..
				and timer <= 110 //To 110.. 2 seconds
				local rnd = P_RandomRange(1,#hittargets) //Spicy RNG to randomly "hit" targets
				local rtarget = hittargets[rnd]
	//				if timer == 40
	//					rtarget.rolls = {}
	//				end
					local s = P_SpawnMobj(rtarget.x, rtarget.y, rtarget.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_ORANGE //Slicy stuffs
					s.scale = FRACUNIT*3
					s.rollangle = P_RandomRange(0, 359)*ANG1
	//				rtarget.rolls[#rtarget.rolls+1] = s.rollangle
					if not (leveltime%6)
					playSound(mo.battlen, sfx_lydhit)
					createSplat(mo)
					end
				elseif timer == 125 //CAMERA!!! Please turn!
					local cx = mo.x + 128*cos(mo.angle + ANG1*25)
					local cy = mo.y + 128*sin(mo.angle + ANG1*25)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
					ANIM_set(mo, mo.anim_special3, true)
				elseif timer == 135 
				elseif timer == 145 //KA
					DoExplosion(mo)//BEWWWWWWWM
				elseif timer == 160
				playSound(mo.battlen, sfx_cutlyd)
				playSound(mo.battlen, sfx_rissun)
				ANIM_set(mo, mo.anim_special4, true)
				elseif timer == 190
				ANIM_set(mo, mo.anim_special3, true)
				elseif timer >= 195
				and timer < 230
					for i = 1, 24
						local boom = P_SpawnMobj(mo.x + P_RandomRange(-48, 48)*FRACUNIT, mo.y + P_RandomRange(-48, 48)*FRACUNIT, mo.z - 32*FRACUNIT, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*3/2
					end
					if timer%4 == 0
						playSound(mo.battlen, sfx_fire1)
					end
				localquake(mo.battlen, FRACUNIT*64, 10)
				ANIM_set(mo, mo.anim_special4, true)
				elseif timer == 230
					local cx = mo.x + 21*cos(mo.angle + ANG1*20)
					local cy = mo.y + 21*sin(mo.angle + ANG1*20)
							if #hittargets < 3
								P_TeleportMove(cam, cx, cy, hittargets[1].z + FRACUNIT*32)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[1].x, hittargets[1].y) 
							elseif #hittargets > 4
								P_TeleportMove(cam, cx, cy, hittargets[3].z + FRACUNIT*32)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[3].x, hittargets[3].y) 
							else
								P_TeleportMove(cam, cx, cy, hittargets[2].z + FRACUNIT*32)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[2].x, hittargets[2].y) 
							end //Turn back
				elseif timer > 230
				and timer <= 300
					if timer%4 == 0
						playSound(mo.battlen, sfx_fire1)
					end
					for i = 1, #hittargets
						local target = hittargets[i]
						for i = 1, 6 //Let's not kill the sprite limit lol 
							local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z - 32*FRACUNIT, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*2
						end
						if timer == 250
						or timer == 270
							damageObject(target)
						end
						
						if timer == 295
							damageObject(target)
							DoExplosion(target)
						end
					end
				elseif timer >= 315 //Camera cools
				and timer < 360
					ANIM_set(mo, mo.anim_aoa_end, true)
					local cx = mo.x - 168*cos(mo.angle + ANG1*20)
					local cy = mo.y - 168*sin(mo.angle + ANG1*20)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, mo.x, mo.y))
				end
				if timer == 360
					mo.hudcharx = nil
					return true
				end
			end,
	}

	--Zero Initial
	attackDefs["tr_tigercharge_c2"] = { //Zoraxua be tired but im fukin bALLIN' 
			name = "Tiger Charge 2", 
			type = ATK_STRIKE,
			power = 900, 
			accuracy = 100,
			status = COND_SHOCK,
				hudfunc =     function(v, mo, timer)	
								if timer < TICRATE
								-- draw chars:
									local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_LYDAOA")
										if mo.status_condition == COND_SUPER
										and charStats[mo.stats] and charStats[mo.stats].hudsaoa
											pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
										end
				
									v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
								end	
							end,
			statuschance = 100,		--this is some extreme bananas for the monke brain
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			nometronome = true,
			norandom = true,
			norogue = true,	
			critical = 35, //Thats 1 in 3 almost (!wow!)
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nCharges like a tiger to a enemy\ncausing Severe Damage,\nSilences",
			target = TGT_ENEMY,
			--norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
			end,
			anim_norepel = true,
			--noenemycast = true,	--Should be enemy safe now.
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_cutlyd)
					playSound(mo.battlen, sfx_llsmn4)	--"right!"
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 15	--ready up
					ANIM_set(mo, mo.anim_guard, true)
				end
				if timer == 30	--"let's go!"
					playSound(mo.battlen, sfx_llsmn3)
				end
				
				if timer == 45	--dash towards the enemy
					ANIM_set(mo, mo.anim_special2, true)
					mo.momx = (target.x - mo.x)/10
					mo.momy = (target.y - mo.y)/10
				end
				
				if timer >= 70 and timer <= 320	--beat them up!
					if timer == 70
						ANIM_set(mo, mo.anim_stand, true)
						P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.floorz)	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
						playSound(mo.battlen, sfx_llaoa3)	--placeholder for his yell
					end
					
					if timer >= 85 and timer < 180
						if timer == 85
							ANIM_set(mo, mo.anim_special8, true)
						end
						if timer%5 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer == 180	--leap back
						ANIM_set(mo, mo.anim_aoa_end, true)
						playSound(mo.battlen, sfx_tigch4)	--TIGER... CHARGE!
						mo.momx = (target.x - mo.x)/8
						mo.momy = (target.y - mo.y)/8
						mo.momz = 5*FRACUNIT
						mo.momx = $*-2
						mo.momy = $*-2
					end
					if timer > 180 and timer <= 270
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(90*ANG1)), mo.y + 256*sin(mo.angle+(90*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					end
					if timer == 200	--ready...
						ANIM_set(mo, mo.anim_special5, true)
						playSound(mo.battlen, sfx_ltchr)
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
					end
					if timer > 200 and timer <= 220
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = (leveltime%3)|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.scale = mo.scale*10
						d.destscale = mo.scale/2
						d.scalespeed = mo.scale
						
						for i = 1, 3
							local h_angle = P_RandomRange(1, 359)*ANG1
							local v_angle = P_RandomRange(1, 359)*ANG1
							local dist = 256
							local spd = P_RandomRange(40, 50)

							local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
							local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
							local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

							local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.target = target
							s.tics = 10
							s.momx = (mo.x - s.x)/10
							s.momy = (mo.y - s.y)/10
							s.momz = (mo.z - s.z)/10
						end
					end
					if timer == 235	--CHARGE!!
						playSound(mo.battlen, sfx_lroar)
						ANIM_set(mo, mo.anim_special2, true)
						mo.momx = (target.x - mo.x)/10
						mo.momy = (target.y - mo.y)/10
					end
					if timer > 235 and timer <= 240
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = A|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*5
						d.destscale = mo.scale/4
						d.scalespeed = mo.scale/2
						P_InstaThrust(d, d.angle, FRACUNIT*8)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 5
							s.momx = FRACUNIT*P_RandomRange(-16, 16)
							s.momy = FRACUNIT*P_RandomRange(-16, 16)
							s.momz = FRACUNIT*P_RandomRange(-16, 16)
						end
					end
					if timer == 240	--slow motion
						mo.momx = (target.x - mo.x)/40
						mo.momy = (target.y - mo.y)/40
					end
					if timer > 240 and timer <= 270
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = A|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*5
						d.destscale = mo.scale/4
						d.scalespeed = mo.scale/8
						P_InstaThrust(d, d.angle, FRACUNIT*2)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z+(FRACUNIT*16), MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 20
							s.momx = FRACUNIT*P_RandomRange(-4, 4)
							s.momy = FRACUNIT*P_RandomRange(-4, 4)
							s.momz = FRACUNIT*P_RandomRange(-4, 4)
						end
					end
					if timer == 270	--speed back up
						mo.momx = (target.x - mo.x)
						mo.momy = (target.y - mo.y)
						P_TeleportMove(cam, target.x + 256 *cos(mo.angle+(90*ANG1)), target.y + 256*sin(mo.angle+(90*ANG1)), target.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
					end
					if timer > 270 and timer <= 300
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = SKINCOLOR_SAPPHIRE
						d.colorized = true
						d.frame = B|FF_FULLBRIGHT
						d.angle = mo.angle + ANG1*180
						d.scale = mo.scale*10
						d.destscale = mo.scale/2
						d.scalespeed = mo.scale/4
						P_InstaThrust(d, d.angle, FRACUNIT/2)
						
						for i = 1, 3
							local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							s.frame = A
							s.color = SKINCOLOR_TEAL
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT*2
							s.destscale = FRACUNIT/5
							s.tics = 5
							s.momx = FRACUNIT*P_RandomRange(-16, 16)
							s.momy = FRACUNIT*P_RandomRange(-16, 16)
							s.momz = FRACUNIT*P_RandomRange(-16, 16)
						end
					end
					
					if timer == 280	--Kablam!!
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_GOLD
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*4
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						for i = 1, 10 do
							local ol = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*90, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_SAPPHIRE
							ol.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ol.scale = FRACUNIT+(FRACUNIT*i/10)
							ol.scalespeed = FRACUNIT+(FRACUNIT*i/10)*5
							ol.destscale = FRACUNIT*150+(FRACUNIT*i*15)
							ol.flags2 = $|MF2_SPLAT
							ol.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT
							ol.tics = 35
							ol.momz = FRACUNIT*10
						end
						
						damageObject(target)
					end
					if timer > 280 and timer <= 320
						local d = P_SpawnMobj(mo.x, mo.y, mo.z-(FRACUNIT*16), MT_THOK)
						d.sprite = SPR_HOWL
						d.color = leveltime%2 and SKINCOLOR_SAPPHIRE or SKINCOLOR_GOLD
						d.colorized = true
						d.frame = (leveltime%3)|FF_FULLBRIGHT
						d.blendmode = AST_ADD
						d.renderflags = $|RF_FULLBRIGHT
						d.scale = mo.scale/2
						d.destscale = mo.scale*10
						d.scalespeed = mo.scale
					end
				end

				if timer == 330
					return true
				end
			end,
	}
	
	--Zero level 32
	attackDefs["tr_risingsun_c2"] = {
			name = "Rising Sun 2",
			type = ATK_FIRE,
			power = 1200,
			accuracy = 100,
			status = COND_BURN, //And lets make burn likely
			statuschance = 25,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			nometronome = true,
			norandom = true,
			norogue = true,	
			--noenemycast = true,	--Should be enemy safe now.
			critical = 10,
			hits = 3, //Mmh tasty bonus damage lol
			anim_norepel = true,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."Lloyd's S-Craft\nDestroys enemies with tons\nof smacking and fire", //Put one here ya want :p
			target = TGT_ALLENEMIES,
			nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
					if not charStats[mo.stats].tpbar or charStats[mo.stats].tpmode ~= "craft points"
						BTL_logMessage(targets[1].battlen, "You can't use this skill.")
						return true
					end
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						if mo.tp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					else
						if mo.sp < 100
							BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
							return true
						end
					end
				end,
			hudfunc =     function(v, mo, timer)	
							if timer >= 150 and timer < 200
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_LYDAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,

							
			anim = function(mo, targets, hittargets, timer)
			
			if timer == 1
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
			end
			
			if timer == 120
				mo.hudcharx = -300
			end
			if timer > 150 and timer < 160
				mo.hudcharx = $+30
			end
			if timer == 161
				mo.hudcharx = 0
			end
			if timer >= 190 - 10
				mo.hudcharx = $+60
			end		
			
			local cam = server.P_BattleStatus[mo.battlen].cam
				
			
			for i = 1, #hittargets
				local target = hittargets[i]
					if timer == 1 //LAUNCH (BASE ZONE)
						for i = 1, 8 //Garu stuffs to simulate da wind
							local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
							g.target = target
							g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
							if i == 1 or i == 8
								g.jizzcolor = true
							end
							if i%2
								g.invertrotation = true
							end
							g.dist = P_RandomRange(45, 90)
							g.tics = 24
						end
					elseif timer == 5
						playSound(mo.battlen, sfx_rinwdj)
					elseif timer == 20 //ZOOM
						P_SetObjectMomZ(target, 60*FRACUNIT)
					elseif timer == 25 //ZOOM 2
						P_SetObjectMomZ(mo, 70*FRACUNIT) //Bye Lloyd lol
					elseif timer > 35
					and timer < 315
					mo.momz = 0
					target.momz = 0
					end //Momz lol, that's sorted now
				end
				
				if timer == 35 //Oi camera, move
						local cx = mo.x + 21*cos(mo.angle + ANG1*20)
						local cy = mo.y + 21*sin(mo.angle + ANG1*20)
							if #hittargets < 3
								P_TeleportMove(cam, cx, cy, hittargets[1].z + FRACUNIT*16)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[1].x, hittargets[1].y) 
							elseif #hittargets > 4
								P_TeleportMove(cam, cx, cy, hittargets[3].z + FRACUNIT*16)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[3].x, hittargets[3].y) 
							else
								P_TeleportMove(cam, cx, cy, hittargets[2].z + FRACUNIT*16)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[2].x, hittargets[2].y) 
							end
		
				elseif timer >= 40 //so 40..
				and timer <= 110 //To 110.. 2 seconds
				local rnd = P_RandomRange(1,#hittargets) //Spicy RNG to randomly "hit" targets
				local rtarget = hittargets[rnd]
	//				if timer == 40
	//					rtarget.rolls = {}
	//				end
					local s = P_SpawnMobj(rtarget.x, rtarget.y, rtarget.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = SKINCOLOR_ORANGE //Slicy stuffs
					s.scale = FRACUNIT*3
					s.rollangle = P_RandomRange(0, 359)*ANG1
	//				rtarget.rolls[#rtarget.rolls+1] = s.rollangle
					if not (leveltime%6)
					playSound(mo.battlen, sfx_lydhit)
					createSplat(mo)
					end
				elseif timer == 125 //CAMERA!!! Please turn!
					local cx = mo.x + 128*cos(mo.angle + ANG1*25)
					local cy = mo.y + 128*sin(mo.angle + ANG1*25)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
					ANIM_set(mo, mo.anim_special3, true)
				elseif timer == 135 
				elseif timer == 145 //KA
					DoExplosion(mo)//BEWWWWWWWM
				elseif timer == 160
				playSound(mo.battlen, sfx_cutlyd)
				playSound(mo.battlen, sfx_rissun)
				ANIM_set(mo, mo.anim_special4, true)
				elseif timer == 190
				ANIM_set(mo, mo.anim_special3, true)
				elseif timer >= 195
				and timer < 230
					for i = 1, 24
						local boom = P_SpawnMobj(mo.x + P_RandomRange(-48, 48)*FRACUNIT, mo.y + P_RandomRange(-48, 48)*FRACUNIT, mo.z - 32*FRACUNIT, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*3/2
					end
					if timer%4 == 0
						playSound(mo.battlen, sfx_fire1)
					end
				localquake(mo.battlen, FRACUNIT*64, 10)
				ANIM_set(mo, mo.anim_special4, true)
				elseif timer == 230
					local cx = mo.x + 21*cos(mo.angle + ANG1*20)
					local cy = mo.y + 21*sin(mo.angle + ANG1*20)
							if #hittargets < 3
								P_TeleportMove(cam, cx, cy, hittargets[1].z + FRACUNIT*32)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[1].x, hittargets[1].y) 
							elseif #hittargets > 4
								P_TeleportMove(cam, cx, cy, hittargets[3].z + FRACUNIT*32)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[3].x, hittargets[3].y) 
							else
								P_TeleportMove(cam, cx, cy, hittargets[2].z + FRACUNIT*32)
								server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[2].x, hittargets[2].y) 
							end //Turn back
				elseif timer > 230
				and timer <= 300
					if timer%4 == 0
						playSound(mo.battlen, sfx_fire1)
					end
					for i = 1, #hittargets
						local target = hittargets[i]
						for i = 1, 6 //Let's not kill the sprite limit lol 
							local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z - 32*FRACUNIT, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*2
						end
						if timer == 250
						or timer == 270
							damageObject(target)
						end
						
						if timer == 295
							damageObject(target)
							DoExplosion(target)
						end
					end
				elseif timer >= 315 //Camera cools
				and timer < 360
					ANIM_set(mo, mo.anim_aoa_end, true)
					local cx = mo.x - 168*cos(mo.angle + ANG1*20)
					local cy = mo.y - 168*sin(mo.angle + ANG1*20)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, mo.x, mo.y))
				end
				if timer == 360
					mo.hudcharx = nil
					return true
				end
			end,
	}

end
